Scriptname SSX_Actor_Cleaner_Quest extends Quest ; V1.4

Quest Property ssxActorCleanerQuest Auto
int numCleaned
int numCleanedTotal
ReferenceAlias[] Property cleanAliases Auto
SSX_Runner_Quest Property ssxRunnerQuest Auto
Faction Property ssxAllFriends Auto
Faction Property ssxCreatures Auto
Faction Property ssxInvolved Auto

Function doInit()
	RegisterForModEvent("startSSXCleaning", "startSSXCleaning")
	RegisterForModEvent("stopSSXCleaning", "stopSSXCleaning")
	RegisterForModEvent("ssxStopSSXMod", "stopSSXCleaning")
	ssxRunnerQuest.log("Cleaner events registered", SSX_Runner_Quest.notifCleanDetails())
	numCleaned=0
	numCleanedTotal=0
	ssxRunnerQuest.clenUpActorsAround=false
	unregisterForUpdate()
EndFunction

Event startSSXCleaning(String what)
	ssxRunnerQuest.log("Starting actors cleaning...", SSX_Runner_Quest.notifCleanDetails())
	ssxActorCleanerQuest.start()
	numCleaned=0
	numCleanedTotal=0
	RegisterForSingleUpdate(1.0)
	ssxRunnerQuest.clenUpActorsAround=true
endEvent

Event stopSSXCleaning(String what)
	ssxRunnerQuest.clenUpActorsAround=false
	unregisterForUpdate()
	ssxActorCleanerQuest.stop()
endEvent

Event OnUpdate()
	numCleaned=0
	String wereThere = ""
	int i=cleanAliases.length
	while i
		i-=1
		Actor a = cleanAliases[i].getActorReference()
		if a
			if a.isInFaction(ssxAllFriends)
				a.removeFromFaction(ssxAllFriends)
			endIf
			if a.isInFaction(ssxCreatures)
				a.removeFromFaction(ssxCreatures)
			endIf
			if a.isInFaction(ssxInvolved)
				a.removeFromFaction(ssxInvolved)
			endIf
			a.evaluatePackage()
			wereThere += a.getDisplayName() + ", "
		endIf
		cleanAliases[i].clear()
		numCleaned+=1
		numCleanedTotal+=1
	endWhile
	if numCleaned>0
		ssxRunnerQuest.log("Cleaned " + numCleaned + " actors: " + wereThere, SSX_Runner_Quest.notifCleanDetails())
		ssxRunnerQuest.log("Total number of cleared actors: " + numCleanedTotal, SSX_Runner_Quest.notifCleanDetails())
	endIf

	ssxActorCleanerQuest.stop()
	Utility.waitMenuMode(0.3)
	ssxActorCleanerQuest.start()
	RegisterForSingleUpdate(3.0)
endEvent
