Scriptname SSX_Deferred_Actors_Loader_Quest extends Quest ; V1.4h

SSX_Runner_Quest Property ssxRunnerQuest Auto
Actor Property PlayerRef Auto
Faction Property ssxGroup1 Auto
Faction Property ssxGroup2 Auto
Faction Property ssxGroup3 Auto
Faction Property ssxGroup4 Auto
Faction Property ssxGroup5 Auto

Function doInit()
	UnregisterForAllModEvents()
	RegisterForModEvent("ssxRescanActors", "DoRescan")
	ssxRunnerQuest.areActorsInProgress=0
	ssxRunnerQuest.log("Deferred Actors Loader started", SSX_Runner_Quest.notifDeferredDetails())
EndFunction

bool doingRescan = false

Event DoRescan(string fromWho)
	if doingRescan
		return
	endIf
	doingRescan=true

	ssxRunnerQuest.startT("MCM Actors scanning " + fromWho)
	ssxRunnerQuest.log("Scanning of actors for MCM started", SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.areActorsInProgress=0

	while ssxRunnerQuest.mcmActorsNum
		ssxRunnerQuest.mcmActorsNum-=1
		ssxRunnerQuest.mcmActors[ssxRunnerQuest.mcmActorsNum] = none
	endWhile
	
	; Scan who is in the cell, to provide a list for defining participants
	ssxRunnerQuest.mcmActorsNum = 0
	Actor[] inCell = MiscUtil.ScanCellNPCs(PlayerRef, 0.0)
	float step = 0.0
	float progress = 1.0
	int i = inCell.length
	if i
		step = 40.0/i
		while i && ssxRunnerQuest.mcmActorsNum<ssxRunnerQuest.mcmActors.length
			i -= 1
			Actor a = inCell[i]
			if a && a!=PlayerRef && ssxRunnerQuest.validateActor(a)
				ssxRunnerQuest.mcmActors[ssxRunnerQuest.mcmActorsNum] = a
				ssxRunnerQuest.mcmActorNames[ssxRunnerQuest.mcmActorsNum] = a.getDisplayName() + " (" + SSX_Runner_Quest.getObjectModName(a) + ")"
				ssxRunnerQuest.mcmActorsNum+=1
				ssxRunnerQuest.addRace("", a.getLeveledActorBase().getRace(), 1, false)
			endIf
			progress += step
			ssxRunnerQuest.areActorsInProgress = progress as Int
		endWhile
	endIf
	; Add the player to the bottom
	if ssxRunnerQuest.mcmActorsNum<ssxRunnerQuest.mcmActors.length
		ssxRunnerQuest.mcmActors[ssxRunnerQuest.mcmActorsNum] = PlayerRef
		ssxRunnerQuest.mcmActorNames[ssxRunnerQuest.mcmActorsNum] = PlayerRef.getDisplayName() + " (" + ssxRunnerQuest.s("$SSX_Player") + ")"
		ssxRunnerQuest.mcmActorsNum+=1
	else
		ssxRunnerQuest.mcmActors[ssxRunnerQuest.mcmActorsNum - 1] = PlayerRef
		ssxRunnerQuest.mcmActorNames[ssxRunnerQuest.mcmActorsNum - 1] = PlayerRef.getDisplayName() + " (" + ssxRunnerQuest.s("$SSX_Player") + ")"
	endIf
	ssxRunnerQuest.addRace("", PlayerRef.getLeveledActorBase().getRace(), 1, false)
	ssxRunnerQuest.areActorsInProgress = 40

	; Scanning and sorting factions of surrounding NPCs was here once
	; TODO: redo percentages
	ssxRunnerQuest.areActorsInProgress = 80
	
	ssxRunnerQuest.updateValidRaces()
	
	ssxRunnerQuest.areActorsInProgress = 100
	
	doingRescan = false
	
	ssxRunnerQuest.log("Scanning of actors for MCM completed", SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.endT("MCM Actors scanning " + fromWho)
EndEvent











