Scriptname SSX_Deferred_Config_Loader_Quest extends Quest ; V1.4f

SSX_Runner_Quest Property ssxRunnerQuest Auto
Quest Property ssxRules Auto 
bool areWeAlreadyLoading
bool areWeAlreadySaving
Race Property ManakinRace Auto
Spell Property ssxAddToFactionGroup1 Auto
Spell Property ssxAddToFactionGroup2 Auto
Spell Property ssxAddToFactionGroup3 Auto
Spell Property ssxAddToFactionGroup4 Auto
Spell Property ssxAddToFactionGroup5 Auto
Actor Property PlayerRef Auto

Function doInit()
	UnregisterForAllModEvents()
	areWeAlreadyLoading = false
	areWeAlreadySaving = false
	RegisterForModEvent("ssxUpdateConfig", "manageConfig")
	Utility.waitMenuMode(0.5)
	ssxRunnerQuest.log("Deferred Config Manager started", SSX_Runner_Quest.notifDeferredDetails())
EndFunction

Bool Function areWeSaving()
	return areWeAlreadySaving
EndFunction

Event manageConfig(String saveLoad, String fromWho)
	if saveLoad=="Save"
		saveSSXConfig()
	elseIf saveLoad=="Load"
		loadSSXConfig()
	else
		ssxRunnerQuest.log("manageConfig ---------------------- unrecognized event", SSX_Runner_Quest.notifDeferredDetails())
	endIf
EndEvent

Function loadSSXConfig()
	if areWeAlreadyLoading
		return
	endIf
	areWeAlreadyLoading = true
	while areWeAlreadySaving
		Utility.waitMenuMode(0.5)
	endWhile
	ssxRunnerQuest.isConfigInProgress=0
	ssxRunnerQuest.startT("Loading Configuration")

	ssxRunnerQuest.log(ssxRunnerQuest.s("$configurationinit"), SSX_Runner_Quest.notifDeferredDetails())
	JSONUtil.Load(ssxRunnerQuest.configFile)
	ssxRunnerQuest.isConfigInProgress=1

	int configVersion = JSONUtil.GetIntValue(ssxRunnerQuest.configFile, "ConfigFileVersion", 0)
	if configVersion>0 && configVersion<10300
		Debug.MessageBox("--- Scent of Sex ---\n--- WARNING ---\n\nThe configuration file is too old, the mod may not work.\nDelete the file \"Data\\configs\\Scent of Sex NG\\settings.json\"")
	endIf

	ssxRunnerQuest.expertiseLevel = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.expertiseLevel", 0)
	ssxRunnerQuest.ssxKeyCode = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.ssxKeyCode", 45)
	if ssxRunnerQuest.ssxKeyCode
		ssxRunnerQuest.unRegisterForEvents()
		ssxRunnerQuest.registerForEvents()
	endIf
	int tmpNexus = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.nexusMode", -1)
	if tmpNexus!=-1
		ssxRunnerQuest.nexusMode = tmpNexus
	endIf
	int previousVersion = JSONUtil.GetIntValue(ssxRunnerQuest.configFile, "configfileversion", -1)
	ssxRunnerQuest.maxNumberOfRules = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.maxNumberOfRules", 24)
	ssxRunnerQuest.maxNumberOfParallelScenes = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".scenes.maxNumberOfParallelScenes", 1)
	ssxRunnerQuest.maxSecondsToReachTarget = JSONUtil.GetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.maxSecondsToReachTarget", 15.0)
	ssxRunnerQuest.maxSecondsToAsk = JSONUtil.GetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.maxSecondsToAsk", 15.0)
	ssxRunnerQuest.maxSecondsToReachDenial = JSONUtil.GetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.maxSecondsToReachDenial", 15.0)
	ssxRunnerQuest.maxSecondsToReachBed = JSONUtil.GetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.maxSecondsToReachBed", 15.0)
	ssxRunnerQuest.stopSceneInCaseOfTimeOuts = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".scenes.stopSceneInCaseOfTimeOuts", 0)
	ssxRunnerQuest.startRightAway = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".scenes.startRightAway", 0)
	ssxRunnerQuest.ruleCheckerMinWaitTime = JSONUtil.GetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.ruleCheckerMinWaitTime", 30.0)
	ssxRunnerQuest.ruleCheckerMaxWaitTime = JSONUtil.GetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.ruleCheckerMaxWaitTime", 120.0)
	ssxRunnerQuest.checkingMode = JSONUtil.GetPathintValue(ssxRunnerQuest.configFile, ".scenes.checkingMode", 0)
	ssxRunnerQuest.rescanCellTime = JSONUtil.GetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.rescanCellTime", 60.0)
	ssxRunnerQuest.skipActorsInNamedScenes = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".scenes.skipActorsInNamedScenes", 1)
	ssxRunnerQuest.dontStopScenes = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".scenes.dontStopScenes", 0)
	ssxRunnerQuest.scanMode = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.scanMode", 0)
	ssxRunnerQuest.genderMode = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.genderMode", 0)
	ssxRunnerQuest.playerOrientation = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.playerOrientation", 1) ; Hetero only humans
	ssxRunnerQuest.orientationMode = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.orientationMode", 2 + 80 + 512 + 8192)
	if (previousVersion!=-1 && previousVersion<10404)
		; Update the orientation mode
		if ssxRunnerQuest.orientationMode==0 ; Was Strainght
			ssxRunnerQuest.orientationMode = 2 + 80 + 512 + 8192 ; M>_F__ | F>M_S_ | S>_F__ | B>_F__
			
		elseIf ssxRunnerQuest.orientationMode==1 ; Was Gay
			ssxRunnerQuest.orientationMode = 1 + 16 + 256 + 4096 ; M>M___ | F>M___ | S>M___ | B>M___
			
		elseIf ssxRunnerQuest.orientationMode==2 ; Was Lesbian
			ssxRunnerQuest.orientationMode = 0 + 32 + 512 + 8192; M>_F__ | F>_F__ | S>_F__ | B>_F__
			
		elseIf ssxRunnerQuest.orientationMode==3 ; Was Bisex
			ssxRunnerQuest.orientationMode = 3 + 48 + 768 + 12288; M>MF__ | F>MF__ | S>MF__ | B>MF__
		endIf
		debug.trace("SSX: Sexual Orientation updated to version 1.4e")
	endIf
	ssxRunnerQuest.useSLSexuality = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.useSLSexuality", 0)
	ssxRunnerQuest.excludeActorsWithCum = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.excludeActorsWithCum", 0)
	ssxRunnerQuest.priorityMode = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.priorityMode", 0)
	ssxRunnerQuest.followersStayInBleedout = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.followersStayInBleedout", 0)
	ssxRunnerQuest.forceStopCombats = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.forceStopCombats", 3)
	ssxRunnerQuest.protectOnHealth = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.protectOnHealth", 1)
	ssxRunnerQuest.safeCheckOfConCAnims = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.safeCheckOfConCAnims", 1)
	ssxRunnerQuest.factionSpells = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".config.factionSpells", 0)
	if Math.LogicalAnd(ssxRunnerQuest.factionSpells, 1)==1 ; Adds the spells if missing
		if !PlayerRef.hasSpell(ssxAddToFactionGroup1)
			PlayerRef.addSpell(ssxAddToFactionGroup1, false)
		endIf
		if !PlayerRef.hasSpell(ssxAddToFactionGroup2)
			PlayerRef.addSpell(ssxAddToFactionGroup2, false)
		endIf
		if !PlayerRef.hasSpell(ssxAddToFactionGroup3)
			PlayerRef.addSpell(ssxAddToFactionGroup3, false)
		endIf
		if !PlayerRef.hasSpell(ssxAddToFactionGroup4)
			PlayerRef.addSpell(ssxAddToFactionGroup4, false)
		endIf
		if !PlayerRef.hasSpell(ssxAddToFactionGroup5)
			PlayerRef.addSpell(ssxAddToFactionGroup5, false)
		endIf
	else ; Remove the spells if added
		if PlayerRef.hasSpell(ssxAddToFactionGroup1)
			PlayerRef.removeSpell(ssxAddToFactionGroup1)
		endIf
		if PlayerRef.hasSpell(ssxAddToFactionGroup2)
			PlayerRef.removeSpell(ssxAddToFactionGroup2)
		endIf
		if PlayerRef.hasSpell(ssxAddToFactionGroup3)
			PlayerRef.removeSpell(ssxAddToFactionGroup3)
		endIf
		if PlayerRef.hasSpell(ssxAddToFactionGroup4)
			PlayerRef.removeSpell(ssxAddToFactionGroup4)
		endIf
		if PlayerRef.hasSpell(ssxAddToFactionGroup5)
			PlayerRef.removeSpell(ssxAddToFactionGroup5)
		endIf
	endIf
	ssxRunnerQuest.isConfigInProgress+=1

	ssxRunnerQuest.notifications = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifications", 0x7FFFFFFF)
	ssxRunnerQuest.popUpDelRule = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".notifications.popUpDelRule", 1)
	ssxRunnerQuest.popUpNotSaved = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".notifications.popUpNotSaved", 1)
	ssxRunnerQuest.popUpNameNotUpated = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".notifications.popUpNameNotUpated", 1)
	
	ssxRunnerQuest.notifHighlight = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifHighlight", 1)
	ssxRunnerQuest.notifHighLightColorScan = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifHighLightColorScan", 0)
	ssxRunnerQuest.notifHighLightColorAskable = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifHighLightColorAskable", 0)
	ssxRunnerQuest.notifHighLightColorCleaned = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifHighLightColorCleaned", 0)
	
	ssxRunnerQuest.isConfigInProgress+=1
	
	ssxRunnerQuest.increaseSpeechCraft = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".interaction.increaseSpeechCraft", 0)
	ssxRunnerQuest.maxSpeechCraftLevel = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".interaction.maxSpeechCraftLevel", 100)
	ssxRunnerQuest.increaseRelationship = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".interaction.increaseRelationship", 0)
	ssxRunnerQuest.maxRelationshipRank = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".interaction.maxRelationshipRank", 4)
	ssxRunnerQuest.isConfigInProgress+=1

	; ((- Races
	ssxRunnerQuest.isConfigInProgress+=1
	
	String[] races = JSONUtil.PathStringElements(ssxRunnerQuest.configFile, ".races.humans.races", "")
	int[] enableds = JSONUtil.PathIntElements(ssxRunnerQuest.configFile, ".races.humans.enabled", 1)
	
	int i = races.length
	while i
		i-=1
		if races[i]
			int enabled = 1
			if i<enableds.length
				enabled = enableds[i]
			endIf
			ssxRunnerQuest.addRace(races[i], None, enabled, false)
		endIf
	endWhile
	
	ssxRunnerQuest.isConfigInProgress+=1
	races = JSONUtil.PathStringElements(ssxRunnerQuest.configFile, ".races.creatures.races", "")
	enableds = JSONUtil.PathIntElements(ssxRunnerQuest.configFile, ".races.creatures.enabled", 0)
	i = races.length
	while i
		i-=1
		if races[i]
			int enabled = 0
			if i<enableds.length
				enabled = enableds[i]
			endIf
			ssxRunnerQuest.addRace(races[i], None, enabled, true)
		endIf
	endWhile
	ssxRunnerQuest.isConfigInProgress+=1

	; Now add the vanilla races if missing
	i = ssxRunnerQuest.vanillaRaces.length
	while i
		i -= 1
		if !ssxRunnerQuest.raceIsKnown(ssxRunnerQuest.vanillaRaces[i])
			ssxRunnerQuest.addRace("", ssxRunnerQuest.vanillaRaces[i], 1, false)
			if ssxRunnerQuest.vanillaRaces[i]==ManakinRace
				ssxRunnerQuest.enableRace(ssxRunnerQuest.getRaceID(ManakinRace), 0)
			endIf
		endIf
	endWhile
	
	; Add also all the RaceKeys from SexLab
	String[] allRaceKeys = sslCreatureAnimationSlots.GetAllRaceKeys()
	i = allRaceKeys.length
	while i
		i -= 1
		if !ssxRunnerQuest.raceIsKnown(None, allRaceKeys[i])
			ssxRunnerQuest.addRace(allRaceKeys[i], None, 0, true)
		endIf
	endWhile
	
	; Sort the races by name
	ssxRunnerQuest.sortStringsAndInt(ssxRunnerQuest.allRacesH, ssxRunnerQuest.allRacesHEditIDs, ssxRunnerQuest.allRacesHEnabled, ssxRunnerQuest.numAllRacesH)
	if ssxRunnerQuest.allRacesC
		ssxRunnerQuest.sortStringAndInt(ssxRunnerQuest.allRacesC, ssxRunnerQuest.allRacesCEnabled, ssxRunnerQuest.numAllRacesC)
	endIf
	ssxRunnerQuest.isConfigInProgress+=1

	; -))
	
	; ((- Loading of rules
	Alias[] tmpRules = ssxRules.GetAliases()
	if tmpRules.length!=8 && tmpRules.length!=16 && tmpRules.length!=24 && tmpRules.length!=32 && tmpRules.length!=40 && tmpRules.length!=48 && tmpRules.length!=56 && tmpRules.length!=64
		debug.trace("SSX: Possible problem, the number of rules is inconsistent with the number of aliases.")
	endIf
	
	if ssxRunnerQuest.maxNumberOfRules==8
		ssxRunnerQuest.rules = new SSX_Rule_Alias[8]
		ssxRunnerQuest.rulesAskFactions = new Faction[8]
	elseIf ssxRunnerQuest.maxNumberOfRules==16
		ssxRunnerQuest.rules = new SSX_Rule_Alias[16]
		ssxRunnerQuest.rulesAskFactions = new Faction[16]
	elseIf ssxRunnerQuest.maxNumberOfRules==24
		ssxRunnerQuest.rules = new SSX_Rule_Alias[24]
		ssxRunnerQuest.rulesAskFactions = new Faction[24]
	elseIf ssxRunnerQuest.maxNumberOfRules==32
		ssxRunnerQuest.rules = new SSX_Rule_Alias[32]
		ssxRunnerQuest.rulesAskFactions = new Faction[32]
	elseIf ssxRunnerQuest.maxNumberOfRules==40
		ssxRunnerQuest.rules = new SSX_Rule_Alias[40]
		ssxRunnerQuest.rulesAskFactions = new Faction[40]
	elseIf ssxRunnerQuest.maxNumberOfRules==48
		ssxRunnerQuest.rules = new SSX_Rule_Alias[48]
		ssxRunnerQuest.rulesAskFactions = new Faction[48]
	elseIf ssxRunnerQuest.maxNumberOfRules==56
		ssxRunnerQuest.rules = new SSX_Rule_Alias[56]
		ssxRunnerQuest.rulesAskFactions = new Faction[56]
	elseIf ssxRunnerQuest.maxNumberOfRules==64
		ssxRunnerQuest.rules = new SSX_Rule_Alias[64]
		ssxRunnerQuest.rulesAskFactions = new Faction[64]
	else
		ssxRunnerQuest.rules = new SSX_Rule_Alias[24]
		ssxRunnerQuest.rulesAskFactions = new Faction[24]
	endIf
	
	i = 0
	while i<tmpRules.length && i<ssxRunnerQuest.rules.length
		ssxRunnerQuest.rules[i] = tmpRules[i] as SSX_Rule_Alias
		ssxRunnerQuest.rules[i].init(ssxRunnerQuest.s("$SSX_noname"))
		i+=1
	endWhile
	ssxRunnerQuest.rulesNum = ssxRunnerQuest.maxNumberOfRules
	ssxRunnerQuest.isConfigInProgress=7
	
	i = 0
	int tot = JSONUtil.PathCount(ssxRunnerQuest.configFile, ".rules")
	if tot>ssxRunnerQuest.rules.length
		ssxRunnerQuest.log("The number of rules in the config file is " + tot + " while the maximum number of rules in your config is set to " + ssxRunnerQuest.rules.length +"/nInclrease the limit and restart, or some of the rules will not be available.", SSX_Runner_Quest.notifMsgBox())
		tot=ssxRunnerQuest.rules.length
	endIf
	int j=0
	while i<tot
		ssxRunnerQuest.getRule(ssxRunnerQuest.configFile, false, i, ssxRunnerQuest.rules[j], None)
		if ssxRunnerQuest.rules[j].inUse!=0
			ssxRunnerQuest.rules[j].generateLocations()
			ssxRunnerQuest.rules[j].clearValidActors()
			j+=1
		endIf
		ssxRunnerQuest.isConfigInProgress+=1
		i+=1
	endWhile

	; -))

	; Armor keywords
	string keywordConfigPath = ssxRunnerQuest.configFolder + "keywords.json"
	if !JSONUtil.JsonExists(keywordConfigPath)
		ssxRunnerQuest.log("Could not find keywords.json. Please check your installation.", SSX_Runner_Quest.notifMsgBox())
		ssxRunnerQuest.iAmInitialized = 0
		return
	endIf

	String[] armorKeywordIDs = JSONUtil.PathStringElements(keywordConfigPath, ".armorKeywordIDs")
	ssxRunnerQuest.armorKeywords = Utility.CreateFormArray(armorKeywordIDs.Length)
	ssxRunnerQuest.armorKeywordIDs = Utility.CreateStringArray(armorKeywordIDs.Length)

	int numValidKeywords = 0
	i = 0
	while i < armorKeywordIDs.Length
		Keyword kw = PO3_SKSEFunctions.GetFormFromEditorID(armorKeywordIDs[i]) As Keyword
		; Invalid keywords are silently ignored
		if kw
			ssxRunnerQuest.armorKeywords[numValidKeywords] = kw
			ssxRunnerQuest.armorKeywordIDs[numValidKeywords] = PO3_SKSEFunctions.GetFormEditorID(kw)
			numValidKeywords += 1
		endIf
		i += 1
	endWhile
	Utility.ResizeStringArray(ssxRunnerQuest.armorKeywordIDs, numValidKeywords)
	Utility.ResizeFormArray(ssxRunnerQuest.armorKeywords, numValidKeywords)
	ssxRunnerQuest.armorKeywordConsideredNaked = Utility.CreateIntArray(numValidKeywords)
	
	Debug.trace("[SSX] Loaded " + numValidKeywords + " out of " + armorKeywordIDs.length + " armor keywords from disk.")
	
	; Nudity
	String[] tmpStrs = JSONUtil.PathStringElements(ssxRunnerQuest.configFile, ".nudity.armorIDs", "")
	if tmpStrs
		if ssxRunnerQuest.nudeArmorsIDs.length<tmpStrs.length
			ssxRunnerQuest.nudeArmorsIDs=SSX_Runner_Quest.CreateStringArray(tmpStrs.length)
		endIf
		i=0
		while i<ssxRunnerQuest.nudeArmorsIDs.length && i<tmpStrs.length
			ssxRunnerQuest.nudeArmorsIDs[i] = tmpStrs[i]
			i+=1
		endWhile
	else
	endIf
	int[] tmpInts = JSONUtil.PathIntElements(ssxRunnerQuest.configFile, ".nudity.armorKeywords", 0)
	if tmpInts
		i=0
		while i<ssxRunnerQuest.armorKeywordConsideredNaked.length && i<tmpInts.length
			ssxRunnerQuest.armorKeywordConsideredNaked[i] = tmpInts[i]
			i+=1
		endWhile
	endIf
	ssxRunnerQuest.nakedHead = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedHead", 2)
	ssxRunnerQuest.nakedBody = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedBody", 2)
	ssxRunnerQuest.nakedForearms = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedForearms", 2)
	ssxRunnerQuest.nakedHands = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedHands", 2)
	ssxRunnerQuest.nakedCalves = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedCalves", 2)
	ssxRunnerQuest.nakedFeet = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedFeet", 2)
	ssxRunnerQuest.nakedPelvis = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedPelvis", 2)
	ssxRunnerQuest.nakedMinLevel = JSONUtil.GetPathFloatValue(ssxRunnerQuest.configFile, ".nudity.nakedMinLevel", 0.0)
	
	ssxRunnerQuest.isConfigInProgress =	100
	ssxRunnerQuest.log(ssxRunnerQuest.s("$configurationcompleted"), SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.endT("Loading Configuration")
	areWeAlreadyLoading = false
EndFunction	



Function saveSSXConfig()
	if areWeAlreadySaving
		return
	endIf
	while areWeAlreadyLoading
		Utility.waitMenuMode(0.5)
	endWhile
	areWeAlreadySaving = true

	ssxRunnerQuest.log(ssxRunnerQuest.s("$savingconfiguration"), SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.startT("Saving Configuration")

	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.expertiseLevel", ssxRunnerQuest.expertiseLevel)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.ssxKeyCode", ssxRunnerQuest.ssxKeyCode)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.maxNumberOfRules", ssxRunnerQuest.maxNumberOfRules)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".scenes.maxNumberOfParallelScenes", ssxRunnerQuest.maxNumberOfParallelScenes)
	JSONUtil.SetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.maxSecondsToReachTarget", ssxRunnerQuest.maxSecondsToReachTarget)
	JSONUtil.SetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.maxSecondsToAsk", ssxRunnerQuest.maxSecondsToAsk)
	JSONUtil.SetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.maxSecondsToReachDenial", ssxRunnerQuest.maxSecondsToReachDenial)
	JSONUtil.SetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.maxSecondsToReachBed", ssxRunnerQuest.maxSecondsToReachBed)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".scenes.stopSceneInCaseOfTimeOuts", ssxRunnerQuest.stopSceneInCaseOfTimeOuts)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".scenes.startRightAway", ssxRunnerQuest.startRightAway)
	JSONUtil.SetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.ruleCheckerMinWaitTime", ssxRunnerQuest.ruleCheckerMinWaitTime)
	JSONUtil.SetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.ruleCheckerMaxWaitTime", ssxRunnerQuest.ruleCheckerMaxWaitTime)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".scenes.checkingMode", ssxRunnerQuest.checkingMode)
	JSONUtil.SetPathFloatValue(ssxRunnerQuest.configFile, ".scenes.rescanCellTime", ssxRunnerQuest.rescanCellTime)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".scenes.skipActorsInNamedScenes", ssxRunnerQuest.skipActorsInNamedScenes)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".scenes.dontStopScenes", ssxRunnerQuest.dontStopScenes)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.scanMode", ssxRunnerQuest.scanMode)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.genderMode", ssxRunnerQuest.genderMode)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.orientationMode", ssxRunnerQuest.orientationMode)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.playerOrientation", ssxRunnerQuest.playerOrientation)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.useSLSexuality", ssxRunnerQuest.useSLSexuality)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.excludeActorsWithCum", ssxRunnerQuest.excludeActorsWithCum)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.priorityMode", ssxRunnerQuest.priorityMode)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.followersStayInBleedout", ssxRunnerQuest.followersStayInBleedout)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.forceStopCombats", ssxRunnerQuest.forceStopCombats)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.protectOnHealth", ssxRunnerQuest.protectOnHealth)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.safeCheckOfConCAnims", ssxRunnerQuest.safeCheckOfConCAnims)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".config.factionSpells", ssxRunnerQuest.factionSpells)
	
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifications", ssxRunnerQuest.notifications)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".notifications.popUpDelRule", ssxRunnerQuest.popUpDelRule)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".notifications.popUpNotSaved", ssxRunnerQuest.popUpNotSaved)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".notifications.popUpNameNotUpated", ssxRunnerQuest.popUpNameNotUpated)
	
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifHighlight", ssxRunnerQuest.notifHighlight)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifHighLightColorScan", ssxRunnerQuest.notifHighLightColorScan)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifHighLightColorAskable", ssxRunnerQuest.notifHighLightColorAskable)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".notifications.notifHighLightColorCleaned", ssxRunnerQuest.notifHighLightColorCleaned)
	
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".interaction.increaseSpeechCraft", ssxRunnerQuest.increaseSpeechCraft)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".interaction.maxSpeechCraftLevel", ssxRunnerQuest.maxSpeechCraftLevel)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".interaction.increaseRelationship", ssxRunnerQuest.increaseRelationship)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".interaction.maxRelationshipRank", ssxRunnerQuest.maxRelationshipRank)

	
	; Races
	if ssxRunnerQuest.nexusMode
		JSONUtil.SetRawPathValue(ssxRunnerQuest.configFile, ".races", "{ \"humans\" : { \"enabled\" : [], \"races\" : [] }}")
		JSONUtil.SetPathStringArray(ssxRunnerQuest.configFile, ".races.humans.races", ssxRunnerQuest.allRacesHEditIDs, false)
		JSONUtil.SetPathIntArray(ssxRunnerQuest.configFile, ".races.humans.enabled", ssxRunnerQuest.allRacesHEnabled, false)
	else
		JSONUtil.SetRawPathValue(ssxRunnerQuest.configFile, ".races", "{ \"creatures\" : { \"enabled\" : [], \"races\" : [] }, \"humans\" : { \"enabled\" : [], \"races\" : [] }}")
		JSONUtil.SetPathStringArray(ssxRunnerQuest.configFile, ".races.humans.races", ssxRunnerQuest.allRacesHEditIDs, false)
		JSONUtil.SetPathIntArray(ssxRunnerQuest.configFile, ".races.humans.enabled", ssxRunnerQuest.allRacesHEnabled, false)
		JSONUtil.SetPathStringArray(ssxRunnerQuest.configFile, ".races.creatures.races", ssxRunnerQuest.allRacesC, false)
		JSONUtil.SetPathIntArray(ssxRunnerQuest.configFile, ".races.creatures.enabled", ssxRunnerQuest.allRacesCEnabled, false)
	endIf
	
	; ((- Saving of rules
	; wipe rules if config file has 'legal' number of rules, since we can assume the loading was done ok
	; if not, assume we only loaded the first [length] rules, try to save them to original slots
	bool needToClean = JSONUtil.PathCount(ssxRunnerQuest.configFile, ".rules")>ssxRunnerQuest.rules.length
	if !needToClean
		JSONUtil.SetRawPathValue(ssxRunnerQuest.configFile, ".rules", "[]")
	endIf
	int i = 0
	int j = 0
	while i<ssxRunnerQuest.rules.length
		if ssxRunnerQuest.rules[i].inUse != 0
			ssxRunnerQuest.setRule(ssxRunnerQuest.configFile, false, j, ssxRunnerQuest.rules[i] as SSX_Rule_Alias)
			j+=1
		endIf
		i+=1
	endWhile
	; -))
	
	
	; Nudity
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedHead", ssxRunnerQuest.nakedHead)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedBody", ssxRunnerQuest.nakedBody)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedForearms", ssxRunnerQuest.nakedForearms)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedHands", ssxRunnerQuest.nakedHands)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedCalves", ssxRunnerQuest.nakedCalves)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedFeet", ssxRunnerQuest.nakedFeet)
	JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".nudity.nakedPelvis", ssxRunnerQuest.nakedPelvis)
	JSONUtil.SetPathFloatValue(ssxRunnerQuest.configFile, ".nudity.nakedMinLevel", ssxRunnerQuest.nakedMinLevel)
	JSONUtil.Save(ssxRunnerQuest.configFile, minify = false)

	int tot=0
	i=ssxRunnerQuest.nudeArmorsIDs.length
	while i
		i-=1
		if ssxRunnerQuest.nudeArmorsIDs[i]
			tot+=1
		endIf
	endWhile
	if tot
		String[] tmpStrs = SSX_Runner_Quest.CreateStringArray(tot)
		i=ssxRunnerQuest.nudeArmorsIDs.length
		tot=0
		while i
			i-=1
			if ssxRunnerQuest.nudeArmorsIDs[i]
				tmpStrs[tot]=ssxRunnerQuest.nudeArmorsIDs[i]
				tot+=1
			endIf
		endWhile
		JSONUtil.SetPathStringArray(ssxRunnerQuest.configFile, ".nudity.armorIDs", tmpStrs, false)
	endIf
	JSONUtil.Save(ssxRunnerQuest.configFile, minify = false)
	
	JSONUtil.SetPathIntArray(ssxRunnerQuest.configFile, ".nudity.armorKeywords", ssxRunnerQuest.armorKeywordConsideredNaked, false)
	
	JSONUtil.SetIntValue(ssxRunnerQuest.configFile, "ConfigFileVersion", ssxRunnerQuest.getVersion())
	JSONUtil.Save(ssxRunnerQuest.configFile, minify = false)
	
	ssxRunnerQuest.log(ssxRunnerQuest.s("$savingconfigurationcompleted"), SSX_Runner_Quest.notifDeferredDetails())
	ssxRunnerQuest.endT("Saving Configuration")
	areWeAlreadySaving = false
EndFunction

