Scriptname SSX_Event_Catcher_Alias extends ReferenceAlias ; V1.4e

SSX_Runner_Quest Property ssxRunnerQuest 
	SSX_Runner_Quest Function get()
		return (GetOwningQuest() As SSX_Rule_Checker_Quest).ssxRunnerQuest
	EndFunction
EndProperty

Actor lastAggressor
Float lastUndress
bool wasINaked
bool catchBleed
int[] ruleIDsB
bool catchNaked
int[] ruleIDsN
bool catchWeapon
int[] ruleIDsW
bool catchCombat
int[] ruleIDsC
bool catchSleep
int[] ruleIDsS
bool catchHealth
int[] catchHealthLevs ; Level of healt, >=0 then as to be greater, <0 has to be less than
int[] ruleIDsH
bool catchClothes
int[] ruleIDsI
int hadBleedoutRecovery
bool alreadyHandlingC
bool alreadyHandlingH
bool alreadyHandlingN
bool alreadyHandlingB
bool alreadyHandlingS
int minHealth
int maxHealth

; catchMode: 1=, 2=Nudity, 3=Health, 4=Combat 5=Bleedout, 6=Sleep, 7=Clothes, 8=, 9=, 10=, 11=

Event OnInit()
	ruleIDsB = new int[8]
	ruleIDsN = new int[8]
	ruleIDsW = new int[8]
	ruleIDsC = new int[8]
	ruleIDsS = new int[8]
	ruleIDsH = new int[8]
	ruleIDsI = new int[8]
	catchHealthLevs = new int[8]
	minHealth = 0
	maxHealth = 999999
	lastUndress = -1.0
	wasINaked=false
	alreadyHandlingC=false
	alreadyHandlingH=false
	alreadyHandlingN=false
	alreadyHandlingB=false
	alreadyHandlingS=false
	hadBleedoutRecovery = -1
	UnregisterForUpdate()
endEvent

Function init(Actor a, SSX_Catchers_Storage_Alias cs)
	bool wasMe = Self.getActorReference() && (a==Self.getActorReference())
	Self.forceRefTo(a)
	if !wasMe
		ssxRunnerQuest.log("EventCatchers Added " + a.getDisplayName(), SSX_Runner_Quest.notifCatchers())
	endIf

	catchBleed = cs.getBleedouts(-1)>0
	int i = ruleIDsB.length
	while i
		i-=1
		ruleIDsB[i] = cs.getBleedouts(i)
	endWhile
	
	catchNaked = cs.getNakeds(-1)>0
	i = ruleIDsN.length
	while i
		i-=1
		ruleIDsN[i] = cs.getNakeds(i)
	endWhile
	
	catchWeapon = cs.getWeapons(i)
	i = ruleIDsW.length
	while i
		i-=1
		ruleIDsW[i] = cs.getWeapons(i)
	endWhile
	
	catchCombat = cs.getCombats(-1)
	i = ruleIDsC.length
	while i
		i-=1
		ruleIDsC[i] = cs.getCombats(i)
	endWhile
	
	catchSleep = cs.getSleeps(-1)
	i = ruleIDsS.length
	while i
		i-=1
		ruleIDsS[i] = cs.getSleeps(i)
	endWhile
	if catchSleep
		RegisterForSleep()
	else
		UnregisterForSleep()
	endIf
	
	catchHealth = cs.getHealths(-1)
	i = ruleIDsH.length
	minHealth = 0
	maxHealth = 999999
	while i
		i-=1
		ruleIDsH[i] = cs.getHealths(i)
		catchHealthLevs[i] = cs.getHealthlevs(i)
		if catchHealthLevs[i] <= 0
			if minHealth < -catchHealthLevs[i]
				minHealth = -catchHealthLevs[i]
			endIf
		elseIf maxHealth > catchHealthLevs[i]
			maxHealth = catchHealthLevs[i]
		endIf
	endWhile
	
	if a.IsPlayerTeammate()
		if (catchBleed || catchHealth) && ssxRunnerQuest.followersStayInBleedout
			if hadBleedoutRecovery == -1 
				if a.GetNoBleedoutRecovery()
					hadBleedoutRecovery = 1
				else
					hadBleedoutRecovery = 0
				endIf
				a.SetNoBleedoutRecovery(true)
			endIf
		elseIf hadBleedoutRecovery != -1
			if hadBleedoutRecovery == 1
				a.SetNoBleedoutRecovery(true)
			elseIf hadBleedoutRecovery == 0
				a.SetNoBleedoutRecovery(false)
			endIf
			hadBleedoutRecovery = -1
		endIf
	endIf

	catchClothes = cs.getClothes(-1)
	i = ruleIDsI.length
	while i
		i-=1
		ruleIDsI[i] = cs.getClothes(i)
	endWhile
	
	if !wasMe
		lastAggressor = None
		lastUndress = -1.0
		wasINaked=false
		alreadyHandlingC=false
		alreadyHandlingH=false
		alreadyHandlingN=false
		alreadyHandlingB=false
		alreadyHandlingS=false
		UnregisterForUpdate()
	endIf
EndFunction

Function clean()
	UnregisterForSleep()
	ruleIDsB = new int[8]
	ruleIDsN = new int[8]
	ruleIDsW = new int[8]
	ruleIDsC = new int[8]
	ruleIDsS = new int[8]
	ruleIDsH = new int[8]
	catchHealthLevs = new int[8]
	lastAggressor = None
	lastUndress = -1.0
	wasINaked=false
	alreadyHandlingC=false
	alreadyHandlingH=false
	alreadyHandlingN=false
	alreadyHandlingB=false
	alreadyHandlingS=false
	Actor a = Self.getActorReference()
	if a
		if hadBleedoutRecovery == 1
			a.SetNoBleedoutRecovery(true)
		elseIf hadBleedoutRecovery == 0
			a.SetNoBleedoutRecovery(false)
		endIf
		ssxRunnerQuest.log("EventCatchers Removed " + a.getDisplayName(), SSX_Runner_Quest.notifCatchers())
	endIf
	Self.clear()
	UnregisterForUpdate()
EndFunction


; ((- Events **********************************************************************************************************************************


; aeCombatState: 0=not in combat, 1=in combat, 2=searching
Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
	if catchCombat && aeCombatState!=0
		ssxRunnerQuest.clearCached(-1,11,self.getActorReference())
		if alreadyHandlingC
			return
		endIf
		RegisterForSingleUpdate(1.0)
		alreadyHandlingC=true
		triggerRules(ruleIDsC, 4)
	endIf
EndEvent



Event OnSleepStart(float afSleepStartTime, float afDesiredSleepEndTime)
	if catchSleep
		if alreadyHandlingS
			return
		endIf
		ssxRunnerQuest.clearCached(-1,8,self.getActorReference())
		RegisterForSingleUpdate(1.0)
		alreadyHandlingS=true
		triggerRules(ruleIDsS, 6)
	endIf
endEvent

Event OnEnterBleedout()
	if catchBleed
		if alreadyHandlingB
			return
		endIf
		ssxRunnerQuest.clearCached(-1,12,self.getActorReference())
		RegisterForSingleUpdate(1.0)
		alreadyHandlingB=true
		triggerRules(ruleIDsB, 5)
	endIf
EndEvent

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	if akAggressor
		lastAggressor = akAggressor as Actor
	endIf
	if !catchHealth || alreadyHandlingH
		return
	endIf
	RegisterForSingleUpdate(1.0)
	alreadyHandlingH=true
EndEvent

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	if (!catchNaked && !catchClothes) || alreadyHandlingN
		return
	endIf
	RegisterForSingleUpdate(2.0)
	alreadyHandlingN=true
EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	if (!catchNaked && !catchClothes) || alreadyHandlingN
		return
	endIf
	RegisterForSingleUpdate(2.0)
	alreadyHandlingN=true
EndEvent

Function triggerRules(int[] ruleIDs, int catchMode) ; Send the event to play the rule for all registered rule IDs. This will fail because the actor may not be in the rule's participants
	; catchMode: 0=unspecified (random), 1=player ask (not really an event), 2=nudity, 3=health, 4=combat, 5=bleedout, 6=sleep, 7=clothing
	if ruleIDs[0] == 0 && ruleIDs[1] == 0 && ruleIDs[2] == 0 && ruleIDs[3] == 0 && ruleIDs[4] == 0 && ruleIDs[5] == 0 && ruleIDs[6] == 0 && ruleIDs[7] == 0
		return ; if all rules are empty, there's no point calling a mod event
	endIf
	;0=none, 1=H, 2=bo, 3=both
	int eventID = ssxRunnerQuest.getEvent()
	if catchMode==3 || catchMode==5 ; Health or Bleedout (Combat is done later inside RulePlayer)
		if (self.getActorReference() == ssxRunnerQuest.PlayerRef || lastAggressor == ssxRunnerQuest.PlayerRef) && ssxRunnerQuest.forceStopCombats != 0
			; try to stop combat immediately on bleedout and health rules for player to give them time to trigger
			ssxRunnerQuest.startCeaseFire(catchMode)
		endIf
	endIf
	String ag = "Nobody"
	if lastAggressor
		ag = lastAggressor.getDisplayName()
	endIf
	ssxRunnerQuest.log("EventCatchers Create event " + ssxRunnerQuest.catchModes[catchMode] + " for [" + self.getActorReference().getDisplayName() + "] by [" + ag + "] rules " + ruleIDs[0] + ", " + ruleIDs[1] + ", " + ruleIDs[2] + ", " + ruleIDs[3], SSX_Runner_Quest.notifCatchers())
	int handle = ModEvent.Create("ssxPlayRule")
	ModEvent.PushForm(handle, Self.getActorReference())
	ModEvent.PushForm(handle, lastAggressor)
	ModEvent.PushInt(handle, catchMode)
	ModEvent.PushInt(handle, ruleIDs[0])
	ModEvent.PushInt(handle, ruleIDs[1])
	ModEvent.PushInt(handle, ruleIDs[2])
	ModEvent.PushInt(handle, ruleIDs[3])
	ModEvent.PushInt(handle, ruleIDs[4])
	ModEvent.PushInt(handle, ruleIDs[5])
	ModEvent.PushInt(handle, ruleIDs[6])
	ModEvent.PushInt(handle, ruleIDs[7])
	ModEvent.PushInt(handle, eventID)
	ModEvent.Send(handle)
EndFunction

Event OnUpdate()
	; Check hit, combat, nudity.
	Actor a = self.getActorReference()
	if !a
		return
	endIf
	if  a.isInFaction(ssxRunnerQuest.ssxInvolved)
		alreadyHandlingB = false
		alreadyHandlingH = false
		alreadyHandlingC = false
		alreadyHandlingN = false
		alreadyHandlingS = false
		return
	endIf
	bool doit = true
	
	if catchBleed && alreadyHandlingB
		alreadyHandlingB=false
	endIf
	
	if alreadyHandlingH
		int h = ssxRunnerQuest.getHealthLevel(a)
		if h <= minHealth || h >= maxHealth
			triggerRules(ruleIDsH, 3)
		endIf
		doit = false
		alreadyHandlingH=false
	endIf

	if doit && alreadyHandlingC
		doit = false
		alreadyHandlingC=false
	endIf

	if doit && alreadyHandlingN
		if catchNaked
			alreadyHandlingN = false
			ssxRunnerQuest.clearCached(-1,1,a)
			bool amINaked = ssxRunnerQuest.isActorNaked(a)
			wasINaked=amINaked
			if amINaked
				triggerRules(ruleIDsN, 2)
			endIf
		endIf
		if catchClothes
			int i=ruleIDsI.length
			while i
				i-=1
				if ruleIDsI[i]!=0
					SSX_Rule_Alias r = ssxRunnerQuest.getRuleByID(ruleIDsI[i])
					if r
						if r.isActorThere(a, 0)
							if ssxRunnerQuest.checkClothes(r, a, 0)
								triggerRules(ruleIDsI, 7)
							endIf
						elseIf r.isActorThere(a, 1)
							if ssxRunnerQuest.checkClothes(r, a, 1)
								triggerRules(ruleIDsI, 7)
							endIf
						elseIf r.isActorThere(a, 2)
							if ssxRunnerQuest.checkClothes(r, a, 2)
								triggerRules(ruleIDsI, 7)
							endIf
						endIf
					endIf
				endIf
			endWhile
		endIf
		alreadyHandlingN=false
	endIf
	
	if catchSleep && alreadyHandlingS
		alreadyHandlingS=false
	endIf

	UnregisterForUpdate()
	if alreadyHandlingC || alreadyHandlingH || alreadyHandlingN || alreadyHandlingB || alreadyHandlingS
		RegisterForSingleUpdate(1.0)
	endIf
EndEvent

; -))


