Scriptname SSX_Faction_Cleaner_Quest extends Quest ; V1.4

; ((- Properties
SSX_Runner_Quest Property ssxRunnerQuest Auto
Actor Property PlayerRef Auto
Faction Property ssxScanningFaction Auto
Faction Property ssxAllFriends Auto
Faction Property ssxInvolved Auto
Quest Property ssxFactionCleanerQuest Auto

int busyUpdating ; number of calls we receive. When it is zero a call can be executed

ReferenceAlias[] Property scanActors Auto
ReferenceAlias[] Property friendActors Auto

bool SClean
bool FClean

int FNumCycles
int SNumCycles

int FnumCleaned
int SnumCleaned

; -))

Function doInit()
	RegisterForModEvent("ssxStartSSXMod", "startSSXCLF")
	RegisterForModEvent("ssxStopSSXMod", "stopSSXCLF")
	RegisterForModEvent("ssxCleanNow", "doItNow")
	SClean = false
	FClean = false
	ssxRunnerQuest.log("Factions Cleaner events registered",SSX_Runner_Quest.notifCleanDetails())
EndFunction

; ((- Generic no-state events
Event startSSXCLF(int mode)
	goToState("active")
EndEvent

Event stopSSXCLF(String unused)
	ssxFactionCleanerQuest.stop()
	if getState()=="active"
		goToState("inactive")
	endIf
EndEvent

Event doItNow(int unused)
	return
EndEvent

int Function cleanActors(ReferenceAlias[] aa, int i)
	return 0
EndFunction

; -))

state inactive
	Function OnBeginState()
		ssxRunnerQuest.log("Factions Cleaner going to inactive state", SSX_Runner_Quest.notifCleanDetails())
		RegisterForModEvent("ssxStartSSXMod", "startSSXCLF")
		; Be sure we stop everything
		UnregisterForUpdate()
		Utility.waitMenuMode(1.0)
		UnregisterForUpdate()
		ssxFactionCleanerQuest.stop()
	EndFunction

	Event stopSSXCLF(String unused)
		return
	EndEvent
endState

state active
	Function OnBeginState()
		ssxRunnerQuest.log("Factions Cleaner going to active state", SSX_Runner_Quest.notifCleanDetails())
		RegisterForModEvent("ssxStopSSXMod", "stopSSXCLF")
	EndFunction

	Event startSSXCLF(int mode)
		return
	EndEvent

	Function doItNow(int type)
		if !SClean && type == 1
			unregisterForUpdate()
			SClean = true
			SNumCycles = 20
			SNumCleaned = 0
			ssxFactionCleanerQuest.stop()
			registerForSingleUpdate(0.1)
		endIf
	
		if !FClean && type == 2
			unregisterForUpdate()
			FClean = true
			FNumCycles = 20
			FNumCleaned = 0
			ssxFactionCleanerQuest.stop()
			registerForSingleUpdate(0.1)
		endIf
	EndFunction

	Event onUpdate()
		ssxRunnerQuest.log("Factions Cleaner START: cycles S:" + SNumCycles + " F: " + FNumCycles, SSX_Runner_Quest.notifCleanDetails())
		ssxFactionCleanerQuest.reset()
		Utility.waitMenuMode(0.1)
		ssxFactionCleanerQuest.start()
		Utility.waitMenuMode(0.1)

		int f = friendActors.length
		int ffound = cleanActors(friendActors,f)

		int s = scanActors.length
		int sfound = cleanActors(scanActors,s)

		if FClean
			FNumCleaned += ffound + sfound
			FNumCycles -= 1
			if FNumCycles < 1 || ffound < f
				FClean = false
				FNumCycles = 0
				ssxRunnerQuest.log("Factions Cleaner: " + FNumCleaned + " FRIENDS cleaned", SSX_Runner_Quest.notifCleanDetails())
			endIf
		endIf

		if SClean
			SNumCleaned += ffound + sfound
			SNumCycles -= 1
			if SNumCycles < 1 || sfound < s
				SClean = false
				SNumCycles = 0
				ssxRunnerQuest.log("Factions Cleaner: " + SNumCleaned + " SCANNED cleaned", SSX_Runner_Quest.notifCleanDetails())
			endIf
		endIf
		ssxFactionCleanerQuest.stop()
		if FClean || SClean
			registerForSingleUpdate(0.2)
		endIf
		ssxRunnerQuest.log("Factions Cleaner DONE: cycles S:" + SNumCycles + " F: " + FNumCycles, SSX_Runner_Quest.notifCleanDetails())
	EndEvent
	
	int Function cleanActors(ReferenceAlias[] aa, int i)
		int found = 0
		while i > 0
			i -= 1
			Actor a = aa[i].getActorRef()
			if a && a != ssxRunnerQuest.PlayerRef && ssxRunnerQuest.allActors.find(a) == -1
				found += 1
				a.removeFromFaction(ssxInvolved)
				if SClean
					a.removeFromFaction(ssxScanningFaction)
				endIf
				if FClean && a.isInFaction(ssxAllFriends)
					a.removeFromFaction(ssxAllFriends)
					float olda = a.GetActorValue("Aggression")
					float newa = a.GetBaseActorValue("Aggression")
					ssxRunnerQuest.log("Factions Cleaner: restoring combat for " + SNumCleaned + ": aggression " + olda + " --> " + newa, SSX_Runner_Quest.notifCleanDetails())
					a.SetActorValue("Aggression", newa)
					a.evaluatePackage()
				endIf
			endIf
		endWhile
		return found
	EndFunction

endState








