Scriptname SSX_Performance_Test_Actor Extends Actor

Actor Property PlayerRef Auto
SSX_Runner_Quest Property ssxRunnerQuest Auto

Float timeFirstStart
int step
int substep

Float timeC
int numC
Float timeA
int numA
Float timeM
int numM
Float timeL
int numL
Float timeH
int numH
Float timeU
int numU
Float extraTime

Function startTest()
	timeFirstStart = -1.0
	extraTime=0.0
	step=0
	substep=0
	numC=0
	numA=0
	numM=0
	numL=0
	numH=0
	numU=0
	RegisterForSingleUpdate(5.0)
EndFunction



Event OnUpdate()
	int i=0
	int j=0
	if timeFirstStart==-1.0
		Self.enableNoWait()
		Self.MoveTo(PlayerRef, 30, 30, 0)
		Utility.waitMenuMode(2.0) ; Give a little bit of time to finalize the close of the MCM
		Utility.waitMenuMode(2.0)
		Debug.trace("SSX DEBUG: Performance test is starting, phase 1 - Calculations")
		Debug.notification("SSX DEBUG: Performance test is starting, phase 1 - Calculations")
		timeFirstStart = Utility.GetCurrentRealTime()
		timeC = Utility.GetCurrentRealTime()
	endIf
	
	if !ssxRunnerQuest
		Debug.MessageBox("Scent of Sex could not be found!\nThe test will NOT be performed correctly!")
	endIf
	
	; C 0<10
	; A 20<30
	; M 40<50
	; L 60<70
	; H 80<90
	; U 100<110
	
	if step<20 ; Math
		i=0
		j=1
		while i<5000
			j+=2
			j*=2
			j-=1
			j/=2
			i+=1
		endWhile
		numC += 1
		
		step+=1
		if (Utility.GetCurrentRealTime() - timeC)>19.9
			timeC += (Utility.GetCurrentRealTime() - timeC)
			step==20
		elseIf step<10
			RegisterForSingleUpdate(1.0)
		elseIf step==10
			timeC = Utility.GetCurrentRealTime() - timeC
			extraTime += 20.0 - timeC
			step=20
		endIf
		
		if step==20
			Debug.trace("SSX DEBUG: Performance test is starting, phase 2 - Arrays")
			Debug.notification("SSX DEBUG: Performance test is starting, phase 2 - Arrays")
			timeA = Utility.GetCurrentRealTime()
			RegisterForSingleUpdate(0.1)
		endIf
		return

	elseIf step<40 ; Arrays
		Actor[] actors = new Actor[32]
		i = 32
		while i
			i-=1
			if Utility.RandomInt(0,1)==0
				actors[i] = PlayerRef
			else
				actors[i] = Self
			endIf
		endWhile
		i = 32
		while i
			i-=1
			actors[i] = None
		endWhile
		numA += 1
		
		step+=1
		if (Utility.GetCurrentRealTime() - timeA)>19.9
			timeA = Utility.GetCurrentRealTime() - timeA
			step==40
		elseIf step<30
			RegisterForSingleUpdate(1.0)
		elseIf step==30
			timeA = Utility.GetCurrentRealTime() - timeA
			extraTime += 20.0 - timeA
			step=40
		endIf

		if step==40
			Debug.trace("SSX DEBUG: Performance test is starting, phase 3 - Memory")
			Debug.notification("SSX DEBUG: Performance test is starting, phase 3 - Memory")
			timeM = Utility.GetCurrentRealTime()
			RegisterForSingleUpdate(1.0)
		endIf
		return
		
	elseIf step<60 ; Memory
		String[] strings = Utility.CreateStringArray(32)
		j=0
		while j<16
			i=strings.length
			while i
				i-=1
				strings[i] = "test" + i
			endWhile
			strings = ssxRunnerQuest.ResizeStringArray(strings, strings.length+32)
			j+=1
		endWhile
		numM += 1

		step+=1
		if (Utility.GetCurrentRealTime() - timeM)>19.9
			timeM = Utility.GetCurrentRealTime() - timeM
			step==60
		elseIf step<50
			RegisterForSingleUpdate(1.0)
		elseIf step==50
			timeM = Utility.GetCurrentRealTime() - timeM
			extraTime += 20.0 - timeM
			step=60
		endIf
		
		if step==60
			Debug.trace("SSX DEBUG: Performance test is starting, phase 4 - Light events")
			Debug.notification("SSX DEBUG: Performance test is starting, phase 4 - Light events")
			timeL = Utility.GetCurrentRealTime()
			RegisterForSingleUpdate(0.1)
		endIf
		return
		
	elseIf step<80 ; Light
		String[] tmp = new String[4]
		tmp[0]="Test 1"
		tmp[1]=tmp[0]+"Test 2"
		tmp[2]=tmp[1]+"Test 3"
		tmp[3]=tmp[2]+"Test 4"
		Self.EvaluatePackage()
		Self.MakePlayerFriend()
		Self.CanFlyHere()
		Self.getActorValue("Health")
		Self.GetCombatState()
		Self.GetEquippedItemType(1)
		Self.GetEquippedShout()
		Self.GetRace()
		Self.IsChild()
		Self.IsDead()
		numL += 1

		step+=1
		if (Utility.GetCurrentRealTime() - timeL)>19.9
			timeL = Utility.GetCurrentRealTime() - timeL
			step==80
		elseIf step<70
			RegisterForSingleUpdate(1.0)
		elseIf step==70
			timeL = Utility.GetCurrentRealTime() - timeL
			extraTime += 20.0 - timeL
			step=80
		endIf

		if step==80
			Debug.trace("SSX DEBUG: Performance test is starting, phase 5 - Heavy events")
			Debug.notification("SSX DEBUG: Performance test is starting, phase 5 - Heavy events")
			timeH = Utility.GetCurrentRealTime()
			RegisterForSingleUpdate(0.1)
			endIf
		return
	
	elseIf step<100 ; Heavy
		String[] tmp = new String[8]
		Self.EvaluatePackage()
		tmp[0]="Test 1"
		tmp[1]=tmp[0]+"Test 2"
		tmp[2]=tmp[1]+"Test 3"
		tmp[3]=tmp[2]+"Test 4"
		tmp[4]=tmp[3]+"Test 5"
		tmp[5]=tmp[4]+"Test 6"
		tmp[6]=tmp[5]+"Test 7"
		tmp[7]=tmp[6]+"Test 8"
		Self.MakePlayerFriend()
		Self.CanFlyHere()
		Self.getActorValue("Stamina")
		Self.GetCombatState()
		Self.GetEquippedItemType(0)
		Self.GetEquippedShout()
		Self.GetRace()
		Self.IsChild()
		Self.IsDead()
		Self.EvaluatePackage()
		int handle = ModEvent.Create("NotExistentEvent")
		ModEvent.PushInt(handle, Utility.RandomInt(0, 1000))
		ModEvent.PushForm(handle, self)
		ModEvent.Send(handle)
		Self.EvaluatePackage()
		Debug.sendAnimationEvent(Self, "Arrok_Undress_G0")
		numH += 1

		step+=1
		if (Utility.GetCurrentRealTime() - timeH)>19.9
			timeH = Utility.GetCurrentRealTime() - timeH
			step==100
		elseIf step<90
			RegisterForSingleUpdate(0.5)
		elseIf step==90
			timeH = Utility.GetCurrentRealTime() - timeH
			extraTime += 20.0 - timeH
			step=100
		endIf
		
		if step==100
			Debug.trace("SSX DEBUG: Performance test is starting, phase 6 - Update events")
			Debug.notification("SSX DEBUG: Performance test is starting, phase 6 - Update events")
			timeU = Utility.GetCurrentRealTime()
			substep=0
			RegisterForSingleUpdate(0.1)
		endIf
		return
		
	elseIf step<120 ; Update
		numU += 1
		if Utility.GetCurrentRealTime() - timeU < 20.0
			if step<105
				substep=0
				step+=1
				Utility.waitMenuMode(0.25)
				RegisterForSingleUpdate(0.5)
				return
			elseIf step<110
				if substep<1
					substep+=1
				else
					substep=0
					step+=1
				endIf
				Utility.waitMenuMode(0.15)
				RegisterForSingleUpdate(0.25)
				return
			elseIf step<115
				if substep<4
					substep+=1
				else
					substep=0
					step+=1
				endIf
				Utility.waitMenuMode(0.05)
				RegisterForSingleUpdate(0.1)
				return
			endIf
			step=120
			timeU = Utility.GetCurrentRealTime() - timeU
			extraTime += 20.0 - timeU
		else
			step=120
			timeU = Utility.GetCurrentRealTime() - timeU
		endIf
	endIf
	
	; Finalize	
	Debug.trace("SSX DEBUG: Performance test is completed")
	Debug.notification("SSX DEBUG: Performance test is completed")
	; Finalize and show results
	String res = "Performance testing completed\nLower numbers = better performance\n"
	Float totalTime = (100.0 * (Utility.GetCurrentRealTime() - timeFirstStart)) as Int / 100.0
	res += "Total time = " + (totalTime as int) + " secs, Xtr=" + (extraTime as int) + ".\nExpected 120 seconds.\nPerformance = " + (12000/totalTime) as Int + "%\n"
	int perc = (2000/timeC) as Int
	step =  (numC*10) as Int
	if perc >= 100
		perc=100
	endIf
	res += "Math = " + timeC + "s, Perf " + perc + "%, Steps " + step + "%\n"

	perc = (2000/timeA) as Int
	step =  (numA*10) as Int
	if perc >= 100
		perc=100
	endIf
	res += "Arrays = " + timeA + "s, Perf " + perc + "%, Steps " + step + "%\n"

	perc = (2000/timeM) as Int
	step =  (numM*10) as Int
	if perc >= 100
		perc=100
	endIf
	res += "Memory = " + timeM + "s, Perf " + perc + "%, Steps " + step + "%\n"
	
	perc = (2000/timeL) as Int
	step =  (numL*10) as Int
	if perc >= 100
		perc=100
	endIf
	res += "Light evs = " + timeL + "s, Perf " + perc + "%, Steps " + step + "%\n"
	
	perc = (2000/timeH) as Int
	step =  (numH*10) as Int
	if perc >= 100
		perc=100
	endIf
	res += "Heavy evs = " + timeH + "s, Perf " + perc + "%, Steps " + step + "%\n"
	
	if numU>40
		numU=40
	endIf
	perc = (2000/timeU) as Int
	step = (5.0*numU/2.0) as Int
	if perc >= 100
		perc=100
	endIf
	res += "Updates = " + timeU + "s, Perf " + perc + "%, Steps " + step + "%\n"
	
	perc = 12000/(100.0 * (Utility.GetCurrentRealTime() - timeFirstStart)) as Int / 100.0 as Int
	if perc>100
		perc=100
	endIf
	perc = (((perc + \
		(2000/timeC) + (numC*10) + \
		(2000/timeA) + (numA*10) + \
		(2000/timeM) + (numM*10) + \
		(2000/timeL) + (numL*10) + \
		(2000/timeH) + (numH*10) + \
		(2000/timeU) + (5.0*numU/2.0)) / 13) as Int)
	if perc >= 100
		perc=100
	endIf
	res+="Final Aggregated Performance = " + perc + "%"

	Debug.trace("SSX Debug: Performance testing\n" + res)
	Debug.MessageBox(res)
	UnregisterForUpdate()
	Self.disableNoWait()
EndEvent

