Scriptname SSX_Player_Load_Game_Alias  extends ReferenceAlias ; V1.4d

SSX_Runner_Quest Property ssxRunnerQuest Auto
SSX_Deferred_Config_Loader_Quest Property ssxDeferredConfigLoaderQuest Auto
SSX_Deferred_Tags_Loader_Quest Property ssxDeferredTagsLoaderQuest Auto
SSX_Deferred_Items_Loader_Quest Property ssxDeferredItemsLoaderQuest Auto
SSX_Deferred_Actors_Loader_Quest Property ssxDeferredActorsLoaderQuest Auto
SSX_Deferred_Mods_Loader_Quest Property ssxDeferredModsLoaderQuest Auto
SSX_Cell_Scanner_Quest Property ssxCellScannerQuest Auto
SSX_SPID_Scanner_Quest Property ssxSPIDScannerQuest Auto
SSX_Rule_Player_Quest Property ssxRulePlayerQuest Auto
SSX_Rule_Checker_Quest Property ssxRuleCheckerQuest Auto
SSX_Scene_Manager_Quest Property ssxSceneManagerQuest Auto
SSX_Faction_Cleaner_Quest Property ssxFactionCleanerQuest Auto
SSX_Actor_Cleaner_Quest Property ssxActorCleanerQuest Auto

Bool doingFirstInit = false

;	ssxRunnerQuest.iAmInitialized: 0=nothing done, =installing, =install completed

Event OnInit()
	ssxRunnerQuest.iAmInitialized=0
	ssxRunnerQuest.isInitInProgress=-1
	doingFirstInit = true
	RegisterForModEvent("ssxForceRestart", "reInitSSX")
	doInit("OnInit")
EndEvent

Event OnPlayerLoadGame()
	ssxRunnerQuest.iAmInitialized=0
	ssxRunnerQuest.isInitInProgress=-1
	UnRegisterForModEvent("ssxForceRestart")
	RegisterForModEvent("ssxForceRestart", "reInitSSX")
	Utility.waitMenuMode(0.5)
	if doingFirstInit
		return
	endIf
	doInit("OnPlayerLoadGame")
EndEvent

Event reInitSSX(String unused)
	ssxRunnerQuest.iAmInitialized=-1
	ssxRunnerQuest.isInitInProgress=-1
	doingFirstInit=true
	doInit("MCM")
EndEvent

Function doInit(String fromWho)
	if ssxRunnerQuest.iAmInitialized==1
		return
	endIf
	
	ssxRunnerQuest.isInitInProgress=1
	ssxRunnerQuest.configFile = ssxRunnerQuest.configFolder + "Scent of Sex Config.json"
	if !ssxRunnerQuest.doInit() ; Runner
		doingFirstInit = false
		return
	endIf
	ssxRunnerQuest.isInitInProgress=5
	ssxRunnerQuest.iAmInitialized=1 ; Init progressing
	Utility.waitMenuMode(0.1)
	ssxDeferredConfigLoaderQuest.doInit()
	ssxRunnerQuest.isInitInProgress=10
	Utility.waitMenuMode(0.1)
	int handle = ModEvent.Create("ssxUpdateConfig")
	ModEvent.PushString(handle, "Load")
	ModEvent.PushString(handle, fromWho)
	ModEvent.Send(handle)
	ssxRunnerQuest.isInitInProgress=15
	Utility.waitMenuMode(0.1)
	ssxCellScannerQuest.doInit()
	ssxRunnerQuest.isInitInProgress=20
	Utility.waitMenuMode(0.2)
	ssxSPIDScannerQuest.doInit()
	; Alias Scanner was here, that's why the percentages are off
	ssxRunnerQuest.isInitInProgress=30
	Utility.waitMenuMode(0.2)
	ssxRuleCheckerQuest.doInit()
	ssxRunnerQuest.isInitInProgress=35
	Utility.waitMenuMode(0.2)
	ssxRulePlayerQuest.doInit()
	ssxRunnerQuest.isInitInProgress=40
	Utility.waitMenuMode(0.2)
	ssxSceneManagerQuest.doInit()
	ssxRunnerQuest.isInitInProgress=45
	Utility.waitMenuMode(0.2)
	ssxDeferredModsLoaderQuest.doInit()
	ssxRunnerQuest.isInitInProgress=50
	Utility.waitMenuMode(0.2)
	ssxDeferredActorsLoaderQuest.doInit()
	ssxRunnerQuest.isInitInProgress=55
	Utility.waitMenuMode(0.2)
	ssxDeferredTagsLoaderQuest.doInit()
	ssxRunnerQuest.isInitInProgress=60
	Utility.waitMenuMode(0.2)
	ssxDeferredItemsLoaderQuest.doInit()
	ssxRunnerQuest.isInitInProgress=65
	Utility.waitMenuMode(0.2)
	ssxFactionCleanerQuest.doInit()
	ssxRunnerQuest.isInitInProgress=70
	Utility.waitMenuMode(0.2)
	ssxRunnerQuest.postInit()
	ssxRunnerQuest.isInitInProgress=75
	Utility.waitMenuMode(0.2)
	ssxRunnerQuest.isInitInProgress=80
	debug.trace("Scent of Sex NG Initialized - " + ssxRunnerQuest.getVersionString())
	debug.notification("Scent of Sex NG Initialized - " + ssxRunnerQuest.getVersionString())
	ssxRunnerQuest.iAmInitialized=2 ; Init completed
	Utility.waitMenuMode(0.5)
	handle = ModEvent.Create("ssxRescanTags")
	ModEvent.PushString(handle, fromWho)
	ModEvent.Send(handle)
	ssxRunnerQuest.isInitInProgress=85
	handle = ModEvent.Create("ssxRescanActors")
	ModEvent.PushString(handle, fromWho)
	ModEvent.Send(handle)
	Utility.waitMenuMode(0.5)
	ssxRunnerQuest.isInitInProgress=90
	handle = ModEvent.Create("ssxScanMods")
	ModEvent.PushString(handle, fromWho)
	ModEvent.Send(handle)
	Utility.waitMenuMode(0.5)
	ssxRunnerQuest.isInitInProgress=95
	doingFirstInit = false
	ssxActorCleanerQuest.doInit()
	ssxRunnerQuest.checkPlayerProtection()
	ssxRunnerQuest.isInitInProgress=100
EndFunction
