Scriptname SSX_Rule_Checker_Quest extends Quest Conditional ; V1.4g
{Grabs all the valid rules, select one, fill it, and runs it if possible}

; ((- Properties
SSX_Runner_Quest Property ssxRunnerQuest Auto
Faction Property SexLabAnimatingFaction Auto
Actor Property PlayerRef Auto

Actor[] Property tmpActors Auto
int numTmpActors

; scenes: 0=PlayerAsk; 1=PlayerIsAsked, 2..5=NPC to NPC scenes
; factions: one for each possible dialogue the player has (5)
; conditionals for the asnwers (5), conditionals for the final sentences (6, one for each possible scene, it is set when the scene starts)
; When a rule is checked, the actors are added to the asking factions, and the conditionals are set

Faction Property ssxAskingFaction Auto ; The faction is used to identify the actors that will ask, globally and for all scenes
int Property ssxRequest1 Auto Conditional ; Request by NPC for the player --> Paired with the scene
int Property ssxRequest2 Auto Conditional ; Request by NPC to NPC --> Paired with the scene
int Property ssxRequest3 Auto Conditional ; Request by NPC to NPC --> Paired with the scene
int Property ssxRequest4 Auto Conditional ; Request by NPC to NPC --> Paired with the scene
int Property ssxRequest5 Auto Conditional ; Request by NPC to NPC --> Paired with the scene
int Property ssxPossibleAnswer0 Auto Conditional ; Possible answer of for the first faction
int Property ssxPossibleAnswer1 Auto Conditional ; Possible answer of for the second faction
int Property ssxPossibleAnswer2 Auto Conditional ; Possible answer of for the third faction
int Property ssxPossibleAnswer3 Auto Conditional ; Possible answer of for the fourth faction
int Property ssxPossibleAnswer4 Auto Conditional ; Possible answer of for the fifth faction

int actorsLenD = 0
int actorsLenS = 0
int actorsLenC = 0
Actor[] actorsD
Actor[] actorsS
Actor[] actorsC
int potentialLenD = 0
int potentialLenS = 0
int potentialLenC = 0
Actor[] potentialsD
Actor[] potentialsS
Actor[] potentialsC

bool restoringAggression
String whoIsChecking

; -))


; ((- Cached status for actors

bool[] actorsNA	;01
bool[] actorsSN	;02
bool[] actorsSS	;03
int[] actorsAR	;04
int[] actorsHE	;05
int[] actorsST	;06
int[] actorsMA	;07
bool[] actorsSL	;08
bool[] actorsSK	;09
bool[] actorsWE	;10
bool[] actorsCO	;11
bool[] actorsBL	;12
bool[] actorsUN	;13

bool checkNA
bool checkSN
bool checkSS
bool checkAR
bool checkHE
bool checkST
bool checkMA
bool checkSL
bool checkSK
bool checkWE
bool checkCO
bool checkBL
bool checkUN
bool checkWR


; -))

Function doInit()
	RegisterForModEvent("ssxStartSSXMod", "startSSXRC")
	RegisterForModEvent("ssxStartSSXRC", "startSSXRC")
	RegisterForModEvent("ssxStopSSXMod", "stopSSXRC")
	RegisterForModEvent("ssxPlayRule", "playRule")
	RegisterForModEvent("ssxDoIt", "doItNow")
	RegisterForModEvent("ssxSetPlayerProtectedCatcher", "setPlayerProtectedCatcher")
	actorsD = new Actor[64]
	actorsS = new Actor[64]
	actorsC = new Actor[64]
	potentialsD = new Actor[64]
	potentialsS = new Actor[64]
	potentialsC = new Actor[64]
	int len = ssxRunnerQuest.allActors.length
	actorsNA = Utility.createBoolArray(len)
	actorsSN = Utility.createBoolArray(len)
	actorsSS = Utility.createBoolArray(len)
	actorsAR = Utility.createIntArray(len)
	actorsHE = Utility.createIntArray(len)
	actorsST = Utility.createIntArray(len)
	actorsMA = Utility.createIntArray(len)
	actorsSL = Utility.createBoolArray(len)
	actorsSK = Utility.createBoolArray(len)
	actorsWE = Utility.createBoolArray(len)
	actorsCO = Utility.createBoolArray(len)
	actorsBL = Utility.createBoolArray(len)
	actorsUN = Utility.createBoolArray(len)
	restoringAggression=false
	whoIsChecking=""
	ssxRunnerQuest.log("Rule Checker events registered", SSX_Runner_Quest.notifCheckerDetails())
endFunction

; ((- Generic no-state events
Event startSSXRC(int unused)
	if !ssxRunnerQuest.needP && ssxRunnerQuest.noActors()
		ssxRunnerQuest.log("Rule Checker is waiting for the actors to be found by the scanner", SSX_Runner_Quest.notifCheckerDetails())
		return
	endIf
	if getState()=="active"
		return
	endIf
	ssxRunnerQuest.log("Rule Checker going to active state", SSX_Runner_Quest.notifCheckerDetails())
	goToState("active")
EndEvent

Event stopSSXRC(String unused)
	ssxRunnerQuest.log("Rule Checker going to inactive state", SSX_Runner_Quest.notifCheckerDetails())
	while restoringAggression
		Utility.waitMenuMode(1.0)
	endWhile
	goToState("inactive")
EndEvent

Event doItNow(String mod)
	if mod=="RuleChecker"
		UnregisterForUpdate()
		if ssxRunnerQuest.checkingMode==0
			RegisterForSingleUpdate(0.1)
		endIf
		goToState("active")
	endIf
EndEvent

Event playRule(Form a, Form b, int catchMode, int r1, int r2, int r3, int r4, int r5, int r6, int r7, int r8, int eventID)
	ssxRunnerQuest.log("Rule Checker received an Event Catcher but was not active", SSX_Runner_Quest.notifCheckerDetails())
	ssxRunnerQuest.resetCombat()
EndEvent


bool Function reserveSchedule(int eventID)
	if eventID == -1
		if whoIsChecking != "" ; update is running but event is taking mutex
			return true
		endIf
		return reserveScheduleUpdate()
	endIf
	return reserveScheduleEvent(eventID, true)
EndFunction

bool Function reserveScheduleUpdate() ; called from onUpdate, handling regular rule checks
    int s = ssxRunnerQuest.schedulerCanIDo("Rule Checker Update")
    while s
        if s == 2
            return false
        endIf ; s == 1
        Utility.waitMenuMode(0.5)
        s = ssxRunnerQuest.schedulerCanIDo("Rule Checker Update")
    endWhile ; s == 0
	cleanupUpdate()
	gotoState("inactive")
    return true
EndFunction

bool Function reserveScheduleEvent(int eventID, bool bypass = false) ; called from playRule, handling ssxEventCatcher events
	if eventID != -1
		ssxRunnerQuest.refreshEvent(eventID)
	endIf
	int s = 1
	int e = ssxRunnerQuest.firstEvent()
	if bypass || e == eventID || e == -1
		s = ssxRunnerQuest.schedulerCanIDo("Rule Checker Event")
	endIf
	while s
		if s == 2
			return false
		endIf ; s == 1
		Utility.waitMenuMode(0.2)
		e = ssxRunnerQuest.firstEvent()
		if bypass || e == eventID || e == -1
			s = ssxRunnerQuest.schedulerCanIDo("Rule Checker Event")
		endIf
	endWhile ; s == 0
	cleanupEvent(eventID)
	gotoState("inactive")
	return true
EndFunction

Function cleanupEvent(int eventID)
	ssxRunnerQuest.releaseEvent(eventID)
	ssxRunnerQuest.schedulerIAmDone("Rule Checker Event")
EndFunction

Function cleanupUpdate()
	ssxRunnerQuest.schedulerIAmDone("Rule Checker Update")
EndFunction

Function redoEvent(int mode, int eventID) ; called from playRule, handling ssxEventCatcher events
	UnRegisterForUpdate()
	float time = Utility.randomFloat(ssxRunnerQuest.ruleCheckerMinWaitTime, ssxRunnerQuest.ruleCheckerMaxWaitTime)
	RegisterForSingleUpdate(time)
	cleanupEvent(eventID)
	if !ssxRunnerQuest.hasEvent()
		ssxRunnerQuest.stopCeaseFire(mode)
	endIf
EndFunction

Function redoUpdate() ; called from onUpdate, handling regular rule checks
	UnRegisterForUpdate()
	float time = Utility.randomFloat(ssxRunnerQuest.ruleCheckerMinWaitTime, ssxRunnerQuest.ruleCheckerMaxWaitTime)
	RegisterForSingleUpdate(time)
	cleanupUpdate()
EndFunction

; -))

state inactive
	Function OnBeginState()
		while restoringAggression
			Utility.waitMenuMode(1.0)
		endWhile
		; Be sure we stop everything
		WhoIsChecking = ""
		UnregisterForUpdate()
		Utility.waitMenuMode(1.0)
		UnregisterForUpdate()
		WhoIsChecking = ""
		cleanupUpdate()
		cleanupEvent(-1)
		
		int i = actorsCatchers.length
		while i
			i-=1
			if actorsCatcherModes[i]==2
				actorsCatchers[i]=None
				actorsCatcherModes[i]=0
				(eventCatchersB[i] as SSX_Event_Catcher_Alias).clean()
			elseIf actorsCatcherModes[i]==1
				actorsCatchers[i]=None
				actorsCatcherModes[i]=0
				(eventCatchers[i] as SSX_Event_Catcher_Alias).clean()
			endIf
		endWhile
	endFunction
	
	int Function checkTheRules(SSX_Rule_Alias[] rules, int eventID = -1)
		WhoIsChecking = ""
		return 0
	EndFunction
	
	Event startSSXRC(int unused)
		goToState("active")
	EndEvent

	Event stopSSXRC(String unused)
		return
	EndEvent

	Event doItNow(String mod)
		ssxRunnerQuest.log("Cannot do an update, I am stopped: Rule Checker", SSX_Runner_Quest.notifCheckerDetails())
	EndEvent
	
endState

state active

	; If ChekerMode==time, register for updates
	; If ChekerMode==When something to do, don't register

	Function OnBeginState()
		if ssxRunnerQuest.checkingMode==0
			if ssxRunnerQuest.startRightAway==1
				RegisterForSingleUpdate(2.0)
				ssxRunnerQuest.log("Starting right away", SSX_Runner_Quest.notifCheckerDetails())
			else
				float time = Utility.randomFloat(ssxRunnerQuest.ruleCheckerMinWaitTime, ssxRunnerQuest.ruleCheckerMaxWaitTime)
				RegisterForSingleUpdate(time)
				ssxRunnerQuest.log("Time to wait for the next update = " + (time as int) + " seconds", SSX_Runner_Quest.notifCheckerDetails())
			endIf
		else
			ssxRunnerQuest.log("Checking will start when something will be possible", SSX_Runner_Quest.notifCheckerDetails())
		endIf
	endFunction
	
	Event startSSXRC(int unused)
		return
	EndEvent

	Event stopSSXRC(String unused)
		while restoringAggression
			Utility.waitMenuMode(1.0)
		endWhile
		UnregisterForUpdate()
		GoToState("inactive")
	EndEvent

	Event doItNow(String mod)
		if mod=="RuleChecker"
			UnregisterForUpdate()
			if ssxRunnerQuest.checkingMode==0
				RegisterForSingleUpdate(0.1)
			else
				OnUpdate()
			endIf
		endIf
	EndEvent
	
	Event playRule(Form a, Form b, int catchMode, int r1, int r2, int r3, int r4, int r5, int r6, int r7, int r8, int eventID)
		UnregisterForUpdate()
		ssxRunnerQuest.log("Rule Checker: playing rules from Event Catchers, EVENT " + eventID, SSX_Runner_Quest.notifCheckerDetails())
		if reserveScheduleEvent(eventID)
			return
		endIf
		
		if a
			ssxRunnerQuest.addToAllActors(a as Actor)
		endIf
		if b
			ssxRunnerQuest.addToAllActors(b as Actor)
		endIf
		
		; Try to fill the rule (any of the set), if at least one rule can be filled, then mark it as valid and call the Rule player
		if r8==0 && r7==0 && r6==0 && r5==0 && r4==0 && r3==0 && r2==0 && r1==0
			redoEvent(catchMode, eventID)
			return
		endIf
		
		if reserveScheduleEvent(eventID)
			return
		endIf

		if ssxRunnerQuest.noActors()
			redoEvent(catchMode, eventID)
			ssxRunnerQuest.log("Rule Checker - No actors.", SSX_Runner_Quest.notifCheckerDetails())
			return
		endIf
	
		while ssxRunnerQuest.letsWait
			Utility.waitMenuMode(1.0)
		endWhile
		
		if ssxRunnerQuest.countScenesPlaying()>=ssxRunnerQuest.maxNumberOfParallelScenes
			redoEvent(catchMode, eventID)
			ssxRunnerQuest.log("Rule Checker - Too many scenes are already playing.", SSX_Runner_Quest.notifCheckerDetails())
			return
		endIf

		if reserveScheduleEvent(eventID)
			return
		endIf
		
		int i = 0
		SSX_Rule_Alias[] testRules = new SSX_Rule_Alias[8]
		if r1
			testRules[i] = ssxRunnerQuest.getRuleById(r1)
			i += 1
		endIf
		if r2
			testRules[i] = ssxRunnerQuest.getRuleById(r2)
			i += 1
		endIf
		if r3
			testRules[i] = ssxRunnerQuest.getRuleById(r3)
			i += 1
		endIf
		if r4
			testRules[i] = ssxRunnerQuest.getRuleById(r4)
			i += 1
		endIf
		if r5
			testRules[i] = ssxRunnerQuest.getRuleById(r5)
			i += 1
		endIf
		if r6
			testRules[i] = ssxRunnerQuest.getRuleById(r6)
			i += 1
		endIf
		if r7
			testRules[i] = ssxRunnerQuest.getRuleById(r7)
			i += 1
		endIf
		if r8
			testRules[i] = ssxRunnerQuest.getRuleById(r8)
			i += 1
		endIf
		
		float justNow = Utility.GetCurrentGameTime()
		int hour = ((justNow - Math.floor(justNow)) * 24) as Int
		int numVRules = 0
		int numPRules = 0
		int act
		
		; Check for all rules what are the things to check.

		; Be sure to add the player if needed
		if ssxRunnerQuest.needP && ssxRunnerQuest.addToAllActors(PlayerRef) ; addToAllActors has special logic to check and ensure player is put in
			ssxRunnerQuest.log("Rule Checker - Player is needed but failed to add to allActors!", SSX_Runner_Quest.notifCheckerDetails())
		endIf
		
		; OK, now check the rules
		if checkTheRules(testRules, eventID)==2
			int handle = ModEvent.Create("ssxPlayRulesNow")
			ModEvent.PushForm(handle, a)
			ModEvent.PushForm(handle, b)
			ModEvent.PushInt(handle, catchMode)
			i = testRules.length
			while i
				i -= 1
				SSX_Rule_Alias r = testRules[i]
				if r && r.status == 2
					ModEvent.PushInt(handle, r.id)
					numVRules += 1
				elseIf r && r.status==1
					numPRules+=1
				endIf
			endWhile
			i = testRules.length - numVRules
			while i
				i -= 1
				ModEvent.PushInt(handle, 0)
			endWhile
			ModEvent.send(handle)
		endIf
		redoEvent(0, eventID)


		if numVRules==0 && ((catchMode==3 && ssxRunnerQuest.protectOnHealth) || catchMode==5) && ssxRunnerQuest.needP && PlayerRef.isBleedingOut()
			while PlayerRef.getActorValue("Health")<5
				PlayerRef.RestoreActorValue("Health", (5.0 - PlayerRef.getActorValue("Health")) / 1.2)
				Game.ForceThirdPerson()
				Utility.waitMenuMode(0.5)
			endWhile
		endIf
		ssxRunnerQuest.log("Rule Checker - Rules checking on EVENT " + eventID + " completed. Found " + numVRules + " valid rules and " + numPRules + " potential rules.", SSX_Runner_Quest.notifCheckerDetails())
	EndEvent
	

	Event OnUpdate()
		UnregisterForUpdate()
		if reserveScheduleUpdate()
			return
		endIf
		
		ssxRunnerQuest.log("Rule Checker - Starting the checking", SSX_Runner_Quest.notifCheckerDetails())
		if ssxRunnerQuest.noActors()
			; No actors, let's move to inactive. The Scanner will wake up up
			ssxRunnerQuest.log("Rule Checker is waiting for the actors to be found by the scanner", SSX_Runner_Quest.notifCheckerDetails())
			cleanupUpdate()
			if ssxRunnerQuest.checkingMode==0
				GoToState("inactive")
			endIf
			return
		endIf
		
		if reserveScheduleUpdate()
			return
		endIf

		while ssxRunnerQuest.letsWait
			Utility.waitMenuMode(1.0)
		endWhile
	
		if ssxRunnerQuest.countScenesPlaying()>=ssxRunnerQuest.maxNumberOfParallelScenes
			if ssxRunnerQuest.checkingMode==0
				redoUpdate()
			endIf
			ssxRunnerQuest.log("Rule Checker - Too many scenes are already playing.", SSX_Runner_Quest.notifCheckerDetails())
			return
		endIf
		
		; Check all rules from ssxRunnerQuest
		float justNow = Utility.GetCurrentGameTime()
		int hour = ((justNow - Math.floor(justNow)) * 24) as Int
		int numVRules = 0
		int numPRules = 0
		int act

		; Be sure to add the player if needed
		if ssxRunnerQuest.needP && ssxRunnerQuest.allActors.find(PlayerRef)==-1
			ssxRunnerQuest.addToAllActors(PlayerRef)
		endIf

		; OK, now check the rules
		if checkTheRules(ssxRunnerQuest.rules, -1) > 0
			int i = ssxRunnerQuest.rules.length
			while i
				i-=1
				SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
				if r && r.startsOn == 0
					if r.status == 2
						numVRules+=1
						ssxRunnerQuest.log("VALID rule " + r.name, SSX_Runner_Quest.notifCheckerDetails())
					elseIf r.status==1
						numPRules+=1
						ssxRunnerQuest.log("POTENTIAL rule " + r.name, SSX_Runner_Quest.notifCheckerDetails())
					endIf
				endIf
			endWhile
		endIf

		; OK, all rules are evaluated and filled
		if reserveScheduleUpdate()
			return
		endIf
		
		; Set up catchers if needed
		setUpCatchers()
		
		; And send the event to Player in case at least one rule is good
		if numVRules>0
			; Send the mod event
			int handle = ModEvent.Create("ssxPlayRules")
			ModEvent.PushInt(handle, 0) ; No previous rules
			ModEvent.Send(handle)
		endIf
		
		if ssxRunnerQuest.checkingMode==0
			redoUpdate()
		endIf
		ssxRunnerQuest.log("Rule Checker - Rules checking on update completed. Found " + numVRules + " valid rules and " + numPRules + " potential rules.", SSX_Runner_Quest.notifCheckerDetails())
	EndEvent
endState



int Function checkTheRules(SSX_Rule_Alias[] rules, int eventID = -1)
	int res = 0
	int i = rules.length
	ssxRunnerQuest.clearCachePreCheck() ; clear cache for: SN, SS, AR, HE, ST, MA, SK, WE, UN
	while i
		i-=1
		
		if reserveSchedule(eventID)
			return 0
		endIf
		
		SSX_Rule_Alias r = rules[i]
		if r && r.inUse==2
			; start the mutex on arrays
			while whoIsChecking!=""
				Utility.waitMenuMode(0.5)
			endWhile
			if eventID != -1 ; an event will nuke update, so update can run without mutex as long as function is free
				whoIsChecking=eventID
			endIf
			int ruleStatus = checkRuleForActors(r)
			if ruleStatus == 2 ; Can be played right now
				res=2
				; Check if the player will ask, in this case put the actors in the correct faction
				Faction canBeAsked = None
				if r.startsOn==1 ; Player asks
					canBeAsked = ssxRunnerQuest.setUpPlayerDialogues(r)
					ssxRunnerQuest.rulesAskFactions[ssxRunnerQuest.rules.find(r)] = canBeAsked
				else
					ssxRunnerQuest.rulesAskFactions[ssxRunnerQuest.rules.find(r)] = None
				endIf
				r.setValidActors(0, actorsD, actorsLenD, potentialsD, potentialLenD, canBeAsked)
				if ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorForRule())
					printActors("Targets", r, actorsD, actorsLenD, potentialsD, potentialLenD)
				endIf
				if reserveSchedule(eventID)
					return 0
				endIf

				r.setValidActors(1, actorsS, actorsLenS, potentialsS, potentialLenS, canBeAsked)
				if ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorForRule())
					printActors("Sources", r, actorsS, actorsLenS, potentialsS, potentialLenS)
				endIf
				if reserveSchedule(eventID)
					return 0
				endIf
				if canBeAsked && ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightAsk())
					int color = ssxRunnerQuest.notifHighLightColorAskable
					if color
						int act=actorsLenD
						while act
							act-=1
							ssxRunnerQuest.hlg(actorsD[act], color, SSX_Runner_Quest.highlightAsk())
						endWhile
						act=actorsLenS
						while act
							act-=1
							ssxRunnerQuest.hlg(actorsS[act], color, SSX_Runner_Quest.highlightAsk())
						endWhile
					endIf
				endIf
				r.setValidActors(2, actorsC, actorsLenC, potentialsC, potentialLenC, None)
				if ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorForRule())
					printActors("Collaborators", r, actorsC, actorsLenC, potentialsC, potentialLenC)
				endIf
				r.status = 2
				
			elseIf ruleStatus == 1 ; Cannot be played now, but is potential
				if res!=2
					res=1
				endIf
				r.setValidActors(0, actorsD, actorsLenD, potentialsD, potentialLenD, None)
				if ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorForRule())
					printActors("Targets", r, actorsD, actorsLenD, potentialsD, potentialLenD)
				endIf
				if reserveSchedule(eventID)
					return 0
				endIf
				r.setValidActors(1, actorsS, actorsLenS, potentialsS, potentialLenS, None)
				if ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorForRule())
					printActors("Sources", r, actorsS, actorsLenS, potentialsS, potentialLenS)
				endIf
				if reserveSchedule(eventID)
					return 0
				endIf
				r.setValidActors(2, actorsC, actorsLenC, potentialsC, potentialLenC, None)
				if ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorForRule())
					printActors("Collaborators", r, actorsC, actorsLenC, potentialsC, potentialLenC)
				endIf
				if reserveSchedule(eventID)
					return 0
				endIf
				ssxRunnerQuest.rulesAskFactions[ssxRunnerQuest.rules.find(r)] = None
				r.status = 1
			
			else ; Cannot be played, clean it up
				int index=ssxRunnerQuest.rules.find(r)
				cleanDialogueActorsFactions(r, ssxRunnerQuest.rulesAskFactions[index])
				ssxRunnerQuest.rulesAskFactions[index] = None
				r.clearValidActors()
				r.status = 0
			endIf

			
			; stop the mutex on arrays
			whoIsChecking=""
		endIf
		while ssxRunnerQuest.letsWait
			Utility.waitMenuMode(1.0)
		endWhile
	endWhile
	ssxRunnerQuest.clearCachePostCheck() ; clear cache for: NA, BO, SL, CO
	return res
endFunction



Function printActors(String what, SSX_Rule_Alias r, Actor[] a1s, int a1len, Actor[] a2s, int a2len)
	String msg = what + " for rule " + r.name + ": "
	int j = 0
	while j<a1len
		if a1s[j]
			msg+= a1s[j].getDisplayName()+" (V), "
		endIf
		j+=1
	endWhile
	j = 0
	while j<a2len
		if a2s[j]
			msg+= a2s[j].getDisplayName()+" (P), "
		endIf
		j+=1
	endWhile
	ssxRunnerQuest.log(msg, SSX_Runner_Quest.notifActorForRule())
endFunction


AssociationType[] Property checkingAssTypes Auto
int numAT


Function cleanDialogueActorsFactions(SSX_Rule_Alias r, Faction toRemove)
	cleanDialogueFactions(r.validDst, toRemove)
	cleanDialogueFactions(r.validSrc, toRemove)
	cleanDialogueFactions(r.validColl, toRemove)
endFunction

Function cleanDialogueFactions(Actor[] aPos, Faction toRemove)
	int i = aPos.length
	; Start by removing the actors from the CanBeAsked Faction
	while i
		i-=1
		Actor a = aPos[i]
		if a
			if a.isInFaction(ssxAskingFaction)
				a.removeFromFaction(ssxAskingFaction)
			endIf
			if toRemove
				if a.isInFaction(toRemove)
					a.removeFromFaction(toRemove)
				endIf
			else
				int j=ssxRunnerQuest.ssxPlayerAskFactions.length
				while j
					j-=1
					if a.isInFaction(ssxRunnerQuest.ssxPlayerAskFactions[j])
						a.removeFromFaction(ssxRunnerQuest.ssxPlayerAskFactions[j])
					endIf
				endWhile
			endIf
		endIf
	endWhile
endFunction

; ((- Event Catchers ******************************************************************************************************************************************************************

ReferenceAlias[] Property eventCatchers Auto				; RefAliases for the event catchers (normal)
ReferenceAlias[] Property eventCatchersB Auto				; RefAliases for the event catchers (bleedout)
ReferenceAlias[] Property catchersStorages Auto			; RefAliases for the storage of the eventCatchers (to correctly associate the rules)


Actor[] Property actorsCatchers Auto								; Actual actor set to the catchers
int[] Property actorsCatcherModes Auto							; Mode for the catchers: 0=Not used, 1=normal, 2=bleedout

; The catchers have to be added to all rules, also the ones without valid actors
Function setUpCatchers()
	{find for all rules the ones that require an event}
	; for each actor, set up a catcher of the appropriate type (depending on the rule requirements, do an exception for the player bleedout)

	; Do a first test for the player (that may not be in allActors)
	ssxRunnerQuest.addToAllActors(PlayerRef)

	int i=catchersStorages.length
	while i
		i-=1
		if ssxRunnerQuest.allActors[i]
			(catchersStorages[i] as SSX_Catchers_Storage_Alias).doInit(ssxRunnerQuest.allActors[i])
		endIf
	endWhile
	
	i = ssxRunnerQuest.rules.length
	while i
		i-=1
		SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
		if r && r.inUse==2 ; Only for active rules
			; Get the possible start conditions that can have catchers
			int pos = 3
			while pos
				pos-=1
				int j=7
				while j
					if r.requiresCatchers(j, pos)
						filterAndAddActor(r, j, pos)
					endIf
					j-=1
				endWhile
			endWhile
		endIf
	endWhile
	
	; Remove all previous catchers, but only if they are not in the allActors
	i = actorsCatchers.length
	while i
		i-=1
		Actor a = actorsCatchers[i]
		if a && ssxRunnerQuest.allActors.find(a)==-1 && a!=PlayerRef
			if actorsCatcherModes[i]==2
				actorsCatchers[i]=None
				actorsCatcherModes[i]=0
				(eventCatchersB[i] as SSX_Event_Catcher_Alias).clean()
			elseIf actorsCatcherModes[i]==1
				actorsCatchers[i]=None
				actorsCatcherModes[i]=0
				(eventCatchers[i] as SSX_Event_Catcher_Alias).clean()
			endIf
		endIf
	endWhile
	
	; OK, now we got all the actors that require an EventCatcher for each rule, set them up
	int pos=ssxRunnerQuest.allActors.length
	while pos
		pos-=1
		Actor a = ssxRunnerQuest.allActors[pos]
		if a
			SSX_Catchers_Storage_Alias cs = catchersStorages[pos] as SSX_Catchers_Storage_Alias
			if a == PlayerRef
				setPlayerHealthBleedout(cs)
			endIf
			if cs.requiresCatcher()
				addCatcher(a, cs)
			endIf
		endIf
	endWhile
endFunction

bool Function setPlayerHealthBleedout(SSX_Catchers_Storage_Alias cs)
	{Find the rules where player needs bleedout or health}
	bool bo=false
	bool he=false
	int i = ssxRunnerQuest.rules.length
	
	while i
		i-=1
		SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
		if r && r.inUse == 2
			int pos = r.canPlayerBeInvolvedBOorHE()
			int res = pos%10
			pos /= 10; integers are truncated
			if res==1 || res==3; BO
				cs.addBleed(r.id)
				bo=true
			endIf
			If res==2 || res==3; He
				cs.addHealth(r.id, r.getHealthLevelMode(pos))
				he=true
			endIf
		endIf
	endWhile
	
	if bo || he
		return true
	endIf
	return false
EndFunction

Event setPlayerProtectedCatcher(String whatever)
	int index=ssxRunnerQuest.allActors.find(PlayerRef)
	if index==-1
		index=0
	endIf
	SSX_Catchers_Storage_Alias cs = catchersStorages[index] as SSX_Catchers_Storage_Alias
	cs.doInit(PlayerRef)
	if setPlayerHealthBleedout(cs)
		addCatcher(PlayerRef, cs)
	else
		int i = ssxRunnerQuest.allActors.find(PlayerRef)
		if i == -1
			return ; shouldn't really happen, but...
		endIf
		if actorsCatcherModes[i]==2
			actorsCatchers[i]=None
			actorsCatcherModes[i]=0
			(eventCatchersB[i] as SSX_Event_Catcher_Alias).clean()
		elseIf actorsCatcherModes[i]==1
			actorsCatchers[i]=None
			actorsCatcherModes[i]=0
			(eventCatchers[i] as SSX_Event_Catcher_Alias).clean()
		endIf
	endIf
EndEvent

; This function should find all actors for the rule, but without considering the Events of the catcher (they should allways be good in this case)
Function filterAndAddActor(SSX_Rule_Alias r, int catcherType, int pos)
	{Add all actors (good and possible) of the rule to the catcherActors}
	int mode = r.getHealthLevelMode(pos)
	Actor[] acts = r.getTheActors(pos, true)
	int i=0
	while i<acts.length
		Actor a = acts[i]
		if a
			int index = ssxRunnerQuest.allActors.find(a)
			if index!=-1 && ssxRunnerQuest.allActors[index]
				if catcherType==1
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addBleed(r.id)
				elseIf catcherType==2
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addNaked(r.id)
				elseIf catcherType==3
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addWeapon(r.id)
				elseIf catcherType==4
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addCombat(r.id)
				elseIf catcherType==5
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addSleep(r.id)
				elseIf catcherType==6
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addHealth(r.id, mode)
				elseIf catcherType==7
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addClothe(r.id)
				endIf
			endIf
		endIf
		i+=1
	endWhile
	acts = r.getTheActors(pos, false)
	i=0
	while i<acts.length
		Actor a = acts[i]
		if a
			int index = ssxRunnerQuest.allActors.find(a)
			if index!=-1 && ssxRunnerQuest.allActors[index]
				(catchersStorages[index] as SSX_Catchers_Storage_Alias).setActor(a)
				if catcherType==1
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addBleed(r.id)
				elseIf catcherType==2
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addNaked(r.id)
				elseIf catcherType==3
					(catchersStorages[i] as SSX_Catchers_Storage_Alias).addWeapon(r.id)
				elseIf catcherType==4
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addCombat(r.id)
				elseIf catcherType==5
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addSleep(r.id)
				elseIf catcherType==6
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addHealth(r.id, mode)
				elseIf catcherType==7
					(catchersStorages[index] as SSX_Catchers_Storage_Alias).addClothe(r.id)
				endIf
			endIf
		endIf
		i+=1
	endWhile
endFunction

Function addCatcher(Actor a, SSX_Catchers_Storage_Alias cs)
	int pos=actorsCatchers.find(a)
	if pos!=-1
		if cs.getBleedouts(-1) || (ssxRunnerQuest.protectOnHealth && cs.getHealths(-1))
			if actorsCatcherModes[pos]!=2
				(eventCatchers[pos] as SSX_Event_Catcher_Alias).clean()
			endIf
			(eventCatchersB[pos] as SSX_Event_Catcher_Alias).init(a, cs)
		elseIf cs.requiresCatcher()
			if actorsCatcherModes[pos]==2
				(eventCatchersB[pos] as SSX_Event_Catcher_Alias).clean()
			endIf
			(eventCatchers[pos] as SSX_Event_Catcher_Alias).init(a, cs)
		else
			(eventCatchers[pos] as SSX_Event_Catcher_Alias).clean()
			(eventCatchersB[pos] as SSX_Event_Catcher_Alias).clean()
		endIf
		return
	endIf
	pos = actorsCatchers.find(None)
	if pos==-1
		return
	endIf
	actorsCatchers[pos]=a
	if cs.getBleedouts(-1) || (ssxRunnerQuest.protectOnHealth && cs.getHealths(-1))
		actorsCatcherModes[pos]=2
		(eventCatchersB[pos] as SSX_Event_Catcher_Alias).init(a, cs)
	elseIf cs.requiresCatcher()
		actorsCatcherModes[pos]=1
		(eventCatchers[pos] as SSX_Event_Catcher_Alias).init(a, cs)
	else
		(eventCatchers[pos] as SSX_Event_Catcher_Alias).clean()
		(eventCatchersB[pos] as SSX_Event_Catcher_Alias).clean()
		actorsCatchers[pos]=None
	endIf
endFunction


Function removeCatcher(int ruleID, int pos, Actor a)
	actorsCatchers[pos]=None
	if actorsCatcherModes[pos]==1
		(eventCatchers[pos] as SSX_Event_Catcher_Alias).clean()
		eventCatchers[pos].clear()
	else
		(eventCatchersB[pos] as SSX_Event_Catcher_Alias).clean()
		eventCatchersB[pos].clear()
	endIf
	actorsCatcherModes[pos]=0
endFunction



; -))




Function safeInsert(SSX_Rule_Alias r, Actor a, int pos, bool v, bool p)
	if !a
		return
	endIf
	if v
		if pos==0
			actorsLenD = pushActor(a, actorsLenD, actorsD)
		elseIf pos==1
			actorsLenS = pushActor(a, actorsLenS, actorsS)
		else
			actorsLenC = pushActor(a, actorsLenC, actorsC)
		endIf
		ssxRunnerQuest.log("Actor " + a.getDisplayName() + " added as " + ssxRunnerQuest.participantEdit[pos] + " in " + r.name, SSX_Runner_Quest.notifNotGoodActors())
	elseIf p
		if pos==0
			potentialLenD = pushActor(a, potentialLenD, potentialsD)
		elseIf pos==1
			potentialLenS = pushActor(a, potentialLenS, potentialsS)
		else
			potentialLenC = pushActor(a, potentialLenC, potentialsC)
		endIf
		ssxRunnerQuest.log("Actor " + a.getDisplayName() + " potential for " + ssxRunnerQuest.participantEdit[pos] + " in " + r.name, SSX_Runner_Quest.notifNotGoodActors())
	else
		ssxRunnerQuest.log("Actor " + a.getDisplayName() + " is not good for " + ssxRunnerQuest.participantEdit[pos] + " in " + r.name, SSX_Runner_Quest.notifNotGoodActors())
	endIf
EndFunction
	
int Function pushActor(Actor a, int i, Actor[] s)
	if !a
		return i
	endIf
	; insert actor a into array r, position i
	; return next empty position, or same if it was last
	if i >= s.length
		i = s.length - 1
	endIf
	int n = s.find(a)
	if n != -1 ; this is for debugging.  Once everything is stable, this test should not be needed, and can be removed for speedup
		return i
	endIf
	s[i] = a
	return i + 1
EndFunction

int Function checkRuleForActors(SSX_Rule_Alias r)
	ssxRunnerQuest.log("Rule Checker: Trying to fill the rule: " + r.name, SSX_Runner_Quest.notifCheckerDetails())

	; Check first the conditions that are not related to Actors (location, time, etc.)
	; Check the locations if required
	if r.getIntExt()>0
		if r.getIntExt() != ssxRunnerQuest.cellIntExt
			ssxRunnerQuest.log("Bad rule because 1 - Bad type of cell (Interior/Exterior) - " + r.name, SSX_Runner_Quest.notifBadRule())
			return 0 ; Cannot start
		endIf
	endIf
	if r.locations!="" || r.cells!="" || r.locationTypes!=""
		if !ssxRunnerQuest.isValidLocation(ssxRunnerQuest.playerLocation, ssxRunnerQuest.currentPlayerCell, r)
			ssxRunnerQuest.log("Bad rule because 2 - Wrong location - " + r.name, SSX_Runner_Quest.notifBadRule())
			return 0 ; Cannot start
		endIf
	endIf
	
	int timeS = r.getStartTimer(true)
	int timeE = r.getStartTimer(false)
	float justNow = Utility.GetCurrentGameTime()
	int hour = ((justNow - Math.floor(justNow)) * 24) as Int

	; Time before re-do
	if r.timeBeforeReDo>0.0 && r.lastRunTime>0.0 && (justNow-r.lastRunTime)*3600.0<r.timeBeforeReDo
		ssxRunnerQuest.log("Bad rule because 3 - Still in timeout - " + r.name, SSX_Runner_Quest.notifBadRule())
		return 0 ; Cannot start
	endIf
	
	if timeS!=-1
		if (timeS==timeE && timeS!=hour) || (timeS<timeE && (timeS>hour || hour>timeE)) || (timeS>timeE && timeS>hour && hour>timeE)
			ssxRunnerQuest.log("Bad rule because 4 - Not the correct time - " + r.name, SSX_Runner_Quest.notifBadRule())
			return 0 ; Cannot start
		endIf
	endIf
		
	
	; For the given rule, check if the actors can fill the positions (the status of each actor is already calculated)
	actorsLenD = 0
	actorsLenS = 0
	actorsLenC = 0
	potentialLenD = 0
	potentialLenS = 0
	potentialLenC = 0
	
	int cl = actorsD.length
	while cl
		cl -= 1
		actorsD[cl] = none
		actorsS[cl] = none
		actorsC[cl] = none
		potentialsD[cl] = none
		potentialsS[cl] = none
		potentialsC[cl] = none
	endWhile
	
	bool isPotential=false
	bool isGood=true
	
	int res=-1
	
	int pos = 0
	while pos<3
		isPotential=false
		isGood=true

		if r.isPlayer(pos) ; ----------------------------------------------------------------------------------------------------------------------------------------------------------- isPlayer ------------------------------------------
			; Involved or animating
			if PlayerRef.IsInFaction(ssxRunnerQuest.ssxInvolved) || PlayerRef.IsInFaction(SexLabAnimatingFaction)
				isPotential=true
				isGood=false
				ssxRunnerQuest.log("Bad rule because player involved or animating - " + r.name, SSX_Runner_Quest.notifBadRule())
			endIf
		
			; No GFHR checks for the player
			
			; Actions
			int index =ssxRunnerQuest.allActors.find(PlayerRef)
			if index==-1
				ssxRunnerQuest.log("Bad rule because -1 - Player NOT Found! - " + r.name, SSX_Runner_Quest.notifBadRule())
			endIf
			res = checkPotentialActions(r, index, pos, PlayerRef)
			; 0 not interesting (such actions are not required)
			; 1 required and all good
			; 2 required but not all good
			if res==1
				isPotential=false
			elseIf res==2
				isPotential=true
				isGood=false
			endIf
			res = checkEffectiveActions(r, index, pos, PlayerRef)
			; 0 not interesting (such actions are not required)
			; 1 required and all good
			; 2 required but not all good
			if res==2
				isGood=false
			endIf
			
			; Now add it
			safeInsert(r, PlayerRef, pos, isGood, isPotential)
		
		elseIf r.isGeneric(pos) || r.isGenericWPl(pos) ; ------------------------------------------------------------------------------------------------------------------------------- isGeneric -----------------------------------------
			int i = ssxRunnerQuest.allActors.length
			while i
				i-=1
				Actor a = ssxRunnerQuest.allActors[i]
				isPotential=false
				isGood=true
				if a && !( a == PlayerRef && r.isGeneric(pos) )
					isGood=true
					isPotential=false
					; Involved or animating
					if a.IsInFaction(ssxRunnerQuest.ssxInvolved) || a.IsInFaction(SexLabAnimatingFaction)
						isPotential=true
						isGood=false
					endIf
				
					; GFHR checks
					if !checkGFHR(r, pos, a)
						isGood=false
						isPotential=false
					endIf

					; Actions
					if isGood || isPotential
						res = checkPotentialActions(r, i, pos, a)
						; 0 not interesting (such actions are not required)
						; 1 required and all good
						; 2 required but not all good
						if res==1
							isPotential=false
						elseIf res==2
							isPotential=true
							isGood=false
						endIf
						res = checkEffectiveActions(r, i, pos, a)
						; 0 not interesting (such actions are not required)
						; 1 required and all good
						; 2 required but not all good
						if res==2
							isGood=false
						endIf
					endIf

					; Now add it
					safeInsert(r, a, pos, isGood, isPotential)
				endIf
				while ssxRunnerQuest.letsWait
					Utility.waitMenuMode(1.0)
				endWhile
			endWhile
		
		elseIf r.isSpecific(pos) ; ----------------------------------------------------------------------------------------------------------------------------------------------------- isSpecific ----------------------------------------
			String[] parts = StringUtil.split(r.getIDs(pos), ";")
			int i = parts.length
			while i
				i-=1
				Actor a = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Actor
				isPotential=false
				isGood=true
				int index = ssxRunnerQuest.allActors.find(a)
				if index!=-1 && a
					; Involved or animating
					if a.IsInFaction(ssxRunnerQuest.ssxInvolved) || a.IsInFaction(SexLabAnimatingFaction)
						isPotential=true
						isGood=false
					endIf
				
					; No GFHR checks for specifics

					; Actions
					if isGood || isPotential
						res = checkPotentialActions(r, index, pos, a)
						; 0 not interesting (such actions are not required)
						; 1 required and all good
						; 2 required but not all good
						if res==1
							isPotential=false
						elseIf res==2
							isPotential=true
							isGood=false
						endIf
						res = checkEffectiveActions(r, index, pos, a)
						; 0 not interesting (such actions are not required)
						; 1 required and all good
						; 2 required but not all good
						if res==2
							isGood=false
						endIf
					endIf
					
					; Now add it
					safeInsert(r, a, pos, isGood, isPotential)
				endIf
				while ssxRunnerQuest.letsWait
					Utility.waitMenuMode(1.0)
				endWhile
			endWhile
	
		elseIf r.isRelationship1(pos) ; ------------------------------------------------------------------------------------------------------------------------------------------------ isRelationship (previous, so OK now) --------------
			String[] parts = StringUtil.split(r.getIDs(pos), ";")
			numAT=0
			int iat = checkingAssTypes.length
			while iat
				iat-=1
				checkingAssTypes[iat]=None
			endWhile
			while iat<parts.length && numAT<checkingAssTypes.length
				AssociationType at = PO3_SKSEFunctions.GetFormFromEditorID(parts[iat]) as AssociationType
				if at
					checkingAssTypes[numAT]=at
					numAT+=1
				endIf
				iat+=1
			endWhile
			if numAT==0
				ssxRunnerQuest.log("No Relationship are defined for position " + pos + " on rule " + r.name, SSX_Runner_Quest.notifNotGoodActors())
			else
				int i = ssxRunnerQuest.allActors.length
				while i
					i-=1
					Actor a = ssxRunnerQuest.allActors[i]
					isPotential=false
					isGood=true
					if a
						if pos==1
							if !hasRelationship(r, pos, a, actorsD, actorsLenD)
								isGood=false
							endIf
						elseIf pos==2
							if !hasRelationship(r, pos, a, actorsS, actorsLenS)
								isGood=false
							endIf
						endIf 

						if isGood
							; Involved or animating
							if a.IsInFaction(ssxRunnerQuest.ssxInvolved) || a.IsInFaction(SexLabAnimatingFaction)
								isPotential=true
								isGood=false
							endIf
						
							; GFHR checks
							if (isGood || isPotential) && !checkGFHR(r, pos, a)
								isGood=false
								isPotential=false
							endIf

							if isGood || isPotential
								; Actions
								res = checkPotentialActions(r, i, pos, a)
								; 0 not interesting (such actions are not required)
								; 1 required and all good
								; 2 required but not all good
								if res==1
									isPotential=false
								elseIf res==2
									isPotential=true
									isGood=false
								endIf
								res = checkEffectiveActions(r, i, pos, a)
								; 0 not interesting (such actions are not required)
								; 1 required and all good
								; 2 required but not all good
								if res==2
									isGood=false
								endIf
							endIf
						endIf
						
						; Now add it
						safeInsert(r, a, pos, isGood, isPotential)
					endIf
					while ssxRunnerQuest.letsWait
						Utility.waitMenuMode(1.0)
					endWhile
				endWhile
			endIf


		elseIf r.isFaction(pos) ; ------------------------------------------------------------------------------------------------------------------------------------------------------ isFaction -----------------------------------------
			String[] parts = StringUtil.split(r.getIDs(pos), ";")
			int i = parts.length
			while i
				i-=1
				Faction f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i]) as Faction
				int index = ssxRunnerQuest.allActors.length
				while index && f
					index-=1
					Actor a = ssxRunnerQuest.allActors[index]
					isPotential=false
					isGood=true
					if a && a.isInFaction(f)
						; Involved or animating
						if a.IsInFaction(ssxRunnerQuest.ssxInvolved) || a.IsInFaction(SexLabAnimatingFaction)
							isPotential=true
							isGood=false
						endIf
					
						; GFHR checks
						if a!=PlayerRef && !checkGFHR(r, pos, a)
							isGood=false
							isPotential=false
						endIf

						; Actions
						if isGood || isPotential
							res = checkPotentialActions(r, index, pos, a)
							; 0 not interesting (such actions are not required)
							; 1 required and all good
							; 2 required but not all good
							if res==1
								isPotential=false
							elseIf res==2
								isPotential=true
								isGood=false
							endIf
							res = checkEffectiveActions(r, index, pos, a)
							; 0 not interesting (such actions are not required)
							; 1 required and all good
							; 2 required but not all good
							if res==2
								isGood=false
							endIf
						endIf
						
						; Now add it
						safeInsert(r, a, pos, isGood, isPotential)
					endIf
					while ssxRunnerQuest.letsWait
						Utility.waitMenuMode(1.0)
					endWhile
				endWhile
			endWhile
	
		elseIf r.isSameRace(pos) && pos==2 ; ------------------------------------------------------------------------------------------------------------------------------------------- isSameRace ----------------------------------------

			; Just grab all the actor from Scanned that have the same race as sources
			int i = 0
			while numTmpActors
				numTmpActors-=1
				tmpActors[numTmpActors]=None
			endWhile
			int j = actorsLenS
			while j && numTmpActors<tmpActors.length
				j-=1
				Actor s = actorsS[j]
				String raceID = ssxRunnerQuest.getActorRaceID(s)
				if s
					i = ssxRunnerQuest.allActors.length
					while i && numTmpActors < tmpActors.length
						i-=1
						Actor a = ssxRunnerQuest.allActors[i]
						if a && raceID==ssxRunnerQuest.getActorRaceID(a)
							; add to tmp actors
							tmpActors[numTmpActors] = a
							numTmpActors+=1
						endIf
					endWhile
				endIf
			endWhile
			i = numTmpActors ; Add them as good actors
			while i
				i-=1
				Actor a = tmpActors[i]
				isPotential=false
				isGood=true
				; Involved or animating
				if a.IsInFaction(ssxRunnerQuest.ssxInvolved) || a.IsInFaction(SexLabAnimatingFaction)
					isGood=false
				endIf
				
				; GFHR checks
				if isGood && !checkGFHR(r, pos, a)
					isGood=false
				endIf

				; Actions
				int index = ssxRunnerQuest.allActors.find(a)
				if isGood && index!=-1
					if checkPotentialActions(r, index, pos, a)==2
						isGood=false
					endIf
					if isGood && checkEffectiveActions(r, index, pos, a)==2
						isGood=false
					endIf
				endIf
					
				; Now add it
				if isGood
					actorsLenC = pushActor(a, actorsLenC, actorsC)
				endIf
				while ssxRunnerQuest.letsWait
					Utility.waitMenuMode(1.0)
				endWhile
			endWhile
			; Now fill the potentials
			while numTmpActors
				numTmpActors-=1
				tmpActors[numTmpActors]=None
			endWhile
			j = potentialLenS
			while j
				j-=1
				Actor s = potentialsS[j]
				String raceID = ssxRunnerQuest.getActorRaceID(s)
				if s
					i = ssxRunnerQuest.allActors.length
					while i && numTmpActors < tmpActors.length
						i-=1
						Actor a = ssxRunnerQuest.allActors[i]
						if a && tmpActors.find(a)==-1 && raceID==ssxRunnerQuest.getActorRaceID(a)
							; add to tmp actors
							tmpActors[numTmpActors] = a
							numTmpActors+=1
						endIf
					endWhile
				endIf
			endWhile
			i = numTmpActors ; Add them as potential actors
			while i
				i-=1
				Actor a = tmpActors[i]
				; Actions
				int index = ssxRunnerQuest.allActors.find(a)
				if isGood && index!=-1
					if checkEffectiveActions(r, index, pos, a)==2
						isGood=false
					endIf
				endIf
					
				; Now add it
				if isGood
					potentialLenC = pushActor(a, potentialLenC, potentialsC)
				endIf
				while ssxRunnerQuest.letsWait
					Utility.waitMenuMode(1.0)
				endWhile
			endWhile
			
		endIf

		pos+=1
	endWhile
	
	; Now we completed the first pass, we may need a second pass for Next Relationship
	pos=0
	while pos<3
		if r.isRelationship2(pos) ; ---------------------------------------------------------------------------------------------------------------------------------------------------- isRelationship (next) -----------------------------
			String[] parts = StringUtil.split(r.getIDs(pos), ";")
			numAT=0
			int iat = checkingAssTypes.length
			while iat
				iat-=1
				checkingAssTypes[iat]=None
			endWhile
			while iat<parts.length && numAT<checkingAssTypes.length
				AssociationType at = PO3_SKSEFunctions.GetFormFromEditorID(parts[iat]) as AssociationType
				if at
					checkingAssTypes[numAT]=at
					numAT+=1
				endIf
				iat+=1
			endWhile
			if numAT==0
				ssxRunnerQuest.log("No Relationship are defined for position " + pos + " on rule " + r.name, SSX_Runner_Quest.notifNotGoodActors())
			else
				int i = ssxRunnerQuest.allActors.length
				while i
					i-=1
					Actor a = ssxRunnerQuest.allActors[i]
					isPotential=false
					isGood=true
					if a
						if pos==0
							if !hasRelationship(r, pos, a, actorsS, actorsLenS)
								isGood=false
							endIf
						elseIf pos==1
							if !hasRelationship(r, pos, a, actorsC, actorsLenC)
								isGood=false
							endIf
						endIf 

						if isGood
							; Involved or animating
							if a.IsInFaction(ssxRunnerQuest.ssxInvolved) || a.IsInFaction(SexLabAnimatingFaction)
								isPotential=true
								isGood=false
							endIf
						
							; GFHR checks
							if (isGood || isPotential) && !checkGFHR(r, pos, a)
								isGood=false
								isPotential=false
							endIf

							if isGood || isPotential
								; Actions
								res = checkPotentialActions(r, i, pos, a)
								; 0 not interesting (such actions are not required)
								; 1 required and all good
								; 2 required but not all good
								if res==1
									isPotential=false
								elseIf res==2
									isPotential=true
									isGood=false
								endIf
								res = checkEffectiveActions(r, i, pos, a)
								; 0 not interesting (such actions are not required)
								; 1 required and all good
								; 2 required but not all good
								if res==2
									isGood=false
								endIf
							endIf
						endIf
						
						; Now add it
						safeInsert(r, a, pos, isGood, isPotential)
					endIf
					while ssxRunnerQuest.letsWait
						Utility.waitMenuMode(1.0)
					endWhile
				endWhile
			endIf
		endIf
		pos+=1
	endWhile
	
	; The good ones and the potential ones are found, fill the rule with actors, and mark it as playable or not
	
	; A rule is good if all required positions have values in GOOD, is potential if at least one of the required positions has only POTENTIAL. Is bad is any of the required position is empty.
	bool canBePotential = false
	if !r.isNobody(0)
		if actorsLenD==0
			if potentialLenD==0
				ssxRunnerQuest.log("Bad rule because 5 - Targets cannot not be found - " + r.name, SSX_Runner_Quest.notifBadRule())
				return 0 ; Cannot start
			else
				; rule is potential right now
				canBePotential=true
			endIf
		endIf
	endIf
	if !r.isNobody(1)
		if actorsLenS==0
			if potentialLenS==0
				ssxRunnerQuest.log("Bad rule because 6 - Sources cannot not be found - " + r.name, SSX_Runner_Quest.notifBadRule())
				return 0 ; Cannot start
			else
				; rule is potential right now
				canBePotential=true
			endIf
		endIf
	endIf
	if !r.isNobody(2)
		if actorsLenC==0
			if potentialLenC==0
				ssxRunnerQuest.log("Bad rule because 7 - Collaborators cannot not be found - " + r.name, SSX_Runner_Quest.notifBadRule())
				return 0 ; Cannot start
			else
				; rule is potential right now
				canBePotential=true
			endIf
		endIf
	endIf
	if canBePotential
			ssxRunnerQuest.log("POTENTIAL rule - " + r.name, SSX_Runner_Quest.notifBadRule())
		return 1 ; The rule cannot start, but is OK
	endIf
	ssxRunnerQuest.log("GOOD rule - " + r.name, SSX_Runner_Quest.notifBadRule())
	return 2 ; The rule can start
endFunction

; test be-naked
bool Function testNA(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,1)
		actorsNA[index]=ssxRunnerQuest.isActorNaked(a)
		ssxRunnerQuest.setCached(index,1)
	endIf
	t = actorsNA[index]==t
	return t
endFunction

; test see-naked
bool Function testSN(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,2)
		int	j = ssxRunnerQuest.allActors.length
		bool notSeeingN=true
		bool notSeeingS=true
		while j && (notSeeingN || notSeeingS)
			j-=1
			Actor b = ssxRunnerQuest.allActors[j]
			if b && a!=b && a.hasLOS(b) ; The actor has to see another actor naked
				if notSeeingN && testNA(index, 1, a) 
					notSeeingN=false
				endIf
				if notSeeingS && b.isInFaction(SexLabAnimatingFaction)
					notSeeingS=false
				endIf
			endIf
		endWhile
		actorsSN[index]=!notSeeingN
		actorsSS[index]=!notSeeingS
		ssxRunnerQuest.setCached(index,2)
		ssxRunnerQuest.setCached(index,3)
	endIf
	t = actorsSN[index]==t
	return t
endFunction

; test see-sex
bool Function testSS(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,3)
		; we'll invalidate 'see-naked' and let testSN update both values
		ssxRunnerQuest.clearCached(index,2)
		testSN(index, mode, a)
	endIf
	t = actorsSS[index]==t
	return t
endFunction

; test arousal
bool Function testAR(int index, int mode, Actor a, int v)
	if !ssxRunnerQuest.isCached(index,4)
		actorsAR[index]=ssxRunnerQuest.getArousalLevel(a)
		ssxRunnerQuest.setCached(index,4)
	endIf
	bool t = (mode==1 && actorsAR[index]>=v) || (mode==2 && actorsAR[index]<v)
	return t
endFunction

; test health
bool Function testHE(int index, int mode, Actor a, int v)
	if !ssxRunnerQuest.isCached(index,5)
		actorsHE[index]=ssxRunnerQuest.getHealthLevel(a)
		ssxRunnerQuest.setCached(index,5)
	endIf
	bool t = (mode==1 && actorsHE[index]>=v) || (mode==2 && actorsHE[index]<v)
	return t
endFunction

; test stamina
bool Function testST(int index, int mode, Actor a, int v)
	if !ssxRunnerQuest.isCached(index,6)
		actorsHE[index]=ssxRunnerQuest.getStaminaLevel(a)
		ssxRunnerQuest.setCached(index,6)
	endIf
	bool t = (mode==1 && actorsST[index]>=v) || (mode==2 && actorsST[index]<v)
	return t
endFunction

; test magicka
bool Function testMA(int index, int mode, Actor a, int v)
	if !ssxRunnerQuest.isCached(index,7)
		actorsMA[index]=ssxRunnerQuest.getMagickaLevel(a)
		ssxRunnerQuest.setCached(index,7)
	endIf
	bool t = (mode==1 && actorsMA[index]>=v) || (mode==2 && actorsMA[index]<v)
	return t
endFunction

; test sleep
bool Function testSL(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,8)
		actorsSL[index]=a.GetSleepState()>2
		ssxRunnerQuest.setCached(index,8)
	endIf
	t = actorsSL[index]==t
	return t
endFunction

; test sneaking
bool Function testSK(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,9)
		actorsSK[index]=a.isSneaking()
		ssxRunnerQuest.setCached(index,9)
	endIf
	t = actorsSK[index]==t
	return t
endFunction

; test weapon-out
bool Function testWE(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,10)
		actorsWE[index]=a.isWeaponDrawn()
		ssxRunnerQuest.setCached(index,10)
	endIf
	t = actorsWE[index]==t
	return t
endFunction

; test in-combat
bool Function testCO(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,11)
		actorsCO[index]=a.isInCombat()
		ssxRunnerQuest.setCached(index,11)
	endIf
	t = actorsCO[index]==t
	return t
endFunction

; test in-bleedout
bool Function testBL(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,12)
		actorsBL[index]=a.isBleedingOut()
		ssxRunnerQuest.setCached(index,12)
	endIf
	t = actorsBL[index]==t
	return t
endFunction

; test is-unconscious
bool Function testUN(int index, int mode, Actor a)
	bool t = true
	if mode == 2
		t = false
	endIf
	if !ssxRunnerQuest.isCached(index,13)
		actorsUN[index]=a.isUnconscious()
		ssxRunnerQuest.setCached(index,13)
	endIf
	t = actorsUN[index]==t
	return t
endFunction

; 0 not interesting (such actions are not required)
; 1 required and all good
; 2 required but not all good
int Function checkPotentialActions(SSX_Rule_Alias r, int index, int pos, Actor a)
	int res=0
	; Naked
	int t = r.getPositionStartMode(1,pos)
 	if t 
		if testNA(index,t,a)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for nudity: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because nudity: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Health
	t = r.getPositionStartMode(5,pos)
 	if t
		if testHE(index, t, a, r.healthLevel)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for health: " + a.getDisplayName() + " Level=" + actorsHE[index] + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because health: " + a.getDisplayName() + " Level=" + actorsHE[index] + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Sleep
	t = r.getPositionStartMode(8,pos)
 	if t
		if testSL(index, t, a)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for sleep: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because sleep: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Combat
	t = r.getPositionStartMode(11,pos)
 	if t
		if testCO(index, t, a)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for combat: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because combat: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Bleedout
	t = r.getPositionStartMode(12,pos)
 	if t
		if testBL(index, t, a)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for bleedout: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because bleedout: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Clothing
	t = r.getPositionStartMode(14,pos)
	if t && r.needEquippedItems(pos)
		if ssxRunnerQuest.checkClothes(r, a, pos)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for clothing: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because clothing: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf

	; OK, were not requires or we passed all tests?
	if res==3
		ssxRunnerQuest.log("Actor is GOOD for potential actions: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
		return 1
	endIf
	return 0
endFunction


; 0 not interesting (such actions are not required)
; 1 required and all good
; 2 required but not all good
int Function checkEffectiveActions(SSX_Rule_Alias r, int index, int pos, Actor a)
	int res=0
	; for each action that is considered, check if the actor should or should not do it
	; SeeNaked
	int t = r.getPositionStartMode(2,pos)
	if t
		if testSN(index,t, a)
			res=3 ; temporarly good
		else
			ssxRunnerQuest.log("Actor is bad because seeing naked: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; SeeSex
	t = r.getPositionStartMode(3,pos)
	if t
		if testSS(index, t, a)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for seeing sex: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because seeing sex: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Arousal
	t = r.getPositionStartMode(4,pos)
	if t
		if testAR(index, t, a, r.arousalLevel)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for arousal: " + a.getDisplayName() + " Level=" + actorsAR[index] + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because arousal: " + a.getDisplayName() + " Level=" + actorsAR[index] + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Stamina
	t = r.getPositionStartMode(6,pos)
	if t
		if testST(index, t, a, r.staminaLevel)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for stamina: " + a.getDisplayName() + " Level=" + actorsST[index] + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because stamina: " + a.getDisplayName() + " Level=" + actorsST[index] + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Magicka
	t = r.getPositionStartMode(7,pos)
	if t
		if testST(index, t, a, r.magickaLevel)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for magicka: " + a.getDisplayName() + " Level=" + actorsMA[index] + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because magicka: " + a.getDisplayName() + " Level=" + actorsMA[index] + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Sneak
	t = r.getPositionStartMode(9,pos)
	if t
		if testSK(index, t, a)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for sneaking: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because sneaking: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Weapon
	t = r.getPositionStartMode(10,pos)
	if t
		if testWE(index, t, a)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for weapons: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because weapons: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf
	; Unconscious
	t = r.getPositionStartMode(13,pos)
	if t
		if testUN(index, t, a)
			res=3 ; temporarly good
;			ssxRunnerQuest.log("actor is good for unconsciousness: " + a.getDisplayName() + " pos=" + pos, ssxRunnerQuest.notifNotGoodActors())
		else
			ssxRunnerQuest.log("Actor is bad because unconsciousness: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return 2
		endIf
	endIf

	; OK, were not requires or we passed all tests?
	if res==3
		ssxRunnerQuest.log("Actor is GOOD for effective actions: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
		return 1
	endIf
	return 0
endFunction

bool Function checkGFHR(SSX_Rule_Alias r, int pos, Actor a) ; False = not good, True = good
	if !ssxRunnerQuest.checkActorSex(r.getSex(pos), a)
		ssxRunnerQuest.log("Actor is bad for its sex: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
		return false
	endIf
	int val = r.getFellowship(pos)
	if (val==1 && !a.isPlayerTeamMate()) || (val==2 && a.isPlayerTeamMate())
		ssxRunnerQuest.log("Actor is bad for its fellowship: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
		return false
	endIf
	if !ssxRunnerQuest.checkActorHumanity(r.getHumanity(pos), a)
		ssxRunnerQuest.log("Actor is bad for its humanity: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
		return false
	endIf
	if !ssxRunnerQuest.checkActorRace(r, pos, a)
		ssxRunnerQuest.log("Actor is bad for its race: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
		return false
	endIf

	; Need to check for mods?
	if r.getMods(pos)!=""
		if StringUtil.find(r.getMods(pos), SSX_Runner_Quest.getObjectFullModName(a))==-1
			ssxRunnerQuest.log("Actor is bad because not for a mod listed: " + a.getDisplayName() + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
			return false
		endIf
	endIf

	; Check the negative factions
	String negFacts = r.getNegativeFactions(pos)
	if negFacts
		String[] facts = StringUtil.split(negFacts, ";")
		int i=facts.length
		while i
			i-=1
			if a.isInFaction(PO3_SKSEFunctions.GetFormFromEditorID(facts[i]) as Faction)
				ssxRunnerQuest.log("RuleChecker: Actor is bad because it is in a negative faction: " + a.getDisplayName() +" -> " + SSX_Runner_Quest.GetNameFromEditorID(facts[i]) + ": " + r.name + " pos=" + pos, SSX_Runner_Quest.notifNotGoodActors())
				return false
			endIf
		endWhile
	endIf

	return true
endFunction

bool Function hasRelationship(SSX_Rule_Alias r, int pos, Actor a, Actor[] withs, int len)
	int j = len
	while j
		j-=1
		Actor b = withs[i]
		int i = numAT
		while i && a!=b
			i-=1
			AssociationType at = checkingAssTypes[i]
			if a.hasAssociation(at, b)
				return true
			endIf
		endWhile
	endWhile
	return false
endFunction


