Scriptname SSX_Scene_Manager_Quest extends Quest ; 1.4h

; ((- Properties
SSX_Runner_Quest Property ssxRunnerQuest Auto
Actor Property PlayerRef Auto
Faction Property SexLabAnimatingFaction Auto
Faction Property ssxCreatures Auto
Faction Property ssxAskingFaction Auto ; The faction is used to identify the actors that will ask, globally and for all scenes
SexLabFramework Property SexLab Auto
String[] emptyStringArray

bool iAmTimeOuting

; -))


;6 aliases for each scene (Target, part1, 2, 3, 4, bed)
;Set aliases should put the correct dst/src in the Target, all the others in partX

;1: walk to target
;2: ask if needed
;3: ask for beds
;4: walk to bed
;5: sex
;6: end dialogue


Function doInit()
	{Nothing to do here, the arrays are initialized as properties}
	iAmTimeOuting = False
	emptyStringArray = SSX_Runner_Quest.CreateStringArray(0)
	RegisterForModEvent("HookAnimationEnding_ScentOfSex", "ssxAnimEnd")
	RegisterForModEvent("HookStageStart_ScentOfSex", "ssxStageStart")
	RegisterForModEvent("ssxStartScene", "startScene")
	RegisterForModEvent("ssxStopScenes", "stopSSXSM")
	ssxRunnerQuest.log("Scene Manager activated and events registered", SSX_Runner_Quest.notifSceneManDetails())
EndFunction

; ((- Generic no-state events

Event stopSSXSM(String unused)
	if !ssxRunnerQuest.dontStopScenes
		stopEverything()
	endIf
	ssxRunnerQuest.log("Scene Manager going to inactive state", SSX_Runner_Quest.notifSceneManDetails())
	goToState("inactive")
EndEvent

bool Function reserveSchedule()
    int s = ssxRunnerQuest.schedulerCanIDo("Scene Manager")
    while s
			if s == 2
				return false
			endIf ; s == 1
			Utility.waitMenuMode(0.2)
			s = ssxRunnerQuest.schedulerCanIDo("Scene Manager")
    endWhile ; s == 0
	cleanup()
	gotoState("inactive")
    return true
EndFunction

Function cleanup()
	ssxRunnerQuest.schedulerIAmDone("Scene Manager")
	return
EndFunction

Function redo()
	UnregisterForUpdate()
	cleanup()
	RegisterForSingleUpdate(5.0)
	return
EndFunction

; -))


state inactive
	Function OnBeginState()
		{Be sure we stop everything}
		ssxRunnerQuest.log("Scene Manager is going in inactive state", SSX_Runner_Quest.notifSceneManDetails())
		UnregisterForUpdate()
		if !ssxRunnerQuest.iAmActive
			stopEverything()
		endIf
		Utility.waitMenuMode(1.0)
		UnregisterForUpdate()
		cleanup()
	EndFunction
	
	Event stopSSXSM(String unused)
	EndEvent
endState

state active
	Function OnBeginState()
		ssxRunnerQuest.log("Scene Manager is going in active state (at least one scene running)", SSX_Runner_Quest.notifSceneManDetails())
		RegisterForSingleUpdate(3.0)
	EndFunction

	Event stopSSXSM(String unused)
		ssxRunnerQuest.log("Scene Manager got stopSSXSM event - shutting down!", SSX_Runner_Quest.notifSceneManDetails())
		UnregisterForUpdate()
		GoToState("inactive")
	EndEvent
	
	Event OnUpdate()
		if reserveSchedule()
			return
		endIf
		; The update is used when a scene plays, to have a timeout
		; Step 0: reaching the target
		; Step 1: ask for sex (can be a forcegreet with player)
		; Step 2: reach target for denial rapes
		; Step 3: reach the bed
		
		int i = 0
		while i < ssxRunnerQuest.scenes.length
			; Check if the scene spent too much time in a specific step, in this case clear the condition to go over
			float justNow = Utility.GetCurrentRealTime()
			float howMuch = ssxRunnerQuest.sceneTimeout[i]
			bool r = false
			if howMuch < 0
				howMuch = -howMuch
				r = true
			endIf
			howMuch = (justNow-howMuch) ; 1.0 is one day 1.0/(24*60 is one minute)
			if !ssxRunnerQuest.sceneAvails[i] ; Only for scenes that are running
				; Check if the actors are NOT dialoguing
				if ssxRunnerQuest.notInDialogues(i)
					float maxTime=-1.0
					int s = ssxRunnerQuest.sceneStep[i]
					if s==0
						maxTime = ssxRunnerQuest.maxSecondsToReachTarget
					elseIf s==1
						maxTime = ssxRunnerQuest.maxSecondsToAsk
					elseIf s==2
						maxTime = ssxRunnerQuest.maxSecondsToReachDenial
					elseIf s==3
						maxTime = ssxRunnerQuest.maxSecondsToReachBed
					endIf
					if maxTime>0 && howMuch>maxTime
						if ssxRunnerQuest.stopSceneInCaseOfTimeOuts==1 || r
							ssxRunnerQuest.releaseScene(index=i)
						else
							; Teleport the actors to the target/bed right away
							ssxRunnerQuest.sceneTimeout[i] = -1.0 * Utility.GetCurrentRealTime()
							ssxRunnerQuest.moveSceneActorsToTarget(i, ssxRunnerQuest.sceneStep[i]==3, 2)
							; ssxRunnerQuest.sceneStep[i]=-1 ; To avoid double teleportation
							Utility.WaitMenuMode(0.1)
						endIf
					endIf
					Scene ts = ssxRunnerQuest.scenes[i]
					if !ts.isPlaying()
						if howMuch > 30 ; scene is marked as active, but has been over 30 in same step and not actually playing
							ssxRunnerQuest.releaseScene(ts)
						endIf
					elseIf s == -1
						; scene is in final step, and still playing - keep track of when it stops playing
						ssxRunnerQuest.sceneTimeout[i] = Utility.GetCurrentRealTime()
					endIf
				endIf
			endIf
			
			if reserveSchedule()
				return
			endIf
			
			i += 1
		endWhile
		
		if ssxRunnerQuest.countScenesPlaying()==0 || ssxRunnerQuest.iAmActive==0
			cleanup()
			return
		endIf
		
		RegisterForSingleUpdate(3.5)
		cleanup()
	EndEvent

endState


Function startSex(Scene sc) ; Like StartSex but in this case there are only NPCs
	if reserveSchedule()
			cleanup()
			return
		endIf

	int pos = ssxRunnerQuest.searchScene(sc)
	if pos==-1
		cleanup()
		return
	endIf
	
	int sceneSexType=0
	if pos==0
		sceneSexType=ssxRunnerQuest.ssxNextAnswerWillBe0
	elseIf pos==1
		sceneSexType=ssxRunnerQuest.ssxNextAnswerWillBe1
	elseIf pos==2
		sceneSexType=ssxRunnerQuest.ssxNextAnswerWillBe2
	elseIf pos==3
		sceneSexType=ssxRunnerQuest.ssxNextAnswerWillBe3
	elseIf pos==4
		sceneSexType=ssxRunnerQuest.ssxNextAnswerWillBe4
	elseIf pos==5
		sceneSexType=ssxRunnerQuest.ssxNextAnswerWillBe5
	endIf
	
	
	; Understand if it has to be consensual, rape, or a masturbation, or no sex at all
	if sceneSexType==0 ; No sex
		ssxRunnerQuest.log("Scene manager: the result of the interaction will produce no sex", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(sc)
		cleanup()
		return
		
	elseif sceneSexType==1 ; Consensual
		SSX_Rule_Alias r = ssxRunnerQuest.sceneRs[pos]
		bool t=true
		bool s=true
		bool c=true
		if !ssxRunnerQuest.sceneDs[pos] || r.doNotInvolveDst()
			t=false
		endIf
		if !ssxRunnerQuest.sceneSs[pos] || r.doNotInvolveSrc()
			s=false
		endIf
		if !ssxRunnerQuest.sceneC1s[pos] || r.doNotInvolveColl()
			c=false
		endIf
		if t && !s && !c
			doSex(r, sc, ssxRunnerQuest.sceneDs[pos], bed=ssxRunnerQuest.sceneBs[pos])
		elseIf t && s && !c
				doSex(r, sc, ssxRunnerQuest.sceneDs[pos], ssxRunnerQuest.sceneSs[pos], bed=ssxRunnerQuest.sceneBs[pos])
		elseIf t && !s && c
				doSex(r, sc, ssxRunnerQuest.sceneDs[pos], ssxRunnerQuest.sceneC1s[pos], ssxRunnerQuest.sceneC2s[pos], ssxRunnerQuest.sceneC3s[pos], bed=ssxRunnerQuest.sceneBs[pos])
		elseIf t && s && c
			doSex(r, sc, ssxRunnerQuest.sceneDs[pos], ssxRunnerQuest.sceneSs[pos], ssxRunnerQuest.sceneC1s[pos], ssxRunnerQuest.sceneC2s[pos], ssxRunnerQuest.sceneC3s[pos], bed=ssxRunnerQuest.sceneBs[pos])
		elseIf !t && s && c
			doSex(r, sc, ssxRunnerQuest.sceneSs[pos], ssxRunnerQuest.sceneC1s[pos], ssxRunnerQuest.sceneC2s[pos], ssxRunnerQuest.sceneC3s[pos], bed=ssxRunnerQuest.sceneBs[pos])
		elseIf !t && !s && c
			doSex(r, sc, ssxRunnerQuest.sceneC1s[pos], ssxRunnerQuest.sceneC2s[pos], ssxRunnerQuest.sceneC3s[pos], bed=ssxRunnerQuest.sceneBs[pos])
		elseIf !t && s && !c
			doSex(r, sc, ssxRunnerQuest.sceneSs[pos], bed=ssxRunnerQuest.sceneBs[pos])
		else
			; Something wrong...
			ssxRunnerQuest.releaseScene(sc)
			cleanup()
			return
		endIf
	
	elseif sceneSexType==2 ; Rape (and the target will be the victim)
		startRape(pos)
		
	elseif sceneSexType==3 ; Masturbation of the source (and the collaborators is any)
		startMasturbation(pos)
		
	endIf
	cleanup()
EndFunction


Function doSex(SSX_Rule_Alias r, Scene sc, Actor a1, Actor a2=None, Actor a3=None, Actor a4=None, Actor a5=None, ObjectReference bed)
{starts an actual SexLab animation}
	if !a1
		return
	endIf
	if reserveSchedule()
		return
	endIf
	
	int numParticipants = r.getNumPlayers()
	; Understand if the actors are a creature or not. And search for anims according to the actor type
	sslBaseAnimation[] tmpAnims
	bool aggr = false
	if r.aggressive>0
		aggr = r.aggressive>Utility.randomInt(0, 3)
	endIf
	
	String ids=r.specificAnimIDs
	if aggr && r.specificAnimAIDs!=""
		ids = r.specificAnimAIDs
	endIf
	
	bool multipleCreatures = false
	if ids!=""
		Actor[] acts = new Actor[5]
		acts[0] = a1
		acts[1] = a2
		acts[2] = a3
		acts[3] = a4
		acts[4] = a5
		tmpAnims = ssxRunnerQuest.getSpecificAnimsForActors(acts, r, aggr)
	else
		String[] raceFilters = new String[5]
		if ssxRunnerQuest.isCreature(a1)
			raceFilters[0] = sslCreatureAnimationSlots.GetRaceKeyByID(MiscUtil.GetActorRaceEditorID(a1))
		endIf
		if a2 && ssxRunnerQuest.isCreature(a2)
			raceFilters[1] = sslCreatureAnimationSlots.GetRaceKeyByID(MiscUtil.GetActorRaceEditorID(a2))
		endIf
		if a3 && ssxRunnerQuest.isCreature(a3)
			raceFilters[2] = sslCreatureAnimationSlots.GetRaceKeyByID(MiscUtil.GetActorRaceEditorID(a3))
		endIf
		if a4 && ssxRunnerQuest.isCreature(a4)
			raceFilters[4] = sslCreatureAnimationSlots.GetRaceKeyByID(MiscUtil.GetActorRaceEditorID(a4))
		endIf
		if a5 && ssxRunnerQuest.isCreature(a5)
			raceFilters[5] = sslCreatureAnimationSlots.GetRaceKeyByID(MiscUtil.GetActorRaceEditorID(a5))
		endIf
		Actor[] sexPos = ssxRunnerQuest.setSexPositions(a1, a2, a3, a4, a5)
		
		if raceFilters[0]!="" || raceFilters[1]!="" || raceFilters[2]!="" || raceFilters[3]!="" || raceFilters[4]!="" 
			; Creatures involved
			if raceFilters[0]!=""
				if (raceFilters[1]!="" && raceFilters[0]!=raceFilters[1]) || (raceFilters[2]!="" && raceFilters[0]!=raceFilters[2]) || (raceFilters[3]!="" && raceFilters[0]!=raceFilters[3]) || (raceFilters[4]!="" && raceFilters[0]!=raceFilters[4])
					multipleCreatures=true
				endIf
			elseIf raceFilters[1]!=""
				if (raceFilters[2]!="" && raceFilters[1]!=raceFilters[2]) || (raceFilters[3]!="" && raceFilters[1]!=raceFilters[3]) || (raceFilters[4]!="" && raceFilters[1]!=raceFilters[4])
					multipleCreatures=true
				endIf
			elseIf raceFilters[2]!=""
				if (raceFilters[3]!="" && raceFilters[2]!=raceFilters[3]) || (raceFilters[4]!="" && raceFilters[2]!=raceFilters[4])
					multipleCreatures=true
				endIf
			elseIf raceFilters[3]!="" && raceFilters[4]!="" && raceFilters[3]!=raceFilters[4]
				multipleCreatures=true
			endIf

			if multipleCreatures
				if ssxRunnerQuest.safeCheckOfConCAnims==1
					; Use a safety search, so no anims will be specified
				else
					tmpAnims = ssxRunnerQuest.getAnims(sexPos, r, aggr, raceFilters) ; No safe-search, we may not find animations
				endIF
			else
				tmpAnims = ssxRunnerQuest.getAnims(sexPos, r, aggr, raceFilters) ; standard case, only one creature
			endIF
			
		else
			; Humans
			tmpAnims = ssxRunnerQuest.getAnims(sexPos, r, aggr, ssxRunnerQuest.emptyRaces)
				
		endIf
	endIf
	if (!tmpAnims || tmpAnims.length==0) && multipleCreatures && ssxRunnerQuest.safeCheckOfConCAnims==0
		ssxRunnerQuest.log("No animations found for " + numParticipants + " participants", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(sc)
		cleanup()
		return
	endIf
	
	; Remove the animations that are filtered
	int numAnims = 0
	sslBaseAnimation[] anims
	if tmpAnims
		int i = tmpAnims.length
		anims = sslUtility.EmptyAnimationArray()
		while i
			i -= 1
			sslBaseAnimation an = tmpAnims[i]
			if an
				if ssxRunnerQuest.isAnimEnabled(an.Registry)
					anims = sslUtility.PushAnimation(an, anims)
					numAnims += 1
				endIf
			endIf
		endWhile
	endIF

	if numAnims==0 && ssxRunnerQuest.safeCheckOfConCAnims==0
		ssxRunnerQuest.log("No animations found for " + numParticipants + " participants", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(sc)
		cleanup()
		return
	endIf
	
	sslThreadController tc = None
	sslThreadModel t = SexLab.NewThread()
	; Put the actors in correct order by respecting how is the passive role
	if r.passiveIs==1 ; Source
		Actor tmp = a1
		a1=a2
		a2=tmp
	elseIf r.passiveIs==2 ; Collaborator
		Actor tmp = a1
		a1=a3
		a3=tmp
	elseIf r.passiveIs==3 ; Random
		if a2 && a3
			int rnd = Utility.RandomInt(0, 2)
			if rnd==1
				Actor tmp = a1
				a1=a2
				a2=tmp
			elseIf rnd==2
				Actor tmp = a1
				a1=a3
				a3=tmp
			endIf
		elseIf a2
			if Utility.RandomInt(0, 1)==0
				Actor tmp = a1
				a1=a2
				a2=tmp
			endIf
		endIf
	elseIf r.passiveIs==4 ; Female (with fallback to dst)
		if a1 && ssxRunnerQuest.calculateSex(a1)==1
		elseIf a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==1
			Actor tmp = a1
			a1=a2
			a2=tmp
		elseIf a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==0 && a3 && ssxRunnerQuest.calculateSex(a3)==1
			Actor tmp = a1
			a1=a3
			a3=tmp
		elseIf a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==0 && a3 && ssxRunnerQuest.calculateSex(a3)==0 && a4 && ssxRunnerQuest.calculateSex(a4)==1
			Actor tmp = a1
			a1=a4
			a4=tmp
		endIf
	elseIf r.passiveIs==5 ; Femdom (with fallback to dst, female will be not passsive)
		if a1 && ssxRunnerQuest.calculateSex(a1)==1
			if a2 && ssxRunnerQuest.calculateSex(a2)==0
				Actor tmp = a1
				a1=a2
				a2=tmp
			elseIf a3 && ssxRunnerQuest.calculateSex(a3)==0
				Actor tmp = a1
				a1=a3
				a3=tmp
			elseIf a4 && ssxRunnerQuest.calculateSex(a4)==0
				Actor tmp = a1
				a1=a4
				a4=tmp
			endIf
		endIf
	elseIf r.passiveIs==6 && ssxRunnerQuest.useSLSexuality ; Gay (dst fallback, only if using SL Sexuality)
		if a1 && SexLab.GetSexuality(a1)<50 && ssxRunnerQuest.calculateSex(a1)==0
		elseIf a2 && SexLab.GetSexuality(a2)<50 && ssxRunnerQuest.calculateSex(a2)==0
			Actor tmp = a1
			a1=a2
			a2=tmp
		elseIf a3 && SexLab.GetSexuality(a3)<50 && ssxRunnerQuest.calculateSex(a3)==0
			Actor tmp = a1
			a1=a3
			a3=tmp
		elseIf a4 && SexLab.GetSexuality(a4)<50 && ssxRunnerQuest.calculateSex(a4)==0
			Actor tmp = a1
			a1=a4
			a4=tmp
		endIf
	elseIf r.passiveIs==7 && ssxRunnerQuest.useSLSexuality ; Gay or Female (with priority, dst fallback, only if using SL Sexuality)
		if a1 && SexLab.GetSexuality(a1)<50 && ssxRunnerQuest.calculateSex(a1)==0
		elseIf a2 && SexLab.GetSexuality(a2)<50 && ssxRunnerQuest.calculateSex(a2)==0
			Actor tmp = a1
			a1=a2
			a2=tmp
		elseIf a3 && SexLab.GetSexuality(a3)<50 && ssxRunnerQuest.calculateSex(a3)==0
			Actor tmp = a1
			a1=a3
			a3=tmp
		elseIf a4 && SexLab.GetSexuality(a4)<50 && ssxRunnerQuest.calculateSex(a4)==0
			Actor tmp = a1
			a1=a4
			a4=tmp
		elseIf a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==1
			Actor tmp = a1
			a1=a2
			a2=tmp
		elseIf a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==0 && a3 && ssxRunnerQuest.calculateSex(a3)==1
			Actor tmp = a1
			a1=a3
			a3=tmp
		elseIf a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==0 && a3 && ssxRunnerQuest.calculateSex(a3)==0 && a4 && ssxRunnerQuest.calculateSex(a4)==1
			Actor tmp = a1
			a1=a4
			a4=tmp
		endIf
	elseIf r.passiveIs==8 && ssxRunnerQuest.useSLSexuality ; Female or Gay (with priority, dst fallback, only if using SL Sexuality)
		if a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==1
			Actor tmp = a1
			a1=a2
			a2=tmp
		elseIf a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==0 && a3 && ssxRunnerQuest.calculateSex(a3)==1
			Actor tmp = a1
			a1=a3
			a3=tmp
		elseIf a1 && ssxRunnerQuest.calculateSex(a1)==0 && a2 && ssxRunnerQuest.calculateSex(a2)==0 && a3 && ssxRunnerQuest.calculateSex(a3)==0 && a4 && ssxRunnerQuest.calculateSex(a4)==1
			Actor tmp = a1
			a1=a4
			a4=tmp
		elseIf a1 && SexLab.GetSexuality(a1)<50 && ssxRunnerQuest.calculateSex(a1)==0
		elseIf a2 && SexLab.GetSexuality(a2)<50 && ssxRunnerQuest.calculateSex(a2)==0
			Actor tmp = a1
			a1=a2
			a2=tmp
		elseIf a3 && SexLab.GetSexuality(a3)<50 && ssxRunnerQuest.calculateSex(a3)==0
			Actor tmp = a1
			a1=a3
			a3=tmp
		elseIf a4 && SexLab.GetSexuality(a4)<50 && ssxRunnerQuest.calculateSex(a4)==0
			Actor tmp = a1
			a1=a4
			a4=tmp
		endIf
	endIf
	
	if t
		if addActor(r, t, a1, 0)
			String aName = "NONE"
			if a1
				aName = a1.getDisplayName()
			endIf
			ssxRunnerQuest.log("Cannot add the actor to a SexLab thread: " + aName, SSX_Runner_Quest.notifErrors())
			ssxRunnerQuest.releaseScene(sc)
			cleanup()
			return
		endIf
		if addActor(r, t, a2, 1)
			String aName = "NONE"
			if a2
				aName = a2.getDisplayName()
			endIf
			ssxRunnerQuest.log("Cannot add the actor to a SexLab thread: " + aName, SSX_Runner_Quest.notifErrors())
			ssxRunnerQuest.releaseScene(sc)
			cleanup()
			return
		endIf
		if addActor(r, t, a3, 2)
			String aName = "NONE"
			if a3
				aName = a3.getDisplayName()
			endIf
			ssxRunnerQuest.log("Cannot add the actor to a SexLab thread: " + aName, SSX_Runner_Quest.notifErrors())
			ssxRunnerQuest.releaseScene(sc)
			cleanup()
			return
		endIf
		if addActor(r, t, a4, 2)
			String aName = "NONE"
			if a4
				aName = a4.getDisplayName()
			endIf
			ssxRunnerQuest.log("Cannot add the actor to a SexLab thread: " + aName, SSX_Runner_Quest.notifErrors())
			ssxRunnerQuest.releaseScene(sc)
			cleanup()
			return
		endIf
		if addActor(r, t, a5, 2)
			String aName = "NONE"
			if a5
				aName = a5.getDisplayName()
			endIf
			ssxRunnerQuest.log("Cannot add the actor to a SexLab thread: " + aName, SSX_Runner_Quest.notifErrors())
			ssxRunnerQuest.releaseScene(sc)
			cleanup()
			return
		endIf
		t.SetHook("ScentOfSex")
		if anims && anims.length>0
			t.SetForcedAnimations(anims)
		endIF
		if r.hasLeadIn()
			sslBaseAnimation[] leadIns = SexLab.GetAnimationsByTags(r.getNumPlayers(), "LeadIn")
			if leadIns && leadIns.length>0
				t.SetLeadAnimations(leadIns)
			endIf
		endIf
		
		
		if !ssxRunnerQuest.useBedIfRequired(r, bed, t)
			ssxRunnerQuest.log("Cannot find a bed, and a bed is mandatory: " + r.name, SSX_Runner_Quest.notifErrors())
			ssxRunnerQuest.releaseScene(sc)
			cleanup()
			return
		else
			tc = ssxRunnerQuest.setSceneThreadController(a1, t)
			; Start the spectator crowds if required
			ssxRunnerQuest.addSpectators(r, a1)
		endIf
		; Do we need a victim?
		int pos = r.getVictim()
		if pos==0
			t.VictimRef = a1
		elseIf pos==1 && a2
			t.VictimRef = a2
		elseIf pos==2 && (a3 || a4 || a5)
			if Utility.randomInt(0,2)==0 && a5
				t.VictimRef = a5
			elseIf Utility.randomInt(0,1)==0 && a4
				t.VictimRef = a4
			else
				t.VictimRef = a3
			endIf 
		endIf
	else
		ssxRunnerQuest.log("Cannot get a SexLab thread", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(sc)
		cleanup()
		return
	endIf
	if !tc
		ssxRunnerQuest.log("SexLab animation did not start", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(sc)
	else
		if r.isStartingOn(12) || (r.isStartingOn(5) && ssxRunnerQuest.protectOnHealth==1) ; restore health at animation start
			healActor(a1)
			healActor(a2)
			healActor(a3)
			healActor(a4)
			healActor(a5)
		endIf
	endIf
	if a1
		a1.SheatheWeapon()
	endIf
	if a2
		a2.SheatheWeapon()
	endIf
	if a3
		a3.SheatheWeapon()
	endIf
	if a4
		a4.SheatheWeapon()
	endIf
	if a5
		a5.SheatheWeapon()
	endIf
	cleanup()
EndFunction

bool Function addActor(SSX_Rule_Alias r, sslThreadModel t, Actor a, int pos, bool asVictim=false)
{adds an actor to the SexLab thread, setting also the underess, and redress. Put the extra needed clothes defined by the rule. Returns false if it is OK}
	if !a
		return false ; If there is no actor we don't fail
	endIf
	int i = 8
	while i > 0 && sexlab.validateActor(a) < 0
		if !a
			return false
		endIf
		if (a.isDisabled() || a.isDead()) && a != PlayerRef
			r.removeActor(a)
			ssxRunnerQuest.removeFromAllActors(a)
			return true
		endIf
		if a == playerRef
			Utility.waitmenumode(1)
		else
			Utility.waitmenumode(0.1)
		endIf
		i -= 1
	endWhile
	if t.AddActor(a, IsVictim=asVictim) == -1 && i == 0
		return true
	endIF
	if pos==0
		r.wearAtStart(pos, a, ssxRunnerQuest.noStripsD, t)
	elseIf pos==1
		r.wearAtStart(pos, a, ssxRunnerQuest.noStripsS, t)
	else
		r.wearAtStart(pos, a, ssxRunnerQuest.noStripsC, t)
	endIf
	if ssxRunnerQuest.dontUndress(a)
		if pos==0
			t.SetStrip(a, ssxRunnerQuest.noStripsD)
		elseIf pos==1
			t.SetStrip(a, ssxRunnerQuest.noStripsS)
		else
			t.SetStrip(a, ssxRunnerQuest.noStripsC)
		endIf
		t.DisableUndressAnimation(a, true)
	endIf
	if ssxRunnerQuest.dontRedress(a)
		t.DisableRedress(a, true)
	endIf
	return false
EndFunction


event ssxStageStart(int tid, bool hasPlayer)
	sslThreadController tc = SexLab.GetController(tid)
	; Find if the stage is not the first one, then check if the rule requires spectators and have them masturbate
	int pos = ssxRunnerQuest.sceneTCs.find(tc)
	if pos==-1 || tc.Stage<2 || tc.Stage>3
		return ; Not interesting
	endIf
	SSX_Rule_Alias r = ssxRunnerQuest.sceneRs[pos]
	if r ; Only if the rule is valid
		int mode = r.getSpectatorsMasturbate()
		if mode==0
			return ; No masturbation
		endIf
		; In case send a new SexLab masturbation anim to one of the actors
		ssxRunnerQuest.doSpectatorMasturbate(pos, mode)
	endIf
endEvent

event ssxAnimEnd(int tid, bool hasPlayer)
	sslThreadController tc = SexLab.GetController(tid)
	Actor[] Positions = tc.Positions
	int i = 0
	
	; Get the rule
	int pos = ssxRunnerQuest.sceneTCs.find(tc)
	if pos==-1
		return ; No scene found, we cannot really do anything
	endIf
	SSX_Rule_Alias r = ssxRunnerQuest.sceneRs[pos]

	if r && r.startsOn==1
		if hasPlayer && (ssxRunnerQuest.IncreaseRelationShip==1 || ssxRunnerQuest.increaseSpeechCraft==1)
			i = Positions.length
			while i
				i -= 1
				Actor a = Positions[i]
				if a && a!=PlayerRef && ssxRunnerQuest.IncreaseRelationShip==1 ; In case there player was asking for sex, and the actor is not the player, increase the relationship rank (Only if the option is set in the MCM)
					int relRank = a.GetRelationshipRank(PlayerRef) ; Now increase the relationship for the other actors
					if relRank<(ssxRunnerQuest.maxRelationshipRank - 4)
						a.SetRelationshipRank(PlayerRef, relRank + 1)
						ssxRunnerQuest.log("Relationship rank with  " + a.getDisplayName() + " increased to " +  ssxRunnerQuest.relRanks[relRank + 5], SSX_Runner_Quest.notifRelationship())
					endIf
				endIf
				if a && a==PlayerRef && ssxRunnerQuest.increaseSpeechCraft==1 ; In case there player was asking for sex, and the actor is the player, increase the perk
					if PlayerRef.getActorValue("SpeechCraft")<ssxRunnerQuest.maxSpeechCraftLevel
						float newVal = PlayerRef.getActorValue("SpeechCraft")
						newVal += Utility.RandomFloat(0.0, 1.5)
						if newVal>ssxRunnerQuest.maxSpeechCraftLevel
							newVal = ssxRunnerQuest.maxSpeechCraftLevel
						endIf
						PlayerRef.setActorValue("SpeechCraft", newVal)
						ssxRunnerQuest.log(PlayerRef.getDisplayName() + " SpeechCraft is now  " + (newVal as Int), SSX_Runner_Quest.notifRelationship())
					endIf
				endIf
			endWhile
		endIf
	endIf
	i = Positions.length
	pos=-1
	while i
		i -= 1
		Actor a = Positions[i]
		if a
			if pos==-1
				pos=ssxRunnerQuest.searchScene(none, -1, a=a)
			endIf
			if pos!=-1 && ssxRunnerQuest.sceneRs[pos]
				if ssxRunnerQuest.sceneDs[pos]==a
					ssxRunnerQuest.sceneRs[pos].wearAtEnd(SSX_Rule_Alias.targetPosition(), a)
				elseIf ssxRunnerQuest.sceneSs[pos]==a
					ssxRunnerQuest.sceneRs[pos].wearAtEnd(SSX_Rule_Alias.sourcePosition(), a)
				elseIf ssxRunnerQuest.sceneC1s[pos]==a
					ssxRunnerQuest.sceneRs[pos].wearAtEnd(SSX_Rule_Alias.collaboratorPosition(), a)
				elseIf ssxRunnerQuest.sceneC2s[pos]==a
					ssxRunnerQuest.sceneRs[pos].wearAtEnd(SSX_Rule_Alias.collaboratorPosition(), a)
				elseIf ssxRunnerQuest.sceneC3s[pos]==a
					ssxRunnerQuest.sceneRs[pos].wearAtEnd(SSX_Rule_Alias.collaboratorPosition(), a)
				endIf
			endIf
		endIf
	endWhile
	if pos!=-1 && ssxRunnerQuest.sceneBs[pos]
		ssxRunnerQuest.releaseBed(ssxRunnerQuest.sceneBs[pos])
	endIf
	tc.RemoveHook("ScentOfSex")
	if pos != -1
		ssxRunnerQuest.releaseScene(None, index=pos, a=None)
;		spectators are now cleaned by releaseScene
;		ssxRunnerQuest.cleanSpectators(pos) ; Stop the spectators
	endIf

; releaseScene also restores combat
	
;	Utility.waitMenuMode(1.0)
; Multiple scenes may be playing at once.
;	if ssxRunnerQuest.countScenesPlaying() == 0
;		ssxRunnerQuest.resetCombat()
;	endIf
endEvent

Function releaseAllScenes()
	int i=ssxRunnerQuest.scenes.length
	while i
		i -= 1
		ssxRunnerQuest.releaseScene(None, index=i, a=None)
	endWhile
EndFunction

Function stopEverything()
	{Release all the actors}
	int i = ssxRunnerQuest.aliasesDs.length
	while i
		i -= 1
		Actor a = ssxRunnerQuest.aliasesDs[i].GetActorReference()
		ssxRunnerQuest.aliasesDs[i].clear()
		if a
			a.EvaluatePackage()
		endIf
		a = ssxRunnerQuest.aliasesSs[i].GetActorReference()
		ssxRunnerQuest.aliasesSs[i].clear()
		if a
			a.EvaluatePackage()
		endIf
		a = ssxRunnerQuest.aliasesC1s[i].GetActorReference()
		ssxRunnerQuest.aliasesC1s[i].clear()
		if a
			a.EvaluatePackage()
		endIf
		a = ssxRunnerQuest.aliasesC2s[i].GetActorReference()
		ssxRunnerQuest.aliasesC2s[i].clear()
		if a
			a.EvaluatePackage()
		endIf
		a = ssxRunnerQuest.aliasesC3s[i].GetActorReference()
		ssxRunnerQuest.aliasesC3s[i].clear()
		if a
			a.EvaluatePackage()
		endIf
	endWhile

	; Stop all the scene
	releaseAllScenes()
	
	; Stop the spectators
	i = 6
	while i
		i-=1
		ssxRunnerQuest.cleanSpectators(i)
	endWhile
	
	; Remove the I love you faction for stopping combats
	ssxRunnerQuest.resetCombat()
	cleanup()
EndFunction




; Function without state
	


; 0, 1, 2, 3 for Scene 0; 4, 5, 6, 7 for Scene 1, etc.


Function startRapeFromScene(Scene s)
	int pos = ssxRunnerQuest.searchScene(s, -1, none)
	if pos!=-1
		startRape(pos)
	endIf
EndFunction

Function startMasturbationFromScene(Scene s)
	int pos = ssxRunnerQuest.searchScene(s, -1, none)
	if pos!=-1
		startMasturbation(pos)
	endIf
EndFunction



Function startRape(int sceneIndex)
	SSX_Rule_Alias r = ssxRunnerQuest.sceneRs[sceneIndex]
	int numP = r.getNumPlayers()

	; Find an available animation
	Actor[] sexPositions = ssxRunnerQuest.setSexPositions(ssxRunnerQuest.sceneDs[sceneIndex], ssxRunnerQuest.sceneSs[sceneIndex], ssxRunnerQuest.sceneC1s[sceneIndex], ssxRunnerQuest.sceneC2s[sceneIndex], ssxRunnerQuest.sceneC3s[sceneIndex])
	bool aggr = false
	if r.getPercRapeAggr()>0
		aggr = r.getPercRapeAggr()>Utility.randomInt(0, 3)
	endIf

	sslBaseAnimation[] anims
	if r.specificAnimIDs!=""
		Actor[] acts = new Actor[5]
		acts[0] = ssxRunnerQuest.sceneDs[sceneIndex]
		acts[1] = ssxRunnerQuest.sceneSs[sceneIndex]
		acts[2] = ssxRunnerQuest.sceneC1s[sceneIndex]
		acts[3] = ssxRunnerQuest.sceneC2s[sceneIndex]
		acts[4] = ssxRunnerQuest.sceneC3s[sceneIndex]
		anims = ssxRunnerQuest.getSpecificAnimsForActors(acts, r, aggr)
	else
		anims = ssxRunnerQuest.getAnims(sexPositions, r, aggr, ssxRunnerQuest.emptyRaces)
	endIf
	if anims.length==0
		ssxRunnerQuest.log("No rape animations found for " + numP + " participants", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(index=sceneIndex)
		return
	endIf
	sslThreadController tc = None
	sslThreadModel t = SexLab.NewThread()
	if t
		; Adding the scene actors
		bool weDidIt = true
		if ssxRunnerQuest.sceneDs[sceneIndex]
			weDidIt = !addActor(r, t, ssxRunnerQuest.sceneDs[sceneIndex], 0, True)
		endIf
		if ssxRunnerQuest.sceneSs[sceneIndex] && weDidIt
			weDidIt = !addActor(r, t, ssxRunnerQuest.sceneSs[sceneIndex], 1, False)
		endIf
		if ssxRunnerQuest.sceneC1s[sceneIndex] && weDidIt
			weDidIt = !addActor(r, t, ssxRunnerQuest.sceneC1s[sceneIndex], 2, False)
		endIf
		if ssxRunnerQuest.sceneC2s[sceneIndex] && weDidIt
			weDidIt = !addActor(r, t, ssxRunnerQuest.sceneC2s[sceneIndex], 2, False)
		endIf
		if ssxRunnerQuest.sceneC3s[sceneIndex] && weDidIt
			weDidIt = !addActor(r, t, ssxRunnerQuest.sceneC3s[sceneIndex], 2, False)
		endIf
		if weDidIt
			RegisterForModEvent("HookAnimationEnding_ScentOfSex", "ssxAnimEnd")
			t.SetHook("ScentOfSex")
			t.SetForcedAnimations(anims)
			t.DisableBedUse(true)
			if (ssxRunnerQuest.sceneDs[sceneIndex]==PlayerRef) || (ssxRunnerQuest.sceneSs[sceneIndex]==PlayerRef) || (ssxRunnerQuest.sceneC1s[sceneIndex]==PlayerRef) || (ssxRunnerQuest.sceneC2s[sceneIndex]==PlayerRef) || (ssxRunnerQuest.sceneC3s[sceneIndex]==PlayerRef)
				t.VictimRef = PlayerRef
			endIf
			tc = ssxRunnerQuest.setSceneThreadController(ssxRunnerQuest.sceneSs[sceneIndex], t)
		else
			ssxRunnerQuest.log("Cannot add all the actors to a SexLab thread", SSX_Runner_Quest.notifErrors())
		endIf
	else
		ssxRunnerQuest.log("Cannot get a SexLab thread", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(index=sceneIndex)
		return
	endIf
	if !tc
		ssxRunnerQuest.log("SexLab animation did not start", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(index=sceneIndex)
	else
		if r.isStartingOn(12) || (r.isStartingOn(5) && ssxRunnerQuest.protectOnHealth==1)
			healActor(ssxRunnerQuest.sceneDs[sceneIndex])
			healActor(ssxRunnerQuest.sceneSs[sceneIndex])
			healActor(ssxRunnerQuest.sceneC1s[sceneIndex])
			healActor(ssxRunnerQuest.sceneC2s[sceneIndex])
			healActor(ssxRunnerQuest.sceneC3s[sceneIndex])
		endIf
	endIf
EndFunction

Function startMasturbation(int sceneIndex)
	Actor[] acts = new Actor[4]
	int num=0
	Actor a

	; Was the player asking? In this case is the Player that should masturbate
	SSX_Rule_Alias r = ssxRunnerQuest.sceneRs[sceneIndex]
	if r && r.startsByPlayerAsking()
		acts[num] = PlayerRef
		num+=1
	else
		a = ssxRunnerQuest.sceneSs[sceneIndex]
		if a
			acts[num] = a
			num+=1
		endIf
	endIf
	a = ssxRunnerQuest.sceneC1s[sceneIndex]
	if a
		acts[num] = a
		num+=1
	endIf	
	a = ssxRunnerQuest.sceneC2s[sceneIndex]
	if a
		acts[num] = a
		num+=1
	endIf	
	a = ssxRunnerQuest.sceneC3s[sceneIndex]
	if a
		acts[num] = a
		num+=1
	endIf	
	; Create the message
	String msg = acts[0].getDisplayName()
	int i=1
	while i<num
		msg += " and " + acts[i].getDisplayName()
		i+=1
	endWhile
	ssxRunnerQuest.log(msg + " could not resist and will masturbate", SSX_Runner_Quest.notifRulePlayedN())
	
	; Now do a SexLab anim for each of them. The first one should get the normal scene thread
	sslBaseAnimation[] anims
	sslThreadModel t
	i=0
	while i<num
		if ssxRunnerQuest.calculateSex(acts[i])==0
			anims = SexLab.getAnimationsByTags(1, "Masturbation,M")
		else
			anims = SexLab.getAnimationsByTags(1, "Masturbation,F")
		endIf
		t = SexLab.NewThread()
		if t

			int n = 5
			while n > 0 && t.AddActor(acts[i]) == -1
				if a.isDisabled() || a.isDead()
					ssxRunnerQuest.removeFromAllActors(a)
					n = 0
				else
					Utility.waitmenumode(0.5)
					n -= 1
				endIf
			endWhile
			if n == 0
				ssxRunnerQuest.log("Cannot add the actor to a SexLab thread", SSX_Runner_Quest.notifErrors())
				ssxRunnerQuest.releaseScene(index=sceneIndex)
				return
			endIf
			if ssxRunnerQuest.dontUndress(acts[i])
				t.SetStrip(acts[i], ssxRunnerQuest.noStripsS)
				t.DisableUndressAnimation(acts[i], true)
			endIf
			if ssxRunnerQuest.dontRedress(acts[i])
				t.DisableRedress(acts[i], true)
			endIf
			t.StartThread()
			t.SetForcedAnimations(anims)
			t.DisableBedUse(true)
		else
			ssxRunnerQuest.log("Cannot get a SexLab thread", SSX_Runner_Quest.notifErrors())
			ssxRunnerQuest.releaseScene(index=sceneIndex)
			return
		endIf
		i+=1
	endWhile
	ssxRunnerQuest.releaseScene(index=sceneIndex) ; Release the scenes, they will not be released at the end
EndFunction



Function startSexFromActor(Actor a)
	int pos = ssxRunnerQuest.searchScene(None, -1, a)
	if pos!=-1
		startSex(ssxRunnerQuest.scenes[pos])
	endIf
EndFunction


; -=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=-
; =-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=-=
; -=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=-
; =-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=-=
; -=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=-
; =-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=--=-=-=-=-=-=-=


Event startScene(int fR, Form fA1, Form fA2, Form fA3, Form fA4, Form fA5, Form fBed, int isPlayerAsking)
	ssxRunnerQuest.letsWait = 1
	SSX_Rule_Alias r = ssxRunnerQuest.getRuleByIndex(fR)

	Actor t = fA1 as Actor
	Actor s = fA2 as Actor
	Actor c1 = fA3 as Actor
	Actor c2 = fA4 as Actor
	Actor c3 = fA5 as Actor
	ObjectReference bed = fBed as ObjectReference

	if !isPlayerAsking && (ssxRunnerQuest.iAmActive==0 || ssxRunnerQuest.areMenuOpen>0)
		ssxRunnerQuest.letsWait = 0
		return
	endIf
	bool notReallyRequiredD = r.doNotInvolveDst()
	bool notReallyRequiredS = r.doNotInvolveSrc()
	bool notReallyRequiredC = r.doNotInvolveColl()

	; Check if the actors are already in a scene, in this case report an error and stop
	if t && !notReallyRequiredD && (ssxRunnerQuest.sceneDs.find(t)!=-1 || ssxRunnerQuest.sceneSs.find(t)!=-1 || ssxRunnerQuest.sceneC1s.find(t)!=-1 || ssxRunnerQuest.sceneC2s.find(t)!=-1 || ssxRunnerQuest.sceneC3s.find(t)!=-1)
		ssxRunnerQuest.log("The Target actor " + t.getDisplayName() + " is in another scene already!", SSX_Runner_Quest.notifNotGoodActors())
		ssxRunnerQuest.letsWait = 0
		return
	endIf
	if s && !notReallyRequiredS && (ssxRunnerQuest.sceneDs.find(s)!=-1 || ssxRunnerQuest.sceneSs.find(s)!=-1 || ssxRunnerQuest.sceneC1s.find(s)!=-1 || ssxRunnerQuest.sceneC2s.find(s)!=-1 || ssxRunnerQuest.sceneC3s.find(s)!=-1)
		ssxRunnerQuest.log("The Source actor " + s.getDisplayName() + " is in another scene already!", SSX_Runner_Quest.notifNotGoodActors())
		ssxRunnerQuest.letsWait = 0
		return
	endIf
	if c1 && !notReallyRequiredC && (ssxRunnerQuest.sceneDs.find(c1)!=-1 || ssxRunnerQuest.sceneSs.find(c1)!=-1 || ssxRunnerQuest.sceneC1s.find(c1)!=-1 || ssxRunnerQuest.sceneC2s.find(c1)!=-1 || ssxRunnerQuest.sceneC3s.find(c1)!=-1)
		ssxRunnerQuest.log("The Collaborator actor " + c1.getDisplayName() + " is in another scene already!", SSX_Runner_Quest.notifNotGoodActors())
		ssxRunnerQuest.letsWait = 0
		return
	endIf
	if c2 && !notReallyRequiredC && (ssxRunnerQuest.sceneDs.find(c2)!=-1 || ssxRunnerQuest.sceneSs.find(c2)!=-1 || ssxRunnerQuest.sceneC1s.find(c2)!=-1 || ssxRunnerQuest.sceneC2s.find(c2)!=-1 || ssxRunnerQuest.sceneC3s.find(c2)!=-1)
		ssxRunnerQuest.log("The Collaborator actor " + c2.getDisplayName() + " is in another scene already!", SSX_Runner_Quest.notifNotGoodActors())
		ssxRunnerQuest.letsWait = 0
		return
	endIf
	if c3 && !notReallyRequiredC && (ssxRunnerQuest.sceneDs.find(c3)!=-1 || ssxRunnerQuest.sceneSs.find(c3)!=-1 || ssxRunnerQuest.sceneC1s.find(c3)!=-1 || ssxRunnerQuest.sceneC2s.find(c3)!=-1 || ssxRunnerQuest.sceneC3s.find(c3)!=-1)
		ssxRunnerQuest.log("The Collaborator actor " + c3.getDisplayName() + " is in another scene already!", SSX_Runner_Quest.notifNotGoodActors())
		ssxRunnerQuest.letsWait = 0
		return
	endIf
	
	; Pick a scene
	bool isPlayerAsked = (fA1==PlayerRef || fA2==PlayerRef || fA3==PlayerRef || fA4==PlayerRef || fA5==PlayerRef) && r.getAskBeforeSex()
	int pos = ssxRunnerQuest.getAScene(isPlayerAsking, isPlayerAsked)
	if pos==-1
		ssxRunnerQuest.log("No available scenes PlayerAsking=" + isPlayerAsking + " isPlayerAsked=" + isPlayerAsked, SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.letsWait = 0
		return ; No available scenes
	endIf
	if !isPlayerAsked && (isPlayerAsking || (r.getAskBeforeSex() && (t==PlayerRef || s==PlayerRef))) ; Player is asking
		; ssxRunnerQuest.ssxNextAnswerWillBe0 is already set by the RuleChecker
		ssxRunnerQuest.ssxFinalSentence0 = r.getDialogue(3)
		
		; Calculate the answer on speechcraft or random, based on the rule dialogue probs definitions
		
	elseIf isPlayerAsked ; Player is asked
		; Calculate only the negative answer, it will be overwritten in case it is accepted
	
		; Fix player position
		if t!=PlayerRef
			if s==PlayerRef
				s=t
				t=PlayerRef
			elseIf c1==PlayerRef
				c1=t
				t=PlayerRef
			elseIf c2==PlayerRef
				c2=t
				t=PlayerRef
			elseIf c3==PlayerRef
				c3=t
				t=PlayerRef
			endIf
		endIf

		ssxRunnerQuest.ssxRequestToPlayer1 = r.getDialogue(0)
		ssxRunnerQuest.ssxNextAnswerWillBe1=r.calculateConsequence(1)
		ssxRunnerQuest.ssxFinalSentence1 = r.getDialogue(3)
		if s
			if ssxRunnerQuest.isCreature(s)
				s.addToFaction(ssxCreatures)
			else
				s.addToFaction(ssxAskingFaction)
			endIf
		endIf
	elseIf r.getAskBeforeSex() ; NPC to NPC
	
	; Calculate randomly based on dialogue probs definition
	
		; Set up the dialogues and the asking faction
		if s
			s.addToFaction(ssxAskingFaction)
		endIf
		int sceneSexType = r.calculateConsequence(2)
		int answer = r.calculateAnswer(sceneSexType)
		if pos==2
			ssxRunnerQuest.ssxNPCRequest2=r.getDialogue(0)
			ssxRunnerQuest.ssxNPCAnswer2=answer
			ssxRunnerQuest.ssxNextAnswerWillBe2=sceneSexType
			ssxRunnerQuest.ssxFinalSentence2=r.getDialogue(3)
		elseIf pos==3
			ssxRunnerQuest.ssxNPCRequest3=r.getDialogue(0)
			ssxRunnerQuest.ssxNPCAnswer3=answer
			ssxRunnerQuest.ssxNextAnswerWillBe3=sceneSexType
			ssxRunnerQuest.ssxFinalSentence3=r.getDialogue(3)
		elseIf pos==4
			ssxRunnerQuest.ssxNPCRequest4=r.getDialogue(0)
			ssxRunnerQuest.ssxNPCAnswer4=answer
			ssxRunnerQuest.ssxNextAnswerWillBe4=sceneSexType
			ssxRunnerQuest.ssxFinalSentence4=r.getDialogue(3)
		elseIf pos==5
			ssxRunnerQuest.ssxNPCRequest5=r.getDialogue(0)
			ssxRunnerQuest.ssxNPCAnswer5=answer
			ssxRunnerQuest.ssxNextAnswerWillBe5=sceneSexType
			ssxRunnerQuest.ssxFinalSentence5=r.getDialogue(3)
		endIf
	else ; No asking, the player can be involved, but we still need to define the sex type
		if pos==2
			ssxRunnerQuest.ssxNPCRequest2=0
			ssxRunnerQuest.ssxNPCAnswer2=0
			ssxRunnerQuest.ssxNextAnswerWillBe2=1 ; Consensual
			ssxRunnerQuest.ssxFinalSentence2=0
		elseIf pos==3
			ssxRunnerQuest.ssxNPCRequest3=0
			ssxRunnerQuest.ssxNPCAnswer3=0
			ssxRunnerQuest.ssxNextAnswerWillBe3=1 ; Consensual
			ssxRunnerQuest.ssxFinalSentence3=0
		elseIf pos==4
			ssxRunnerQuest.ssxNPCRequest4=0
			ssxRunnerQuest.ssxNPCAnswer4=0
			ssxRunnerQuest.ssxNextAnswerWillBe4=1 ; Consensual
			ssxRunnerQuest.ssxFinalSentence4=0
		elseIf pos==5
			ssxRunnerQuest.ssxNPCRequest5=0
			ssxRunnerQuest.ssxNPCAnswer5=0
			ssxRunnerQuest.ssxNextAnswerWillBe5=1 ; Consensual
			ssxRunnerQuest.ssxFinalSentence5=0
		endIf
	endIf
	
	
	Scene ts = ssxRunnerQuest.scenes[pos]
	if !isPlayerAsking && (ssxRunnerQuest.iAmActive==0 || ssxRunnerQuest.areMenuOpen>0)
		ssxRunnerQuest.log("Not starting the scene because we are stopping 1", SSX_Runner_Quest.notifActivationN())
		ssxRunnerQuest.letsWait = 0
		ssxRunnerQuest.sceneAvails[pos]=true ; this was reserved in getAScene earlier, so should undo it
		return
	endIf
	
	; FIXME Set the involved actors, but avoid theones that are not involved
	if notReallyRequiredD && notReallyRequiredS
		ssxRunnerQuest.setInvolved(c1, c2, c3)
	elseIf notReallyRequiredD && notReallyRequiredC
		ssxRunnerQuest.setInvolved(s)
	elseIf notReallyRequiredS && notReallyRequiredC
		ssxRunnerQuest.setInvolved(s, c1, c2, c3)
	elseIf notReallyRequiredD
		ssxRunnerQuest.setInvolved(s, c1, c2, c3)
	elseIf notReallyRequiredS
		ssxRunnerQuest.setInvolved(t, c1, c2, c3)
	elseIf notReallyRequiredC
		ssxRunnerQuest.setInvolved(t, s)
	else
		ssxRunnerQuest.setInvolved(s, t, c1, c2, c3)
	endIf
	
	; Handle the not required and do some logs
	String party = ""
	int numCs = 0
	Actor c = none
	if c3
		numCs+=1
		c=c3
	endIf
	if c2
		numCs+=1
		c=c2
	endIf
	if c1
		numCs+=1
		c=c1
	endIf
	if t && s && numCs>1
		party = ssxRunnerQuest.s("$SSX_party3p", numCs+2, t.getDisplayName(), s.getDisplayName())
	elseIf t && !s && numCs>2
		party = ssxRunnerQuest.s("$SSX_party3p", numCs+1, t.getDisplayName(), "...")
	elseIf !t && s && numCs>2
		party = ssxRunnerQuest.s("$SSX_party3p", numCs+1, s.getDisplayName(), "...")
	elseIf t && s && numCs==1
		party = ssxRunnerQuest.s("$SSX_party3", t.getDisplayName(), s.getDisplayName(), c.getDisplayName())
	elseIf t && !s && numCs==2
		party = ssxRunnerQuest.s("$SSX_party3", t.getDisplayName(), c.getDisplayName(), "...")
	elseIf !t && s && numCs==2
		party = ssxRunnerQuest.s("$SSX_party3", s.getDisplayName(), c.getDisplayName(), "...")
	elseIf numCs==3
		party = ssxRunnerQuest.s("$SSX_party3", c1.getDisplayName(), c2.getDisplayName(), c3.getDisplayName())
	elseIf t && s
		party = ssxRunnerQuest.s("$SSX_party2", t.getDisplayName(), s.getDisplayName())
	elseIf t && !s && numCs==1
		party = ssxRunnerQuest.s("$SSX_party2", t.getDisplayName(), c.getDisplayName())
	elseIf !t && s && numCs==1
		party = ssxRunnerQuest.s("$SSX_party2", s.getDisplayName(), c.getDisplayName())
	elseIf !t && !s && numCs==2
		party = ssxRunnerQuest.s("$SSX_party2", c.getDisplayName(), "...")
	elseIf t && !s && numCs==0
			party = ssxRunnerQuest.s("$SSX_party1", t.getDisplayName())
	elseIf !t && s && numCs==0
			party = ssxRunnerQuest.s("$SSX_party1", s.getDisplayName())
	elseIf !t && !s && numCs==1
			party = ssxRunnerQuest.s("$SSX_party1", c.getDisplayName())
	endIF
	
	ssxRunnerQuest.log(ssxRunnerQuest.s("$SSX_RuleSelected", r.name, party), SSX_Runner_Quest.notifRulePlayedN())
	String msg = ""
	if t
		msg = "Target " + t.getDisplayName()
	endIf
	if r.src!=0 && s
		msg += " Source " + s.getDisplayName()
	endIf
	if r.coll!=0 && c1
		if c1
			msg += " with " + c1.getDisplayName()
		endIf
		if c2
			msg += ", " + c2.getDisplayName()
		endIf
		if c3
			msg += ", " + c3.getDisplayName()
		endIf
	endIf
	ssxRunnerQuest.log(msg, SSX_Runner_Quest.notifRulePlayedN())
	if !isPlayerAsking && (ssxRunnerQuest.iAmActive==0 || ssxRunnerQuest.areMenuOpen>0)
		ssxRunnerQuest.releaseScene(None, index=pos, a=None)
		ssxRunnerQuest.log("Not starting the scene because we are stopping 2", SSX_Runner_Quest.notifActivationN())
		ssxRunnerQuest.letsWait = 0
		return
	endIf

	; Assign the aliases and all the Objects in the scene variables, in case player is asked, be sure it is the target
	ssxRunnerQuest.setAliases(pos, r, t, s, c1, c2, c3, bed, r.getStripMode(0), r.getStripMode(1), r.getStripMode(2))
	
	; Any chance we have to stop combats?
	if r.stopAllCombats==2
		ssxRunnerQuest.stopAllCombats()
	elseIf r.stopAllCombats==1
		if s==PlayerRef || t==PlayerRef || c1==PlayerRef || c2==PlayerRef || c3==PlayerRef || (s && s.isPlayerTeamMate()) || (t && t.isPlayerTeamMate()) || (c1 && c1.isPlayerTeamMate()) || (c2 && c2.isPlayerTeamMate()) || (c3 && c3.isPlayerTeamMate())
			ssxRunnerQuest.stopAllCombats()
		endIf
	endIf
	
	; Highlight the selected actors
	int color
	if t
		color = r.getHighlightColor(0, true)
		if color
			ssxRunnerQuest.hlg(t, color, SSX_Runner_Quest.highlightScene())
		endIf
	endIf
	if s
		color = r.getHighlightColor(1, true)
		if color
			ssxRunnerQuest.hlg(s, color, SSX_Runner_Quest.highlightScene())
		endIf
	endIf
	if c1
		color = r.getHighlightColor(2, true)
		if color
			ssxRunnerQuest.hlg(c1, color, SSX_Runner_Quest.highlightScene())
		endIf
	endIf
	if c2
		color = r.getHighlightColor(2, true)
		if color
			ssxRunnerQuest.hlg(c2, color, SSX_Runner_Quest.highlightScene())
		endIf
	endIf
	if c3
		color = r.getHighlightColor(2, true)
		if color
			ssxRunnerQuest.hlg(c3, color, SSX_Runner_Quest.highlightScene())
		endIf
	endIf
	
	; Start the scene
	ssxRunnerQuest.log("Starting scene for rule " + r.name, SSX_Runner_Quest.notifRulePlayedN())
	ts.ForceStart() ; When a scene is started, start a timeout, to be sure the actors are not stuck in a transition
	int i=10
	while i
		i-=1
		Utility.waitMenuMode(0.3)
		if ts.isPlaying()
			i=0
		endIf
	endWhile
	if !ts.isPlaying()
		ssxRunnerQuest.log("Failed to start the scene, the actors were probably in another scene already.", SSX_Runner_Quest.notifErrors())
		ssxRunnerQuest.releaseScene(ts)
		ssxRunnerQuest.letsWait = 0
		return
	endIf
	
	r.lastRunTime = Utility.GetCurrentGameTime()

	goToState("active")
EndEvent

Function healActor(Actor a)
	if !a
		return
	endIf
	while a.getActorValue("Health")<10
		a.RestoreActorValue("Health", 10.0 - a.getActorValue("Health"))
		if a == PlayerRef
		; 0 = 1st person; 1 = vanity; 2 = VATS; 3 = free; 4 = sights; 5 = furniture; 6 = transition
		; 7 = menu; 8 & 9 = 3rd person; 10 = horse; 11 = bleedout; 12 = dragon
			int cs = Game.GetCameraState()
			if (cs < 3 || cs == 4 || cs > 10)
				Game.ForceThirdPerson()
			endIf
		endIf
		Utility.waitMenuMode(0.1)
	endWhile
EndFunction


