Scriptname SSX_MCM_Quest extends SKI_ConfigBase ; V 1.4h

; FIXME Fixed a small MCM error when the sexual preferences where involving creatures butcreatures are disabled
; FIXME Now races for filters will not fail in case the name of the race is a sub-string of another race (e.g. "NordRace" is no more the same as "myCustomNordRace")
; FIXME Actors not required in the scene (used just to start scenes) are no more involved when the scene starts, allowing other rules to run
; FIXME When a scene is started and the orgymode is set, mutiple instances of the rule can be started right away
; FIXME Fixed a problem when checking orgy mode rules when some of the actors were set as non-participating
; FIXME The cell scans (to find actors, or when opening the MCM) are now done using Miscutil actors scan, improving a lot the performance
; FIXME 
; FIXME 
; FIXME 


; ((- Properties
SexLabFramework Property SexLab Auto
Actor Property PlayerRef Auto
DialogueFollowerScript Property DialogueFollower Auto
SSX_Runner_Quest Property ssxRunnerQuest Auto
SSX_Rule_Alias Property editRuleL0 Auto ; Top level editing (main edit rule page)
SSX_Rule_Alias Property editRuleL1 Auto ; Sub level editing (properties, locations, participants, tags, etc.)
SSX_Rule_Alias Property editRuleL2 Auto ; Sub-sub level (specific participants)
Actor Property ssxTestGuy Auto ; used to perform the performance tests
Faction Property currentFollowerFaction Auto
Faction Property potentialFollowerFaction Auto

Spell Property ssxAddToFactionGroup1 Auto
Spell Property ssxAddToFactionGroup2 Auto
Spell Property ssxAddToFactionGroup3 Auto
Spell Property ssxAddToFactionGroup4 Auto
Spell Property ssxAddToFactionGroup5 Auto
; -))

; ((- OPT IDs
int howToFilterRules = 0
int positionEdited
int tmpVictimMask
string[] jsonRules
bool canIBeAskedSLENFix
bool isRuleEdit				; true for edit a rule, false for adding a rule
int ruleEditIndex			; Index of the actual rule to be edited/created. -1 is no rule is selected
int curRuleIndex 			; That is the index of the selected rule in the visible list. -1 is no rule is selected
int numOpRules				; This is the number of actual rules in the visible list
String[] availableRaces
int[] actorsSex
int num
int[] Property pageOPTs Auto
int[] tmpValInt
String[] tmpValString
int usedOptions				; Conteins the total number of options in the current page, to speed-up the cleaning up of options
int pageEditMode			; holds the index of the current page shown
bool check
bool doTests					; This is used to start the performance checkings
int editingLevel=-1
Cell lastActorCell
String factionFilter
String prevFactionFilter
String[] factionFilters
; -))


int Function getVersion()
	return ssxRunnerQuest.getVersion()
EndFunction

String Function getVersionString()
	return ssxRunnerQuest.getVersionString()
EndFunction


; ((- --------- Async and Init stuff -----------
bool areWeReLoading = false

Function doInit(String fromWhere)
	Utility.waitMenuMode(0.1) ; This will give away the papyrus time, so after there will be enough run time to execute the first two items
	if areWeReLoading || ssxRunnerQuest.isMCMLoaded
		debug.trace("[SSX] We are already doing init of MCM (" + fromWhere + ")")
		return
	endIf
	areWeReLoading = True
	ssxRunnerQuest.log(ssxRunnerQuest.s("$onGameReLoadStart", getVersionString()), SSX_Runner_Quest.notifActivationN())
	ModName = "Scent of Sex NG"
	; Data\configs\Scent of Sex NG
	ssxRunnerQuest.configFolder = "..\\..\\..\\configs\\Scent of Sex NG\\"
	ssxRunnerQuest.configFile = ssxRunnerQuest.configFolder + "settings.json"
	
	tmpValInt = new int[128]
	tmpValString = new string[128]
	availableRaces = new string[128]
	areWeReLoading = False
EndFunction

Event OnConfigRegister()
	ssxRunnerQuest.isMCMLoaded = true
EndEvent

int oldVersion = 0

Event OnVersionUpdate(int newVersion)
	if newVersion!=oldVersion
		oldVersion=newVersion
		ssxRunnerQuest.forceActorsCleanUp()
		doInit("OnVersionUpdate")
		setPageNamesForExpertiseLevel()
		debug.trace("New SSX Version = " + getVersionString() + " (" + getVersion() + ")")
	endIf
EndEvent

; -))

event OnConfigOpen()
	if ssxRunnerQuest.iAmInitialized!=2
		return
	endIf

	ssxRunnerQuest.isMCMLoaded = true
	ssxRunnerQuest.startT("MCM Opening")
	pageEditMode=0
	; Check if the config is loaded, if not show a temporary page
	if ssxRunnerQuest.isConfigInProgress==-1
		int handle = ModEvent.Create("ssxUpdateConfig")
		ModEvent.PushString(handle, "Load")
		ModEvent.PushString(handle, "OnConfigOpen")
		ModEvent.Send(handle)
		Pages = New String[1]
		Pages[0] = "Install"
		areWeReLoading = true
		return
	elseIf ssxRunnerQuest.isConfigInProgress<100
		areWeReLoading = true
		return
	endIf
	setPageNamesForExpertiseLevel()

	int i = ModEvent.Create("ssxRescanItems")
	ModEvent.PushString(i, "OnConfigOpen")
	ModEvent.Send(i)
	
	if lastActorCell!=PlayerRef.getParentCell()
		lastActorCell=PlayerRef.getParentCell()
		i = ModEvent.Create("ssxRescanActors")
		ModEvent.PushString(i, "OnConfigOpen")
		ModEvent.Send(i)
	endIf
	
	actorsSex = new int[5]
	curRuleIndex = -1
	isRuleEdit = false
	ruleEditIndex = -1
	ssxRunnerQuest.countRules()
	doTests=false
	
	i = 0
	while i < ssxRunnerQuest.rules.length
		SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
		if r.inUse!=0
			ssxRunnerQuest.checkRuleIDs(r, Self)
		endIf
		i+=1
	endWhile
	
	if !ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnSLENFix())
		check = false
		i = ssxRunnerQuest.rules.length
		while i
			i -= 1
			SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
			if r.inUse==2 && r.getAskBeforeSex()==1
				check = true
				i = 0
			endIf
		endWhile
		if check
			; Check SexLab Eager NPCs load order
			int slenOrder = Game.GetModByName("SexLab Eager NPCs.esp")
			int ssxOrder = Game.GetModByName("Scent of Sex.esp")
			if slenOrder!=-1 && slenOrder!=255 && slenOrder>ssxOrder
				if !ShowMessage(ssxRunnerQuest.s("$SSX_SLENWarning", slenOrder, ssxOrder), true, ssxRunnerQuest.s("$SSX_SLENWIWIll"), ssxRunnerQuest.s("$SSX_SLENWNoAndDontBother"))
					ssxRunnerQuest.setDebug(SSX_Runner_Quest.notifDontBotherOnSLENFix(), true)
				else
					canIBeAskedSLENFix = false
				endIf
			else
				canIBeAskedSLENFix = true
			endIf
		else
			canIBeAskedSLENFix = true
		endIf
	endIf
	
	; Create the factionFilters array using the actual filter
	if factionFilter=="" ; All of them
		factionFilters = ssxRunnerQuest.mcmFactionNames
	else
		num=0
		i = ssxRunnerQuest.mcmFactionNames.length
		while i
			i-=1
			if ssxRunnerQuest.mcmFactionNames[i]!="" && StringUtil.find(ssxRunnerQuest.mcmFactionNames[i], factionFilter)!=-1
				num+=1
			endIf
		endWhile
		if num==0
			factionFilters = ssxRunnerQuest.mcmFactionNames
		else
			factionFilters = Utility.createStringArray(num)
			i = ssxRunnerQuest.mcmFactionNames.length
			num=0
			while i
				i-=1
				if ssxRunnerQuest.mcmFactionNames[i]!="" && StringUtil.find(ssxRunnerQuest.mcmFactionNames[i], factionFilter)!=-1
					factionFilters[num] = ssxRunnerQuest.mcmFactionNames[i]
					num+=1
				endIf
			endWhile
			PapyrusUtil.SortStringArray(factionFilters)
		endIf
	endIf
	prevFactionFilter = factionFilter

	ssxRunnerQuest.endT("MCM Opening")
EndEvent

Event OnConfigClose()
	if ssxRunnerQuest.iAmActive==-1
		return
	endIf

	if ssxRunnerQuest.iAmInitialized!=2
		return
	endIf

	if (ruleEditIndex>=0 && ruleEditIndex<ssxRunnerQuest.rules.length) && (editingLevel!=-1 || isRuleEdit)
		if (editingLevel==0 && ssxRunnerQuest.rules[ruleEditIndex].didAnyChange(editRuleL0)) || (editingLevel==1 && ssxRunnerQuest.rules[ruleEditIndex].didAnyChange(editRuleL1)) || (editingLevel==2 && ssxRunnerQuest.rules[ruleEditIndex].didAnyChange(editRuleL2))
			if ssxRunnerQuest.popUpNotSaved==1 ; Ask
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL0.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					saveTheRuleActually(true)
				else
					editingLevel=-1
				endIf
			elseIf ssxRunnerQuest.popUpNotSaved==2 ; Always save
				saveTheRuleActually(true)
			endIf
		endIf
	endIf

	areWeReLoading = false
	pageEditMode=0
	isRuleEdit = false
	ruleEditIndex=-1
	ssxRunnerQuest.updateAllNeededActors()
	ssxRunnerQuest.updateAllNeededRaces()
	int handle = ModEvent.Create("ssxUpdateConfig") 
	ModEvent.PushString(handle, "Save")
	ModEvent.PushString(handle, "OnConfigClose")
	ModEvent.Send(handle)
	
	if doTests
		ssxTestGuy.enable()
		(ssxTestGuy as SSX_Performance_Test_Actor).startTest()
		Debug.trace("[SSX] DEBUG: Performance test will start in about 5 seconds")
		doTests=false
	endIf
	
	ssxRunnerQuest.checkPlayerProtection()
EndEvent

Event OnPageReset(string a_page)
	if ssxRunnerQuest.isInitInProgress<100
		UnloadCustomContent()
		generateConfigLoading(a_page)
		return
	endIf
	
	if (a_page == "")
		LoadCustomContent("Scent of Sex/Scent of Sex.dds", 10, 14)
		areWeReLoading=false
		return
	endIf
	UnloadCustomContent()
	
	if ssxRunnerQuest.iAmInitialized==0
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetTitleText("Scent of Sex NOT Initialized")
		AddTextOption("The mod is not yet initialized","", OPTION_FLAG_DISABLED)
		AddTextOption("Probably because SexLab has not","", OPTION_FLAG_DISABLED)
		AddTextOption("completed the initialization.","", OPTION_FLAG_DISABLED)
		AddEmptyOption()
		AddEmptyOption()
		AddTextOption("Be sure you fully initilize SexLab","")
		pageOPTs[0]=AddTextOption("then click on:","INSTALL")
		pageEditMode=-1
		return
	elseIf ssxRunnerQuest.iAmInitialized==1
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetTitleText("Scent of Sex is initializing")
		AddTextOption("The mod is initializing,","", OPTION_FLAG_DISABLED)
		AddTextOption("please wait...","", OPTION_FLAG_DISABLED)
		AddEmptyOption()
		AddEmptyOption()
		pageOPTs[0]=AddTextOption("In case you want to force it, click:","INSTALL")
		pageEditMode=-1
		return
	endIf

	if ssxRunnerQuest.areItemsInProgress<1
		int i = ModEvent.Create("ssxRescanItems")
		ModEvent.PushString(i, "MCM")
		ModEvent.Send(i)
	endIf
	if ssxRunnerQuest.areActorsInProgress<1
		int i = ModEvent.Create("ssxRescanActors")
		ModEvent.PushString(i, "MCM")
		ModEvent.Send(i)
	endIf
	
	if ssxRunnerQuest.areTagsInProgress<0
		int i = ModEvent.Create("ssxRescanTags")
		ModEvent.PushString(i, "MCM")
		ModEvent.Send(i)
	endIf

	if doSanityCheck()
		return
	endIf
	
	clearPreviousOptions()
	
	if (editingLevel!=-1 || isRuleEdit) && a_page!=ssxRunnerQuest.s("$SSX_PageSexRules")
		if ruleEditIndex!=-1 && ssxRunnerQuest.rules[ruleEditIndex]
			if (editingLevel==0 && ssxRunnerQuest.rules[ruleEditIndex].didAnyChange(editRuleL0)) || (editingLevel==1 && ssxRunnerQuest.rules[ruleEditIndex].didAnyChange(editRuleL1)) || (editingLevel==2 && ssxRunnerQuest.rules[ruleEditIndex].didAnyChange(editRuleL2))
				if ssxRunnerQuest.popUpNotSaved==1 ; Ask
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL0.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					saveTheRuleActually(true)
				else
					editingLevel=-1
				endIf
				elseIf ssxRunnerQuest.popUpNotSaved==2 ; Always save
				saveTheRuleActually(true)
			endIf
			endIf
		endIf
	endIf
	
	If (a_page==ssxRunnerQuest.s("$SSX_PageMain"))
		if pageEditMode<0 || pageEditMode>9
			pageEditMode=0
		endIf
		generateMain()
		
	elseIf a_page==ssxRunnerQuest.s("$SSX_PageSexRules")
		if pageEditMode<10 || pageEditMode>29
			pageEditMode=10
		endIf
		generateSexRules()

	elseIf a_page==ssxRunnerQuest.s("$SSX_PageNudity")
		if pageEditMode<30 || pageEditMode>39
			pageEditMode=30
		endIf
		generateNudity()
		
	elseIf a_page==ssxRunnerQuest.s("$SSX_PageRaces")
		if pageEditMode<40 || pageEditMode>49
			pageEditMode=40
		endIf
		generateRaces()
	
	elseIf a_page==ssxRunnerQuest.s("$SSX_PageAnimations")
		if pageEditMode<60 || pageEditMode>69
			pageEditMode=60
		endIf
		generateAnims()
		
	elseIf a_page==ssxRunnerQuest.s("$SSX_PageActorsEditor")
		if pageEditMode<80 || pageEditMode>89
			pageEditMode=80
		endIf
		generateActorsEditor()

	elseIf a_page==ssxRunnerQuest.s("$SSX_PageDebug")
		if pageEditMode<70 || pageEditMode>79
			pageEditMode=70
		endIf
		if pageEditMode==70
			generateDebug()
		elseIf pageEditMode==71
			generateDebugAdv()
		elseIf pageEditMode==72
			generateHighlightActors()
		endIf
	endif
EndEvent


bool Function doSanityCheck()
{Checks if the arrays in the page are ALL initialized (not zero)}
	check=!pageOPTs || pageOPTs.length==0 || !tmpValInt || tmpValInt.length==0 || !tmpValString || tmpValString.length==0 || !ssxRunnerQuest.expertiseLevels || ssxRunnerQuest.expertiseLevels.length==0 || \
		!ssxRunnerQuest.scanModes || ssxRunnerQuest.scanModes.length==0 || !ssxRunnerQuest.yesNo || ssxRunnerQuest.yesNo.length==0 || !ssxRunnerQuest.relRanks || ssxRunnerQuest.relRanks.length==0 || !ssxRunnerQuest.genderModes || ssxRunnerQuest.genderModes.length==0 || \
		!ssxRunnerQuest.orientationModes || ssxRunnerQuest.orientationModes.length==0 || !ssxRunnerQuest.addGenderTagsMenu || ssxRunnerQuest.addGenderTagsMenu.length==0 || !ssxRunnerQuest.playerGenderTags || ssxRunnerQuest.playerGenderTags.length==0 || \
		!ssxRunnerQuest.filterRules || ssxRunnerQuest.filterRules.length==0 || !ssxRunnerQuest.numOfColls || ssxRunnerQuest.numOfColls.length==0 || !ssxRunnerQuest.whoWillBePassive || ssxRunnerQuest.whoWillBePassive.length==0 || \
		!ssxRunnerQuest.participantQuickSettingsNX || ssxRunnerQuest.participantQuickSettingsNX.length==0 || !ssxRunnerQuest.participantQuickSettingsLL || ssxRunnerQuest.participantQuickSettingsLL.length==0 || !ssxRunnerQuest.actTypes || ssxRunnerQuest.actTypes.length==0 || \
		!ssxRunnerQuest.sexActorValue || ssxRunnerQuest.sexActorValue.length==0 || !ssxRunnerQuest.followerOrNot || ssxRunnerQuest.followerOrNot.length==0 || !ssxRunnerQuest.humanOrCreature || ssxRunnerQuest.humanOrCreature.length==0 || \
		!ssxRunnerQuest.associationNames || ssxRunnerQuest.associationNames.length==0 || !ssxRunnerQuest.colors || ssxRunnerQuest.colors.length==0 || !ssxRunnerQuest.inCaseOfAggressiveness || ssxRunnerQuest.inCaseOfAggressiveness.length==0 || \
		!ssxRunnerQuest.raceInclusiveExclusive || ssxRunnerQuest.raceInclusiveExclusive.length==0 || !ssxRunnerQuest.stripModes || ssxRunnerQuest.stripModes.length==0 || !ssxRunnerQuest.requestDialogues || ssxRunnerQuest.requestDialogues.length==0 || \
		!ssxRunnerQuest.positiveAnswers || ssxRunnerQuest.positiveAnswers.length==0 || !ssxRunnerQuest.answerProbs || ssxRunnerQuest.answerProbs.length==0 || !ssxRunnerQuest.negativeAnswers || ssxRunnerQuest.negativeAnswers.length==0 || !ssxRunnerQuest.percs || ssxRunnerQuest.percs.length==0 || \
		!ssxRunnerQuest.npcFinalSentences || ssxRunnerQuest.npcFinalSentences.length==0 || !ssxRunnerQuest.whoIsVictim || ssxRunnerQuest.whoIsVictim.length==0 || \
		!ssxRunnerQuest.stopAllCombats || ssxRunnerQuest.stopAllCombats.length==0 || !ssxRunnerQuest.prob || ssxRunnerQuest.prob.length==0 || !ssxRunnerQuest.beds || ssxRunnerQuest.beds.length==0 || !ssxRunnerQuest.scaleActorsVals || ssxRunnerQuest.scaleActorsVals.length==0 || \
		!ssxRunnerQuest.locationList || ssxRunnerQuest.locationList.length==0 || !ssxRunnerQuest.locationTypeList || ssxRunnerQuest.locationTypeList.length==0 || !ssxRunnerQuest.intExtMnu || ssxRunnerQuest.intExtMnu.length==0 || !ssxRunnerQuest.startModes || ssxRunnerQuest.startModes.length==0 || \
		!ssxRunnerQuest.startsOnActorModes || ssxRunnerQuest.startsOnActorModes.length==0 || !ssxRunnerQuest.startsOnActorModesVal || ssxRunnerQuest.startsOnActorModesVal.length==0 || !ssxRunnerQuest.timeOfTheDay || ssxRunnerQuest.timeOfTheDay.length==0 || \
		!ssxRunnerQuest.importRulesMode || ssxRunnerQuest.importRulesMode.length==0 || !ssxRunnerQuest.nakedIf || ssxRunnerQuest.nakedIf.length==0 || !ssxRunnerQuest.armorKeywordIDs || ssxRunnerQuest.armorKeywordIDs.length==0 || \
		!ssxRunnerQuest.racesToFilter || ssxRunnerQuest.racesToFilter.length==0 || !ssxRunnerQuest.popUpName || ssxRunnerQuest.popUpName.length==0

		
	if check ; In case of failure
		SetCursorFillMode(TOP_TO_BOTTOM)
		SetTitleText("Strings not initialized!")
		AddTextOption("WARNING!", "", OPTION_FLAG_DISABLED)
		AddEmptyOption()
		AddTextOption("Some of the arrays for this page", "", OPTION_FLAG_DISABLED)
		AddTextOption("are NOT initialized.", "", OPTION_FLAG_DISABLED)
		AddEmptyOption()
		pageOPTs[0] = AddTextOption("Click here to reinit them:", "Click")
		pageEditMode=-2
	endIf
	return check
EndFunction

Function generateConfigLoading(String a_page)
	SetCursorFillMode(TOP_TO_BOTTOM)
	if ssxRunnerQuest.isConfigInProgress==-1 && ssxRunnerQuest.isInitInProgress==-1
		AddHeaderOption("Scent of Sex is NOT installed")
		return
	endIf
	
	Form SexLabQuestFramework = Game.GetFormFromFile(0xD62, "SexLab.esm")
	if !SexLabQuestFramework
		AddHeaderOption("SexLab is not installed!")
		return
	endIf
	SexLabFramework sl = SexLabQuestFramework as SexLabFramework
	sslSystemAlias SystemAlias = sl.GetNthAlias(0) as sslSystemAlias
	if !SystemAlias.IsInstalled	
		AddHeaderOption("SexLab is not fully installed!")
		AddEmptyOption()
		AddTextOption("Please complete SexLab installation", "", OPTION_FLAG_DISABLED)
		AddTextOption("before running this mod!", "", OPTION_FLAG_DISABLED)
		return
	endIf
	
	
	AddHeaderOption("Initialization in progress")
	AddTextOption("Please wait...", "", OPTION_FLAG_DISABLED)
	
	AddEmptyOption()
	AddEmptyOption()
	if ssxRunnerQuest.isInitInProgress<100
		if ssxRunnerQuest.isConfigInProgress==-1
			AddTextOption("Config Progress", "Not started", OPTION_FLAG_DISABLED)
		elseIf ssxRunnerQuest.isConfigInProgress<100
			AddTextOption("Config Progress", ssxRunnerQuest.isConfigInProgress + "%", OPTION_FLAG_DISABLED)
		else
			AddTextOption("Config Progress", "Completed!", OPTION_FLAG_DISABLED)
		endIf
		if ssxRunnerQuest.isInitInProgress<80
			AddTextOption("Init Progress", ssxRunnerQuest.isInitInProgress + "%", OPTION_FLAG_DISABLED)
		elseIf ssxRunnerQuest.isInitInProgress<100
			AddTextOption("Init Progress", ssxRunnerQuest.isInitInProgress + "%", OPTION_FLAG_DISABLED)
			AddTextOption("Now, it is safe to use the MCM", "", OPTION_FLAG_DISABLED)
		else
			AddTextOption("Init Progress", "Completed!", OPTION_FLAG_DISABLED)
		endIf
	else
		AddTextOption("Progress", "Completed!", OPTION_FLAG_DISABLED)
		ForcePageReset()
		return
	endIf
	if ssxRunnerQuest.isInitInProgress>=80 && ssxRunnerQuest.isConfigInProgress==100
		SetCursorPosition(20)
		AddTextOptionST("GoButton", "Start using the MCM", ssxRunnerQuest.s("$SSX_Go"))
		AddTextOptionST("RefreshButton", "Refresh the page", ssxRunnerQuest.s("$SSX_Refresh"))
	else
		SetCursorPosition(22)
		AddTextOptionST("RefreshButton", "Refresh the page", ssxRunnerQuest.s("$SSX_Refresh"))
	endIf
	
	SetCursorPosition(1)
	AddEmptyOption()
	AddTextOption("When the config will be at least at 80%", "", OPTION_FLAG_DISABLED)
	AddTextOption("a button to start using the MCM will show.", "", OPTION_FLAG_DISABLED)
	AddTextOption("But only after you click on refresh.", "", OPTION_FLAG_DISABLED)
	AddEmptyOption()
	AddTextOption("You can use other MCMs or play while waiting", "", OPTION_FLAG_DISABLED)
	SetCursorPosition(23)
	AddTextOption("-- This page does NOT update alone!", "", OPTION_FLAG_DISABLED)
EndFunction

Function generateMain() ; 0 (Main), 1 (General), 2 (Timers), 3 (Sexuality), 4 (Relationship), 5 (Faction Spells)
	if pageEditMode==0 ; Main ------------------------------------------------------------------------------------------------------------------------------------------------
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("Scent of Sex NG v" + getVersionString() + " by eldr3d & CPU")
		AddEmptyOption()
		if !ssxRunnerQuest.countRules()
			pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_NoActiveRulesMsg"), "")
			AddEmptyOption()
		elseIf ssxRunnerQuest.iAmActive==0
			pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_SexScentNotApplied"), ssxRunnerQuest.s("$SSX_SexScentApply"))
			AddKeyMapOptionST("SetKeyKM", "Key to quicky apply/remove", ssxRunnerQuest.ssxKeyCode)
		else
			pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_SexScentApplied"), ssxRunnerQuest.s("$SSX_SexScentRemove"))
			AddKeyMapOptionST("SetKeyKM", ssxRunnerQuest.s("$SSX_SexScentHotKey"), ssxRunnerQuest.ssxKeyCode)
		endIf
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_EditConfig"), ssxRunnerQuest.s("$SSX_Change"))
		endIf
		pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_EditTimers"), ssxRunnerQuest.s("$SSX_Change"))
		if ssxRunnerQuest.expertiseLevel>0
			pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_EditSexuality"), ssxRunnerQuest.s("$SSX_Change"))
			pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_EditRelationship"), ssxRunnerQuest.s("$SSX_Change"))
		endIf
		
		SetCursorPosition(1)
		pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_ExpertiseLevel"), ssxRunnerQuest.expertiseLevels[ssxRunnerQuest.expertiseLevel])
		AddEmptyOption()
		AddTextOption(ssxRunnerQuest.s("$SSX_RulesInfoCount"), ssxRunnerQuest.countRules() + "/" + ssxRunnerQuest.countRules(true) +"/" + ssxRunnerQuest.rules.length, OPTION_FLAG_DISABLED)
		pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$SSX_TotalNumberOfAnims"), ssxRunnerQuest.s("$SSX_Count"))
		AddEmptyOption()
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_ModeToScanActors"), ssxRunnerQuest.scanModes[ssxRunnerQuest.scanMode])
		endIf
		usedOptions=9
	elseIf pageEditMode==1 ; Edit General ------------------------------------------------------------------------------------------------------------------------------------------------
		SetTitleText("General")
		SetCursorFillMode(TOP_TO_BOTTOM)
		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_PriorityMode"), ssxRunnerQuest.priorityModes[ssxRunnerQuest.priorityMode])
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_SkipActorsInNamedScenes"), ssxRunnerQuest.yesNo[ssxRunnerQuest.skipActorsInNamedScenes])
		AddEmptyOption()
		pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_ForceStopCombats"), ssxRunnerQuest.forceStopCombatsMN[ssxRunnerQuest.forceStopCombats])
		pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_followersStayInBleedout"), ssxRunnerQuest.yesNo[ssxRunnerQuest.followersStayInBleedout])
		pageOPTs[11] = AddMenuOption(ssxRunnerQuest.s("$SSX_ProtectPlayerOnHealth"), ssxRunnerQuest.yesNo[ssxRunnerQuest.protectOnHealth])
		AddEmptyOption()
		pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$SSX_SortRules"), ssxRunnerQuest.s("$SSX_Sort"))
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel==2
			AddSliderOptionST("maxNumberOfRulesSL", ssxRunnerQuest.s("$SSX_MaxNumberOfRules"), ssxRunnerQuest.maxNumberOfRules)
		elseIf ssxRunnerQuest.expertiseLevel==1
			AddSliderOptionST("maxNumberOfRulesSL", ssxRunnerQuest.s("$SSX_MaxNumberOfRules"), ssxRunnerQuest.maxNumberOfRules, OPTION_FLAG_DISABLED)
		endIf
		if SexLab.AllowCreatures && !ssxRunnerQuest.nexusMode
			AddEmptyOption()
			pageOPTs[12] = AddMenuOption(ssxRunnerQuest.s("$SSX_SafeCheckOfConCAnims"), ssxRunnerQuest.yesNo[ssxRunnerQuest.safeCheckOfConCAnims])
		endIf
	
		SetCursorPosition(1)
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_PopupWhenDeletingRule"), ssxRunnerQuest.yesNo[ssxRunnerQuest.popUpDelRule])
		pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_PopupWhenRuleIsNotSaved"), ssxRunnerQuest.popUpName[ssxRunnerQuest.popUpNotSaved])
		pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_PopupIfRuleNameIsntUpdated"), ssxRunnerQuest.popUpName[ssxRunnerQuest.popUpNameNotUpated])
		if Game.GetModByName("SexLab Eager NPCs.esp")!=255 && Game.GetModByName("SexLab Eager NPCs.esp")!=-1
			pageOPTs[8] = AddToggleOption(ssxRunnerQuest.s("$SSX_DonBotherSLEN"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnSLENFix()))
		else
			pageOPTs[8] = AddToggleOption(ssxRunnerQuest.s("$SSX_DonBotherSLEN"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnSLENFix()), OPTION_FLAG_DISABLED)
		endIf
		if Game.GetModByName("SexLabDefeat.esp")!=255 && Game.GetModByName("SexLabDefeat.esp")!=-1
			pageOPTs[9] = AddToggleOption(ssxRunnerQuest.s("$SSX_DonBotherDefeat"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix()))
		else
			pageOPTs[9] = AddToggleOption(ssxRunnerQuest.s("$SSX_DonBotherDefeat"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix()), OPTION_FLAG_DISABLED)
		endIf
		SetCursorPosition(23)
		pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
		usedOptions=13

	
	elseIf pageEditMode==2 ; Edit Timers ------------------------------------------------------------------------------------------------------------------------------------------------
		SetTitleText("Timers and Scenes")
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditTimers"))
		if ssxRunnerQuest.expertiseLevel==2
			if ssxRunnerQuest.startRightAway==1
				pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_StartRightAwayYes"), ssxRunnerQuest.s("$SSX_Change"))
			else
				pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_StartRightAwayNo"), ssxRunnerQuest.s("$SSX_Change"))
			endIf
		else
			AddEmptyOption()
		endIf
		AddSliderOptionST("RescanCellTimeSL", ssxRunnerQuest.s("$SSX_RescanCellTime"), ssxRunnerQuest.rescanCellTime , "{0} secs")
		if ssxRunnerQuest.expertiseLevel==2
			pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_CheckingMode"), ssxRunnerQuest.checkingModes[ssxRunnerQuest.checkingMode])
		else
			AddEmptyOption()
		endIf
		if ssxRunnerQuest.checkingMode==0 || ssxRunnerQuest.expertiseLevel<2
			AddSliderOptionST("MinTimeSL", ssxRunnerQuest.s("$SSX_MinTime"), ssxRunnerQuest.ruleCheckerMinWaitTime , "{0} secs")
			AddSliderOptionST("MaxTimeSL", ssxRunnerQuest.s("$SSX_MaxTime"), ssxRunnerQuest.ruleCheckerMaxWaitTime , "{0} secs")
		else
			AddSliderOptionST("MinTimeSL", ssxRunnerQuest.s("$SSX_MinTime"), ssxRunnerQuest.ruleCheckerMinWaitTime , "{0} secs", OPTION_FLAG_DISABLED)
			AddSliderOptionST("MaxTimeSL", ssxRunnerQuest.s("$SSX_MaxTime"), ssxRunnerQuest.ruleCheckerMaxWaitTime , "{0} secs", OPTION_FLAG_DISABLED)
		endIf
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			AddSliderOptionST("MaxNumberOfParallelScenesSL", ssxRunnerQuest.s("$SSX_MaxNumberOfParallelScenes"), ssxRunnerQuest.maxNumberOfParallelScenes, "{0}")
		else
			AddEmptyOption()
			AddEmptyOption()
			ssxRunnerQuest.maxNumberOfParallelScenes = 1
		endIf
		AddEmptyOption()
		AddEmptyOption()
		pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))

		SetCursorPosition(1)
		AddHeaderOption(ssxRunnerQuest.s("$SSX_TimeOutsHeader"))
		AddSliderOptionST("maxSecondsToReachTargetSL", ssxRunnerQuest.s("$SSX_MaxSecondsToReachTarget"), ssxRunnerQuest.maxSecondsToReachTarget, "{0} secs")
		AddSliderOptionST("maxSecondsToAskSL", ssxRunnerQuest.s("$SSX_MaxSecondsToAsk"), ssxRunnerQuest.maxSecondsToAsk, "{0} secs")
		AddSliderOptionST("maxSecondsToReachDenialSL", ssxRunnerQuest.s("$SSX_MaxSecondsToDenial"), ssxRunnerQuest.maxSecondsToReachDenial, "{0} secs")
		AddSliderOptionST("maxSecondsToReachBedSL", ssxRunnerQuest.s("$SSX_MaxSecondsToBed"), ssxRunnerQuest.maxSecondsToReachBed, "{0} secs")
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel==2
			pageOPTs[2] = AddToggleOption(ssxRunnerQuest.s("$SSX_stopSceneInCaseOfTimeOuts"), ssxRunnerQuest.stopSceneInCaseOfTimeOuts==1)
			pageOPTs[3] = AddToggleOption(ssxRunnerQuest.s("$SSX_dontStopScenes"), ssxRunnerQuest.dontStopScenes==1)
		endIf
		usedOptions=5
		
	elseIf pageEditMode==3 ; Edit Sexuality ------------------------------------------------------------------------------------------------------------------------------------------------
		SetTitleText("Sexuality")
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditSexuality"))
		AddEmptyOption()
		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_GenderMode"), ssxRunnerQuest.genderModes[ssxRunnerQuest.genderMode])
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_PlayerOrientation"), ssxRunnerQuest.playerOrientations[ssxRunnerQuest.playerOrientation])
		; In case there are wrong configurations, force fix them (as both M&F)
		if ssxRunnerQuest.getSexBitsForType(0)>=ssxRunnerQuest.orientationModesC.length || ssxRunnerQuest.getSexBitsForType(0)>=ssxRunnerQuest.orientationModes.length
			ssxRunnerQuest.setSexBitsForType(0, 3)
		endIf
		if ssxRunnerQuest.getSexBitsForType(1)>=ssxRunnerQuest.orientationModesC.length || ssxRunnerQuest.getSexBitsForType(1)>=ssxRunnerQuest.orientationModes.length
			ssxRunnerQuest.setSexBitsForType(1, 3)
		endIf
		if ssxRunnerQuest.getSexBitsForType(2)>=ssxRunnerQuest.orientationModesC.length
			ssxRunnerQuest.setSexBitsForType(2, 3)
		endIf
		if ssxRunnerQuest.getSexBitsForType(3)>=ssxRunnerQuest.orientationModesC.length
			ssxRunnerQuest.setSexBitsForType(3, 3)
		endIf
		if SexLab.AllowCreatures && !ssxRunnerQuest.nexusMode
			pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_OrientationModeM"), ssxRunnerQuest.orientationModesC[ssxRunnerQuest.getSexBitsForType(0)]) ; Males
			pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_OrientationModeF"), ssxRunnerQuest.orientationModesC[ssxRunnerQuest.getSexBitsForType(1)]) ; Females
			pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_OrientationModeS"), ssxRunnerQuest.orientationModesC[ssxRunnerQuest.getSexBitsForType(2)]) ; Male Creatures
			pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_OrientationModeB"), ssxRunnerQuest.orientationModesC[ssxRunnerQuest.getSexBitsForType(3)]) ; Female Creatures
		else
			pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_OrientationModeM"), ssxRunnerQuest.orientationModes[ssxRunnerQuest.getSexBitsForType(0)]) ; Males
			pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_OrientationModeF"), ssxRunnerQuest.orientationModes[ssxRunnerQuest.getSexBitsForType(1)]) ; Females
		endIf
		
		pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_UseSLSexuality"), ssxRunnerQuest.yesNo[ssxRunnerQuest.useSLSexuality])
		AddEmptyOption()
		pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_ExcludeActorsWithCum"), ssxRunnerQuest.yesNo[ssxRunnerQuest.excludeActorsWithCum])

		SetCursorPosition(1)
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditFactionGroups"))
		if Math.LogicalAnd(ssxRunnerQuest.factionSpells, 1)==1 && PlayerRef.hasSpell(ssxAddToFactionGroup1)
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_RemoveFactionSpells"), ssxRunnerQuest.s("$SSX_Remove"))
			AddEmptyOption()
			pageOPTs[9] = AddMenuOption(ssxRunnerQuest.s("$SSX_ColorToHighlightGroup1"), ssxRunnerQuest.colors[ssxRunnerQuest.getFactionGroupColor(1)])
			pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_ColorToHighlightGroup2"), ssxRunnerQuest.colors[ssxRunnerQuest.getFactionGroupColor(2)])
			pageOPTs[11] = AddMenuOption(ssxRunnerQuest.s("$SSX_ColorToHighlightGroup3"), ssxRunnerQuest.colors[ssxRunnerQuest.getFactionGroupColor(3)])
			pageOPTs[12] = AddMenuOption(ssxRunnerQuest.s("$SSX_ColorToHighlightGroup4"), ssxRunnerQuest.colors[ssxRunnerQuest.getFactionGroupColor(4)])
			pageOPTs[13] = AddMenuOption(ssxRunnerQuest.s("$SSX_ColorToHighlightGroup5"), ssxRunnerQuest.colors[ssxRunnerQuest.getFactionGroupColor(5)])
		else
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_AddFactionSpells"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		SetCursorPosition(23)
		pageOPTs[14] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
		usedOptions=15
	
	elseIf pageEditMode==4 ; Edit Relationship ------------------------------------------------------------------------------------------------------------------------------------------------
		SetTitleText("Relationship")
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditRelationship"))
		AddEmptyOption()

		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_IncreaseSpeechcraftAskingForSex"), ssxRunnerQuest.yesNo[ssxRunnerQuest.increaseSpeechCraft])
		if ssxRunnerQuest.increaseSpeechCraft==0
			AddSliderOptionST("maxSpeechCraftLevelSL", ssxRunnerQuest.s("$SSX_MaximumSpeechcraftReachable"), ssxRunnerQuest.maxSpeechCraftLevel, "{0}", OPTION_FLAG_DISABLED)
		else
			AddSliderOptionST("maxSpeechCraftLevelSL", ssxRunnerQuest.s("$SSX_MaximumSpeechcraftReachable"), ssxRunnerQuest.maxSpeechCraftLevel, "{0}")
		endIf
		AddEmptyOption()
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_IncreaseRelationshipAskingForSex"), ssxRunnerQuest.yesNo[ssxRunnerQuest.IncreaseRelationShip])
		if ssxRunnerQuest.IncreaseRelationShip==0
			pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_MaximumRelationshipRank"), ssxRunnerQuest.relRanks[ssxRunnerQuest.maxRelationshipRank], OPTION_FLAG_DISABLED)
		else
			pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_MaximumRelationshipRank"), ssxRunnerQuest.relRanks[ssxRunnerQuest.maxRelationshipRank])
		endIf

		SetCursorPosition(22)
		pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
		usedOptions=5
	endIf
EndFunction

Function generateSexRules() ; -
	if pageEditMode==10 ; --- LIST OF RULES --- Show the list of rules
		generateSexRules_List()
		
	elseIf pageEditMode==11 ; --- RULE CREATION/EDITING ---
		generateSexRules_Edit()
	elseIf pageEditMode==12 ; --- RULE PARTICIPANTS ---
		generateSexRules_Participants()
	elseIf pageEditMode==13 ; --- RULE EDIT PARTICIPANTS ---
		generateSexRules_EditParticipant()
	elseIf pageEditMode==14 ; --- RULE ANIMATIONS AND TAGS INDIRECTION ---
		generateSexRules_AnimTags()
	elseIf pageEditMode==15 ; --- RULE RACE FILTERS ---
		generateSexRules_RaceFilters()
	elseIf pageEditMode==16 ; --- RULE WEARABLES ---
		generateSexRules_Wearables()
	elseIf pageEditMode==17 ; --- RULE INTERACTIONS AND DIALOGUES ---
		generateSexRules_Interactions()
	elseIf pageEditMode==18 ; --- RULE PROPERTIES ---
		generateSexRules_Properties()
	elseIf pageEditMode==19 ; --- RULE LOCATIONS ---
		generateSexRules_Locations()
	elseIf pageEditMode==20 ; --- RULE START MODE AND START FILTERS ---
		generateSexRules_StartFilters()
	elseIf pageEditMode==21 ; --- RULE IMPORT/EXPORT ---
		generateSexRules_ImportExport()
	elseIf pageEditMode==22 ; --- RULE CHECK ---
		generateSexRules_CheckRule()
	elseIf pageEditMode==23 ; --- RULE PARTICIPANT MODS ---
		generateSexRules_PositionMods()
	elseIf pageEditMode==24 ; --- RULE TAGS CONSENSUAL ---
		generateSexRules_AnimTags_ConsTags()
	elseIf pageEditMode==25 ; --- RULE TAGS AGGRESSIVE ---
		generateSexRules_AnimTags_AggrTags()
	elseIf pageEditMode==26 ; --- RULE TANIMATIONS CONSENSUAL ---
		generateSexRules_AnimTags_ConsAnims()
	elseIf pageEditMode==27 ; --- RULE ANIMATIONS AGGRESSIVE ---
		generateSexRules_AnimTags_AggrAnims()
	elseIf pageEditMode==28 ; --- RULE NEGATIVE FACTIONS ---
		generateSexRules_NegFactions()
	elseIf pageEditMode==29 ; --- RULE START MODE WEARABLES ---
		generateSexRules_StartWearables()
	endIf
EndFunction

Function generateSexRules_List() ; 10
	SetTitleText("Rules List")
	check=false
	SetCursorFillMode(TOP_TO_BOTTOM)
	if ssxRunnerQuest.countRules(true)==0
		; No rules, don't show the anims, just show a warning
		AddTextOption(ssxRunnerQuest.s("$SSX_WarningNoSexRulesAreDefined"), "", OPTION_FLAG_DISABLED)
		AddTextOption(ssxRunnerQuest.s("$SSX_UseAddButtonToCreateSexRule"), "", OPTION_FLAG_DISABLED)
	else
		numOpRules = 0
		int i = 0
		while i < ssxRunnerQuest.rules.length && numOpRules < 64
			SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
			String rStatus = ssxRunnerQuest.s("$SSX_RuleUndefined")
			If r.inUse==2 ; Enabled
				rStatus=""
			elseIf r.inUse==1 ; Disabled
				rStatus=ssxRunnerQuest.s("$SSX_RuleDisabled")
			endIf
			if rStatus!=ssxRunnerQuest.s("$SSX_RuleUndefined")
				if howToFilterRules==0 || \
					(howToFilterRules==1 && r.inUse==1) || \
					(howToFilterRules==2 && r.inUse==2) || \
					(howToFilterRules==3 && r.startsOn==0) || \
					(howToFilterRules==4 && r.startsOn==11) || \
					(howToFilterRules==5 && r.isStartingOn(1)) || \
					(howToFilterRules==6 && r.isStartingOn(4)) || \
					(howToFilterRules==7 && r.isStartingOn(11)) || \
					(howToFilterRules==8 && r.isStartingOn(12)) || \
					(howToFilterRules==9 && r.isStartingOn(8))
					pageOPTs[10 + numOpRules] = AddToggleOption(rStatus + r.name, numOpRules==curRuleIndex)
					tmpValInt[10 + numOpRules] = i
					if numOpRules==curRuleIndex && !check
						check=true
					endIf
					numOpRules += 1
				endIf
			endIf
			i += 1
		endWhile
		if !check
			curRuleIndex=-1
		endIf	
	endIf

	SetCursorPosition(1)
	pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_AddNewRule"), ssxRunnerQuest.s("$SSX_Add"))
	if check
		pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_EditCurrentRule"), ssxRunnerQuest.s("$SSX_Edit"))
		pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_DeleteCurrentRule"), ssxRunnerQuest.s("$SSX_Delete"))
		if ssxRunnerQuest.expertiseLevel==2
			pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_ImportExportRules"), ssxRunnerQuest.s("$SSX_Go"))
			pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_DuplicateCurrentRule"), ssxRunnerQuest.s("$SSX_Duplicate"))
		else
			AddEmptyOption()
			AddEmptyOption()
		endIf
		if ssxRunnerQuest.expertiseLevel>0
			if ssxRunnerQuest.rules[tmpValInt[10 + curRuleIndex]].inUse==1
				pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$SSX_EnableTheRule"), ssxRunnerQuest.s("$SSX_Enable"))
			else
				pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$SSX_DisableTheRule"), ssxRunnerQuest.s("$SSX_Disable"))
			endIf
		else
			AddEmptyOption()
		endIf
	else
		AddTextOption(ssxRunnerQuest.s("$SSX_EditCurrentRule"), "", OPTION_FLAG_DISABLED)
		AddTextOption(ssxRunnerQuest.s("$SSX_DeleteCurrentRule"), "", OPTION_FLAG_DISABLED)
		if ssxRunnerQuest.expertiseLevel==2
			pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_ImportExportRules"), ssxRunnerQuest.s("$SSX_Go"))
			AddTextOption(ssxRunnerQuest.s("$SSX_DuplicateCurrentRule"), "", OPTION_FLAG_DISABLED)
		else
			AddEmptyOption()
			AddEmptyOption()
		endIf
		if ssxRunnerQuest.expertiseLevel>0
			AddTextOption(ssxRunnerQuest.s("$SSX_EnableTheRule"), ssxRunnerQuest.s("$SSX_Enable"), OPTION_FLAG_DISABLED)
		else
			AddEmptyOption()
		endIf
	endIf
	AddEmptyOption()
	AddEmptyOption()
	if check
		pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_CountTheAnimations"), ssxRunnerQuest.s("$SSX_Count"))
	else
		AddTextOption(ssxRunnerQuest.s("$SSX_CountTheAnimations"), "", OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()
	if ssxRunnerQuest.expertiseLevel==2
		pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_ShowOnlyRulesThat"), ssxRunnerQuest.filterRules[howToFilterRules])
	else
		AddEmptyOption()
	endIf
	if ssxRunnerQuest.expertiseLevel>0
		if numOpRules>0
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_DeleteallRules"), ssxRunnerQuest.s("$SSX_Delete"))
		else
			AddTextOption(ssxRunnerQuest.s("$SSX_DeleteallRules"), "", OPTION_FLAG_DISABLED)
		endIf
	endIf
	usedOptions=10+numOpRules
EndFunction

Function generateSexRules_Edit() ; 11 L0 OK
	SetCursorFillMode(TOP_TO_BOTTOM)
	if isRuleEdit ; --- EDITING RULE --- Edit the current selected rule
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditingOfExistingRule"))
		SetTitleText("Rule Edit")
	else ; --- RULE CREATION --- Add new rule
		AddHeaderOption(ssxRunnerQuest.s("$SSX_CreationOfANewRule"))
		SetTitleText("Rule Creation")
	endIf
	AddInputOptionST("RuleNameINP", ssxRunnerQuest.s("$SSX_RuleName"), editRuleL0.name)
	pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_GenerateName"), ssxRunnerQuest.s("$SSX_Generate"))
	AddEmptyOption()

	pageOPTs[1] = AddTextOption(calculateParticipants(editRuleL0), "")
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_EditParticipants"), ssxRunnerQuest.s("$SSX_Edit"))
	AddEmptyOption()

	pageOPTs[3] = AddTextOption(calculateStartingMode(editRuleL0), "")
	pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleStartsOn"), ssxRunnerQuest.s("$SSX_Change"))
	AddEmptyOption()

	if editRuleL0.canOnlyBeAggressive()
		if editRuleL0.specificAnimAIDs!=""
			pageOPTs[5] = AddTextOption(ssxRunnerQuest.generateAnimNames(editRuleL0, true), "")
		else
			pageOPTs[5] = AddTextOption(calculateTagsMessage(editRuleL0, true), "")
		endIf
	else
		if editRuleL0.specificAnimIDs!=""
			pageOPTs[5] = AddTextOption(ssxRunnerQuest.generateAnimNames(editRuleL0, false), "")
		else
			pageOPTs[5] = AddTextOption(calculateTagsMessage(editRuleL0, false), "")
		endIf
	endIf
	pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_ChangeAnimTags"), ssxRunnerQuest.s("$SSX_Change"))

	SetCursorPosition(1)
	pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_ChangeRuleProperties"), ssxRunnerQuest.s("$SSX_Change"))
	AddEmptyOption()
	
	pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_EditInteractions"), ssxRunnerQuest.s("$SSX_Change"))
	AddEmptyOption()
	
	pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_ChangeRuleLocations"), ssxRunnerQuest.s("$SSX_Change"))
	AddEmptyOption()
	
	AddEmptyOption()
	AddEmptyOption()
	AddEmptyOption()

	pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_CountNumOfAnims"), ssxRunnerQuest.s("$SSX_Count"))
	pageOPTs[11] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveTheRule"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[12] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Exit"))
	usedOptions=13
EndFunction

Function generateSexRules_Participants() ; 12 L1 OK
	SetCursorFillMode(TOP_TO_BOTTOM)
	AddHeaderOption(ssxRunnerQuest.s("$SSX_EditParticipants"))
	SetTitleText("Rule Participants")
	AddEmptyOption()

	pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_Target", ssxRunnerQuest.getPositionShortName(editRuleL1, 0)), "")
	if ssxRunnerQuest.expertiseLevel>0
		pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_EditTarget"), ssxRunnerQuest.s("$SSX_Edit"))
	else
		AddEmptyOption()
	endIf
	pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_QuickTargetSettings"), ssxRunnerQuest.s("$SSX_Change"))
	AddEmptyOption()
	
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_Source", ssxRunnerQuest.getPositionShortName(editRuleL1, 1)), "")
	if ssxRunnerQuest.expertiseLevel>0
		pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_EditSource"), ssxRunnerQuest.s("$SSX_Edit"))
	else
		AddEmptyOption()
	endIf
	pageOPTs[11] = AddMenuOption(ssxRunnerQuest.s("$SSX_QuickSourceSettings"), ssxRunnerQuest.s("$SSX_Change"))
	
	SetCursorPosition(1)
	pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$SSX_Collaborator", ssxRunnerQuest.getPositionShortName(editRuleL1, 2)), "")
	if ssxRunnerQuest.expertiseLevel>0
		pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$SSX_EditCollaborator"), ssxRunnerQuest.s("$SSX_Edit"))
	else
		AddEmptyOption()
	endIf
	pageOPTs[12] = AddMenuOption(ssxRunnerQuest.s("$SSX_QuickCollaboratorSettings"), ssxRunnerQuest.s("$SSX_Change"))
	AddEmptyOption()
	if editRuleL1.isNobody(2)
		pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_NumberOfCollaborators"), ssxRunnerQuest.numOfColls[0], OPTION_FLAG_DISABLED)
	else
		pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_NumberOfCollaborators"), ssxRunnerQuest.numOfColls[editRuleL1.getNumColls()])
		pageOPTs[13] = AddToggleOption(ssxRunnerQuest.s("$SSX_OptionalCollaborators"), editRuleL1.getOptionalCollaborators())
	endIf
	if ssxRunnerQuest.expertiseLevel==2
		AddEmptyOption()
		if !editRuleL1.isNobody(1) || !editRuleL1.isNobody(2)
			pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_WhoPlaysThePassiveRole"), ssxRunnerQuest.whoWillBePassive[editRuleL1.passiveIs])
		endIf
	else
		AddEmptyOption()
	endIf
	
	SetCursorPosition(21)
	pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Exit"))
	usedOptions=14
EndFunction

Function generateSexRules_EditParticipant() ; 13 L2 OK
	if ssxRunnerQuest.areActorsInProgress<100
		AddTextOptionST("RefreshButton", "Actors and Factions are updating... " + ssxRunnerQuest.areActorsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
		return
	endIf

	SetTitleText("Edit Rule Participant")
	SetCursorFillMode(TOP_TO_BOTTOM)
	if positionEdited==SSX_Rule_Alias.targetPosition() ; Target
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditingOfRuleTarget"))
	elseIf positionEdited==SSX_Rule_Alias.sourcePosition() ; Source
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditingOfRuleSource"))
	elseIf positionEdited==SSX_Rule_Alias.collaboratorPosition() ; Collaborator
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditingOfRuleCollaborator"))
	endIf
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositionType"), ssxRunnerQuest.actTypes[editRuleL2.getType(positionEdited)])
	AddEmptyOption()

	if editRuleL2.isNobody(positionEdited) || editRuleL2.isPlayer(positionEdited) || editRuleL2.isSpecific(positionEdited)
		pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_ActorSexMN"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
		pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_FollowerOrNotMN"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
		pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_HumanOrCreatureMN"), ssxRunnerQuest.s("$SSX_Human"), OPTION_FLAG_DISABLED)
	else
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_ActorSexMN"), ssxRunnerQuest.sexActorValue[editRuleL2.getSex(positionEdited) - 1])
		pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_FollowerOrNotMN"), ssxRunnerQuest.followerOrNot[editRuleL2.getFellowship(positionEdited) - 1])
		if SexLab.AllowCreatures && !ssxRunnerQuest.nexusMode
			pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_HumanOrCreatureMN"), ssxRunnerQuest.humanOrCreature[editRuleL2.getHumanity(positionEdited) - 1])
		else
			if !ssxRunnerQuest.nexusMode
				pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_HumanOrCreatureMN"), ssxRunnerQuest.s("$SSX_Human"), OPTION_FLAG_DISABLED)
			else
				AddEmptyOption()
			endIf
		endIf
	endIf
	AddEmptyOption()
	if ssxRunnerQuest.expertiseLevel==2
		if editRuleL2.isNobody(positionEdited)
			pageOPTs[4] = AddToggleOption(ssxRunnerQuest.s("$SSX_DontInvolveMe"), false, OPTION_FLAG_DISABLED)
		else
			pageOPTs[4] = AddToggleOption(ssxRunnerQuest.s("$SSX_DontInvolveMe"), tmpValInt[1]==1)
		endIf
	else
		AddEmptyOption()
	endIf
	
	if editRuleL2.isNobody(positionEdited) || editRuleL2.isPlayer(positionEdited)
		pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$SSX_EditTheFiltersOnRaces"), ssxRunnerQuest.s("$SSX_Edit"), OPTION_FLAG_DISABLED)
	else
		pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$SSX_EditTheFiltersOnRaces"), ssxRunnerQuest.s("$SSX_Edit"))
	endIf
	if editRuleL2.isNobody(positionEdited) || editRuleL2.isPlayer(positionEdited)
		pageOPTs[17] = AddTextOption(ssxRunnerQuest.s("$SSX_EditTheFiltersOnFactions"), ssxRunnerQuest.s("$SSX_Edit"), OPTION_FLAG_DISABLED)
	else
		pageOPTs[17] = AddTextOption(ssxRunnerQuest.s("$SSX_EditTheFiltersOnFactions"), ssxRunnerQuest.s("$SSX_Edit"))
	endIf	
	if editRuleL2.isNobody(positionEdited)
		pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_EditTheWearables"), ssxRunnerQuest.s("$SSX_Edit"), OPTION_FLAG_DISABLED)
	else
		pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_EditTheWearables"), ssxRunnerQuest.s("$SSX_Edit"))
	endIf
	if editRuleL2.isNobody(positionEdited) || editRuleL2.isPlayer(positionEdited)
		pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_EditPositionMods"), ssxRunnerQuest.s("$SSX_Edit"), OPTION_FLAG_DISABLED)
	else
		pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_EditPositionMods"), ssxRunnerQuest.s("$SSX_Edit"))
	endIf
	
	SetCursorPosition(1)
	AddEmptyOption()
	; Factions, Specific, Relationship values
	if editRuleL2.isSpecific(positionEdited)
		pageOPTs[8] = AddTextOption(ssxRunnerQuest.getPositionValues(editRuleL2, positionEdited), "", OPTION_FLAG_DISABLED)
		pageOPTs[9] = AddTextOption(ssxRunnerQuest.getPositionShortName(editRuleL2, positionEdited), "")
		pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_PickAnActor"), ssxRunnerQuest.mcmActorNames[tmpValInt[0]])
		pageOPTs[11] = AddTextOption(ssxRunnerQuest.s("$SSX_AddThisActor"), ssxRunnerQuest.s("$SSX_Add"))
		pageOPTs[12] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearActors"), ssxRunnerQuest.s("$SSX_Clear"))
	
	elseIf editRuleL2.isFaction(positionEdited)
		pageOPTs[8] = AddTextOption(ssxRunnerQuest.getPositionValues(editRuleL2, positionEdited), "", OPTION_FLAG_DISABLED)
		pageOPTs[9] = AddTextOption(ssxRunnerQuest.getPositionShortName(editRuleL2, positionEdited), "")
		AddInputOptionST("factionFilterINP", ssxRunnerQuest.s("$SSX_FactionsFilter"), factionFilter)
		if tmpValInt[0]>-1 && tmpValInt[0]<factionFilters.length
			pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_PickAFaction"), factionFilters[tmpValInt[0]])
		else
			pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_PickAFaction"), "")
		endIf
		pageOPTs[11] = AddTextOption(ssxRunnerQuest.s("$SSX_AddThisFaction"), ssxRunnerQuest.s("$SSX_Add"))
		pageOPTs[12] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearFaction"), ssxRunnerQuest.s("$SSX_Clear"))

	elseIf editRuleL2.isRelationship(positionEdited)
		pageOPTs[8] = AddTextOption(ssxRunnerQuest.getPositionValues(editRuleL2, positionEdited), "", OPTION_FLAG_DISABLED)
		pageOPTs[9] = AddTextOption(ssxRunnerQuest.getPositionShortName(editRuleL2, positionEdited), "")
		pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_PickARelationship"), ssxRunnerQuest.associationNames[tmpValInt[0]])
		pageOPTs[11] = AddTextOption(ssxRunnerQuest.s("$SSX_AddThisRelationship"), ssxRunnerQuest.s("$SSX_Add"))
		pageOPTs[12] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearRelationship"), ssxRunnerQuest.s("$SSX_Clear"))

	else
		AddEmptyOption()
		AddEmptyOption()
		AddEmptyOption()
		AddEmptyOption()
	endIf
	AddEmptyOption()
	if ssxRunnerQuest.expertiseLevel==2
		pageOPTs[13] = AddMenuOption(ssxRunnerQuest.s("$SSX_ColorToHighlightGood"), ssxRunnerQuest.colors[editRuleL2.getHighlightColor(positionEdited, true)])
		pageOPTs[14] = AddMenuOption(ssxRunnerQuest.s("$SSX_ColorToHighlightBad"), ssxRunnerQuest.colors[editRuleL2.getHighlightColor(positionEdited, false)])
	endIf
	
	SetCursorPosition(21)
	pageOPTs[15] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[16] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Exit"))
	usedOptions=18
EndFunction

Function generateSexRules_AnimTags() ; 14 L1 Indirection page
	SetTitleText("Define Animations or Tags for the Rule")
	SetCursorFillMode(TOP_TO_BOTTOM)

	; Do we have anims or tags?
	String goOrEdit
	if editRuleL1.canOnlyBeAggressive()
		pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsForConsensualConsequences"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
	else
		if editRuleL1.specificAnimIDs==""
			if editRuleL1.tags=="" && editRuleL1.avoid==""
				goOrEdit=ssxRunnerQuest.s("$SSX_Go")
			else
				goOrEdit=ssxRunnerQuest.s("$SSX_Edit")
			endIf
		else
			goOrEdit=ssxRunnerQuest.s("$SSX_Go")
		endIf
		pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsForConsensualConsequences"), goOrEdit)
	endIf
	if !ssxRunnerQuest.nexusMode && ssxRunnerQuest.expertiseLevel>0
		if editRuleL1.canBeAggressive()
			if editRuleL1.specificAnimAIDs==""
				if editRuleL1.tagsA=="" && editRuleL1.avoidA==""
					goOrEdit=ssxRunnerQuest.s("$SSX_Go")
				else
					goOrEdit=ssxRunnerQuest.s("$SSX_Edit")
				endIf
			else
				goOrEdit=ssxRunnerQuest.s("$SSX_Go")
			endIf
			pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsForAggressiveConsequences"), goOrEdit)
		else
			pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsForAggressiveConsequences"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
		endIf
	endIf
	AddEmptyOption()
	
	if editRuleL1.canOnlyBeAggressive()
		pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_SpecificAnimsForConsConsequences"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
	else
		if editRuleL1.specificAnimIDs==""
			goOrEdit=ssxRunnerQuest.s("$SSX_Go")
		else
			goOrEdit=ssxRunnerQuest.s("$SSX_Edit")
		endIf
		pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_SpecificAnimsForConsConsequences"), goOrEdit)
	endIf
	if !ssxRunnerQuest.nexusMode
		if editRuleL1.canBeAggressive() && !ssxRunnerQuest.nexusMode
			if editRuleL1.specificAnimAIDs==""
				goOrEdit=ssxRunnerQuest.s("$SSX_Go")
			else
				goOrEdit=ssxRunnerQuest.s("$SSX_Edit")
			endIf
			pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_SpecificAnimsForAggrConsequences"), goOrEdit)
		else
			pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_SpecificAnimsForAggrConsequences"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
		endIf
	endIf
	AddEmptyOption()
	AddEmptyOption()
	if !ssxRunnerQuest.nexusMode
		pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_InCaseOfAggressiveness"), StringUtil.substring(ssxRunnerQuest.inCaseOfAggressiveness[editRuleL1.aggressiveTagReqired()], 0, 16))
	endIf
	
	SetCursorPosition(20)
	pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Exit"))

	SetCursorPosition(1)
	if editRuleL1.canBeAggressive()
		if editRuleL1.canOnlyBeAggressive()
			pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleIsOnlyAggressive"), "", OPTION_FLAG_DISABLED)
		else
			pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleCanBeAggressive"), "", OPTION_FLAG_DISABLED)
		endIf
		AddEmptyOption()
		if (editRuleL1.getPercRape()>0 && editRuleL1.getPercRapeAggr()>0)
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleCanBeAggressiveForRapes"), "", OPTION_FLAG_DISABLED)
			AddEmptyOption()
		endIf
		if !editRuleL1.canOnlyBeAggressive()
			if editRuleL1.specificAnimIDs!=""
				pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingSpecAnimsForConsensual"), "", OPTION_FLAG_DISABLED)
				pageOPTs[9] = AddTextOption(ssxRunnerQuest.generateAnimNames(editRuleL1, false), "", OPTION_FLAG_DISABLED)
			elseIf editRuleL1.tags!=""
				pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingTagsForConsensual"), "", OPTION_FLAG_DISABLED)
				pageOPTs[8] = AddTextOption(calculateTagsMessage(editRuleL1, false), "", OPTION_FLAG_DISABLED)
			else
				pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingNothingForConsensual"), "", OPTION_FLAG_DISABLED)
			endIf
		endIf
		AddEmptyOption()
		if editRuleL1.specificAnimAIDs!=""
			pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingSpecAnimsForAggressive"), "", OPTION_FLAG_DISABLED)
			pageOPTs[11] = AddTextOption(ssxRunnerQuest.generateAnimNames(editRuleL1, true), "", OPTION_FLAG_DISABLED)
		elseIf editRuleL1.tagsA!=""
			pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingTagsForAggressive"), "", OPTION_FLAG_DISABLED)
			pageOPTs[11] = AddTextOption(calculateTagsMessage(editRuleL1, true), "", OPTION_FLAG_DISABLED)
		else
			pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingNothingForAggressive"), "", OPTION_FLAG_DISABLED)
		endIf
	else
		pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleIsConsensualOnly"), "", OPTION_FLAG_DISABLED)
		AddEmptyOption()
		if editRuleL1.specificAnimIDs!=""
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingSpecAnimsForConsensual"), "", OPTION_FLAG_DISABLED)
			pageOPTs[9] = AddTextOption(ssxRunnerQuest.generateAnimNames(editRuleL1, false), "", OPTION_FLAG_DISABLED)
		elseIf editRuleL1.tags!=""
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingTagsForConsensual"), "", OPTION_FLAG_DISABLED)
			pageOPTs[9] = AddTextOption(calculateTagsMessage(editRuleL1, false), "", OPTION_FLAG_DISABLED)
		else
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleUsingNothingForConsensual"), "", OPTION_FLAG_DISABLED)
		endIf
	endIf
	usedOptions=12
EndFunction

Function generateSexRules_AnimTags_ConsTags() ; 24 L2 Tags for consensual (or not expert)
	if ssxRunnerQuest.areTagsInProgress<100
		AddTextOptionST("RefreshButton", "Tags are updating... " + ssxRunnerQuest.areTagsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
		return
	endIf

	SetTitleText(ssxRunnerQuest.s("$SSX_TagsConsensualTitle"))
	SetCursorFillMode(TOP_TO_BOTTOM)
	int h = editRuleL2.getHumanityFullVal()
	if h==2
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), ssxRunnerQuest.s("$SSX_WithCreatures", OPTION_FLAG_DISABLED))
	elseIf h==1
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), ssxRunnerQuest.s("$SSX_OnlyHumans"), OPTION_FLAG_DISABLED)
	else
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), "", OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()

	if ssxRunnerQuest.numTags==0 ; Check if the tags are loaded
		if !ssxRunnerQuest.allTags && ssxRunnerQuest.areTagsInProgress==-1
			SendModEvent("ssxRescanTags")
			Utility.waitMenuMode(2.0)
			ForcePageReset()
			return
		endIf
		AddHeaderOption(ssxRunnerQuest.s("$SSX_WaitLoadingTags", ssxRunnerQuest.areTagsInProgress))
		Utility.waitMenuMode(2.0)
		ForcePageReset()
		return
	endIf
	; left --
	check = StringUtil.find(editRuleL2.tags, ",")!=-1
	if editRuleL2.allTagsRequired(false) && check
		pageOPTs[0] = AddToggleOption(ssxRunnerQuest.s("$SSX_PossibleTags", editRuleL2.tags), tmpValInt[0]==0)
	else
		pageOPTs[0] = AddToggleOption(ssxRunnerQuest.s("$SSX_RequiredTags", editRuleL2.tags), tmpValInt[0]==0)
	endIf
	if check && tmpValInt[0]==0
		if editRuleL2.allTagsRequired(false)
			pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsAndOrOR"), ssxRunnerQuest.s("$SSX_Change"))
		else
			pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsAndOrAND"), ssxRunnerQuest.s("$SSX_Change"))
		endIf
	else
		pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsAndOrAND"), "", OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()
	pageOPTs[2] = AddToggleOption(ssxRunnerQuest.s("$SSX_TagsToAvoid", editRuleL2.avoid), tmpValInt[0]==1)
	AddEmptyOption()
	AddEmptyOption()
	if ssxRunnerQuest.expertiseLevel>0
		pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_AddGenderTags"), ssxRunnerQuest.addGenderTagsMenu[editRuleL2.genderTagMode(false)])
		pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$ssx_playergendertags"), ssxRunnerQuest.playerGenderTags[editRuleL2.playerGenderTagMode(false)])
	endIf
	; right
	SetCursorPosition(1)
	if tmpValInt[0]!=0 && tmpValInt[0]!=1 ; Disabled
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_TagForTheAnimation"), ssxRunnerQuest.allTags[tmpValInt[5]], OPTION_FLAG_DISABLED)
		pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownR"), ssxRunnerQuest.s("$SSX_Add"), OPTION_FLAG_DISABLED)
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			AddInputOptionST("TagNameINP", ssxRunnerQuest.s("$SSX_TypeTheTagNameHere"), tmpValString[7], OPTION_FLAG_DISABLED)
			pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownR"), ssxRunnerQuest.s("$SSX_Add"), OPTION_FLAG_DISABLED)
		else
			AddEmptyOption()
			AddEmptyOption()
		endIf
		AddEmptyOption()
		pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearTagsR"), ssxRunnerQuest.s("$SSX_Clear"), OPTION_FLAG_DISABLED)

	elseIf tmpValInt[0]==0 ; Required/Possible
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_TagForTheAnimation"), ssxRunnerQuest.allTags[tmpValInt[5]])
		if editRuleL2.allTagsRequired(false)
			pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownP"), ssxRunnerQuest.s("$SSX_Add"))
		else
			pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownR"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			AddInputOptionST("TagNameINP", ssxRunnerQuest.s("$SSX_TypeTheTagNameHere"), tmpValString[7])
			if editRuleL2.allTagsRequired(false)
				pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownP"), ssxRunnerQuest.s("$SSX_Add"))
			else
				pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownR"), ssxRunnerQuest.s("$SSX_Add"))
			endIf
		else
			AddEmptyOption()
			AddEmptyOption()
		endIf
		AddEmptyOption()
		if editRuleL2.allTagsRequired(false)
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearTagsP"), ssxRunnerQuest.s("$SSX_Clear"))
		else
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearTagsR"), ssxRunnerQuest.s("$SSX_Clear"))
		endIf

	else ; Avoid
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_TagForTheAnimation"), ssxRunnerQuest.allTags[tmpValInt[5]])
		pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownA"), ssxRunnerQuest.s("$SSX_Add"))
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			AddInputOptionST("TagNameINP", ssxRunnerQuest.s("$SSX_TypeTheTagNameHere"), tmpValString[7])
			pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownA"), ssxRunnerQuest.s("$SSX_Add"))
		else
			AddEmptyOption()
			AddEmptyOption()
		endIf
		AddEmptyOption()
		pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearTagsA"), ssxRunnerQuest.s("$SSX_Clear"))
	
	endIf
	
	SetCursorPosition(17)
	pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_CountNumOfAnims"), ssxRunnerQuest.s("$SSX_Count"))
	pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[11] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Exit"))
	usedOptions=13
EndFunction

Function generateSexRules_AnimTags_AggrTags() ; 25 L2 Tags for aggressive
	if ssxRunnerQuest.areTagsInProgress<100
		AddTextOptionST("RefreshButton", "Tags are updating... " + ssxRunnerQuest.areTagsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
		return
	endIf

	SetTitleText(ssxRunnerQuest.s("$SSX_TagsAggressiveTitle"))
	SetCursorFillMode(TOP_TO_BOTTOM)
	int h = editRuleL2.getHumanityFullVal()
	if h==2
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), ssxRunnerQuest.s("$SSX_WithCreatures", OPTION_FLAG_DISABLED))
	elseIf h==1
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), ssxRunnerQuest.s("$SSX_OnlyHumans"), OPTION_FLAG_DISABLED)
	else
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), "", OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()

	if ssxRunnerQuest.numTags==0 ; Check if the tags are loaded
		if !ssxRunnerQuest.allTags && ssxRunnerQuest.areTagsInProgress==-1
			SendModEvent("ssxRescanTags")
			Utility.waitMenuMode(2.0)
			ForcePageReset()
			return
		endIf
		AddHeaderOption(ssxRunnerQuest.s("$SSX_WaitLoadingTags", ssxRunnerQuest.areTagsInProgress))
		Utility.waitMenuMode(2.0)
		ForcePageReset()
		return
	endIf
	; left --
	check = StringUtil.find(editRuleL2.tagsA, ",")!=-1
	if editRuleL2.allTagsRequired(true) && check
		pageOPTs[0] = AddToggleOption(ssxRunnerQuest.s("$SSX_PossibleTags", editRuleL2.tagsA), tmpValInt[0]==0)
	else
		pageOPTs[0] = AddToggleOption(ssxRunnerQuest.s("$SSX_RequiredTags", editRuleL2.tagsA), tmpValInt[0]==0)
	endIf
	if check && tmpValInt[0]==0
		if editRuleL2.allTagsRequired(true)
			pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsAndOrOR"), ssxRunnerQuest.s("$SSX_Change"))
		else
			pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsAndOrAND"), ssxRunnerQuest.s("$SSX_Change"))
		endIf
	else
		pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_TagsAndOrAND"), "", OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()
	pageOPTs[2] = AddToggleOption(ssxRunnerQuest.s("$SSX_TagsToAvoid", editRuleL2.avoidA), tmpValInt[0]==1)
	AddEmptyOption()
	AddEmptyOption()
	if ssxRunnerQuest.expertiseLevel>0
		pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_AddGenderTags"), ssxRunnerQuest.addGenderTagsMenu[editRuleL2.genderTagMode(true)])
		pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$ssx_playergendertags"), ssxRunnerQuest.playerGenderTags[editRuleL2.playerGenderTagMode(true)])
	endIf
	; right
	SetCursorPosition(1)
	if tmpValInt[0]!=0 && tmpValInt[0]!=1 ; Disabled
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_TagForTheAnimation"), ssxRunnerQuest.allTags[tmpValInt[5]], OPTION_FLAG_DISABLED)
		pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownR"), ssxRunnerQuest.s("$SSX_Add"), OPTION_FLAG_DISABLED)
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			AddInputOptionST("TagNameINP", ssxRunnerQuest.s("$SSX_TypeTheTagNameHere"), tmpValString[7], OPTION_FLAG_DISABLED)
			pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownR"), ssxRunnerQuest.s("$SSX_Add"), OPTION_FLAG_DISABLED)
		else
			AddEmptyOption()
			AddEmptyOption()
		endIf
		AddEmptyOption()
		pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearTagsR"), ssxRunnerQuest.s("$SSX_Clear"), OPTION_FLAG_DISABLED)

	elseIf tmpValInt[0]==0 ; Required/Possible
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_TagForTheAnimation"), ssxRunnerQuest.allTags[tmpValInt[5]])
		if editRuleL2.allTagsRequired(true)
			pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownP"), ssxRunnerQuest.s("$SSX_Add"))
		else
			pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownR"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			AddInputOptionST("TagNameINP", ssxRunnerQuest.s("$SSX_TypeTheTagNameHere"), tmpValString[7])
			if editRuleL2.allTagsRequired(true)
				pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownP"), ssxRunnerQuest.s("$SSX_Add"))
			else
				pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownR"), ssxRunnerQuest.s("$SSX_Add"))
			endIf
		else
			AddEmptyOption()
			AddEmptyOption()
		endIf
		AddEmptyOption()
		if editRuleL2.allTagsRequired(true)
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearTagsP"), ssxRunnerQuest.s("$SSX_Clear"))
		else
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearTagsR"), ssxRunnerQuest.s("$SSX_Clear"))
		endIf

	else ; Avoid
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_TagForTheAnimation"), ssxRunnerQuest.allTags[tmpValInt[5]])
		pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownA"), ssxRunnerQuest.s("$SSX_Add"))
		AddEmptyOption()
		if ssxRunnerQuest.expertiseLevel>0
			AddInputOptionST("TagNameINP", ssxRunnerQuest.s("$SSX_TypeTheTagNameHere"), tmpValString[7])
			pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_AddTagFromDropdownA"), ssxRunnerQuest.s("$SSX_Add"))
		else
			AddEmptyOption()
			AddEmptyOption()
		endIf
		AddEmptyOption()
		pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearTagsA"), ssxRunnerQuest.s("$SSX_Clear"))
	
	endIf
	
	SetCursorPosition(17)
	pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_CountNumOfAnims"), ssxRunnerQuest.s("$SSX_Count"))
	pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[11] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Exit"))
	usedOptions=13
EndFunction

Function generateSexRules_AnimTags_ConsAnims() ; 26 L2 Anims for consensual (or not expert)
	if ssxRunnerQuest.areTagsInProgress<100
		AddTextOptionST("RefreshButton", "Tags are updating... " + ssxRunnerQuest.areTagsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
		return
	endIf

	SetTitleText(ssxRunnerQuest.s("$SSX_AnimsConsensualTitle"))
	SetCursorFillMode(TOP_TO_BOTTOM)
	int h = editRuleL2.getHumanityFullVal()
	if h==2
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), ssxRunnerQuest.s("$SSX_WithCreatures", OPTION_FLAG_DISABLED))
	elseIf h==1
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), ssxRunnerQuest.s("$SSX_OnlyHumans"), OPTION_FLAG_DISABLED)
	else
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), "", OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()
	sslBaseAnimation anim

	; left --
	; list of anims, selectable
	numOpRules = 0
	string[] parts = StringUtil.split(editRuleL2.specificAnimIDs, ";")
	int i = 0
	while i<parts.length && (20 + numOpRules)<124
		anim = SexLab.getAnimationByRegistry(parts[i])
		if !anim
			anim = SexLab.GetCreatureAnimationByRegistry(parts[i])
		endIf
		if anim && anim.name
			pageOPTs[20 + numOpRules] = AddTextOption(anim.name, ssxRunnerQuest.s("$SSX_Remove"))
			numOpRules+=1
		endIf
		i+=1
	endWhile
	if editRuleL2.specificAnimIDs==""
		AddTextOption(ssxRunnerQuest.s("$SSX_NoAnimsAdded"), "", OPTION_FLAG_DISABLED)
	endIf
	
	; right --
	SetCursorPosition(1)
	if ssxRunnerQuest.expertiseLevel>0
		AddInputOptionST("SearchAnimIDNameTag", ssxRunnerQuest.s("$SSX_NameOrID"), tmpValString[0]) ; text to find anims by name or tags
	endIf
	pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_SelectAnimationFromList"), ssxRunnerQuest.animNames[tmpValInt[1]]) ; drop down with anims
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_AddSelectedAnim"), ssxRunnerQuest.s("$SSX_Add")) ; add selected
	pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearAnimList"), ssxRunnerQuest.s("$SSX_Clear")); clear all
	AddEmptyOption()
	AddEmptyOption()
	
	if ssxRunnerQuest.expertiseLevel>0
		pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_AddGenderTags"), ssxRunnerQuest.addGenderTagsMenu[editRuleL2.genderTagMode(false)])
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$ssx_playergendertags"), ssxRunnerQuest.playerGenderTags[editRuleL2.playerGenderTagMode(false)])
	endIf

	SetCursorPosition(19)
	pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_CountNumOfAnims"), ssxRunnerQuest.s("$SSX_Count"))
	pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Exit"))
	usedOptions=21 + numOpRules
EndFunction

Function generateSexRules_AnimTags_AggrAnims() ; 27 L2 Anims for aggressive
	if ssxRunnerQuest.areTagsInProgress<100
		AddTextOptionST("RefreshButton", "Tags are updating... " + ssxRunnerQuest.areTagsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
		return
	endIf

	SetTitleText(ssxRunnerQuest.s("$SSX_AnimsAggressiveTitle"))
	SetCursorFillMode(TOP_TO_BOTTOM)
	int h = editRuleL2.getHumanityFullVal()
	if h==2
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), ssxRunnerQuest.s("$SSX_WithCreatures", OPTION_FLAG_DISABLED))
	elseIf h==1
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), ssxRunnerQuest.s("$SSX_OnlyHumans"), OPTION_FLAG_DISABLED)
	else
		AddTextOption(ssxRunnerQuest.s("$SSX_NumParticipant", editRuleL2.getNumPlayers()), "", OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()
	sslBaseAnimation anim

	; left --
	; list of anims, selectable
	numOpRules = 0
	string[] parts = StringUtil.split(editRuleL2.specificAnimAIDs, ";")
	int i = 0
	while i<parts.length && (20 + numOpRules)<124
		anim = SexLab.getAnimationByRegistry(parts[i])
		if !anim
			anim = SexLab.GetCreatureAnimationByRegistry(parts[i])
		endIf
		if anim && anim.name
			pageOPTs[20 + numOpRules] = AddTextOption(anim.name, ssxRunnerQuest.s("$SSX_Remove"))
			numOpRules+=1
		endIf
		i+=1
	endWhile
	if editRuleL2.specificAnimAIDs==""
		AddTextOption(ssxRunnerQuest.s("$SSX_NoAnimsAdded"), "", OPTION_FLAG_DISABLED)
	endIf
	
	; right --
	SetCursorPosition(1)
	if ssxRunnerQuest.expertiseLevel>0
		AddInputOptionST("SearchAnimIDNameTag", ssxRunnerQuest.s("$SSX_NameOrID"), tmpValString[0]) ; text to find anims by name or tags
	endIf
	pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_SelectAnimationFromList"), ssxRunnerQuest.animNames[tmpValInt[1]]) ; drop down with anims
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_AddSelectedAnim"), ssxRunnerQuest.s("$SSX_Add")) ; add selected
	pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearAnimList"), ssxRunnerQuest.s("$SSX_Clear")); clear all
	AddEmptyOption()
	AddEmptyOption()
	
	if ssxRunnerQuest.expertiseLevel>0
		pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_AddGenderTags"), ssxRunnerQuest.addGenderTagsMenu[editRuleL2.genderTagMode(true)])
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$ssx_playergendertags"), ssxRunnerQuest.playerGenderTags[editRuleL2.playerGenderTagMode(true)])
	endIf

	SetCursorPosition(19)
	pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_CountNumOfAnims"), ssxRunnerQuest.s("$SSX_Count"))
	pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Exit"))
	usedOptions=21 + numOpRules
EndFunction

Function generateSexRules_RaceFilters() ; 15 L2 OK
	if ssxRunnerQuest.areActorsInProgress<100
		Utility.waitMenuMode(0.1)
		if ssxRunnerQuest.areActorsInProgress<100
			Utility.waitMenuMode(0.2)
			if ssxRunnerQuest.areActorsInProgress<100
				Utility.waitMenuMode(0.4)
				if ssxRunnerQuest.areActorsInProgress<100
					Utility.waitMenuMode(0.8)
					if ssxRunnerQuest.areActorsInProgress<100
						AddTextOptionST("RefreshButton", "Races are updating... " + ssxRunnerQuest.areActorsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
						return
					endIf
				endIf
			endIf
		endIf
	endIf
	if ssxRunnerQuest.needToUpdateRaces()
		ssxRunnerQuest.updateValidRaces()
	endIf

	SetTitleText("Participant Race Filters")
	SetCursorFillMode(TOP_TO_BOTTOM)
	if positionEdited==SSX_Rule_Alias.targetPosition() ; Target
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditRaceFiltersFor", ssxRunnerQuest.s("$SSX_TheTarget")))
	elseIf positionEdited==SSX_Rule_Alias.sourcePosition() ; Source
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditRaceFiltersFor", ssxRunnerQuest.s("$SSX_TheSource")))
	elseIf positionEdited==SSX_Rule_Alias.collaboratorPosition() ; Collaborator
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditRaceFiltersFor", ssxRunnerQuest.s("$SSX_TheCollaborator")))
	endIf
	AddEmptyOption()
	String theRaces = editRuleL2.getRaceFilter(positionEdited)
	if theRaces!=""
		string[] parts = StringUtil.split(theRaces, ";")
		int i = 0
		; list of races
		while i<parts.length && (20 + i)<124
			pageOPTs[20 + i] = AddTextOption(parts[i], ssxRunnerQuest.s("$SSX_Remove"))
			tmpValString[20 + i] = parts[i]
			i+=1
		endWhile
	else
		AddTextOption(ssxRunnerQuest.s("$SSX_NoRaceFiltersAreDefined"), "", OPTION_FLAG_DISABLED)
	endIf

	; right
	SetCursorPosition(1)
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_RaceInclusiveExclusive"), ssxRunnerQuest.raceInclusiveExclusive[editRuleL2.getRaceMode(positionEdited)])
	AddEmptyOption()
	int i = editRuleL2.getHumanityPart(positionEdited)
	ssxRunnerQuest.updateValidRaces()
	if i==1 ; Humans
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_SelectRace"), ssxRunnerQuest.allValidRacesH[tmpValInt[1]])
	elseIf i==2 ; Creatures
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_SelectRace"), ssxRunnerQuest.allValidRacesC[tmpValInt[1]])
	else ; Both = 0
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_SelectRace"), ssxRunnerQuest.allValidRacesB[tmpValInt[1]])
	endIf
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRace"), ssxRunnerQuest.s("$SSX_Add"))
	pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearRaces"), ssxRunnerQuest.s("$SSX_Clear"))
	SetCursorPosition(23)
	pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
	usedOptions=pageOPTs.length
EndFunction

Function generateSexRules_Wearables() ; 16 L2 OK
	if ssxRunnerQuest.areItemsInProgress<100
		AddTextOptionST("RefreshButton", "Wearables are updating... " + ssxRunnerQuest.areItemsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
		return
	endIf

	SetTitleText("Participant Clothing")
	SetCursorFillMode(TOP_TO_BOTTOM)
	if positionEdited==SSX_Rule_Alias.targetPosition() ; Target
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditWearablesFor", ssxRunnerQuest.s("$SSX_TheTarget")))
	elseIf positionEdited==SSX_Rule_Alias.sourcePosition() ; Source
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditWearablesFor", ssxRunnerQuest.s("$SSX_TheSource")))
	elseIf positionEdited==SSX_Rule_Alias.collaboratorPosition() ; Collaborator
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditWearablesFor", ssxRunnerQuest.s("$SSX_TheCollaborator")))
	endIf
	AddEmptyOption()
	
	; Left **************
	; List wearables at start
	AddHeaderOption(ssxRunnerQuest.s("$ssx_towearatstart"))
	String[] wears = editRuleL2.getWearAtStart(positionEdited)
	if !wears || wears.length==0 || wears[0]==""
		pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_NoItemsDefinedForStart"), "", OPTION_FLAG_DISABLED)
	else
		int i = 0
		while i<wears.length && (20 + i)<124
			pageOPTs[10 + i] = AddTextOption(wears[i], ssxRunnerQuest.s("$SSX_Remove"))
			i+=1
		endWhile
	endIf
	; List wearables at end
	int i = 0
	AddHeaderOption(ssxRunnerQuest.s("$ssx_towearatend"))
	wears = editRuleL2.getWearAtEnd(positionEdited)
	if !wears || wears.length==0 || wears[0]==""
		pageOPTs[40] = AddTextOption(ssxRunnerQuest.s("$SSX_NoItemsDefinedForEnd"), "", OPTION_FLAG_DISABLED)
	else
		while i<wears.length && (40 + i)<124
			pageOPTs[40 + i] = AddTextOption(wears[i], ssxRunnerQuest.s("$SSX_Remove"))
			i+=1
		endWhile
	endIf
	
	; Right **************
	SetCursorPosition(1)
	; Pick
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$ssx_pickwearable"),  ssxRunnerQuest.currentArmorsNames[tmpValInt[0]])
	; Add to start
	pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$ssx_addatstart"), ssxRunnerQuest.s("$SSX_Add"))
	; Add to end
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$ssx_addatend"), ssxRunnerQuest.s("$SSX_Add"))
	; Clear start
	pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$ssx_clearwearablesstart"), ssxRunnerQuest.s("$SSX_Clear"))
	; Clear end
	pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$ssx_clearwearablesend"), ssxRunnerQuest.s("$SSX_Clear"))
	AddEmptyOption()
	; Stripping mode
	pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_StripOfMode"), ssxRunnerQuest.stripModes[editRuleL2.getStripMode(positionEdited)])
	SetCursorPosition(23)
	; Back
	pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))

	usedOptions=40 + i
EndFunction

Function generateSexRules_Interactions() ; 17 L1 OK
	SetCursorFillMode(TOP_TO_BOTTOM)
	SetTitleText("Rule Dialogues and Interactions")
	; Dialogues...
	AddHeaderOption(ssxRunnerQuest.s("$SSX_DialogueOptions"))
	if editRuleL1.startsByPlayerAsking()
		; Player ask dialogue
		;pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_AskMeBeforeSex"), ssxRunnerQuest.yesNo[editRuleL1.askMeBeforeSex])
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_PlayerAsksWith"), StringUtil.substring(ssxRunnerQuest.requestDialogues[editRuleL1.getDialogue(0)], 0, 16) + "...")
		pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_BaseAnswersOnSpeechCraft"), ssxRunnerQuest.yesNo[editRuleL1.getUseSpeechCraft()])
		pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositiveAnswer"), StringUtil.substring(ssxRunnerQuest.positiveAnswers[editRuleL1.getDialogue(1)], 0, 16) + "...")
		if editRuleL1.getUseSpeechCraft()
			pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositiveAnswerProb"), ssxRunnerQuest.answerProbs[editRuleL1.getAnswerProbability(true)], OPTION_FLAG_DISABLED)
		else
			pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositiveAnswerProb"), ssxRunnerQuest.answerProbs[editRuleL1.getAnswerProbability(true)])
		endIf
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_NegativeAnswer"), StringUtil.substring(ssxRunnerQuest.negativeAnswers[editRuleL1.getDialogue(2)], 0, 16) + "...")
		if editRuleL1.getUseSpeechCraft()
			pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_NegativeAnswerProb"), ssxRunnerQuest.answerProbs[editRuleL1.getAnswerProbability(false)], OPTION_FLAG_DISABLED)
		else
			pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_NegativeAnswerProb"), ssxRunnerQuest.answerProbs[editRuleL1.getAnswerProbability(false)])
		endIf
		if (editRuleL1.getAnswerProbability(false)!=4 && editRuleL1.getAnswerProbability(true)!=0) || editRuleL1.getUseSpeechCraft()
			if ssxRunnerQuest.nexusMode
				AddEmptyOption()
				AddEmptyOption()
			else
				pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_PlayerRapesOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercRape()])
				pageOPTs[8] = AddMenuOption(ssxRunnerQuest.s("$SSX_AggressivenessOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercRapeAggr()])
			endIf
			pageOPTs[9] = AddMenuOption(ssxRunnerQuest.s("$SSX_MasturbationOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercMast()])
		else
			if ssxRunnerQuest.nexusMode
				AddEmptyOption()
				AddEmptyOption()
			else
				pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_PlayerRapesOnDenials"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
				pageOPTs[8] = AddMenuOption(ssxRunnerQuest.s("$SSX_AggressivenessOnDenials"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
			endIf
			pageOPTs[9] = AddMenuOption(ssxRunnerQuest.s("$SSX_MasturbationOnDenials"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
		endIf
		pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_AnswerFinal"), StringUtil.substring(ssxRunnerQuest.npcFinalSentences[editRuleL1.getDialogue(3)], 0, 16) + "...")
		
	elseIf editRuleL1.isPlayerInvolved() && editRuleL1.getNumPlayers()>1
		; NPC asks player
		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_AskMeBeforeSex"), ssxRunnerQuest.yesNo[editRuleL1.getAskBeforeSex()])
		if editRuleL1.getAskBeforeSex()
			pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_NPCAsksToPlayer"), StringUtil.substring(ssxRunnerQuest.requestDialogues[editRuleL1.getDialogue(0)], 0, 16) + "...")
			;pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_BaseAnswersOnSpeachCraft"), ssxRunnerQuest.yesNo[editRuleL1.???])
			;pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositiveAnswer"), StringUtil.substring(ssxRunnerQuest.positiveAnswers[editRuleL1.getDialogue(1)], 0, 16) + "...")
			;pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositiveAnswerProb"), ssxRunnerQuest.answerProbs[editRuleL1.getAnswerProbability(true)])
			;pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_NegativeAnswer"), StringUtil.substring(ssxRunnerQuest.negativeAnswers[editRuleL1.getDialogue(2)], 0, 16) + "...")
			;pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_NegativeAnswerProb"), ssxRunnerQuest.answerProbs[editRuleL1.getAnswerProbability(false)])
			if ssxRunnerQuest.nexusMode
				AddEmptyOption()
				AddEmptyOption()
			else
				pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_PlayerRapedOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercRape()])
				pageOPTs[8] = AddMenuOption(ssxRunnerQuest.s("$SSX_AggressivenessOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercRapeAggr()])
			endIf
			pageOPTs[9] = AddMenuOption(ssxRunnerQuest.s("$SSX_MasturbationOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercMast()])
		endIf
		pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_AnswerFinal"), StringUtil.substring(ssxRunnerQuest.npcFinalSentences[editRuleL1.getDialogue(3)], 0, 16) + "...")

	elseIf !editRuleL1.isPlayerInvolved() && editRuleL1.getNumPlayers()>1
		; NPC asks NPC
		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_EnableNPCtoNPCDialogues"), ssxRunnerQuest.yesNo[editRuleL1.getAskBeforeSex()])
		if editRuleL1.getAskBeforeSex()
			pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_NPCAsksToNPC"), StringUtil.substring(ssxRunnerQuest.requestDialogues[editRuleL1.getDialogue(0)], 0, 16) + "...")
			;pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_BaseAnswersOnSpeachCraft"), ssxRunnerQuest.yesNo[editRuleL1.???])
			pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositiveAnswer"), StringUtil.substring(ssxRunnerQuest.positiveAnswers[editRuleL1.getDialogue(1)], 0, 16) + "...")
			pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositiveAnswerProb"), ssxRunnerQuest.answerProbs[editRuleL1.getAnswerProbability(true)])
			pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_NegativeAnswer"), StringUtil.substring(ssxRunnerQuest.negativeAnswers[editRuleL1.getDialogue(2)], 0, 16) + "...")
			pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_NegativeAnswerProb"), ssxRunnerQuest.answerProbs[editRuleL1.getAnswerProbability(false)])
			if editRuleL1.getAnswerProbability(false)==4 || editRuleL1.getAnswerProbability(true)==0
				if ssxRunnerQuest.nexusMode
					AddEmptyOption()
					AddEmptyOption()
				else
					pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_NPCRapedOnDenials"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
					pageOPTs[8] = AddMenuOption(ssxRunnerQuest.s("$SSX_AggressivenessOnDenials"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
				endIf
				pageOPTs[9] = AddMenuOption(ssxRunnerQuest.s("$SSX_MasturbationOnDenials"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
			else
				if ssxRunnerQuest.nexusMode
					AddEmptyOption()
					AddEmptyOption()
				else
					pageOPTs[7] = AddMenuOption(ssxRunnerQuest.s("$SSX_NPCRapedOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercRape()])
					pageOPTs[8] = AddMenuOption(ssxRunnerQuest.s("$SSX_AggressivenessOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercRapeAggr()])
				endIf
				pageOPTs[9] = AddMenuOption(ssxRunnerQuest.s("$SSX_MasturbationOnDenials"), ssxRunnerQuest.percs[editRuleL1.getPercMast()])
			endIf
		endIf
		pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$SSX_AnswerFinal"), StringUtil.substring(ssxRunnerQuest.npcFinalSentences[editRuleL1.getDialogue(3)], 0, 16) + "...")
	else
		pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_NoDialoguesPossible"), "", OPTION_FLAG_DISABLED)
	endIf	
	
	SetCursorPosition(1)
	AddHeaderOption(ssxRunnerQuest.s("$SSX_EditingTheInteractionOfTheRule"))
	if ssxRunnerQuest.nexusMode
		editRuleL1.aggressive=0
		editRuleL1.setPercRape(0)
	else
		pageOPTs[11] = AddMenuOption(ssxRunnerQuest.s("$SSX_Aggressiveness"), ssxRunnerQuest.percs[editRuleL1.aggressive])
		if editRuleL1.aggressive==0
			pageOPTs[12] = AddMenuOption(ssxRunnerQuest.s("$SSX_WhoWillBeVictim"), ssxRunnerQuest.s("$SSX_NA"), OPTION_FLAG_DISABLED)
		else
			pageOPTs[12] = AddMenuOption(ssxRunnerQuest.s("$SSX_WhoWillBeVictim"), ssxRunnerQuest.whoIsVictim[editRuleL1.getVictim() + 1])
		endIf
	endIf
	AddEmptyOption()
	pageOPTs[14] = AddMenuOption(ssxRunnerQuest.s("$SSX_StopAllCombats"), ssxRunnerQuest.stopAllCombats[editRuleL1.stopAllCombats])
	SetCursorPosition(21)
	pageOPTs[15] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[16] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Cancel"))	
	usedOptions=17
EndFunction

Function generateSexRules_Properties() ; 18 L1 OK
	SetTitleText("Rule Properties")
	SetCursorFillMode(TOP_TO_BOTTOM)
	AddHeaderOption(ssxRunnerQuest.s("$SSX_EditRuleProperties"))
	AddEmptyOption()
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_RulePriority"), ssxRunnerQuest.prob[editRuleL1.probability])
	pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_AboutBeds"), ssxRunnerQuest.beds[editRuleL1.beds])
	AddEmptyOption()
	pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_UseATimeOut"), ssxRunnerQuest.yesNo[tmpValInt[2]])
	if tmpValInt[2]==1
		AddSliderOptionST("TimeBeforeReDoSL", ssxRunnerQuest.s("$SSX_TimeBeforeReDo"), editRuleL1.timeBeforeReDo, "{0} secs")
	else
		AddEmptyOption()
	endIf
	if ssxRunnerQuest.expertiseLevel>0
		if editRuleL1.isPlayerInvolvedAndParticipating()
			pageOPTs[15] = AddMenuOption(ssxRunnerQuest.s("$SSX_AllowOrgies"), ssxRunnerQuest.yesNo[editRuleL1.enableOrgies], OPTION_FLAG_DISABLED)
			editRuleL1.enableOrgies=0
		else
			pageOPTs[15] = AddMenuOption(ssxRunnerQuest.s("$SSX_AllowOrgies"), ssxRunnerQuest.yesNo[editRuleL1.enableOrgies])
		endIf
	endIf
	if ssxRunnerQuest.forePlayActive()
		pageOPTs[16] = AddToggleOption(ssxRunnerQuest.s("$SSX_UseLeadInForeplay"), editRuleL1.hasLeadIn())
	else
		pageOPTs[16] = AddToggleOption(ssxRunnerQuest.s("$SSX_UseLeadInForeplay"), false, OPTION_FLAG_DISABLED)
	endIf

	if ssxRunnerQuest.expertiseLevel>0
		AddSliderOptionST("SpectatorsSL", ssxRunnerQuest.s("$SSX_EnableSpectators"), editRuleL1.getSpectators())
		if editRuleL1.getSpectators()>0
			pageOPTs[17] = AddMenuOption(ssxRunnerQuest.s("$SSX_SpectatorsMasturbate"), ssxRunnerQuest.spectatorsMasturbates[editRuleL1.getSpectatorsMasturbate()])
		else
			pageOPTs[17] = AddMenuOption(ssxRunnerQuest.s("$SSX_SpectatorsMasturbate"), ssxRunnerQuest.spectatorsMasturbates[0], OPTION_FLAG_DISABLED)
		endIf
	endIf
	if ssxRunnerQuest.expertiseLevel==2
		pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_ScaleActors"), ssxRunnerQuest.scaleActorsVals[editRuleL1.scaleActors])
	endIf
	SetCursorPosition(1)
	; Author and Desription
	AddInputOptionST("RuleAuthorINP", ssxRunnerQuest.s("$SSX_Author", editRuleL1.author), ssxRunnerQuest.s("$SSX_Edit"))
	AddHeaderOption(ssxRunnerQuest.s("$SSX_Description"))
	string[] descrs = StringUtil.split(editRuleL1.description, "\n")
	tmpValString[15] = ""
	int i = 0
	while i<5
		if i<descrs.length
			pageOPTs[10 + i] = AddToggleOption(descrs[i], tmpValInt[10]==i)
			tmpValString[10 + i] = descrs[i]
		else
			pageOPTs[10 + i] = AddToggleOption("", tmpValInt[10]==i)
			tmpValString[10 + i] = ""
		endIf
		if tmpValInt[10]==i && i<descrs.length
			tmpValString[15] = descrs[i]
		endIf
		i+=1
	endWhile
	AddInputOptionST("EditDescrINP", "", ssxRunnerQuest.s("$SSX_Edit"))

	SetCursorPosition(21)
	pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Cancel"))
	usedOptions=18
EndFunction

Function generateSexRules_Locations() ; 19 L1 OK
	SetTitleText("Rule Locations")
	SetCursorFillMode(TOP_TO_BOTTOM)
	AddHeaderOption(ssxRunnerQuest.s("$SSX_EditRuleLocations"))
	String[] parts = StringUtil.split(editRuleL1.locations, ";")
	int i = parts.length
	int count=0
	while i
		i-=1
		pageOPTs[count + 20] = AddTextOption(SSX_Runner_Quest.GetNameFromEditorID(parts[i]), ssxRunnerQuest.s("$SSX_Remove"))
		tmpValString[count + 20] = parts[i]
		count += 1
	endWhile
	parts = StringUtil.split(editRuleL1.cells, ";")
	i = parts.length
	while i
		i-=1
		pageOPTs[count + 20] = AddTextOption(SSX_Runner_Quest.GetNameFromEditorID(parts[i]), ssxRunnerQuest.s("$SSX_Remove"))
		tmpValString[count + 20] = parts[i]
		count += 1
	endWhile
	parts = StringUtil.split(editRuleL1.locationTypes, ";")
	i = parts.length
	while i
		i-=1
		pageOPTs[count + 20] = AddTextOption(SSX_Runner_Quest.GetNameFromEditorID(parts[i]), ssxRunnerQuest.s("$SSX_Remove"))
		tmpValString[count + 20] = parts[i]
		count += 1
	endWhile

	SetCursorPosition(1)
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_SelectLocationToAdd"), ssxRunnerQuest.locationList[tmpValInt[0]])
	pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_AddSelectedLocation"), ssxRunnerQuest.s("$SSX_Add"))
	if PlayerRef.getCurrentLocation()
		pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_AddCurrentLocation"), PlayerRef.getCurrentLocation().getName())
	else
		pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_AddCurrentLocation"), ssxRunnerQuest.s("$ssx_novalidlocation"), OPTION_FLAG_DISABLED)
	endIf
	if PlayerRef.getParentCell().getName()
		pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_AddCurrentCell"), PlayerRef.getParentCell().getName())
	else
		pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_AddCurrentLocation"), ssxRunnerQuest.s("$ssx_novalidcell"), OPTION_FLAG_DISABLED)
	endIf
	pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_LocationTypeSelect"), ssxRunnerQuest.locationTypeList[tmpValInt[3]])
	pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$SSX_LocationTypeAdd"), ssxRunnerQuest.s("$SSX_Add"))
	pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearAllLocations"), ssxRunnerQuest.s("$SSX_Clear"))
	AddEmptyOption()
	pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_InternalExternal"), ssxRunnerQuest.intExtMnu[editRuleL1.getIntExt()])
	if editRuleL1.getCellInclExcl()
		pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$ssx_cellinclusiveexclusive"), ssxRunnerQuest.inclExclMnu[1])
	else
		pageOPTs[10] = AddMenuOption(ssxRunnerQuest.s("$ssx_cellinclusiveexclusive"), ssxRunnerQuest.inclExclMnu[0])
	endIf
	pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Cancel"))
	usedOptions=21 + count
EndFunction

Function generateSexRules_StartFilters() ; 20 L1 OK
	SetTitleText("Rule Starting and Filters")
	SetCursorFillMode(LEFT_TO_RIGHT)
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_editrulestartingmode"), ssxRunnerQuest.startModes[editRuleL1.startsOn])
	pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleStartsInitialize"), ssxRunnerQuest.s("$SSX_Clear"))
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_SaveAndGoBack"), ssxRunnerQuest.s("$SSX_Save"))
	pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_ExitWithoutSaving"), ssxRunnerQuest.s("$SSX_Cancel"))	
	AddHeaderOption("Actual Filters")
	AddHeaderOption("Possible Filters")
	SetCursorFillMode(TOP_TO_BOTTOM)
	SetCursorPosition(6)
	; List of start filters, with the widgets to edit them
	if editRuleL1.isStartingOn(0) ; No actual filters
		pageOPTs[20] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleStartsRandom"), "", OPTION_FLAG_DISABLED)
	endIf
	; 1=be naked, 2=see naked, 3=see sex, 4=arousal, 5=health, 6=stamina, 7=magicka, 8=sleep, 9=sneak, 10=weapon, 11=combat, 12=bleedout, 13=unconscious, 14=wearables, timer, sequence
	if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMBeNaked(), -1, -1, -1) ; be naked
		pageOPTs[21] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsNaked"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMBeNaked(),-1)])
	endIf
	if ssxRunnerQuest.expertiseLevel>0
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMSeeNaked(), -1, -1, -1) ; see naked
			pageOPTs[22] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsSeeNaked"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMSeeNaked(),-1)])
		endIf
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMSeeSex(), -1, -1, -1) ; seeing sex
			pageOPTs[23] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsSeeSex"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMSeeSex(),-1)])
		endIf
	endIf
	if ssxRunnerQuest.expertiseLevel>1
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMArousal(), -1, -1, -1) ; arousal
			if ssxRunnerQuest.weHaveSLA()
				pageOPTs[24] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsArousal"), ssxRunnerQuest.startsOnActorModesVal[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMArousal(), -1)])
				AddSliderOptionST("ArousalSL", ssxRunnerQuest.s("$SSX_RuleStartsArousal"), editRuleL1.arousalLevel, "{0}")
			else
				AddSliderOptionST("ArousalSL", ssxRunnerQuest.s("$SSX_RuleStartsArousalValue"), editRuleL1.arousalLevel, "{0}", OPTION_FLAG_DISABLED)
			endIf
		endIf
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMHealth(), -1, -1, -1) ; health
			pageOPTs[25] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsHealth"), ssxRunnerQuest.startsOnActorModesVal[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMHealth(), -1)])
			AddSliderOptionST("HealthSL", ssxRunnerQuest.s("$SSX_RuleStartsHealthValue"), editRuleL1.healthLevel, "{0}%")
		endIf
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMStamina(), -1, -1, -1) ; stamina
			pageOPTs[26] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsStamina"), ssxRunnerQuest.startsOnActorModesVal[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMStamina(), -1)])
			AddSliderOptionST("StaminaSL", ssxRunnerQuest.s("$SSX_RuleStartsStaminaValue"), editRuleL1.staminaLevel, "{0}%")
		endIf
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMMagicka(), -1, -1, -1) ; Magicka
			pageOPTs[27] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsMagicka"), ssxRunnerQuest.startsOnActorModesVal[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMMagicka(), -1)])
			AddSliderOptionST("MagickaSL", ssxRunnerQuest.s("$SSX_RuleStartsMagickaValue"), editRuleL1.magickaLevel, "{0}%")
		endIf
	endIf
	if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMSleep(), -1, -1, -1) ; sleeping
		pageOPTs[28] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsSleeping"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMSleep(), -1)])
	endIf
	if ssxRunnerQuest.expertiseLevel>1
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMSneak(), -1, -1, -1) ; Sneaking
			pageOPTs[29] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsSneaking"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMSneak(), -1)])
		endIf
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMWeapon(), -1, -1, -1) ; has Weapon
			pageOPTs[30] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsHasWeapon"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMWeapon(), -1)])
		endIf
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMCombat(), -1, -1, -1) ; in combat
			pageOPTs[31] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsInCombat"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMCombat(), -1)])
		endIf
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMBleedOut(), -1, -1, -1) ; bleed out
			pageOPTs[32] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsBleedout"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMBleedOut(), -1)])
		endIf
		if editRuleL1.isStartingOn(SSX_Rule_Alias.getSMUnconscious(), -1, -1, -1) ; unconscious
			pageOPTs[33] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsUnconscious"), ssxRunnerQuest.startsOnActorModes[editRuleL1.getPositionStartMode(SSX_Rule_Alias.getSMUnconscious(), -1)])
		endIf
	endIf

	if ssxRunnerQuest.expertiseLevel>0 && editRuleL1.isStartingOn(SSX_Rule_Alias.getSMWearables(), 1, 1, 1) ; Clothing
		pageOPTs[55] = AddTextOption(ssxRunnerQuest.s("$SSX_RuleStartsWearables"), ssxRunnerQuest.s("$SSX_Edit"))
	endIf

	; time
	if ssxRunnerQuest.expertiseLevel>0 && editRuleL1.getStartTimer(true)!=-1
		pageOPTs[34] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartTime"), ssxRunnerQuest.timeOfTheDay[editRuleL1.getStartTimer(true)])
		pageOPTs[35] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleEndTime"), ssxRunnerQuest.timeOfTheDay[editRuleL1.getStartTimer(false)])
	endIf
	; Sequence
	if ssxRunnerQuest.expertiseLevel>1 && editRuleL1.startsOn==2
		if ssxRunnerQuest.ruleNames.length==1 && ssxRunnerQuest.ruleNames[0]==ssxRunnerQuest.s("$SSX_NoRules")
			pageOPTs[36] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsSequence"), "", OPTION_FLAG_DISABLED)
		else
			int index=0
			if editRuleL1.prevRule<1
				editRuleL1.prevRule=0
			else
				index = ssxRunnerQuest.getRuleIndexById(editRuleL1.prevRule)
				if index<0 || index>=ssxRunnerQuest.ruleNames.length
					index=0
				endIf
			endIf
			pageOPTs[36] = AddMenuOption(ssxRunnerQuest.s("$SSX_RuleStartsSequence"), ssxRunnerQuest.ruleNames[index])
		endIf
	endIf


	; Right
	SetCursorPosition(7)
	; Add the "Add starting types"
	; 1=be naked, 2=see naked, 3=see sex, 4=arousal, 5=health, 6=stamina, 7=magicka, 8=sleep, 9=sneak, 10=weapon, 11=combat, 12=bleedout, 13=unconscious, timer, sequence
	if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMBeNaked(), -1, -1, -1) ; be naked
		pageOPTs[41] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsNaked"), ssxRunnerQuest.s("$SSX_Add"))
	endIf
	if ssxRunnerQuest.expertiseLevel>0
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMSeeNaked(), -1, -1, -1) ; see naked
			pageOPTs[42] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsSeeNaked"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMSeeSex(), -1, -1, -1) ; seeing sex
			pageOPTs[43] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsSeeSex"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
	endIf
	if ssxRunnerQuest.expertiseLevel>1
		if ssxRunnerQuest.weHaveSLA() && !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMArousal(), -1, -1, -1) ; arousal
			pageOPTs[44] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsArousal"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMHealth(), -1, -1, -1) ; health
			pageOPTs[45] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsHealth"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMStamina(), -1, -1, -1) ; stamina
			pageOPTs[46] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsStamina"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMMagicka(), -1, -1, -1) ; Magicka
			pageOPTs[47] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsMagicka"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
	endIf
	if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMSleep(), -1, -1, -1) ; sleeping
		pageOPTs[48] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsSleeping"), ssxRunnerQuest.s("$SSX_Add"))
	endIf
	if ssxRunnerQuest.expertiseLevel>1
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMSneak(), -1, -1, -1) ; Sneaking
			pageOPTs[49] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsSneaking"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMWeapon(), -1, -1, -1) ; has Weapon
			pageOPTs[50] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsWeapon"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMCombat(), -1, -1, -1) ; in combat
			pageOPTs[51] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsCombat"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMBleedOut(), -1, -1, -1) ; bleed out
			pageOPTs[52] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsBleedout"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
		if !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMUnconscious(), -1, -1, -1) ; unconscious
			pageOPTs[53] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsUnconscious"), ssxRunnerQuest.s("$SSX_Add"))
		endIf
	endIf
	if ssxRunnerQuest.expertiseLevel>0 && !editRuleL1.isStartingOn(SSX_Rule_Alias.getSMWearables(), 1, 1, 1)
		pageOPTs[56] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsWearables"), ssxRunnerQuest.s("$SSX_Add"))
	endIf
	; time
	if ssxRunnerQuest.expertiseLevel>0 && editRuleL1.getStartTimer(true)==-1
		pageOPTs[54] = AddTextOption(ssxRunnerQuest.s("$SSX_AddRuleStartsTime"), ssxRunnerQuest.s("$SSX_Add"))
	endIf

	usedOptions=57
EndFunction

Function generateSexRules_ImportExport() ; 21 OK
	SetTitleText("Rules Import/Export")
	SetCursorFillMode(TOP_TO_BOTTOM)
	AddHeaderOption(ssxRunnerQuest.s("$SSX_ImportExportRules"))
	; Show the list of rule, enable to select multiple rules
	check=false
	bool atleastOne=false
	int i = 0
	while i<ssxRunnerQuest.rules.length && i<40
		SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
		if r.inUse!=0
			atleastOne = true
			pageOPTs[i] = AddToggleOption(r.name, tmpValInt[i]!=0)
			if tmpValInt[i]!=0
				check=true
			endIf
		endIf
		i+=1
	endWhile
	SetCursorPosition(1)
	pageOPTs[64] = AddMenuOption(ssxRunnerQuest.s("$SSX_MultipleExportJoined"), ssxRunnerQuest.yesNo[tmpValInt[64]])
	if check ; Export selected
		pageOPTs[65] = AddTextOption(ssxRunnerQuest.s("$SSX_EportSelectedRules"), ssxRunnerQuest.s("$SSX_Export"))
	else
		pageOPTs[65] = AddTextOption(ssxRunnerQuest.s("$SSX_EportSelectedRules"), ssxRunnerQuest.s("$SSX_Export"), OPTION_FLAG_DISABLED)
	endIf
	if atLeastOne ; Export all
		pageOPTs[66] = AddTextOption(ssxRunnerQuest.s("$SSX_EportAllRules"), ssxRunnerQuest.s("$SSX_Export"))
	else
		pageOPTs[66] = AddTextOption(ssxRunnerQuest.s("$SSX_EportAllRules"), ssxRunnerQuest.s("$SSX_Export"), OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()
	; Import mode
	pageOPTs[67] = AddMenuOption(ssxRunnerQuest.s("$SSX_ImportRulesMode"), ssxRunnerQuest.importRulesMode[tmpValInt[67]])
	; Import list
	String[] jsonRulesTmp = JSONUtil.JsonInFolder("../Scent of Sex/")
	if jsonRules[0] != ""
		String val = StringUtil.substring(jsonRules[tmpValInt[68]], 0, 20)
		if StringUtil.getLength(jsonRules[tmpValInt[68]])>20
			val+="..."
		endIf
		pageOPTs[68] = AddMenuOption(ssxRunnerQuest.s("$SSX_FoundRules"), val)
		; Check rule in list
		pageOPTs[69] = AddTextOption(ssxRunnerQuest.s("$SSX_CheckTheRule"), ssxRunnerQuest.s("$SSX_Check"))
		; Import selected
		pageOPTs[70] = AddTextOption(ssxRunnerQuest.s("$SSX_ImportSelectedRule"), ssxRunnerQuest.s("$SSX_Import"))
		; Import all
		pageOPTs[71] = AddTextOption(ssxRunnerQuest.s("$SSX_ImportAllRules"), ssxRunnerQuest.s("$SSX_Import"))
	else
		pageOPTs[68] = AddTextOption(ssxRunnerQuest.s("$SSX_FoundRules"), ssxRunnerQuest.s("$SSX_NoRulesFound"), OPTION_FLAG_DISABLED)
		pageOPTs[69] = AddTextOption(ssxRunnerQuest.s("$SSX_CheckTheRule"), ssxRunnerQuest.s("$SSX_Check"), OPTION_FLAG_DISABLED)
		pageOPTs[70] = AddTextOption(ssxRunnerQuest.s("$SSX_ImportSelectedRule"), ssxRunnerQuest.s("$SSX_Import"), OPTION_FLAG_DISABLED)
		pageOPTs[71] = AddTextOption(ssxRunnerQuest.s("$SSX_ImportAllRules"), ssxRunnerQuest.s("$SSX_Import"), OPTION_FLAG_DISABLED)
	endIf
	SetCursorPosition(23)
	pageOPTs[72] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
	usedOptions=73
EndFunction

Function generateSexRules_CheckRule() ; 22 L0 OK
	SetTitleText("Checking Rule")
	SetCursorFillMode(TOP_TO_BOTTOM)
	String file = ssxRunnerQuest.configFolder + "rules\\" + jsonRules[tmpValInt[68]] + ".json"
	JSONUtil.load(file) ; Load the file
	if !JSONUtil.isGood(file)
		debug.messagebox(ssxRunnerQuest.s("$SSX_NotValidJSONFile", file, JSONUtil.getErrors(file)))
		jumpToPage(21)
		return
	endIf
	; Check the version
	int version = JSONUtil.GetPathIntValue(file, ".version", -1)
	if version==-1
		Debug.messagebox(ssxRunnerQuest.s("$SSX_RuleTooOldOrProbablyNotARule"))
		jumpToPage(21)
		return
	elseIf version<10300
		Debug.messagebox(ssxRunnerQuest.s("$SSX_RuleTooOld"))
		jumpToPage(21)
		return
	endIf
	; Check if it is a collection of rule
	num = JSONUtil.PathCount(file, ".rules")
	if num>0 ; Collection of rules
		Debug.messagebox(ssxRunnerQuest.s("$SSX_WarningMultipleRulesInTheFile", num))
		ssxRunnerQuest.getRule(file, false, 0, editRuleL0, Self)
	else ; Single rule
		ssxRunnerQuest.getRule(file, true, -1, editRuleL0, Self)
	endIf
	AddTextOption(editRuleL0.name, "", OPTION_FLAG_DISABLED)
	AddTextOption(ssxRunnerQuest.s("$SSX_Author", editRuleL0.author), "", OPTION_FLAG_DISABLED)
	pageOPTs[0] = AddTextOption(ssxRunnerQuest.s("$SSX_Description", editRuleL0.description), "")
	AddTextOption("Tgt:", ssxRunnerQuest.getPositionShortName(editRuleL0, 0), OPTION_FLAG_DISABLED)
	AddTextOption("IDs:", ssxRunnerQuest.getPositionValues(editRuleL0, 0), OPTION_FLAG_DISABLED)
	AddTextOption("Races:", editRuleL0.dstRaces, OPTION_FLAG_DISABLED)
	AddTextOption("Src:", ssxRunnerQuest.getPositionShortName(editRuleL0, 1), OPTION_FLAG_DISABLED)
	AddTextOption("IDs:", ssxRunnerQuest.getPositionValues(editRuleL0, 1), OPTION_FLAG_DISABLED)
	AddTextOption("Races:", editRuleL0.srcRaces, OPTION_FLAG_DISABLED)
	AddTextOption("Coll:", ssxRunnerQuest.getPositionShortName(editRuleL0, 2) + " (" + editRuleL0.getNumColls() + ")", OPTION_FLAG_DISABLED)
	AddTextOption("IDs:", ssxRunnerQuest.getPositionValues(editRuleL0, 2), OPTION_FLAG_DISABLED)
	AddTextOption("Races:", editRuleL0.collRaces, OPTION_FLAG_DISABLED)
	SetCursorPosition(1)
	String msg=""
	String[] parts = StringUtil.split(editRuleL0.locations, ";")
	int i = 0
	while i<parts.length
		msg += SSX_Runner_Quest.GetNameFromEditorID(parts[i]) + "; "
		i += 1
	endWhile
	parts = StringUtil.split(editRuleL0.locationTypes, ";")
	i = 0
	while i<parts.length
		msg += SSX_Runner_Quest.GetNameFromEditorID(parts[i]) + "; "
		i += 1
	endWhile	
	AddTextOption("Locations:", msg, OPTION_FLAG_DISABLED)
	AddTextOption("Start:", calculateStartingMode(editRuleL0), OPTION_FLAG_DISABLED)
	; wearing (short)
	msg=""
	i = 0
	if editRuleL0.wearAtStartDst!="" || editRuleL0.wearAtEndDst!=""
		msg+="Dst"
		i+=1
	endIf
	if editRuleL0.wearAtStartSrc!="" || editRuleL0.wearAtEndSrc!=""
		if msg!=""
			msg+=", "
		endIf
		msg+="Src"
		i+=1
	endIf
	if editRuleL0.wearAtStartColl!="" || editRuleL0.wearAtEndColl!=""
		if msg!=""
			msg+=", "
		endIf
		msg+="Coll"
		i+=1
	endIf
	if msg!=""
		if i==1
			msg+=" has to wear"
		else
			msg+=" have to wear"
		endIf
	endIf
	AddTextOption("Clothes:", msg, OPTION_FLAG_DISABLED)
	if editRuleL0.getAskBeforeSex()
		if editRuleL0.isPlayerInvolved()
			AddTextOption("Player will be asked", "", OPTION_FLAG_DISABLED)
		else
			AddTextOption("NPCs will be asked", "", OPTION_FLAG_DISABLED)
		endIf
	else
		if editRuleL0.isPlayerInvolved()
			AddTextOption("Player will NOT be asked", "", OPTION_FLAG_DISABLED)
		else
			AddTextOption("Nobody will be asked", "", OPTION_FLAG_DISABLED)
		endIf
	endIf

	SetCursorPosition(23)
	; Back
	pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
	usedOptions=2
EndFunction

Function generateSexRules_PositionMods() ; 23 L2 OK
	if ssxRunnerQuest.areModsInProgress<100
		AddTextOption("The Mods list is updating... " + ssxRunnerQuest.areModsInProgress + "%", "")
		AddTextOptionST("RefreshButton", "", ssxRunnerQuest.s("$SSX_Refresh"))
		return
	endIf

	SetTitleText("Mods filter for Position")
	SetCursorFillMode(TOP_TO_BOTTOM)
	; Get the list of all mods, but split it in 50 elements array, sorted
	String[] mods = StringUtil.split(editRuleL2.getMods(positionEdited), ";")
	int i = 0
	while i<mods.length && (10 + i)<124
		pageOPTs[10 + i] = AddTextOption(mods[i], ssxRunnerQuest.s("$SSX_Remove"))
		i+=1
	endWhile
	SetCursorPosition(1)
	pageOPTs[0] = AddMenuOption("Mods 1", ssxRunnerQuest.modsSet1[tmpValInt[0]])
	pageOPTs[1] = AddTextOption("Add selected Mod", ssxRunnerQuest.s("$SSX_Add"))
	i = Game.GetModCount()
	if i>63
		pageOPTs[2] = AddMenuOption("Mods 2", ssxRunnerQuest.modsSet2[tmpValInt[2]])
		pageOPTs[3] = AddTextOption("Add selected Mod", ssxRunnerQuest.s("$SSX_Add"))
	endIf
	if i>127
		pageOPTs[4] = AddMenuOption("Mods 3", ssxRunnerQuest.modsSet3[tmpValInt[4]])
		pageOPTs[5] = AddTextOption("Add selected Mod", ssxRunnerQuest.s("$SSX_Add"))
	endIf
	if i>191
		pageOPTs[6] = AddMenuOption("Mods 4", ssxRunnerQuest.modsSet4[tmpValInt[6]])
		pageOPTs[7] = AddTextOption("Add selected Mod", ssxRunnerQuest.s("$SSX_Add"))
	endIf
	AddEmptyOption()
	if mods.length>0
		pageOPTs[8] = AddTextOption("Clear all Mods", ssxRunnerQuest.s("$SSX_Clear"))
	else
		pageOPTs[8] = AddTextOption("Clear all Mods", ssxRunnerQuest.s("$SSX_Clear"), OPTION_FLAG_DISABLED)
	endIf
	SetCursorPosition(23)
	pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
	usedOptions=mods.length+11
EndFunction

Function generateSexRules_NegFactions() ; 28 L2
	SetTitleText("Edit negative faction filter")
	SetCursorFillMode(TOP_TO_BOTTOM)
	if positionEdited==SSX_Rule_Alias.targetPosition() ; Target
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditingOfRuleTarget"))
	elseIf positionEdited==SSX_Rule_Alias.sourcePosition() ; Source
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditingOfRuleSource"))
	elseIf positionEdited==SSX_Rule_Alias.collaboratorPosition() ; Collaborator
		AddHeaderOption(ssxRunnerQuest.s("$SSX_EditingOfRuleCollaborator"))
	endIf
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_PositionType"), ssxRunnerQuest.actTypes[editRuleL2.getType(positionEdited)], OPTION_FLAG_DISABLED)
	AddEmptyOption()
	AddHeaderOption("Negative Factions")
	String factID = editRuleL2.getNegativeFactions(positionEdited)
	int i=0
	if factID==""
		AddTextOption("No factions", "", OPTION_FLAG_DISABLED)
	else
		String[] factIDs = StringUtil.split(factID, ";")
		while i<factIDs.length && (10 + i)<124
			Faction f = PO3_SKSEFunctions.GetFormFromEditorID(factIDs[i]) as Faction
			if f
				tmpValString[10 + i] = factIDs[i]
				pageOPTs[10 + i] = AddTextOption(SSX_Runner_Quest.GetNameAndEditorID(f), ssxRunnerQuest.s("$SSX_Remove"))
			endIf
			i+=1
		endWhile
	endIf
	
	SetCursorPosition(1)
	AddInputOptionST("factionFilterINP", ssxRunnerQuest.s("$SSX_FactionsFilter"), factionFilter)
	if tmpValInt[1]>-1 && tmpValInt[1]<factionFilters.length
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_PickAFaction"), factionFilters[tmpValInt[1]])
	else
		pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_PickAFaction"), "")
	endIf
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_AddThisFaction"), ssxRunnerQuest.s("$SSX_Add"))
	if i
		pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearFaction"), ssxRunnerQuest.s("$SSX_Clear"))
	else
		pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$SSX_ClearFaction"), ssxRunnerQuest.s("$SSX_Clear"), OPTION_FLAG_DISABLED)
	endIf
	AddEmptyOption()
	AddEmptyOption()
	pageOPTs[4] = AddTextOption(ssxRunnerQuest.s("$SSX_ShowFactions"), ssxRunnerQuest.s("$SSX_Show"))
	
	
	SetCursorPosition(23)
	pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
	usedOptions=11 + i
EndFunction

Function generateSexRules_StartWearables() ; 29 L2
	SetTitleText("Starting Filters on Wearables")
	SetCursorFillMode(TOP_TO_BOTTOM)
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_EditParticipant"), ssxRunnerQuest.participantEdit[tmpValInt[0]])
	;Get all items from the selected position and show them (add remove button)
	String ws = editRuleL2.getHasToWear(tmpValInt[0], tmpValInt[1]==0)
	String[] parts = StringUtil.split(ws, ";")
	int i = 0
	while i < parts.length && (10 + i)<124
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if f
			if f.getName()!="" ; Armor
				pageOPTs[10 + i] = AddTextOption(f.getName(), ssxRunnerQuest.s("$SSX_Remove"))
			else ; Check if is a keyword
				int pos = ssxRunnerQuest.armorKeywords.find(f as Keyword)
				if pos!=-1
					pageOPTs[10 + i] = AddTextOption(ssxRunnerQuest.armorKeywordIDs[pos], ssxRunnerQuest.s("$SSX_Remove"))
				else
					AddTextOption("MISSING", "")
				endIf
			endIf
		else
			AddTextOption("MISSING", "")
		endIf
		i+=1
	endWhile

	SetCursorPosition(1)
	pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_HasToNotTo"), ssxRunnerQuest.hasToNotTos[tmpValInt[1]]) ; has/should not
	AddEmptyOption()
	pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$ssx_pickwearable"),  ssxRunnerQuest.currentArmorsNames[tmpValInt[2]])
	pageOPTs[3] = AddTextOption(ssxRunnerQuest.s("$ssx_addwearable"), ssxRunnerQuest.s("$SSX_Add"))
	AddEmptyOption()
	pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$ssx_armorpiecekeywordmenu"), ssxRunnerQuest.armorKeywordIDs[tmpValInt[4]])
	pageOPTs[5] = AddTextOption(ssxRunnerQuest.s("$ssx_addarmorkeyword"), ssxRunnerQuest.s("$SSX_Add"))
	AddEmptyOption()
	pageOPTs[6] = AddTextOption(ssxRunnerQuest.s("$ssx_clearallwearables"), ssxRunnerQuest.s("$SSX_Clear"))
	
	SetCursorPosition(19)
	pageOPTs[8] = AddTextOption("Check Player", "Check")
	if Game.GetCurrentCrosshairRef() as Actor
		pageOPTs[9] = AddTextOption("Check Actor", "Check")
	else
		pageOPTs[9] = AddTextOption("Check Actor", "Check", OPTION_FLAG_DISABLED)
	endIf
	pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
	
	usedOptions=i+10
endFunction

Function generateNudity() ; 30
	SetCursorFillMode(TOP_TO_BOTTOM)
	AddHeaderOption(ssxRunnerQuest.s("$SSX_ThePlayerIsNakedWhen"))
	pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("$SSX_WearsAHelmet"), ssxRunnerQuest.nakedIf[ssxRunnerQuest.nakedHead])
	pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_WearsClothesOrArmors"), ssxRunnerQuest.nakedIf[ssxRunnerQuest.nakedBody])
	pageOPTs[2] = AddMenuOption(ssxRunnerQuest.s("$SSX_HasTheForearmsCovered"), ssxRunnerQuest.nakedIf[ssxRunnerQuest.nakedForearms])
	pageOPTs[3] = AddMenuOption(ssxRunnerQuest.s("$SSX_WearsGloves"), ssxRunnerQuest.nakedIf[ssxRunnerQuest.nakedHands])
	pageOPTs[4] = AddMenuOption(ssxRunnerQuest.s("$SSX_HasTheCalvesCovered"), ssxRunnerQuest.nakedIf[ssxRunnerQuest.nakedCalves])
	pageOPTs[5] = AddMenuOption(ssxRunnerQuest.s("$SSX_WearsShoes"), ssxRunnerQuest.nakedIf[ssxRunnerQuest.nakedFeet])
	pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_WearsPelvis"), ssxRunnerQuest.nakedIf[ssxRunnerQuest.nakedPelvis])
	AddSliderOptionST("nakedLevelSL", ssxRunnerQuest.s("$SSX_MinArmorValueToBeNaked"), ssxRunnerQuest.nakedMinLevel)
	AddHeaderOption(ssxRunnerQuest.s("$SSX_NudityCheck"))
	if ssxRunnerQuest.isPlayerNaked()
		pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_NowThePlayerIs"), ssxRunnerQuest.s("$SSX_Naked"))
	else
		pageOPTs[7] = AddTextOption(ssxRunnerQuest.s("$SSX_NowThePlayerIs"), ssxRunnerQuest.s("$SSX_NOTNaked"))
	endIf
	Actor a = Game.GetCurrentCrosshairRef() as Actor
	if a ; We have somebody
		if ssxRunnerQuest.isActorNaked(a)
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ActorUnderCrosshairIs", a.getDisplayName()), ssxRunnerQuest.s("$SSX_Naked"))
		else
			pageOPTs[8] = AddTextOption(ssxRunnerQuest.s("$SSX_ActorUnderCrosshairIs", a.getDisplayName()), ssxRunnerQuest.s("$SSX_NOTNaked"))
		endIf
	else
		AddTextOption(ssxRunnerQuest.s("$SSX_HaveActorInCrossHairToCkeck"), "", OPTION_FLAG_DISABLED)
	endIf
	
	SetCursorPosition(1)
	String shortName = ssxRunnerQuest.currentArmorsNames[tmpValInt[9]]
	if StringUtil.getLength(shortName)>20
		shortName = StringUtil.substring(shortName, 0, 20) + "..."
	endIf
	pageOPTs[9] = AddMenuOption(ssxRunnerQuest.s("$ssx_armorpiecemenu"), shortName)
	pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$ssx_addarmorpiece"), ssxRunnerQuest.s("$SSX_Add"))
	pageOPTs[11] = AddMenuOption(ssxRunnerQuest.s("$ssx_armorpiecekeywordmenu"), ssxRunnerQuest.armorKeywordIDs[tmpValInt[11]])
	pageOPTs[12] = AddTextOption(ssxRunnerQuest.s("$ssx_addarmorkeyword"), ssxRunnerQuest.s("$SSX_Add"))
	pageOPTs[13] = AddTextOption(ssxRunnerQuest.s("$ssx_cleanarmorpieces"), ssxRunnerQuest.s("$SSX_Clear"))
	AddHeaderOption(ssxRunnerQuest.s("$ssx_namedlist"))
	int i = ssxRunnerQuest.armorKeywordConsideredNaked.length
	int pos=0
	while i && (20 + pos)<124
		i -= 1
		if ssxRunnerQuest.armorKeywordConsideredNaked[i]!=0
			pageOPTs[20 + pos] = AddTextOption(ssxRunnerQuest.armorKeywordIDs[i], ssxRunnerQuest.s("$SSX_Remove"))
			tmpValString[20 + pos] = ssxRunnerQuest.armorKeywordIDs[i]
			pos+=1
		endIf
	endWhile
	i = ssxRunnerQuest.nudeArmorsIDs.length
	while i && (20 + pos)<124
		i -= 1
		if ssxRunnerQuest.nudeArmorsIDs[i]
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(ssxRunnerQuest.nudeArmorsIDs[i])
			String name = "Unavailable"
			if f
				name = f.getName()
				if name==""
					name = ssxRunnerQuest.nudeArmorsIDs[i]
				endIf
			endIf
			pageOPTs[20 + pos] = AddTextOption(name, ssxRunnerQuest.s("$SSX_Remove"))
			tmpValString[20 + pos] = ssxRunnerQuest.nudeArmorsIDs[i]
			pos+=1
		endIf
	endWhile
	usedOptions=21 + pos
EndFunction

Function generateRaces() ; 40
	if ssxRunnerQuest.areActorsInProgress<100
		Utility.waitMenuMode(0.1)
		if ssxRunnerQuest.areActorsInProgress<100
			Utility.waitMenuMode(0.2)
			if ssxRunnerQuest.areActorsInProgress<100
				Utility.waitMenuMode(0.4)
				if ssxRunnerQuest.areActorsInProgress<100
					Utility.waitMenuMode(0.8)
					if ssxRunnerQuest.areActorsInProgress<100
						AddTextOptionST("RefreshButton", "Races are updating... " + ssxRunnerQuest.areActorsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
						return
					endIf
				endIf
			endIf
		endIf
	endIf
	if ssxRunnerQuest.needToUpdateRaces()
		ssxRunnerQuest.updateValidRaces()
	endIf

	SetCursorFillMode(LEFT_TO_RIGHT)
	if ssxRunnerQuest.nexusMode || !SexLab.AllowCreatures
		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("SSX_RacesToFilter"), ssxRunnerQuest.racesToFilter[0], OPTION_FLAG_DISABLED)
		tmpValInt[0]=0
	else
		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("SSX_RacesToFilter"), ssxRunnerQuest.racesToFilter[tmpValInt[0]])
	endIf
	AddEmptyOption()
	pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$ssx_EnableAllRaces"), ssxRunnerQuest.s("$SSX_Click"))
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$ssx_DisableAllRaces"), ssxRunnerQuest.s("$SSX_Click"))
	AddHeaderOption("")
	AddHeaderOption("")
	int i = 0
	int j = 0
	if tmpValInt[0]!=1
		num = ssxRunnerQuest.numAllRacesH
		while i < num
			tmpValString[10 + j] = ssxRunnerQuest.allRacesH[i]
			if ssxRunnerQuest.isRaceEnabled(tmpValString[10 + j])
				tmpValInt[10 + j] = 1
			else
				tmpValInt[10 + j] = 0
			endIf
			pageOPTs[10 + j] = AddToggleOption(tmpValString[10 + j], tmpValInt[10 + j]==1)
			i += 1
			j += 1
		endWhile
	endIf
	i = 0
	if tmpValInt[0]!=0
		num = ssxRunnerQuest.numAllRacesC
		while i < num
			tmpValString[10 + j] = ssxRunnerQuest.allRacesC[i]
			if ssxRunnerQuest.isRaceEnabled(tmpValString[10 + j])
				tmpValInt[10 + j] = 1
			else
				tmpValInt[10 + j] = 0
			endIf
			pageOPTs[10 + j] = AddToggleOption(tmpValString[10 + j], tmpValInt[10 + j]==1)
			i += 1
			j += 1
		endWhile
	endIf
	usedOptions=10 + j
EndFunction

Function generateAnims() ; 60
	if ssxRunnerQuest.areActorsInProgress<100
		AddTextOptionST("RefreshButton", "Races are updating... " + ssxRunnerQuest.areActorsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
		return
	endIf

	SetCursorFillMode(LEFT_TO_RIGHT)
	if ssxRunnerQuest.nexusMode || !SexLab.AllowCreatures
		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("SSX_RacesToFilter"), ssxRunnerQuest.racesToFilter[0], OPTION_FLAG_DISABLED)
		tmpValInt[0]=0
	else
		pageOPTs[0] = AddMenuOption(ssxRunnerQuest.s("SSX_RacesToFilter"), ssxRunnerQuest.racesToFilter[tmpValInt[0]])
	endIf
	AddInputOptionST("FilterAnimIDNameTag", ssxRunnerQuest.s("$SSX_NameOrID"), tmpValString[1]) ; text to find anims by name or tags
	pageOPTs[1] = AddTextOption(ssxRunnerQuest.s("$SSX_EnableAllAnimations"), ssxRunnerQuest.s("$SSX_Click"))
	pageOPTs[2] = AddTextOption(ssxRunnerQuest.s("$SSX_DisableAllAnimations"), ssxRunnerQuest.s("$SSX_Click"))
	AddHeaderOption("")
	AddHeaderOption("")
	; Grab all anims from all rules, filter for humans and creatures while searching for them
	sslBaseAnimation[] resAnims
	int i = ssxRunnerQuest.rules.length
	while i
		i -= 1
		SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
		if r.inUse == 2
			; Check if we need humans or creatures, and do not ask for anims of the rules of the wrong type
			sslBaseAnimation[] anims
			if r.hasCreatures() && tmpValInt[0]!=0
				anims = getAnims(r)
				resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
			elseIf !r.hasCreatures() && tmpValInt[0]!=1
				anims = getAnims(r)
				resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
			endIf
		endIf
	endWhile

	if !resAnims || resAnims.length==0
		pageOPTs[10]=AddTextOption("No anims", "", OPTION_FLAG_DISABLED)
		usedOptions=11
		return
	endIf

	; Then filter by id, name, tags
	if tmpValString[1]!=""
		if StringUtil.find(tmpValString[1], "tag:")!=-1
			String tag = StringUtil.subString(tmpValString[1], StringUtil.find(tmpValString[1], "tag:") + 4)
			; Filter by tag
			i = resAnims.length
			while i
				i-=1
				if resAnims[i] && !resAnims[i].HasTag(tag)
					resAnims[i]=None
				endIf
			endWhile
		else ; Can be part of the name of the id
			i = resAnims.length
			while i
				i-=1
				if resAnims[i] && (StringUtil.find(resAnims[i].name, tmpValString[1])==-1 || StringUtil.find(resAnims[i].registry, tmpValString[1])==-1)
					resAnims[i]=None
				endIf
			endWhile
		endIf
	endIf

	; Sort the anims by name
	if resAnims && resAnims.length>0
		SSX_Runner_Quest.sortAnims(resAnims)
	endIf
	
	; Produce the list (and keep the IDs, so we can quickly activate/deactivate)
	i = 0
	int count = 0
	while i<resAnims.length && count < pageOPTs.length - 10
		if resAnims[i]
			pageOPTs[10 + count] = AddToggleOption(resAnims[i].name, ssxRunnerQuest.isAnimEnabled(resAnims[i].Registry))
			tmpValString[10 + count] = resAnims[i].Registry
			count+=1
		endIf
		i+=1
	endWhile
	
	if count==0
		pageOPTs[10]=AddTextOption("No anims", "", OPTION_FLAG_DISABLED)
		usedOptions=11
		return
	endIf
	usedOptions=10+count
EndFunction


Function generateDebug() ; 70
	SetCursorFillMode(TOP_TO_BOTTOM)
	SetTitleText("Debug")
	pageOPTs[0] = AddToggleOption(ssxRunnerQuest.s("$SSX_ModIsActivatedDeactivatedN"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActivationN()))
	pageOPTs[1] = AddToggleOption(ssxRunnerQuest.s("$SSX_ModIsActivatedDeactivatedT"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActivationT()))
	pageOPTs[2] = AddToggleOption(ssxRunnerQuest.s("$SSX_WhatIsGoingONN"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifWhatIsGoingOnN()))
	pageOPTs[3] = AddToggleOption(ssxRunnerQuest.s("$SSX_WhatIsGoingONT"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifWhatIsGoingOnT()))
	pageOPTs[4] = AddToggleOption(ssxRunnerQuest.s("$SSX_NumberOfActorsFoundInScanN"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorsInScanN()))
	pageOPTs[5] = AddToggleOption(ssxRunnerQuest.s("$SSX_NumberOfActorsFoundInScanT"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorsInScanT()))
	pageOPTs[6] = AddToggleOption(ssxRunnerQuest.s("$SSX_RulePlayedN"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifRulePlayedN()))
	pageOPTs[7] = AddToggleOption(ssxRunnerQuest.s("$SSX_RulePlayedT"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifRulePlayedT()))
	pageOPTs[8] = AddToggleOption(ssxRunnerQuest.s("$SSX_AnimPlayedN"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifAnimPlayedN()))
	pageOPTs[9] = AddToggleOption(ssxRunnerQuest.s("$SSX_AnimPlayedT"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifAnimPlayedT()))

	SetCursorPosition(1)
	pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_DebugMessages"), ssxRunnerQuest.s("$SSX_Go"))
	pageOPTs[11] = AddTextOption(ssxRunnerQuest.s("$SSX_HighlightActors"), ssxRunnerQuest.s("$SSX_Go"))
	AddEmptyOption()
	pageOPTs[12] = AddTextOption(ssxRunnerQuest.s("$SSX_ForceActorsCleanUp"), ssxRunnerQuest.s("$SSX_Go"))
	pageOPTs[13] = AddToggleOption(ssxRunnerQuest.s("$SSX_ClenUpActorsAround"), ssxRunnerQuest.clenUpActorsAround)
	pageOPTs[15] = AddTextOption(ssxRunnerQuest.s("$ssx_rescanallthetags"), ssxRunnerQuest.s("$SSX_Rescan"))
	AddEmptyOption()
	pageOPTs[14] = AddTextOption(ssxRunnerQuest.s("$SSX_ForceRestart"), ssxRunnerQuest.s("$SSX_Go"))
	
	usedOptions=16
EndFunction


Function generateDebugAdv() ; 71
	SetTitleText("Advanced Debug")
	SetCursorFillMode(TOP_TO_BOTTOM)
	
	; Is papyrus active? if not just ask to enable it
	if !Utility.GetINIBool("bEnableLogging:Papyrus") || !Utility.GetINIBool("bEnableTrace:Papyrus")
		AddTextOption("WARNING: your Payrus.log is disabled!", "")
		AddEmptyOption()
		AddEmptyOption()
		SetCursorPosition(1)
		AddTextOption("Mod Organizer:", "", OPTION_FLAG_DISABLED)
		AddTextOption("Open the Profile folder in MO, then", "", OPTION_FLAG_DISABLED)
		AddTextOption("open your profile, and edit skirim.ini", "", OPTION_FLAG_DISABLED)
		AddEmptyOption()
		AddTextOption("NMM or manual:", "", OPTION_FLAG_DISABLED)
		AddTextOption("Go in My Documentss\\My Games\\Skyrim\\", "", OPTION_FLAG_DISABLED)
		AddTextOption("and edit skyrim.ini", "", OPTION_FLAG_DISABLED)
		AddEmptyOption()
		AddTextOption("Add inside skyrim.ini:", "", OPTION_FLAG_DISABLED)
		AddTextOption("[Papyrus]", "", OPTION_FLAG_DISABLED)
		AddTextOption("bEnableLogging=1", "", OPTION_FLAG_DISABLED)
		AddTextOption("bEnableTrace=1", "", OPTION_FLAG_DISABLED)
		Debug.MessageBox("-- WARNING --\nYour Payrus.log is disabled!\nIt is not possible to debug without it.")
		return
	endIf
	
	pageOPTs[0] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifTimeToComplete"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifTimeToComplete()))	
	pageOPTs[1] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifWarnings"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifWarnings()))	
	pageOPTs[2] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifErrors"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifErrors()))	
	pageOPTs[3] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifCombats"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifCombats()))	
	pageOPTs[4] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifRelationship"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifRelationship()))	
	pageOPTs[5] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifBadRule"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifBadRule()))	
	pageOPTs[6] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifActorForRule"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorForRule()))	
	pageOPTs[7] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifActorsFoundLong"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorsFoundLong()))	
	pageOPTs[8] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifNotGoodActors"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifNotGoodActors()))	
	pageOPTs[9] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifAnimsScan"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifAnimsScan()))
	AddEmptyOption()
	pageOPTs[10] = AddTextOption(ssxRunnerQuest.s("$SSX_TestPerformance"), ssxRunnerQuest.s("$SSX_Go"))
	SetCursorPosition(1)
	pageOPTs[11] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifScanDetails"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifScanDetails()))
	pageOPTs[12] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifCheckerDetails"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifCheckerDetails()))
	pageOPTs[13] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifPlayerDetails"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifPlayerDetails()))
	pageOPTs[14] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifSceneManDetails"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifSceneManDetails()))
	pageOPTs[15] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifCatchers"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifCatchers()))
	pageOPTs[16] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifDeferredDetails"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDeferredDetails()))
	pageOPTs[17] = AddToggleOption(ssxRunnerQuest.s("$SSX_notifCleanDetails"), ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifCleanDetails()))
	AddEmptyOption()
	AddEmptyOption()
	AddEmptyOption()
	AddEmptyOption()
	pageOPTs[18] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
	usedOptions=19
EndFunction

Function generateHighlightActors() ; 72
	SetTitleText("Highlight Actors options")
	SetCursorFillMode(TOP_TO_BOTTOM)
	AddHeaderOption("Hilight actors in")
	; 0=0x01=Scan (color=globalScan), 1=0x02=Valid for rule (color=rule), 2=0x04=Potential for rule (color=rule), 3=0x08=Starting a scene (color=rule), 4=0x10=Askable (color=globalScan), 5=0x20 Found by Cleaner (color=globalScan)

	pageOPTs[0] = AddToggleOption("Found in Scan", ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightScan()))
	pageOPTs[1] = AddMenuOption("Scan color", ssxRunnerQuest.colors[ssxRunnerQuest.notifHighLightColorScan])
	pageOPTs[2] = AddToggleOption("Valid for Rule", ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightValid()))
	pageOPTs[3] = AddToggleOption("Potential for Rule", ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightPotential()))
	pageOPTs[4] = AddToggleOption("Starting a Scene", ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightScene()))
	pageOPTs[5] = AddToggleOption("Actors can be asked for sex", ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightAsk()))
	pageOPTs[6] = AddMenuOption("Ask color", ssxRunnerQuest.colors[ssxRunnerQuest.notifHighLightColorAskable])
	pageOPTs[7] = AddToggleOption("Cleaned by Cleaner", ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightClean()))
	pageOPTs[8] = AddMenuOption("Cleaned color", ssxRunnerQuest.colors[ssxRunnerQuest.notifHighLightColorCleaned])

	SetCursorPosition(3)
	AddTextOption("Colors for Rules and Scenes,", "", OPTION_FLAG_DISABLED)
	AddTextOption("are defined at rule level.", "", OPTION_FLAG_DISABLED)
	SetCursorPosition(21)
	pageOPTs[9] = AddTextOption(ssxRunnerQuest.s("$SSX_GoBack"), ssxRunnerQuest.s("$SSX_Back"))
	usedOptions=9
EndFunction

Actor currentA
ActorBase currentAB
Form[] currentFactions
String[] currentFactionsNames
Actor factionsA

Function generateActorsEditor() ; 80
	SetTitleText(ssxRunnerQuest.s("$SSX_ActorsEditor"))
	if ssxRunnerQuest.areActorsInProgress<100
		if ssxRunnerQuest.areActorsInProgress<0
			AddTextOptionST("RefreshButton", "Actors are updating... ", ssxRunnerQuest.s("$SSX_Refresh"))
		else
			AddTextOptionST("RefreshButton", "Actors are updating... " + ssxRunnerQuest.areActorsInProgress + "%", ssxRunnerQuest.s("$SSX_Refresh"))
		endIf
		return
	endIf

	; do a sanity check of the actors, some of them can be removed because of a fast travel or COC
	int ai = 0
	bool oneNull=false
	while ai<ssxRunnerQuest.mcmActors.length
		if !ssxRunnerQuest.mcmActors[ai]
			; Find the next valid
			ssxRunnerQuest.mcmActorNames[ai] = "" ; Pre-reset, in case there are no more valid actors
			int bi=ai+1
			while bi<ssxRunnerQuest.mcmActors.length
				if ssxRunnerQuest.mcmActors[bi]
					ssxRunnerQuest.mcmActors[ai] = ssxRunnerQuest.mcmActors[bi]
					ssxRunnerQuest.mcmActorNames[ai] = ssxRunnerQuest.mcmActorNames[bi]
					bi=1000
				endIf
				bi+=1
			endWhile
			if bi==ssxRunnerQuest.mcmActors.length
				ai=1000 ; No more actors
			else
				oneNull=true
			endIf
		endIf
		ai+=1
	endWhile
	if oneNull
		currentA=none
	endIf


	if currentA==none
		tmpValInt[0]=0
	else
		tmpValInt[0] = ssxRunnerQuest.mcmActors.find(currentA)
		if tmpValInt[0]==-1
			tmpValInt[0]=0
		endIf
	endIf
	
	usedOptions=34
	if tmpValInt[0]<0 || tmpValInt[0]>=ssxRunnerQuest.mcmActorNames.length
		tmpValInt[0]=0
	endIf
	if tmpValInt[1]<0 || tmpValInt[1]>3
		tmpValInt[1]=0
	endIf
	currentA = ssxRunnerQuest.mcmActors[tmpValInt[0]]
	if !currentA
		; Need to clean up
		ssxRunnerQuest.mcmActors[tmpValInt[0]] = ssxRunnerQuest.mcmActors[tmpValInt[0] + 1]
		ssxRunnerQuest.mcmActorNames[tmpValInt[0]] = ssxRunnerQuest.mcmActorNames[tmpValInt[0] + 1]
		currentA = ssxRunnerQuest.mcmActors[tmpValInt[0]]
	endIf
	if currentA
		currentAB = currentA.getLeveledActorBase()
	else
		tmpValInt[1]=0 ; Force the edit
	endIf

	SetCursorFillMode(TOP_TO_BOTTOM)
	AddHeaderOption(ssxRunnerQuest.s("$SSX_SelectActorToEdit"))
	pageOPTs[0] = AddMenuOption("", ssxRunnerQuest.mcmActorNames[tmpValInt[0]])
	pageOPTs[1] = AddMenuOption(ssxRunnerQuest.s("$SSX_Edit"), ssxRunnerQuest.editTypes[tmpValInt[1]])
	AddEmptyOption()
	
	if tmpValInt[1]==0
		if currentA
			AddInputOptionST("UpdateNameIN", ssxRunnerQuest.s("$SSX_Name"), currentA.getDisplayName())
			pageOPTs[10] = AddToggleOption(ssxRunnerQuest.s("$SSX_IsEssential"), currentAB.isEssential())
			pageOPTs[11] = AddToggleOption(ssxRunnerQuest.s("$SSX_IsProtected"), currentAB.isProtected())
			int ro = 0
			if currentA.isOnMount()
				ro = OPTION_FLAG_DISABLED
			endIf
			tmpValInt[12] = currentAB.getWeight() as int
			AddSliderOptionST("UpdateWeightSL", ssxRunnerQuest.s("$SSX_Weight"), tmpValInt[12], "{0}", ro)
			tmpValInt[13] = (currentAB.getHeight() * 100.0) as int
			AddSliderOptionST("UpdateHeightSL", ssxRunnerQuest.s("$SSX_Height"), tmpValInt[13], "{0}", ro)
			pageOPTs[15] = AddToggleOption(ssxRunnerQuest.s("$SSX_IsUnique"), currentAB.IsUnique(), OPTION_FLAG_DISABLED)
			pageOPTs[16] = AddTextOption(ssxRunnerQuest.s("$SSX_Race"), ssxRunnerQuest.getActorRaceID(currentA), OPTION_FLAG_DISABLED)
		else
			AddInputOptionST("UpdateNameIN", ssxRunnerQuest.s("$SSX_Name"), "", OPTION_FLAG_DISABLED)
			pageOPTs[10] = AddToggleOption(ssxRunnerQuest.s("$SSX_IsEssential"), false, OPTION_FLAG_DISABLED)
			pageOPTs[11] = AddToggleOption(ssxRunnerQuest.s("$SSX_IsProtected"), false, OPTION_FLAG_DISABLED)
			tmpValInt[12] = 0
			AddSliderOptionST("UpdateWeightSL", ssxRunnerQuest.s("$SSX_Weight"), 0, "{0}", OPTION_FLAG_DISABLED)
			tmpValInt[13] = 0
			AddSliderOptionST("UpdateHeightSL", ssxRunnerQuest.s("$SSX_Height"), 0, "{0}", OPTION_FLAG_DISABLED)
			pageOPTs[15] = AddToggleOption(ssxRunnerQuest.s("$SSX_IsUnique"), false, OPTION_FLAG_DISABLED)
			pageOPTs[16] = AddTextOption(ssxRunnerQuest.s("$SSX_Race"), "", OPTION_FLAG_DISABLED)
		endIf

	elseIf tmpValInt[1]==1
		; Check if it is a follower, if yes state and add a disband button, if not state and add a recruit button
		; Change the aggresiveness and the friendship
		if currentA!=PlayerRef
			AddTextOption(currentA.getDisplayName(), "", OPTION_FLAG_DISABLED)
			if currentA.isPlayerTeammate()
				AddTextOption(ssxRunnerQuest.s("$SSX_IsFollower"), "", OPTION_FLAG_DISABLED)
				pageOPTs[20] = AddTextOption("", ssxRunnerQuest.s("$SSX_DismissV"))
				pageOPTs[21] = AddTextOption("", ssxRunnerQuest.s("$SSX_DismissL"))
			else
				AddTextOption(ssxRunnerQuest.s("$SSX_IsNotFollower"), "", OPTION_FLAG_DISABLED)
				pageOPTs[22] = AddTextOption("", ssxRunnerQuest.s("$SSX_RecruitV"))
				pageOPTs[23] = AddTextOption("", ssxRunnerQuest.s("$SSX_RecruitL"))
			endIf
		endIf
		AddEmptyOption()
		if currentA!=PlayerRef
			pageOPTs[24] = AddMenuOption(ssxRunnerQuest.s("$SSX_RelationshipRank"), ssxRunnerQuest.relRanks[currentA.GetRelationshipRank(PlayerRef) + 4])
		endIf

	elseIf tmpValInt[1]==2
		if currentA!=factionsA
			setFactionsAndNames(currentA)
			factionsA=currentA
		endIf
	
		AddInputOptionST("factionFilterINP", ssxRunnerQuest.s("$SSX_FactionsFilter"), factionFilter)
		if tmpValInt[30]>-1 && tmpValInt[30]<factionFilters.length
			pageOPTs[30] = AddMenuOption(ssxRunnerQuest.s("$SSX_SelectFaction"), factionFilters[tmpValInt[30]])
		else
			pageOPTs[30] = AddMenuOption(ssxRunnerQuest.s("$SSX_SelectFaction"), "")
		endIf
		pageOPTs[31] = AddTextOption(ssxRunnerQuest.s("$SSX_AddFaction"), ssxRunnerQuest.s("$SSX_Add"))
		AddEmptyOption()
		; if a faction is selected, then show the slider, if not, gray it out
		if tmpValInt[33]==-1 || tmpValInt[33] >= currentFactions.length
			pageOPTs[33] = AddTextOption(ssxRunnerQuest.s("$SSX_NoFactionSelected"), "", OPTION_FLAG_DISABLED)
		else
			pageOPTs[33] = AddTextOption("", ssxRunnerQuest.s("$SSX_CurrentFaction", currentFactionsNames[tmpValInt[33]]), OPTION_FLAG_DISABLED)
			AddSliderOptionST("FactionRankSL", ssxRunnerQuest.s("$SSX_FactionRank"), currentA.getFactionRank(currentFactions[tmpValInt[33]] As Faction), "{0}")
			pageOPTs[32] = AddTextOption(ssxRunnerQuest.s("$SSX_RemoveFaction"), ssxRunnerQuest.s("$SSX_Remove"))
		endIf
		SetCursorPosition(1)
		int i=0
		num=0
		while i<currentFactions.length && i<78
			if currentFactions[i] && currentA.isInFaction(currentFactions[i] As Faction)
				String fname = currentFactionsNames[i]
				if fname!=""
					num = 50 + i
					pageOPTs[num] = AddToggleOption(fname + " " + currentA.getFactionRank(currentFactions[i] As Faction), i==tmpValInt[33])
				else
					pageOPTs[50 + i] = -1
				endIf
			else
				pageOPTs[50 + i] = -1
			endIf
			i+=1
		endWhile
		usedOptions = num
	endIf
endFunction

; ((- ---------- Event Management ------------------------------------------------------------------------------------------------------------------

string Function GetCustomControl(int keyCode)
	if keyCode==ssxRunnerQuest.ssxKeyCode && ssxRunnerQuest.ssxKeyCode>1
		return " Quick start/stop for Scent of Sex"
	endIf
	return ""
EndFunction


SSX_Player_Load_Game_Alias Property ssxPlayerLoadGameAlias Auto

Event OnOptionSelect(int option) ; --------------------------------------------------------> SELECT <----------
	; ------------- Options by pageEditMode ----------------------------
	int pos = pageOPTs.find(option)
	
	if pageEditMode==-1 ; Init not done
		SetTextOptionValue(option, "Progressing...")
		ssxPlayerLoadGameAlias.doInit("MCM")
		SetTextOptionValue(option, "Completed")
		Utility.waitMenuMode(1.0)
		ForcePageReset()
	
	elseIf pageEditMode==-2 ; Strings not initialized
		; If we are here, then we click on the Init Strings button. Cannot rely on arrays here
		SetTextOptionValue(option, "Initializing...")
		ssxRunnerQuest.initStringArrays()
		tmpValInt = new int[128]
		tmpValString = new string[128]
		availableRaces = new string[128]
		SetTextOptionValue(option, "DONE!")
		Utility.waitMenuMode(1.0)
		ForcePageReset()
		return
	
	elseIf pageEditMode==0 ; Main
		if pos==0 ; No rules
		elseIf pos==1 ; Scent Applied or Not
			if ssxRunnerQuest.iAmActive
				ssxRunnerQuest.stopSSX()
			else
				ssxRunnerQuest.startSSX(true)
			endIf
			ForcePageReset()
		elseIf pos==2 ; Edit timers
			jumpToPage(2)
		elseIf pos==3 ; Edit sexuality
			jumpToPage(3)
		elseIf pos==4 ; Expertise level
		elseIf pos==5 ; Count anims
			SetTextOptionValue(option, countAnims(None, false, true))
		elseIf pos==6 ; Edit relationships
			jumpToPage(4)
		elseIf pos==7 ; Scan Mode
		elseIf pos==8 ; Edit Config
			jumpToPage(1)
		endIf
		return
		
	elseIf pageEditMode==1 ; Edit Config
		if pos==0 ; MN Priority mode
		elseIf pos==1 ; MN skipActorsInNamedScenes
		elseIf pos==2 ; MN forceStopCombats
		elseIf pos==3 ; MN followersStayInBleedout
		elseIf pos==4 ; BN Sort Rules
			ssxRunnerQuest.sortRules()
			debug.messagebox(ssxRunnerQuest.s("$SSX_SortingCompleted"))
		elseIf pos==5 ; MN popUpDelRule
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==6 ; MN popUpNotSaved
			SetMenuDialogOptions(ssxRunnerQuest.popUpName)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==7 ; MN popUpNameNotUpated
			SetMenuDialogOptions(ssxRunnerQuest.popUpName)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==8 ; TG dontBotherOnSLENFix
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifDontBotherOnSLENFix())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnSLENFix()))
		elseIf pos==9 ; TG dontBotherOnDefeatFix
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix()))
		elseIf pos==10 ; BN Back
			jumpToPage(0)
		elseIf pos==11 ; MN ProtectPlayerOnHealth
		elseIf pos==12 ; MN SafeCheckOfConCAnims
		endIf
	
	elseIf pageEditMode==2 ; Edit Timers
		if pos==0 ; Start right away
			ssxRunnerQuest.startRightAway = 1 - ssxRunnerQuest.startRightAway
			ForcePageReset()
		elseIf pos==1 ; Back
			jumpToPage(0)
		elseIf pos==2 ; Stop Scene for Timeouts
			ssxRunnerQuest.stopSceneInCaseOfTimeOuts = 1 - ssxRunnerQuest.stopSceneInCaseOfTimeOuts
			SetToggleOptionValue(option, ssxRunnerQuest.stopSceneInCaseOfTimeOuts==1)		
		elseIf pos==3 ; Don't Stop Scenes
			ssxRunnerQuest.dontStopScenes = 1 - ssxRunnerQuest.dontStopScenes
			SetToggleOptionValue(option, ssxRunnerQuest.dontStopScenes==1)
		elseIf pos==4 ; MN Checking mode
		endIf
		return
		
	elseIf pageEditMode==3 ; Edit Sexuality
		if pos==0 ; Gender Mode
		elseIf pos==1 ; Player Orientation
		elseIf pos==2 ; HM=M Orientation Mode
		elseIf pos==3 ; HF=F Orientation Mode
		elseIf pos==4 ; CM=S Orientation Mode
		elseIf pos==5 ; CF=B Orientation Mode
		elseIf pos==6 ; Use SL Sexuality
		elseIf pos==7 ; Exclude actors with cum
		elseIf pos==8 ; BN Add/Remove faction spells
			if Math.LogicalAnd(ssxRunnerQuest.factionSpells, 1)==1 ; Remove
				ssxRunnerQuest.factionSpells = math.LogicalAnd(0xFFFFFE, ssxRunnerQuest.factionSpells)
				PlayerRef.removeSpell(ssxAddToFactionGroup1)
				PlayerRef.removeSpell(ssxAddToFactionGroup2)
				PlayerRef.removeSpell(ssxAddToFactionGroup3)
				PlayerRef.removeSpell(ssxAddToFactionGroup4)
				PlayerRef.removeSpell(ssxAddToFactionGroup5)
				ForcePageReset()
			else
				ssxRunnerQuest.factionSpells = math.LogicalOr(1, ssxRunnerQuest.factionSpells)
				PlayerRef.addSpell(ssxAddToFactionGroup1, false)
				PlayerRef.addSpell(ssxAddToFactionGroup2, false)
				PlayerRef.addSpell(ssxAddToFactionGroup3, false)
				PlayerRef.addSpell(ssxAddToFactionGroup4, false)
				PlayerRef.addSpell(ssxAddToFactionGroup5, false)
				ForcePageReset()
			endIf
		elseIf pos==9 ; MN Group Color
		elseIf pos==10 ; MN Group Color
		elseIf pos==11 ; MN Group Color
		elseIf pos==12 ; MN Group Color
		elseIf pos==13 ; MN Group Color
			pageOPTs[6] = AddMenuOption(ssxRunnerQuest.s("$SSX_ColorToHighlightGroup1"), ssxRunnerQuest.colors[ssxRunnerQuest.getFactionGroupColor(1)])
		elseIf pos==14 ; Back
			jumpToPage(0)
		endIf
		return
		
	elseIf pageEditMode==4 ; Edit Relationships
		if pos==0 ; MN Increase Speech
		elseIf pos==1 ; MN Increase relationship
		elseIf pos==2 ; MN Max rel rank
		elseIf pos==3 ; BN Back
			jumpToPage(0)
		endIf
		return
		
	elseIf pageEditMode==10 ; Rules list
		if pos==0 ; Add rule
			; Create a new rule with the specified values; Find an available slot in the rules
			ruleEditIndex = -1
			int i = 0
			while i<ssxRunnerQuest.rules.length && ruleEditIndex==-1
				SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
				if r.inUse==0
					ruleEditIndex = i
				endIf
				i += 1
			endWhile
			if ruleEditIndex==-1
				Debug.MessageBox("You already have too many defined rules.\nThe max number of rules is: " + ssxRunnerQuest.rules.length)
				return
			endIf
			isRuleEdit = false
			editRuleL0.init(ssxRunnerQuest.s("$SSX_noname"))
			editingLevel=0
			jumpToPage(11)
		
		elseIf pos==1 ; Edit rule
			; edit the current selected rule with the specified values. Find the rule index
			if curRuleIndex==-1
				ruleEditIndex = -1
				Debug.MessageBox(ssxRunnerQuest.s("$SSX_NoRuleIsSelected"))
				return
			endIf
			ruleEditIndex = tmpValInt[curRuleIndex + 10]
			isRuleEdit = true
			editRuleL0.copyFrom(ssxRunnerQuest.rules[ruleEditIndex])
			editRuleL0.id = ssxRunnerQuest.rules[ruleEditIndex].id
			editingLevel=0
			jumpToPage(11)
		
		elseIf pos==2 ; Delete rule
			; Ask confirmation and then delete the rule
			SSX_Rule_Alias r = ssxRunnerQuest.rules[tmpValInt[curRuleIndex + 10]]
			bool res = ShowMessage(ssxRunnerQuest.s("$SSX_ConfirmDeleteOneRule", r.name), true, ssxRunnerQuest.s("$SSX_ConfirmDeleteOneRuleY"), ssxRunnerQuest.s("$SSX_ConfirmDeleteOneRuleN"))
			if res
				if ssxRunnerQuest.popUpDelRule==1
					Debug.messagebox(ssxRunnerQuest.s("$SSX_SingleRuleDeleted", r.name))
				endIf
				r.inUse = 0
				curRuleIndex = -1
			endIf
			ssxRunnerQuest.countRules()
			ForcePageReset()
		
		elseIf pos==3 ; Duplicate rule
			if curRuleIndex==-1
				Debug.MessageBox(ssxRunnerQuest.s("$SSX_NoRuleIsSelected"))
				return
			endIf
			SSX_Rule_Alias srcRule = ssxRunnerQuest.rules[tmpValInt[curRuleIndex + 10]]
			; Get a rule slot that is empty
			SSX_Rule_Alias dstRule = None
			int i = 0
			while i < ssxRunnerQuest.rules.length
				dstRule = ssxRunnerQuest.rules[i]
				if dstRule.inUse==0
					i = 1000
				endIf
				i += 1
			endWhile
			if i<1000
				Debug.MessageBox(ssxRunnerQuest.s("$SSX_TooManyRulesToDuplicate"))
				return
			endIf
			dstRule.copyFrom(srcRule)
			i=1000
			int e=Utility.RandomInt(1, 65535)
			while i > 0 && ssxRunnerQuest.getRuleById(e) ; not 100% sure about this but seems reasonable -- Reikiri
				e=Utility.RandomInt(1, 65535)
				i -= 1
			endWhile
			dstRule.id = e
			dstRule.inUse=2
			dstRule.name += " DUP"
			; SLEN Check and warning
			if !canIBeAskedSLENFix && dstRule.getAskBeforeSex()
				int slenOrder = Game.GetModByName("SexLab Eager NPCs.esp")
				int ssxOrder = Game.GetModByName("Scent of Sex.esp")
				if slenOrder!=-1 && slenOrder!=255 && slenOrder>ssxOrder
					if !ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnSLENFix()) && !ShowMessage(ssxRunnerQuest.s("$SSX_SLENWarning", slenOrder, ssxOrder), true, ssxRunnerQuest.s("$SSX_SLENWIWIll"), ssxRunnerQuest.s("$SSX_SLENWNoAndDontBother"))
						 ssxRunnerQuest.setDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix(), true)
					endIf
				endIf
			endIf
			ForcePageReset()
		
		elseIf pos==4 ; Enable rule
			SSX_Rule_Alias r = ssxRunnerQuest.rules[tmpValInt[curRuleIndex + 10]]
			; Check the race filters
			if !ssxRunnerQuest.atLeastOneValidRace(r, 0)
				if !ShowMessage(ssxRunnerQuest.s("$SSX_CannotActivateTheRuleForMissingDstRaces", r.dstRaces), ssxRunnerQuest.s("$SSX_YesNoYes"), ssxRunnerQuest.s("$SSX_YesNoNo"))
					return
				endIf
				String[] parts = StringUtil.split(r.dstRaces, ";")
				int i = parts.length
				while i
					i-=1
					ssxRunnerQuest.enableRace(parts[i], 1)
				endWhile
			endIf
			if !ssxRunnerQuest.atLeastOneValidRace(r, 0)
				if !ShowMessage(ssxRunnerQuest.s("$SSX_CannotActivateTheRuleForMissingSrcRaces", r.srcRaces), ssxRunnerQuest.s("$SSX_YesNoYes"), ssxRunnerQuest.s("$SSX_YesNoNo"))
					return
				endIf
				String[] parts = StringUtil.split(r.srcRaces, ";")
				int i = parts.length
				while i
					i-=1
					ssxRunnerQuest.enableRace(parts[i], 1)
				endWhile
			endIf
			if !ssxRunnerQuest.atLeastOneValidRace(r, 0)
				if !ShowMessage(ssxRunnerQuest.s("$SSX_CannotActivateTheRuleForMissingCollRaces", r.collRaces), ssxRunnerQuest.s("$SSX_YesNoYes"), ssxRunnerQuest.s("$SSX_YesNoNo"))
					return
				endIf
				String[] parts = StringUtil.split(r.collRaces, ";")
				int i = parts.length
				while i
					i-=1
					ssxRunnerQuest.enableRace(parts[i], 1)
				endWhile
			endIf
			r.inUse = 2
			if r.isStartingOn(12) && Game.GetModByName("SexLabDefeat.esp")!=255 && Game.GetModByName("SexLabDefeat.esp")!=-1 && !ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix())
				if !ShowMessage(ssxRunnerQuest.s("$SSX_DefeatWarning"), true, ssxRunnerQuest.s("$SSX_SLENWIWIll"), ssxRunnerQuest.s("$SSX_SLENWNoAndDontBother"))
					ssxRunnerQuest.setDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix(), true)
				endIf
			endIf
			ForcePageReset()
		
		elseIf pos==5 ; Disable rule
			SSX_Rule_Alias r = ssxRunnerQuest.rules[tmpValInt[curRuleIndex + 10]]
			r.inUse = 1
			ForcePageReset()
		
		elseIf pos==6 ; CountAnims
			SSX_Rule_Alias r = ssxRunnerQuest.rules[tmpValInt[curRuleIndex + 10]]
			SetTextOptionValue(option, countAnims(r, false, true))
		elseIf pos==7 ; Filter Rules
		elseIf pos==8 ; DeleteAllRules
			; Ask confirmation and then delete the rule
			if ShowMessage(ssxRunnerQuest.s("$SSX_ConfirmDeleteAllRules"), true, ssxRunnerQuest.s("$SSX_ConfirmDeleteAllRulesY"), ssxRunnerQuest.s("$SSX_ConfirmDeleteAllRulesN"))
				if !ShowMessage(ssxRunnerQuest.s("$SSX_ConfirmDeleteAllRules2"), true, ssxRunnerQuest.s("$SSX_ConfirmDeleteAllRulesY2"), ssxRunnerQuest.s("$SSX_ConfirmDeleteAllRulesN2"))
					int i = ssxRunnerQuest.rules.length
					while i
						i -= 1
						SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
						r.inUse = 0
					endWhile
					if ssxRunnerQuest.popUpDelRule==1
						Debug.messagebox(ssxRunnerQuest.s("$SSX_AllRulesDeleted"))
					endIf
					ForcePageReset()
				endIf
			endIf
		elseIf pos==9 ; Import/Export
			String[] jsonRulesTmp = JSONUtil.JsonInFolder("../Scent of Sex/")
			if jsonRulesTmp.length>1
				jsonRules = SSX_Runner_Quest.CreateStringArray(jsonRulesTmp.length - 1)
				num=0
				int i = jsonRulesTmp.length
				while i
					i-=1
					if jsonRulesTmp[i]!="Scent of Sex Config.json" && StringUtil.find(jsonRulesTmp[i], "Scent of Sex_Translation_")==-1
						jsonRules[num] = StringUtil.subString(jsonRulesTmp[i], 0, StringUtil.getLength(jsonRulesTmp[i]) - 5)
						num+=1
					endIf
				endWhile
			else
				jsonRules[0] = ""
			endIf
			jumpToPage(21, true)
		elseIf pos>9 && pos <80; It is a rule
			curRuleIndex = pos - 10
			; Update the curValues with the definition of the selected rule
			ruleEditIndex = tmpValInt[pos]
			editRuleL0.copyFrom(ssxRunnerQuest.rules[ruleEditIndex])
			editingLevel=0
			int i = 0
			while i < numOpRules
				SetToggleOptionValue(pageOPTs[i + 10], i==curRuleIndex, true)
				i += 1
			endWhile
			ForcePageReset()
		
		endIf
		return

	elseIf pageEditMode==11 ; Add/Edit Rule
		if pos==0 ; Generate Name
			String prevName = editRuleL0.name
			editRuleL0.name = generateName()
			editRuleL0.automaticName = true
			ForcePageReset()
		elseIf pos==1 ; Calculate Participants
		elseIf pos==2 ; Edit Participants
			editRuleL1.copyFrom(editRuleL0)
			editingLevel=1
			jumpToPage(12)
		elseIf pos==3 ; Calculate StartsOn
		elseIf pos==4 ; Edit StartsOn
			editRuleL1.copyFrom(editRuleL0)
			ssxRunnerQuest.generateRuleNames(editRuleL1.id)
			editingLevel=1
			jumpToPage(20, true)
		elseIf pos==5 ; Calculate Anims/Tags
		elseIf pos==6 ; Change Anims/Tags
			editRuleL1.copyFrom(editRuleL0)
			editingLevel=1
			int h = editRuleL1.getHumanityFullVal()
			ssxRunnerQuest.getAllAnimationNames(editRuleL0.getNumPlayers(), humanity=h, name="", tag="", raceTypes=ssxRunnerQuest.getRaceTypes(editRuleL1, h==1))
			tmpValString[0] = "name, id, or tag"
			if editRuleL1.specificAnimIDs!=""
				tmpValInt[0]=0
			else
				tmpValInt[0]=1
			endIf
			tmpValInt[10]=-1
			jumpToPage(14, true)
		elseIf pos==7 ; Change Rule Properties
			editRuleL1.copyFrom(editRuleL0)
			editingLevel=1
			if editRuleL1.timeBeforeReDo==0.0
				tmpValInt[2] = 0
			else
				tmpValInt[2] = 1
			endIf
			jumpToPage(18, true)
			
		elseIf pos==8 ; Change Interactions
			editRuleL1.copyFrom(editRuleL0)
			editingLevel=1
			jumpToPage(17, true)
		elseIf pos==9 ; Edit Locations
			editRuleL1.copyFrom(editRuleL0)
			editingLevel=1
			jumpToPage(19, true)
		elseIf pos==10 ; Count anims
			SetTextOptionValue(option, countAnims(editRuleL0, editRuleL0.canBeAggressive(), true))
		elseIf pos==11 ; Save
			if saveTheRuleActually(false)
				jumpToPage(10)
			endIf
		elseIf pos==12 ; Cancel
			if ruleEditIndex!=-1 && ssxRunnerQuest.rules[ruleEditIndex].didAnyChange(editRuleL0) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL0.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			isRuleEdit = false
			ruleEditIndex = -1
			editingLevel=-1
			jumpToPage(10)
		endIf
		return
		
	elseIf pageEditMode==12 ; Edit participants
		if pos==0 ; Target description
		elseIf pos==1 ; Target edit
			positionEdited=0
			editRuleL2.copyFrom(editRuleL1)
			editingLevel=2
			jumpToPage(13)
		elseIf pos==2 ; Source description
		elseIf pos==3 ; Source edit
			positionEdited=1
			editRuleL2.copyFrom(editRuleL1)
			editingLevel=2
			jumpToPage(13)
		elseIf pos==4 ; Collaborator description
		elseIf pos==5 ; Collaborator edit
			positionEdited=2
			editRuleL2.copyFrom(editRuleL1)
			editingLevel=2
			jumpToPage(13)
		elseIf pos==6 ; Number of collaborators
		elseIf pos==8 ; Save
			if editingLevel==1
				editRuleL0.copyFrom(editRuleL1)
			elseIf editingLevel==2
				editRuleL0.copyFrom(editRuleL2)
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==9 ; Cancel
			if editRuleL0.didAnyChange(editRuleL1) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL1.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==10 ; Quick Target Settings
		elseIf pos==11 ; Quick Source Settings
		elseIf pos==12 ; Quick Collaborator Settings
		elseIf pos==13 ; TG Optional Collaborators
			editRuleL1.toggleOptionalCollaborators()
			SetToggleOptionValue(option, editRuleL1.getOptionalCollaborators())
		endIf
		return

	elseIf pageEditMode==13 ; Edit Specific participant
		if pos==0 ; MN Position Type
		elseIf pos==1 ; MN Sex
		elseIf pos==2 ; MN Fellowship
		elseIf pos==3 ; MN Humanity
		elseIf pos==4 ; TG Do not involve me
			tmpValInt[1]=1 - tmpValInt[1]
			SetToggleOptionValue(option, tmpValInt[1]==1)
			editRuleL2.setDoNotInvolveMe(positionEdited, tmpValInt[1]==1)
		elseIf pos==5 ; TX Edit Race Filters
			jumpToPage(15)
		elseIf pos==6 ; TX Edit Wearables
			jumpToPage(16)
		elseIf pos==7 ; TX Edit Mods
			jumpToPage(23)
		elseIf pos==8 ; TX Position values
		elseIf pos==9 ; TX Position name
		elseIf pos==10 ; MN Pick Actor/Faction/Relationship
		elseIf pos==11 ; TX Add Actor/Faction/Relationship
			if editRuleL2.isSpecific(positionEdited)
				editRuleL2.addSpecificActor(positionEdited, ssxRunnerQuest.mcmActors[tmpValInt[0]])
			elseIf editRuleL2.isFaction(positionEdited)
				if tmpValInt[0]>-1 && tmpValInt[0]<factionFilters.length
					int fPos=ssxRunnerQuest.mcmFactionNames.find(factionFilters[tmpValInt[0]])
					if fPos!=-1
						editRuleL2.addSpecificFaction(positionEdited, ssxRunnerQuest.mcmFactions[fPos] As Faction)
					endIf
				endIf
			elseIf editRuleL2.isRelationship(positionEdited)
				editRuleL2.addSpecificRelationship(positionEdited, ssxRunnerQuest.associations[tmpValInt[0]])
			endIf
			ForcePageReset()
		elseIf pos==12 ; TX Clear Actor/Faction/Relationship
			if positionEdited==0
				editRuleL2.dstIDs=""
			elseIf positionEdited==1
				editRuleL2.srcIDs=""
			else
				editRuleL2.collIDs=""
			endIf
			ForcePageReset()
		elseIf pos==13 ; MN highlight color
		elseIf pos==14 ; MN highlight components
		elseIf pos==15 ; TX Save
			if (editRuleL2.isSpecific(positionEdited) || editRuleL2.isFaction(positionEdited) || editRuleL2.isRelationship(positionEdited)) && editRuleL2.getIDs(positionEdited)==""
				debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningYouNeedToSpecify"))
				return
			endIf
			editRuleL1.copyFrom(editRuleL2)
			editingLevel=1
			if positionEdited==2
				if !editRuleL1.isNobody(2) && editRuleL1.getNumColls()==0
					editRuleL1.setNumColls(1)
				else
					editRuleL1.setNumColls(0)
				endIf
			endIf
			jumpToPage(12)
		elseIf pos==16 ; TX Cancel
			if editRuleL1.didAnyChange(editRuleL2) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL1.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			jumpToPage(12)
		elseIf pos==17 ; BN Edit negative faction filter
			jumpToPage(28)
		endIf
		return


	elseIf pageEditMode==14 ; Edit Animations and Tags Indirection
		if pos==0 ; Go Tags Consensual
			editRuleL2.copyFrom(editRuleL1)
			editingLevel=2
			jumpToPage(24)
		elseIf pos==1 ; Go Anims Consensual
			editRuleL2.copyFrom(editRuleL1)
			editingLevel=2
			jumpToPage(25)
		elseIf pos==2 ; Go Tags Aggressive
			editRuleL2.copyFrom(editRuleL1)
			editingLevel=2
			jumpToPage(26)
		elseIf pos==3 ; Go Anims Aggressive
			editRuleL2.copyFrom(editRuleL1)
			editingLevel=2
			jumpToPage(27)
		elseIf pos==4 ; In Case of Aggressiveness
		elseIf pos==5 ; Save
			editRuleL0.copyFrom(editRuleL1)
			editingLevel=0
			jumpToPage(11)
		elseIf pos==6 ; Cancel
			if editRuleL0.didAnyChange(editRuleL1) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL2.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos<11 ; Not used, ignore
		endIf
		return


	elseIf pageEditMode==24 ; Edit Tags Consensual
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
			tmpValInt[0]=0
			ForcePageReset()
		elseIf pos==1 ; BN Tags AND/OR
			editRuleL2.setAllTagsRequired(false, !editRuleL2.allTagsRequired(false))
			ForcePageReset()
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
			tmpValInt[0]=1
			ForcePageReset()
		elseIf pos==3 ; MN Gender tags
		elseIf pos==4 ; MN Player Gender tags
		elseIf pos==5 ; MN Tag list
		elseIf pos==6 ; BN Add from list
			String theTag = ssxRunnerQuest.allTags[tmpValInt[5]]
			if tmpValInt[0]==0
				if StringUtil.find(editRuleL2.tags, theTag)!=-1
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_tagsalreadyinrequiredtags", theTag))
				elseif StringUtil.find(editRuleL2.tags, theTag)==-1
					if editRuleL2.tags==""
						editRuleL2.tags=theTag
					else
						editRuleL2.tags+=","+theTag
					endIf
				endIf
			elseIf tmpValInt[0]==1
				if StringUtil.find(editRuleL2.avoid, theTag)!=-1
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_tagsalreadyinavoidtagsdup", theTag))
				elseif StringUtil.find(editRuleL2.avoid, theTag)==-1
					if editRuleL2.avoid==""
						editRuleL2.avoid=theTag
					else
						editRuleL2.avoid+=","+theTag
					endIf
				endIf
			endIf
			ForcePageReset()
		elseIf pos==7 ; BN Add Typed Tag
			; Check if the tag actually exists
			if ssxRunnerQuest.allTags.find(tmpValString[7])==-1
				Debug.MessageBox(ssxRunnerQuest.s("$SSX_MissingTag", tmpValString[7]))
				return
			endIf
			if tmpValInt[0]==0
				if StringUtil.find(editRuleL2.tags, tmpValString[7])!=-1
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_tagsalreadyinrequiredtags", tmpValString[7]))
				elseif StringUtil.find(editRuleL2.tags, tmpValString[7])==-1
					if editRuleL2.tags==""
						editRuleL2.tags=tmpValString[7]
					else
						editRuleL2.tags+=","+tmpValString[7]
					endIf
				endIf
			elseIf tmpValInt[0]==1
				if StringUtil.find(editRuleL2.avoid, tmpValString[7])!=-1
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_tagsalreadyinavoidtagsdup", tmpValString[7]))
				elseif StringUtil.find(editRuleL2.avoid, tmpValString[7])==-1
					if editRuleL2.avoid==""
						editRuleL2.avoid=tmpValString[7]
					else
						editRuleL2.avoid+=","+tmpValString[7]
					endIf
				endIf
			endIf
			ForcePageReset()
		elseIf pos==8 ; BN Clear tags
			if tmpValInt[0]==0
				editRuleL2.tags=""
			elseIf tmpValInt[0]==1
				editRuleL2.avoid=""
			endIf
			ForcePageReset()
		elseIf pos==9 ; BN Count Anims
			SetTextOptionValue(option, countAnims(editRuleL2, false, false))
		elseIf pos==10 ; BN Save
			; Saving Tags: remove anims
			editRuleL2.specificAnimIDs=""
			editRuleL1.copyFrom(editRuleL2)
			editingLevel=1
			jumpToPage(14)
		elseIf pos==11 ; Cancel
			if editRuleL1.didAnyChange(editRuleL2) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL2.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=1
			jumpToPage(14)
		endIf
		return

	elseIf pageEditMode==25 ; Edit Tags Aggressive
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
			tmpValInt[0]=0
			ForcePageReset()
		elseIf pos==1 ; BN Tags AND/OR
			editRuleL2.setAllTagsRequired(true, !editRuleL2.allTagsRequired(true))
			ForcePageReset()
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
			tmpValInt[0]=1
			ForcePageReset()
		elseIf pos==3 ; MN Gender tags
		elseIf pos==4 ; MN Player Gender tags
		elseIf pos==5 ; MN Tag list
		elseIf pos==6 ; BN Add from list
			String theTag = ssxRunnerQuest.allTags[tmpValInt[5]]
			if tmpValInt[0]==0
				if StringUtil.find(editRuleL2.tagsA, theTag)!=-1
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_tagsalreadyinrequiredtags", theTag))
				elseif StringUtil.find(editRuleL2.tagsA, theTag)==-1
					if editRuleL2.tagsA==""
						editRuleL2.tagsA=theTag
					else
						editRuleL2.tagsA+=","+theTag
					endIf
				endIf
			elseIf tmpValInt[0]==1
				if StringUtil.find(editRuleL2.avoidA, theTag)!=-1
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_tagsalreadyinavoidtagsdup", theTag))
				elseif StringUtil.find(editRuleL2.avoidA, theTag)==-1
					if editRuleL2.avoidA==""
						editRuleL2.avoidA=theTag
					else
						editRuleL2.avoidA+=","+theTag
					endIf
				endIf
			endIf
			ForcePageReset()
		elseIf pos==7 ; BN Add Typed Tag
			; Check if the tag actually exists
			if ssxRunnerQuest.allTags.find(tmpValString[7])==-1
				Debug.MessageBox(ssxRunnerQuest.s("$SSX_MissingTag", tmpValString[7]))
				return
			endIf
			if tmpValInt[0]==0
				if StringUtil.find(editRuleL2.tagsA, tmpValString[7])!=-1
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_tagsalreadyinrequiredtags", tmpValString[7]))
				elseif StringUtil.find(editRuleL2.tagsA, tmpValString[7])==-1
					if editRuleL2.tagsA==""
						editRuleL2.tagsA=tmpValString[7]
					else
						editRuleL2.tagsA+=","+tmpValString[7]
					endIf
				endIf
			elseIf tmpValInt[0]==1
				if StringUtil.find(editRuleL2.avoidA, tmpValString[7])!=-1
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_tagsalreadyinavoidtagsdup", tmpValString[7]))
				elseif StringUtil.find(editRuleL2.avoidA, tmpValString[7])==-1
					if editRuleL2.avoidA==""
						editRuleL2.avoidA=tmpValString[7]
					else
						editRuleL2.avoidA+=","+tmpValString[7]
					endIf
				endIf
			endIf
			ForcePageReset()
		elseIf pos==8 ; BN Clear tags
			if tmpValInt[0]==0
				editRuleL2.tagsA=""
			elseIf tmpValInt[0]==1
				editRuleL2.avoidA=""
			endIf
			ForcePageReset()
		elseIf pos==9 ; BN Count Anims
			SetTextOptionValue(option, countAnims(editRuleL2, true, false))
		elseIf pos==10 ; BN Save
			; Saving Tags: remove anims
			editRuleL2.specificAnimAIDs=""
			editRuleL1.copyFrom(editRuleL2)
			editingLevel=1
			jumpToPage(14)
		elseIf pos==11 ; Cancel
			if editRuleL1.didAnyChange(editRuleL2) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL2.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=1
			jumpToPage(14)
		endIf
		return

	elseIf pageEditMode==26 ; Edit Anims Consensual
		if pos==0 ; IN Type anim filter
		elseIf pos==1 ; MN Select anim
		elseIf pos==2 ; BN Add
			String animName = ssxRunnerQuest.animNames[tmpValInt[1]]
			sslBaseAnimation anim = SexLab.getAnimationByName(animName)
			if !anim
				anim = SexLab.GetCreatureAnimationByName(animName)
			endIf
			if anim
				if StringUtil.find(editRuleL2.specificAnimIDs, anim.registry)==-1
					if editRuleL2.specificAnimIDs==""
						editRuleL2.specificAnimIDs = anim.registry
					else
						editRuleL2.specificAnimIDs += ";" + anim.registry
					endIf
				endIf
			endIf
			ForcePageReset()
		elseIf pos==3 ; BN Clear
			editRuleL2.specificAnimIDs = ""
			ForcePageReset()
		elseIf pos==4 ; MN Gender Tags
		elseIf pos==5 ; MN player Gender Tags
		elseIf pos==6 ; BN Count
			SetTextOptionValue(option, countAnims(editRuleL2, false, false))
		elseIf pos==7 ; BN Save
			; Saving Tags: remove tags
			editRuleL2.tags=""
			editRuleL2.avoid=""
			editRuleL1.copyFrom(editRuleL2)
			editingLevel=1
			jumpToPage(14)
		elseIf pos==8 ; BN Cancel
			if editRuleL1.didAnyChange(editRuleL2) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL2.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=1
			jumpToPage(14)
		elseIf pos>19 && pos<80 ; BN Remove anim
			string[] parts = StringUtil.split(editRuleL2.specificAnimIDs, ";")
			editRuleL2.specificAnimIDs=""
			int i = 0
			while i<parts.length
				if i+20!=pos
					editRuleL2.specificAnimIDs+=parts[i]+";"
				endIf
				i+=1
			endWhile
			if editRuleL2.specificAnimIDs!=""
				editRuleL2.specificAnimIDs = StringUtil.subString(editRuleL2.specificAnimIDs, 0, StringUtil.getLength(editRuleL2.specificAnimIDs) - 1)
			endIf
			ForcePageReset()
		endIf
		return
		
	elseIf pageEditMode==27 ; Edit Anims Aggressive
		if pos==0 ; IN Type anim filter
		elseIf pos==1 ; MN Select anim
		elseIf pos==2 ; BN Add
			String animName = ssxRunnerQuest.animNames[tmpValInt[1]]
			sslBaseAnimation anim = SexLab.getAnimationByName(animName)
			if !anim
				anim = SexLab.GetCreatureAnimationByName(animName)
			endIf
			if anim
				if StringUtil.find(editRuleL2.specificAnimAIDs, anim.registry)==-1
					if editRuleL2.specificAnimAIDs==""
						editRuleL2.specificAnimAIDs = anim.registry
					else
						editRuleL2.specificAnimAIDs += ";" + anim.registry
					endIf
				endIf
			endIf
			ForcePageReset()
		elseIf pos==3 ; BN Clear
			editRuleL2.specificAnimAIDs = ""
			ForcePageReset()
		elseIf pos==4 ; MN Gender Tags
		elseIf pos==5 ; MN player Gender Tags
		elseIf pos==6 ; BN Count
			SetTextOptionValue(option, countAnims(editRuleL2, true, false))
		elseIf pos==7 ; BN Save
			; Saving Tags: remove tags
			editRuleL2.tagsA=""
			editRuleL2.avoidA=""
			editRuleL1.copyFrom(editRuleL2)
			editingLevel=1
			jumpToPage(14)
		elseIf pos==8 ; BN Cancel
			if editRuleL1.didAnyChange(editRuleL2) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL2.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=1
			jumpToPage(14)
		elseIf pos>19 && pos<80 ; BN Remove anim
			string[] parts = StringUtil.split(editRuleL2.specificAnimAIDs, ";")
			editRuleL2.specificAnimAIDs=""
			int i = 0
			while i<parts.length
				if i+20!=pos
					editRuleL2.specificAnimAIDs+=parts[i]+";"
				endIf
				i+=1
			endWhile
			if editRuleL2.specificAnimAIDs!=""
				editRuleL2.specificAnimAIDs = StringUtil.subString(editRuleL2.specificAnimAIDs, 0, StringUtil.getLength(editRuleL2.specificAnimAIDs) - 1)
			endIf
			ForcePageReset()
		endIf
		return

	elseIf pageEditMode==15 ; Edit Race Filters
		if pos==0 ; MN Race Mode
		elseIf pos==1 ; MN Pick Race
		elseIf pos==2 ; BN Add race
			String theRace
			int i = editRuleL2.getHumanityPart(positionEdited)
			if i==1 ; Humans
				theRace = ssxRunnerQuest.allValidRacesH[tmpValInt[1]]
			elseIf i==2 ; Creatures
				theRace = ssxRunnerQuest.allValidRacesC[tmpValInt[1]]
			else ; Both = 0
				theRace = ssxRunnerQuest.allValidRacesB[tmpValInt[1]]
			endIf
			editRuleL2.addRaceFilter(positionEdited, theRace)
			ForcePageReset()
			
		elseIf pos==3 ; BN Clear races
			if positionEdited==0
				editRuleL2.dstRaces=""
			elseIf positionEdited==1
				editRuleL2.srcRaces=""
			else
				editRuleL2.collRaces=""
			endIf
			ForcePageReset()
				
		elseIf pos==4 ; BN Back
			jumpToPage(13)
		elseIf pos>=20 && pos<40 ; BN Remove selected race
			String theRaces = editRuleL2.getRaceFilter(positionEdited)
			String[] parts = StringUtil.split(theRaces, ";")
			int i = 0
			theRaces=""
			while i<parts.length
				if parts[i]!=tmpValString[pos]
					theRaces+=parts[i]+";"
				endIf
				i+=1
			endWhile
			if theRaces!=""
				theRaces = StringUtil.subString(theRaces, 0, StringUtil.getLength(theRaces) - 1)
			endIf
			if positionEdited==0
				editRuleL2.dstRaces=theRaces
			elseIf positionEdited==1
				editRuleL2.srcRaces=theRaces
			else
				editRuleL2.collRaces=theRaces
			endIf
			ForcePageReset()

		endIf
		return
			
	elseIf pageEditMode==16 ; Position wearables
		if pos==0 ; Pick wearables
		elseIf pos==1 ; Add wearables start
			editRuleL2.setWearable(positionEdited, true, ssxRunnerQuest.currentArmorsIDs[tmpValInt[0]])
			ForcePageReset()
		elseIf pos==2 ; Add wearables end
			editRuleL2.setWearable(positionEdited, false, ssxRunnerQuest.currentArmorsIDs[tmpValInt[0]])
			ForcePageReset()
		elseIf pos==3 ; Clear wearables start
			editRuleL2.setWearable(positionEdited, true, "")
			ForcePageReset()
		elseIf pos==4 ; Clear wearables end
			editRuleL2.setWearable(positionEdited, false, "")
			ForcePageReset()
		elseIf pos==5 ; Strip mode
		elseIf pos==6 ; Back
			jumpToPage(13)
		elseIf pos>9 && pos< 40
			editRuleL2.removeWearable(positionEdited, true, pos - 20)
			ForcePageReset()
		elseIf pos>39 && pos<70
			editRuleL2.removeWearable(positionEdited, false, pos - 40)
			ForcePageReset()
		endIf

	elseIf pageEditMode==17 ; Rule interactions
		if pos==0 ; NM AskBeforeSex
		elseIf pos==1 ; MN Ask dialogue
		elseIf pos==2 ; MN Answer on SpeechCraft
		elseIf pos==3 ; MN Positive Answer
		elseIf pos==4 ; MN Positive Answer probability
		elseIf pos==5 ; MN Negative Answer
		elseIf pos==6 ; MN Negative Answer probability
		elseIf pos==7 ; MN Rape on denials
		elseIf pos==8 ; MN Agreesiveness on denials
		elseIf pos==9 ; MN Mast on denials
		elseIf pos==10 ; MN Final sentence
		elseIf pos==11 ; MN Aggressiveness
		elseIf pos==12 ; MN Victim
		elseIf pos==13 ; not used
		elseIf pos==14 ; MN Combats
		elseIf pos==15 ; MN Save
			if editingLevel==1
				editRuleL0.copyFrom(editRuleL1)
			elseIf editingLevel==2
				editRuleL0.copyFrom(editRuleL2)
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==16 ; MN Cancel
			if editRuleL0.didAnyChange(editRuleL1) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL1.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=0
			jumpToPage(11)
		endIf
		
	elseIf pageEditMode==18 ; Rule properties
		if pos==0 ; MN Probability
		elseIf pos==1 ; MN Beds
		elseIf pos==2 ; MN Use timeout
		elseIf pos==3 ; BN Save
			if editingLevel==1
				editRuleL0.copyFrom(editRuleL1)
			elseIf editingLevel==2
				editRuleL0.copyFrom(editRuleL2)
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==4 ; BN Cancel
			if editRuleL0.didAnyChange(editRuleL1) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL1.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==5 ; BN Scale Actors
		elseIf pos>9 && pos<15 ; TG Select description line
			string[] descrs = StringUtil.split(editRuleL1.description, "\n")
			int i = 0
			tmpValString[10] = ""
			tmpValInt[10] = -1
			while i<5
				if i + 10 == pos
					tmpValInt[10] = i
					if i<descrs.length
						tmpValString[10] = descrs[i]
					else
						tmpValString[10] = ""
					endIf
				endIf
				i+=1
			endWhile
			ForcePageReset()
		elseIf pos==15 ; MN Allow Orgies
		elseIf pos==16 ; TG Enable Foreplay
			bool foreplay = !editRuleL1.hasLeadIn()
			if foreplay
				sslBaseAnimation[] anims = SexLab.GetAnimationsByTags(editRuleL0.getNumPlayers(), "LeadIn")
				if !anims || anims.length==0
					Debug.MessageBox(ssxRunnerQuest.s("$ssx_warnforeplaymissing", editRuleL1.getNumPlayers()))
					return
				endIf
			endIf
			editRuleL1.setLeadIn(foreplay)
			SetToggleOptionValue(option, foreplay)
		elseIf pos==17 ; MN Spectators masturbate
		endIf

	elseIf pageEditMode==19 ; Rule locations
		if pos==0 ; MN Select location
		elseIf pos==1 ; BN Add location
			String locID = PO3_SKSEFunctions.GetFormEditorID(ssxRunnerQuest.locations[tmpValInt[0]])
			if StringUtil.find(editRuleL1.locations, locID)==-1
				if editRuleL1.locations==""
					editRuleL1.locations = locID
				else
					editRuleL1.locations += ";" + locID
				endIf
			endIf
			ForcePageReset()
			
		elseIf pos==2 ; BN Add current location
			String locID = PO3_SKSEFunctions.GetFormEditorID(PlayerRef.getCurrentLocation())
			if StringUtil.find(editRuleL1.locations, locID)==-1
				if editRuleL1.locations==""
					editRuleL1.locations = locID
				else
					editRuleL1.locations += ";" + locID
				endIf
			endIf
			ForcePageReset()
			
		elseIf pos==3 ; MN Select location type
		elseIf pos==4 ; BN Add location type
			String locID=""
			if tmpValInt[3]>=0 && tmpValInt[3]<ssxRunnerQuest.LocTypes.length
				locID = PO3_SKSEFunctions.GetFormEditorID(ssxRunnerQuest.LocTypes[tmpValInt[3]])
			endIf
			if locID!="" && StringUtil.find(editRuleL1.locationTypes, locID)==-1
				if editRuleL1.locationTypes==""
					editRuleL1.locationTypes = locID
				else
					editRuleL1.locationTypes += ";" + locID
				endIf
			endIf
			ForcePageReset()
			
		elseIf pos==5 ; BN Clear all
			editRuleL1.locations=""
			editRuleL1.locationTypes=""
			ForcePageReset()
			
		elseIf pos==6 ; MN Internal/External
		elseIf pos==7 ; Save
			if editingLevel==1
				editRuleL0.copyFrom(editRuleL1)
			elseIf editingLevel==2
				editRuleL0.copyFrom(editRuleL2)
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==8 ; Cancel
			if editRuleL0.didAnyChange(editRuleL1) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL1.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==9 ; BN Add current cell
			String cellID = PO3_SKSEFunctions.GetFormEditorID(PlayerRef.getParentCell())
			if StringUtil.find(editRuleL1.cells, cellID)==-1
				if editRuleL1.cells==""
					editRuleL1.cells = cellID
				else
					editRuleL1.cells += ";" + cellID
				endIf
			endIf
			ForcePageReset()
		
		elseIf pos==10 ; MN Inclusive/Exclusive cells
		elseIf pos>=20 && pos<50 ; BN Remove specific location/cell
			String toRemove = tmpValString[pos]
			if StringUtil.find(editRuleL1.locations, toRemove)!=-1
				if editRuleL1.locations==toRemove
					editRuleL1.locations=""
				else
					String[] parts=StringUtil.split(editRuleL1.locations, ";")
					int i = 0
					editRuleL1.locations=""
					while i<parts.length
						if parts[i]!=toRemove
							editRuleL1.locations+=parts[i]+";"
						endIf
						i+=1
					endWhile
					editRuleL1.locations = StringUtil.subString(editRuleL1.locations, 0, StringUtil.getLength(editRuleL1.locations) - 1)
				endIf
			elseIf StringUtil.find(editRuleL1.cells, toRemove)!=-1
				if editRuleL1.cells==toRemove
					editRuleL1.cells=""
				else
					String[] parts=StringUtil.split(editRuleL1.cells, ";")
					int i = 0
					editRuleL1.cells=""
					while i<parts.length
						if parts[i]!=toRemove
							editRuleL1.cells+=parts[i]+";"
						endIf
						i+=1
					endWhile
					editRuleL1.cells = StringUtil.subString(editRuleL1.cells, 0, StringUtil.getLength(editRuleL1.cells) - 1)
				endIf
			elseIf StringUtil.find(editRuleL1.locationTypes, toRemove)!=-1
				if editRuleL1.locationTypes==toRemove
					editRuleL1.locationTypes=""
				else
					String[] parts=StringUtil.split(editRuleL1.locationTypes, ";")
					int i = 0
					editRuleL1.locationTypes=""
					while i<parts.length
						if parts[i]!=toRemove
							editRuleL1.locationTypes+=parts[i]+";"
						endIf
						i+=1
					endWhile
					editRuleL1.locationTypes = StringUtil.subString(editRuleL1.locationTypes, 0, StringUtil.getLength(editRuleL1.locationTypes) - 1)
				endIf
			endIf
			ForcePageReset()
		endIf
	

	elseIf pageEditMode==20 ; Rule Start mode
		if pos==0 ; MN StartsOn
		elseIf pos==1 ; BN Clean
			editRuleL1.setStartOn(0, 0, 0, 0, 0)
			ForcePageReset()
		elseIf pos==2 ; BN Save
			if editingLevel==1
				editRuleL0.copyFrom(editRuleL1)
			elseIf editingLevel==2
				editRuleL0.copyFrom(editRuleL2)
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==3 ; BN Cancel
			if editRuleL0.didAnyChange(editRuleL1) && ssxRunnerQuest.popUpNotSaved==1
				bool res = ShowMessage(ssxRunnerQuest.s("$SSX_WarningRuleNotSaved", editRuleL1.name), true, ssxRunnerQuest.s("$SSX_WarningRuleNotSavedY"), ssxRunnerQuest.s("$SSX_WarningRuleNotSavedN"))
				if res
					return
				endIf
			endIf
			editingLevel=0
			jumpToPage(11)
		elseIf pos==20 ; BN Random (ReadOnly)
		elseIf pos==21 ; MN Naked
		elseIf pos==22 ; MN SeeNaked
		elseIf pos==23 ; MN SeeSex
		elseIf pos==24 ; MN Arousal
		elseIf pos==25 ; MN Health
		elseIf pos==26 ; MN Stamina
		elseIf pos==27 ; MN Magicka
		elseIf pos==28 ; MN Sleeping
		elseIf pos==29 ; MN Sneaking
		elseIf pos==30 ; MN HasWeapon
		elseIf pos==31 ; MN InCombat
		elseIf pos==32 ; MN Bleedout
		elseIf pos==33 ; MN Unconscious
		elseIf pos==34 ; MN StartTime timeOfTheDay
		elseIf pos==35 ; MN EndTime timeOfTheDay
		elseIf pos==36 ; MN Sequence
		elseIf pos==41 ; BN Naked
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMBeNaked(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==42 ; BN SeeNaked
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMSeeNaked(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==43 ; BN SeeSex
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMSeeSex(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==44 ; BN Arousal
			if editRuleL1.arousalLevel<1
				editRuleL1.arousalLevel=50
			endIf
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMArousal(), 1, -1, -1, editRuleL1.arousalLevel)
			ForcePageReset()
		elseIf pos==45 ; BN Health
			if editRuleL1.healthLevel<1
				editRuleL1.healthLevel=50
			endIf
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMHealth(), 1, -1, -1, editRuleL1.healthLevel)
			ForcePageReset()
		elseIf pos==46 ; BN Stamina
			if editRuleL1.staminaLevel<1
				editRuleL1.staminaLevel=50
			endIf
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMStamina(), 1, -1, -1, editRuleL1.staminaLevel)
			ForcePageReset()
		elseIf pos==47 ; BN Magicka
			if editRuleL1.magickaLevel<1
				editRuleL1.magickaLevel=50
			endIf
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMMagicka(), 1, -1, -1, editRuleL1.magickaLevel)
			ForcePageReset()
		elseIf pos==48 ; BN Sleeping
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMSleep(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==49 ; BN Sneaking
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMSneak(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==50 ; BN Weapon
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMWeapon(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==51 ; BN Combat
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMCombat(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==52 ; BN Bleedout
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMBleedOut(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==53 ; BN Unconscious
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMUnconscious(), 1, -1, -1, 50)
			ForcePageReset()
		elseIf pos==54 ; BN Time
			editRuleL1.setStartTimer(8, 20)
			ForcePageReset()
		elseIf pos==55 ; BN Edit Wearables
			editRuleL2.copyFrom(editRuleL1)
			jumpToPage(29)
		elseIf pos==56 ; BN Add Wearables
			editRuleL1.setStartOn(SSX_Rule_Alias.getSMWearables(), 1, 1, 1, -1)
			ForcePageReset()
		endIf
	
	elseIf pageEditMode==21 ; Import/Export rules
		if pos>-1 && pos<64 ; TG Rule
			tmpValInt[pos] = 1 - tmpValInt[pos]
			SetToggleOptionValue(option, tmpValInt[pos]==1)
			; Check if we need to enable the export button or not
			check=false
			int i = 64
			while i
				i-=1
				if tmpValInt[i]!=0
					check=true
				endIf
			endWhile
			if check
				SetOptionFlags(pageOPTs[65], OPTION_FLAG_NONE)
			else
				SetOptionFlags(pageOPTs[65], OPTION_FLAG_DISABLED)
			endIf
		elseIf pos==64 ; MN MultipleExportJoined
		elseIf pos==65 ; BN Export Selected
			exportRules(false)
		elseIf pos==66 ; BN Export All
			exportRules(true)
		elseIf pos==67 ; MN Import rules mode
		elseIf pos==68 ; MN Select rule
		elseIf pos==69 ; BN Check rule
			jumpToPage(22, true)
		elseIf pos==70 ; BN Import selected
			importRules(false)
			ForcePageReset()
		elseIf pos==71 ; BN Import All
			importRules(true)
			ForcePageReset()
		elseIf pos==72 ; BN Back
			jumpToPage(10)
		endIf

	elseIf pageEditMode==22 ; Rule check
		if pos==0 ; Description
		elseIf pos==1 ; BN Back
			jumpToPage(21)
		endIf

	elseIf pageEditMode==23 ; Edit Position Mods
		if pos==0 ; MN Pick mod1
		elseIf pos==1 ; BN Add1
			editRuleL2.addMod(positionEdited, ssxRunnerQuest.modsSet1[tmpValInt[0]])
			ForcePageReset()
		elseIf pos==2 ; MN Pick mod 2
		elseIf pos==3 ; BN Add2
			editRuleL2.addMod(positionEdited, ssxRunnerQuest.modsSet2[tmpValInt[2]])
			ForcePageReset()
		elseIf pos==4 ; MN Pick mod 3
		elseIf pos==5 ; BN Add3
			editRuleL2.addMod(positionEdited, ssxRunnerQuest.modsSet3[tmpValInt[4]])
			ForcePageReset()
		elseIf pos==6 ; MN Pick mod 4
		elseIf pos==7 ; BN Add4
			editRuleL2.addMod(positionEdited, ssxRunnerQuest.modsSet4[tmpValInt[6]])
			ForcePageReset()
		elseIf pos==8 ; BN Clear
			editRuleL2.clearMods(positionEdited)
			ForcePageReset()
		elseIf pos==9 ; BN Back
			jumpToPage(13)
		elseIf pos>9 && pos<50 ; BN remove mod
			editRuleL2.removeMod(positionEdited, pos - 10)
			ForcePageReset()
		endIf


	elseIf pageEditMode==28 ; Edit negative faction filter
		if pos==0 ; read only position type
		elseIf pos==1 ; MN Pick Faction
		elseIf pos==2 ; BN Add Faction
			if tmpValInt[1]>-1 && tmpValInt[1]<factionFilters.length
				int fPos=ssxRunnerQuest.mcmFactionNames.find(factionFilters[tmpValInt[1]])
				if fPos!=-1
					editRuleL2.addNegativeFaction(ssxRunnerQuest.mcmFactions[fPos] As Faction, positionEdited)
				endIf
				ForcePageReset()
			endIf
		elseIf pos==3 ; BN Clean all factions
			editRuleL2.removeAllNegativeFaction(positionEdited)
			ForcePageReset()
		elseIf pos==4 ; BN Show Factions
			Actor a = Game.GetCurrentCrosshairRef() as Actor
			String res=""
			if a
				res="Factions of " + a.getDisplayName() + ":\n"
			else
				a=PlayerRef
				res="Factions of the Player:\n"
			endIf
			Faction[] facts = a.getFactions(-127,127)
			int i=0
			while i<facts.length
				String fn = SSX_Runner_Quest.getNameAndEditorID(facts[i])
				if fn
					res+=fn+"\n"
				endIf
				i+=1
			endWhile
			Debug.MessageBox(res)
		
		elseIf pos==5 ; BN Back
			jumpToPage(13)
		elseIf pos>9 && pos<60 ; BN Remove specific faction
			editRuleL2.removeNegativeFaction(tmpValString[pos], positionEdited)
			ForcePageReset()
		endIf

	elseIf pageEditMode==29 ; Edit Starting Wearables
		if pos==0 ; MN Participant
		elseIf pos==1 ; MN Has to/Not to
		elseIf pos==2 ; MN Pick wearable
		elseIf pos==3 ; BN Add wearable
			if editRuleL2.setHasToWear(tmpValInt[0], (tmpValInt[1]==0), ssxRunnerQuest.currentArmorsIDs[tmpValInt[2]])
				ForcePageReset()
			endIf
		elseIf pos==4 ; MN Pick Keyword
		elseIf pos==5 ; BN Add keyword
			if editRuleL2.setHasToWear(tmpValInt[0], tmpValInt[1]==0, ssxRunnerQuest.armorKeywordIDs[tmpValInt[4]])
				ForcePageReset()
			endIf
		elseIf pos==6 ; BN Clear wearables
			String prev = editRuleL2.getHasToWear(tmpValInt[0], tmpValInt[1]==0)
			editRuleL2.clearHasToWear(tmpValInt[0], tmpValInt[1]==0)
			if prev!=""
				ForcePageReset()
			endIf
		elseIf pos==7 ; BN Back
			; In case all wearables are removed, remove the start condition
			if editRuleL2.hasToWearDst=="" && editRuleL2.notToWearDst=="" && editRuleL2.hasToWearSrc=="" && editRuleL2.notToWearSrc=="" && editRuleL2.hasToWearColl=="" && editRuleL2.notToWearColl==""
				editRuleL2.setStartOn(SSX_Rule_Alias.getSMWearables(), 0, 0, 0, -1)
			endIf
			editRuleL1.copyFrom(editRuleL2)
			jumpToPage(20)
		elseIf pos==8 ; BN Check player
			editRuleL2.generateClothes()
			if ssxRunnerQuest.checkClothes(editRuleL2, PlayerRef, tmpValInt[0])
				debug.messagebox(ssxRunnerQuest.s("$SSX_CheckingWearablesForGood", PlayerRef.getDisplayName()))
			else
				debug.messagebox(ssxRunnerQuest.s("$SSX_CheckingWearablesForBad", PlayerRef.getDisplayName()))
			endIf
		elseIf pos==9 ; BN Check actor
			Actor a = Game.GetCurrentCrosshairRef() as Actor
			if a
				editRuleL2.generateClothes()
				if ssxRunnerQuest.checkClothes(editRuleL2, a, tmpValInt[0])
					debug.messagebox(ssxRunnerQuest.s("$SSX_CheckingWearablesForGood", a.getDisplayName()))
				else
					debug.messagebox(ssxRunnerQuest.s("$SSX_CheckingWearablesForBad", a.getDisplayName()))
				endIf
			endIf
		elseIf pos>0 ; BN Remove nth wearable
			editRuleL2.clearNthHasToWear(tmpValInt[0], tmpValInt[1]==0, pos - 10)
			ForcePageReset()
		endIf
		
	elseIf pageEditMode==30 ; Nudity
		if pos==0 ; MN Helmet
		elseIf pos==1 ; MN Armor
		elseIf pos==2 ; MN Forearms
		elseIf pos==3 ; MN Gloves
		elseIf pos==4 ; MN Calves
		elseIf pos==5 ; MN Shoes
		elseIf pos==6 ; MN Pelvis
		elseIf pos==7 ; BN Now player is
		elseIf pos==8 ; BN Actor crosshair
		elseIf pos==9 ; MN Armor pieces
		elseIf pos==10 ; BN Add armor piece
			; We have the index. Get the ID from the index
			String id = ssxRunnerQuest.currentArmorsIDs[tmpValInt[9]]
			if ssxRunnerQuest.nudeArmorsIDs.find(id)!=-1
				return
			endIf
			; Add it to the naked list (resize if necessary)
			int i = ssxRunnerQuest.nudeArmorsIDs.find("")
			if i==-1
				ssxRunnerQuest.nudeArmorsIDs = ssxRunnerQuest.ResizeStringArray(ssxRunnerQuest.nudeArmorsIDs, ssxRunnerQuest.nudeArmorsIDs.length + 64, "")
				i = ssxRunnerQuest.nudeArmorsIDs.find("")
			endIf
			ssxRunnerQuest.nudeArmorsIDs[i] = id
			ForcePageReset()
			
		elseIf pos==11 ; MN Armor keyword pieces
		elseIf pos==12 ; BN Add armor keyword
			ssxRunnerQuest.armorKeywordConsideredNaked[tmpValInt[11]]=1
			ForcePageReset()

		elseIf pos==13 ; BN Clear
			int i = ssxRunnerQuest.nudeArmorsIDs.length
			while i
				i-=1
				ssxRunnerQuest.nudeArmorsIDs[i]=""
			endWhile
			i=ssxRunnerQuest.armorKeywordConsideredNaked.length
			while i
				i-=1
				ssxRunnerQuest.armorKeywordConsideredNaked[i]=0
			endWhile
			ForcePageReset()
		elseIf pos>=20 && pos<50 ; BN Remove
			String id = tmpValString[pos]
			if ssxRunnerQuest.armorKeywordIDs.find(id)!=-1
				ssxRunnerQuest.armorKeywordConsideredNaked[ssxRunnerQuest.armorKeywordIDs.find(id)]=0
				ForcePageReset()
				return
			endIf
			if ssxRunnerQuest.nudeArmorsIDs.find(id)!=-1
				int i = ssxRunnerQuest.nudeArmorsIDs.find(id)
				ssxRunnerQuest.nudeArmorsIDs[i]=""
				ForcePageReset()
				return
			endIf
		endIf
		
	elseIf pageEditMode==40 ; Global Races Filter
		if pos==0 ; MN Races to Filter
		elseIf pos==1 ; BN Enable All
			int i = 10
			while i<usedOptions
				String r = tmpValString[i]
				if r!=""
					if !ssxRunnerQuest.isCreatureRace(r) || ssxRunnerQuest.hasRaceValidAnimations(r)
						tmpValInt[i] = 1
						ssxRunnerQuest.enableRace(r, 1)
						SetToggleOptionValue(pageOPTs[i], true)
					else
						tmpValInt[i] = 0
						ssxRunnerQuest.enableRace(r, 1)
						SetToggleOptionValue(pageOPTs[i], false)
					endIf
				endIf
				i+=1
			endWhile

		elseIf pos==2 ; BN Disable All
			int i = 10
			while i<usedOptions
				String r = tmpValString[i]
				if r!=""
					tmpValInt[i] = 0
					ssxRunnerQuest.enableRace(r, 0)
					SetToggleOptionValue(pageOPTs[i], false)
				endIf
				i+=1
			endWhile
			
		elseIf pos>9 && pos <110 ; TG Enable/Disable race
			String r = tmpValString[pos]
			if r!=""
				if ssxRunnerQuest.isCreatureRace(r) && !ssxRunnerQuest.hasRaceValidAnimations(r)
					debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningRaceNoAnims", r))
					return
				endIf
				tmpValInt[pos] = 1 - tmpValInt[pos]
				ssxRunnerQuest.enableRace(r, tmpValInt[pos])
				SetToggleOptionValue(option, tmpValInt[pos]==1)
			endIf
		endIf

	elseIf pageEditMode==60 ; Anims
		if pos==0 ; MN Race filter
		elseIf pos==1 ; BN Enable all anims
			int i = usedOptions
			while i
				i-=1
				if tmpValString[i]!=""
					JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".anims." + tmpValString[i], 1)
				endIf
			endWhile
			ForcePageReset()
		elseIf pos==2 ; BN Disable all anims
			int i = usedOptions
			while i
				i-=1
				if tmpValString[i]!=""
					JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".anims." + tmpValString[i], 0)
				endIf
			endWhile
			ForcePageReset()
		elseIf pos>9 ; Toggle anim
			if tmpValString[pos]!=""
				int enabled = JSONUtil.GetPathIntValue(ssxRunnerQuest.configFile, ".anims." + tmpValString[pos], 0)
				enabled = 1 - enabled
				JSONUtil.SetPathIntValue(ssxRunnerQuest.configFile, ".anims." + tmpValString[pos], enabled)
				SetToggleOptionValue(option, enabled==1)
			endIf
		endIf
	

	elseIf pageEditMode==70 ; Debug
		if pos==0 ; TG Active/Deactive N
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifActivationN())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActivationN()))
		elseIf pos==1 ; TG Active/Deactiva T
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifActivationT())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActivationT()))
		elseIf pos==2 ; TG What is going on N
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifWhatIsGoingOnN())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifWhatIsGoingOnN()))
		elseIf pos==3 ; TG What is going on T
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifWhatIsGoingOnT())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifWhatIsGoingOnT()))
		elseIf pos==4 ; TG Num actors N
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifActorsInScanN())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorsInScanN()))
		elseIf pos==5 ; TG Num actors T
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifActorsInScanT())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorsInScanT()))
		elseIf pos==6 ; TG Rule played N
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifRulePlayedN())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifRulePlayedN()))
		elseIf pos==7 ; TG Rule played T
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifRulePlayedT())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifRulePlayedT()))
		elseIf pos==8 ; TG Anim played N
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifAnimPlayedN())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifAnimPlayedN()))
		elseIf pos==9 ; TG Anim played T
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifAnimPlayedT())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifAnimPlayedT()))
		elseIf pos==10 ; BN AdvDebug
			jumpToPage(71)
		elseIf pos==11 ; BN Highlight Actors
			jumpToPage(72)
		elseIf pos==12 ; BN ForceActorsCleanUp
			SetTextOptionValue(option, "Please wait...")
			ssxRunnerQuest.forceActorsCleanUp()
			SetTextOptionValue(option, "Done!")
			Debug.MessageBox("Actors Clean Up completed.")
		elseIf pos==13 ; BN CleanUpActorAround
			if ssxRunnerQuest.clenUpActorsAround
				int handle = ModEvent.Create("stopSSXCleaning") 
				ModEvent.PushString(handle, "DoIt")
				ModEvent.Send(handle)
			else
				if ssxRunnerQuest.iAmActive==1
					ssxRunnerQuest.stopSSX()
				endIf
				Utility.waitMenuMode(0.1)
				int handle = ModEvent.Create("startSSXCleaning") 
				ModEvent.PushString(handle, "DoIt")
				ModEvent.Send(handle)
			endIf
			Utility.waitMenuMode(0.5)
			ForcePageReset()
			
		elseIf pos==14 ; BN ForceRestart
			SetTextOptionValue(option, "Restarting...")
			SetOptionFlags(option, OPTION_FLAG_DISABLED)
			ForceRestart()
		elseIf pos==15 ; BN Rescan Tags
			int handler = ModEvent.create("ssxRescanTags")
			ModEvent.PushString(handler, "MCM")
			ModEvent.send(handler)
			SetTextOptionValue(option, ssxRunnerQuest.s("$ssx_rescanning"))
		endIf
		return

	elseIf pageEditMode==71 ; Advanced Debug
		if pos==0 ; TG notifTimeToComplete
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifTimeToComplete())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifTimeToComplete()))
		elseIf pos==1 ; TG notifWarnings
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifWarnings())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifWarnings()))
		elseIf pos==2 ; TG notifErrors
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifErrors())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifErrors()))
		elseIf pos==3 ; TG notifCombats
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifCombats())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifCombats()))
		elseIf pos==4 ; TG notifRelationship
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifRelationship())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifRelationship()))
		elseIf pos==5 ; TG notifBadRule
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifBadRule())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifBadRule()))
		elseIf pos==6 ; TG notifActorForRule
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifActorForRule())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorForRule()))
		elseIf pos==7 ; TG notifActorsFoundLong
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifActorsFoundLong())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifActorsFoundLong()))
		elseIf pos==8 ; TG notifNotGoodActors
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifNotGoodActors())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifNotGoodActors()))
		elseIf pos==9 ; TG notifAnimsScan
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifAnimsScan())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifAnimsScan()))
		elseIf pos==10 ; BN TestPerformance
			if ShowMessage("Are you sure to start the Performance tests?", true, ssxRunnerQuest.s("$ssx_hellyes"), ssxRunnerQuest.s("$ssx_nothanks"))
				doTests = True
				Debug.MessageBox("The Performance Test Guy is active, the test will start about 5 seconds after you exit the MCM.")
			endIf
		elseIf pos==11 ; TG notifScanDetails
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifScanDetails())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifScanDetails()))
		elseIf pos==12 ; TG notifCheckerDetails
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifCheckerDetails())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifCheckerDetails()))
		elseIf pos==13 ; TG notifPlayerDetails
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifPlayerDetails())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifPlayerDetails()))
		elseIf pos==14 ; TG notifSceneManDetails
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifSceneManDetails())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifSceneManDetails()))
		elseIf pos==15 ; TG notifCatchers
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifCatchers())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifCatchers()))
		elseIf pos==16 ; TG notifDeferredDetails
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifDeferredDetails())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDeferredDetails()))
		elseIf pos==17 ; TG notifCleanDetails
			ssxRunnerQuest.changeDebug(SSX_Runner_Quest.notifCleanDetails())
			SetToggleOptionValue(option, ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifCleanDetails()))
		elseIf pos==18 ; BN Back
			jumpToPage(70)
		endIf
		return

	elseIf pageEditMode==72 ; Highlights
		if pos==0 ; TG Found in Scanse
			ssxRunnerQuest.toggleHighlight(SSX_Runner_Quest.highlightScan())
			SetToggleOptionValue(option, ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightScan()))
		elseIf pos==1 ; MC Scan Color
		elseIf pos==2 ; TG Valid for Rule
			ssxRunnerQuest.toggleHighlight(SSX_Runner_Quest.highlightValid())
			SetToggleOptionValue(option, ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightValid()))
		elseIf pos==3 ; TG Potential for Rule
			ssxRunnerQuest.toggleHighlight(SSX_Runner_Quest.highlightPotential())
			SetToggleOptionValue(option, ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightPotential()))
		elseIf pos==4 ; TG Starting Scenes
			ssxRunnerQuest.toggleHighlight(SSX_Runner_Quest.highlightScene())
			SetToggleOptionValue(option, ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightScene()))
		elseIf pos==5 ; TG Actors can be asked for sex
			ssxRunnerQuest.toggleHighlight(SSX_Runner_Quest.highlightAsk())
			SetToggleOptionValue(option, ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightAsk()))
		elseIf pos==6 ; MN Ask color
		elseIf pos==7 ; TG Cleaned by Cleaner
			ssxRunnerQuest.toggleHighlight(SSX_Runner_Quest.highlightClean())
			SetToggleOptionValue(option, ssxRunnerQuest.getHighlight(SSX_Runner_Quest.highlightClean()))
		elseIf pos==8 ; MN Cleaned color
		elseIf pos==9 ; BN back
			jumpToPage(70)
		endIf
		return

	elseIf pageEditMode==80 ; Actors Editor
		if pos==0 ; MN Select Actor
		elseIf pos==1 ; MN Select Edit Mode
		elseIf pos==10 ; TG Essential
			if currentAB.isEssential()
				currentAB.setEssential(false)
				SetToggleOptionValue(option, false)
			else
				currentAB.setEssential(true)
				SetToggleOptionValue(option, true)
			endIf
		elseIf pos==11 ; TG Protected
			if currentAB.isProtected()
				currentAB.setProtected(false)
				SetToggleOptionValue(option, false)
			else
				currentAB.setProtected(true)
				SetToggleOptionValue(option, true)
			endIf
		elseIf pos==15 ; RO Unique
		elseIf pos==16 ; RO Race
		elseIf pos==20 ; BN Dismiss Follower (vanilla)
			if ssxRunnerQuest.isCreature(currentA)
				DialogueFollower.DismissAnimal()
			else
				currentA.StopCombatAlarm()
				currentA.AddToFaction(DialogueFollower.pDismissedFollower)
				currentA.SetPlayerTeammate(false)
				currentA.RemoveFromFaction(DialogueFollower.pCurrentHireling)
				currentA.setActorValue("WaitingForPlayer", 0)
				currentA.RemoveItem(DialogueFollower.FollowerHuntingBow, 999, true)
				currentA.RemoveItem(DialogueFollower.FollowerIronArrow, 999, true)
				if DialogueFollower.pFollowerAlias.getActorRef()==currentA
					DialogueFollower.pPlayerFollowerCount.SetValue(DialogueFollower.pPlayerFollowerCount.GetValue() - 1)
					DialogueFollower.pFollowerAlias.clear()
				endIf
			endIf
			currentA.setPlayerTeamMate(false)
			ForcePageReset()
			
		elseIf pos==21 ; BN Dismiss Follower (light)
			currentA.setPlayerTeamMate(false)
			ForcePageReset()
			
		elseIf pos==22 ; BN Recruit Follower (vanilla)
			if ssxRunnerQuest.isCreature(currentA)
				DialogueFollower.SetAnimal(currentA)
			else
				DialogueFollower.SetFollower(currentA)
			endIf
			ForcePageReset()
			
		elseIf pos==23 ; BN Recruit Follower (light)
			currentA.setPlayerTeamMate(true)
			if currentA.GetRelationshipRank(PlayerRef)<1
				currentA.SetRelationshipRank(PlayerRef, 1)
			endIf
			currentA.addToFaction(currentFollowerFaction)
			currentA.setFactionRank(currentFollowerFaction, -1)
			currentA.addToFaction(potentialFollowerFaction)
			currentA.setFactionRank(potentialFollowerFaction, 0)
			ForcePageReset()

		elseIf pos==24 ; MN Relationship Rank
			

		elseIf pos==30 ; MN Select Faction
		elseIf pos==31 ; BN Add Faction

			if tmpValInt[30]>-1 && tmpValInt[30]<factionFilters.length
				int fPos = ssxRunnerQuest.mcmFactionNames.find(factionFilters[tmpValInt[30]])
				if fPos!=-1
					if !currentA.isInFaction(ssxRunnerQuest.mcmFactions[fPos] As Faction)
						currentA.addToFaction(ssxRunnerQuest.mcmFactions[fPos] As Faction)
						currentA.setFactionRank(ssxRunnerQuest.mcmFactions[fPos] As Faction, 0)
						SetTextOptionValue(option, "Adding...")
						SetOptionFlags(option, OPTION_FLAG_DISABLED)
						setFactionsAndNames(currentA)
						factionsA=currentA
						ForcePageReset()
					endIf
				endIf
			endIf
			
		elseIf pos==32 ; BN Remove Faction
			if tmpValInt[33]>-1 && tmpValInt[33]<currentFactions.length
				if currentA.isInFaction(currentFactions[tmpValInt[33]] As Faction)
					currentA.removeFromFaction(currentFactions[tmpValInt[33]] As Faction)
					SetTextOptionValue(option, "Removing...")
					SetOptionFlags(option, OPTION_FLAG_DISABLED)
					setFactionsAndNames(currentA)
					factionsA=currentA
					ForcePageReset()
				endIf
			endIf

		elseIf pos>=50
			tmpValInt[33] = pos - 50
			ForcePageReset()
		endIf
		return

	endIf
EndEvent

Event OnOptionMenuOpen(int option) ; ------------------------------------------------------> OPEN <----------
	; ------------- Options by pageEditMode ----------------------------
	int pos = pageOPTs.find(option)
	if pageEditMode==0 ; Main
		if pos==0 ; No active rule
		elseIf pos==1 ; Scent Applied or Not
		elseIf pos==2 ; Edit timers
		elseIf pos==3 ; Edit sexuality
		elseIf pos==4 ; Expertise level
			SetMenuDialogOptions(ssxRunnerQuest.expertiseLevels)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==5 ; Count anims
		elseIf pos==6 ; Edit Relationship
		elseIf pos==7 ; Scan Mode
			SetMenuDialogOptions(ssxRunnerQuest.scanModes)
			SetMenuDialogDefaultIndex(3)
		endIf
		return
		
	elseIf pageEditMode==1 ; Edit Config
		if pos==0 ; MN Priority mode
			SetMenuDialogOptions(ssxRunnerQuest.priorityModes)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(ssxRunnerQuest.priorityMode)
		elseIf pos==1 ; MN skipActorsInNamedScenes
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(1)
			SetMenuDialogStartIndex(ssxRunnerQuest.skipActorsInNamedScenes)
		elseIf pos==2 ; MN forceStopCombats
			SetMenuDialogOptions(ssxRunnerQuest.forceStopCombatsMN)
			SetMenuDialogDefaultIndex(3)
			SetMenuDialogStartIndex(ssxRunnerQuest.forceStopCombats)
		elseIf pos==3 ; MN followersStayInBleedout
			SetMenuDialogStartIndex(ssxRunnerQuest.followersStayInBleedout)
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==5 ; MN popUpDelRule
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==6 ; MN popUpNotSaved
			SetMenuDialogOptions(ssxRunnerQuest.popUpName)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==7 ; MN popUpNameNotUpated
			SetMenuDialogOptions(ssxRunnerQuest.popUpName)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==8 ; TG dontBotherOnSLENFix
		elseIf pos==9 ; TG dontBotherOnDefeatFix
		elseIf pos==10 ; BN Back
		elseIf pos==11 ; MN ProtectPlayerOnHealth
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(1)
			SetMenuDialogStartIndex(ssxRunnerQuest.protectOnHealth)
		elseIf pos==12 ; MN SafeCheckOfConCAnims
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(ssxRunnerQuest.safeCheckOfConCAnims)
		endIf
		return
		
	elseIf pageEditMode==2 ; Edit Timers
		if pos==0 ; Start right away
		elseIf pos==1 ; Back
		elseIf pos==2
		elseIf pos==3 ; Don't Stop Scenes
		elseIf pos==4 ; MN Checking mode
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogOptions(ssxRunnerQuest.checkingModes)
			SetMenuDialogStartIndex(ssxRunnerQuest.checkingMode)
		endIf
		return
		
	elseIf pageEditMode==3 ; Edit Sexuality
		if pos==0 ; Gender Mode
			SetMenuDialogOptions(ssxRunnerQuest.genderModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; Player Orientation
			SetMenuDialogOptions(ssxRunnerQuest.playerOrientations)
			SetMenuDialogDefaultIndex(1)
			SetMenuDialogStartIndex(ssxRunnerQuest.playerOrientation)
		elseIf pos==2 ; HM=M Orientation Mode
			if SexLab.AllowCreatures && !ssxRunnerQuest.nexusMode
				SetMenuDialogOptions(ssxRunnerQuest.orientationModesC)
			else
				SetMenuDialogOptions(ssxRunnerQuest.orientationModes)
			endIf
			SetMenuDialogDefaultIndex(2) ; HFemales
			SetMenuDialogStartIndex(ssxRunnerQuest.getSexBitsForType(0))
		elseIf pos==3 ; HF=F Orientation Mode
			if SexLab.AllowCreatures && !ssxRunnerQuest.nexusMode
				SetMenuDialogOptions(ssxRunnerQuest.orientationModesC)
			else
				SetMenuDialogOptions(ssxRunnerQuest.orientationModes)
			endIf
			SetMenuDialogDefaultIndex(1) ; HMales
			SetMenuDialogStartIndex(ssxRunnerQuest.getSexBitsForType(1))
		elseIf pos==4 ; CM=S Orientation Mode
			if SexLab.AllowCreatures && !ssxRunnerQuest.nexusMode
				SetMenuDialogOptions(ssxRunnerQuest.orientationModesC)
			else
				SetMenuDialogOptions(ssxRunnerQuest.orientationModes)
			endIf
			SetMenuDialogDefaultIndex(2) ; HFemales
			SetMenuDialogStartIndex(ssxRunnerQuest.getSexBitsForType(2))
		elseIf pos==5 ; CF=B Orientation Mode
			if SexLab.AllowCreatures && !ssxRunnerQuest.nexusMode
				SetMenuDialogOptions(ssxRunnerQuest.orientationModesC)
			else
				SetMenuDialogOptions(ssxRunnerQuest.orientationModes)
			endIf
			SetMenuDialogDefaultIndex(2) ; HFemales
			SetMenuDialogStartIndex(ssxRunnerQuest.getSexBitsForType(3))
		elseIf pos==6 ; Use SL Sexuality
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==7 ; Exclude Covered in Cum
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogStartIndex(ssxRunnerQuest.excludeActorsWithCum)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==8 ; BN Add/Remove
		elseIf pos==9 ; MN Group Color
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogStartIndex(ssxRunnerQuest.getFactionGroupColor(1))
		elseIf pos==10 ; MN Group Color
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogStartIndex(ssxRunnerQuest.getFactionGroupColor(2))
		elseIf pos==11 ; MN Group Color
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogStartIndex(ssxRunnerQuest.getFactionGroupColor(3))
		elseIf pos==12 ; MN Group Color
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogStartIndex(ssxRunnerQuest.getFactionGroupColor(4))
		elseIf pos==13 ; MN Group Color
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogStartIndex(ssxRunnerQuest.getFactionGroupColor(5))
		elseIf pos==14 ; Back
		endIf
		return

	elseIf pageEditMode==4 ; Edit Relationships
		if pos==0 ; MN Increase Speech
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; MN Increase relationship
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==2 ; MN Max rel rank
			SetMenuDialogOptions(ssxRunnerQuest.relRanks)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==3 ; BN Back
		endIf
		return

	elseIf pageEditMode==10 ; Rule list
		if pos==0 ; Add rule
		elseIf pos==1 ; Edit rule
		elseIf pos==2 ; Delete rule
		elseIf pos==3 ; Duplicate rule
		elseIf pos==4 ; Enable rule
		elseIf pos==5 ; Disable rule
		elseIf pos==6 ; CountAnims
		elseIf pos==7 ; Filter Rules
		elseIf pos==8 ; DeleteAllRules
		endIf
		return

	elseIf pageEditMode==11 ; Add/Edit Rule
		if pos==0 ; Generate Name
		elseIf pos==1 ; Calculate Participants
		elseIf pos==2 ; Edit Participants
		elseIf pos==3 ; Calculate StartsOn
		elseIf pos==4 ; Edit StartsOn
		elseIf pos==5 ; Calculate Anims/Tags
		elseIf pos==6 ; Change Anims/Tags
		elseIf pos==7 ; Change Rule Properties
		elseIf pos==8 ; Change Interactions
		elseIf pos==9 ; Edit Locations
		elseIf pos==10 ; Count anims
		elseIf pos==11 ; Save
		elseIf pos==12 ; Cancel
		endIf
		return

	elseIf pageEditMode==12 ; Edit participants
		if pos==0 ; Target description
		elseIf pos==1 ; Target edit
		elseIf pos==2 ; Source description
		elseIf pos==3 ; Source edit
		elseIf pos==4 ; Collaborator description
		elseIf pos==5 ; Collaborator edit
		elseIf pos==6 ; Number of collaborators
			SetMenuDialogOptions(ssxRunnerQuest.numOfColls)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==7 ; MN Passive role
			SetMenuDialogOptions(ssxRunnerQuest.whoWillBePassive)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==8 ; Save
		elseIf pos==9 ; Cancel
		elseIf pos==10 ; Quick Target Settings
			if ssxRunnerQuest.nexusMode || !SexLab.AllowCreatures
				SetMenuDialogOptions(ssxRunnerQuest.participantQuickSettingsNX)
			else
				SetMenuDialogOptions(ssxRunnerQuest.participantQuickSettingsLL)
			endIf
			SetMenuDialogDefaultIndex(4)
		elseIf pos==11 ; Quick Source Settings
			if ssxRunnerQuest.nexusMode || !SexLab.AllowCreatures
				SetMenuDialogOptions(ssxRunnerQuest.participantQuickSettingsNX)
			else
				SetMenuDialogOptions(ssxRunnerQuest.participantQuickSettingsLL)
			endIf
			SetMenuDialogDefaultIndex(0)
		elseIf pos==12 ; Quick Collaborator Settings
			if ssxRunnerQuest.nexusMode || !SexLab.AllowCreatures
				SetMenuDialogOptions(ssxRunnerQuest.participantQuickSettingsNX)
			else
				SetMenuDialogOptions(ssxRunnerQuest.participantQuickSettingsLL)
			endIf
			SetMenuDialogDefaultIndex(0)
		endIf
		return

	elseIf pageEditMode==13 ; Edit Specific participant
		if pos==0 ; MN Position Type
			SetMenuDialogOptions(ssxRunnerQuest.actTypes)
			if positionEdited==0
				SetMenuDialogDefaultIndex(1) ; Player
			else
				SetMenuDialogDefaultIndex(0) ; Nobody
			endIf
		elseIf pos==1 ; MN Sex
			SetMenuDialogOptions(ssxRunnerQuest.sexActorValue)
			SetMenuDialogDefaultIndex(2) ; Both
		elseIf pos==2 ; MN Fellowship
			SetMenuDialogOptions(ssxRunnerQuest.followerOrNot)
			SetMenuDialogDefaultIndex(2) ; Both
		elseIf pos==3 ; MN Humanity
			SetMenuDialogOptions(ssxRunnerQuest.humanOrCreature)
			SetMenuDialogDefaultIndex(1) ; Human
		elseIf pos==4 ; TG Do not involve me
		elseIf pos==5 ; TX Edit Race Filters
		elseIf pos==6 ; TX Edit Wearables
		elseIf pos==7 ; TX Edit mods
		elseIf pos==8 ; TX Position values
		elseIf pos==9 ; TX Position name
		elseIf pos==10 ; MN Pick Actor/Faction/Relationship
			if editRuleL2.isSpecific(positionEdited)
				SetMenuDialogOptions(ssxRunnerQuest.mcmActorNames)
			elseIf editRuleL2.isFaction(positionEdited)
				SetMenuDialogOptions(factionFilters)
				SetMenuDialogStartIndex(tmpValInt[0])
			elseIf editRuleL2.isRelationship(positionEdited)
				SetMenuDialogOptions(ssxRunnerQuest.associationNames)
			endIf
			SetMenuDialogDefaultIndex(0) ; None
		elseIf pos==11 ; TX Add Actor/Faction/Relationship
		elseIf pos==12 ; TX Clear Actor/Faction/Relationship
		elseIf pos==13 ; MN highlight color
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==14 ; MN highlight components
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==15 ; TX Save
		elseIf pos==16 ; TX Cancel
		elseIf pos==17 ; BN Edit negative faction filter
		endIf
		return
	
	elseIf pageEditMode==14 ; Edit Animations and Tags Indirection
		if pos==0 ; Go Tags Consensual
		elseIf pos==1 ; Go Anims Consensual
		elseIf pos==2 ; Go Tags Aggressive
		elseIf pos==3 ; Go Anims Aggressive
		elseIf pos==4 ; In Case of Aggressiveness
			SetMenuDialogOptions(ssxRunnerQuest.inCaseOfAggressiveness)
			SetMenuDialogDefaultIndex(1) ; Add it
		elseIf pos==5 ; Go Back
		elseIf pos<11 ; Not used, ignore
		endIf
		return

	elseIf pageEditMode==24 || pageEditMode==25 ; Edit Tags Consensual/Aggressive
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
		elseIf pos==1 ; BN Tags AND/OR
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
		elseIf pos==3 ; MN Gender tags
			SetMenuDialogOptions(ssxRunnerQuest.addGenderTagsMenu)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==4 ; MN Player Gender tags
			SetMenuDialogOptions(ssxRunnerQuest.playerGenderTags)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==5 ; MN Tag list
			SetMenuDialogOptions(ssxRunnerQuest.allTags)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==6 ; BN Add from list
		elseIf pos==7 ; BN Add Typed Tag
		elseIf pos==8 ; BN Clear tags
		elseIf pos==9 ; BN Count Anims
		elseIf pos==10 ; BN Save
		elseIf pos==11 ; Cancel
		endIf

	elseIf pageEditMode==26 || pageEditMode==27 ; Edit Anims Consensual/Aggressive
		if pos==0 ; IN Type anim filter
		elseIf pos==1 ; MN Select anim
			SetMenuDialogOptions(ssxRunnerQuest.animNames)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==2 ; BN Add
		elseIf pos==3 ; BN Clear
		elseIf pos==4 ; MN Gender Tags
			SetMenuDialogOptions(ssxRunnerQuest.addGenderTagsMenu)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==5 ; MN player Gender Tags
			SetMenuDialogOptions(ssxRunnerQuest.playerGenderTags)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==6 ; BN Count
		elseIf pos==7 ; BN Save
		elseIf pos==8 ; BN Cancel
		elseIf pos>19 && pos<80 ; BN Remove anim
		endIf
		return

	elseIf pageEditMode==15 ; Edit Race Filters
		if pos==0 ; MN Race Mode
			SetMenuDialogOptions(ssxRunnerQuest.raceInclusiveExclusive)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; MN Pick Race
			int i = editRuleL2.getHumanityPart(positionEdited)
			if i==1 ; Humans
				SetMenuDialogOptions(ssxRunnerQuest.allValidRacesH)
			elseIf i==2 ; Creatures
				SetMenuDialogOptions(ssxRunnerQuest.allValidRacesC)
			else ; Both = 0
				SetMenuDialogOptions(ssxRunnerQuest.allValidRacesB)
			endIf
			SetMenuDialogStartIndex(tmpValInt[1])
		elseIf pos==2 ; BN Add race
		elseIf pos==3 ; BN Clear races
		elseIf pos==4 ; BN Back
		elseIf pos>=20 && pos<40 ; BN Remove selected race
		endIf
		return
		
	elseIf pageEditMode==16 ; Position wearables
		if pos==0 ; Pick wearables
			SetMenuDialogOptions(ssxRunnerQuest.currentArmorsNames)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; Add wearables start
		elseIf pos==2 ; Add wearables end
		elseIf pos==3 ; Clear wearables start
		elseIf pos==4 ; Clear wearables end
		elseIf pos==5 ; Strip mode
			SetMenuDialogOptions(ssxRunnerQuest.stripModes)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(tmpValInt[5])
		elseIf pos==6 ; Back
		elseIf pos>9 && pos< 40
		elseIf pos>39 && pos<70
		endIf
	
	elseIf pageEditMode==17 ; Rule interactions
		if pos==0 ; NM AskBeforeSex
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; MN Ask dialogue
			SetMenuDialogOptions(ssxRunnerQuest.requestDialogues)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==2 ; MN Answer on SpeechCraft
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==3 ; MN Positive Answer
			SetMenuDialogOptions(ssxRunnerQuest.positiveAnswers)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==4 ; MN Positive Answer probability
			SetMenuDialogOptions(ssxRunnerQuest.answerProbs)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==5 ; MN Negative Answer
			SetMenuDialogOptions(ssxRunnerQuest.negativeAnswers)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==6 ; MN Negative Answer probability
			SetMenuDialogOptions(ssxRunnerQuest.answerProbs)
			SetMenuDialogDefaultIndex(4)
		elseIf pos==7 ; MN Rape on denials
			SetMenuDialogOptions(ssxRunnerQuest.percs)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==8 ; MN Agreesiveness on denials
			SetMenuDialogOptions(ssxRunnerQuest.percs)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==9 ; MN Mast on denials
			SetMenuDialogOptions(ssxRunnerQuest.percs)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==10 ; MN Final sentence
			SetMenuDialogOptions(ssxRunnerQuest.npcFinalSentences)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==11 ; MN Aggressiveness
			SetMenuDialogOptions(ssxRunnerQuest.percs)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==12 ; MN Victim
			SetMenuDialogOptions(ssxRunnerQuest.whoIsVictim)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==13 ; MN not used
		elseIf pos==14 ; MN Combats
			SetMenuDialogOptions(ssxRunnerQuest.stopAllCombats)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==15 ; MN Save
		elseIf pos==16 ; MN Cancel
		endIf

	elseIf pageEditMode==18 ; Rule properties
		if pos==0 ; MN Probability
			SetMenuDialogOptions(ssxRunnerQuest.prob)
			SetMenuDialogDefaultIndex(1)
		elseIf pos==1 ; MN Beds
			SetMenuDialogOptions(ssxRunnerQuest.beds)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==2 ; MN Use timeout
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==3 ; BN Save
		elseIf pos==4 ; BN Cancel
		elseIf pos==5 ; BN Scale Actors
			SetMenuDialogOptions(ssxRunnerQuest.scaleActorsVals)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==15 ; MN Allow Orgies
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==17 ; MN Spectators masturbate
			SetMenuDialogOptions(ssxRunnerQuest.spectatorsMasturbates)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(editRuleL1.getSpectatorsMasturbate())
		endIf
		
		
	elseIf pageEditMode==19 ; Rule locations
		if pos==0 ; MN Select location
			SetMenuDialogOptions(ssxRunnerQuest.locationList)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; BN Add location
		elseIf pos==2 ; BN Add current location
		elseIf pos==3 ; MN Select location type
			SetMenuDialogOptions(ssxRunnerQuest.locationTypeList)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==4 ; BN Add location type
		elseIf pos==5 ; BN Clear all
		elseIf pos==6 ; MN Internal/External
			SetMenuDialogOptions(ssxRunnerQuest.intExtMnu)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==7 ; Save
		elseIf pos==8 ; Cancel
		elseIf pos==9 ; BN Add current cell
		elseIf pos==10 ; MN Inclusive/Exclusive cells
			if editRuleL1.getCellInclExcl()
				SetMenuDialogStartIndex(1)
			else
				SetMenuDialogStartIndex(0)
			endIf
			SetMenuDialogOptions(ssxRunnerQuest.inclExclMnu)
			SetMenuDialogDefaultIndex(0)
		elseIf pos>=20 && pos<50 ; BN Remove specific location
		endIf
	
	elseIf pageEditMode==20 ; Rule Start mode
		if pos==0 ; MN StartsOn
			SetMenuDialogOptions(ssxRunnerQuest.startModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; BN Clean
		elseIf pos==2 ; BN Save
		elseIf pos==3 ; BN Cancel
		elseIf pos==20 ; BN Random
		elseIf pos==21 ; MN Naked
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==22 ; MN SeeNaked
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==23 ; MN SeeSex
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==24 ; MN Arousal
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModesVal)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==25 ; MN Health
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModesVal)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==26 ; MN Stamina
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModesVal)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==27 ; MN Magicka
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModesVal)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==28 ; MN Sleeping
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==29 ; MN Sneaking
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==30 ; MN HasWeapon
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==31 ; MN InCombat
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==32 ; MN Bleedout
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==33 ; MN Unconscious
			SetMenuDialogOptions(ssxRunnerQuest.startsOnActorModes)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==34 ; MN StartTime timeOfTheDay
			SetMenuDialogOptions(ssxRunnerQuest.timeOfTheDay)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==35 ; MN EndTime timeOfTheDay
			SetMenuDialogOptions(ssxRunnerQuest.timeOfTheDay)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==36 ; MN Sequence
			SetMenuDialogOptions(ssxRunnerQuest.ruleNames)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==41 ; BN Naked
		elseIf pos==42 ; BN SeeNaked
		elseIf pos==43 ; BN SeeSex
		elseIf pos==44 ; BN Arousal
		elseIf pos==45 ; BN Health
		elseIf pos==46 ; BN Stamina
		elseIf pos==47 ; BN Magicka
		elseIf pos==48 ; BN Sleeping
		elseIf pos==49 ; BN Sneaking
		elseIf pos==50 ; BN Weapon
		elseIf pos==51 ; BN Combat
		elseIf pos==52 ; BN Bleedout
		elseIf pos==53 ; BN Unconscious
		elseIf pos==54 ; BN Time
		endIf
	
	elseIf pageEditMode==21 ; Import/Export rules
		if pos>-1 && pos<64 ; TG Rule
		elseIf pos==64 ; MN MultipleExportJoined
			SetMenuDialogOptions(ssxRunnerQuest.yesNo)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==65 ; BN Export Selected
		elseIf pos==66 ; BN Export All
		elseIf pos==67 ; MN Import rules mode
			SetMenuDialogOptions(ssxRunnerQuest.importRulesMode)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==68 ; MN Select rule
			SetMenuDialogOptions(jsonRules)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==69 ; BN Check rule
		elseIf pos==70 ; BN Import selected
		elseIf pos==71 ; BN Import All
		elseIf pos==72 ; BN Back
		endIf

	elseIf pageEditMode==22 ; Rule check
		if pos==0 ; Description
		elseIf pos==1 ; BN Back
		endIf

	elseIf pageEditMode==23 ; Edit Position Mods
		if pos==0 ; MN Pick mod1
			SetMenuDialogOptions(ssxRunnerQuest.modsSet1)
		elseIf pos==1 ; BN Add1
		elseIf pos==2 ; MN Pick mod 2
			SetMenuDialogOptions(ssxRunnerQuest.modsSet2)
		elseIf pos==3 ; BN Add2
		elseIf pos==4 ; MN Pick mod 3
			SetMenuDialogOptions(ssxRunnerQuest.modsSet3)
		elseIf pos==5 ; BN Add3
		elseIf pos==6 ; MN Pick mod 4
			SetMenuDialogOptions(ssxRunnerQuest.modsSet4)
		elseIf pos==7 ; BN Add4
		elseIf pos==8 ; BN Clear
		elseIf pos==9 ; BN Back
		elseIf pos>9 && pos<50 ; BN remove mod
		endIf

	elseIf pageEditMode==28 ; Edit negative faction filter
		if pos==0 ; read only position type
		elseIf pos==1 ; MN Pick Faction
			SetMenuDialogOptions(factionFilters)
			SetMenuDialogStartIndex(tmpValInt[1])
		elseIf pos==2 ; BN Add Faction
		elseIf pos==3 ; BN Clean all factions
		elseIf pos==4 ; BN Show Factions
		elseIf pos==5 ; BN Back
		elseIf pos>9 && pos<60 ; BN Remove specific faction
		endIf
	
	elseIf pageEditMode==29 ; Edit Starting Wearables
		if pos==0 ; MN Participant
			SetMenuDialogOptions(ssxRunnerQuest.participantEdit)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(tmpValInt[0])
		elseIf pos==1 ; MN Has to/Not to
			SetMenuDialogOptions(ssxRunnerQuest.hasToNotTos)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(tmpValInt[1])
		elseIf pos==2 ; MN Pick wearable
			SetMenuDialogOptions(ssxRunnerQuest.currentArmorsNames)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(tmpValInt[2])
		elseIf pos==3 ; BN Add wearable
		elseIf pos==4 ; MN Pick Keyword
			SetMenuDialogOptions(ssxRunnerQuest.armorKeywordIDs)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(tmpValInt[4])
		elseIf pos==5 ; BN Add keyword
		elseIf pos==6 ; BN Clear wearables
		elseIf pos==7 ; BN Back
		elseIf pos>0 ; BN Remove nth wearable
		endIf
		
	elseIf pageEditMode==30 ; Nudity
		if pos==0 ; MN Helmet
			SetMenuDialogOptions(ssxRunnerQuest.nakedIf)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; MN Armor
			SetMenuDialogOptions(ssxRunnerQuest.nakedIf)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==2 ; MN Forearms
			SetMenuDialogOptions(ssxRunnerQuest.nakedIf)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==3 ; MN Gloves
			SetMenuDialogOptions(ssxRunnerQuest.nakedIf)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==4 ; MN Calves
			SetMenuDialogOptions(ssxRunnerQuest.nakedIf)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==5 ; MN Shoes
			SetMenuDialogOptions(ssxRunnerQuest.nakedIf)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==6 ; MN Pelvis
			SetMenuDialogOptions(ssxRunnerQuest.nakedIf)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==7 ; BN Now player is
		elseIf pos==8 ; BN Actor crosshair
		elseIf pos==9 ; MN Armor pieces
			SetMenuDialogOptions(ssxRunnerQuest.currentArmorsNames)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==10 ; BN Add armor piece
		elseIf pos==11 ; MN Armor keyword pieces
			SetMenuDialogOptions(ssxRunnerQuest.armorKeywordIDs)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==12 ; BN Add armor keyword
		elseIf pos==13 ; BN Clear
		elseIf pos>=20 && pos<50 ; BN Remove
		endIf

	elseIf pageEditMode==40 ; Global Races Filter
		if pos==0 ; MN Races to Filter
			SetMenuDialogOptions(ssxRunnerQuest.racesToFilter)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; BN Enable All
		elseIf pos==2 ; BN Disable All
		elseIf pos>9 ; TG Enable/Disable race
		endIf

	elseIf pageEditMode==60 ; Anims
		if pos==0 ; MN Race filter
			SetMenuDialogOptions(ssxRunnerQuest.racesToFilter)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==1 ; BN Enable all anims
		elseIf pos==2 ; BN Disable all anims
		elseIf pos>9 ; Toggle anim
		endIf
		
	elseIf pageEditMode==70 ; Debug
		if pos==0 ; TG Active/Deactive N
		elseIf pos==1 ; TG Active/Deactiva T
		elseIf pos==2 ; TG What is going on N
		elseIf pos==3 ; TG What is going on T
		elseIf pos==4 ; TG Num actors N
		elseIf pos==5 ; TG Num actors T
		elseIf pos==6 ; TG Rule played N
		elseIf pos==7 ; TG Rule played T
		elseIf pos==8 ; TG Anim played N
		elseIf pos==9 ; TG Anim played T
		elseIf pos==10 ; BN AdvDebug
		elseIf pos==11 ; BN Highlight Actors
		elseIf pos==12 ; BN ForceActorsCleanUp
		elseIf pos==13 ; BN CleanUpActorAround
		elseIf pos==14 ; BN ForceRestart
		elseIf pos==15 ; BN Rescan Tags
		endIf
		return

	elseIf pageEditMode==71 ; Adv Debug
		return
	elseIf pageEditMode==72 ; Highlights
		if pos==0 ; TG Found in Scanse
		elseIf pos==1 ; MN Scan Color
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==2 ; TG Valid for Rule
		elseIf pos==3 ; TG Potential for Rule
		elseIf pos==4 ; TG Starting Scenes
		elseIf pos==5 ; TG Actors can be asked for sex
		elseIf pos==6 ; MN Ask color
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==7 ; TG Cleaned by Cleaner
		elseIf pos==8 ; MN Cleaned color
			SetMenuDialogOptions(ssxRunnerQuest.colors)
			SetMenuDialogDefaultIndex(0)
		elseIf pos==9 ; BN back
		endIf
		return
		
	elseIf pageEditMode==80 ; Actors Editor
		if pos==0 ; MN Select Actor
			SetMenuDialogOptions(ssxRunnerQuest.mcmActorNames)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(tmpValInt[0])
		elseIf pos==1 ; MN Select Edit Mode
			SetMenuDialogOptions(ssxRunnerQuest.editTypes)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(tmpValInt[1])
		elseIf pos==10 ; TG Essential
		elseIf pos==11 ; TG Protected
		elseIf pos==15 ; RO Unique
		elseIf pos==16 ; RO Race
		elseIf pos==24 ; MN Relationship Rank
			SetMenuDialogOptions(ssxRunnerQuest.relRanks)
			SetMenuDialogDefaultIndex(4)
			SetMenuDialogStartIndex(currentA.GetRelationshipRank(PlayerRef) + 4)
		elseIf pos==30 ; MN Select Faction
			SetMenuDialogOptions(factionFilters)
			SetMenuDialogDefaultIndex(0)
			SetMenuDialogStartIndex(tmpValInt[30])
		elseIf pos==31 ; BN Add Faction
			if !currentA.isInFaction(ssxRunnerQuest.mcmFactions[tmpValInt[30]] As Faction)
				currentA.addToFaction(ssxRunnerQuest.mcmFactions[tmpValInt[30]] As Faction)
				currentA.setFactionRank(ssxRunnerQuest.mcmFactions[tmpValInt[30]] As Faction, 0)
				factionsA = None
				ForcePageReset()
			endIf
		elseIf pos==32 ; BN Remove Faction
			if currentA.isInFaction(ssxRunnerQuest.mcmFactions[tmpValInt[30]] As Faction)
				currentA.removeFromFaction(ssxRunnerQuest.mcmFactions[tmpValInt[30]] As Faction)
				factionsA = None
				ForcePageReset()
			endIf
		else
		endIf
		return

	endIf

EndEvent

; Type: 0=Nobody, 1=Player, 2=Generic NPC, 3=Generic and player, 4=Specific NPC, 5=In relationship with 1st, 6=In relationship with 2nd, 7=In factions, 8=same creature

Event OnOptionMenuAccept(int option, int index); ------------------------------------------> ACCEPT <----------
	; ------------- Options by pageEditMode ----------------------------
	int pos = pageOPTs.find(option)
	if pageEditMode==0 ; Main
		if pos==0 ; No active rule
		elseIf pos==1 ; Scent Applied or Not
		elseIf pos==2 ; Edit timers
		elseIf pos==3 ; Edit sexuality
		elseIf pos==4 ; Expertise level
			int prev = ssxRunnerQuest.expertiseLevel
			if index > -1
				ssxRunnerQuest.expertiseLevel = index
			else
				ssxRunnerQuest.expertiseLevel = 1
			endIf
			if prev==0 && ssxRunnerQuest.expertiseLevel > prev
				debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningRefreshMCMToSeeNewpages"))
			endIf
			SetMenuOptionValue(option, ssxRunnerQuest.expertiseLevels[ssxRunnerQuest.expertiseLevel])
			setPageNamesForExpertiseLevel()
			ForcePageReset()
		elseIf pos==5 ; Count anims
		elseIf pos==6 ; Edit Relationship
		elseIf pos==7 ; Scan Mode
			if index>=0 && index<=4 ; < sanity check i guess?
				if ssxRunnerQuest.scanMode!=index && ssxRunnerQuest.iAmActive
					int handle = ModEvent.Create("ssxStopScanner") 
					ModEvent.PushString(handle, "")
					ModEvent.Send(handle)
					Utility.waitMenuMode(0.5)
					handle = ModEvent.Create("ssxStartScanner")
					ModEvent.PushInt(handle, index)
					ModEvent.Send(handle)	
				endIf
				ssxRunnerQuest.scanMode=index
				SetMenuOptionValue(option, ssxRunnerQuest.scanModes[index])
			endIf
		endIf
		return
		
	elseIf pageEditMode==1 ; Edit Config
		if pos==0 ; MN Priority mode
			if index==0 || index==1
				ssxRunnerQuest.priorityMode=index
				SetMenuOptionValue(option, ssxRunnerQuest.priorityModes[index])
			endIf
		elseIf pos==1 ; MN skipActorsInNamedScenes
			if index==0 || index==1
				ssxRunnerQuest.skipActorsInNamedScenes=index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
		elseIf pos==2 ; MN forceStopCombats
			if index>-1 && index<ssxRunnerQuest.forceStopCombatsMN.length
				ssxRunnerQuest.forceStopCombats=index
				SetMenuOptionValue(option, ssxRunnerQuest.forceStopCombatsMN[index])
			endIf
		elseIf pos==3 ; MN followersStayInBleedout
			if index==0 || index==1
				ssxRunnerQuest.followersStayInBleedout = index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
		elseIf pos==5 ; MN popUpDelRule
			if index==0 || index==1
				ssxRunnerQuest.popUpDelRule = index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
		elseIf pos==6 ; MN popUpNotSaved
			if index==0 || index==1
				ssxRunnerQuest.popUpNotSaved = index
				SetMenuOptionValue(option, ssxRunnerQuest.popUpName[index])
			endIf
		elseIf pos==7 ; MN popUpNameNotUpated
			if index==0 || index==1
				ssxRunnerQuest.popUpNameNotUpated = index
				SetMenuOptionValue(option, ssxRunnerQuest.popUpName[index])
			endIf
		elseIf pos==8 ; TG dontBotherOnSLENFix
		elseIf pos==9 ; TG dontBotherOnDefeatFix
		elseIf pos==10 ; BN Back
		elseIf pos==11 ; MN ProtectPlayerOnHealth
			if index==0 || index==1
				ssxRunnerQuest.protectOnHealth = index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
		elseIf pos==12 ; MN SafeCheckOfConCAnims
			if index==0 || index==1
				ssxRunnerQuest.safeCheckOfConCAnims = index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
		endIf
		return
		
	elseIf pageEditMode==2 ; Edit Timers
		if pos==0 ; Start right away
		elseIf pos==1 ; Back
		elseIf pos==2 ; 
		elseIf pos==3 ; Don't Stop Scenes
		elseIf pos==4 ; MN Checking mode
			if index==0 || index==1
				ssxRunnerQuest.checkingMode=index
				SetMenuOptionValue(option, ssxRunnerQuest.checkingModes[ssxRunnerQuest.checkingMode])
				ForcePageReset()
			endIf
		endIf
		return
		
	elseIf pageEditMode==3 ; Edit Sexuality
		if pos==0 ; Gender Mode
			if index!=0 && index!=1
				index=0
			endIf
			ssxRunnerQuest.genderMode = index
			SetMenuOptionValue(option, ssxRunnerQuest.genderModes[ssxRunnerQuest.genderMode])
		elseIf pos==1 ; Player Orientation
			if index>=0 && index<ssxRunnerQuest.playerOrientations.length
				ssxRunnerQuest.playerOrientation = index
				SetMenuOptionValue(option, ssxRunnerQuest.playerOrientations[ssxRunnerQuest.playerOrientation])
			endIf
		elseIf pos==2 ; HM=M Orientation Mode
			if index>-1 && index<ssxRunnerQuest.orientationModesC.length
				ssxRunnerQuest.orientationMode = ssxRunnerQuest.setSexBitsForType(0, index)
				SetMenuOptionValue(option, ssxRunnerQuest.orientationModesC[index])
			endIf
		elseIf pos==3 ; HF=F Orientation Mode
			if index>-1 && index<ssxRunnerQuest.orientationModesC.length
				ssxRunnerQuest.orientationMode = ssxRunnerQuest.setSexBitsForType(1, index)
				SetMenuOptionValue(option, ssxRunnerQuest.orientationModesC[index])
			endIf
		elseIf pos==4 ; CM=S Orientation Mode
			if index>-1 && index<ssxRunnerQuest.orientationModesC.length
				ssxRunnerQuest.orientationMode = ssxRunnerQuest.setSexBitsForType(2, index)
				SetMenuOptionValue(option, ssxRunnerQuest.orientationModesC[index])
			endIf
		elseIf pos==5 ; CF=B Orientation Mode
			if index>-1 && index<ssxRunnerQuest.orientationModesC.length
				ssxRunnerQuest.orientationMode = ssxRunnerQuest.setSexBitsForType(3, index)
				SetMenuOptionValue(option, ssxRunnerQuest.orientationModesC[index])
			endIf
		elseIf pos==6 ; Use SL Sexuality
			if index!=0 && index!=1
				index=0
			endIf
			ssxRunnerQuest.useSLSexuality = index
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[ssxRunnerQuest.useSLSexuality])
		elseIf pos==7 ; Exclude Covered in Cum
			if index==0 || index==1
				ssxRunnerQuest.excludeActorsWithCum = index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
		elseIf pos==8 ; BN Add/Remove
		elseIf pos==9 ; MN Group Color
			if index>-1 && index<ssxRunnerQuest.colors.length
				ssxRunnerQuest.setFactionGroupColor(1, index)
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==10 ; MN Group Color
			if index>-1 && index<ssxRunnerQuest.colors.length
				ssxRunnerQuest.setFactionGroupColor(2, index)
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==11 ; MN Group Color
			if index>-1 && index<ssxRunnerQuest.colors.length
				ssxRunnerQuest.setFactionGroupColor(3, index)
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==12 ; MN Group Color
			if index>-1 && index<ssxRunnerQuest.colors.length
				ssxRunnerQuest.setFactionGroupColor(4, index)
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==13 ; MN Group Color
			if index>-1 && index<ssxRunnerQuest.colors.length
				ssxRunnerQuest.setFactionGroupColor(5, index)
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==14 ; Back
		endIf
		return

	elseIf pageEditMode==4 ; Edit Relationships
		if pos==0 ; MN Increase Speech
			if index==0 || index==1
				ssxRunnerQuest.increaseSpeechCraft = index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
				ForcePageReset()
			endIf
		elseIf pos==1 ; MN Increase relationship
			if index==0 || index==1
				ssxRunnerQuest.IncreaseRelationShip = index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
				ForcePageReset()
			endIf
		elseIf pos==2 ; MN Max rel rank
			if index>=0 && index<ssxRunnerQuest.relRanks.length
				ssxRunnerQuest.maxRelationshipRank = index
				SetMenuOptionValue(option, ssxRunnerQuest.relRanks[index])
			endIf
		elseIf pos==3 ; BN Back
		endIf
		return
		
	elseIf pageEditMode==10 ; Rule list
		if pos==0 ; Add rule
		elseIf pos==1 ; Edit rule
		elseIf pos==2 ; Delete rule
		elseIf pos==3 ; Duplicate rule
		elseIf pos==4 ; Enable rule
		elseIf pos==5 ; Disable rule
		elseIf pos==6 ; CountAnims
		elseIf pos==7 ; Filter Rules
		elseIf pos==8 ; DeleteAllRules
		endIf
		return

	elseIf pageEditMode==11 ; Add/Edit Rule
		if pos==0 ; Generate Name
		elseIf pos==1 ; Calculate Participants
		elseIf pos==2 ; Edit Participants
		elseIf pos==3 ; Calculate StartsOn
		elseIf pos==4 ; Edit StartsOn
		elseIf pos==5 ; Calculate Anims/Tags
		elseIf pos==6 ; Change Anims/Tags
		elseIf pos==7 ; Change Rule Properties
		elseIf pos==8 ; Change Interactions
		elseIf pos==9 ; Edit Locations
		elseIf pos==10 ; Count anims
		elseIf pos==11 ; Save
		elseIf pos==12 ; Cancel
		endIf
		return

	elseIf pageEditMode==12 ; Edit participants
		if pos==0 ; Target description
		elseIf pos==1 ; Target edit
		elseIf pos==2 ; Source description
		elseIf pos==3 ; Source edit
		elseIf pos==4 ; Collaborator description
		elseIf pos==5 ; Collaborator edit
		elseIf pos==6 ; Number of collaborators
			if index>=0 && index<4
				editRuleL1.setNumColls(index)
				SetMenuOptionValue(option, ssxRunnerQuest.numOfColls[index])
				if index==0
					editRuleL1.setParticipant(2, 0, 0, 0, 0)
					ForcePageReset()
				endIf
			endIf
		elseIf pos==7 ; MN Passive role
			if index==1 && editRuleL1.isNobody(1)
				index=0
			elseIf index==2 && editRuleL1.isNobody(2)
				index=0
			endIf
			if index>=0 && index<ssxRunnerQuest.whoWillBePassive.length
				if index==0 && (editRuleL1.isNobody(0) || editRuleL1.doNotInvolveDst())
					return
				elseIf index==1 && (editRuleL1.isNobody(1) || editRuleL1.doNotInvolveSrc())
					return
				elseIf index==2 && (editRuleL1.isNobody(2) || editRuleL1.doNotInvolveColl())
					return
				endIf
				editRuleL1.passiveIs=index
				SetMenuOptionValue(option, ssxRunnerQuest.whoWillBePassive[index])
			endIf
		elseIf pos==8 ; Save
		elseIf pos==9 ; Cancel
		elseIf pos==10 ; Quick Target Settings
			if index<0 || (!ssxRunnerQuest.nexusMode && SexLab.AllowCreatures && index>=ssxRunnerQuest.participantQuickSettingsLL.length) || (ssxRunnerQuest.nexusMode && index>=ssxRunnerQuest.participantQuickSettingsNX.length)
				return
			endIf
			
			if index==0 ; nobody
				editRuleL1.setParticipant(0, 0, 0, 0, 0)
			elseIf index==1 ; player
				editRuleL1.setParticipant(0, 3, 3, 3, 1)
			elseIf index==2 ; human male
				editRuleL1.setParticipant(0, 1, 2, 1, 2)
			elseIf index==3 ; human female
				editRuleL1.setParticipant(0, 2, 2, 1, 2)
			elseIf index==4 ; humans
				editRuleL1.setParticipant(0, 3, 2, 1, 2)
			elseIf index==5 ; humans and player
				editRuleL1.setParticipant(0, 3, 2, 1, 3)
			elseIf index==6 ; Followers
				editRuleL1.setParticipant(0, 3, 1, 3, 2)
			elseIf index==7 ; Human followers
				editRuleL1.setParticipant(0, 3, 1, 1, 2)
			elseIf index==8 ; Male followers
				editRuleL1.setParticipant(0, 1, 1, 1, 2)
			elseIf index==9 ; Female followers
				editRuleL1.setParticipant(0, 2, 1, 1, 2)
			elseIf index==10 ; Creatures
				editRuleL1.setParticipant(0, 3, 3, 2, 2)
			elseIf index==11 ; Dogs & Wolves
				editRuleL1.setParticipant(0, 3, 3, 2, 2)
				editRuleL1.srcRaces="Dogs;Wolves"
			elseIf index==12 ; 4 Falmers
				editRuleL1.setParticipant(0, 3, 3, 1, 2)
				editRuleL1.setParticipant(1, 3, 3, 2, 2)
				editRuleL1.setParticipant(2, 3, 3, 2, 8)
				editRuleL1.setNumColls(3)
				editRuleL1.srcRaces="Falmers"
			elseIf index==13 ; 4 Draugrs
				editRuleL1.setParticipant(0, 3, 3, 1, 2)
				editRuleL1.setParticipant(1, 3, 3, 2, 2)
				editRuleL1.setParticipant(2, 3, 3, 3, 8)
				editRuleL1.setNumColls(3)
				editRuleL1.srcRaces="Draugrs"
			endIf
			SetMenuOptionValue(option, ssxRunnerQuest.participantQuickSettingsLL[index])
			ForcePageReset()
		elseIf pos==11 ; Quick Source Settings
			if index<0 || (!ssxRunnerQuest.nexusMode && SexLab.AllowCreatures && index>=ssxRunnerQuest.participantQuickSettingsLL.length) || (ssxRunnerQuest.nexusMode && index>=ssxRunnerQuest.participantQuickSettingsNX.length)
				return
			endIf

			if index==0 ; nobody
				editRuleL1.setParticipant(1, 0, 0, 0, 0)
			elseIf index==1 ; player
				editRuleL1.setParticipant(1, 3, 3, 3, 1)
			elseIf index==2 ; human male
				editRuleL1.setParticipant(1, 1, 2, 1, 2)
			elseIf index==3 ; human female
				editRuleL1.setParticipant(1, 2, 2, 1, 2)
			elseIf index==4 ; humans
				editRuleL1.setParticipant(1, 3, 2, 1, 2)
			elseIf index==5 ; humans and player
				editRuleL1.setParticipant(1, 3, 2, 1, 3)
			elseIf index==6 ; Followers
				editRuleL1.setParticipant(1, 3, 1, 3, 2)
			elseIf index==7 ; Human followers
				editRuleL1.setParticipant(1, 3, 1, 1, 2)
			elseIf index==8 ; Male followers
				editRuleL1.setParticipant(1, 1, 1, 1, 2)
			elseIf index==9 ; Female followers
				editRuleL1.setParticipant(1, 2, 1, 1, 2)
			elseIf index==10 ; Creatures
				editRuleL1.setParticipant(1, 3, 3, 2, 2)
			elseIf index==11 ; Dogs & Wolves
				editRuleL1.setParticipant(1, 3, 3, 2, 2)
				editRuleL1.srcRaces="Dogs;Wolves"
			elseIf index==12 ; 4 Falmers
				editRuleL1.setParticipant(1, 3, 3, 2, 2)
				editRuleL1.setParticipant(2, 3, 3, 2, 8)
				editRuleL1.setNumColls(3)
				editRuleL1.srcRaces="Falmers"
			elseIf index==13 ; 4 Draugrs
				editRuleL1.setParticipant(1, 3, 3, 2, 2)
				editRuleL1.setParticipant(2, 3, 3, 2, 8)
				editRuleL1.setNumColls(3)
				editRuleL1.srcRaces="Draugrs"
			endIf
			SetMenuOptionValue(option, ssxRunnerQuest.participantQuickSettingsLL[index])
			ForcePageReset()
		elseIf pos==12 ; Quick Collaborator Settings
			if index<0 || (!ssxRunnerQuest.nexusMode && SexLab.AllowCreatures && index>=ssxRunnerQuest.participantQuickSettingsLL.length) || (ssxRunnerQuest.nexusMode && index>=ssxRunnerQuest.participantQuickSettingsNX.length)
				return
			endIf

			if index==0 ; nobody
				editRuleL1.setParticipant(3, 0, 0, 0, 0)
			elseIf index==1 ; player
				editRuleL1.setParticipant(3, 3, 3, 3, 1)
			elseIf index==2 ; human male
				editRuleL1.setParticipant(3, 1, 2, 1, 2)
			elseIf index==3 ; human female
				editRuleL1.setParticipant(3, 2, 2, 1, 2)
			elseIf index==4 ; humans
				editRuleL1.setParticipant(3, 3, 2, 1, 2)
			elseIf index==5 ; humans and player
				editRuleL1.setParticipant(3, 3, 2, 1, 3)
			elseIf index==6 ; Followers
				editRuleL1.setParticipant(3, 3, 1, 3, 2)
			elseIf index==7 ; Human followers
				editRuleL1.setParticipant(3, 3, 1, 1, 2)
			elseIf index==8 ; Male followers
				editRuleL1.setParticipant(3, 1, 1, 1, 2)
			elseIf index==9 ; Female followers
				editRuleL1.setParticipant(3, 2, 1, 1, 2)
			elseIf index==10 ; Creatures
				editRuleL1.setParticipant(3, 3, 3, 2, 2)
			elseIf index==11 ; Dogs & Wolves
				editRuleL1.setParticipant(3, 3, 3, 2, 2)
				editRuleL1.srcRaces="Dogs;Wolves"
			elseIf index==12 ; 4 Falmers
				editRuleL1.setParticipant(1, 3, 3, 2, 2)
				editRuleL1.setParticipant(2, 3, 3, 2, 8)
				editRuleL1.setNumColls(3)
				editRuleL1.srcRaces="Falmers"
			elseIf index==13 ; 4 Draugrs
				editRuleL1.setParticipant(1, 3, 3, 2, 2)
				editRuleL1.setParticipant(2, 3, 3, 2, 8)
				editRuleL1.setNumColls(3)
				editRuleL1.srcRaces="Draugrs"
			endIf
			SetMenuOptionValue(option, ssxRunnerQuest.participantQuickSettingsLL[index])
			if index!=0 && editRuleL1.getNumColls()==0
				editRuleL1.setNumColls(1)
			else
				editRuleL1.setNumColls(0)
			endIf
			ForcePageReset()

		endIf
		return

	elseIf pageEditMode==13 ; Edit Specific participant
		if pos==0 ; MN Position Type
			if index>=0 && index<ssxRunnerQuest.actTypes.length
				if editRuleL2.setParticipant(positionEdited, -1, -1, 1, index)
					; Clean the previous ID, or it will fail because it will be a wrong object
					if positionEdited==0
						editRuleL2.dstIDs=""
					elseIf positionEdited==1
						editRuleL2.srcIDs=""
					else
						editRuleL2.collIDs=""
					endIf
				endIf
				SetMenuOptionValue(option, ssxRunnerQuest.actTypes[index])
				ForcePageReset()
			endIf
		elseIf pos==1 ; MN Sex
			if index>=0 && index<3
				index+=1
				editRuleL2.setParticipant(positionEdited, index, -1, -1, -1)
				SetMenuOptionValue(option, ssxRunnerQuest.sexActorValue[index - 1])
			endIf
		elseIf pos==2 ; MN Fellowship
			if index>=0 && index<3
				index+=1
				editRuleL2.setParticipant(positionEdited, -1, index, -1, -1)
				SetMenuOptionValue(option, ssxRunnerQuest.followerOrNot[index - 1])
			endIf
		elseIf pos==3 ; MN Humanity
			if index>=0 && index<2
				index+=1
				editRuleL2.setParticipant(positionEdited, -1, -1, index, -1)
				SetMenuOptionValue(option, ssxRunnerQuest.humanOrCreature[index - 1])
			endIf
		elseIf pos==4 ; TG Do not involve me
		elseIf pos==5 ; TX Edit Race Filters
		elseIf pos==6 ; TX Edit Wearables
		elseIf pos==7 ; TX Edit mods
		elseIf pos==8 ; TX Position values
		elseIf pos==9 ; TX Position name
		elseIf pos==10 ; MN Pick Actor/Faction/Relationship
			if editRuleL2.isSpecific(positionEdited)
				if index>=0 && index<ssxRunnerQuest.mcmActorNames.length
					tmpValInt[0] = index
				endIf
				SetMenuOptionValue(option, ssxRunnerQuest.mcmActorNames[tmpValInt[0]])
			elseIf editRuleL2.isFaction(positionEdited)
				if index>=0 && index<factionFilters.length
					tmpValInt[0] = index
					SetMenuOptionValue(option, factionFilters[tmpValInt[0]])
				endIf
			elseIf editRuleL2.isRelationship(positionEdited)
				if index>=0 && index<ssxRunnerQuest.associationNames.length
					tmpValInt[0] = index
				endIf
				SetMenuOptionValue(option, ssxRunnerQuest.associationNames[tmpValInt[0]])
			endIf
		elseIf pos==11 ; TX Add Actor/Faction/Relationship
		elseIf pos==12 ; TX Clear Actor/Faction/Relationship
		elseIf pos==13 ; MN highlight color
			if index>=0 && index<ssxRunnerQuest.colors.length
				editRuleL2.setHighlightColor(positionEdited, index, true)
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==14 ; MN highlight components
			if index>=0 && index<ssxRunnerQuest.colors.length
				editRuleL2.setHighlightColor(positionEdited, index, false)
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==15 ; TX Save
		elseIf pos==16 ; TX Cancel
		elseIf pos==17 ; BN Edit negative faction filter
		endIf
		return

	elseIf pageEditMode==14 ; Edit Animations and Tags Indirection
		if pos==0 ; Go Tags Consensual
		elseIf pos==1 ; Go Anims Consensual
		elseIf pos==2 ; Go Tags Aggressive
		elseIf pos==3 ; Go Anims Aggressive
		elseIf pos==4 ; In Case of Aggressiveness
			if index>=0 && index<ssxRunnerQuest.inCaseOfAggressiveness.length
				editRuleL1.setAggressiveTagReqired(index)
				SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.inCaseOfAggressiveness[editRuleL1.aggressiveTagReqired()], 0, 18))
			endIf
		elseIf pos==5 ; Go Back
		elseIf pos<11 ; Not used, ignore
		endIf
		return

	elseIf pageEditMode==24 ; Edit Tags Consensual
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
		elseIf pos==1 ; BN Tags AND/OR
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
		elseIf pos==3 ; MN Gender tags
			if index>=0 && index<ssxRunnerQuest.addGenderTagsMenu.length
				SetMenuOptionValue(option, ssxRunnerQuest.addGenderTagsMenu[index])
				editRuleL2.setGenderTags(index, -1, false)
			endIf
		elseIf pos==4 ; MN Player Gender tags
			if index>=0 && index<ssxRunnerQuest.playerGenderTags.length
				SetMenuOptionValue(option, ssxRunnerQuest.playerGenderTags[index])
				editRuleL2.setGenderTags(-1, index, false)
			endIf
		elseIf pos==5 ; MN Tag list
			if index>=0 && index<ssxRunnerQuest.allTags.length
				tmpValInt[5] = index
				SetMenuOptionValue(option, ssxRunnerQuest.allTags[tmpValInt[5]])
			endIf
		elseIf pos==6 ; BN Add from list
		elseIf pos==7 ; BN Add Typed Tag
		elseIf pos==8 ; BN Clear tags
		elseIf pos==9 ; BN Count Anims
		elseIf pos==10 ; BN Save
		elseIf pos==11 ; Cancel
		endIf

	elseIf pageEditMode==25 ; Edit Tags Aggressive
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
		elseIf pos==1 ; BN Tags AND/OR
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
		elseIf pos==3 ; MN Gender tags
			if index>=0 && index<ssxRunnerQuest.addGenderTagsMenu.length
				SetMenuOptionValue(option, ssxRunnerQuest.addGenderTagsMenu[index])
				editRuleL2.setGenderTags(index, -1, true)
			endIf
		elseIf pos==4 ; MN Player Gender tags
			if index>=0 && index<ssxRunnerQuest.playerGenderTags.length
				SetMenuOptionValue(option, ssxRunnerQuest.playerGenderTags[index])
				editRuleL2.setGenderTags(-1, index, true)
			endIf
		elseIf pos==5 ; MN Tag list
			if index>=0 && index<ssxRunnerQuest.allTags.length
				tmpValInt[5] = index
				SetMenuOptionValue(option, ssxRunnerQuest.allTags[tmpValInt[5]])
			endIf
		elseIf pos==6 ; BN Add from list
		elseIf pos==7 ; BN Add Typed Tag
		elseIf pos==8 ; BN Clear tags
		elseIf pos==9 ; BN Count Anims
		elseIf pos==10 ; BN Save
		elseIf pos==11 ; Cancel
		endIf

		
	elseIf pageEditMode==26 ; Edit Anims Consensual
		if pos==0 ; IN Type anim filter
		elseIf pos==1 ; MN Select anim
			if index>=0 && index<ssxRunnerQuest.animNames.length
				tmpValInt[1]=index
				SetMenuOptionValue(option, ssxRunnerQuest.animNames[index])
			endIf
		elseIf pos==2 ; BN Add
		elseIf pos==3 ; BN Clear
		elseIf pos==4 ; MN Gender Tags
			if index>=0 && index<ssxRunnerQuest.addGenderTagsMenu.length
				SetMenuOptionValue(option, ssxRunnerQuest.addGenderTagsMenu[index])
				editRuleL2.setGenderTags(index, -1, false)
			endIf
		elseIf pos==5 ; MN player Gender Tags
			if index>=0 && index<ssxRunnerQuest.playerGenderTags.length
				SetMenuOptionValue(option, ssxRunnerQuest.playerGenderTags[index])
				editRuleL2.setGenderTags(-1, index, false)
			endIf
		elseIf pos==6 ; BN Count
		elseIf pos==7 ; BN Save
		elseIf pos==8 ; BN Cancel
		elseIf pos>19 && pos<80 ; BN Remove anim
		endIf
		return
		
	elseIf pageEditMode==27 ; Edit Anims Aggressive
		if pos==0 ; IN Type anim filter
		elseIf pos==1 ; MN Select anim
			if index>=0 && index<ssxRunnerQuest.animNames.length
				tmpValInt[1]=index
				SetMenuOptionValue(option, ssxRunnerQuest.animNames[index])
			endIf
		elseIf pos==2 ; BN Add
		elseIf pos==3 ; BN Clear
		elseIf pos==4 ; MN Gender Tags
			if index>=0 && index<ssxRunnerQuest.addGenderTagsMenu.length
				SetMenuOptionValue(option, ssxRunnerQuest.addGenderTagsMenu[index])
				editRuleL2.setGenderTags(index, -1, true)
			endIf
		elseIf pos==5 ; MN player Gender Tags
			if index>=0 && index<ssxRunnerQuest.playerGenderTags.length
				SetMenuOptionValue(option, ssxRunnerQuest.playerGenderTags[index])
				editRuleL2.setGenderTags(-1, index, true)
			endIf
		elseIf pos==6 ; BN Count
		elseIf pos==7 ; BN Save
		elseIf pos==8 ; BN Cancel
		elseIf pos>19 && pos<80 ; BN Remove anim
		endIf
		return
		
	elseIf pageEditMode==15 ; Edit Race Filters
		if pos==0 ; MN Race Mode
			if index==0 || index==1
				editRuleL2.setRaceMode(positionEdited, index)
				SetMenuOptionValue(option, ssxRunnerQuest.raceInclusiveExclusive[index])
			endIf

		elseIf pos==1 ; MN Pick Race
			int i = editRuleL2.getHumanityPart(positionEdited)
			string[] list
			if i==1 ; Humans
				list = ssxRunnerQuest.allValidRacesH
			elseIf i==2 ; Creatures
				list = ssxRunnerQuest.allValidRacesC
			else ; Both = 0
				list = ssxRunnerQuest.allValidRacesB
			endIf
			if index>=0 && index<list.length
				tmpValInt[1] = index
				SetMenuOptionValue(option, list[tmpValInt[1]])
			endIf
			
		elseIf pos==2 ; BN Add race
		elseIf pos==3 ; BN Clear races
		elseIf pos==4 ; BN Back
		elseIf pos>=20 && pos<40 ; BN Remove selected race
		endIf
		return
		
	elseIf pageEditMode==16 ; Position wearables
		if pos==0 ; Pick wearables
			if index>=0 && index<ssxRunnerQuest.currentArmorsNames.length
				tmpValInt[0] = index
				SetMenuOptionValue(option, ssxRunnerQuest.currentArmorsNames[tmpValInt[0]])
			endIf
		elseIf pos==1 ; Add wearables start
		elseIf pos==2 ; Add wearables end
		elseIf pos==3 ; Clear wearables start
		elseIf pos==4 ; Clear wearables end
		elseIf pos==5 ; Strip mode
			if index>=0 && index<ssxRunnerQuest.stripModes.length
				tmpValInt[5] = index
				SetMenuOptionValue(option, ssxRunnerQuest.stripModes[tmpValInt[5]])
				editRuleL2.setStripping(positionEdited, tmpValInt[5])
			endIf
		elseIf pos==6 ; Back
		elseIf pos>9 && pos< 40
		elseIf pos>39 && pos<70
		endIf

	elseIf pageEditMode==17 ; Rule interactions
		if pos==0 ; NM AskBeforeSex
			if index>=0 && index<ssxRunnerQuest.yesNo.length
				editRuleL1.setAskBeforeSex(index==1)
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
			ForcePageReset()
		elseIf pos==1 ; MN Ask dialogue
			if index>=0 && index<ssxRunnerQuest.requestDialogues.length
				editRuleL1.setDialogue(index, 0)
				SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.requestDialogues[index], 0, 16) + "...")
			endIf
		elseIf pos==2 ; MN Answer on SpeechCraft
			if index>=0 && index<ssxRunnerQuest.yesNo.length
				editRuleL1.setUseSpeechCraft(index==1)
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
			ForcePageReset()
		elseIf pos==3 ; MN Positive Answer
			if index>=0 && index<ssxRunnerQuest.positiveAnswers.length
				editRuleL1.setDialogue(index, 1)
				SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.positiveAnswers[index], 0, 16) + "...")
			endIf
		elseIf pos==4 ; MN Positive Answer probability
			if index>=0 && index<ssxRunnerQuest.answerProbs.length
				editRuleL1.setAnswerProbability(index, true)
				SetMenuOptionValue(option, ssxRunnerQuest.answerProbs[index])
				if index==0
					editRuleL1.setAnswerProbability(4, false)
					SetMenuOptionValue(pageOPTs[6], ssxRunnerQuest.answerProbs[4])
				elseIf index==4
					editRuleL1.setAnswerProbability(0, false)
					SetMenuOptionValue(pageOPTs[6], ssxRunnerQuest.answerProbs[0])
				endIf
			endIf
			ForcePageReset()
		elseIf pos==5 ; MN Negative Answer
			if index>=0 && index<ssxRunnerQuest.negativeAnswers.length
				editRuleL1.setDialogue(index, 2)
				SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.negativeAnswers[index], 0, 16) + "...")
			endIf
		elseIf pos==6 ; MN Negative Answer probability
			if index>=0 && index<ssxRunnerQuest.answerProbs.length
				editRuleL1.setAnswerProbability(index, false)
				SetMenuOptionValue(option, ssxRunnerQuest.answerProbs[index])
				if index==0
					editRuleL1.setAnswerProbability(4, true)
					SetMenuOptionValue(pageOPTs[4], ssxRunnerQuest.answerProbs[4])
				elseIf index==4
					editRuleL1.setAnswerProbability(0, true)
					SetMenuOptionValue(pageOPTs[4], ssxRunnerQuest.answerProbs[0])
				endIf
			endIf
			ForcePageReset()
		elseIf pos==7 ; MN Rape on denials
			if index>=0 && index<ssxRunnerQuest.percs.length
				editRuleL1.setPercRape(index)
				SetMenuOptionValue(option, ssxRunnerQuest.percs[index])
			endIf
		elseIf pos==8 ; MN Agreesiveness on denials
			if index>=0 && index<ssxRunnerQuest.percs.length
				editRuleL1.setPercRapeAggr(index)
				SetMenuOptionValue(option, ssxRunnerQuest.percs[index])
			endIf
		elseIf pos==9 ; MN Mast on denials
			if index>=0 && index<ssxRunnerQuest.percs.length
				editRuleL1.setPercMast(index)
				SetMenuOptionValue(option, ssxRunnerQuest.percs[index])
			endIf
		elseIf pos==10 ; MN Final sentence
			if index>=0 && index<ssxRunnerQuest.npcFinalSentences.length
				editRuleL1.setDialogue(index, 3)
				SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.npcFinalSentences[index], 0, 16) + "...")
			endIf
		elseIf pos==11 ; MN Aggressiveness
			if index>=0 && index<ssxRunnerQuest.percs.length
				editRuleL1.aggressive = index
				SetMenuOptionValue(option, ssxRunnerQuest.percs[index])
			endIf
			ForcePageReset()
		elseIf pos==12 ; MN Victim
			if index==0
				editRuleL1.setVictim(-1)
				SetMenuOptionValue(option, ssxRunnerQuest.whoIsVictim[0])
			elseIf index==1 && !editRuleL1.doNotInvolveDst()
				editRuleL1.setVictim(0)
				SetMenuOptionValue(option, ssxRunnerQuest.whoIsVictim[1])
			elseIf index==2 && !editRuleL1.doNotInvolveSrc()
				editRuleL1.setVictim(1)
				SetMenuOptionValue(option, ssxRunnerQuest.whoIsVictim[2])
			elseIf index==3 && !editRuleL1.doNotInvolveColl()
				editRuleL1.setVictim(2)
				SetMenuOptionValue(option, ssxRunnerQuest.whoIsVictim[3])
			endIf
		elseIf pos==13 ; MN not used
		elseIf pos==14 ; MN Combats
			if index>=0 && index<ssxRunnerQuest.stopAllCombats.length
				editRuleL1.stopAllCombats = index
				SetMenuOptionValue(option, ssxRunnerQuest.stopAllCombats[index])
			endIf
		elseIf pos==15 ; MN Save
		elseIf pos==16 ; MN Cancel
		endIf

	elseIf pageEditMode==18 ; Rule properties
		if pos==0 ; MN Probability
			if index>=0 && index<ssxRunnerQuest.prob.length
				editRuleL1.probability=index
				SetMenuOptionValue(option, ssxRunnerQuest.prob[index])
			endIf
		elseIf pos==1 ; MN Beds
			if index>=0 && index<ssxRunnerQuest.beds.length
				editRuleL1.beds=index
				SetMenuOptionValue(option, ssxRunnerQuest.beds[index])
			endIf
		elseIf pos==2 ; MN Use timeout
			if index>=0 && index<ssxRunnerQuest.prob.length
				tmpValInt[2]=index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
			ForcePageReset()
		elseIf pos==3 ; BN Save
		elseIf pos==4 ; BN Cancel
		elseIf pos==5 ; BN Scale Actors
			if index>=0 && index<ssxRunnerQuest.prob.length
				editRuleL1.scaleActors=index
				SetMenuOptionValue(option, ssxRunnerQuest.scaleActorsVals[index])
			endIf
		elseIf pos==15 ; MN Allow Orgies
			if index==0 || index==1
				editRuleL1.enableOrgies=index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
		elseIf pos==17 ; MN Spectators masturbate
			if index>-1 && index<4
				editRuleL1.setSpectatorsMasturbate(index)
				SetMenuOptionValue(option, ssxRunnerQuest.spectatorsMasturbates[index])
			endIf
		endIf
		
	elseIf pageEditMode==19 ; Rule locations
		if pos==0 ; MN Select location
			if index>=0 && index<ssxRunnerQuest.locationList.length
				tmpValInt[0]=index
				SetMenuOptionValue(option, ssxRunnerQuest.locationList[index])
			endIf
		elseIf pos==1 ; BN Add location
		elseIf pos==2 ; BN Add current location
		elseIf pos==3 ; MN Select location type
			if index>=0 && index<ssxRunnerQuest.locationTypeList.length
				tmpValInt[3]=index
				SetMenuOptionValue(option, ssxRunnerQuest.locationTypeList[index])
			endIf
		elseIf pos==4 ; BN Add location type
		elseIf pos==5 ; BN Clear all
		elseIf pos==6 ; MN Internal/External
			if index>=0 && index<ssxRunnerQuest.intExtMnu.length
				editRuleL1.setIntExt(index)
				SetMenuOptionValue(option, ssxRunnerQuest.intExtMnu[index])
			endIf
		elseIf pos==7 ; Save
		elseIf pos==8 ; Cancel
		elseIf pos==9 ; BN Add current cell
		elseIf pos==10 ; MN Inclusive/Exclusive cells
			if index==0
				editRuleL1.setCellInclExcl(true)
				SetMenuOptionValue(option, ssxRunnerQuest.inclExclMnu[0])
			elseIf index==1
				editRuleL1.setCellInclExcl(false)
				SetMenuOptionValue(option, ssxRunnerQuest.inclExclMnu[1])
			endIf
		elseIf pos>=20 && pos<50 ; BN Remove specific location
		endIf
	
	elseIf pageEditMode==20 ; Rule Start mode
		if pos==0 ; MN StartsOn
			if index>=0 && index<3
				editRuleL1.startsOn = index
				SetMenuOptionValue(option, ssxRunnerQuest.startModes[index])
				if index!=2
					editRuleL1.prevRule = 0
				endIf
			endIf
			ForcePageReset()
		elseIf pos==1 ; BN Clean
		elseIf pos==2 ; BN Save
		elseIf pos==3 ; BN Cancel
		elseIf pos==20 ; BN Random
		elseIf pos==21 ; MN Naked
			if index==0
				editRuleL1.setStartOnCompact(1, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(1, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==22 ; MN SeeNaked
			if index==0
				editRuleL1.setStartOnCompact(2, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(2, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==23 ; MN SeeSex
			if index==0
				editRuleL1.setStartOnCompact(3, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(3, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==24 ; MN Arousal
			if index==0
				editRuleL1.setStartOnCompact(4, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(4, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModesVal[index])
			endIf
		elseIf pos==25 ; MN Health
			if index==0
				editRuleL1.setStartOnCompact(5, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(5, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModesVal[index])
			endIf
		elseIf pos==26 ; MN Stamina
			if index==0
				editRuleL1.setStartOnCompact(6, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(6, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModesVal[index])
			endIf
		elseIf pos==27 ; MN Magicka
			if index==0
				editRuleL1.setStartOnCompact(7, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(7, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModesVal[index])
			endIf
		elseIf pos==28 ; MN Sleeping
			if index==0
				editRuleL1.setStartOnCompact(8, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(8, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==29 ; MN Sneaking
			if index==0
				editRuleL1.setStartOnCompact(9, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(9, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==30 ; MN HasWeapon
			if index==0
				editRuleL1.setStartOnCompact(10, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(10, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==31 ; MN InCombat
			if index==0
				editRuleL1.setStartOnCompact(11, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(11, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==32 ; MN Bleedout
			if index==0
				editRuleL1.setStartOnCompact(12, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(12, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==33 ; MN Unconscious
			if index==0
				editRuleL1.setStartOnCompact(13, 0)
				ForcePageReset()
			elseIf index>0 && index<27
				int i = editRuleL1.checkPositionFilters(index) ; Check if the required positions are valid...
				if i
					Debug.MessageBox(ssxRunnerQuest.positionsFilterWarning[i])
					return
				endIf
				editRuleL1.setStartOnCompact(13, index)
				SetMenuOptionValue(option, ssxRunnerQuest.startsOnActorModes[index])
			endIf
		elseIf pos==34 ; MN StartTime 
			if index>=0 && index<ssxRunnerQuest.timeOfTheDay.length
				editRuleL1.setStartTimer(index, editRuleL1.getStartTimer(false))
				SetMenuOptionValue(option, ssxRunnerQuest.timeOfTheDay[editRuleL1.getStartTimer(true)])
			endIf
		elseIf pos==35 ; MN EndTime
			if index>=0 && index<ssxRunnerQuest.timeOfTheDay.length
				editRuleL1.setStartTimer(editRuleL1.getStartTimer(true), index)
				SetMenuOptionValue(option, ssxRunnerQuest.timeOfTheDay[editRuleL1.getStartTimer(false)])
			endIf
		elseIf pos==36 ; MN Sequence
			if index>=0 && index<ssxRunnerQuest.ruleNames.length
				editRuleL1.prevRule = ssxRunnerQuest.getRuleIdByIndex(index)
				SetMenuOptionValue(option, ssxRunnerQuest.ruleNames[index])
			endIf
		elseIf pos==41 ; BN Naked
		elseIf pos==42 ; BN SeeNaked
		elseIf pos==43 ; BN SeeSex
		elseIf pos==44 ; BN Arousal
		elseIf pos==45 ; BN Health
		elseIf pos==46 ; BN Stamina
		elseIf pos==47 ; BN Magicka
		elseIf pos==48 ; BN Sleeping
		elseIf pos==49 ; BN Sneaking
		elseIf pos==50 ; BN Weapon
		elseIf pos==51 ; BN Combat
		elseIf pos==52 ; BN Bleedout
		elseIf pos==53 ; BN Unconscious
		elseIf pos==54 ; BN Time
		endIf
	
	elseIf pageEditMode==21 ; Import/Export rules
		if pos>-1 && pos<64 ; TG Rule
		elseIf pos==64 ; MN MultipleExportJoined
			if index==0 || index==1
				tmpValInt[40] = index
				SetMenuOptionValue(option, ssxRunnerQuest.yesNo[index])
			endIf
		elseIf pos==65 ; BN Export Selected
		elseIf pos==66 ; BN Export All
		elseIf pos==67 ; MN Import rules mode
			if index==0 || index==1 || index==2
				tmpValInt[67] = index
				SetMenuOptionValue(option, ssxRunnerQuest.importRulesMode[index])
			endIf
		elseIf pos==68 ; MN Select rule
			if index>=0 && index<jsonRules.length
				tmpValInt[68] = index
				String val = StringUtil.substring(jsonRules[index], 0, 20)
				if StringUtil.getLength(jsonRules[index])>20
					val+="..."
				endIf
				SetMenuOptionValue(option, val)
			endIf
		elseIf pos==69 ; BN Check rule
		elseIf pos==70 ; BN Import selected
		elseIf pos==71 ; BN Import All
		elseIf pos==72 ; BN Back
		endIf

	elseIf pageEditMode==22 ; Rule check
		if pos==0 ; Description
		elseIf pos==1 ; BN Back
		endIf

	elseIf pageEditMode==23 ; Edit Position Mods
		if pos==0 ; MN Pick mod1
			if index>=0 && index<ssxRunnerQuest.modsSet1.length
				tmpValInt[0]=index
				SetMenuOptionValue(option, ssxRunnerQuest.modsSet1[index])
			endIf
		elseIf pos==1 ; BN Add1
		elseIf pos==2 ; MN Pick mod 2
			if index>=0 && index<ssxRunnerQuest.modsSet2.length
				tmpValInt[2]=index
				SetMenuOptionValue(option, ssxRunnerQuest.modsSet2[index])
			endIf
		elseIf pos==3 ; BN Add2
		elseIf pos==4 ; MN Pick mod 3
			if index>=0 && index<ssxRunnerQuest.modsSet3.length
				tmpValInt[4]=index
				SetMenuOptionValue(option, ssxRunnerQuest.modsSet3[index])
			endIf
		elseIf pos==5 ; BN Add3
		elseIf pos==6 ; MN Pick mod 4
			if index>=0 && index<ssxRunnerQuest.modsSet4.length
				tmpValInt[6]=index
				SetMenuOptionValue(option, ssxRunnerQuest.modsSet4[index])
			endIf
		elseIf pos==7 ; BN Add4
		elseIf pos==8 ; BN Clear
		elseIf pos==9 ; BN Back
		elseIf pos>9 && pos<50 ; BN remove mod
		endIf

	elseIf pageEditMode==28 ; Edit negative faction filter
		if pos==0 ; read only position type
		elseIf pos==1 ; MN Pick Faction
			if index>=0 && index<factionFilters.length
				tmpValInt[1] = index
			endIf
			SetMenuOptionValue(option, factionFilters[tmpValInt[1]])
		elseIf pos==2 ; BN Add Faction
		elseIf pos==3 ; BN Clean all factions
		elseIf pos==4 ; BN Show Factions
		elseIf pos==5 ; BN Back
		elseIf pos>9 && pos<60 ; BN Remove specific faction
		endIf
	
	elseIf pageEditMode==29 ; Edit Starting Wearables
		if pos==0 ; MN Participant
			if index==0
				tmpValInt[0]=0
				SetMenuOptionValue(option, ssxRunnerQuest.participantEdit[0])
				ForcePageReset()
			elseIf index==1
				if editRuleL2.isNobody(1)
					Debug.MessageBox("The Source is not a valid participant, you cannot select it!")
					return
				endIf
				tmpValInt[0]=1
				SetMenuOptionValue(option, ssxRunnerQuest.participantEdit[1])
				ForcePageReset()
			elseIf index==2
				if editRuleL2.isNobody(2)
					Debug.MessageBox("The Collaborator is not a valid participant, you cannot select it!")
					return
				endIf
				tmpValInt[0]=2
				SetMenuOptionValue(option, ssxRunnerQuest.participantEdit[2])
				ForcePageReset()
			endIf
		elseIf pos==1 ; MN Has to/Not to
			if index==0 || index==1
				tmpValInt[1]=index
				SetMenuOptionValue(option, ssxRunnerQuest.hasToNotTos[index])
				ForcePageReset()
			endIf
		elseIf pos==2 ; MN Pick wearable
			if index>-1 && index<ssxRunnerQuest.currentArmorsNames.length
				tmpValInt[2]=index
				SetMenuOptionValue(option, ssxRunnerQuest.currentArmorsNames[index])
			endIf
		elseIf pos==3 ; BN Add wearable
		elseIf pos==4 ; MN Pick Keyword
			if index>-1 && index<ssxRunnerQuest.armorKeywordIDs.length
				tmpValInt[4]=index
				SetMenuOptionValue(option, ssxRunnerQuest.armorKeywordIDs[index])
			endIf
		elseIf pos==5 ; BN Add keyword
		elseIf pos==6 ; BN Clear wearables
		elseIf pos==7 ; BN Back
		elseIf pos>0 ; BN Remove nth wearable
		endIf
		
	elseIf pageEditMode==30 ; Nudity
		if pos==0 ; MN Helmet
			if index>=0 && index<ssxRunnerQuest.nakedIf.length
				ssxRunnerQuest.nakedHead=index
				SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[index])
				ForcePageReset()
			endIf
		elseIf pos==1 ; MN Armor
			if index>=0 && index<ssxRunnerQuest.nakedIf.length
				ssxRunnerQuest.nakedBody=index
				SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[index])
				ForcePageReset()
			endIf
		elseIf pos==2 ; MN Forearms
			if index>=0 && index<ssxRunnerQuest.nakedIf.length
				ssxRunnerQuest.nakedForearms=index
				SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[index])
				ForcePageReset()
			endIf
		elseIf pos==3 ; MN Gloves
			if index>=0 && index<ssxRunnerQuest.nakedIf.length
				ssxRunnerQuest.nakedHands=index
				SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[index])
				ForcePageReset()
			endIf
		elseIf pos==4 ; MN Calves
			if index>=0 && index<ssxRunnerQuest.nakedIf.length
				ssxRunnerQuest.nakedCalves=index
				SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[index])
				ForcePageReset()
			endIf
		elseIf pos==5 ; MN Shoes
			if index>=0 && index<ssxRunnerQuest.nakedIf.length
				ssxRunnerQuest.nakedFeet=index
				SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[index])
				ForcePageReset()
			endIf
		elseIf pos==6 ; MN Pelvis
			if index>=0 && index<ssxRunnerQuest.nakedIf.length
				ssxRunnerQuest.nakedPelvis=index
				SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[index])
				ForcePageReset()
			endIf
		elseIf pos==7 ; BN Now player is
		elseIf pos==8 ; BN Actor crosshair
		elseIf pos==9 ; MN Armor pieces
			if index>=0 && index<ssxRunnerQuest.currentArmorsNames.length
				tmpValInt[9]=index
				String shortName = ssxRunnerQuest.currentArmorsNames[index]
				if StringUtil.getLength(shortName)>20
					shortName = StringUtil.substring(shortName, 0, 20) + "..."
				endIf
				SetMenuOptionValue(option, shortName)
			endIf
		elseIf pos==10 ; BN Add armor piece
		elseIf pos==11 ; MN Armor keyword pieces
			if index>=0 && index<ssxRunnerQuest.armorKeywordIDs.length
				tmpValInt[11]=index
				SetMenuOptionValue(option, ssxRunnerQuest.armorKeywordIDs[index])
			endIf
		elseIf pos==12 ; BN Add armor keyword
		elseIf pos==13 ; BN Clear
		elseIf pos>=20 && pos<50 ; BN Remove
		endIf

	elseIf pageEditMode==40 ; Global Races Filter
		if pos==0 ; MN Races to Filter
			if ssxRunnerQuest.nexusMode || !SexLab.AllowCreatures
				tmpValInt[0]=0
				SetMenuOptionValue(option, ssxRunnerQuest.racesToFilter[tmpValInt[0]])
				ForcePageReset()
			elseIf index>=0 && index<ssxRunnerQuest.racesToFilter.length
				tmpValInt[0] = index
				SetMenuOptionValue(option, ssxRunnerQuest.racesToFilter[tmpValInt[0]])
				ForcePageReset()
			endIf
		elseIf pos==1 ; BN Enable All
		elseIf pos==2 ; BN Disable All
		elseIf pos>9 ; TG Enable/Disable race
		endIf
		

	elseIf pageEditMode==60 ; Anims
		if pos==0 ; MN Race filter
			if ssxRunnerQuest.nexusMode || !SexLab.AllowCreatures
				tmpValInt[0]=0
				SetMenuOptionValue(option, ssxRunnerQuest.racesToFilter[tmpValInt[0]])
				ForcePageReset()
			elseIf index>=0 && index<ssxRunnerQuest.racesToFilter.length
				tmpValInt[0] = index
				SetMenuOptionValue(option, ssxRunnerQuest.racesToFilter[tmpValInt[0]])
				ForcePageReset()
			endIf
		elseIf pos==1 ; BN Enable all anims
		elseIf pos==2 ; BN Disable all anims
		elseIf pos>9 ; Toggle anim
		endIf
		
	elseIf pageEditMode==70 ; Debug
		if pos==0 ; TG Active/Deactive N
		elseIf pos==1 ; TG Active/Deactiva T
		elseIf pos==2 ; TG What is going on N
		elseIf pos==3 ; TG What is going on T
		elseIf pos==4 ; TG Num actors N
		elseIf pos==5 ; TG Num actors T
		elseIf pos==6 ; TG Rule played N
		elseIf pos==7 ; TG Rule played T
		elseIf pos==8 ; TG Anim played N
		elseIf pos==9 ; TG Anim played T
		elseIf pos==10 ; BN AdvDebug
		elseIf pos==11 ; BN Highlight Actors
		elseIf pos==12 ; BN ForceActorsCleanUp
		elseIf pos==13 ; BN CleanUpActorAround
		elseIf pos==14 ; BN ForceRestart
		elseIf pos==15 ; BN Rescan Tags
		endIf
		return

	elseIf pageEditMode==71 ; Adv Debug
		return
	elseIf pageEditMode==72 ; Highlights
		if pos==0 ; TG Found in Scanse
		elseIf pos==1 ; MN Scan Color
			if index>-1 && index<ssxRunnerQuest.colors.length
				ssxRunnerQuest.notifHighLightColorScan = index
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==2 ; TG Valid for Rule
		elseIf pos==3 ; TG Potential for Rule
		elseIf pos==4 ; TG Starting Scenes
		elseIf pos==5 ; TG Actors can be asked for sex
		elseIf pos==6 ; MN Ask color
			if index>-1 && index<ssxRunnerQuest.colors.length
				ssxRunnerQuest.notifHighLightColorAskable = index
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==7 ; TG Cleaned by Cleaner
		elseIf pos==8 ; MN Cleaned color
			if index>-1 && index<ssxRunnerQuest.colors.length
				ssxRunnerQuest.notifHighLightColorCleaned = index
				SetMenuOptionValue(option, ssxRunnerQuest.colors[index])
			endIf
		elseIf pos==9 ; BN back
		endIf
		return

	elseIf pageEditMode==80 ; Actors Editor
		if pos==0 ; MN Select Actor
			if index>-1 && index<ssxRunnerQuest.mcmActorNames.length
				SetMenuOptionValue(option, ssxRunnerQuest.mcmActorNames[index])
				if tmpValInt[0]!=index
					tmpValInt[0]=index
					currentA = ssxRunnerQuest.mcmActors[index]
					if tmpValInt[1]==2 && currentA!=factionsA
						SetMenuOptionValue(option, "Calculating...")
						SetOptionFlags(option, OPTION_FLAG_DISABLED)
						setFactionsAndNames(currentA)
						factionsA=currentA
					endIf
					ForcePageReset()
				endIf
			endIf
		elseIf pos==1 ; MN Select Edit Mode
			if index>-1 && index<3
				SetMenuOptionValue(option, ssxRunnerQuest.editTypes[index])
				if tmpValInt[1]!=index
					tmpValInt[1]=index
					if index==2 && currentA!=factionsA
						SetMenuOptionValue(option, "Calculating...")
						SetOptionFlags(option, OPTION_FLAG_DISABLED)
						setFactionsAndNames(currentA)
						factionsA=currentA
					endIf
					ForcePageReset()
				endIf
			endIf
		elseIf pos==10 ; TG Essential
		elseIf pos==11 ; TG Protected
		elseIf pos==15 ; RO Unique
		elseIf pos==16 ; RO Race
		elseIf pos==24 ; MN Relationship Rank
			if index>-1 && index<ssxRunnerQuest.relRanks.length
				SetMenuOptionValue(option, ssxRunnerQuest.relRanks[index])
				currentA.SetRelationshipRank(PlayerRef, index - 4)
			endIf
		elseIf pos==30 ; MN Select Faction
			if index>-1 && index<factionFilters.length
				SetMenuOptionValue(option, factionFilters[index])
				tmpValInt[30] = index
			endIf
		else
		endIf
		return

	endIf

EndEvent

Event OnOptionDefault(int option); --------------------------------------------------------> DEFAULT <----------
	; ------------- Options by pageEditMode ----------------------------
	int pos = pageOPTs.find(option)
	if pageEditMode==0 ; Main
		if pos==0 ; No active rule
		elseIf pos==1 ; Scent Applied or Not
		elseIf pos==2 ; Edit timers
		elseIf pos==3 ; Edit sexuality
		elseIf pos==4 ; Expertise level
			ssxRunnerQuest.expertiseLevel = 1
			SetMenuOptionValue(option, ssxRunnerQuest.expertiseLevels[1])
			ForcePageReset()
		elseIf pos==5 ; Count anims
		elseIf pos==6 ; Edit Relationship
		elseIf pos==7 ; Scan Mode
			int defaultScanMode = 3
			if ssxRunnerQuest.scanMode != defaultScanMode && ssxRunnerQuest.iAmActive
				int handle = ModEvent.Create("ssxStopScanner")
				ModEvent.Send(handle)
				Utility.waitMenuMode(0.5)
				handle = ModEvent.Create("ssxStopScanner")
				ModEvent.PushInt(handle, defaultScanMode)
				ModEvent.Send(handle)	
			endIf
			ssxRunnerQuest.scanMode=defaultScanMode
			SetMenuOptionValue(option, ssxRunnerQuest.scanModes[ssxRunnerQuest.scanMode])
		endIf
		return
		

	elseIf pageEditMode==1 ; Edit Config
		if pos==0 ; MN Priority mode
			ssxRunnerQuest.priorityMode=0
			SetMenuOptionValue(option, ssxRunnerQuest.priorityModes[0])
		elseIf pos==1 ; MN skipActorsInNamedScenes
			ssxRunnerQuest.skipActorsInNamedScenes=1
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[1])
		elseIf pos==2 ; MN forceStopCombats
			ssxRunnerQuest.forceStopCombats=3
			SetMenuOptionValue(option, ssxRunnerQuest.forceStopCombatsMN[3])
		elseIf pos==3 ; MN followersStayInBleedout
			ssxRunnerQuest.followersStayInBleedout = 1
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[1])
		elseIf pos==5 ; MN popUpDelRule
			ssxRunnerQuest.popUpDelRule = 1
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[1])
		elseIf pos==6 ; MN popUpNotSaved
			ssxRunnerQuest.popUpNotSaved = 1
			SetMenuOptionValue(option, ssxRunnerQuest.popUpName[1])
		elseIf pos==7 ; MN popUpNameNotUpated
			ssxRunnerQuest.popUpNameNotUpated = 1
			SetMenuOptionValue(option, ssxRunnerQuest.popUpName[1])
		elseIf pos==8 ; TG dontBotherOnSLENFix
		elseIf pos==9 ; TG dontBotherOnDefeatFix
		elseIf pos==10 ; BN Back
		elseIf pos==11 ; MN ProtectPlayerOnHealth
			ssxRunnerQuest.protectOnHealth = 1
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[1])
		elseIf pos==12 ; MN SafeCheckOfConCAnims
			ssxRunnerQuest.safeCheckOfConCAnims = 0
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
		endIf
		return

	elseIf pageEditMode==2 ; Edit Timers
		if pos==0 ; Start right away
		elseIf pos==1 ; Back
		elseIf pos==2 ; 
		elseIf pos==3 ; Dont stop
		elseIf pos==4 ; MN Checking mode
			ssxRunnerQuest.checkingMode=0
			SetMenuOptionValue(option, ssxRunnerQuest.checkingModes[0])
		endIf
		return

	elseIf pageEditMode==3 ; Edit Sexuality
		if pos==0 ; Gender Mode
			ssxRunnerQuest.genderMode = 0
			SetMenuOptionValue(option, ssxRunnerQuest.genderModes[0])
			ForcePageReset()
		elseIf pos==1 ; Player Orientation
			ssxRunnerQuest.playerOrientation = 1
			SetMenuOptionValue(option, ssxRunnerQuest.playerOrientations[1])
		elseIf pos==2 ; HM=M Orientation Mode
			ssxRunnerQuest.orientationMode = ssxRunnerQuest.setSexBitsForType(0, 2)
			SetMenuOptionValue(option, ssxRunnerQuest.orientationModes[2])
			ForcePageReset()
		elseIf pos==3 ; HF=F Orientation Mode
			ssxRunnerQuest.orientationMode = ssxRunnerQuest.setSexBitsForType(0, 1)
			SetMenuOptionValue(option, ssxRunnerQuest.orientationModes[1])
			ForcePageReset()
		elseIf pos==4 ; CM=S Orientation Mode
			ssxRunnerQuest.orientationMode = ssxRunnerQuest.setSexBitsForType(0, 2)
			SetMenuOptionValue(option, ssxRunnerQuest.orientationModes[2])
			ForcePageReset()
		elseIf pos==5 ; CF=B Orientation Mode
			ssxRunnerQuest.orientationMode = ssxRunnerQuest.setSexBitsForType(0, 2)
			SetMenuOptionValue(option, ssxRunnerQuest.orientationModes[2])
			ForcePageReset()
		elseIf pos==6 ; Use SL Sexuality
			ssxRunnerQuest.useSLSexuality = 0
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
			ForcePageReset()
		elseIf pos==7 ; Exclude Covered in Cum
			ssxRunnerQuest.excludeActorsWithCum = 0
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
		elseIf pos==8 ; BN Add/Remove
		elseIf pos==9 ; MN Group Color
			ssxRunnerQuest.setFactionGroupColor(1, 0)
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==10 ; MN Group Color
			ssxRunnerQuest.setFactionGroupColor(2, 0)
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==11 ; MN Group Color
			ssxRunnerQuest.setFactionGroupColor(3, 0)
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==12 ; MN Group Color
			ssxRunnerQuest.setFactionGroupColor(4, 0)
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==13 ; MN Group Color
			ssxRunnerQuest.setFactionGroupColor(5, 0)
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==14 ; Back
		endIf
		return

	elseIf pageEditMode==4 ; Edit Relationships
		if pos==0 ; MN Increase Speech
			ssxRunnerQuest.increaseSpeechCraft = 0
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
			ForcePageReset()
		elseIf pos==1 ; MN Increase relationship
			ssxRunnerQuest.IncreaseRelationShip = 0
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
			ForcePageReset()
		elseIf pos==2 ; MN Max rel rank
			ssxRunnerQuest.maxRelationshipRank = 0
			SetMenuOptionValue(option, ssxRunnerQuest.relRanks[0])
		elseIf pos==3 ; BN Back
		endIf
		return
		
	elseIf pageEditMode==10 ; Rule list
		if pos==0 ; Add rule
		elseIf pos==1 ; Edit rule
		elseIf pos==2 ; Delete rule
		elseIf pos==3 ; Duplicate rule
		elseIf pos==4 ; Enable rule
		elseIf pos==5 ; Disable rule
		elseIf pos==6 ; CountAnims
		elseIf pos==7 ; Filter Rules
		elseIf pos==8 ; DeleteAllRules
		endIf
		return

	elseIf pageEditMode==11 ; Add/Edit Rule
		if pos==0 ; Generate Name
		elseIf pos==1 ; Calculate Participants
		elseIf pos==2 ; Edit Participants
		elseIf pos==3 ; Calculate StartsOn
		elseIf pos==4 ; Edit StartsOn
		elseIf pos==5 ; Calculate Anims/Tags
		elseIf pos==6 ; Change Anims/Tags
		elseIf pos==7 ; Change Rule Properties
		elseIf pos==8 ; Change Interactions
		elseIf pos==9 ; Edit Locations
		elseIf pos==10 ; Count anims
		elseIf pos==11 ; Save
		elseIf pos==12 ; Cancel
		endIf
		return

	elseIf pageEditMode==12 ; Edit participants
		if pos==0 ; Target description
		elseIf pos==1 ; Target edit
		elseIf pos==2 ; Source description
		elseIf pos==3 ; Source edit
		elseIf pos==4 ; Collaborator description
		elseIf pos==5 ; Collaborator edit
		elseIf pos==6 ; Number of collaborators
			editRuleL1.setNumColls(1)
			SetMenuOptionValue(option, ssxRunnerQuest.numOfColls[1])
		elseIf pos==7 ; MN Passive role
			editRuleL1.passiveIs=0
			SetMenuOptionValue(option, ssxRunnerQuest.whoWillBePassive[0])
		elseIf pos==8 ; Save
		elseIf pos==9 ; Cancel
		elseIf pos==10 ; Quick Target Settings
			editRuleL1.setParticipant(0, 3, 2, 1, 2)
			editRuleL1.dstRaces=""
			SetMenuOptionValue(option, ssxRunnerQuest.participantQuickSettingsLL[4])
			ForcePageReset()
		elseIf pos==11 ; Quick Source Settings
			editRuleL1.setParticipant(1, 0, 0, 0, 0)
			editRuleL1.srcRaces=""
			SetMenuOptionValue(option, ssxRunnerQuest.participantQuickSettingsLL[0])
			ForcePageReset()
		elseIf pos==12 ; Quick Collaborator Settings
			editRuleL1.setParticipant(2, 0, 0, 0, 0)
			editRuleL1.collRaces=""
			editRuleL1.setNumColls(0)
			SetMenuOptionValue(option, ssxRunnerQuest.participantQuickSettingsLL[0])
			ForcePageReset()
		endIf
		return

	elseIf pageEditMode==13 ; Edit Specific participant
		if pos==0 ; MN Position Type
			if positionEdited==0
				SetMenuOptionValue(option, ssxRunnerQuest.actTypes[1])
			else
				SetMenuOptionValue(option, ssxRunnerQuest.actTypes[0])
			endIf
			if positionEdited==0
				editRuleL2.dstIDs=""
			elseIf positionEdited==1
				editRuleL2.srcIDs=""
			else
				editRuleL2.collIDs=""
			endIf
		elseIf pos==1 ; MN Sex
			SetMenuOptionValue(option, ssxRunnerQuest.sexActorValue[2])
		elseIf pos==2 ; MN Fellowship
			SetMenuOptionValue(option, ssxRunnerQuest.followerOrNot[2])
		elseIf pos==3 ; MN Humanity
			SetMenuOptionValue(option, ssxRunnerQuest.humanOrCreature[0])
		elseIf pos==4 ; TG Do not involve me
		elseIf pos==5 ; TX Edit Race Filters
		elseIf pos==6 ; TX Edit Wearables
		elseIf pos==7 ; TX Edit mods
		elseIf pos==8 ; TX Position values
		elseIf pos==9 ; TX Position name
		elseIf pos==10 ; MN Pick Actor/Faction/Relationship
			; Do nothing, there is not an actual default
		elseIf pos==11 ; TX Add Actor/Faction/Relationship
		elseIf pos==12 ; TX Clear Actor/Faction/Relationship
		elseIf pos==13 ; MN highlight color
			editRuleL2.setHighlightColor(positionEdited, 0, true)
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==14 ; MN highlight components
			editRuleL2.setHighlightColor(positionEdited, 0, false)
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==15 ; TX Save
		elseIf pos==16 ; TX Cancel
		elseIf pos==17 ; BN Edit negative faction filter
		endIf
		return
	
	elseIf pageEditMode==14 ; Edit Animations and Tags Indirection
		if pos==0 ; Go Tags Consensual
		elseIf pos==1 ; Go Anims Consensual
		elseIf pos==2 ; Go Tags Aggressive
		elseIf pos==3 ; Go Anims Aggressive
		elseIf pos==4 ; In Case of Aggressiveness
			editRuleL1.setAggressiveTagReqired(1)
			SetMenuOptionValue(option, ssxRunnerQuest.inCaseOfAggressiveness[1])
		elseIf pos==5 ; Go Back
		elseIf pos<11 ; Not used, ignore
		endIf
		return

	elseIf pageEditMode==24 ; Edit Tags Consensual
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
		elseIf pos==1 ; BN Tags AND/OR
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
		elseIf pos==3 ; MN Gender tags
			SetMenuOptionValue(option, ssxRunnerQuest.addGenderTagsMenu[1])
			editRuleL2.setGenderTags(1, -1, false)
		elseIf pos==4 ; MN Player Gender tags
			SetMenuOptionValue(option, ssxRunnerQuest.playerGenderTags[0])
			editRuleL2.setGenderTags(-1, 0, false)
		elseIf pos==5 ; MN Tag list
		elseIf pos==6 ; BN Add from list
		elseIf pos==7 ; BN Add Typed Tag
		elseIf pos==8 ; BN Clear tags
		elseIf pos==9 ; BN Count Anims
		elseIf pos==10 ; BN Save
		elseIf pos==11 ; Cancel
		endIf

	elseIf pageEditMode==25 ; Edit Tags Aggressive
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
		elseIf pos==1 ; BN Tags AND/OR
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
		elseIf pos==3 ; MN Gender tags
			SetMenuOptionValue(option, ssxRunnerQuest.addGenderTagsMenu[1])
			editRuleL2.setGenderTags(1, -1, true)
		elseIf pos==4 ; MN Player Gender tags
			SetMenuOptionValue(option, ssxRunnerQuest.playerGenderTags[0])
			editRuleL2.setGenderTags(-1, 0, true)
		elseIf pos==5 ; MN Tag list
		elseIf pos==6 ; BN Add from list
		elseIf pos==7 ; BN Add Typed Tag
		elseIf pos==8 ; BN Clear tags
		elseIf pos==9 ; BN Count Anims
		elseIf pos==10 ; BN Save
		elseIf pos==11 ; Cancel
		endIf

		
	elseIf pageEditMode==26 ; Edit Anims Consensual
	elseIf pageEditMode==27 ; Edit Anims Aggressive
		if pos==0 ; IN Type anim filter
		elseIf pos==1 ; MN Select anim
			tmpValInt[1]=0
			SetMenuOptionValue(option, ssxRunnerQuest.animNames[0])
		elseIf pos==2 ; BN Add
		elseIf pos==3 ; BN Clear
		elseIf pos==4 ; MN Gender Tags
			SetMenuOptionValue(option, ssxRunnerQuest.addGenderTagsMenu[1])
			editRuleL2.setGenderTags(1, -1, true)
		elseIf pos==5 ; MN player Gender Tags
			SetMenuOptionValue(option, ssxRunnerQuest.playerGenderTags[0])
			editRuleL2.setGenderTags(-1, 0, true)
		elseIf pos==6 ; BN Count
		elseIf pos==7 ; BN Save
		elseIf pos==8 ; BN Cancel
		elseIf pos>19 && pos<80 ; BN Remove anim
		endIf
		return

	elseIf pageEditMode==15 ; Edit Race Filters
		if pos==0 ; MN Race Mode
			SetMenuOptionValue(option, ssxRunnerQuest.raceInclusiveExclusive[0])

		elseIf pos==1 ; MN Pick Race
			tmpValInt[1] = 0
			SetMenuOptionValue(option, ssxRunnerQuest.allValidRacesB[tmpValInt[1]])
			
		elseIf pos==2 ; BN Add race
		elseIf pos==3 ; BN Clear races
		elseIf pos==4 ; BN Back
		elseIf pos>=20 && pos<40 ; BN Remove selected race
		endIf
		return

	elseIf pageEditMode==16 ; Position wearables
		if pos==0 ; Pick wearables
			tmpValInt[0] = 0
			SetMenuOptionValue(option, ssxRunnerQuest.currentArmorsNames[tmpValInt[0]])
		elseIf pos==1 ; Add wearables start
		elseIf pos==2 ; Add wearables end
		elseIf pos==3 ; Clear wearables start
		elseIf pos==4 ; Clear wearables end
		elseIf pos==5 ; Strip mode
			tmpValInt[5] = 0
			SetMenuOptionValue(option, ssxRunnerQuest.stripModes[tmpValInt[5]])
			editRuleL2.setStripping(positionEdited, tmpValInt[5])
		elseIf pos==6 ; Back
		elseIf pos>9 && pos< 40
		elseIf pos>39 && pos<70
		endIf
	
	elseIf pageEditMode==17 ; Rule interactions
		if pos==0 ; NM AskBeforeSex
			editRuleL1.setAskBeforeSex(false)
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
			ForcePageReset()
		elseIf pos==1 ; MN Ask dialogue
			editRuleL1.setDialogue(0, 0)
			SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.requestDialogues[0], 0, 16) + "...")
		elseIf pos==2 ; MN Answer on SpeechCraft
			editRuleL1.setUseSpeechCraft(false)
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
			ForcePageReset()
		elseIf pos==3 ; MN Positive Answer
			editRuleL1.setDialogue(0, 1)
			SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.positiveAnswers[0], 0, 16) + "...")
		elseIf pos==4 ; MN Positive Answer probability
			editRuleL1.setAnswerProbability(0, true)
			SetMenuOptionValue(option, ssxRunnerQuest.answerProbs[0])
			editRuleL1.setAnswerProbability(4, false)
			SetMenuOptionValue(pageOPTs[6], ssxRunnerQuest.answerProbs[4])
			ForcePageReset()
		elseIf pos==5 ; MN Negative Answer
			editRuleL1.setDialogue(0, 2)
			SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.negativeAnswers[0], 0, 16) + "...")
		elseIf pos==6 ; MN Negative Answer probability
			editRuleL1.setAnswerProbability(0, true)
			SetMenuOptionValue(pageOPTs[4], ssxRunnerQuest.answerProbs[0])
			editRuleL1.setAnswerProbability(4, false)
			SetMenuOptionValue(option, ssxRunnerQuest.answerProbs[4])
			ForcePageReset()
		elseIf pos==7 ; MN Rape on denials
			editRuleL1.setPercRape(0)
			SetMenuOptionValue(option, ssxRunnerQuest.percs[0])
		elseIf pos==8 ; MN Agreesiveness on denials
			editRuleL1.setPercRapeAggr(0)
			SetMenuOptionValue(option, ssxRunnerQuest.percs[0])
		elseIf pos==9 ; MN Mast on denials
			editRuleL1.setPercMast(0)
			SetMenuOptionValue(option, ssxRunnerQuest.percs[0])
		elseIf pos==10 ; MN Final sentence
			editRuleL1.setDialogue(0, 3)
			SetMenuOptionValue(option, StringUtil.substring(ssxRunnerQuest.npcFinalSentences[0], 0, 16) + "...")
		elseIf pos==11 ; MN Aggressiveness
			editRuleL1.aggressive = 0
			SetMenuOptionValue(option, ssxRunnerQuest.percs[0])
			ForcePageReset()
		elseIf pos==12 ; MN Victim
			editRuleL1.setVictim(-1)
			SetMenuOptionValue(option, ssxRunnerQuest.whoIsVictim[0])
		elseIf pos==13 ; MN not used
		elseIf pos==14 ; MN Combats
			editRuleL1.stopAllCombats = 0
			SetMenuOptionValue(option, ssxRunnerQuest.stopAllCombats[0])
		elseIf pos==15 ; MN Save
		elseIf pos==16 ; MN Cancel
		endIf
		
	elseIf pageEditMode==18 ; Rule properties
		if pos==0 ; MN Probability
			editRuleL1.probability=1
			SetMenuOptionValue(option, ssxRunnerQuest.prob[editRuleL1.probability])
		elseIf pos==1 ; MN Beds
			editRuleL1.beds=0
			SetMenuOptionValue(option, ssxRunnerQuest.beds[editRuleL1.beds])
		elseIf pos==2 ; MN Use timeout
			tmpValInt[2]=0
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[tmpValInt[2]])
			ForcePageReset()
		elseIf pos==3 ; BN Save
		elseIf pos==4 ; BN Cancel
		elseIf pos==5 ; BN Scale Actors
			editRuleL1.scaleActors=0
			SetMenuOptionValue(option, ssxRunnerQuest.scaleActorsVals[0])
		elseIf pos==15 ; MN Allow Orgies
			editRuleL1.enableOrgies=0
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
		elseIf pos==17 ; MN Spectators masturbate
			editRuleL1.setSpectatorsMasturbate(0)
			SetMenuOptionValue(option, ssxRunnerQuest.spectatorsMasturbates[0])
		endIf
		
	elseIf pageEditMode==19 ; Rule locations
		if pos==0 ; MN Select location
			tmpValInt[0]=0
			SetMenuOptionValue(option, ssxRunnerQuest.locationList[0])
		elseIf pos==1 ; BN Add location
		elseIf pos==2 ; BN Add current location
		elseIf pos==3 ; MN Select location type
			tmpValInt[3]=0
			SetMenuOptionValue(option, ssxRunnerQuest.locationTypeList[0])
		elseIf pos==4 ; BN Add location type
		elseIf pos==5 ; BN Clear all
		elseIf pos==6 ; MN Internal/External
			tmpValInt[6]=0
			SetMenuOptionValue(option, ssxRunnerQuest.intExtMnu[0])
		elseIf pos==7 ; Save
		elseIf pos==8 ; Cancel
		elseIf pos==9 ; BN Add current cell
		elseIf pos==10 ; MN Inclusive/Exclusive cells
			editRuleL1.setCellInclExcl(true)
			SetMenuOptionValue(option, ssxRunnerQuest.inclExclMnu[0])
		elseIf pos>=20 && pos<50 ; BN Remove specific location
		endIf
	
	elseIf pageEditMode==20 ; Rule Start mode
		if pos==0 ; MN StartsOn
			editRuleL1.startsOn = 0
			editRuleL1.prevRule = 0
			SetMenuOptionValue(option, ssxRunnerQuest.startModes[0])
			ForcePageReset()
		
		elseIf pos==1 ; BN Clean
		elseIf pos==2 ; BN Save
		elseIf pos==3 ; BN Cancel
		elseIf pos==20 ; BN Random
		elseIf pos==21 ; MN Naked
		elseIf pos==22 ; MN SeeNaked
		elseIf pos==23 ; MN SeeSex
		elseIf pos==24 ; MN Arousal
		elseIf pos==25 ; MN Health
		elseIf pos==26 ; MN Stamina
		elseIf pos==27 ; MN Magicka
		elseIf pos==28 ; MN Sleeping
		elseIf pos==29 ; MN Sneaking
		elseIf pos==30 ; MN HasWeapon
		elseIf pos==31 ; MN InCombat
		elseIf pos==32 ; MN Bleedout
		elseIf pos==33 ; MN Unconscious
		elseIf pos==34 ; MN StartTime
			editRuleL1.setStartTimer(8, editRuleL1.getStartTimer(false))
			SetMenuOptionValue(option, ssxRunnerQuest.timeOfTheDay[8])
		elseIf pos==35 ; MN EndTime
			editRuleL1.setStartTimer(editRuleL1.getStartTimer(true), 20)
			SetMenuOptionValue(option, ssxRunnerQuest.timeOfTheDay[20])
		elseIf pos==36 ; MN Sequence
		elseIf pos==41 ; BN Naked
		elseIf pos==42 ; BN SeeNaked
		elseIf pos==43 ; BN SeeSex
		elseIf pos==44 ; BN Arousal
		elseIf pos==45 ; BN Health
		elseIf pos==46 ; BN Stamina
		elseIf pos==47 ; BN Magicka
		elseIf pos==48 ; BN Sleeping
		elseIf pos==49 ; BN Sneaking
		elseIf pos==50 ; BN Weapon
		elseIf pos==51 ; BN Combat
		elseIf pos==52 ; BN Bleedout
		elseIf pos==53 ; BN Unconscious
		elseIf pos==54 ; BN Time
		endIf
	
	elseIf pageEditMode==21 ; Import/Export rules
		if pos>-1 && pos<64 ; TG Rule
		elseIf pos==64 ; MN MultipleExportJoined
			tmpValInt[40] = 0
			SetMenuOptionValue(option, ssxRunnerQuest.yesNo[0])
		elseIf pos==65 ; BN Export Selected
		elseIf pos==66 ; BN Export All
		elseIf pos==67 ; MN Import rules mode
			tmpValInt[67] = 0
			SetMenuOptionValue(option, ssxRunnerQuest.importRulesMode[0])
		elseIf pos==68 ; MN Select rule
			tmpValInt[68] = 0
			String val = StringUtil.substring(jsonRules[0], 20)
			if StringUtil.getLength(jsonRules[0])>20
				val+="..."
			endIf
			SetMenuOptionValue(option, val)
		elseIf pos==69 ; BN Check rule
		elseIf pos==70 ; BN Import selected
		elseIf pos==71 ; BN Import All
		elseIf pos==72 ; BN Back
		endIf

	elseIf pageEditMode==22 ; Rule check
		if pos==0 ; Description
		elseIf pos==1 ; BN Back
		endIf

	elseIf pageEditMode==23 ; Edit Position Mods
		if pos==0 ; MN Pick mod1
			tmpValInt[0]=0
			SetMenuOptionValue(option, ssxRunnerQuest.modsSet1[0])
		elseIf pos==1 ; BN Add1
		elseIf pos==2 ; MN Pick mod 2
			tmpValInt[2]=0
			SetMenuOptionValue(option, ssxRunnerQuest.modsSet2[0])
		elseIf pos==3 ; BN Add2
		elseIf pos==4 ; MN Pick mod 3
			tmpValInt[4]=0
			SetMenuOptionValue(option, ssxRunnerQuest.modsSet3[0])
		elseIf pos==5 ; BN Add3
		elseIf pos==6 ; MN Pick mod 4
			tmpValInt[6]=0
			SetMenuOptionValue(option, ssxRunnerQuest.modsSet4[0])
		elseIf pos==7 ; BN Add4
		elseIf pos==8 ; BN Clear
		elseIf pos==9 ; BN Back
		elseIf pos>9 && pos<50 ; BN remove mod
		endIf

	elseIf pageEditMode==28 ; Edit negative faction filter
		if pos==0 ; read only position type
		elseIf pos==1 ; MN Pick Faction
			tmpValInt[1] = 0
			SetMenuOptionValue(option, factionFilters[tmpValInt[0]])
		elseIf pos==2 ; BN Add Faction
		elseIf pos==3 ; BN Clean all factions
		elseIf pos==4 ; BN Show Factions
		elseIf pos==5 ; BN Back
		elseIf pos>9 && pos<60 ; BN Remove specific faction
		endIf
	
	elseIf pageEditMode==29 ; Edit Starting Wearables
		if pos==0 ; MN Participant
			tmpValInt[0]=0
			SetMenuOptionValue(option, ssxRunnerQuest.participantEdit[0])
			ForcePageReset()
		elseIf pos==1 ; MN Has to/Not to
			tmpValInt[1]=0
			SetMenuOptionValue(option, ssxRunnerQuest.hasToNotTos[0])
			ForcePageReset()
		elseIf pos==2 ; MN Pick wearable
			tmpValInt[2]=0
			SetMenuOptionValue(option, ssxRunnerQuest.currentArmorsNames[0])
		elseIf pos==3 ; BN Add wearable
		elseIf pos==4 ; MN Pick Keyword
			tmpValInt[4]=0
			SetMenuOptionValue(option, ssxRunnerQuest.armorKeywordIDs[0])
		elseIf pos==5 ; BN Add keyword
		elseIf pos==6 ; BN Clear wearables
		elseIf pos==7 ; BN Back
		elseIf pos>0 ; BN Remove nth wearable
		endIf
		
	elseIf pageEditMode==30 ; Nudity
		if pos==0 ; MN Helmet
			ssxRunnerQuest.nakedHead=0
			SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[0])
			ForcePageReset()
		elseIf pos==1 ; MN Armor
			ssxRunnerQuest.nakedBody=0
			SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[0])
			ForcePageReset()
		elseIf pos==2 ; MN Forearms
			ssxRunnerQuest.nakedForearms=0
			SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[0])
			ForcePageReset()
		elseIf pos==3 ; MN Gloves
			ssxRunnerQuest.nakedHands=0
			SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[0])
			ForcePageReset()
		elseIf pos==4 ; MN Calves
			ssxRunnerQuest.nakedCalves=0
			SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[0])
			ForcePageReset()
		elseIf pos==5 ; MN Shoes
			ssxRunnerQuest.nakedFeet=0
			SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[0])
			ForcePageReset()
		elseIf pos==6 ; MN Pelvis
			ssxRunnerQuest.nakedPelvis=0
			SetMenuOptionValue(option, ssxRunnerQuest.nakedIf[0])
			ForcePageReset()
		elseIf pos==7 ; BN Now player is
		elseIf pos==8 ; BN Actor crosshair
		elseIf pos==9 ; MN Armor pieces
			tmpValInt[9]=0
			SetMenuOptionValue(option, ssxRunnerQuest.currentArmorsNames[0])
		elseIf pos==10 ; BN Add armor piece
		elseIf pos==11 ; MN Armor keyword pieces
			tmpValInt[11]=0
			SetMenuOptionValue(option, ssxRunnerQuest.armorKeywordIDs[0])
		elseIf pos==12 ; BN Add armor keyword
		elseIf pos==13 ; BN Clear
		elseIf pos>=20 && pos<50 ; BN Remove
			
		endIf

	elseIf pageEditMode==40 ; Global Races Filter
		if pos==0 ; MN Races to Filter
			tmpValInt[0]=0
			SetMenuOptionValue(option, ssxRunnerQuest.racesToFilter[tmpValInt[0]])
			ForcePageReset()
		elseIf pos==1 ; BN Enable All
		elseIf pos==2 ; BN Disable All
		elseIf pos>9 ; TG Enable/Disable race
		endIf
		
	elseIf pageEditMode==60 ; Anims
		if pos==0 ; MN Race filter
			tmpValInt[0]=0
			SetMenuOptionValue(option, ssxRunnerQuest.racesToFilter[tmpValInt[0]])
			ForcePageReset()
		elseIf pos==1 ; BN Enable all anims
		elseIf pos==2 ; BN Disable all anims
		elseIf pos>9 ; Toggle anim
		endIf
		
	elseIf pageEditMode==70 ; Debug
		if pos==0 ; TG Active/Deactive N
		elseIf pos==1 ; TG Active/Deactiva T
		elseIf pos==2 ; TG What is going on N
		elseIf pos==3 ; TG What is going on T
		elseIf pos==4 ; TG Num actors N
		elseIf pos==5 ; TG Num actors T
		elseIf pos==6 ; TG Rule played N
		elseIf pos==7 ; TG Rule played T
		elseIf pos==8 ; TG Anim played N
		elseIf pos==9 ; TG Anim played T
		elseIf pos==10 ; BN AdvDebug
		elseIf pos==11 ; BN Highlight Actors
		elseIf pos==12 ; BN ForceActorsCleanUp
		elseIf pos==13 ; BN CleanUpActorAround
		elseIf pos==14 ; BN ForceRestart
		elseIf pos==15 ; BN Rescan Tags
		endIf
		return
		
	elseIf pageEditMode==71 ; Adv Debug
		return
	elseIf pageEditMode==72 ; Highlights
		if pos==0 ; TG Found in Scanse
		elseIf pos==1 ; MN Scan Color
			ssxRunnerQuest.notifHighLightColorScan = 0
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==2 ; TG Valid for Rule
		elseIf pos==3 ; TG Potential for Rule
		elseIf pos==4 ; TG Starting Scenes
		elseIf pos==5 ; TG Actors can be asked for sex
		elseIf pos==6 ; MN Ask color
			ssxRunnerQuest.notifHighLightColorAskable = 0
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==7 ; TG Cleaned by Cleaner
		elseIf pos==8 ; MN Cleaned color
			ssxRunnerQuest.notifHighLightColorCleaned = 0
			SetMenuOptionValue(option, ssxRunnerQuest.colors[0])
		elseIf pos==9 ; BN back
		endIf
		return

	elseIf pageEditMode==80 ; Actors Editor
		if pos==0 ; MN Select Actor
			SetMenuOptionValue(option, ssxRunnerQuest.mcmActorNames[0])
			if tmpValInt[0]!=0
				tmpValInt[0]=0
				ForcePageReset()
			endIf
		elseIf pos==1 ; MN Select Edit Mode
			SetMenuOptionValue(option, ssxRunnerQuest.editTypes[0])
			if tmpValInt[1]!=0
				tmpValInt[1]=0
				ForcePageReset()
			endIf
		elseIf pos==10 ; TG Essential
		elseIf pos==11 ; TG Protected
		elseIf pos==15 ; RO Unique
		elseIf pos==16 ; RO Race
		elseIf pos==24 ; MN Relationship Rank
			SetMenuOptionValue(option, ssxRunnerQuest.relRanks[4])
			currentA.SetRelationshipRank(PlayerRef, 0)
		elseIf pos==30 ; MN Select Faction			
			SetMenuOptionValue(option, factionFilters[0])
			tmpValInt[30] = 0
		else
		endIf
		return

	endIf

EndEvent

Event OnOptionHighlight(int option); ------------------------------------------------------> HIGHLIGHT <----------
	; ------------- Options by pageEditMode ----------------------------
	int pos = pageOPTs.find(option)
	if pageEditMode==0 ; Main
		if pos==0 ; No active rule
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgNoRulesDefined"))
		elseIf pos==1 ; Scent Applied or Not
			if ssxRunnerQuest.iAmActive==1
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDisableMod"))
			else
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEnableMod"))
			endIf
		elseIf pos==2 ; Edit timers
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditTimers"))
		elseIf pos==3 ; Edit sexuality
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditSexuality"))
		elseIf pos==4 ; Expertise level
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgExpertiseLevelMN"))
		elseIf pos==5 ; Count anims
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgCountAnimsA"))
		elseIf pos==6 ; Edit relationships
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgRelationship"))
		elseIf pos==7 ; Scan Mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgScanMode"))
		elseIf pos==8 ; Edit Config
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditConfig"))
		endIf
		return

	elseIf pageEditMode==1 ; Edit Config
		if pos==0 ; MN Priority mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPriorityModes"))
		elseIf pos==1 ; MN skipActorsInNamedScenes
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgskipactorsinnamedscenes"))
		elseIf pos==2 ; MN forceStopCombats
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgforcestopcombats"))
		elseIf pos==3 ; MN followersStayInBleedout
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgfollowersStayInBleedout"))
		elseIf pos==4 ; BN Sort Rules
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSortRules"))
		elseIf pos==5 ; MN popUpDelRule
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgpopUpDelRuleMN"))
		elseIf pos==6 ; MN popUpNotSaved
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgpopUpNotSavedMN"))
		elseIf pos==7 ; MN popUpNameNotUpated
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgpopUpNameNotUpatedMN"))
		elseIf pos==8 ; TG dontBotherOnSLENFix
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgdonbotherslen"))
		elseIf pos==9 ; TG dontBotherOnDefeatFix
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgdonbotherdefeat"))
		elseIf pos==10 ; BN Back
			SetInfoText(ssxRunnerQuest.s("$SSX_Back"))
		elseIf pos==11 ; MN ProtectPlayerOnHealth
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgProtectPlayerOnHealth"))
		elseIf pos==12 ; MN SafeCheckOfConCAnims
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSafeCheckOfConCAnims"))
		endIf
	
	elseIf pageEditMode==2 ; Edit Timers
		if pos==0 ; Start right away
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgStartRightAway", ssxRunnerQuest.s("$SSX_StartRightAwayYes"), ssxRunnerQuest.s("$SSX_StartRightAwayNo")))
		elseIf pos==1 ; Back
		elseIf pos==2 ; Stop scenes in case of timeouts
			SetInfoText(ssxRunnerQuest.s("$SSX_hMsgStopSceneInCaseOfTimeouts"))
		elseIf pos==3 ; Don't Stop Scenes
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDontStopScenes"))
		elseIf pos==4 ; MN Checking mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgCheckingMode"))
		endIf
		return
		
	elseIf pageEditMode==3 ; Edit Sexuality
		if pos==0 ; Gender Mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgGenderModeMN"))
		elseIf pos==1 ; Player Orientation
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPlayerOrientation"))
		elseIf pos==2 ; HM=M Orientation Mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgOrientationMode"))
		elseIf pos==3 ; HF=F Orientation Mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgOrientationMode"))
		elseIf pos==4 ; CM=S Orientation Mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgOrientationMode"))
		elseIf pos==5 ; CF=B Orientation Mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgOrientationMode"))
		elseIf pos==6 ; Use SL Sexuality
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsguseslsexuality"))
		elseIf pos==7 ; Exclude Covered in Cum
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgexcludeactorswithcum"))
		elseIf pos==8 ; BN Add/Remove
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgfactionspells"))
		elseIf pos==9 ; MN Group Color
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcolortohighlightgroup"))
		elseIf pos==10 ; MN Group Color
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcolortohighlightgroup"))
		elseIf pos==11 ; MN Group Color
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcolortohighlightgroup"))
		elseIf pos==12 ; MN Group Color
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcolortohighlightgroup"))
		elseIf pos==13 ; MN Group Color
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcolortohighlightgroup"))
		elseIf pos==13 ; Back
		endIf
		return

	elseIf pageEditMode==4 ; Edit Relationships
		if pos==0 ; MN Increase Speech
			SetInfoText(ssxRunnerQuest.s("$SSX_increaseSpeechCraftMN"))
		elseIf pos==1 ; MN Increase relationship
			SetInfoText(ssxRunnerQuest.s("$SSX_IncreaseRelationShipMN"))
		elseIf pos==2 ; MN Max rel rank
			SetInfoText(ssxRunnerQuest.s("$SSX_maxRelationshipRankMN"))
		elseIf pos==3 ; BN Back
			SetInfoText(ssxRunnerQuest.s("$SSX_Back"))
		endIf
		return
		
	elseIf pageEditMode==10 ; Rule list
		if pos==0 ; Add rule
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddRuleBTN"))
		elseIf pos==1 ; Edit rule
			String ruleName = "<No rule selected>"
			if curRuleIndex!=-1
				ruleName = ssxRunnerQuest.rules[curRuleIndex].name
			endIf
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditRuleBTN", ruleName))
		elseIf pos==2 ; Delete rule
			String ruleName = "<No rule selected>"
			if curRuleIndex!=-1
				ruleName = ssxRunnerQuest.rules[tmpValInt[curRuleIndex + 10]].name
			endIf
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDeleteRuleBTN", ruleName))
		elseIf pos==3 ; Duplicate rule
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDuplicaBTN"))
		elseIf pos==4 ; Enable rule
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEnableRuleBTN"))
		elseIf pos==5 ; Disable rule
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDisableRuleBTN"))
		elseIf pos==6 ; CountAnims
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcountanimsr"))
		elseIf pos==7 ; Filter Rules
		elseIf pos==8 ; DeleteAllRules
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDeleteAllRulesBTN"))
		elseIf pos==9 ; Import/Export
			SetInfoText(ssxRunnerQuest.s("$SSX_hmgsgo"))
		elseIf pos>9 && pos <64; It is a rule
			HighLightRule(pos)
		endIf
		return

	elseIf pageEditMode==11 ; Add/Edit Rule
		if pos==0 ; Generate Name
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgGenerateNameBTN"))
		elseIf pos==1 ; Calculate Participants
			SetInfoText(calculateParticipants(editRuleL0, true))
		elseIf pos==2 ; Edit Participants
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditParticipants"))
		elseIf pos==3 ; Calculate StartsOn
			SetInfoText(calculateStartingMode(editRuleL0, true))
		elseIf pos==4 ; Edit StartsOn
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditStartsOn"))
		elseIf pos==5 ; Calculate Anims/Tags
			SetInfoText(calculateAnimTags(editRuleL0, true))
		elseIf pos==6 ; Change Anims/Tags
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditAnimsTags"))
		elseIf pos==7 ; Change Rule Properties
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditProperties"))
		elseIf pos==8 ; Change Interactions
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditStartsOn"))
		elseIf pos==9 ; Edit Locations
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditLocations"))
		elseIf pos==10 ; Count anims
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgCountAnimsR"))
		elseIf pos==11 ; Save
			if isRuleEdit
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSaveRuleBTNC"))
			else
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSaveRuleBTNU"))
			endIf
		elseIf pos==12 ; Cancel
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgCancelRuleBTN"))
		endIf
		return

	elseIf pageEditMode==12 ; Edit participants
		if pos==0 ; Target description
			SetInfoText(ssxRunnerQuest.getPositionLongName(editRuleL1, 0))
		elseIf pos==1 ; Target edit
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgTargetEdit"))
		elseIf pos==2 ; Source description
			SetInfoText(ssxRunnerQuest.getPositionLongName(editRuleL1, 1))
		elseIf pos==3 ; Source edit
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSourceEdit"))
		elseIf pos==4 ; Collaborator description
			SetInfoText(ssxRunnerQuest.getPositionLongName(editRuleL1, 2))
		elseIf pos==5 ; Collaborator edit
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgCollaboratorEdit"))
		elseIf pos==6 ; Number of collaborators
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgNumberOfCollaborators"))
		elseIf pos==7 ; MN Passive role
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgWhoWillBePassive"))
		elseIf pos==8 ; Save
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSavePositionBtn"))
		elseIf pos==9 ; Cancel
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgCancelPositionBtn"))
		elseIf pos==10 ; Quick Target Settings
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgQuickParticipantSetting"))
		elseIf pos==11 ; Quick Source Settings
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgQuickParticipantSetting"))
		elseIf pos==12 ; Quick Collaborator Settings
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgQuickParticipantSetting"))
		elseIf pos==13 ; TG Optional Collaborators
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgOptionalCollaborators"))
		endIf
		return

	elseIf pageEditMode==13 ; Edit Specific participant
		if pos==0 ; MN Position Type
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPositionType"))
		elseIf pos==1 ; MN Sex
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgActorSexMN"))
		elseIf pos==2 ; MN Fellowship
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgFollowerornot"))
		elseIf pos==3 ; MN Humanity
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgHumanorcreature"))
		elseIf pos==4 ; TG Do not involve me
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDoNotInvolveMe"))

		elseIf pos==5 ; TX Edit Race Filters
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditRaceFilter", editRuleL2.getRaceFilter(positionEdited)))
		elseIf pos==6 ; TX Edit Wearables
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditWearables"))
		elseIf pos==7 ; TX Edit mods
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditPositionMods"))
		elseIf pos==8 ; TX Position values
		elseIf pos==9 ; TX Position name
			SetInfoText(ssxRunnerQuest.getPositionLongName(editRuleL2, positionEdited))
		elseIf pos==10 ; MN Pick Actor/Faction/Relationship
			if editRuleL2.isSpecific(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPickSpecific"))
			elseIf editRuleL2.isFaction(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPickFaction"))
			elseIf editRuleL2.isRelationship(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPickRelationship"))
			endIf
		elseIf pos==11 ; TX Add Actor/Faction/Relationship
			if editRuleL2.isSpecific(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddSpecific"))
			elseIf editRuleL2.isFaction(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddFaction"))
			elseIf editRuleL2.isRelationship(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddRelationship"))
			endIf
		elseIf pos==12 ; TX Clear Actor/Faction/Relationship
			if editRuleL2.isSpecific(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgClearSpecific"))
			elseIf editRuleL2.isFaction(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgClearFaction"))
			elseIf editRuleL2.isRelationship(positionEdited)
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgClearRelationship"))
			endIf
		elseIf pos==13 ; MN highlight color good
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgHighlightColorParticipantGood"))
		elseIf pos==14 ; MN highlight color good
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgHighlightColorParticipantBad"))
		elseIf pos==15 ; TX Save
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSavePositionBtn"))
		elseIf pos==16 ; TX Cancel
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgCancelPositionBtn"))
		elseIf pos==17 ; BN Edit negative faction filter
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditTheFiltersOnFactions", ssxRunnerQuest.getNegativeFactionNames(editRuleL2, positionEdited)))
		endIf
		return
	
	elseIf pageEditMode==14 ; Edit Animations and Tags Indirection
		if pos==0 ; Go Tags Consensual
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgTagsConsensual"))
		elseIf pos==1 ; Go Tags Aggressive
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgTagsAggressive"))
		elseIf pos==2 ; Go Anims Consensual
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimsConsensual"))
		elseIf pos==3 ; Go Anims Aggressive
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimsAggressive"))
		elseIf pos==4 ; In Case of Aggressiveness
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgInCaseOfAggressiveness"))
		elseIf pos==5 ; Go Back
		elseIf pos<11 ; Not used, ignore
		endIf
		return

	elseIf pageEditMode==24 ; Edit Tags Consensual
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgsetrequiredtags", editRuleL2.tags))
		elseIf pos==1 ; BN Tags AND/OR
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgtagsandor"))
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgsetavoidtags", editRuleL2.avoid))
		elseIf pos==3 ; MN Gender tags
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddgendertags"))
		elseIf pos==4 ; MN Player Gender tags
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgplayergendertags"))
		elseIf pos==5 ; MN Tag list
			SetInfoText(ssxRunnerQuest.s("$ssx_alltagslist"))
		elseIf pos==6 || pos==7 ; BN Add from list or Typed
			; Calculate the section that will be used to add
			if tmpValInt[0]==1
				SetInfoText(ssxRunnerQuest.s("$ssx_addtagfromdropdowna"))
			elseIf StringUtil.find(editRuleL2.tags, ",")!=-1 && editRuleL2.allTagsRequired(false)
				SetInfoText(ssxRunnerQuest.s("$ssx_addtagfromdropdownp"))
			else
				SetInfoText(ssxRunnerQuest.s("$ssx_addtagfromdropdownr"))
			endIf
		elseIf pos==8 ; BN Clear tags
			; Calculate the section that will be used to clear
			if tmpValInt[0]==1
				SetInfoText(ssxRunnerQuest.s("$ssx_cleartagsa"))
			elseIf StringUtil.find(editRuleL2.tags, ",")!=-1 && editRuleL2.allTagsRequired(false)
				SetInfoText(ssxRunnerQuest.s("$ssx_cleartagsp"))
			else
				SetInfoText(ssxRunnerQuest.s("$ssx_cleartagsr"))
			endIf
		elseIf pos==9 ; BN Count Anims
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcountanimsr"))
		elseIf pos==10 ; BN Save
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsSave"))
		elseIf pos==11 ; Cancel
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsCancel"))
		endIf

	elseIf pageEditMode==25 ; Edit Tags Aggressive
		if pos==0 ; CK req/poss tags (tmpValInt[0]==0)
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgsetrequiredtags", editRuleL2.tagsA))
		elseIf pos==1 ; BN Tags AND/OR
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgtagsandor"))
		elseIf pos==2 ; CK Tags avoid (tmpValInt[0]==1)
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgsetavoidtags", editRuleL2.avoidA))
		elseIf pos==3 ; MN Gender tags
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddgendertags"))
		elseIf pos==4 ; MN Player Gender tags
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgplayergendertags"))
		elseIf pos==5 ; MN Tag list
			SetInfoText(ssxRunnerQuest.s("$ssx_alltagslist"))
		elseIf pos==6 || pos==7 ; BN Add from list or Typed
			; Calculate the section that will be used to add
			if tmpValInt[0]==1
				SetInfoText(ssxRunnerQuest.s("$ssx_addtagfromdropdowna"))
			elseIf StringUtil.find(editRuleL2.tagsA, ",")!=-1 && editRuleL2.allTagsRequired(true)
				SetInfoText(ssxRunnerQuest.s("$ssx_addtagfromdropdownp"))
			else
				SetInfoText(ssxRunnerQuest.s("$ssx_addtagfromdropdownr"))
			endIf
		elseIf pos==8 ; BN Clear tags
			; Calculate the section that will be used to clear
			if tmpValInt[0]==1
				SetInfoText(ssxRunnerQuest.s("$ssx_cleartagsa"))
			elseIf StringUtil.find(editRuleL2.tagsA, ",")!=-1 && editRuleL2.allTagsRequired(true)
				SetInfoText(ssxRunnerQuest.s("$ssx_cleartagsp"))
			else
				SetInfoText(ssxRunnerQuest.s("$ssx_cleartagsr"))
			endIf
		elseIf pos==9 ; BN Count Anims
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcountanimsr"))
		elseIf pos==10 ; BN Save
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsSave"))
		elseIf pos==11 ; Cancel
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsCancel"))
		endIf

		
	elseIf pageEditMode==26 || pageEditMode==27 ; Edit Anims Consensual
		if pos==0 ; IN Type anim filter
		elseIf pos==1 ; MN Select anim
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsPick"))
		elseIf pos==2 ; BN Add
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsAdd"))
		elseIf pos==3 ; BN Clear
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsClear"))
		elseIf pos==4 ; MN Gender Tags
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddgendertags"))
		elseIf pos==5 ; MN player Gender Tags
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgplayergendertags"))
		elseIf pos==6 ; BN Count
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcountanimsr"))
		elseIf pos==7 ; BN Save
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsSave"))
		elseIf pos==8 ; BN Cancel
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsCancel"))
		elseIf pos>19 && pos<80 ; BN Remove anim
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAnimTagsRemoveSelected"))
		endIf
		return

	elseIf pageEditMode==15 ; Edit Race Filters
		if pos==0 ; MN Race Mode
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgraceinclusiveexclusive"))
		elseIf pos==1 ; MN Pick Race
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgselectrace"))
		elseIf pos==2 ; BN Add race
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddrace"))
		elseIf pos==3 ; BN Clear races
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgclearraces"))
		elseIf pos==4 ; BN Back
		elseIf pos>=20 && pos<40 ; BN Remove selected race
		endIf
		return
		
	elseIf pageEditMode==16 ; Position wearables
		if pos==0 ; Pick wearables
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPickWearables"))
		elseIf pos==1 ; Add wearables start
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddWearableToStart"))
		elseIf pos==2 ; Add wearables end
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddWearableToEnd"))
		elseIf pos==3 ; Clear wearables start
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgClearStartWearables"))
		elseIf pos==4 ; Clear wearables end
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgClearEndWearables"))
		elseIf pos==5 ; Strip mode
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgStripMode"))
		elseIf pos==6 ; Back
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgWearablesBack"))
		elseIf pos>9 && pos< 40
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgRemoveWearableFromStart"))
		elseIf pos>39 && pos<70
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgRemoveWearableFromEnd"))
		endIf
	
	elseIf pageEditMode==17 ; Rule interactions
		if pos==0 ; NM AskBeforeSex
			if editRuleL1.startsByPlayerAsking()
			elseIf editRuleL1.isPlayerInvolved() && editRuleL1.getNumPlayers()>1 && editRuleL1.getAskBeforeSex()
				SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaskmebeforesexmn"))
			elseIf !editRuleL1.isPlayerInvolved() && editRuleL1.getNumPlayers()>1
				SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDialoguesNPCtoNPC"))
			endIf
		elseIf pos==1 ; MN Ask dialogue
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDialoguesRequests"))
		elseIf pos==2 ; MN Answer on SpeechCraft
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDialoguesSpeechCraft"))
		elseIf pos==3 ; MN Positive Answer
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDialoguesAnswersP"))
		elseIf pos==4 ; MN Positive Answer probability
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDialoguesProbs"))
		elseIf pos==5 ; MN Negative Answer
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDialoguesAnswersN"))
		elseIf pos==6 ; MN Negative Answer probability
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDialoguesProbs"))
		elseIf pos==7 ; MN Rape on denials
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgdenrapepercmn"))
		elseIf pos==8 ; MN Agresiveness on denials
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgdenaggressivemn"))
		elseIf pos==9 ; MN Mast on denials
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgdenmastpercmn"))
		elseIf pos==10 ; MN Final sentence
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDialoguesFinal"))
		elseIf pos==11 ; MN Aggressiveness
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaggressivemn"))
		elseIf pos==12 ; MN Victim
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgMNVictim"))
		elseIf pos==13 ; MN not used
		elseIf pos==14 ; MN Combats
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgstopallcombats"))
		elseIf pos==15 ; MN Save
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgsaveinteractionbtn"))
		elseIf pos==16 ; MN Cancel
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcancelinteractionbtn"))
		endIf
		
	elseIf pageEditMode==18 ; Rule properties
		if pos==0 ; MN Probability
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgProbMN"))
		elseIf pos==1 ; MN Beds
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgBedsMN"))
		elseIf pos==2 ; MN Use timeout
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgUseatimeout"))
		elseIf pos==3 ; BN Save
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSaveproperties"))
		elseIf pos==4 ; BN Cancel
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgCancelproperties"))
		elseIf pos==5 ; BN Scale Actors
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgScaleActorsMN"))
		elseIf pos>9 && pos<15 ; TG Select description line
			SetInfoText(editRuleL1.description)
		elseIf pos==15 ; MN Allow Orgies
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAllowOrgies"))
		elseIf pos==16 ; TG Enable Foreplay
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgUseLeadinForeplay"))
		elseIf pos==17 ; MN Spectators masturbate
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSpectatorsMasturbate"))
		endIf
		
	elseIf pageEditMode==19 ; Rule locations
		if pos==0 ; MN Select location
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgselectlocationtoadd"))
		elseIf pos==1 ; BN Add location
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddselectedlocation"))
		elseIf pos==2 ; BN Add current location
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddcurrentlocation"))
		elseIf pos==3 ; MN Select location type
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsglocationtypeselect"))
		elseIf pos==4 ; BN Add location type
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsglocationtypeadd"))
		elseIf pos==5 ; BN Clear all
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgclearalllocations"))
		elseIf pos==6 ; MN Internal/External
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsginternalexternal"))
		elseIf pos==7 ; Save
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNSave"))
		elseIf pos==8 ; Cancel
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNCancel"))
		elseIf pos==9 ; BN Add current cell
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddcurrentcell"))
		elseIf pos==10 ; MN Inclusive/Exclusive cells
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgcellinclusiveexclusive"))
		elseIf pos>=20 && pos<50 ; BN Remove specific location
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgremovelocation"))
		endIf
	
	elseIf pageEditMode==20 ; Rule Start mode
		if pos==0 ; MN StartsOn
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNStartsOn"))
		elseIf pos==1 ; BN Clean
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNClean"))
		elseIf pos==2 ; BN Save
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNSave"))
		elseIf pos==3 ; BN Cancel
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNCancel"))
		elseIf pos==20 ; BN Random
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNRandom"))
		elseIf pos==21 ; MN Naked
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNNaked"))
		elseIf pos==22 ; MN SeeNaked
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNSeeNaked"))
		elseIf pos==23 ; MN SeeSex
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNSeeSex"))
		elseIf pos==24 ; MN Arousal
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNArousal"))
		elseIf pos==25 ; MN Health
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNHealth"))
		elseIf pos==26 ; MN Stamina
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNStamina"))
		elseIf pos==27 ; MN Magicka
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNMagicka"))
		elseIf pos==28 ; MN Sleeping
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNSleeping"))
		elseIf pos==29 ; MN Sneaking
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNSneaking"))
		elseIf pos==30 ; MN HasWeapon
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNHasWeapon"))
		elseIf pos==31 ; MN InCombat
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNInCombat"))
		elseIf pos==32 ; MN Bleedout
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNBleedout"))
		elseIf pos==33 ; MN Unconscious
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNUnconscious"))
		elseIf pos==34 ; MN StartTime timeOfTheDay
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNStartTime", calculateTiming(editRuleL1)))
		elseIf pos==35 ; MN EndTime timeOfTheDay
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNEndTime", calculateTiming(editRuleL1)))
		elseIf pos==36 ; MN Sequence
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgMNSequence"))
		elseIf pos==41 ; BN Naked
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNNaked"))
		elseIf pos==42 ; BN SeeNaked
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNSeeNaked"))
		elseIf pos==43 ; BN SeeSex
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNSeeSex"))
		elseIf pos==44 ; BN Arousal
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNArousal"))
		elseIf pos==45 ; BN Health
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNHealth"))
		elseIf pos==46 ; BN Stamina
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNStamina"))
		elseIf pos==47 ; BN Magicka
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNMagicka"))
		elseIf pos==48 ; BN Sleeping
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNSleeping"))
		elseIf pos==49 ; BN Sneaking
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNSneaking"))
		elseIf pos==50 ; BN Weapon
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNWeapon"))
		elseIf pos==51 ; BN Combat
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNCombat"))
		elseIf pos==52 ; BN Bleedout
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNBleedout"))
		elseIf pos==53 ; BN Unconscious
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNUnconscious"))
		elseIf pos==54 ; BN Time
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNTime", calculateTiming(editRuleL1)))
		elseIf pos==55 ; BN Edit Wearables
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNWearables", calculateWearables(editRuleL1)))
		elseIf pos==56 ; BN Add Wearables
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgBNAddWearables"))
		endIf
	
	elseIf pageEditMode==21 ; Import/Export rules
		if pos>-1 && pos<64 ; TG Rule
		elseIf pos==64 ; MN MultipleExportJoined
			SetInfoText(ssxRunnerQuest.s("$ssx_hmgsmultipleexportjoined"))
		elseIf pos==65 ; BN Export Selected
			SetInfoText(ssxRunnerQuest.s("$ssx_hmgseportselectedrules"))
		elseIf pos==66 ; BN Export All
			SetInfoText(ssxRunnerQuest.s("$ssx_hmgseportallrules"))
		elseIf pos==67 ; MN Import rules mode
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgimportrulesmode"))
		elseIf pos==68 ; MN Select rule
			SetInfoText(ssxRunnerQuest.s("$ssx_hmgsfoundrules"))
		elseIf pos==69 ; BN Check rule
			SetInfoText(ssxRunnerQuest.s("$ssx_hmgschecktherule"))
		elseIf pos==70 ; BN Import selected
			SetInfoText(ssxRunnerQuest.s("$ssx_hmgsimportselectedrule"))
		elseIf pos==71 ; BN Import All
			SetInfoText(ssxRunnerQuest.s("$ssx_hmgsimportallrules"))
		elseIf pos==72 ; BN Back
		endIf
		
	elseIf pageEditMode==22 ; Rule check
		if pos==0 ; Description
			SetInfoText(editRuleL0.description)
		elseIf pos==1 ; BN Back
		endIf

	elseIf pageEditMode==23 ; Edit Position Mods
		if pos==0 ; MN Pick mod1
			SetInfoText("Select one of your mods (this list has the mods from #1 to #64")
		elseIf pos==1 ; BN Add1
			SetInfoText("Add the selected mod in the list of valid mods for the position")
		elseIf pos==2 ; MN Pick mod 2
			SetInfoText("Select one of your mods (this list has the mods from #65 to #128")
		elseIf pos==3 ; BN Add2
			SetInfoText("Add the selected mod in the list of valid mods for the position")
		elseIf pos==4 ; MN Pick mod 3
			SetInfoText("Select one of your mods (this list has the mods from #129 to #192")
		elseIf pos==5 ; BN Add3
			SetInfoText("Add the selected mod in the list of valid mods for the position")
		elseIf pos==6 ; MN Pick mod 4
			SetInfoText("Select one of your mods (this list has the mods from #193 to #254")
		elseIf pos==7 ; BN Add4
			SetInfoText("Add the selected mod in the list of valid mods for the position")
		elseIf pos==8 ; BN Clear
			SetInfoText("Clear all the valid mods for the position (so the position will not check if the actor it is from a mod.)")
		elseIf pos==9 ; BN Back
			SetInfoText("Go back to the previous page")
		elseIf pos>9 && pos<50 ; BN remove mod
			SetInfoText("Remove this mod from the list of valid mods")
		endIf

	elseIf pageEditMode==28 ; Edit negative faction filter
		if pos==0 ; read only position type
		elseIf pos==1 ; MN Pick Faction
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPickFaction"))
		elseIf pos==2 ; BN Add Faction
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddFaction"))
		elseIf pos==3 ; BN Clean all factions
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgClearFaction"))
		elseIf pos==4 ; BN Show Factions
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgshowfactions"))
		elseIf pos==5 ; BN Back
		elseIf pos>9 && pos<60 ; BN Remove specific faction
		endIf
	
	elseIf pageEditMode==29 ; Edit Starting Wearables
		if pos==0 ; MN Participant
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEditParticipant"))
		elseIf pos==1 ; MN Has to/Not to
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgHasToNotTo"))
		elseIf pos==2 ; MN Pick wearable
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPickWearables"))
		elseIf pos==3 ; BN Add wearable
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddWearable"))
		elseIf pos==4 ; MN Pick Keyword
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgPickWearablesKW"))
		elseIf pos==5 ; BN Add keyword
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAddarmorKeyword"))
		elseIf pos==6 ; BN Clear wearables
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgclearallwearables"))
		elseIf pos==7 ; BN Back
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgWearablesfilterback"))
		elseIf pos==8 ; BN Check player
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgWearablesCheckPlayer"))
		elseIf pos==9 ; BN Check actor
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgWearablesCheckNPC"))
		elseIf pos>0 ; BN Remove nth wearable
			SetInfoText(ssxRunnerQuest.s("$SSX_RemoveNthWearable"))
		endIf
		
	elseIf pageEditMode==30 ; Nudity
		if pos==0 ; MN Helmet
			SetInfoText(ssxRunnerQuest.s("$ssx_nakedheadmn"))
		elseIf pos==1 ; MN Armor
			SetInfoText(ssxRunnerQuest.s("$ssx_nakedbodymn"))
		elseIf pos==2 ; MN Forearms
			SetInfoText(ssxRunnerQuest.s("$ssx_nakedforearmsmn"))
		elseIf pos==3 ; MN Gloves
			SetInfoText(ssxRunnerQuest.s("$ssx_nakedhandsmn"))
		elseIf pos==4 ; MN Calves
			SetInfoText(ssxRunnerQuest.s("$ssx_nakedcalvesmn"))
		elseIf pos==5 ; MN Shoes
			SetInfoText(ssxRunnerQuest.s("$ssx_nakedfeetmn"))
		elseIf pos==6 ; MN Pelvis
			SetInfoText(ssxRunnerQuest.s("$ssx_nakedpelvismn"))
		elseIf pos==7 ; BN Now player is
			SetInfoText(ssxRunnerQuest.calculateNudityCheck(PlayerRef))
		elseIf pos==8 ; BN Actor crosshair
			Actor a = Game.GetCurrentCrosshairRef() as Actor
			if a
				SetInfoText(ssxRunnerQuest.calculateNudityCheck(a))
			endIf
		elseIf pos==9 ; MN Armor pieces
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgselectarmorpiece"))
		elseIf pos==10 ; BN Add armor piece
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddarmorpiece"))
		elseIf pos==11 ; MN Armor keyword pieces
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgselectarmorkeyword"))
		elseIf pos==12 ; BN Add armor keyword
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgaddarmorkeyword"))
		elseIf pos==13 ; BN Clear
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgclearnakedarmors"))
		elseIf pos>=20 && pos<50 ; BN Remove
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgremovearmorpiece"))
		endIf

	elseIf pageEditMode==40 ; Global Races Filter
		if pos==0 ; MN Races to Filter
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgRacesToFilter"))
		elseIf pos==1 ; BN Enable All
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgEnableAllRaces"))
		elseIf pos==2 ; BN Disable All
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgDisableAllRaces"))
		elseIf pos>9 ; TG Enable/Disable race
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgEnableDisableTheRace"))
		endIf

	elseIf pageEditMode==60 ; Anims
		if pos==0 ; MN Race filter
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsganimracefilter"))
		elseIf pos==1 ; BN Enable all anims
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgenableallanimations"))
		elseIf pos==2 ; BN Disable all anims
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgdisableallanimations"))
		elseIf pos>9 ; Toggle anim
			generateAnimHighlight(pos)
		endIf
		
	elseIf pageEditMode==70 ; Debug
		if pos==0 ; TG Active/Deactive N
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgmodisactivateddeactivated"))
		elseIf pos==1 ; TG Active/Deactiva T
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgmodisactivateddeactivated"))
		elseIf pos==2 ; TG What is going on N
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgWhatIsGoingOn"))
		elseIf pos==3 ; TG What is going on T
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgWhatIsGoingOn"))
		elseIf pos==4 ; TG Num actors N
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnumberofactorsfoundinscant"))
		elseIf pos==5 ; TG Num actors T
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnumberofactorsfoundinscant"))
		elseIf pos==6 ; TG Rule played N
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgruleplayed"))
		elseIf pos==7 ; TG Rule played T
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgruleplayed"))
		elseIf pos==8 ; TG Anim played N
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsganimplayed"))
		elseIf pos==9 ; TG Anim played T
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsganimplayed"))
		elseIf pos==10 ; BN AdvDebug
			SetInfoText("Opens an advanced page to define what you want to see in the papyrus traces.")
		elseIf pos==11 ; BN Highlight Actors
			SetInfoText("Opens an advanced page to define if and when the actors will be highlighted.")
		elseIf pos==12 ; BN ForceActorsCleanUp
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgforceactorscleanup"))	
		elseIf pos==13 ; BN CleanUpActorAround
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgClenUpActorsAround"))
		elseIf pos==14 ; BN ForceRestart
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgForceRestart"))
		elseIf pos==15 ; BN Rescan Tags
			if ssxRunnerQuest.areTagsInProgress==100
				SetTextOptionValue(option, ssxRunnerQuest.s("$SSX_Rescan"))
			else
				SetTextOptionValue(option, ssxRunnerQuest.s("$ssx_rescanning") + " " + ssxRunnerQuest.areTagsInProgress + "%")
			endIf
			SetInfoText(ssxRunnerQuest.s("$ssx_hmsgrescantags"))
		endIf
		return

	elseIf pageEditMode==71 ; Adv Debug
		if pos==0 ; TG notifTimeToComplete
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifTimeToComplete"))
		elseIf pos==1 ; TG notifWarnings
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifWarnings"))
		elseIf pos==2 ; TG notifErrors
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifErrors"))
		elseIf pos==3 ; TG notifCombats
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifCombats"))
		elseIf pos==4 ; TG notifRelationship
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifRelationship"))
		elseIf pos==5 ; TG notifBadRule
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifBadRule"))
		elseIf pos==6 ; TG notifActorForRule
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifActorForRule"))
		elseIf pos==7 ; TG notifActorsFoundLong
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifActorsFoundLong"))
		elseIf pos==8 ; TG notifNotGoodActors
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifNotGoodActors"))
		elseIf pos==9 ; TG notifAnimsScan
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifAnimsScan"))
		elseIf pos==10 ; BN TestPerformance
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgTestPerformance"))
		elseIf pos==11 ; TG notifScanDetails
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifScanDetails"))
		elseIf pos==12 ; TG notifCheckerDetails
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifCheckerDetails"))
		elseIf pos==13 ; TG notifPlayerDetails
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifPlayerDetails"))
		elseIf pos==14 ; TG notifSceneManDetails
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifSceneManDetails"))
		elseIf pos==15 ; TG notifCatchers
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifCatchers"))
		elseIf pos==16 ; TG notifDeferredDetails
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifDeferredDetails"))
		elseIf pos==17 ; TG notifCleanDetails
			SetInfoText(ssxRunnerQuest.s("$SSX_hmsgnotifCleanDetails"))
		elseIf pos==18 ; BN Back
			SetInfoText(ssxRunnerQuest.s("$SSX_Back"))
		endIf
		return
	
		if pos==0 ; TG Activations
			SetInfoText("Show in the traces when a part of this mod (Cell Scanner, Rule Checker, Rule Player, etc.) is starting or stopping, high level, no much details.")
		elseIf pos==1 ; TG Advanced activations and failures
			SetInfoText("Show in the traces what is doing any of the parts of this mod")
		elseIf pos==2 ; TG Timers to complete operations
			SetInfoText("Show in the traces the amount of time required to complete an operation (cell scan, menu open, etc.)")
		elseIf pos==3 ; TG Results of actors scanning
			SetInfoText("Show in the traces the list of actors that are found in a scan")
		elseIf pos==4 ; TG Refused actors in scans
			SetInfoText("Show in the traces when an actor is rejected from the list of available actors")
		elseIf pos==5 ; TG Accepted actors in scans
			SetInfoText("Show in the traces when an actor is added to the actor list")
		elseIf pos==6 ; TG Actors good in filtering
			SetInfoText("Show in the traces when an actor is added to the positions of a rule, with a high level of details")
		elseIf pos==7 ; TG Actors bad in filtering
			SetInfoText("Show in the traces when an actor is rejected by a position of a rule, including the details of the reject")
		elseIf pos==8 ; TG Rules rejected
			SetInfoText("Show in the traces when a rule is rejected as rule to play, including the details of the reject")
		elseIf pos==9 ; TG Rules accepted
			SetInfoText("Show in the traces when a rule is accepted as possible rule to play")
		elseIf pos==10 ; TG Scenes and Animations
			SetInfoText("Show in the traces problems on the Scenes, problems on Animations, and the Animations played")
		elseIf pos==11 ; BN Back
			SetInfoText(ssxRunnerQuest.s("$SSX_Back"))
		elseIf pos==12 ; 
			SetInfoText("Runner: it is the core of the mod. It includes all the global functions, properties, configuration, and data for this mod.")
		elseIf pos==13 ; 
			SetInfoText("Cell Scanner: scans a cell when you enter in it and periadically after the first scan")
		elseIf pos==14 ; 
			SetInfoText("Config Loader: are a set of deferred components that load the config, the tags, and do a quick scan of the items around when you open the MCM")
		elseIf pos==15 ; 
			SetInfoText("MCM: it is the code that handles this MCM")
		elseIf pos==16 ; 
			SetInfoText("Rule Checker: is the part of the mod that check if a rule can be filled and played")
		elseIf pos==17 ; 
			SetInfoText("Rule Player: is the part of the mod that actually plays a rule from the list of possible and filled rules")
		elseIf pos==18 ; 
			SetInfoText("Scene Manager: it handles all the scenes that are run when a rule is playing")
		elseIf pos==19 ; BN test performance
			SetInfoText(ssxRunnerQuest.s("$SSX_HMsgTestPerformance"))
		elseIf pos==20 ; BN Enable papyrus
			SetInfoText("This will try to enable the papyrus.log configuration.\nThe game has to be restarted after.\nThis will NOT work if you are using Mod Organizer.")
		else
		endIf
		return
	elseIf pageEditMode==72 ; Highlights
		if pos==0 ; TG Scans (found actors)
		elseIf pos==1 ; TG Scans (good actors)
			SetInfoText("If checked all the actors that are identified in the scan process as good and are sent to the Rule Checking, will be highlighted with the color defined at the bottom of this page.")
		elseIf pos==2 ; TG Scans (bad actors)
			SetInfoText("If checked the actors that will be identified in the scan process but will not pass the basic filtering will be highlighted with the color defined at the bottom of this page.")
		elseIf pos==3 ; TG Rules Checking (good actors)
			SetInfoText("If checked the actors that will added to a rule (as potential actors) will be highlighted with the color for good actors defined in the rule that is being checked.")
		elseIf pos==4 ; TG Actors can be asked for sex
			SetInfoText("If checked the actors that can be asked for sex will be highlighted with the color for good actors defined in the rule that will be selected.")
		elseIf pos==5 ; TG Starting Scenes
			SetInfoText("If checked the actors that will fill a scene will be highlighted with the color for good actors defined in the rule that will be selected.")
		elseIf pos==6 ; BN back
			SetInfoText("Goes back to the main Debug page")
		elseIf pos==7 ; MN Scan color good
		elseIf pos==8 ; MN Scan color bad
			SetInfoText("This will be the color used to highlight actors that are not fitting in the scan conditions.\nFor all other cases (not scan related) the actual color is defined at rule level.")
		else
		endIf
		return
		if pos==0 ; TG Found in Scanse
			SetInfoText("If checked then as soon as one actor is processed in the scan it will be highlighted with the color defined below.")
		elseIf pos==1 ; MN Scan Color
			SetInfoText("This will be the color used to highlight actors that are good in the scan and will be processed by the rules.")
		elseIf pos==2 ; TG Valid for Rule
			SetInfoText("If checked all the actors that are valid for a rule will be highlighted.\nThe color is defined in the rule itself for each participant.")
		elseIf pos==3 ; TG Potential for Rule
			SetInfoText("If checked all the actors that are potential (good but do not respect all the filters) for a rule will be highlighted.\nThe color is defined in the rule itself for each participant.")
		elseIf pos==4 ; TG Starting Scenes
			SetInfoText("If checked then all actors that will start a sex scene will be highlighted.\nThe color is defined in the rule itself for each participant.")
		elseIf pos==5 ; TG Actors can be asked for sex
			SetInfoText("If checked then all actors that can be asked for sex will be highlighted with the color defined below.")
		elseIf pos==6 ; MN Ask color
			SetInfoText("This will be the color used to highlight actors that can be asked for sex.")
		elseIf pos==7 ; TG Cleaned by Cleaner
			SetInfoText("If checked then all actors that are cleaned up bu the cleaner will be highlighted with the color defined below.")
		elseIf pos==8 ; MN Cleaned color
			SetInfoText("This will be the color used to highlight actors that are cleaned.")
		elseIf pos==9 ; BN back
		endIf
		return

	elseIf pageEditMode==80 ; Actors Editor
		if pos==0 ; MN Select Actor
		elseIf pos==1 ; MN Select Edit Mode
		elseIf pos==10 ; TG Essential
		elseIf pos==11 ; TG Protected
		elseIf pos==15 ; RO Unique
		elseIf pos==16 ; RO Race
		elseIf pos==24 ; MN Relationship Rank
		else
		endIf
		return

	endIf

EndEvent

; -))

; ((- ---------- Sliders, KeyMap, Input ------------------------------------------------------------------------------------------------------------------



state RefreshButton
	event OnSelectST()
		SetTextOptionValueST("Refreshing...")
		Utility.waitMenuMode(0.5)
		ForcePageReset()
	endEvent
endState

state GoButton
	event OnSelectST()
		Utility.waitMenuMode(0.5)
		ssxRunnerQuest.isInitInProgress=100
		ForcePageReset()
	endEvent
endState

state SetKeyKM
	event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
		if newKeyCode==1
			; Esc, let's use it to cancel the values
			if ssxRunnerQuest.ssxKeyCode
				ssxRunnerQuest.UnregisterForKey(ssxRunnerQuest.ssxKeyCode)
			endIf
			ssxRunnerQuest.ssxKeyCode = 0
			ForcePageReset()
		elseIf conflictControl ||  conflictName
			debug.MessageBox("The keymap is conflicting with " + conflictControl + "\n" + conflictName)
		else
			if ssxRunnerQuest.ssxKeyCode
				ssxRunnerQuest.UnregisterForKey(ssxRunnerQuest.ssxKeyCode)
			endIf
			ssxRunnerQuest.ssxKeyCode = newKeyCode
			if ssxRunnerQuest.ssxKeyCode
				ssxRunnerQuest.RegisterForKey(ssxRunnerQuest.ssxKeyCode)
			endIf
			SetKeyMapOptionValueST(ssxRunnerQuest.ssxKeyCode)
		endIf
	endEvent
	
	event OnDefaultST()
		if ssxRunnerQuest.ssxKeyCode
			ssxRunnerQuest.UnregisterForKey(ssxRunnerQuest.ssxKeyCode)
		endIf
		ssxRunnerQuest.ssxKeyCode = 0
		SetKeyMapOptionValueST(0)
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgDefineHotKey"))
	endEvent
endState

state RescanCellTimeSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.rescanCellTime)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(5, 300)
		SetSliderDialogInterval(5)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.rescanCellTime = a_value
		SetSliderOptionValueST(ssxRunnerQuest.rescanCellTime, "{0} secs")
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.rescanCellTime = 30.0
		SetSliderOptionValueST(30.0, "{0} secs")
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgRescanCellTime", getTimeString(ssxRunnerQuest.rescanCellTime)))
	endEvent
endState

state TimeBeforeReDoSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(editRuleL1.timeBeforeReDo)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0, 600)
		SetSliderDialogInterval(5)
	endEvent

	event OnSliderAcceptST(float a_value)
		editRuleL1.timeBeforeReDo=a_value
		SetSliderOptionValueST(editRuleL1.timeBeforeReDo)
		if editRuleL1.timeBeforeReDo==0.0
			tmpValInt[2]=0
			ForcePageReset()
		endIf
	endEvent

	event OnDefaultST()
		editRuleL1.timeBeforeReDo = 0.0
		SetSliderOptionValueST(0.0)
		tmpValInt[2]=0
		ForcePageReset()
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgTimebeforeredo", getTimeString(editRuleL1.timeBeforeReDo)))
	endEvent
endState

state MinTimeSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.ruleCheckerMinWaitTime)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(5, ssxRunnerQuest.ruleCheckerMaxWaitTime)
		if ssxRunnerQuest.ruleCheckerMaxWaitTime < 65
			SetSliderDialogInterval(5)
		elseIf ssxRunnerQuest.ruleCheckerMaxWaitTime < 121
			SetSliderDialogInterval(10)
		else
			SetSliderDialogInterval(30)
		endIf
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.ruleCheckerMinWaitTime = a_value
		SetSliderOptionValueST(ssxRunnerQuest.ruleCheckerMinWaitTime, "{0} secs")
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.ruleCheckerMinWaitTime = 30.0
		SetSliderOptionValueST(30.0, "{0} secs")
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgMinSexUpdate", getTimeString(ssxRunnerQuest.ruleCheckerMinWaitTime)))
	endEvent
endState

state MaxTimeSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.ruleCheckerMaxWaitTime)
		SetSliderDialogDefaultValue(120.0)
		SetSliderDialogRange(ssxRunnerQuest.ruleCheckerMinWaitTime, 6000)
		if ssxRunnerQuest.ruleCheckerMinWaitTime < 65
			SetSliderDialogInterval(5)
		elseIf ssxRunnerQuest.ruleCheckerMinWaitTime < 121
			SetSliderDialogInterval(10)
		else
			SetSliderDialogInterval(30)
		endIf
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.ruleCheckerMaxWaitTime = a_value
		SetSliderOptionValueST(ssxRunnerQuest.ruleCheckerMaxWaitTime, "{0} secs")
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.ruleCheckerMaxWaitTime = 120.0
		SetSliderOptionValueST(120.0, "{0} secs")
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgMaxSecUpdate", getTimeString(ssxRunnerQuest.ruleCheckerMaxWaitTime)))
	endEvent
endState

state MaxNumberOfParallelScenesSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.maxNumberOfParallelScenes)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1, 4)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.maxNumberOfParallelScenes = a_value as Int
		SetSliderOptionValueST(ssxRunnerQuest.maxNumberOfParallelScenes)
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.maxNumberOfParallelScenes = 1
		SetSliderOptionValueST(1.0)
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgNumParScenes"))
	endEvent
endState

state maxNumberOfRulesSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.maxNumberOfRules)
		SetSliderDialogDefaultValue(24.0)
		SetSliderDialogRange(8, 64)
		SetSliderDialogInterval(8)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.maxNumberOfRules = a_value as Int
		SetSliderOptionValueST(ssxRunnerQuest.maxNumberOfRules)
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.maxNumberOfRules = 24
		SetSliderOptionValueST(24.0)
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgmaxNumberOfRules"))
	endEvent
endState

state maxSecondsToReachTargetSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.maxSecondsToReachTarget)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(1.0, 60.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.maxSecondsToReachTarget = a_value as Int
		SetSliderOptionValueST(ssxRunnerQuest.maxSecondsToReachTarget, "{0} secs")
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.maxSecondsToReachTarget = 10.0
		SetSliderOptionValueST(10.0, "{0} secs")
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgNumSecTargetTimeout"))
	endEvent
endState

state maxSecondsToAskSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.maxSecondsToAsk)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(1.0, 60.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.maxSecondsToAsk = a_value as Int
		SetSliderOptionValueST(ssxRunnerQuest.maxSecondsToAsk, "{0} secs")
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.maxSecondsToAsk = 10.0
		SetSliderOptionValueST(10.0, "{0} secs")
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgNumSecGreetTimeout"))
	endEvent
endState

state maxSecondsToReachDenialSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.maxSecondsToReachDenial)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(1.0, 60.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.maxSecondsToReachDenial = a_value as Int
		SetSliderOptionValueST(ssxRunnerQuest.maxSecondsToReachDenial, "{0} secs")
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.maxSecondsToReachDenial = 10.0
		SetSliderOptionValueST(10.0, "{0} secs")
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgNumSecTargetTimeout"))
	endEvent
endState

state maxSecondsToReachBedSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.maxSecondsToReachBed)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(1.0, 60.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.maxSecondsToReachBed = a_value as Int
		SetSliderOptionValueST(ssxRunnerQuest.maxSecondsToReachBed, "{0} secs")
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.maxSecondsToReachBed = 10.0
		SetSliderOptionValueST(10.0, "{0} secs")
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgNumSecBedTimeout"))
	endEvent
endState

state RuleNameINP
	event OnInputOpenST()
		if editRuleL0.name!=ssxRunnerQuest.s("$ssx_noname")
			SetInputDialogStartText(editRuleL0.name)
		endIf
	endEvent

	event OnInputAcceptST(string newTxt)
		if newTxt
			editRuleL0.name = newTxt
		else
			; Generate it
			editRuleL0.name = generateName()
			editRuleL0.automaticName = true
		endIf
		SetInputOptionValueST(editRuleL0.name)
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgRuleNameINP", editRuleL0.name))
	endEvent
endState

state SearchAnimIDNameTag
	event OnInputOpenST()
		SetInputDialogStartText("")
	endEvent

	event OnInputAcceptST(string newNameIdTag)
		tmpValString[0] = newNameIdTag
		String[] thrRaceTypes
		int h
		if StringUtil.find(newNameIdTag, "tag:")!=-1
			h = editRuleL1.getHumanityFullVal()
			ssxRunnerQuest.getAllAnimationNames(editRuleL1.getNumPlayers(), humanity=h, name="", tag=StringUtil.subString(newNameIdTag, StringUtil.find(newNameIdTag, "tag:") + 4), raceTypes=ssxRunnerQuest.getRaceTypes(editRuleL1, h==1))
		else
			h = editRuleL1.getHumanityFullVal()
			ssxRunnerQuest.getAllAnimationNames(editRuleL1.getNumPlayers(), humanity=h, name=newNameIdTag, tag="", raceTypes=ssxRunnerQuest.getRaceTypes(editRuleL1, h==1))
		endIf
		tmpValInt[1]=0
		ForcePageReset()
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSearchAnimIDNameTag"))
	endEvent
endState

state FilterAnimIDNameTag
	event OnInputOpenST()
		SetInputDialogStartText(tmpValString[1])
	endEvent

	event OnInputAcceptST(string newNameIdTag)
		tmpValString[1] = newNameIdTag
		ForcePageReset()
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgSearchAnimIDNameTag"))
	endEvent
endState

state TagNameINP
	event OnInputOpenST()
		if tmpValString[7]!=""
			SetInputDialogStartText(tmpValString[7])	
		endIf
	endEvent

	event OnInputAcceptST(string newTxt)
		tmpValString[7] = newTxt
		SetInputOptionValueST(tmpValString[7])
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgTagOKNameINP"))
	endEvent
endState

state factionFilterINP
	event OnInputOpenST()
		if factionFilter!=""
			SetInputDialogStartText(factionFilter)
		endIf
	endEvent

	event OnInputAcceptST(string newTxt)
		if pageEditMode==13 ; Edit Participant
			SetMenuOptionValue(pageOPTs[10], "Calculating...")
			tmpValInt[0]=-1
		elseIf pageEditMode==28 ; Negative Factions
			SetMenuOptionValue(pageOPTs[1], "Calculating...")
			tmpValInt[1]=-1
		elseIf pageEditMode==80 ; Actor Editor
			SetMenuOptionValue(pageOPTs[30], "Calculating...")
			tmpValInt[30]=-1
		endIf
		factionFilter = newTxt
		if factionFilter!=prevFactionFilter
			; TODO: duplicate code around line 190
			if factionFilter=="" ; All of them
				factionFilters = ssxRunnerQuest.mcmFactionNames
			else
				num=0
				int i = ssxRunnerQuest.mcmFactionNames.length
				while i
					i-=1
					if ssxRunnerQuest.mcmFactionNames[i]!="" && StringUtil.find(ssxRunnerQuest.mcmFactionNames[i], factionFilter)!=-1
						num+=1
					endIf
				endWhile
				if num==0
					factionFilters = ssxRunnerQuest.mcmFactionNames
				else
					factionFilters = Utility.createStringArray(num)
					i = ssxRunnerQuest.mcmFactionNames.length
					num=0
					while i
						i-=1
						if ssxRunnerQuest.mcmFactionNames[i]!="" && StringUtil.find(ssxRunnerQuest.mcmFactionNames[i], factionFilter)!=-1
							factionFilters[num] = ssxRunnerQuest.mcmFactionNames[i]
							num+=1
						endIf
					endWhile
					PapyrusUtil.SortStringArray(factionFilters)
				endIf
			endIf
			prevFactionFilter = factionFilter
		endIf
		SetInputOptionValueST(factionFilter)
		
		if tmpValInt[0]>factionFilters.length
			tmpValInt[0]=0
		endIf
		
		if pageEditMode==13 ; Edit Participant
			SetMenuOptionValue(pageOPTs[10], "")
			tmpValInt[0]=-1
		elseIf pageEditMode==28 ; Negative Factions
			SetMenuOptionValue(pageOPTs[1], "")
			tmpValInt[1]=-1
		elseIf pageEditMode==80 ; Actor Editor
			SetMenuOptionValue(pageOPTs[30], "")
			tmpValInt[30]=-1
		endIf
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgFactionsFilter"))
	endEvent
endState

state maxSpeechCraftLevelSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.maxSpeechCraftLevel)
		SetSliderDialogDefaultValue(100.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.maxSpeechCraftLevel = a_value as Int
		SetSliderOptionValueST(ssxRunnerQuest.maxSpeechCraftLevel)
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.maxSpeechCraftLevel = 100
		SetSliderOptionValueST(100.0)
	endEvent

	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_maxSpeechCraftLevelSL"))
	endEvent
endState

state ArousalSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(editRuleL1.arousalLevel)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		editRuleL1.arousalLevel = a_value as Int
		SetSliderOptionValueST(editRuleL1.arousalLevel, "{0}%")
	endEvent

	event OnDefaultST()
		editRuleL1.arousalLevel = 50
		SetSliderOptionValueST(50.0)
	endEvent
endState

state HealthSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(editRuleL1.healthLevel)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		editRuleL1.healthLevel = a_value as Int
		SetSliderOptionValueST(editRuleL1.healthLevel, "{0}%")
	endEvent

	event OnDefaultST()
		editRuleL1.healthLevel = 50
		SetSliderOptionValueST(50.0)
	endEvent
endState

state StaminaSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(editRuleL1.staminaLevel)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		editRuleL1.staminaLevel = a_value as Int
		SetSliderOptionValueST(editRuleL1.staminaLevel, "{0}%")
	endEvent

	event OnDefaultST()
		editRuleL1.staminaLevel = 50
		SetSliderOptionValueST(50.0)
	endEvent
endState

state MagickaSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(editRuleL1.magickaLevel)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		editRuleL1.magickaLevel = a_value as Int
		SetSliderOptionValueST(editRuleL1.magickaLevel, "{0}%")
	endEvent

	event OnDefaultST()
		editRuleL1.magickaLevel = 50
		SetSliderOptionValueST(50.0)
	endEvent
endState

state RuleAuthorINP
	event OnInputOpenST()
		SetInputDialogStartText(editRuleL1.author)	
	endEvent

	event OnInputAcceptST(string newTxt)
		editRuleL1.author = newTxt
		ForcePageReset()
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAuthor"))
	endEvent
endState

state EditDescrINP
	event OnInputOpenST()
		; Find the line that is selcted, get the nth line
		SetInputDialogStartText(tmpValString[15])
	endEvent

	event OnInputAcceptST(string newTxt)
		tmpValString[15] = newTxt
		int i = 0
		while i<5
			if tmpValInt[10]==i
				tmpValString[10 + i] = newTxt
			endIf
			i+=1
		endWhile
		editRuleL1.description=""
		if tmpValString[10]!=""
			editRuleL1.description=tmpValString[10]
		endIf
		editRuleL1.description+="\n"
		if tmpValString[11]!=""
			editRuleL1.description+=tmpValString[11]
		endIf
		editRuleL1.description+="\n"
		if tmpValString[12]!=""
			editRuleL1.description+=tmpValString[12]
		endIf
		editRuleL1.description+="\n"
		if tmpValString[13]!=""
			editRuleL1.description+=tmpValString[13]
		endIf
		editRuleL1.description+="\n"
		if tmpValString[14]!=""
			editRuleL1.description+=tmpValString[14]
		endIf
		ForcePageReset()
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgAuthor"))
	endEvent
endState

state UpdateNameIN
	event OnInputOpenST()
		SetInputDialogStartText(currentA.getDisplayName())
	endEvent

	event OnInputAcceptST(string newTxt)
		if newTxt!=""
			currentA.setName(newTxt)
			currentA.setDisplayName(newTxt, true)
		endIf
		SetInputOptionValueST(newTxt)
	endEvent
	
	event OnHighlightST()
		SetInfoText("Changes the names of the NPCs and the Player")
	endEvent
endState

state UpdateWeightSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(currentAB.getWeight())
		SetSliderDialogDefaultValue(tmpValInt[12])
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		if currentAB.getWeight()!=a_value
			currentAB.setWeight(a_value)
			float neckDelta = (currentAB.getWeight() / 100.0) - (a_value / 100.0)
			currentA.UpdateWeight(neckDelta)
		endIf
		SetSliderOptionValueST(a_value, "{0}")
	endEvent

	event OnDefaultST()
		currentAB.setWeight(tmpValInt[12])
		SetSliderOptionValueST(tmpValInt[12])
		currentA.QueueNiNodeUpdate()
	endEvent
	
	event OnHighlightST()
		SetInfoText("Changes the Weight of the Actor\nThe change is not persistent for NPCs. It is not possible to change weight or height of an Actor that is on mount")
	endEvent
endState

state UpdateHeightSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(currentAB.getHeight()*100.0)
		SetSliderDialogDefaultValue(tmpValInt[13])
		SetSliderDialogRange(10.0, 200.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		if currentAB.getHeight()!=a_value
			currentAB.setHeight(a_value / 100.0)
			currentA.QueueNiNodeUpdate()
		endIf
		SetSliderOptionValueST(a_value, "{0}")
	endEvent

	event OnDefaultST()
		currentAB.setHeight(tmpValInt[13] / 100.0)
		SetSliderOptionValueST(tmpValInt[13])
		currentA.QueueNiNodeUpdate()
	endEvent
	
	event OnHighlightST()
		SetInfoText("Changes the Height of the Actor\nThe change is not persistent for NPCs. It is not possible to change weight or height of an Actor that is on mount")
	endEvent
endState

state FactionRankSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(currentA.getFactionRank(currentFactions[tmpValInt[33]] As Faction))
		SetSliderDialogDefaultValue(currentA.getFactionRank(currentFactions[tmpValInt[33]] As Faction))
		SetSliderDialogRange(-128.0, 127.0)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		bool update = (currentA.getFactionRank(currentFactions[tmpValInt[33]] As Faction) != a_value)
		currentA.setFactionRank(currentFactions[tmpValInt[33]] As Faction, a_value as Int)
		SetSliderOptionValueST(a_value, "{0}")
		if update
			ForcePageReset()
		endIf
	endEvent

	event OnDefaultST()
	endEvent
	
	event OnHighlightST()
		SetInfoText("Changes the faction rank of the selected actor for the selected faction")
	endEvent
endState

state nakedLevelSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(ssxRunnerQuest.nakedMinLevel)
		SetSliderDialogDefaultValue(0)
		SetSliderDialogRange(0, 500)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		ssxRunnerQuest.nakedMinLevel = a_value as Int
		SetSliderOptionValueST(a_value, "{0}")
	endEvent

	event OnDefaultST()
		ssxRunnerQuest.nakedMinLevel = 0
		SetSliderOptionValueST(0, "{0}")
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$ssx_nakedlevelsl"))
	endEvent
endState

state SpectatorsSL
	Event OnSliderOpenST()
		SetSliderDialogStartValue(editRuleL1.getSpectators())
		SetSliderDialogDefaultValue(0)
		SetSliderDialogRange(0, 15)
		SetSliderDialogInterval(1)
	endEvent

	event OnSliderAcceptST(float a_value)
		if a_value>=0 && a_value<16
			bool wasZero = editRuleL1.getSpectators()==0
			editRuleL1.setSpectators(a_value as Int)
			SetSliderOptionValueST(a_value, "{0}")
			if a_value==0
				editRuleL1.setSpectatorsMasturbate(0) ; No masturbation if there are no spectators
				if !wasZero
					ForcePageReset()
				endIf
			elseIf wasZero
				ForcePageReset()
			endIf
		endIf
	endEvent

	event OnDefaultST()
		editRuleL1.setSpectators(0)
		SetSliderOptionValueST(0, "{0}")
	endEvent
	
	event OnHighlightST()
		SetInfoText(ssxRunnerQuest.s("$SSX_HMsgEnableSpectators"))
	endEvent
endState

; -))

; ((- ---------- Anims functions ------------------------------------------------------------------------------------------------------------------

String Function countAnims(SSX_Rule_Alias r, bool aggressive, bool both)
	{Search the num of anims for all the possible rules}
	sslBaseAnimation[] resAnims
	int plSex = ssxRunnerQuest.calculateSex(PlayerRef)
	if !r
		int i = ssxRunnerQuest.rules.length
		while i
			i -= 1
			r = ssxRunnerQuest.rules[i]
			if r.inUse == 2
				String t = r.tags
				String a = r.avoid
				if aggressive
					t = r.tagsA
					a = r.avoidA
				endIf
				ssxRunnerQuest.generateRaceFilters(availableRaces, r)
				sslBaseAnimation[] anims
				if both
					if r.canBeAggressive()
						anims = ssxRunnerQuest.getAnimsByType(r, true, ssxRunnerQuest.emptyRaces)
						resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
						anims = ssxRunnerQuest.getAnimsByType(r, true, availableRaces)
						resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
					endIf
					anims = ssxRunnerQuest.getAnimsByType(r, false, ssxRunnerQuest.emptyRaces)
					resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
					anims = ssxRunnerQuest.getAnimsByType(r, false, availableRaces)
					resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
				else
					anims = ssxRunnerQuest.getAnimsByType(r, aggressive, ssxRunnerQuest.emptyRaces)
					resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
					anims = ssxRunnerQuest.getAnimsByType(r, aggressive, availableRaces)
					resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
				endIf
			endIf
		endWhile
	else
		String t = r.tags
		String a = r.avoid
		if aggressive
			t = r.tagsA
			a = r.avoidA
		endIf
		ssxRunnerQuest.generateRaceFilters(availableRaces, r)
		sslBaseAnimation[] anims
		if both
			if r.canBeAggressive()
				anims = ssxRunnerQuest.getAnimsByType(r, true, availableRaces)
				resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
			endIf
			anims = ssxRunnerQuest.getAnimsByType(r, false, availableRaces)
		else
			anims = ssxRunnerQuest.getAnimsByType(r, aggressive, availableRaces)
		endIf
		resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
	endIf

	if !resAnims || resAnims.length==0
		return "No anims"
	else
		int tot = resAnims.length
		if tot==1
			return "One anim"
		else
			return tot + " anims"
		endIf
	endIf
EndFunction

sslBaseAnimation[] Function getAnims(SSX_Rule_Alias r)
	{Search the num of anims for all the possible rules}
	sslBaseAnimation[] resAnims
	int plSex = ssxRunnerQuest.calculateSex(PlayerRef)
	if !r
		int i = ssxRunnerQuest.rules.length
		while i
			i -= 1
			r = ssxRunnerQuest.rules[i]
			if r.inUse == 2
				ssxRunnerQuest.generateRaceFilters(availableRaces, r)
				sslBaseAnimation[] anims = ssxRunnerQuest.getAnimsByType(r, r.hasToBeAggressive(), ssxRunnerQuest.emptyRaces)
				resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
				anims = ssxRunnerQuest.getAnimsByType(r, r.hasToBeAggressive(), availableRaces)
				resAnims = SSX_Runner_Quest.MergeAnimLists(resAnims, anims)
			endIf
		endWhile
	else
		ssxRunnerQuest.generateRaceFilters(availableRaces, r)
		if availableRaces[0]==""
			resAnims = ssxRunnerQuest.getAnimsByType(r, r.hasToBeAggressive(), ssxRunnerQuest.emptyRaces)
		else
			resAnims = ssxRunnerQuest.getAnimsByType(r, r.hasToBeAggressive(), availableRaces)
		endIf
	endIf

	return resAnims
EndFunction


; -))

; ((- ---------- Utility functions ------------------------------------------------------------------------------------------------------------------

String Function calculateTiming(SSX_Rule_Alias r)
	int hour = ((Utility.GetCurrentGameTime() - Math.floor(Utility.GetCurrentGameTime())) * 24) as Int
	int sh = r.getStartTimer(true)
	int eh = r.getStartTimer(false)
	if sh==-1 || eh==-1
		return "Now is: " + ssxRunnerQuest.timeOfTheDay[hour]
	endIf
	if sh<=eh && sh<=hour && hour<=eh
		return "Now is: " + ssxRunnerQuest.timeOfTheDay[hour] + " and the rule is valid for the current hour"
	elseIf sh>eh && (sh<=hour || hour<=eh)
		return "Now is: " + ssxRunnerQuest.timeOfTheDay[hour] + " and the rule is valid for the current hour"
	endIf
	return "Now is: " + ssxRunnerQuest.timeOfTheDay[hour] + " and the rule is NOT valid for the current hour"
EndFunction

String Function calculateWearables(SSX_Rule_Alias r)
	String res=""
	if !r.doNotInvolveDst() && (r.hasToWearDst!="" || r.notToWearDst!="")
		res=ssxRunnerQuest.s("$SSX_TheTarget")
		if r.hasToWearDst!=""
			res+=" has to wear items"
			if r.notToWearDst!=""
				res+=" and not wear other items"
			endIf
		else
			if r.notToWearDst!=""
				res+=" has not wear items"
			endIf
		endIf
		res+="\n"
	endIf
	if !r.doNotInvolveSrc() && (r.hasToWearSrc!="" || r.notToWearSrc!="")
		res=ssxRunnerQuest.s("$SSX_TheSource")
		if r.hasToWearSrc!=""
			res+=" has to wear items"
			if r.notToWearSrc!=""
				res+=" and not wear other items"
			endIf
		else
			if r.notToWearSrc!=""
				res+=" has not wear items"
			endIf
		endIf
		res+="\n"
	endIf
	if !r.doNotInvolveColl() && (r.hasToWearColl!="" || r.notToWearColl!="")
		res=ssxRunnerQuest.s("$SSX_TheCollaborator")
		if r.hasToWearColl!=""
			res+=" has to wear items"
			if r.notToWearColl!=""
				res+=" and not wear other items"
			endIf
		else
			if r.notToWearColl!=""
				res+=" has not wear items"
			endIf
		endIf
	endIf
	return res
EndFunction

Function setPageNamesForExpertiseLevel()
	ModName = "Scent of Sex NG"
	Pages = new String[7]
	Pages[0] = ssxRunnerQuest.s("$SSX_PageMain")
	Pages[1] = ssxRunnerQuest.s("$SSX_PageSexRules")
	Pages[2] = ssxRunnerQuest.s("$SSX_PageNudity")
	Pages[3] = ssxRunnerQuest.s("$SSX_PageRaces")
	Pages[4] = ssxRunnerQuest.s("$SSX_PageAnimations")
	Pages[5] = ssxRunnerQuest.s("$SSX_PageActorsEditor")
	Pages[6] = ssxRunnerQuest.s("$SSX_PageDebug")
EndFunction

Function clearPreviousOptions()
	if usedOptions>128
		usedOptions=128
	endIf
	while usedOptions
		usedOptions-=1
		pageOPTs[usedOptions]=-1
	endWhile
endFunction

Function jumpToPage(int page, bool dontReset=false)
	if !dontReset
		int i = usedOptions
		while i
			i-=1
			tmpValInt[i]=0
			tmpValString[i]=""
		endWhile
	endIf
	pageEditMode=page
	ForcePageReset()
endFunction

String Function generateName()
	String res = "UNKNOWN TYPE"
	; Only target: TARGETTYPE for TAG
	; Trg and Src: SRCTYPE on TRGTTYPE for [aggressive] TAG
	; Trg!=C, Src: SRCTYPE with COLTYPE on TRGTTYPE for [aggressive] TAG
	; Trg==C, Src: Threesome of SRCTYPE and TRGTTYPE for [aggressive] TAG
	if editRuleL0.isNobody(SSX_Rule_Alias.sourcePosition()) && editRuleL0.isNobody(SSX_Rule_Alias.collaboratorPosition())
		res = ssxRunnerQuest.getPositionShortName(editRuleL0, 0) + ssxRunnerQuest.s("$ssx_rulenamepartfor")
		if editRuleL0.specificAnimIDs!=""
			res+=ssxRunnerQuest.generateAnimNames(editRuleL0, editRuleL0.canOnlyBeAggressive())
		else
			res+= editRuleL0.tags 
		endIf
	elseIf editRuleL0.isNobody(SSX_Rule_Alias.collaboratorPosition())
		if editRuleL0.isSpecific(1)
			res = editRuleL0.getSpecificActorNames(SSX_Rule_Alias.sourcePosition(), onlyFirstWithDots=true) + ssxRunnerQuest.s("$ssx_rulenameparton")
		elseIf editRuleL0.isRelationship1(1) || editRuleL0.isRelationship2(1)
			res = ssxRunnerQuest.s("$ssx_rulenamepartrelated") + ssxRunnerQuest.s("$ssx_rulenameparton")
		else
			res = ssxRunnerQuest.getPositionShortName(editRuleL0, 1) + ssxRunnerQuest.s("$ssx_rulenameparton")
		endIf
		if editRuleL0.isSpecific(0)
			res += editRuleL0.getSpecificActorNames(SSX_Rule_Alias.targetPosition(), onlyFirstWithDots=true)
		elseIf editRuleL0.isRelationship1(0) || editRuleL0.isRelationship2(0)
			res = ssxRunnerQuest.s("$ssx_rulenamepartrelated") + ssxRunnerQuest.s("$ssx_rulenameparton")
		else
			res += ssxRunnerQuest.getPositionShortName(editRuleL0, 0)
		endIf
		if editRuleL0.specificAnimIDs!=""
			res+=ssxRunnerQuest.s("$ssx_rulenamepartfor") + ssxRunnerQuest.generateAnimNames(editRuleL0, editRuleL0.canOnlyBeAggressive())
		else
			if editRuleL0.tags!=""
				res +=  ssxRunnerQuest.s("$ssx_rulenamepartfor")
				if editRuleL0.aggressive>2
					res += ssxRunnerQuest.s("$ssx_rulenamepartaggr")+ " "
				endIf
				res +=  editRuleL0.tags
			else
				if editRuleL0.aggressive>2
					res += ssxRunnerQuest.s("$ssx_rulenamepartaggr")
				endIf
			endIf
		endIf
	elseIf editRuleL0.src!=editRuleL0.coll
	
		if editRuleL0.isSpecific(1)
			res = editRuleL0.getSpecificActorNames(SSX_Rule_Alias.sourcePosition(), onlyFirstWithDots=true) + ssxRunnerQuest.s("$ssx_rulenamepartwith")
		else
			res = ssxRunnerQuest.getPositionShortName(editRuleL0, 1) + ssxRunnerQuest.s("$ssx_rulenamepartwith")
		endIf
		if editRuleL0.isSpecific(2)
			res += editRuleL0.getSpecificActorNames(SSX_Rule_Alias.collaboratorPosition(), onlyFirstWithDots=true) + ssxRunnerQuest.s("$ssx_rulenameparton") 
		else
			res += ssxRunnerQuest.getPositionShortName(editRuleL0, 2) + ssxRunnerQuest.s("$ssx_rulenameparton")
		endIf
		if editRuleL0.isSpecific(0)
			res += editRuleL0.getSpecificActorNames(SSX_Rule_Alias.targetPosition(), onlyFirstWithDots=true)
		else
			res += ssxRunnerQuest.getPositionShortName(editRuleL0, 0)
		endIf
		if editRuleL0.specificAnimIDs!=""
			res+=ssxRunnerQuest.s("$ssx_rulenamepartfor") + ssxRunnerQuest.generateAnimNames(editRuleL0, editRuleL0.canOnlyBeAggressive())
		else
			if editRuleL0.tags!=""
				res +=  ssxRunnerQuest.s("$ssx_rulenamepartfor")
				if editRuleL0.aggressive>2
					res += ssxRunnerQuest.s("$ssx_rulenamepartaggr")+ " "
				endIf
				res +=  editRuleL0.tags
			else
				if editRuleL0.aggressive>2
					res += ssxRunnerQuest.s("$ssx_rulenamepartaggr")
				endIf
			endIf
		endIf
	elseIf (editRuleL0.isSameRace(2)) || (editRuleL0.src==editRuleL0.coll)
		if editRuleL0.getNumColls()==1
			res=ssxRunnerQuest.s("$ssx_rulenamepart3some")
		else
			res=ssxRunnerQuest.s("$ssx_rulenamepartorgy")
		endIf
		if editRuleL0.isSpecific(1)
			res += editRuleL0.getSpecificActorNames(SSX_Rule_Alias.sourcePosition(), onlyFirstWithDots=true) + ssxRunnerQuest.s("$ssx_rulenamepartand")
		else
			res += ssxRunnerQuest.getPositionShortName(editRuleL0, 1) + ssxRunnerQuest.s("$ssx_rulenamepartand")
		endIf
		if editRuleL0.isSpecific(0)
			res += editRuleL0.getSpecificActorNames(SSX_Rule_Alias.targetPosition(), onlyFirstWithDots=true)
		else
			res += ssxRunnerQuest.getPositionShortName(editRuleL0, 0)
		endIf
		if editRuleL0.specificAnimIDs!=""
			res+=ssxRunnerQuest.s("$ssx_rulenamepartfor") + ssxRunnerQuest.generateAnimNames(editRuleL0, editRuleL0.canOnlyBeAggressive())
		else
			if editRuleL0.tags!=""
				res +=  ssxRunnerQuest.s("$ssx_rulenamepartfor")
				if editRuleL0.aggressive>2
					res += ssxRunnerQuest.s("$ssx_rulenamepartaggr")+ " "
				endIf
				res +=  editRuleL0.tags
			else
				if editRuleL0.aggressive>2
					res += ssxRunnerQuest.s("$ssx_rulenamepartaggr")
				endIf
			endIf
		endIf
	endIf
	return res
EndFunction

Function HighLightRule(int pos)
	SSX_Rule_Alias r = ssxRunnerQuest.rules[tmpValInt[pos]]
	String msg = ssxRunnerQuest.s("$SSX_RDRule")
	msg += r.name
	msg += ssxRunnerQuest.s("$SSX_RDTarget")
	msg += ssxRunnerQuest.getPositionLongName(r, 0)
	if !r.isNobody(1)
		msg += ssxRunnerQuest.s("$SSX_RDSource")
		msg += ssxRunnerQuest.getPositionLongName(r, 1)
	endIf
	if !r.isNobody(2)
		msg += ssxRunnerQuest.s("$SSX_RDColl")
		msg += r.getNumColls()+" "+ssxRunnerQuest.getPositionLongName(r, 2)
	endIf
	if r.specificAnimIDs!=""
		msg += " " + ssxRunnerQuest.s("$SSX_SpecificAnims") + ssxRunnerQuest.generateAnimNames(r, r.canOnlyBeAggressive())
	else
		if r.tags
			msg += ssxRunnerQuest.s("$SSX_RDTags")
			msg += r.tags
		endIf
		if r.aggressive
			msg += ssxRunnerQuest.s("$SSX_RDAggrYes")
		else
			msg += ssxRunnerQuest.s("$SSX_RDAggrNo")
		endIf
	endIf
	msg += ssxRunnerQuest.s("$SSX_RDProbability") + ssxRunnerQuest.prob[r.probability]
	if r.getAskBeforeSex() && r.isPlayerInvolved()
		msg += ssxRunnerQuest.s("$SSX_RDPlAskedForSex")
	endIf
	msg += "\n"
	if r.hasCreatures()
		if r.hasAlsoHumans()
			msg += ssxRunnerQuest.s("$SSX_RDCreaturesMayInvolved")
		else
			msg += ssxRunnerQuest.s("$SSX_RDCreaturesInvolved")
		endIf
	endIf
	if r.hasRaceFilters()
		msg += ssxRunnerQuest.s("$SSX_RDWithRaceFilter")
	endIf
	msg += " Locations: "
	if r.locations!="" || r.locationTypes!=""
		String[] parts = StringUtil.split(r.locations, ";")
		int i = 0
		while i<parts.length
			msg += SSX_Runner_Quest.GetNameFromEditorID(parts[i]) + "; "
			i += 1
		endWhile
		parts = StringUtil.split(r.locationTypes, ";")
		i = 0
		while i<parts.length
			msg += SSX_Runner_Quest.GetNameFromEditorID(parts[i]) + "; "
			i += 1
		endWhile	
	endIf
	msg += calculateStartingMode(r, true)
	int i = 0
	if r.wearAtStartDst!="" || r.wearAtEndDst!="" || r.wearAtStartSrc!="" || r.wearAtEndSrc!="" || r.wearAtStartColl!="" || r.wearAtEndColl!=""
		msg+="Clothes: "
	endIf
	if r.wearAtStartDst!="" || r.wearAtEndDst!=""
		msg+="Dst"
		i+=1
	endIf
	if r.wearAtStartSrc!="" || r.wearAtEndSrc!=""
		if msg!=""
			msg+=", "
		endIf
		msg+="Src"
		i+=1
	endIf
	if r.wearAtStartColl!="" || r.wearAtEndColl!=""
		if msg!=""
			msg+=", "
		endIf
		msg+="Coll"
		i+=1
	endIf
	if r.wearAtStartDst!="" || r.wearAtEndDst!="" || r.wearAtStartSrc!="" || r.wearAtEndSrc!="" || r.wearAtStartColl!="" || r.wearAtEndColl!=""
		if i==1
			msg+=" has to wear"
		else
			msg+=" have to wear"
		endIf
	endIf
	msg += ". "
	if r.inUse==2
		msg += ssxRunnerQuest.s("$SSX_RDRuleEnabled")
	elseIf r.inUse==1
		msg += ssxRunnerQuest.s("$SSX_RDRuleDisabled")
	else
		msg += ssxRunnerQuest.s("$SSX_RDRuleNOTUsed")
	endIf
	if r.automaticName
		msg += ssxRunnerQuest.s("$SSX_RDAutoNamed")
	endIf
	SetInfoText(msg)
EndFunction

String Function calculateParticipants(SSX_Rule_Alias r, bool longDescription=false)
	int i = r.getNumPlayers()
	int j = r.getNumNonInvolved()
	
	String res=""
	if longDescription
		if i==0
			return "Nobody is participating, not valid rule"
		elseIf i==1
			if j
				return "1 participant (and " + j + " not active)\nTarget: " + ssxRunnerQuest.getPositionLongName(r, 0) + "\nSource: " + ssxRunnerQuest.getPositionLongName(r, 1)
			else
				return "1 participant\nTarget: " + ssxRunnerQuest.getPositionLongName(r, 0)
			endIf
		elseIf i==2
			if j
				return "2 participants (and " + j + " not active)\nTarget: " + ssxRunnerQuest.getPositionLongName(r, 0) + "\nSource: " + ssxRunnerQuest.getPositionLongName(r, 1) + "\nCollaborator: " + ssxRunnerQuest.getPositionLongName(r, 2)
			else
				return "2 participants\nTarget: " + ssxRunnerQuest.getPositionLongName(r, 0) + "\nSource: " + ssxRunnerQuest.getPositionLongName(r, 1)
			endIf
		elseIf i==3
			return "3 participants\nTarget: " + ssxRunnerQuest.getPositionLongName(r, 0) + "\nSource: " + ssxRunnerQuest.getPositionLongName(r, 1) + "\nCollaborator: " + ssxRunnerQuest.getPositionLongName(r, 2)
		elseIf i==4 || i==5
			return i + " participants\nTarget: " + ssxRunnerQuest.getPositionLongName(r, 0) + "\nSource: " + ssxRunnerQuest.getPositionLongName(r, 1) + "\n" + (i - 2) + " collaborators: " + ssxRunnerQuest.getPositionLongName(r, 2)
		endIf
		
		return "this is the long description for the participants: " + i
	else
		if i==0
			return "Nobody is participating, not valid rule"
		elseIf i==1
			if j
				return "1 participant (and " + j + " not active)"
			else
				return "1 participant"
			endIf
		else
			if j
				return i + " participants (and " + j + " not active)"
			else
				return i + " participants"
			endIf
		endIf
	endIf
EndFunction

String Function calculateStartingMode(SSX_Rule_Alias r, bool longDescription=false)
	String res = ssxRunnerQuest.s("$SSX_RDStartsOn")
	if longDescription
		if r.startsOn==0
			res += ssxRunnerQuest.startsOns[0]
		elseIf r.startsOn==1
			res += ssxRunnerQuest.startsOns[1]
		elseIf r.startsOn==2
			res += ssxRunnerQuest.startsOns[2]
			if r.prevRule!=-1
				SSX_Rule_Alias prev = ssxRunnerQuest.getRuleById(r.prevRule)
				if prev
					res+=prev.name
				else
					res+="<missing rule>"
				endIf
			else
				res+="<missing rule>"
			endIf
		endIf

		; 1=be naked, 2=see naked, 3=see sex, 4=arousal, 5=health, 6=stamina, 7=magicka, 8=sleep, 9=sneak, 10=weapon, 11=combat, 12=bleedout, 13=unconscious
		if r.isStartingOn(SSX_Rule_Alias.getSMBeNaked())
			res += ", " + ssxRunnerQuest.startsOns[3] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMBeNaked(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMSeeNaked())
			res += ", " + ssxRunnerQuest.startsOns[4] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMSeeNaked(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMSeeSex())
			res += ", " + ssxRunnerQuest.startsOns[5] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMSeeSex(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMArousal())
			res += ", " + ssxRunnerQuest.startsOns[6] + " " + ssxRunnerQuest.startsOnActorModesVal[r.getPositionStartMode(SSX_Rule_Alias.getSMArousal(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMHealth())
			res += ", " + ssxRunnerQuest.startsOns[7] + " " + ssxRunnerQuest.startsOnActorModesVal[r.getPositionStartMode(SSX_Rule_Alias.getSMHealth(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMMagicka())
			res += ", " + ssxRunnerQuest.startsOns[8] + " " + ssxRunnerQuest.startsOnActorModesVal[r.getPositionStartMode(SSX_Rule_Alias.getSMMagicka(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMStamina())
			res += ", " + ssxRunnerQuest.startsOns[9] + " " + ssxRunnerQuest.startsOnActorModesVal[r.getPositionStartMode(SSX_Rule_Alias.getSMStamina(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMSleep())
			res += ", " + ssxRunnerQuest.startsOns[10] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMSleep(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMSneak())
			res += ", " + ssxRunnerQuest.startsOns[11] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMSneak(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMWeapon())
			res += ", " + ssxRunnerQuest.startsOns[12] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMWeapon(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMCombat())
			res += ", " + ssxRunnerQuest.startsOns[13] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMCombat(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMBleedOut())
			res += ", " + ssxRunnerQuest.startsOns[14] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMBleedOut(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMUnconscious())
			res += ", " + ssxRunnerQuest.startsOns[15] + " " + ssxRunnerQuest.startsOnActorModes[r.getPositionStartMode(SSX_Rule_Alias.getSMUnconscious(), -1)]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMWearables(), 1, 1, 1)
			res += ", " + ssxRunnerQuest.startsOns[16] + " "
			if r.getHasToWear(0, true)!="" || r.getHasToWear(0, false)!=""
				res += ssxRunnerQuest.s("$SSX_TheTarget") + " "
			endIf
			if r.getHasToWear(1, true)!="" || r.getHasToWear(1, false)!=""
				res += ssxRunnerQuest.s("$SSX_TheSource") + " "
			endIf
			if r.getHasToWear(2, true)!="" || r.getHasToWear(2, false)!=""
				res += ssxRunnerQuest.s("$SSX_TheCollaborator")
			endIf
		endIf
		if r.getStartTimer(true)!=-1
			if r.getStartTimer(true)<=r.getStartTimer(false)
				res+=", between " + ssxRunnerQuest.timeOfTheDay[r.getStartTimer(true)] + " and " + ssxRunnerQuest.timeOfTheDay[r.getStartTimer(false)] + ", and " + calculateTiming(r)
			else
				res+=", between " + ssxRunnerQuest.timeOfTheDay[r.getStartTimer(true)] + " and " + ssxRunnerQuest.timeOfTheDay[r.getStartTimer(false)] + " of the next day, and " + calculateTiming(r)
			endIf
		endIf
		if r.getIntExt() || r.locations || r.locationTypes
			res+=", locations will matter"
		endIf
		if r.needEquippedItems(-1)
			res+=", participants will need specific items"
		endIf
		return res

	else
		if r.startsOn==0
			res = ssxRunnerQuest.startsOns[0]
		elseIf r.startsOn==1
			res = ssxRunnerQuest.startsOns[1]
		elseIf r.startsOn==2
			res = ssxRunnerQuest.startsOns[2]
		endIf
		; 1=be naked, 2=see naked, 3=see sex, 4=arousal, 5=health, 6=stamina, 7=magicka, 8=sleep, 9=sneak, 10=weapon, 11=combat, 12=bleedout, 13=unconscious
		if r.isStartingOn(SSX_Rule_Alias.getSMBeNaked())
			res += ", " + ssxRunnerQuest.startsOns[3]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMSeeNaked())
			res += ", " + ssxRunnerQuest.startsOns[4]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMSeeSex())
			res += ", " + ssxRunnerQuest.startsOns[5]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMArousal())
			res += ", " + ssxRunnerQuest.startsOns[6]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMHealth())
			res += ", " + ssxRunnerQuest.startsOns[7]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMMagicka())
			res += ", " + ssxRunnerQuest.startsOns[8]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMStamina())
			res += ", " + ssxRunnerQuest.startsOns[9]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMSleep())
			res += ", " + ssxRunnerQuest.startsOns[10]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMSneak())
			res += ", " + ssxRunnerQuest.startsOns[11]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMWeapon())
			res += ", " + ssxRunnerQuest.startsOns[12]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMCombat())
			res += ", " + ssxRunnerQuest.startsOns[13]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMBleedOut())
			res += ", " + ssxRunnerQuest.startsOns[14]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMUnconscious())
			res += ", " + ssxRunnerQuest.startsOns[15]
		endIf
		if r.isStartingOn(SSX_Rule_Alias.getSMWearables(), 1, 1, 1)
			res += ", " + ssxRunnerQuest.startsOns[16]
		endIf
		return res
	endIf
EndFunction

String Function calculateAnimTags(SSX_Rule_Alias r, bool longDescription=false)
	string[] parts
	string res
	if longDescription
		if r.specificAnimIDs!=""
			parts = StringUtil.split(r.specificAnimIDs, ";")
			int i = 0
			res = ssxRunnerQuest.s("$SSX_SpecificAnimsNames")
			while i<parts.length
				sslBaseAnimation anim = SexLab.getAnimationByRegistry(parts[i])
				if !anim
					anim = SexLab.getCreatureAnimationByRegistry(parts[i])
				endIf
				if anim
					res+= anim.name+", "
				endIf
				i+=1
			endWhile
			return StringUtil.subString(res, 0, StringUtil.getLength(res) - 2)
		else
			String concat = " & "
			if r.allTagsRequired(false)
				concat = " | "
			endIf
			parts = StringUtil.split(r.tags, ",")
			int i = 0
			res = "Tags: "
			while i<parts.length
				res+=parts[i]
				res+=concat
				i+=1
			endWhile
			if parts.length==0
				return "Tags: none"
			else
				return StringUtil.subString(res, 0, StringUtil.getLength(res) - 3)
			endIf
		endIf
	else
		if r.specificAnimIDs!=""
			parts = StringUtil.split(r.specificAnimIDs, ";")
			return ssxRunnerQuest.s("$SSX_SpecificAnimsShortName", parts.length)
		else
			parts = StringUtil.split(r.tags, ",")
			int i = 0
			res = "Tags: "
			while i<parts.length
				res+=parts[i]+", "
				i+=1
			endWhile
			if parts.length==0
				return "Tags: none"
			else
				return StringUtil.subString(res, 0, StringUtil.getLength(res) - 2)
			endIf
		endIf
	endIf
	return ""
EndFunction

String Function calculateTagsMessage(SSX_Rule_Alias r, bool aggressive)
	string[] parts
	string res=""
	String concat = " & "
	if r.allTagsRequired(false)
		concat = " | "
	endIf
	if aggressive
		parts = StringUtil.split(r.tagsA, ",")
	else
		parts = StringUtil.split(r.tags, ",")
	endIf
	int i = 0
	while i<parts.length
		res+="+"+parts[i]+concat
		i+=1
	endWhile
	res+=" "
	if aggressive
		parts = StringUtil.split(r.avoidA, ",")
	else
		parts = StringUtil.split(r.avoid, ",")
	endIf
	i = 0
	while i<parts.length
		res+="-"+parts[i]+concat
		i+=1
	endWhile
	if res==""
		return "Tags: none"
	else
		return StringUtil.subString(res, 0, StringUtil.getLength(res) - 3)
	endIf
	return ""
EndFunction

bool Function saveTheRuleActually(bool forceNoChecks)
	if !forceNoChecks
		; Check if the player is not in two places
		int numPlayers = 0
		if editRuleL0.isPlayer(0)
			numPlayers += 1
		endIf
		if editRuleL0.isPlayer(1)
			numPlayers += 1
		endIf
		if editRuleL0.isPlayer(2)
			numPlayers += 1
		endIf
		if numPlayers>1
			Debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningBothTargetAndSource"))
			return false
		endIf
		; Check if we have at least one actor that does sex
		if editRuleL0.getNumPlayers()==0
			Debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningNoSextingActors", editRuleL0.countDefinedPositions(), editRuleL0.getNumNonInvolved()))
			return false
		endIf
		; Check if we start on somebody that does not exists
		if editRuleL0.isNobody(1)
			if editRuleL0.isStartingOn(SSX_Rule_Alias.getSMBeNaked(), -1, 0, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeNaked(), -1, 0, -1) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeSex(), -1, 0, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMArousal(), -1, 0, -1) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSleep(), -1, 0, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMHealth(), -1, 0, -1) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMStamina(), -1, 0, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMMagicka(), -1, 0, -1) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSneak(), -1, 0, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMWeapon(), -1, 0, -1) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMCombat(), -1, 0, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMBleedOut(), -1, 0, -1) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMUnconscious(), -1, 0, -1)
				Debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningRelyingOnNullActor", ssxRunnerQuest.s("$ssx_thesource")))
				return false
			endIf
		endIf
		if editRuleL0.isNobody(2)
			if editRuleL0.isStartingOn(SSX_Rule_Alias.getSMBeNaked(), -1, -1, 0) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeNaked(), -1, -1, 0) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeSex(), -1, -1, 0) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMArousal(), -1, -1, 0) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSleep(), -1, -1, 0) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMHealth(), -1, -1, 0) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMStamina(), -1, -1, 0) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMMagicka(), -1, -1, 0) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSneak(), -1, -1, 0) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMWeapon(), -1, -1, 0) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMCombat(), -1, -1, 0) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMBleedOut(), -1, -1, 0) || \
				editRuleL0.isStartingOn(SSX_Rule_Alias.getSMUnconscious(), -1, -1, 0)
				Debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningRelyingOnNullActor", ssxRunnerQuest.s("$ssx_thecollaborator")))
				return false
			endIf
		endIf
		if SSX_Rule_Alias.neededPos(SSX_Rule_Alias.targetPosition(), editRuleL0.filter1, editRuleL0.filter2, editRuleL0.filter3) && editRuleL0.isNobody(0)
			debug.messagebox(ssxRunnerQuest.s("$SSX_EmptyPositionForStartingMode", ssxRunnerQuest.s("$SSX_TheTarget")))
			return false
		endIf
		if SSX_Rule_Alias.neededPos(SSX_Rule_Alias.sourcePosition(), editRuleL0.filter1, editRuleL0.filter2, editRuleL0.filter3) && editRuleL0.isNobody(1)
			debug.messagebox(ssxRunnerQuest.s("$SSX_EmptyPositionForStartingMode", ssxRunnerQuest.s("$SSX_TheSource")))
			return false
		endIf
		if SSX_Rule_Alias.neededPos(SSX_Rule_Alias.collaboratorPosition(), editRuleL0.filter1, editRuleL0.filter2, editRuleL0.filter3) && editRuleL0.isNobody(2)
			debug.messagebox(ssxRunnerQuest.s("$SSX_EmptyPositionForStartingMode", ssxRunnerQuest.s("$SSX_TheCollaborator")))
			return false
		endIf
		; Check if the rule has valid position per type
		
		; check for each actor the start conditions -> if an actor is sleeping cannot also be bleeding|in combat|weapon|see naked|see sex|sneaking
		if editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSleep(), 1, -1, -1)
			if editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeNaked(), 1, -1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeSex(), 1, -1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSneak(), 1, -1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMCombat(), 1, -1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMWeapon(), 1, -1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMBleedOut(), 1, -1, -1)
				debug.messagebox(ssxRunnerQuest.s("$SSX_WhoSleepsCannotDoOtherActions", ssxRunnerQuest.s("$SSX_TheTarget")))
				return false
			endIf
		endIf
		if editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSleep(), -1, 1, -1)
			if editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeNaked(), -1, 1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeSex(), -1, 1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSneak(), -1, 1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMCombat(), -1, 1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMWeapon(), -1, 1, -1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMBleedOut(), -1, 1, -1)
				debug.messagebox(ssxRunnerQuest.s("$SSX_WhoSleepsCannotDoOtherActions", ssxRunnerQuest.s("$SSX_TheSource")))
				return false
			endIf
		endIf
		if editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSleep(), -1, -1, 1)
			if editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeNaked(), -1, -1, 1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSeeSex(), -1, -1, 1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMSneak(), -1, -1, 1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMCombat(), -1, -1, 1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMWeapon(), -1, -1, 1) || editRuleL0.isStartingOn(SSX_Rule_Alias.getSMBleedOut(), -1, -1, 1)
				debug.messagebox(ssxRunnerQuest.s("$SSX_WhoSleepsCannotDoOtherActions", ssxRunnerQuest.s("$SSX_TheCollaborator")))
				return false
			endIf
		endIf
		
		; Check if specific actors are overlapping
		if editRuleL0.checkSpecificActorsOverlapping()
			Debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningSpecificActorsOverlapping"))
			return false
		endIf
		; Check if the rule can produce at least one animation or we have specific animations
		if editRuleL0.specificAnimIDs==""
			if countAnims(editRuleL0, editRuleL0.hasToBeAggressive(), true)=="No anims"
				Debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningTheRuleDoesNotProuceAnyValidAnimation"))
				return false
			endIf
			; Check if we have rapes on denials that can produce an animation
			if editRuleL0.getAskBeforeSex()==1 && editRuleL0.getPercRape()>0 && editRuleL0.getPercRapeAggr()>0
				if countAnims(editRuleL0, true, false)=="No anims"
					Debug.MessageBox(ssxRunnerQuest.s("$SSX_WarningTheRuleDoesNotProuceAnyValidAnimationForRape"))
					return false
				endIf
			endIf
		endIf
		
		; Check that if creature are possible, then at least one race is enabled, and ask to enable all of them (or the ones in the rule, maybe)
		if editRuleL0.hasCreatures()
			if !ssxRunnerQuest.isAnyCreatureRaceEnabled()
				; msgbox and fix
				if ShowMessage(ssxRunnerQuest.s("$SSX_CreaturesNotEnabled"), true, ssxRunnerQuest.s("$ssx_hellyes"), ssxRunnerQuest.s("$ssx_nothanks"))
					ssxRunnerQuest.enableCreatures("")
				endIf
			endIf
			if editRuleL0.isCreature(0) && !ssxRunnerQuest.isAnyOfTheseRacesEnabled(editRuleL0.dstRaces)
				; msgbox and fix
				if ShowMessage(ssxRunnerQuest.s("$SSX_CreaturesNotEnabledPos", ssxRunnerQuest.s("$SSX_TheTarget")), true, ssxRunnerQuest.s("$ssx_hellyes"), ssxRunnerQuest.s("$ssx_nothanks"))
					ssxRunnerQuest.enableCreatures(editRuleL0.dstRaces)
				endIf
			endIf
			if editRuleL0.isCreature(1) && !ssxRunnerQuest.isAnyOfTheseRacesEnabled(editRuleL0.srcRaces)
				; msgbox and fix
				if ShowMessage(ssxRunnerQuest.s("$SSX_CreaturesNotEnabledPos", ssxRunnerQuest.s("$SSX_TheSource")), true, ssxRunnerQuest.s("$ssx_hellyes"), ssxRunnerQuest.s("$ssx_nothanks"))
					ssxRunnerQuest.enableCreatures(editRuleL0.srcRaces)
				endIf
			endIf
			if editRuleL0.isCreature(2) && !ssxRunnerQuest.isAnyOfTheseRacesEnabled(editRuleL0.collRaces)
				; msgbox and fix
				if ShowMessage(ssxRunnerQuest.s("$SSX_CreaturesNotEnabledPos", ssxRunnerQuest.s("$SSX_TheCollaborator")), true, ssxRunnerQuest.s("$ssx_hellyes"), ssxRunnerQuest.s("$ssx_nothanks"))
					ssxRunnerQuest.enableCreatures(editRuleL0.collRaces)
				endIf
			endIf
		endIf

		; Check, in case of creatures, that all races in the filters (if any) have valid animations
		if editRuleL0.hasCreatures() && editRuleL0.hasRaceFilters()
			String error=""
			String[] races
			String goodRaces=""
			if editRuleL0.isCreature(0) && editRuleL0.dstRaces!=""
				; Check all the items in the races, and find if any of them has no valid anims
				races = StringUtil.split(editRuleL0.dstRaces, ";")
				int i=races.length
				while i
					i-=1
					if SexLab.GetCreatureAnimationsByRaceKey(editRuleL0.getNumPlayers(), races[i]).length==0
						error+=ssxRunnerQuest.s("$SSX_NotValidRaceForRule", races[i], ssxRunnerQuest.s("$SSX_TheTarget"))
					endIf
				endWhile
			endIf
			if editRuleL0.isCreature(1) && editRuleL0.srcRaces!=""
				; Check all the items in the races, and find if any of them has no valid anims
				races = StringUtil.split(editRuleL0.srcRaces, ";")
				int i=races.length
				while i
					i-=1
					if SexLab.GetCreatureAnimationsByRaceKey(editRuleL0.getNumPlayers(), races[i]).length==0
						error+=ssxRunnerQuest.s("$SSX_NotValidRaceForRule", races[i], ssxRunnerQuest.s("$SSX_TheSource"))
					endIf
				endWhile
			endIf
			if editRuleL0.isCreature(2) && editRuleL0.collRaces!=""
				; Check all the items in the races, and find if any of them has no valid anims
				races = StringUtil.split(editRuleL0.collRaces, ";")
				int i=races.length
				while i
					i-=1
					if SexLab.GetCreatureAnimationsByRaceKey(editRuleL0.getNumPlayers(), races[i]).length==0
						error+=ssxRunnerQuest.s("$SSX_NotValidRaceForRule", races[i], ssxRunnerQuest.s("$SSX_TheCollaborator"))
					endIf
				endWhile
			endIf
			if error!="" && ShowMessage(ssxRunnerQuest.s("$SSX_NotValidRacesForRule", error), true, ssxRunnerQuest.s("$SSX_FixItForMe"), ssxRunnerQuest.s("$SSX_NoDontBother"))
				if editRuleL0.dstRaces!=""
					races = StringUtil.split(editRuleL0.dstRaces, ";")
					goodRaces=""
					int i=races.length
					while i
						i-=1
						if SexLab.GetCreatureAnimationsByRaceKey(editRuleL0.getNumPlayers(), races[i]).length!=0
							goodRaces+=races[i]+";"
						endIf
					endWhile
					if goodRaces!=""
						editRuleL0.dstRaces=StringUtil.substring(goodRaces, 0, StringUtil.getLength(goodRaces) - 1)
					else
						editRuleL0.dstRaces=""
					endIf
				endIf
				if editRuleL0.srcRaces!=""
					races = StringUtil.split(editRuleL0.srcRaces, ";")
					goodRaces=""
					int i=races.length
					while i
						i-=1
						if SexLab.GetCreatureAnimationsByRaceKey(editRuleL0.getNumPlayers(), races[i]).length!=0
							goodRaces+=races[i]+";"
						endIf
					endWhile
					if goodRaces!=""
						editRuleL0.srcRaces=StringUtil.substring(goodRaces, 0, StringUtil.getLength(goodRaces) - 1)
					else
						editRuleL0.srcRaces=""
					endIf
				endIf
				if editRuleL0.collRaces!=""
					races = StringUtil.split(editRuleL0.collRaces, ";")
					goodRaces=""
					int i=races.length
					while i
						i-=1
						if SexLab.GetCreatureAnimationsByRaceKey(editRuleL0.getNumPlayers(), races[i]).length!=0
							goodRaces+=races[i]+";"
						endIf
					endWhile
					if goodRaces!=""
						editRuleL0.collRaces=StringUtil.substring(goodRaces, 0, StringUtil.getLength(goodRaces) - 1)
					else
						editRuleL0.collRaces=""
					endIf
				endIf
			endIf
		endIf
		
		ssxRunnerQuest.checkRuleIDs(editRuleL0, Self)
	endIf
	; Save the rule
	SSX_Rule_Alias r = ssxRunnerQuest.rules[ruleEditIndex]
	if editRuleL0.name==ssxRunnerQuest.s("$ssx_noname")
		if ssxRunnerQuest.popUpNameNotUpated==2
			editRuleL0.name = generateName()
			editRuleL0.automaticName = true
		elseIf ssxRunnerQuest.popUpNameNotUpated==1 && ShowMessage(ssxRunnerQuest.s("$SSX_DialogNoName"), true, ssxRunnerQuest.s("$ssx_hellyes"), ssxRunnerQuest.s("$ssx_nothanks"))
			editRuleL0.name = generateName()
			editRuleL0.automaticName = true
		endIf
	endIf
	if forceNoChecks && editRuleL0.name==ssxRunnerQuest.s("$ssx_noname")
		editRuleL0.name = generateName()
		editRuleL0.automaticName = true
	endIf

	; Check if Foreplay anims are possible for the number of players, if not then remove foreplay
	if editRuleL0.hasLeadIn()
		sslBaseAnimation[] anims = SexLab.GetAnimationsByTags(editRuleL0.getNumPlayers(), "LeadIn")
		if !anims || anims.length==0
			editRuleL0.setLeadIn(false)
		endIf
	endIf

	; update the rule with the specified values
	if editingLevel==0
		r.copyFrom(editRuleL0)
	elseIf editingLevel==1
		r.copyFrom(editRuleL1)
	elseIf editingLevel==2
		r.copyFrom(editRuleL2)
	endIf
	editingLevel=-1
	; If the player is in a position, and there are race filters, clean them, and show a debug ssxRunnerQuest.notifActosForTheRule
	if r.dstRaces!="" && !r.areRaceFilterPossible(SSX_Rule_Alias.targetPosition())
		r.dstRaces=""
		ssxRunnerQuest.log(ssxRunnerQuest.s("$SSX_PlayerInPositionWithRaceFiltersCleaned"), SSX_Runner_Quest.notifWarnings())
	endIf
	if r.srcRaces!="" && !r.areRaceFilterPossible(SSX_Rule_Alias.sourcePosition())
		r.srcRaces=""
		ssxRunnerQuest.log(ssxRunnerQuest.s("$SSX_PlayerInPositionWithRaceFiltersCleaned"), SSX_Runner_Quest.notifWarnings())
	endIf
	if r.collRaces!="" && !r.areRaceFilterPossible(SSX_Rule_Alias.collaboratorPosition())
		r.collRaces=""
		ssxRunnerQuest.log(ssxRunnerQuest.s("$SSX_PlayerInPositionWithRaceFiltersCleaned"), SSX_Runner_Quest.notifWarnings())
	endIf

	r.generateLocations()
	r.generateClothes()
	if r.inUse==0
		r.inUse = 2
	endIf
	isRuleEdit=false
	ruleEditIndex=-1
	ssxRunnerQuest.countRules()
	if r.isStartingOn(12) && Game.GetModByName("SexLabDefeat.esp")!=255 && Game.GetModByName("SexLabDefeat.esp")!=-1 && !ssxRunnerQuest.getDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix())
		if !ShowMessage(ssxRunnerQuest.s("$SSX_DefeatWarning"), true, ssxRunnerQuest.s("$SSX_SLENWIWIll"), ssxRunnerQuest.s("$SSX_SLENWNoAndDontBother"))
			 ssxRunnerQuest.setDebug(SSX_Runner_Quest.notifDontBotherOnDefeatFix(), true)
		endIf
	endIf
	
	; Remove the rule as valid, so the actors can be refreshed
	r.status=0
	return true
EndFunction

string Function getTimeString(float timeValue)
	if timeValue==1.0
		return "1 second"
	elseIf timeValue<60.0
		return (timeValue as int) + " secondss"
	else
		int i = timeValue as int
		if i==60
			return "1 minute"
		elseIf i % 60 == 0
			return (i/60) + " minutes"
		elseIf i/60==1
			return "1 minute " + (i%60) + " secsonds"
		else
			return  (i/60) + " minutes " + (i%60) + " secsonds"
		endIf
	endIf
EndFunction

Function generateAnimHighlight(int pos)
	sslBaseAnimation a = SexLab.getAnimationByRegistry(tmpValString[pos])
	if !a
		a = SexLab.getCreatureAnimationByRegistry(tmpValString[pos])
	endIf
	if !a
		SetInfoText("Animation is not exisitng: " + tmpValString[pos])
		return
	endIf
	String msg = a.name+" - " + a.ActorCount() + " "
	if a.ActorCount()==1
		msg += ssxRunnerQuest.s("$SSX_Participant") + "\n"
	else
		msg += ssxRunnerQuest.s("$SSX_Participants") + "\n"
	endIf
	
	; Check the races
	string[] tmpRaces = new String[64]
	string testRace
	int numTmpR = 0
	int i = ssxRunnerQuest.allRacesC.length
	while i
		i -= 1
		if tmpRaces.find(ssxRunnerQuest.allRacesC[i])==-1 ; Check this one
			testRace = ssxRunnerQuest.allRacesC[i]
			
			; Check race for all positions
			int numP = a.ActorCount()
			while numP
				numP-=1
				if tmpRaces.find(testRace)==-1 && a.IsPositionRace(numP, testRace)
					tmpRaces[numTmpR] = testRace
					numTmpR += 1
				endIf
			endWhile
		endIf
	endWhile
	if numTmpR
		msg += ssxRunnerQuest.s("$SSX_Races:")
		while numTmpR
			numTmpR -= 1
			msg += tmpRaces[numTmpR]
			if numTmpR
				msg += ", "
			endIf
		endWhile
		msg += "\n"
	endIf
	
	; Get the tags
	msg += ssxRunnerQuest.s("$SSX_Tags:")
	i = 0
	String[] tags = a.getTags()
	while i < tags.length
		msg += tags[i]
		if i < tags.length - 1
			msg += ", "
		endIf
		i += 1
	EndWhile
	SetInfoText(msg)
EndFunction

Function setFactionsAndNames(Actor a)
	{SKSE getFactions(min, max) seems to be buggy in this case, the new faction are not retrieved}
	; this array is large, so this probably runs pretty slow
	currentFactions = Utility.createFormArray(ssxRunnerQuest.mcmFactions.length)
	currentFactionsNames = Utility.createStringArray(ssxRunnerQuest.mcmFactions.length)
	int len = 0
	int i = ssxRunnerQuest.mcmFactions.length
	while i
		i-=1
		if a.isInFaction(ssxRunnerQuest.mcmFactions[i] As Faction)
			currentFactions[len] = ssxRunnerQuest.mcmFactions[i] As Faction
			currentFactionsNames[len] = ssxRunnerQuest.mcmFactionNames[i]
			len += 1
		endIf
	endWhile
	currentFactions = Utility.ResizeFormArray(currentFactions, len)
	currentFactionsNames = Utility.ResizeStringArray(currentFactionsNames, len)
	tmpValInt[33]=-1
endFunction

Function ForceRestart()
	ssxRunnerQuest.iAmActive = -1
	; Clean the actors arrays
	ssxRunnerQuest.forceActorsCleanUp()
	int i = ssxRunnerQuest.allActors.length
	while i
		i-=1
		ssxRunnerQuest.removeFromAllActors(none, i) ; use RFAA becasue need to restore aggression / predator
	endWhile
	i = ssxRunnerQuest.mcmActors.length
	while i
		i-=1
		ssxRunnerQuest.removeActorForGood(none, i, ssxRunnerQuest.mcmActors)
	endWhile
	
	; Shut down SSX
	ssxRunnerQuest.dontStopScenes=0
	ssxRunnerQuest.stopSSX()
	ssxRunnerQuest.iAmActive = -1
	
	; Send message to PlayerLoadGame to re-execute the reload.
	int handle = ModEvent.Create("ssxForceRestart")
	ModEvent.PushString(handle, "MCM")
	ModEvent.Send(handle)
	Utility.waitMenuMode(5.0)
	ForcePageReset()
endFunction

; -))

; ((- ---------- Rules Import/Export ------------------------------------------------------------------------------------------------------------------

; Exports the rules a json file(s), if allOfThem is false then only the ones that are selected will be exported, if it is true then all of them (selected or not) will be exported
Function exportRules(bool allOfThem)
	String file
	String displayPath = "Data\\configs\\Scent of Sex NG\\"
	num=0
	if allOfThem
		if tmpValInt[64]==1 ; Joined
			file="rules\\exported rules.json"
			displayPath += file
			file=ssxRunnerQuest.configFolder + file
			JSONUtil.ClearAll(file)
			JSONUtil.SetPathIntValue(file, ".version", ssxRunnerQuest.getVersion())
			int i = 0
			while i<ssxRunnerQuest.rules.length
				SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
				if r.inUse!=0
					ssxRunnerQuest.setRule(file, false, i, r)
					num+=1
				endIf
				i+=1
			endWhile
			JSONUtil.save(file)
			debug.MessageBox(ssxRunnerQuest.s("$SSX_AllRulesExported", displayPath, num))
		else ; Each rule in a different file
			int i = 0
			while i<ssxRunnerQuest.rules.length
				SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
				if r.inUse!=0
					file="rules\\" + fixIllegalChars(r.name) + ".json"
					displayPath += file
					file=ssxRunnerQuest.configFolder + file
					JSONUtil.ClearAll(file)
					JSONUtil.SetPathIntValue(file, ".version", ssxRunnerQuest.getVersion())
					ssxRunnerQuest.setRule(file, true, i, r)
					num+=1
					JSONUtil.save(file)
				endIf
				i+=1
			endWhile
			debug.MessageBox(ssxRunnerQuest.s("$SSX_AllRulesExportedMultipleFiles", displayPath, num))
		endIf
	else ; Only the ones selected
		if tmpValInt[64]==1 ; Joined
			file="rules\\exported rules.json"
			displayPath += file
			file=ssxRunnerQuest.configFolder + file
			JSONUtil.ClearAll(file)
			JSONUtil.SetPathIntValue(file, ".version", ssxRunnerQuest.getVersion())
			int i = 0
			while i<ssxRunnerQuest.rules.length && i<64
				SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
				if r.inUse!=0
					if tmpValInt[i]==1
						ssxRunnerQuest.setRule(file, false, i, r)
						num+=1
					endIf
				endIf
				i+=1
			endWhile
			JSONUtil.save(file)
			debug.MessageBox(ssxRunnerQuest.s("$SSX_AllSelectedRulesExported", file, num))
		else ; Each rule in a different file
			int i = 0
			while i<ssxRunnerQuest.rules.length && i<64
				SSX_Rule_Alias r = ssxRunnerQuest.rules[i]
				if r.inUse!=0 && tmpValInt[i]==1
					file="rules\\" + fixIllegalChars(r.name) + ".json"
					displayPath += file
					file=ssxRunnerQuest.configFolder + file
					JSONUtil.ClearAll(file)
					JSONUtil.SetPathIntValue(file, ".version", ssxRunnerQuest.getVersion())
					ssxRunnerQuest.setRule(file, true, i, r)
					num+=1
					JSONUtil.save(file)
				endIf
				i+=1
			endWhile
			debug.MessageBox(ssxRunnerQuest.s("$SSX_AllSelectedRulesExportedMultipleFiles", file, num))
		endIf
	endIf
EndFunction

; Imports all the rules in the directory (case allOfThem == true), or the one selected in the dropdown (case allOfThem == false)
Function importRules(bool allOfThem)
	String file
	if allOfThem
		int j = jsonRules.length
		while j
			j-=1
			file = ssxRunnerQuest.configFolder + "rules\\" + jsonRules[j] + ".json"
			JSONUtil.load(file) ; Load the file
			if !JSONUtil.isGood(file)
				debug.messagebox(ssxRunnerQuest.s("$SSX_NotValidJSONFile", file, JSONUtil.getErrors(file)))
			else
				; Check the version
				int version = JSONUtil.GetPathIntValue(file, ".version", -1)
				if version<10300
					Debug.messagebox(ssxRunnerQuest.s("$SSX_RuleTooOld"))
				else
					; Check if it is a collection of rule
					num = JSONUtil.PathCount(file, ".rules")
					if num>0 ; Collection of rules
						while num
							num-=1
							importARule(file, num)
						endWhile
					else ; Single rule
						importARule(file)
					endIf
				endIf
			endIf
		endWhile
	
	else ; Just the selected one
		file = ssxRunnerQuest.configFolder + "rules\\" + jsonRules[tmpValInt[68]] + ".json"
		JSONUtil.load(file) ; Load the file
		if !JSONUtil.isGood(file)
			debug.messagebox(ssxRunnerQuest.s("$SSX_NotValidJSONFile", file, JSONUtil.getErrors(file)))
			return
		endIf
		; Check the version
		int version = JSONUtil.GetPathIntValue(file, ".version", -1)
		if version<10300
			Debug.messagebox(ssxRunnerQuest.s("$SSX_RuleTooOld"))
			return
		endIf
		; Check if it is a collection of rule
		num = JSONUtil.PathCount(file, ".rules")
		if num>0 ; Collection of rules
			while num
				num-=1
				importARule(file, num)
			endWhile
		else ; Single rule
			importARule(file)
		endIf
	endIf
EndFunction

Function importARule(String file, int index=-1)
	ssxRunnerQuest.getRule(file, index==-1, index, editRuleL0, Self)
	; Check if a rule with the same ID exists, in case follow the import mode selected
	SSX_Rule_Alias r = ssxRunnerQuest.getRuleById(editRuleL0.id)
	if r!=None
		if tmpValInt[67]==0
			debug.messagebox(ssxRunnerQuest.s("$SSX_NotImportedBecauseIgnore", r.name))
			return
		elseIf tmpValInt[67]==1 ; Overwrite
			String name = r.name
			r.copyFrom(editRuleL0)
			debug.messagebox(ssxRunnerQuest.s("$SSX_RuleImportedByOverwriting", name, r.name))
			return
		elseIf tmpValInt[67]==2 ; Duplicate
			; Find an empty slot
			ruleEditIndex = -1
			int i = 0
			while i<ssxRunnerQuest.rules.length && ruleEditIndex==-1
				if ssxRunnerQuest.rules[i].inUse==0
					ruleEditIndex = i
				endIf
				i += 1
			endWhile
			if ruleEditIndex==-1
				Debug.MessageBox("The rule cannot be imported with duplication. You already have too many defined rules.\nThe max number of rules is: " + ssxRunnerQuest.rules.length)
				return
			endIf
			while r.id==editRuleL0.id
				editRuleL0.id=Utility.RandomInt(1, 65535)
			endWhile
			if ssxRunnerQuest.getRuleByName(editRuleL0.name)!=None
				editRuleL0.name+=" DUP"
			endIf
			ssxRunnerQuest.rules[ruleEditIndex].copyFrom(editRuleL0)
			debug.messagebox(ssxRunnerQuest.s("$SSX_RuleImportedWithDuplication", editRuleL0.name))
			return
		endIf
	endIf
	; The rule does not exist, create it
	ruleEditIndex = -1
	int i = 0
	while i<ssxRunnerQuest.rules.length && ruleEditIndex==-1
		if ssxRunnerQuest.rules[i].inUse==0
			ruleEditIndex = i
		endIf
		i += 1
	endWhile
	if ruleEditIndex==-1
		Debug.MessageBox("The rule cannot be imported. You already have too many defined rules.\nThe max number of rules is: " + ssxRunnerQuest.rules.length)
		return
	endIf
;	if ssxRunnerQuest.rules[ruleEditIndex].id==editRuleL0.ID
;		editRuleL0.ID=Utility.RandomInt(1, 65535)
;	endIf
	i = 1000
	while i > 0 && ssxRunnerQuest.getRuleById(editRuleL0.id) ; not 100% sure about this but seems reasonable -- Reikiri
		editRuleL0.id=Utility.RandomInt(1, 65535)
		i -= 1
	endWhile
	ssxRunnerQuest.rules[ruleEditIndex].copyFrom(editRuleL0)
	ssxRunnerQuest.rules[ruleEditIndex].generateLocations()
	ssxRunnerQuest.rules[ruleEditIndex].generateClothes()
	debug.messagebox(ssxRunnerQuest.s("$SSX_RuleImported", editRuleL0.name))
EndFunction

String Function fixIllegalChars(String name)
	String res=""
	int len = StringUtil.getLength(name)
	int i=0
	while i<len
		String c = StringUtil.GetNthChar(name, i)
			if c=="/" || c=="\\" || c=="?" || c=="*" || c==":" || c=="|" || c=="\"" || c=="<" || c==">"
				res+="_"
			else
				res+=c
			endIf
		i+=1
	endWhile
	if res==""
		res="Rule"
	endIf
	return res
endFunction

; -))
