Scriptname SSX_Runner_Quest extends Quest Conditional ; V1.4h

import PO3_SKSEFunctions

; ((- Properties

; ((- Properties for referencing Vanilla and SexLab items

SexLabFramework Property SexLab Auto
slaFrameworkScr slaf ; Arousal
sslSystemConfig Property SexLabConfig Auto
sslCreatureAnimationSlots CreatureSlots
Actor Property PlayerRef Auto
Spell Property ssxPlayerCellDetectorSpell Auto
Faction Property SexLabAnimatingFaction Auto
Faction Property SexLabForbiddenFaction Auto
Keyword Property ActorTypeCreature Auto
Keyword Property ActorTypeAnimal Auto
Faction Property CreatureFaction Auto
Faction Property FarmAnimalsFaction Auto
Race Property manakinRace Auto
Faction Property ssxAllFriends Auto
Faction Property ssxScanningFaction Auto
Faction Property ssxCreatures Auto
Faction Property ssxAggressionFaction  Auto  
Faction Property PredatorFaction Auto
bool Property nexusMode Auto
Location[] Property locations Auto
AssociationType[] Property associations Auto
string[] Property associationNames Auto

Keyword[] Property LocTypes auto ; 44
Race[] Property vanillaRaces Auto

CreatureFramework Property CF Auto Hidden

; -))

; ((- Properties for understanding the status

int Property areMenuOpen Auto ; Number of menu open, it increases at every menu open and decrease at every menu closed
Bool Property isMCMLoaded Auto ; True when the MCM finishes its loading
int Property isMCMOpen Auto
int Property iAmActive Auto Conditional ; True if the scan cycle is running

; -- ACTOR VALUE CACHE MANAGEMENT --

int[] actorsUpdate

Function clearCached(int index = -1, int type = -1, Actor a = none)
	if a != none
		index = allActors.find(a)
		if index == -1
			return
		endIf
	endIf
	int mask = 0
	if type != -1
		mask = 0xFFFFFF - (Math.leftShift(1, (type - 1)))
	endIf
	if index != -1
		actorsUpdate[index] = math.logicalAnd(actorsUpdate[index], mask)
		return
	endIf
	int i = actorsUpdate.length
	while i
		i-=1
		actorsUpdate[i]=0
	endWhile
	return
endFunction

Function clearCachePreCheck()
	{clear cache for: SN, SS, AR, HE, ST, MA, SK, WE, UN}
	int i = actorsUpdate.length
	int mask = 0xC81
	while i
		i-=1
		actorsUpdate[i] = Math.logicalAnd(actorsUpdate[i], mask)
	endWhile
endFunction

Function clearCachePostCheck()
	{clear cache for: NA, BO, SL, CO}
	int i = actorsUpdate.length
	int mask = 0x137E
	while i
		i-=1
		actorsUpdate[i] = Math.logicalAnd(actorsUpdate[i], mask)
	endWhile
endFunction

Function setCached(int index, int type)
	actorsUpdate[index] = Math.logicalOr(actorsUpdate[index], Math.leftShift(1, (type - 1)))
endFunction

bool Function isCached(int index, int type)
	return Math.logicalAnd(actorsUpdate[index],Math.leftShift(1, (type - 1)))
endFunction
; -----------------------------------

; ((- SCHEDULER

float[] checkerEvents

int Function getEvent()
	int i = checkerEvents.length
	float old = Utility.getCurrentRealTime() - 60.0
	while i
		i -= 1
		if checkerEvents[i] < old
			checkerEvents[i] = old + 60.0
			return i
		endIf
	endWhile
	return -1
EndFunction

Function refreshEvent(int i)
	if i > -1 && i < checkerEvents.length
		checkerEvents[i] = Utility.getCurrentRealTime() ; ensure event doesn't expire when active, also possibly recover from 'double booking' errors
	endIf
EndFunction

Function releaseEvent(int i)
	if i > -1 && i < checkerEvents.length
		checkerEvents[i] = 0.0
	endIf
EndFunction

bool Function hasEvent(int id = -1)
	if firstEvent(id) == -1
		return false
	endIf
	return true
endFunction

int Function firstEvent(int id = -1)
	int i = checkerEvents.length
	float old = Utility.getcurrentRealTime() - 60.0
	while i
		i -= 1
		if checkerEvents[i] >= old && i != id
			return i
		endIf
	endWhile
	return -1
EndFunction

String _whatIAmDoing
float schedulerScan = -1.0
float schedulerCheckerUpdate = -1.0
float schedulerCheckerEvent = -1.0
float schedulerPlayer = -1.0
float schedulerSManager = -1.0

int Function schedulerCanIDo(String who)
{Checks what is going on and returs 0=if the script should stop, 1=if it has to wait, 2=if it is OK to proceed}
	if iAmActive==0
		return 0 ; Just stop
	endIf
	if _whatIAmDoing==who
		return 2 ; Why are you asking?
	endIf
	float howMuch = 0.0
	float justNow = Utility.getCurrentRealTime()
	if who=="Scene Manager"
		if schedulerSManager<0.1
			schedulerSManager = justNow
		else
			howMuch = justNow- schedulerSManager
		endIf
	elseIf who=="Rule Checker Update"
		if hasEvent() ; if there is any active event, we'll wait
			return 1
		endIf
		if schedulerCheckerUpdate<0.1
			schedulerCheckerUpdate = justNow
		else
			howMuch = justNow- schedulerCheckerUpdate
		endIf
			
	elseIf who=="Rule Checker Event"
		if schedulerCheckerEvent<0.1
			schedulerCheckerEvent = justNow
		else
			howMuch = justNow- schedulerCheckerEvent
		endIf
	elseIf who=="Rule Player"
		if schedulerPlayer<0.1
			schedulerPlayer = justNow
		else
			howMuch = justNow- schedulerPlayer
		endIf
	elseIf who=="Scanner"
		if schedulerScan<0.1
			schedulerScan = justNow
		else
			howMuch = justNow- schedulerScan
		endIf
	endIf
	
	if _whatIAmDoing==""
		log(who + " starts", notifWhatIsGoingOnN())
		_whatIAmDoing=who
		return 2 ; Do it right away
	endIf
	
	; Then check how long we run, and give priority to the other waiters
	float current = 0.0
	if _whatIAmDoing == "Scene Manager"
		current = justNow - schedulerSManager
	elseIf _whatIAmDoing == "Rule Checker Update"
		current = justNow - schedulerCheckerUpdate
	elseIf _whatIAmDoing == "Rule Checker Event"
		current = justNow - schedulerCheckerEvent
	elseIf _whatIAmDoing == "Rule Player"
		current = justNow - schedulerPlayer
	elseIf _whatIAmDoing == "Scanner"
		current = justNow - schedulerScan
	endIf
	
	if who=="Scene Manager"
		if _whatIAmDoing=="Rule Checker Update"
			if howMuch<5.0 || current < 3.0
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Rule Checker Event"
			if howMuch<5.0 || current < 10.0
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerSManager = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Rule Player"
			if howMuch<5.0 || current < 3.0
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerSManager = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Scanner"
			if howMuch<5.0 || current < 3.0
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerSManager = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Scene Manager"
			return 2 ; Just Do it
		endIf
		
	elseIf who=="Rule Checker Event"
		if _whatIAmDoing=="Scene Manager"
			if howMuch<1.0 || current < 2.0
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerCheckerEvent = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Rule Checker Update"
;			if howMuch<1.0
;				return 1 ; Wait
;			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerCheckerEvent = justNow
				return 2 ; Do it
;			endIf
		endIf
		if _whatIAmDoing=="Rule Player"
			if howMuch<2.0
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerCheckerEvent = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Scanner"
			if howMuch<1.0
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerCheckerEvent = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Rule Checker Event"
			return 2 ; Just Do it
		endIf
	
	elseIf who=="Rule Checker Update"
		if _whatIAmDoing=="Scene Manager"
			if howMuch<3.0 || current < 5.0
				return 1 ; Wait
			endIf
		endIf
		if _whatIAmDoing=="Rule Checker Event"
			return 1 ; Wait
		endIf
		if _whatIAmDoing=="Rule Player"
			if howMuch<20.0 ; 20 secodns should be enough for rule player to do it's thing
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerCheckerUpdate = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Scanner"
			if howMuch<50.0 ; basically - if scanner is running, let it finish before checking rules on update
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerCheckerUpdate = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Rule Checker Update"
			return 2 ; Just Do it
		endIf

	elseIf who=="Rule Player"
		if _whatIAmDoing=="Scene Manager"
			if howMuch<5.0 || current < 5.0
				return 1 ; Wait
			endIf
		endIf
		if _whatIAmDoing=="Rule Checker Event"
			if howMuch<25.0  || current < 10.0; give rule checker a reasonable amount of time to do it's thing before running player
				return 1 ; Wait
			endIf
		endIf
		if _whatIAmDoing=="Rule Checker Update"
			if howMuch<25.0 || current < 2.0 ; give rule checker a reasonable amount of time to do it's thing before running player
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerPlayer = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Scanner"
			if howMuch<5.0 || current < 3.0
				return 1 ; Wait
			else
				log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
				_whatIAmDoing = who
				schedulerPlayer = justNow
				return 2 ; Do it
			endIf
		endIf
		if _whatIAmDoing=="Rule Player"
			return 2 ; Just Do it
		endIf
	
	elseIf who=="Scanner"
		if _whatIAmDoing!="Scanner"
			if howMuch < 30.0 || schedulerCheckerEvent > 0.0 || current < 5.0
				return 1 ; Wait
			endIf
			log("Bypassing " + _whatIAmDoing + ", Starting " + who, notifWhatIsGoingOnN())
			_whatIAmDoing = who
			schedulerScan = justNow
			return 2 ; Do it
		else
			return 2 ; Just Do it
		endIf
	endIf
	
	return 2
endFunction

Function schedulerIAmDone(String who)
	if who=="Scene Manager"
		schedulerSManager = -1.0
	elseIf who=="Rule Checker Update"
		schedulerCheckerUpdate = -1.0
	elseIf who=="Rule Checker Event"
		schedulerCheckerEvent = -1.0
	elseIf who=="Rule Player"
		schedulerPlayer = -1.0
	elseIf who=="Scanner"
		schedulerScan = -1.0
	endIf
	
	; Find if there is somebody waiting
	if schedulerSManager>0.0
		_whatIAmDoing="Scene Manager"
		schedulerSManager = Utility.getCurrentRealTime()
	elseIf schedulerCheckerEvent>0.0
		_whatIAmDoing="Rule Checker Event"
		schedulerCheckerEvent = Utility.getCurrentRealTime()
	elseIf schedulerPlayer>0.0
		_whatIAmDoing="Rule Player"
		schedulerPlayer = Utility.getCurrentRealTime()
	elseIf schedulerCheckerUpdate>0.0
		_whatIAmDoing="Rule Checker Update"
	schedulerCheckerUpdate = Utility.getCurrentRealTime()
	elseIf schedulerScan>0.0
		_whatIAmDoing="Scanner"
		schedulerScan = Utility.getCurrentRealTime()
	else
		_whatIAmDoing=""
	endIf
	
	if _whatIAmDoing==""
		log(who + " completed", notifWhatIsGoingOnN())
	else
		log(who + " completed, " + _whatIAmDoing + " started", notifWhatIsGoingOnN())
	endIf
endFunction


;-))

int Property iAmInitialized Auto
int Property dontStopScenes Auto ; True if when stopping the mod, then the scenes should not stop
int Property letsWait Auto ; True if a complax heavy item is requiring power, like a scene starting
int Property isInitInProgress Auto ; -1=not done, 0..100 is the progress, where 100=completed
int Property isConfigInProgress Auto ; -1=not done, 0..100 is the progress, where 100=completed
int Property areTagsInProgress Auto ; -1=not done, 0..100 is the progress, where 100=completed
int Property areItemsInProgress Auto ; -1=not done, 0..100 is the progress, where 100=completed
int Property areActorsInProgress Auto ; -1=not done, 0..100 is the progress, where 100=completed
int Property areModsInProgress Auto ; -1=not done, 0..100 is the progress, where 100=completed

int Property playerSex auto

; -))

; ((- Properties for Configuration
String Property configFolder Auto
String Property configFile Auto
int Property maxNumberOfRules Auto
float Property ruleCheckerMinWaitTime auto
float Property ruleCheckerMaxWaitTime auto
int Property checkingMode auto
float Property rescanCellTime auto
int Property ssxKeyCode Auto
int Property startRightAway Auto
int Property expertiseLevel Auto
int Property maxNumberOfParallelScenes auto
float Property maxSecondsToReachTarget auto
float Property maxSecondsToAsk auto
float Property maxSecondsToReachDenial auto
float Property maxSecondsToReachBed auto
int Property stopSceneInCaseOfTimeOuts auto
int Property genderMode auto
int Property orientationMode auto ; Types: M (Male human), F (Female Human), S (Male Creature), B (Female Creature): 4 bits for each type with the allowed other types: M[MFSB]F[MFSB]S[MFSB]B[MFSB]
int Property playerOrientation auto ; 0=HeteroH, 1=BisexualH, 2=HomoH, 3=Creatures, 4=HetroH&C, 5=BisexualH&C, 6=HomoH&C, 7=Use SexLab sexuality (H&C)
int Property useSLSexuality auto
int Property excludeActorsWithCum auto
int Property skipActorsInNamedScenes Auto
int Property scanMode Auto ; 0=CellScanner, 1=Cloak 50 feet, 2=Cloak 100 feet, 3=Cloak 200 feet
int Property priorityMode Auto ; 0=Use scaled probability, 1=use priority
int Property forceStopCombats Auto ;0=none, 1=Health, 2=Bleedout, 3=Both
int Property followersStayInBleedout Auto
int Property protectOnHealth Auto
int Property safeCheckOfConCAnims Auto
int Property factionSpells Auto ; first bit to add/remove the spells, then 4 bits (5 times) to identify the color

int Property increaseSpeechCraft Auto
int Property maxSpeechCraftLevel Auto
int Property increaseRelationship Auto
int Property maxRelationshipRank Auto

int Property nakedHead Auto
int Property nakedBody Auto
int Property nakedForearms Auto
int Property nakedHands Auto
int Property nakedCalves Auto
int Property nakedFeet Auto
int Property nakedPelvis Auto
Float Property nakedMinLevel Auto
; -))

; ((- Properties for Debug
String[] Property colors Auto
Spell[] Property highlightColors Auto

int Property notifications Auto
int Property notifHighlight Auto ; 0=0x01=Scan (color=globalScan), 1=0x02=Valid for rule (color=rule), 2=0x04=Potential for rule (color=rule), 3=0x08=Starting a scene (color=rule), 4=0x10=Askable (color=globalScan), 5=0x20 Found by Cleaner (color=globalScan)
int Property notifHighLightColorScan Auto
int Property notifHighLightColorAskable Auto
int Property notifHighLightColorCleaned Auto


int Property popUpDelRule Auto
int Property popUpNotSaved Auto
int Property popUpNameNotUpated Auto
bool Property clenUpActorsAround Auto


; 0=0x01=Scan (color=globalScan), 1=0x02=Valid for rule (color=rule), 2=0x04=Potential for rule (color=rule), 3=0x08=Starting a scene (color=rule), 4=0x10=Askable (color=globalScan), 5=0x20 Found by Cleaner (color=globalScan)
int function highlightScan() global
	return 0
endFunction
int function highlightValid() global
	return 1
endFunction
int function highlightPotential() global
	return 2
endFunction
int function highlightScene() global
	return 3
endFunction
int function highlightAsk() global
	return 4
endFunction
int function highlightClean() global
	return 5
endFunction


bool Function getHighlight(int h)
	return math.LogicalAnd(notifHighlight, Math.LeftShift(1, h))!=0
endFunction

Function toggleHighlight(int h)
	if getHighlight(h)
		notifHighlight = math.LogicalAnd(notifHighlight, 0xFF - Math.LeftShift(1, h))
	else
		notifHighlight = math.LogicalOr(notifHighlight, Math.LeftShift(1, h))
	endIf
endFunction

; -))

; ((- Properties for finding actors

; Conditional filters to quicly understand if we need somebody (cell, cloak and aliases)
int Property needH Auto Conditional ; Needed Humans
int Property needC Auto Conditional ; Needed Creatures
int Property needM Auto Conditional ; Needed Males
int Property needF Auto Conditional ; Needed Females
int Property needN Auto Conditional ; Needed not Follower
int Property needW Auto Conditional ; Needed Follower
int Property needP Auto Conditional ; Needed Player
String[] Property needRaces Auto ; List of all valid races (RaceType)
Form[] Property needRacesR Auto ; List of all valid races (Race)

; -))

; ((- Properties for Scene management
Scene[] Property scenes Auto ; array of the actual Scenes, the scene in position 0 is the one used for player asking, 1 is for NPCs asking the player, the remaining 4 items are the scene where the player is not involved
bool[] Property sceneAvails Auto ; Boolean to understand if a scene is available or not
Actor[] Property sceneDs Auto ; array of the Target actors for each scene
Actor[] Property sceneSs Auto ; array of the Source (active) actors for each scene
Actor[] Property sceneC1s Auto ; array of the Collaborators for each scene
Actor[] Property sceneC2s Auto ; array of the Collaborators for each scene
Actor[] Property sceneC3s Auto ; array of the Collaborators for each scene
ObjectReference[] Property sceneBs Auto ; array of the beds for each scene
SSX_Rule_Alias[] Property sceneRs Auto ; array of the rules associated with the scenes
sslThreadController[] Property sceneTCs Auto; array of SexLab Thread Controllers that will play the actual SexLab animation
ReferenceAlias[] Property aliasesDs Auto
ReferenceAlias[] Property aliasesSs Auto
ReferenceAlias[] Property aliasesC1s Auto
ReferenceAlias[] Property aliasesC2s Auto
ReferenceAlias[] Property aliasesC3s Auto
ReferenceAlias[] Property aliasesBs Auto
int[] Property sceneStep Auto ; Used to understand the current step of the scene ; Scene staps: 1 Move to target; 2 Question about sex; 3 Question about bed; 4 move to bed; 5 execute sex action
float[] Property sceneTimeout Auto ; Used to understand how long the scene step lasted (start time)
int[] Property sceneStrippingD Auto ; 0 undress & redress, 1 no strip & redress, 2 undress & keep naked, 3 no strip and keep naked
int[] Property sceneStrippingS Auto 
int[] Property sceneStrippingC Auto 
Bool[] Property noStripsD Auto
Bool[] Property noStripsS Auto
Bool[] Property noStripsC Auto
Actor[] Property sexPositions Auto
int Property ssxFinalSentence0 Auto Conditional ; Player asks conditional --> Paired with the scene 0
int Property ssxFinalSentence1 Auto Conditional ; Player is asked conditional --> Paired with the scene 1
int Property ssxFinalSentence2 Auto Conditional ; NPC2NPC conditional 0 --> Paired with the scene 2
int Property ssxFinalSentence3 Auto Conditional ; NPC2NPC conditional 1 --> Paired with the scene 3
int Property ssxFinalSentence4 Auto Conditional ; NPC2NPC conditional 2 --> Paired with the scene 4
int Property ssxFinalSentence5 Auto Conditional ; NPC2NPC conditional 3 --> Paired with the scene 5
int Property ssxRequestToPlayer1 Auto Conditional ; Ask the Player dialogue  --> Paired with the scene 1
int Property ssxNPCRequest2 Auto Conditional ; NPC2NPC conditional 0 --> Paired with the scene 2 --> This is used to select the request dialogue
int Property ssxNPCRequest3 Auto Conditional ; NPC2NPC conditional 1 --> Paired with the scene 3
int Property ssxNPCRequest4 Auto Conditional ; NPC2NPC conditional 2 --> Paired with the scene 4
int Property ssxNPCRequest5 Auto Conditional ; NPC2NPC conditional 3 --> Paired with the scene 5



int Property ssxNPCAnswer0 Auto Conditional ; NPC2NPC conditional 0 --> Paired with the scene 0 --> This is used to select the line of the answer
; No need for 1, is the player that is answering
int Property ssxNPCAnswer2 Auto Conditional ; NPC2NPC conditional 2 --> Paired with the scene 2 --> This is used to select the line of the answer
int Property ssxNPCAnswer3 Auto Conditional ; NPC2NPC conditional 3 --> Paired with the scene 3
int Property ssxNPCAnswer4 Auto Conditional ; NPC2NPC conditional 4 --> Paired with the scene 4
int Property ssxNPCAnswer5 Auto Conditional ; NPC2NPC conditional 5 --> Paired with the scene 5
int Property ssxNextAnswerWillBe0 Auto Conditional ; Pl2NPC conditional 0 --> Paired with the scene 0 --> Used when the player asks
int Property ssxNextAnswerWillBe1 Auto Conditional ; NPC2Pl conditional 1 -->  Used when the player is asked
int Property ssxNextAnswerWillBe2 Auto Conditional ; NPC2NPC conditional 2 --> Paired with the scene 2 --> This is used to decide the result of the asking (0=stop, 1=consensual, 2=rape, 3=mast, 4=brawl) ; FIXME
int Property ssxNextAnswerWillBe3 Auto Conditional ; NPC2NPC conditional 3 --> Paired with the scene 3
int Property ssxNextAnswerWillBe4 Auto Conditional ; NPC2NPC conditional 4 --> Paired with the scene 4
int Property ssxNextAnswerWillBe5 Auto Conditional ; NPC2NPC conditional 5 --> Paired with the scene 5

Message Property ssxAskToUseBedPlayer Auto
Message Property ssxAskToUseBedNPCs Auto
Message Property ssxAskToUseBedAll Auto
Message Property ssxMissingBed Auto
Message Property ssxAskForCreatureSexMessage Auto


int Function getAScene(int playerAsking, bool isPlayerAsked)
	if playerAsking
		if sceneAvails[0]
			sceneAvails[0]=false
			sceneTimeout[0] = Utility.GetCurrentRealTime()
			areScenesPlaying=true
			return 0
		else
			return -1
		endIf
	endIf
	if isPlayerAsked
		if sceneAvails[1]
			sceneAvails[1]=false
			sceneTimeout[1] = Utility.GetCurrentRealTime()
			areScenesPlaying=true
			return 1
		else
			return -1
		endIf
	endIf
	int i = 2
	while i<scenes.length
		if sceneAvails[i]
			sceneAvails[i] = false
			sceneTimeout[i] = Utility.GetCurrentRealTime()
			areScenesPlaying=true
			return i
		endIf
		i += 1
	endWhile
	return -1
EndFunction

bool Function verifyNoDialogue(Actor a)
	if !a
		return true
	endIf
	if a == PlayerRef && UI.IsMenuOpen("Dialogue Menu")
		return false
	endIf
	Actor d = a.getDialogueTarget()
	; close to player an actor has player as dialogue target when repeating 'standard greeting', don't stop for that
	if d && (d != PlayerRef || UI.IsMenuOpen("Dialogue Menu"))
		return false
	endIf
	return true
endFunction

bool Function notInDialogues(int index)
	{Check that all the actors in the scene are NOT in dialogue}
	return verifyNoDialogue(sceneDs[index]) && verifyNoDialogue(sceneSs[index]) && verifyNoDialogue(sceneC1s[index]) && verifyNoDialogue(sceneC2s[index]) && verifyNoDialogue(sceneC3s[index])
endFunction

Function startStep(Scene sc, int step)
	int pos = -1
	if sc
		pos = scenes.find(sc)
	endIf
	if pos!=-1
		sceneStep[pos] = step
		sceneTimeout[pos] = Utility.GetCurrentRealTime()
	endIf
EndFunction
 
int Function searchScene(Scene s=none, int index=-1, Actor a=None)
	if s
		return scenes.find(s)
	elseIf index!=-1 && index<5
		return index
	elseIf a!=none
		int pos = sceneDs.find(a)
		if pos==-1
			pos = sceneSs.find(a)
		endIf
		if pos==-1
			pos = sceneC1s.find(a)
		endIf
		if pos==-1
			pos = sceneC2s.find(a)
		endIf
		if pos==-1
			pos = sceneC3s.find(a)
		endIf
		return pos
	endIf
	return -1
EndFunction

sslThreadController Function setSceneThreadController(Actor a, sslThreadModel t)
	int pos = searchScene(None, -1, a)
	if pos==-1
		log("Cannot find the scene for the actor " + a, notifErrors())
		return None
	endIf
	; Set the actors scaling, wait a couple of seconds, and then reset the value
	SSX_Rule_Alias r = sceneRs[pos]
	if r.scaleActors==1 ; Always scale
		setSexLabActorScaling(true)
	elseIf r.scaleActors==2 ; Never scale
		setSexLabActorScaling(false)
	endIf
	letsWait = 1
	sslThreadController tc = t.StartThread()
	if getDebug(notifAnimPlayedN())
		String msg = "Anim: " + tc.Animation.name + "("
		if sceneDs[pos]
			msg+=sceneDs[pos].getDisplayName()
		endIf
		if sceneSs[pos]
			msg+=", " + sceneSs[pos].getDisplayName()
		endIf
		if sceneC1s[pos]
			msg+=", ..."
		endIf
		msg+=")"
		log(msg, notifAnimPlayedN())
	endIf
	sceneTCs[pos] = tc
	if tc && r.scaleActors!=0
		Utility.waitMenuMode(1.0) ; Only one second. Actor Scaling is no more used.
		restoreSexLabActorScaling()
	endIf
	stopAllCombats()
	Utility.waitMenuMode(0.5)
	
	letsWait = 0
	return tc
EndFunction

Function setAliases(int pos, SSX_Rule_Alias r, Actor t, Actor s, Actor c1, Actor c2, Actor c3, ObjectReference bed, int smt, int sms, int smc)
	sceneDs[pos] = t
	sceneSs[pos] = s
	sceneC1s[pos] = c1
	sceneC2s[pos] = c2
	sceneC3s[pos] = c3
	sceneBs[pos] = bed
	sceneRs[pos] = r
	sceneStrippingD[pos] = smt
	sceneStrippingS[pos] = sms
	sceneStrippingC[pos] = smc

	; In case asking is not required, but the player is involved, set the player as target
	if !r.getAskBeforeSex() && (s==PlayerRef || c1==PlayerRef || c2==PlayerRef || c3==PlayerRef)
		; Swap
		if s==PlayerRef
			s=t
		elseIf c1==PlayerRef
			c1=t
		elseIf c2==PlayerRef
			c2=t
		elseIf c3==PlayerRef
			c3=t
		endIf
		t=PlayerRef	
	endIf
	
	aliasesDs[pos].clear()
	aliasesSs[pos].clear()
	aliasesC1s[pos].clear()
	aliasesC2s[pos].clear()
	aliasesC3s[pos].clear()
	aliasesBs[pos].clear()
	
	int color
	if t
		if Math.LogicalAnd(notifHighlight, 0x20)
			color = r.getHighlightColor(0, true)
			if color
				highlightColors[color - 1].cast(t, t)
			endIf
		endIf
		aliasesDs[pos].forceRefTo(t)
		stopCombatForActor(t)
	endIf
	if s
		if Math.LogicalAnd(notifHighlight, 0x20)
			color = r.getHighlightColor(1, true)
			if color
				highlightColors[color - 1].cast(s, s)
			endIf
		endIf
		aliasesSs[pos].forceRefTo(s)
		stopCombatForActor(s)
	endIf
	if c1
		if Math.LogicalAnd(notifHighlight, 0x20)
			color = r.getHighlightColor(2, true)
			if color
				highlightColors[color - 1].cast(c1, c1)
			endIf
		endIf
		aliasesC1s[pos].forceRefTo(c1)
		stopCombatForActor(c1)
	endIf
	if c2
		if Math.LogicalAnd(notifHighlight, 0x20)
			color = r.getHighlightColor(2, true)
			if color
				highlightColors[color - 1].cast(c2, c2)
			endIf
		endIf
		aliasesC2s[pos].forceRefTo(c2)
		stopCombatForActor(c2)
	endIf
	if c3
		if Math.LogicalAnd(notifHighlight, 0x20)
			color = r.getHighlightColor(2, true)
			if color
				highlightColors[color - 1].cast(c3, c3)
			endIf
		endIf
		aliasesC3s[pos].forceRefTo(c3)
		stopCombatForActor(c3)
	endIf
	if bed
		aliasesBs[pos].forceRefTo(bed)
	endIf
EndFunction

Function releaseScene(Scene s=none, int index=-1, Actor a=None)
	int pos = searchScene(s, index, a)
	if pos==-1
		return
	endIf
	letsWait=1
	if !dontStopScenes
		scenes[pos].stop()
		if sceneTCs[pos]
			sceneTCs[pos].EndAnimation(true) ; Quickly
			sceneTCs[pos] = None
		endIf
	endIf
; do not restore aggression here - resetCombat takes care of it
;debug.trace(">>>>> releaseScene - restore aggression")
;	restoreAggression(sceneDs[pos])
;	restoreAggression(sceneSs[pos])
;	restoreAggression(sceneC1s[pos])
;	restoreAggression(sceneC2s[pos])
;	restoreAggression(sceneC3s[pos])
	SSX_Rule_Alias r = sceneRs[pos]
	sceneRs[pos] = None
	if sceneRs.find(r)==-1
		r.status = 2
	endIf
	sceneRs[pos] = None
	sceneAvails[pos]=true
	removeInvolved(sceneDs[pos], sceneSs[pos], sceneC1s[pos], sceneC2s[pos], sceneC3s[pos])
	cleanSpectators(pos)
;	landDragons(sceneDs[pos], sceneSs[pos], sceneC1s[pos], sceneC2s[pos], sceneC3s[pos])
	sceneDs[pos] = None
	sceneSs[pos] = None
	sceneC1s[pos] = None
	sceneC2s[pos] = None
	sceneC3s[pos] = None
	releaseBed(sceneBs[pos])
	sceneBs[pos] = None
	; The rule ended, check if we have a rule that starts after this one
	if iAmActive
		int i = rules.length
		while i
			i-=1
			SSX_Rule_Alias nr = rules[i]
			if nr && nr.startsOn==2 && nr.status>0
				; Check if the rule has as predecessor the rule just ended
				if nr.prevRule==r.id
					; Start it!
					int handle = ModEvent.Create("ssxPlayRules")
					ModEvent.PushInt(handle, r.id)
					ModEvent.Send(handle)
					i=0
				endIf
			endIf
		endWhile
		; In case we can run another scene and the checking is "as soon as possible", wake up the Checker
		if checkingMode==1
			int handle = ModEvent.Create("ssxDoIt")
			ModEvent.PushString(handle, "RuleChecker")
			ModEvent.Send(handle)
		endIf
	endIf
	letsWait=0
	; Stop the pacification if the scenes are completed
	if countScenesPlaying()==0
		resetCombat()
	endIf
EndFunction

; landDragons not used at the moment, it didn't end the flying state
Function landDragons(Actor a1, Actor a2, Actor a3, Actor a4, Actor a5)
	if a1 && a1.getFlyingState() != 0
		a1.SetAllowFlying(false)
		a1.SetAllowFlying(true)
	endIf
	if a2 && a2.getFlyingState() != 0
		a2.SetAllowFlying(false)
		a2.SetAllowFlying(true)
	endIf
	if a3 && a3.getFlyingState() != 0
		a3.SetAllowFlying(false)
		a3.SetAllowFlying(true)
	endIf
	if a4 && a4.getFlyingState() != 0
		a4.SetAllowFlying(false)
		a4.SetAllowFlying(true)
	endIf
	if a5 && a5.getFlyingState() != 0
		a5.SetAllowFlying(false)
		a5.SetAllowFlying(true)
	endIf
endFunction

String Function getSceneDescription(int s)
	if s>scenes.length
		return "The scene is not available."
	endIf
	String res = sceneRs[s].name
	if sceneDs[s]
		res += " with " + sceneDs[s].getDisplayName()
	endIf
	if sceneSs[s]
		res += ", " + sceneSs[s].getDisplayName()
	endIf
	if sceneC1s[s]
		res += ", " + sceneC1s[s].getDisplayName()
	endIf
	if sceneC2s[s]
		res += ", " + sceneC2s[s].getDisplayName()
	endIf
	if sceneC3s[s]
		res += ", " + sceneC3s[s].getDisplayName()
	endIf
	if sceneTCs[s]
		res += "\nPlaying " + sceneTCs[s].Animation.Name
	endIf
	return res
EndFunction

bool Function isSceneRunning(int s)
	if s<scenes.length
		return !sceneAvails[s]
	endIf
	return false
EndFunction

bool Property areScenesPlaying Auto

int function countScenesPlaying()
	int res = 0
	int i = scenes.length
	while i
		i -= 1
		if !sceneAvails[i]
			res += 1
		endIf
	endWhile
	areScenesPlaying = (res>0)
	return res
EndFunction

bool Function dontUndress(Actor a)
	if !a
		return false
	endIf
	int pos = sceneDs.find(a)
	if pos!=-1
		return sceneStrippingD[pos]==1 || sceneStrippingD[pos]==3
	endIf
	pos = sceneSs.find(a)
	if pos!=-1
		return sceneStrippingS[pos]==1 || sceneStrippingS[pos]==3
	endIf
	pos = sceneC1s.find(a)
	if pos!=-1
		return sceneStrippingC[pos]==1 || sceneStrippingC[pos]==3
	endIf
	pos = sceneC2s.find(a)
	if pos!=-1
		return sceneStrippingC[pos]==1 || sceneStrippingC[pos]==3
	endIf
	pos = sceneC3s.find(a)
	if pos!=-1
		return sceneStrippingC[pos]==1 || sceneStrippingC[pos]==3
	endIf
	return false
EndFunction

bool Function dontRedress(Actor a)
	int pos = sceneDs.find(a)
	if pos!=-1
		return sceneStrippingD[pos]>1
	endIf
	pos = sceneSs.find(a)
	if pos!=-1
		return sceneStrippingS[pos]>1
	endIf
	pos = sceneC1s.find(a)
	if pos!=-1
		return sceneStrippingC[pos]>1
	endIf
	pos = sceneC2s.find(a)
	if pos!=-1
		return sceneStrippingC[pos]>1
	endIf
	pos = sceneC3s.find(a)
	if pos!=-1
		return sceneStrippingC[pos]>1
	endIf
	return false
EndFunction

Function moveSceneActorsToTarget(int index, bool toTheBed, int nextStep)
	if toTheBed && sceneBs[index]
		moveActor(sceneDs[index], None, sceneBs[index])
		moveActor(sceneSs[index], None, sceneBs[index])
		moveActor(sceneC1s[index], None, sceneBs[index])
		moveActor(sceneC2s[index], None, sceneBs[index])
		moveActor(sceneC3s[index], None, sceneBs[index])
	else
		Actor t = sceneDs[index]
		moveActor(sceneSs[index], t, None)
		moveActor(sceneC1s[index], t, None)
		moveActor(sceneC2s[index], t, None)
		moveActor(sceneC3s[index], t, None)
	endIf
EndFunction

bool Function needLockPlayerAI(Scene sc)
	int pos = scenes.find(sc)
	if pos==-1
		return false
	endIf
	; Need to lock only if there is a bed AND there are no creatures AND the player is involved
	if sceneDs[pos]==PlayerRef || sceneSs[pos]==PlayerRef || sceneC1s[pos]==PlayerRef || sceneC2s[pos]==PlayerRef || sceneC3s[pos]==PlayerRef
		bool sexTypeCond = false
		if pos==0
			sexTypeCond = ssxNextAnswerWillBe0==1
		elseIf pos==1
			sexTypeCond = ssxNextAnswerWillBe1==1
		elseIf pos==2
			sexTypeCond = ssxNextAnswerWillBe2==1
		elseIf pos==3
			sexTypeCond = ssxNextAnswerWillBe3==1
		elseIf pos==4
			sexTypeCond = ssxNextAnswerWillBe4==1
		elseIf pos==5
			sexTypeCond = ssxNextAnswerWillBe5==1
		endIf
		bool crCond = (sceneDs[pos] && sceneDs[pos].IsInFaction(ssxCreatures)) || (sceneSs[pos] && sceneSs[pos].IsInFaction(ssxCreatures)) || (sceneC1s[pos] && sceneC1s[pos].IsInFaction(ssxCreatures)) || (sceneC2s[pos] && sceneC2s[pos].IsInFaction(ssxCreatures)) || (sceneC3s[pos] && sceneC3s[pos].IsInFaction(ssxCreatures))
		if (sceneBs[pos] != None) && !crCond && sexTypeCond
			useBed(sceneBs[pos])
			return true
		endIf
	endIf
	return false
EndFunction

Actor[] Function setSexPositions(Actor a1=none, Actor a2=none, Actor a3=none, Actor a4=none, Actor a5=none)
	Actor[] res = new Actor[5]
	res[0] = a1
	res[1] = a2
	res[2] = a3
	res[3] = a4
	res[4] = a5
	return res
EndFunction

bool Function isPlayerInScene(int i)
	return sceneDs[i]==PlayerRef || sceneSs[i]==PlayerRef || sceneC1s[i]==PlayerRef || sceneC2s[i]==PlayerRef || sceneC3s[i]==PlayerRef
EndFunction

bool Function AskForCreatureSex(Actor a)
	bool res = ssxAskForCreatureSexMessage.Show() as Bool
	if res
		ssxNextAnswerWillBe1 = 1
	endIf
	return res
EndFunction

Faction[] Property ssxPlayerAskFactions Auto ; Each faction is associated with a dialogue (used to have the possibility to ask NPCs)

Faction Function setUpPlayerDialogues(SSX_Rule_Alias r)
	{Find the good dialogue line}
	int pos=r.getDialogue(0)
	Faction askFaction = ssxPlayerAskFactions[pos]
	
	; Set the NPCs that can be answered in the correct Faction
	int i=r.validDst.length
	while i
		i-=1
		Actor a = r.validDst[i]
		if a && !a.isInFaction(askFaction)
			a.addToFaction(askFaction)
		endIf
	endWhile
	; Calculate the answer type (including SpeechCraft if defined)
	if r.getUseSpeechCraft() ; With speechcraft
		ssxNextAnswerWillBe0=r.calculateConsequence(0, PlayerRef.getActorValue("Speechcraft") as Int)
		ssxNPCAnswer0=r.calculateAnswer(ssxNextAnswerWillBe0)
	else ; Normal probabilities
		ssxNextAnswerWillBe0=r.calculateConsequence(0)
		ssxNPCAnswer0=r.calculateAnswer(ssxNextAnswerWillBe0)
	endIf
	return askFaction
EndFunction


; ((- Beds functions

ObjectReference[] Property allBeds Auto
ObjectReference[] Property usedBeds Auto
Float[] Property bedDistances Auto
int Property numBeds Auto

Function askForBeds(Scene s, Actor a)
	int pos = searchScene(s, index=-1, a=a)
	if pos==-1
		return
	endIf

	SSX_Rule_Alias r = sceneRs[pos]

	; The player was asked and it was a denial or a masturbation, just don't ask and don't use beds
	if ssxNextAnswerWillBe1==1 || ssxNextAnswerWillBe1==2 ; Remove the bed
		sceneBs[pos]=None
		aliasesBs[pos].clear()
		return
	endIf
	
	if !r.isBedRequired() ; Remove the bed
		sceneBs[pos]=None
		aliasesBs[pos].clear()
		return
	else ; Do we need to ask?
		if r.needToAskForBeds(sceneBs[pos]!=None)
			if r.isPlayerInvolved() ; Ask if player involved
				if ssxAskToUseBedPlayer.show()==0
					sceneBs[pos]=None
					aliasesBs[pos].clear()
					return
				endIf
			else
				if ssxAskToUseBedNPCs.show()==0
					sceneBs[pos]=None
					aliasesBs[pos].clear()
					return
				endIf
			endIf
		endIf
	endIf
	if r.beds==SSX_Rule_Alias.bedMandatory() && !sceneBs[pos] ; Mandatory use (missing)
		ssxMissingBed.show()
		return
	endIf
	useBed(aliasesBs[pos].getReference() as ObjectReference)
EndFunction

; Check and maybe ask if to use a bed, and set it to the SexLab thread if required
bool Function useBedIfRequired(SSX_Rule_Alias r, ObjectReference bed, sslThreadModel t)
	if r.beds==SSX_Rule_Alias.bedMandatory() && !bed
		return false
	endIf
	if r.isBedRequired()
		if bed
			t.SetBedFlag(1)
			t.CenterOnObject(bed)
			useBed(bed)
		else
			t.DisableBedUse(true)
		endIf
	else
		t.DisableBedUse(true)
	endIf
	return true
EndFunction

Function clearBeds(Scene s, Actor a)
	int pos = searchScene(s, index=-1, a=a)
	if pos==-1
		return
	endIf
	aliasesBs[pos].clear()
EndFunction

int Function getBeds(ObjectReference[] dst)
	int i = numBeds
	while i
		i-=1
		dst[i] = allBeds[i]
	endWhile
	i = numBeds
	while i<dst.length
		dst[i] = None
		i+=1
	endWhile
	return numBeds
EndFunction

Function setBeds(ObjectReference[] src, int num)
	numBeds = num
	int i = numBeds
	while i
		i-=1
		allBeds[i] = src[i]
	endWhile
	i = numBeds
	while i<src.length
		allBeds[i] = None
		i+=1
	endWhile
EndFunction

ObjectReference Function getClosestAvailableBed(ObjectReference center)
	if numBeds == 0
		return none
	endIf
	if !center
		center = PlayerRef
	endIf
	sslThreadLibrary ThreadLib = SexLab.ThreadLib

	; Find which one of the found beds is the actual closes, with a push for the ones at the same level
	i = numBeds
	while i
		i -= 1
		Float dX = center.X-(allBeds[i] as ObjectReference).X
		Float dY = center.Y-(allBeds[i] as ObjectReference).Y
		Float dZ = center.Z-(allBeds[i] as ObjectReference).Z
		bedDistances[i] = Math.sqrt(dX*dX + dY*dY + dZ*dZ*dZ*dZ)
	endWhile
	; Now grab the one with minimum distance
	int pos = -1
	float minDist = -1.0
	int i = numBeds
	while i
		i -= 1
		if (minDist==-1.0 || bedDistances[i] < minDist) && !usedBeds[i]
			pos = i
			minDist = bedDistances[i]
		endIf
	endWhile
	if pos == -1
		return none
	endIf
	return allBeds[pos] as ObjectReference
endFunction

bool Function areBedsAvailable()
	int i = numBeds
	while i
		i-=1
		if allBeds[i] && !usedBeds[i]
			return true
		endIf
	endWhile
	return false
EndFunction

Function useBed(ObjectReference bed)
	int pos = usedBeds.find(bed)
	if pos!=-1
		return
	endIf
	pos = allBeds.find(bed)
	if pos==-1
		return
	endIf
	usedBeds[pos]=bed
EndFunction

Function releaseBed(ObjectReference bed)
	if !bed
		return
	endIf
	int pos = usedBeds.find(bed)
	if pos == -1
		return
	endIf
	usedBeds[pos]=None
EndFunction

int Function scanBeds(ObjectReference[] theBeds)
	sslThreadLibrary ThreadLib = SexLab.ThreadLib

	; Search for a nearby bed first before looking for random
	int i = theBeds.length
	while i
		i-=1
		theBeds[i]=None
	endWhile
	int numFound = 0
	int times = 32
	while times && numFound<theBeds.length
		ObjectReference nearBed = Game.FindRandomReferenceOfAnyTypeInListFromRef(ThreadLib.BedsList, PlayerRef, 1500.0 + (32-times) * 20)
		if nearBed && theBeds.find(nearBed)==-1 && !nearBed.IsDisabled() && nearBed.Is3DLoaded() && SexLab.IsBedAvailable(nearBed)
			theBeds[numFound] = nearBed
			numFound += 1
		endIf
		times -= 1
	endWhile
	i = numFound
	while i<theBeds.length
		theBeds[i] = None
		i+=1
	endWhile
	return numFound
EndFunction

; -))


; -))


int[] Property doNotInvolve auto
{Used to globally filter the actions:
0=Naked, 1=Sexing, 2=Sleeping, 3=Arousal, 4=Health, 5=Stamina, 6=Magicka, 7=Sneaking, 8=Weapon, 9=Combat, 10=Bleeding, 11=Unconscious
Values: 0=ignore, 1=never, 2=only if, 3=use the rule}


String[] Property nudeArmorsIDs Auto
{IDs of the objects that are in the config list to be considered as nude. Defined as usual ObjectID}
Form[] Property armorKeywords Auto
{Actual keywords for the armors to be considered as nude}
int[] Property armorKeywordConsideredNaked Auto
String[] Property armorKeywordIDs Auto

int Property currentArmorsNum Auto
String[] Property currentArmorsIDs Auto
String[] Property currentArmorsNames Auto
int Property mcmActorsNum Auto
Actor[] Property mcmActors Auto
String[] Property mcmActorNames Auto
Form[] Property mcmFactions Auto 
{This has to be a Form[] to work with Papyrus Extender & PapyrusUtil}
String[] Property mcmFactionNames Auto

String[] Property filterAnimIDs Auto
int[] Property filterAnimsEnabled Auto
int Property filterAnimsNum Auto




Cell Property currentPlayerCell Auto
Cell Property lastPlayerCell Auto
Location Property playerLocation Auto
String Property locationID Auto
int Property cellIntExt Auto
string[] Property importRulesMode Auto

; -))


; ((- Variables and String arrays
string[] translationCache
string[] translationValue
String currentGameTranslation = "English";
; can't use configFolder because initialization value needs to be constant
String translationsPath = "..\\..\\..\\configs\\Scent of Sex NG\\translations\\english.json"
bool stringArraysInitialized = false
bool alreadyInitializingStrings = false
string[] emptyRaceKeys

string[] Property relRanks Auto
String[] Property humanOrCreature Auto
String[] Property followerOrNot Auto
String[] Property preferredGenders Auto
String[] Property sexActorValue Auto
String[] Property actTypes Auto
String[] Property prob Auto
string[] Property percs Auto
string[] Property beds Auto
string[] Property yesNo Auto
string[] Property playerGenderTags Auto
string[] Property popUpName Auto
string[] Property numOfColls Auto
string[] Property startsOns Auto
string[] Property startModes Auto
string[] Property nakedIf Auto
string[] Property filterRules Auto
string[] Property genderModes Auto
string[] Property playerOrientations Auto
string[] Property orientationModes Auto
string[] Property orientationModesC Auto
string[] Property scaleActorsVals Auto
string[] Property doNotInvolveMenu Auto
string[] Property doNotInvolveMenuVal Auto
string[] Property addGenderTagsMenu Auto
string[] Property animNames Auto
string[] Property actionFilterNA Auto
string[] Property actionFilterSE Auto
string[] Property actionFilterSL Auto
string[] Property actionFilterAR Auto
string[] Property actionFilterHE Auto
string[] Property actionFilterST Auto
string[] Property actionFilterMA Auto
string[] Property actionFilterSN Auto
string[] Property actionFilterWE Auto
string[] Property actionFilterCO Auto
string[] Property actionFilterBL Auto
string[] Property actionFilterUN Auto
string[] Property expertiseLevels Auto
String[] Property scanModes Auto
string[] Property stopAllCombats Auto
string[] Property bodyParts Auto
string[] Property whoIsVictim Auto
string[] Property participantEdit Auto
string[] Property hasToNotTos Auto
string[] Property intExtMnu Auto
string[] Property inclExclMnu Auto
string[] Property locationList Auto
string[] Property locationTypeList Auto
string[] Property stripModes Auto
string[] Property startsOnActorModes Auto
string[] Property startsOnActorModesVal Auto
string[] Property positionsFilterWarning Auto
string[] Property timeOfTheDay Auto
string[] Property mods Auto
string[] Property modsSet1 Auto
string[] Property modsSet2 Auto
string[] Property modsSet3 Auto
string[] Property modsSet4 Auto
string[] Property editTypes Auto ; 0=Properties, 1=Fellowship, 2=Factions
string[] Property priorityModes Auto
string[] Property forceStopCombatsMN Auto

string[] Property requestDialogues Auto
string[] Property positiveAnswers Auto
string[] Property negativeAnswers Auto
string[] Property npcFinalSentences Auto
string[] Property answerProbs Auto
String[] Property participantQuickSettingsLL Auto
String[] Property participantQuickSettingsNX Auto
String[] Property whoWillBePassive Auto
String[] Property raceInclusiveExclusive Auto
String[] Property racesToFilter Auto
String[] Property inCaseOfAggressiveness Auto
String[] Property spectatorsMasturbates Auto
String[] Property catchModes Auto
String[] Property checkingModes Auto

String[] Property emptyRaces Auto

bool defaultSexLabActorsScaling

; TODO: There must be a better way to do this (JSONUtil probably)
Function initStringArrays()
	if alreadyInitializingStrings || stringArraysInitialized
		Utility.waitMenuMode(0.2)
		return
	endIf
	alreadyInitializingStrings = true

	emptyRaces = new String[1]
	emptyRaces[0] = ""
	
	relRanks = new String[9]
	relRanks[0] = s("$SSX_RelRanksArchnemesis")
	relRanks[1] = s("$SSX_RelRanksEnemy")
	relRanks[2] = s("$SSX_RelRanksFoe")
	relRanks[3] = s("$SSX_RelRanksRival")
	relRanks[4] = s("$SSX_RelRanksAcquaintance")
	relRanks[5] = s("$SSX_RelRanksFriend")
	relRanks[6] = s("$SSX_RelRanksConfidant")
	relRanks[7] = s("$SSX_RelRanksAlly")
	relRanks[8] = s("$SSX_RelRanksLover")
	
	nakedIf = new String[3]
	nakedIf[0] = s("$SSX_NakedIfNotNaked")
	nakedIf[1] = s("$SSX_NakedIfIsNaked")
	nakedIf[2] = s("$SSX_NakedIfUseArmorRating")
	
	filterRules = new String[10]
	filterRules[0] = s("$SSX_All")
	filterRules[1] = s("$SSX_FilterRulesAreDisabled")
	filterRules[2] = s("$SSX_FilterRulesAreEnabled")
	filterRules[3] = s("$SSX_FilterRulesStartRandomlyByNPCs")
	filterRules[4] = s("$SSX_FilterRulesPlayerAsksForSex")
	filterRules[5] = s("$SSX_FilterRulesStartOnNaked")
	filterRules[6] = s("$SSX_FilterRulesStartOnArousal")
	filterRules[7] = s("$SSX_FilterRulesStartOnCombat")
	filterRules[8] = s("$SSX_FilterRulesStartOnBleedsout")
	filterRules[9] = s("$SSX_FilterRulesStartOnSleeping")

	startModes = new String[3]
	startModes[0] = s("$SSX_StartsOnsRandomly")
	startModes[1] = s("$SSX_StartsOnsPlayerAsksForSex")
	startModes[2] = s("$SSX_StartsOnsSequence")
	
; Start mode types: 0=Rnd, 1=Player Ask; (2=be naked; 3=see nudity; 4=see sex; 5=arousal; 6=sleeping; 7=health;) (8=stamina; 9=Magicka; 10=sneaking; 11=weapon; 12=combat; 13=bleedout;) (14=unconscious; ...)
	startsOns = new String[17]
	startsOns[0] = s("$SSX_StartsOnsRandomly")
	startsOns[1] = s("$SSX_StartsOnsPlayerAsksForSex")
	startsOns[2] = s("$SSX_StartsOnsSequence")
	startsOns[3] = s("$SSX_StartsOnsNaked")
	startsOns[4] = s("$SSX_StartsOnsSeeNaked")
	startsOns[5] = s("$SSX_StartsOnsSeeSex")
	startsOns[6] = s("$SSX_StartsOnsArousal")
	startsOns[7] = s("$SSX_StartsOnsHealth")
	startsOns[8] = s("$SSX_StartsOnsMagicka")
	startsOns[9] = s("$SSX_StartsOnsStamina")
	startsOns[10] = s("$SSX_StartsOnsSleeping")
	startsOns[11] = s("$SSX_StartsOnsSneaking")
	startsOns[12] = s("$SSX_StartsOnsWeapon")
	startsOns[13] = s("$SSX_StartsOnsCombat")
	startsOns[14] = s("$SSX_StartsOnsBleedout")
	startsOns[15] = s("$SSX_StartsOnsUnconscious")
	startsOns[16] = s("$SSX_StartsOnsClothes")
	
	yesNo = new String[2]
	yesNo[0] = s("$SSX_YesNoNo")
	yesNo[1] = s("$SSX_YesNoYes")

	humanOrCreature = new String[2]
	humanOrCreature[0] = s("$SSX_Human")
	humanOrCreature[1] = s("$SSX_Creature")
	followerOrNot = new String[3]
	followerOrNot[0] = s("$SSX_Follower")
	followerOrNot[1] = s("$SSX_NonFollower")
	followerOrNot[2] = s("$SSX_Both")
	sexActorValue = new String[3]
	sexActorValue[0] = s("$SSX_Male")
	sexActorValue[1] = s("$SSX_Female")
	sexActorValue[2] = s("$SSX_Both")
	
	preferredGenders = new String[6]
	preferredGenders[0] = s("$SSX_Male")
	preferredGenders[1] = s("$SSX_Female")
	preferredGenders[2] = s("$SSX_Both")
	preferredGenders[3] = s("$SSX_MaleC")
	preferredGenders[4] = s("$SSX_FemaleC")
	preferredGenders[5] = s("$SSX_BothC")
	
	actTypes = new String[9]
	actTypes[0] = s("$SSX_TypeNobody")
	actTypes[1] = s("$SSX_TypePlayer")
	actTypes[2] = s("$SSX_TypeGeneric")
	actTypes[3] = s("$SSX_TypeGenericWPl")
	actTypes[4] = s("$SSX_TypeSpecific")
	actTypes[5] = s("$SSX_TypeRelationship1")
	actTypes[6] = s("$SSX_TypeRelationship2")
	actTypes[7] = s("$SSX_TypeFaction")
	actTypes[8] = s("$SSX_TypeSameRace")
	
	prob = new String[5]
	prob[0] = s("$SSX_ProbVeryHigh")
	prob[1] = s("$SSX_ProbHigh")
	prob[2] = s("$SSX_ProbMedium")
	prob[3] = s("$SSX_ProbLow")
	prob[4] = s("$SSX_ProbVeryLow")

	percs = new String[5]
	percs[0] = s("$SSX_PercsNever")
	percs[1] = s("$SSX_Percs25")
	percs[2] = s("$SSX_Percs50")
	percs[3] = s("$SSX_Percs75")
	percs[4] = s("$SSX_PercsAlways")

	beds = new String[10]
	beds[0] = s("$SSX_BedsPnNn")
	beds[1] = s("$SSX_BedsPuNn")
	beds[2] = s("$SSX_BedsPaNn")
	beds[3] = s("$SSX_BedsPnNu")
	beds[4] = s("$SSX_BedsPuNu")
	beds[5] = s("$SSX_BedsPaNu")
	beds[6] = s("$SSX_BedsPnNa")
	beds[7] = s("$SSX_BedsPuNa")
	beds[8] = s("$SSX_BedsPaNa")
	beds[9] = s("$SSX_BedsMUse")
	
	popUpName = new String[3]
	popUpName[0] = s("$SSX_PopUpNameDontShow")
	popUpName[1] = s("$SSX_PopUpNameShowIt")
	popUpName[2] = s("$SSX_PopUpNameAlwaysAccept")

	numOfColls = new String[4]
	numOfColls[0] = "Nobody"
	numOfColls[1] = "1"
	numOfColls[2] = "2"
	numOfColls[3] = "3"
	
	genderModes = new String[2]
	genderModes[0] = s("$SSX_GenderModeCK")
	genderModes[1] = s("$SSX_GenderModeSL")
	
	orientationModes = new String[4]
	orientationModes[0] = s("$SSX_orientationModes0") ; ____
	orientationModes[1] = s("$SSX_orientationModes1") ; M___
	orientationModes[2] = s("$SSX_orientationModes2") ; _F__
	orientationModes[3] = s("$SSX_orientationModes3") ; MF__
	
	orientationModesC = new String[16]
	orientationModesC[0] = s("$SSX_orientationModes0") ; ____
	orientationModesC[1] = s("$SSX_orientationModes1") ; M___
	orientationModesC[2] = s("$SSX_orientationModes2") ; _F__
	orientationModesC[3] = s("$SSX_orientationModes3") ; MF__
	orientationModesC[4] = s("$SSX_orientationModes4") ; __S_
	orientationModesC[5] = s("$SSX_orientationModes5") ; M_S_
	orientationModesC[6] = s("$SSX_orientationModes6") ; _FS_
	orientationModesC[7] = s("$SSX_orientationModes7") ; MFS_
	orientationModesC[8] = s("$SSX_orientationModes8") ; ___B
	orientationModesC[9] = s("$SSX_orientationModes9") ; M__B
	orientationModesC[10] = s("$SSX_orientationModesA") ; _F_B
	orientationModesC[11] = s("$SSX_orientationModesB") ; MF_B
	orientationModesC[12] = s("$SSX_orientationModesC") ; __SB
	orientationModesC[13] = s("$SSX_orientationModesD") ; M_SB
	orientationModesC[14] = s("$SSX_orientationModesE") ; _FSB
	orientationModesC[15] = s("$SSX_orientationModesF") ; MFSB
	
	if nexusMode==0
		playerOrientations = new String[8]
		playerOrientations[0] = s("$ssx_playerorientationSL")
		playerOrientations[1] = s("$ssx_playerorientationSH")
		playerOrientations[2] = s("$ssx_playerorientationBH")
		playerOrientations[3] = s("$ssx_playerorientationGH")
		playerOrientations[4] = s("$ssx_playerorientationCO")
		playerOrientations[5] = s("$ssx_playerorientationSC")
		playerOrientations[6] = s("$ssx_playerorientationBC")
		playerOrientations[7] = s("$ssx_playerorientationGC")
	else
		playerOrientations = new String[4]
		playerOrientations[0] = s("$ssx_playerorientationSL")
		playerOrientations[1] = s("$ssx_playerorientationSH")
		playerOrientations[2] = s("$ssx_playerorientationBH")
		playerOrientations[3] = s("$ssx_playerorientationGH")
	endIf
	
	scaleActorsVals = new String[3]
	scaleActorsVals[0] = s("$SSX_ScaleActorsSLD")
	scaleActorsVals[1] = s("$SSX_ScaleActorsYes")
	scaleActorsVals[2] = s("$SSX_ScaleActorsNo")
	
	actionFilterNA = new String[3]
	actionFilterNA[0] = s("$SSX_actionFilterNA0")
	actionFilterNA[1] = s("$SSX_actionFilterNAN")
	actionFilterNA[2] = s("$SSX_actionFilterNAY")
	
	actionFilterSE = new String[3]
	actionFilterSE[0] = s("$SSX_actionFilterSE0")
	actionFilterSE[1] = s("$SSX_actionFilterSEN")
	actionFilterSE[2] = s("$SSX_actionFilterSEY")
	
	actionFilterSL = new String[3]
	actionFilterSL[0] = s("$SSX_actionFilterSL0")
	actionFilterSL[1] = s("$SSX_actionFilterSLN")
	actionFilterSL[2] = s("$SSX_actionFilterSLY")
	
	actionFilterAR = new String[3]
	actionFilterAR[0] = s("$SSX_actionFilterAR0")
	actionFilterAR[1] = s("$SSX_actionFilterARN")
	actionFilterAR[2] = s("$SSX_actionFilterARY")
	
	actionFilterHE = new String[3]
	actionFilterHE[0] = s("$SSX_actionFilterHE0")
	actionFilterHE[1] = s("$SSX_actionFilterHEN")
	actionFilterHE[2] = s("$SSX_actionFilterHEY")
	
	actionFilterST = new String[3]
	actionFilterST[0] = s("$SSX_actionFilterST0")
	actionFilterST[1] = s("$SSX_actionFilterSTN")
	actionFilterST[2] = s("$SSX_actionFilterSTY")
	
	actionFilterMA = new String[3]
	actionFilterMA[0] = s("$SSX_actionFilterMA0")
	actionFilterMA[1] = s("$SSX_actionFilterMAN")
	actionFilterMA[2] = s("$SSX_actionFilterMAY")
	
	actionFilterSN = new String[3]
	actionFilterSN[0] = s("$SSX_actionFilterSN0")
	actionFilterSN[1] = s("$SSX_actionFilterSNN")
	actionFilterSN[2] = s("$SSX_actionFilterSNY")
	
	actionFilterWE = new String[3]
	actionFilterWE[0] = s("$SSX_actionFilterWE0")
	actionFilterWE[1] = s("$SSX_actionFilterWEY")
	actionFilterWE[2] = s("$SSX_actionFilterWEN")
	
	actionFilterCO = new String[3]
	actionFilterCO[0] = s("$SSX_actionFilterCO0")
	actionFilterCO[1] = s("$SSX_actionFilterCON")
	actionFilterCO[2] = s("$SSX_actionFilterCOY")
	
	actionFilterBL = new String[3]
	actionFilterBL[0] = s("$SSX_actionFilterBL0")
	actionFilterBL[1] = s("$SSX_actionFilterBLN")
	actionFilterBL[2] = s("$SSX_actionFilterBLY")
	
	actionFilterUN = new String[3]
	actionFilterUN[0] = s("$SSX_actionFilterUN0")
	actionFilterUN[1] = s("$SSX_actionFilterUNN")
	actionFilterUN[2] = s("$SSX_actionFilterUNY")
	
	expertiseLevels = new String[3]
	expertiseLevels[0] = s("$SSX_ExpertiseLevelEasy")
	expertiseLevels[1] = s("$SSX_ExpertiseLevelNormal")
	expertiseLevels[2] = s("$SSX_ExpertiseLevelExpert")
	
	scanModes = new String[5]
	scanModes[0] = s("$SSX_ScanMode0")
	scanModes[1] = s("$SSX_ScanMode1")
	scanModes[2] = s("$SSX_ScanMode2")
	scanModes[3] = s("$SSX_ScanMode3")
	
	stopAllCombats = new String[3]
	stopAllCombats[0] = s("$SSX_StopAllCombatsNo")
	stopAllCombats[1] = s("$SSX_StopAllCombatsPF")
	stopAllCombats[2] = s("$SSX_StopAllCombatsYes")

	bodyParts = new String[23]
	bodyParts[1] = s("$SSX_BodyPartHead")
	bodyParts[2] = s("$SSX_BodyPartBody")
	bodyParts[3] = s("$SSX_BodyPartHands")
	bodyParts[4] = s("$SSX_BodyPartForearms")
	bodyParts[7] = s("$SSX_BodyPartFeet")
	bodyParts[8] = s("$SSX_BodyPartCalves")
	bodyParts[22] = s("$SSX_BodyPartPelvis")
	
	whoIsVictim = new String[4]
	whoIsVictim[0] = s("$SSX_Nobody")
	whoIsVictim[1] = s("$SSX_TheTarget")
	whoIsVictim[2] = s("$SSX_TheSource")
	whoIsVictim[3] = s("$SSX_TheCollaborator")

	participantEdit = new String[3]
	participantEdit[0] = s("$SSX_TheTarget")
	participantEdit[1] = s("$SSX_TheSource")
	participantEdit[2] = s("$SSX_TheCollaborator")
	
	hasToNotTos = new String[2]
	hasToNotTos[0] = s("$SSX_HasToNotTo0")
	hasToNotTos[1] = s("$SSX_HasToNotTo1")
	
	intExtMnu = new String[3]
	intExtMnu[0] = s("$SSX_Both")
	intExtMnu[1] = s("$SSX_InternalOnly")
	intExtMnu[2] = s("$SSX_ExternalOnly")

	inclExclMnu = new String[2]
	inclExclMnu[0] = s("$SSX_cellinclusiveexclusiveI")
	inclExclMnu[1] = s("$SSX_cellinclusiveexclusiveE")
	
	locationList = CreateStringArray(locations.length)
	int i = locations.length
	while i
		i-=1
		locationList[i] = locations[i].getName()
	endWhile
	
	locationTypeList = new String[44]
	locationTypeList[0] = s("$SSX_LocTypePlayerHouse")
	locationTypeList[1] = s("$SSX_LocTypeHouse")
	locationTypeList[2] = s("$SSX_LocTypeCity")
	locationTypeList[3] = s("$SSX_LocTypeHold")
	locationTypeList[4] = s("$SSX_LocTypeInn")
	locationTypeList[5] = s("$SSX_LocTypeKeeps")
	locationTypeList[6] = s("$SSX_LocTypeJails")
	locationTypeList[7] = s("$SSX_LocTypeDungeons")
	locationTypeList[8] = s("$SSX_LocTypeBarracks")
	locationTypeList[9] = s("$SSX_LocTypeBanditCamp")
	locationTypeList[10] = s("$SSX_LocTypeOrcStronghold")
	locationTypeList[11] = s("$SSX_LocTypeForswornCamp")
	locationTypeList[12] = s("$SSX_LocTypeDraugrCrypt")
	locationTypeList[13] = s("$SSX_LocTypeHabitation")
	locationTypeList[14] = s("$SSX_LocTypeMilitaryCamp")
	locationTypeList[15] = s("$SSX_LocTypeMilitaryFort")
	locationTypeList[16] = s("$SSX_LocTypeGiantCamp")
	locationTypeList[17] = s("$SSX_LocTypeVampireLair")
	locationTypeList[18] = s("$SSX_LocTypeWerewolfLair")
	locationTypeList[19] = s("$SSX_LocTypeMine")
	locationTypeList[20] = s("$SSX_LocTypeStore")
	locationTypeList[21] = s("$SSX_LocTypeTemple")
	locationTypeList[22] = s("$SSX_LocTypeTown")
	locationTypeList[23] = s("$SSX_LocTypeAnimalDen")
	locationTypeList[24] = s("$SSX_LocTypeCemetery")
	locationTypeList[25] = s("$SSX_LocTypeDragonLair")
	locationTypeList[26] = s("$SSX_LocTypeDragonPriestLair")
	locationTypeList[27] = s("$SSX_LocTypeDwarvenAutomatron")
	locationTypeList[28] = s("$SSX_LocTypeDwelling")
	locationTypeList[29] = s("$SSX_LocTypeFalmerHive")
	locationTypeList[30] = s("$SSX_LocTypeFarm")
	locationTypeList[31] = s("$SSX_LocTypeGuild")
	locationTypeList[32] = s("$SSX_LocTypeHabitationWithInn")
	locationTypeList[33] = s("$SSX_LocTypeHagravenNest")
	locationTypeList[34] = s("$SSX_LocTypeHoldCapital")
	locationTypeList[35] = s("$SSX_LocTypeHoldMajor")
	locationTypeList[36] = s("$SSX_LocTypeHoldMinor")
	locationTypeList[37] = s("$SSX_LocTypeLumberMill")
	locationTypeList[38] = s("$SSX_LocTypeSettlement")
	locationTypeList[39] = s("$SSX_LocTypeShip")
	locationTypeList[40] = s("$SSX_LocTypeShipwreck")
	locationTypeList[41] = s("$SSX_LocTypeSprigganGrove")
	locationTypeList[42] = s("$SSX_LocTypeStewardsDwelling")
	locationTypeList[43] = s("$SSX_LocTypeWarlockLair")
	
	associationNames = new String[21]
	associationNames[0] = s("$SSX_AssociationTypeAuntUncle")
	associationNames[1] = s("$SSX_AssociationTypeBossEmployee")
	associationNames[2] = s("$SSX_AssociationTypeBusinessPartners")
	associationNames[3] = s("$SSX_AssociationTypeConspirators")
	associationNames[4] = s("$SSX_AssociationTypeCourting")
	associationNames[5] = s("$SSX_AssociationTypeCousins")
	associationNames[6] = s("$SSX_AssociationTypeFavorTarget")
	associationNames[7] = s("$SSX_AssociationTypeGrandAuntUncle")
	associationNames[8] = s("$SSX_AssociationTypeGrandparentGrandchild")
	associationNames[9] = s("$SSX_AssociationTypeGreatGrandparentGreatgrandchild")
	associationNames[10] = s("$SSX_AssociationTypeInLawAuntUncle")
	associationNames[11] = s("$SSX_AssociationTypeInLawBrotherSister")
	associationNames[12] = s("$SSX_AssociationTypeInLawGrandparentGrandchild")
	associationNames[13] = s("$SSX_AssociationTypeInLawParentChild")
	associationNames[14] = s("$SSX_AssociationTypeJarlHousecarl")
	associationNames[15] = s("$SSX_AssociationTypeJarlSteward")
	associationNames[16] = s("$SSX_AssociationTypeMasterAssistant")
	associationNames[17] = s("$SSX_AssociationTypeParentChild")
	associationNames[18] = s("$SSX_AssociationTypeSiblings")
	associationNames[19] = s("$SSX_AssociationTypeSpouse")
	
	stripModes = new String[4]
	stripModes[0] = s("$SSX_stripModesNone")
	stripModes[1] = s("$SSX_stripModesDontUndress")
	stripModes[2] = s("$SSX_stripModesDontRedress")
	stripModes[3] = s("$SSX_stripModesDontUndressAndRedress")
	
	startsOnActorModes = new String[27]
	startsOnActorModes[0] = s("$SSX_StartsOnActorModes000")
	startsOnActorModes[1] = s("$SSX_StartsOnActorModes100")
	startsOnActorModes[2] = s("$SSX_StartsOnActorModes200")
	startsOnActorModes[3] = s("$SSX_StartsOnActorModes010")
	startsOnActorModes[4] = s("$SSX_StartsOnActorModes110")
	startsOnActorModes[5] = s("$SSX_StartsOnActorModes210")
	startsOnActorModes[6] = s("$SSX_StartsOnActorModes020")
	startsOnActorModes[7] = s("$SSX_StartsOnActorModes120")
	startsOnActorModes[8] = s("$SSX_StartsOnActorModes220")
	startsOnActorModes[9] = s("$SSX_StartsOnActorModes001")
	startsOnActorModes[10] = s("$SSX_StartsOnActorModes101")
	startsOnActorModes[11] = s("$SSX_StartsOnActorModes201")
	startsOnActorModes[12] = s("$SSX_StartsOnActorModes011")
	startsOnActorModes[13] = s("$SSX_StartsOnActorModes111")
	startsOnActorModes[14] = s("$SSX_StartsOnActorModes211")
	startsOnActorModes[15] = s("$SSX_StartsOnActorModes021")
	startsOnActorModes[16] = s("$SSX_StartsOnActorModes121")
	startsOnActorModes[17] = s("$SSX_StartsOnActorModes221")
	startsOnActorModes[18] = s("$SSX_StartsOnActorModes002")
	startsOnActorModes[19] = s("$SSX_StartsOnActorModes102")
	startsOnActorModes[20] = s("$SSX_StartsOnActorModes202")
	startsOnActorModes[21] = s("$SSX_StartsOnActorModes012")
	startsOnActorModes[22] = s("$SSX_StartsOnActorModes112")
	startsOnActorModes[23] = s("$SSX_StartsOnActorModes212")
	startsOnActorModes[24] = s("$SSX_StartsOnActorModes022")
	startsOnActorModes[25] = s("$SSX_StartsOnActorModes122")
	startsOnActorModes[26] = s("$SSX_StartsOnActorModes222")

	startsOnActorModesVal = new String[27]
	startsOnActorModesVal[0] = s("$SSX_StartsOnActorModesVal000")
	startsOnActorModesVal[1] = s("$SSX_StartsOnActorModesVal100")
	startsOnActorModesVal[2] = s("$SSX_StartsOnActorModesVal200")
	startsOnActorModesVal[3] = s("$SSX_StartsOnActorModesVal010")
	startsOnActorModesVal[4] = s("$SSX_StartsOnActorModesVal110")
	startsOnActorModesVal[5] = s("$SSX_StartsOnActorModesVal210")
	startsOnActorModesVal[6] = s("$SSX_StartsOnActorModesVal020")
	startsOnActorModesVal[7] = s("$SSX_StartsOnActorModesVal120")
	startsOnActorModesVal[8] = s("$SSX_StartsOnActorModesVal220")
	startsOnActorModesVal[9] = s("$SSX_StartsOnActorModesVal001")
	startsOnActorModesVal[10] = s("$SSX_StartsOnActorModesVal101")
	startsOnActorModesVal[11] = s("$SSX_StartsOnActorModesVal201")
	startsOnActorModesVal[12] = s("$SSX_StartsOnActorModesVal011")
	startsOnActorModesVal[13] = s("$SSX_StartsOnActorModesVal111")
	startsOnActorModesVal[14] = s("$SSX_StartsOnActorModesVal211")
	startsOnActorModesVal[15] = s("$SSX_StartsOnActorModesVal021")
	startsOnActorModesVal[16] = s("$SSX_StartsOnActorModesVal121")
	startsOnActorModesVal[17] = s("$SSX_StartsOnActorModesVal221")
	startsOnActorModesVal[18] = s("$SSX_StartsOnActorModesVal002")
	startsOnActorModesVal[19] = s("$SSX_StartsOnActorModesVal102")
	startsOnActorModesVal[20] = s("$SSX_StartsOnActorModesVal202")
	startsOnActorModesVal[21] = s("$SSX_StartsOnActorModesVal012")
	startsOnActorModesVal[22] = s("$SSX_StartsOnActorModesVal112")
	startsOnActorModesVal[23] = s("$SSX_StartsOnActorModesVal212")
	startsOnActorModesVal[24] = s("$SSX_StartsOnActorModesVal022")
	startsOnActorModesVal[25] = s("$SSX_StartsOnActorModesVal122")
	startsOnActorModesVal[26] = s("$SSX_StartsOnActorModesVal222")

	positionsFilterWarning = new String[4]
	positionsFilterWarning[1] = s("$SSX_FilterNotValidDst")
	positionsFilterWarning[2] = s("$SSX_FilterNotValidSrc")
	positionsFilterWarning[3] = s("$SSX_FilterNotValidColl")
	
	timeOfTheDay = new String[24]
	timeOfTheDay[0] = "Midnight"
	timeOfTheDay[1] = "1 AM"
	timeOfTheDay[2] = "2 AM"
	timeOfTheDay[3] = "3 AM"
	timeOfTheDay[4] = "4 AM"
	timeOfTheDay[5] = "5 AM"
	timeOfTheDay[6] = "6 AM"
	timeOfTheDay[7] = "7 AM"
	timeOfTheDay[8] = "8 AM"
	timeOfTheDay[9] = "9 AM"
	timeOfTheDay[10] = "10 AM"
	timeOfTheDay[11] = "11 AM"
	timeOfTheDay[12] = "Midday"
	timeOfTheDay[13] = "1 PM"
	timeOfTheDay[14] = "2 PM"
	timeOfTheDay[15] = "3 PM"
	timeOfTheDay[16] = "4 PM"
	timeOfTheDay[17] = "5 PM"
	timeOfTheDay[18] = "6 PM"
	timeOfTheDay[19] = "7 PM"
	timeOfTheDay[20] = "8 PM"
	timeOfTheDay[21] = "9 PM"
	timeOfTheDay[22] = "10 PM"
	timeOfTheDay[23] = "11 PM"
	
	playerGenderTags = new String[4]
	playerGenderTags[0] = s("$SSX_PlayerGenderTags0")
	playerGenderTags[1] = s("$SSX_PlayerGenderTags1")
	playerGenderTags[2] = s("$SSX_PlayerGenderTags2")
	playerGenderTags[3] = s("$SSX_PlayerGenderTags3")
	
	addGenderTagsMenu = new String[4]
	addGenderTagsMenu[0] = s("$SSX_addgendertagsmode0")
	addGenderTagsMenu[1] = s("$SSX_addgendertagsmode1")
	addGenderTagsMenu[2] = s("$SSX_addgendertagsmode2")
	addGenderTagsMenu[3] = s("$SSX_addgendertagsmode3")

	animNames = new String[1]
	animNames[0] = "no anims"
	
	emptyRaceKeys = new String[1]
	emptyRaceKeys[0]=""
	
	participantQuickSettingsLL = new String[14]
	participantQuickSettingsLL[0] = s("$SSX_QuickNobody")
	participantQuickSettingsLL[1] = s("$SSX_QuickPlayer")
	participantQuickSettingsLL[2] = s("$SSX_QuickHumanMales")
	participantQuickSettingsLL[3] = s("$SSX_QuickHumanFemales")
	participantQuickSettingsLL[4] = s("$SSX_QuickHumans")
	participantQuickSettingsLL[5] = s("$SSX_QuickHumansAndPlayer")
	participantQuickSettingsLL[6] = s("$SSX_QuickFollowers")
	participantQuickSettingsLL[7] = s("$SSX_QuickHumanFollowers")
	participantQuickSettingsLL[8] = s("$SSX_QuickMaleFollowers")
	participantQuickSettingsLL[9] = s("$SSX_QuickFemaleFollowers")
	participantQuickSettingsLL[10] = s("$SSX_QuickCreatures")
	participantQuickSettingsLL[11] = s("$SSX_QuickDogsNWolves")
	participantQuickSettingsLL[12] = s("$SSX_Quick3Falmers")
	participantQuickSettingsLL[13] = s("$SSX_Quick3Draugrs")
	
	participantQuickSettingsNX = new String[10]
	participantQuickSettingsNX[0] = s("$SSX_QuickNobody")
	participantQuickSettingsNX[1] = s("$SSX_QuickPlayer")
	participantQuickSettingsNX[2] = s("$SSX_QuickHumanMales")
	participantQuickSettingsNX[3] = s("$SSX_QuickHumanFemales")
	participantQuickSettingsNX[4] = s("$SSX_QuickHumans")
	participantQuickSettingsNX[5] = s("$SSX_QuickHumansAndPlayer")
	participantQuickSettingsNX[6] = s("$SSX_QuickFollowers")
	participantQuickSettingsNX[7] = s("$SSX_QuickHumanFollowers")
	participantQuickSettingsLL[8] = s("$SSX_QuickMaleFollowers")
	participantQuickSettingsNX[9] = s("$SSX_QuickFemaleFollowers")
	
	raceInclusiveExclusive = new String[2]
	raceInclusiveExclusive[0] = s("$SSX_RaceInclusiveExclusiveI")
	raceInclusiveExclusive[1] = s("$SSX_RaceInclusiveExclusiveE")
	
	racesToFilter = new String[3]
	racesToFilter[0] = s("$SSX_RacesToFilterHumans")
	racesToFilter[1] = s("$SSX_RacesToFilterCreatures")
	racesToFilter[2] = s("$SSX_RacesToFilterBoth")
	
	whoWillBePassive = new String[9]
	whoWillBePassive[0] = s("$SSX_WhoWillBePassive0") ; Dst
	whoWillBePassive[1] = s("$SSX_WhoWillBePassive1") ; Src
	whoWillBePassive[2] = s("$SSX_WhoWillBePassive2") ; Coll
	whoWillBePassive[3] = s("$SSX_WhoWillBePassive3") ; Random
	whoWillBePassive[4] = s("$SSX_WhoWillBePassive4") ; Female
	whoWillBePassive[5] = s("$SSX_WhoWillBePassive5") ; Femdom
	whoWillBePassive[6] = s("$SSX_WhoWillBePassive6") ; Gay
	whoWillBePassive[7] = s("$SSX_WhoWillBePassive7") ; Gay or Female
	whoWillBePassive[8] = s("$SSX_WhoWillBePassive8") ; Female or Gay
	
	inCaseOfAggressiveness = new String[4]
	inCaseOfAggressiveness[0] = s("$SSX_DoNothing")
	inCaseOfAggressiveness[1] = s("$SSX_AddAggressiveTag")
	inCaseOfAggressiveness[2] = s("$SSX_AddAggressiveTagAndRemove")
	inCaseOfAggressiveness[3] = s("$SSX_AddAggressiveTagAlsoAnims")
	
	spectatorsMasturbates = new String[4]
	spectatorsMasturbates[0] = s("$SSX_spectatorsmasturbate0")
	spectatorsMasturbates[1] = s("$SSX_spectatorsmasturbate1")
	spectatorsMasturbates[2] = s("$SSX_spectatorsmasturbate2")
	spectatorsMasturbates[3] = s("$SSX_spectatorsmasturbate3")
	
	catchModes = new String[8]
	catchModes[0] = s("$SSX_CatchMode0")
	catchModes[1] = s("$SSX_CatchMode1")
	catchModes[2] = s("$SSX_CatchMode2")
	catchModes[3] = s("$SSX_CatchMode3")
	catchModes[4] = s("$SSX_CatchMode4")
	catchModes[5] = s("$SSX_CatchMode5")
	catchModes[6] = s("$SSX_CatchMode6")
	catchModes[7] = s("$SSX_CatchMode7")
	
	importRulesMode = new String[3]
	importRulesMode[0] = s("$SSX_ImportRulesMode0")
	importRulesMode[1] = s("$SSX_ImportRulesMode1")
	importRulesMode[2] = s("$SSX_ImportRulesMode2")
	
	checkingModes = new String[2]
	checkingModes[0] = s("$SSX_checkingModes0")
	checkingModes[1] = s("$SSX_checkingModes1")
	
	colors = new String[8]
	colors[0] = s("$SSX_None")
	colors[1] = s("$SSX_Green")
	colors[2] = s("$SSX_Yellow")
	colors[3] = s("$SSX_Red")
	colors[4] = s("$SSX_Blue")
	colors[5] = s("$SSX_Purple")
	colors[6] = s("$SSX_Cyan")
	colors[7] = s("$SSX_White")
	
	mcmActorNames = new String[64]

	; TODO: i18n
	; would also need language-specific esp files
	requestDialogues = new String[5]
	requestDialogues[0] = "Come on, let's find somewhere quiet."
	requestDialogues[1] = "Want to come to bed with me?"
	requestDialogues[2] = "I hear you'll do it with anybody."
	requestDialogues[3] = "Quiet now. No more talking."
	requestDialogues[4] = "I hear the divines blessed you with... special talents."


	positiveAnswers = new String[5]
	positiveAnswers[0] = "I know just the place."
	positiveAnswers[1] = "You can take me anytime."
	positiveAnswers[2] = "I'm all yours."
	positiveAnswers[3] = "Do I really have a choice?"
	positiveAnswers[4] = "Oh yes, please..."
	
	negativeAnswers = new String[5]
	negativeAnswers[0] = "Is this a joke? Go bother someone else!"
	negativeAnswers[1] = "Quit that already!"
	negativeAnswers[2] = "Get away from me!"
	negativeAnswers[3] = "No! Stop!"
	negativeAnswers[4] = "I'd rather do it with a troll."
	
	npcFinalSentences = new String[6]
	npcFinalSentences[0] = "<None>"
	npcFinalSentences[1] = "Ask again anytime"
	npcFinalSentences[2] = "It was wonderful"
	npcFinalSentences[3] = "I'll look forward to seeing you again"
	npcFinalSentences[4] = "Now my ass hurts"
	npcFinalSentences[5] = "Next time bring a friend or two"
	
	answerProbs = new String[5]
	answerProbs[0] = "Always"
	answerProbs[1] = "High"
	answerProbs[2] = "Medium"
	answerProbs[3] = "Low"
	answerProbs[4] = "Never"

	editTypes = new String[3]
	editTypes[0] = s("$SSX_EditProperties")
	editTypes[1] = s("$SSX_EditFellowship")
	editTypes[2] = s("$SSX_EditFactions")
	
	priorityModes = new String[2]
	priorityModes[0] = s("$SSX_ScaledProbability")
	priorityModes[1] = s("$SSX_PriorityFirst")
	
	forceStopCombatsMN = new String[4]
	forceStopCombatsMN[0] = s("$SSX_ForceStopCombats0")
	forceStopCombatsMN[1] = s("$SSX_ForceStopCombats1")
	forceStopCombatsMN[2] = s("$SSX_ForceStopCombats2")
	forceStopCombatsMN[3] = s("$SSX_ForceStopCombats3")
	
	stringArraysInitialized = true
	alreadyInitializingStrings = false
EndFunction

Function loadJSONTranslations()
	if !translationCache || translationCache.length==0 || !translationValue || translationValue.length==0
		translationCache = CreateStringArray(128)
		translationValue = CreateStringArray(128)
	endIf
	; Check if we have the file with the current language. If missing revert to the English one
	translationsPath = configFolder + "translations\\" + currentGameTranslation + ".json"
	JSONUtil.Load(translationsPath)
	if !JSONUtil.IsGood(translationsPath)
		debug.trace("[SSX] error, the translation file " + translationsPath + " is not valid.")
		if currentGameTranslation!="English"
			debug.MessageBox("--- Scent of Sex Error ---\nThe translation file \"" + translationsPath + "\" is not valid.\nReverting to English.")
		endIf
	endIf
	int translationVersion = JSONUtil.GetIntValue(translationsPath, "$ssx_translationversion", missing = -1)
	if translationVersion==-1
		; Revert to English
		translationsPath = configFolder + "translations\\english.json"
		if !JSONUtil.IsGood(translationsPath)
			debug.MessageBox("--- Scent of Sex Error ---\nThe default English translation file is wrong!\nThe mod will NOT work!\n" + JSONUtil.GetErrors(translationsPath))
		endIf
	endIf
	JSONUtil.Load(translationsPath)
EndFunction

; -))

bool jsonAlreadyReloaded = false
bool areWeReLoading = false


int Function getVersion()
	return 10408
EndFunction

String Function getVersionString()
	return "1.4h"
EndFunction

int Function getSubVersion()
	return 0
EndFunction

bool wasIActive

bool Function doInit()
	areWeReLoading = True
	
	wasIActive = (iAmActive==1)
	if wasIActive
		stopSSX() ; Stop it
	endIf
	iAmActive = 0
	
	configFolder = "..\\..\\..\\configs\\Scent of Sex NG\\"
	configFile = configFolder + "settings.json"
	currentGameTranslation = Utility.GetINIString("sLanguage:General")
	loadJSONTranslations()
	isConfigInProgress = -1
	areTagsInProgress = -1
	
	; Get all SexLab properties
	Form SexLabQuestAnimations = Game.GetFormFromFile(0x639DF, "SexLab.esm")
	if !SexLabQuestAnimations
		log("Could not find SexLab.esm! Check your installation!", notifMsgBox())
		return false
	endIf
	Form SexLabQuestFramework = Game.GetFormFromFile(0xD62, "SexLab.esm")
	if SexLabQuestFramework
		SexLabConfig = SexLabQuestFramework as sslSystemConfig
	else
		log("Could not find SexLab.esm! Check your installation!", notifMsgBox())
		return false
	endIf
	Form SexLabQuestRegistry = Game.GetFormFromFile(0x664FB, "SexLab.esm")
	if SexLabQuestRegistry
		CreatureSlots = SexLabQuestRegistry as sslCreatureAnimationSlots
	else
		log("Could not find SexLab.esm! Check your installation!", notifMsgBox())
		return false
	endIf
	if SexLabQuestFramework
		SexLabFramework sl = SexLabQuestFramework as SexLabFramework
		sslSystemAlias SystemAlias = sl.GetNthAlias(0) as sslSystemAlias
		if !SystemAlias.IsInstalled
			int times=0
			while times<10 && !SystemAlias.IsInstalled
				Utility.waitMenuMode(1.0)
				times+=1
			endWhile
			if !SystemAlias.IsInstalled
				debug.notification("[SSX] Please complete SexLab installation before running this mod!")
				return false
			endIf
		endIf
	else
		debug.notification("[SSX] Please complete SexLab installation before running this mod!")
		return false
	endIf
	Utility.waitMenuMode(0.5)

	if PapyrusUtil.GetVersion()<32
		log("Too old version of PapyrusUtil.\nYou need at least version 3.2\nYour version = " + (PapyrusUtil.GetVersion() / 10) + "." + (PapyrusUtil.GetVersion() % 10), notifMsgBox())
	endIf

		; Check SKSE version
	if SKSE.GetScriptVersionRelease() < 48
		debug.MessageBox(s("$SSX_WarningSKSEVersion"))
	endIf
	; Check SexLab version
	if SexLab.getVersion() < 16200
		Debug.MessageBox(s("$WarningSSLVersion", SexLab.GetStringVer()))
		return false
	endIf
	; Check SkyUI version (this is done through a really back hack, because there is no easy way to find the actual version of SkyUI)
	int skyUIOrder = Game.GetModByName("SkyUI_SE.esp")
	Debug.notification("[SSX] SkyUI SE Check ")
	if skyUIOrder!=-1 && skyUIOrder!=255
			ski_main skyUI = Game.getFormFromFile(0x814, "SkyUI_SE.esp") as Ski_main
			Debug.notification("[SSX] SkyUI SE found")
			int skyUIMaj = StringUtil.GetNthChar(skyUI.ReqSWFVersion, 0) as Int
	Else
			Debug.MessageBox("[SSX] SkyUI SE not found")
	endIf

	; Check if we have Arousal
	if Game.GetModByName("SexLabAroused.esm")!=-1 && Game.GetModByName("SexLabAroused.esm")!=255
		; We have SexLab Arousal
		slaf = Game.getFormFromFile(0x4290F, "SexLabAroused.esm") as slaFrameworkScr
	else
		slaf = None
	endIf
	
	; Check if we have Creature Framework
	if !nexusMode && Game.GetModByName("CreatureFramework.esm")!=-1 && Game.GetModByName("CreatureFramework.esm")!=255
		; We have Creature Framework
		debug.trace("[SSX] Found Creature Framework")
		CF = Game.getFormFromFile(0xD62, "CreatureFramework.esm") as CreatureFramework
	else
		CF = None
	endIf

	if !PlayerRef.hasSpell(ssxPlayerCellDetectorSpell)
		PlayerRef.addSpell(ssxPlayerCellDetectorSpell, false)
	endIf

	needToSortRaceArraysH = true
	needToSortRaceArraysC = true
	needToUpdateRaceDisplayArraysH = true
	needToUpdateRaceDisplayArraysC = true
	defaultSexLabActorsScaling = false

	initStringArrays()
	
	if ssxKeyCode==0
		ssxKeyCode = JSONUtil.GetIntValue(configFile, "OPT_EnableDisableKeyCode", 0)
	endIf
	
	checkerEvents = new float[16]
	int i = 16
	while (i)
		i -= 1
		checkerEvents[i] = 0.0
	endWhile
	actorsUpdate = Utility.createIntArray(allActors.length)

	areWeReLoading = False
	return true
EndFunction

Function postInit()
	int handle
	if isConfigInProgress==-1
		handle = ModEvent.Create("ssxUpdateConfig")
		ModEvent.PushString(handle, "Load")
		ModEvent.PushString(handle, "postInit")
		ModEvent.Send(handle)
	endIf
	int times=0
	while isConfigInProgress<100 && times < 50
		Utility.waitMenuMode(0.3)
		times+=1
	endWhile
	if isConfigInProgress==-1
		log("Scent of Sex failed to initialize.\nCheck your installation.", notifMsgBox())
	elseIf isConfigInProgress<100
		log("Scent of Sex is taking a long time to start up.\n" + isConfigInProgress + "% after 15 seconds\nTry to open the MCM in a little while.", notifMsgBox())
	endIf
	
	updateRacesProgress = -1
	updateAllNeededActors()
	updateAllNeededRaces()
	registerForEvents()
	
	forceActorsCleanUp()

	; Get all factions
	Form[] tempMcmFactions = PO3_SKSEFunctions.GetAllForms(11) ; FormType.kFaction
	Debug.Trace("[SSX] Found " + tempMcmFactions.length + " factions.")
	; If factions changed (also if we're initializing for the first time):
	; This can fail if users uninstall and install other mods on the go. That's on them.
	if mcmFactions.length != tempMcmFactions.length
		Debug.Trace("[SSX] Factions have changed. Regenerating and sorting faction list.")
		mcmFactions = tempMcmFactions
		mcmFactionNames = Utility.CreateStringArray(mcmFactions.length)
		
		int i = mcmFactions.length
		while i
			i -= 1
			mcmFactionNames[i] = getNameAndEditorID(mcmFactions[i])
		endWhile
			
		; Sort the factions
		; TODO: This would benefit from further optimization. Not exactly sure how tbh. Takes more than a minute on my PC.
		PapyrusUtil.SortStringArray(mcmFactionNames)
		i = mcmFactions.length
		while i
			i -= 1
			String[] parts = StringUtil.split(mcmFactionNames[i], " | ")
			; This should hopefully work for both string containing " | " more and less than once
			int last_index = parts.length - 1
			mcmFactions[i] = PO3_SKSEFunctions.GetFormFromEditorID(parts[last_index])
		endWhile
		Debug.Trace("[SSX] Sorted faction list.")
	endIf


	if wasIActive
		wasIActive=false
		startSSX(true)
	else
		stopSSX()
	endIf
EndFunction

; ((- -------------------------- EVENTS Management --------------------------
; key to start/stop -> ssxr
; console -> ssxr
; dialogues -> ssxr
; menu -> ssxr

Function registerForEvents()
	UnregisterForAllKeys()
	UnregisterForAllMenus()
	if ssxKeyCode
		RegisterForKey(ssxKeyCode)
	endIf
	RegisterForMenu("Console")
	RegisterForMenu("Main Menu")
	RegisterForMenu("Top Menu")
	RegisterForMenu("Loading Menu")
	RegisterForMenu("BarterMenu")
	RegisterForMenu("Dialogue Menu")
	RegisterForMenu("GiftMenu")
	RegisterForMenu("MapMenu")
	RegisterForMenu("LevelUp Menu")
	RegisterForMenu("Journal Menu")
	RegisterForMenu("RaceSex Menu")
	RegisterForMenu("Tutorial Menu")
	RegisterForMenu("Credits Menu")
	RegisterForMenu("TitleSequence Menu")
	RegisterForMenu("Console Native UI Menu")
	RegisterForMenu("Kinect Menu")
	RegisterForMenu("InventoryMenu")
	RegisterForMenu("MessageBoxMenu")
	RegisterForMenu("MagicMenu")
	RegisterForMenu("Top Menu")
	RegisterForMenu("Overlay Menu")
	RegisterForMenu("Overlay Interaction Menu")
	RegisterForMenu("Loading Menu")
	RegisterForMenu("TweenMenu")
	RegisterForMenu("Lockpicking Menu")
	RegisterForMenu("Quantity Menu")
	RegisterForMenu("StatsMenu")
	RegisterForMenu("ContainerMenu")
	RegisterForMenu("Sleep/Wait Menu")
	RegisterForMenu("Book Menu")
	RegisterForMenu("FavoritesMenu")
	RegisterForMenu("Crafting Menu")
	RegisterForMenu("Training Menu")
	RegisterForMenu("Mist Menu")

	RegisterForModEvent("ssxStart", "startSSX")
	RegisterForModEvent("ssxStop", "stopSSX")
	
	if UI.IsMenuOpen("Console")
		areMenuOpen += 1
	endIf
	if UI.IsMenuOpen("Main Menu")
		areMenuOpen += 1
	endIf
EndFunction

Function unRegisterForEvents()
	UnregisterForAllKeys()
	UnregisterForAllMenus()
EndFunction

Event OnKeyUp(Int KeyCode, Float HoldTime)
	If KeyCode == ssxKeyCode
		if isMCMOpen || UI.IsMenuOpen("Console")
			return
		endIf
		if isConfigInProgress!=100
			debug.notification("Scent of Sex is busy updating, please wait to start it " + isConfigInProgress + "%")
			debug.trace("[SSX] Scent of Sex is busy updating, please wait to start it " + isConfigInProgress + "%")
			return
		endIf
		; If we are running then stop, else let's start
		if iAmActive
			log("Stopping Scent of Sex", notifActivationN())
			stopSSX()
		else
			startSSX(HoldTime>1.99)
		endIf
	endIf
EndEvent

Function setModActive(bool active)
	if active
		if iAmActive==1
			stopSSX()
		endIf
	else
		if iAmActive==0
			startSSX(false)
		endIf
	endIf
EndFunction

Event OnMenuOpen(string menuName)
	areMenuOpen+=1
endEvent

Event OnMenuClose(string menuName)
	areMenuOpen-=1
	if menuName=="Loading Menu"
		areMenuOpen=0
	endIf
	if areMenuOpen<=0
		areMenuOpen=0
	endIf
endEvent

bool Function checkMenuOpen()
	if !UI.IsMenuOpen("Console") && !UI.IsMenuOpen("Main Menu") && !UI.IsMenuOpen("Top Menu") && !UI.IsMenuOpen("Loading Menu") && !UI.IsMenuOpen("BarterMenu") && !UI.IsMenuOpen("Dialogue Menu") && !UI.IsMenuOpen("GiftMenu") && !UI.IsMenuOpen("MapMenu") && !UI.IsMenuOpen("LevelUp Menu") && !UI.IsMenuOpen("Journal Menu") && !UI.IsMenuOpen("RaceSex Menu") && !UI.IsMenuOpen("Tutorial Menu") && !UI.IsMenuOpen("Credits Menu") && !UI.IsMenuOpen("TitleSequence Menu") && !UI.IsMenuOpen("Console Native UI Menu") && !UI.IsMenuOpen("Kinect Menu")  && !UI.IsMenuOpen("InventoryMenu") && !UI.IsMenuOpen("MessageBoxMenu") && !UI.IsMenuOpen("MagicMenu") && !UI.IsMenuOpen("Top Menu") && !UI.IsMenuOpen("Overlay Menu") && !UI.IsMenuOpen("Overlay Interaction Menu") && !UI.IsMenuOpen("Loading Menu") && !UI.IsMenuOpen("TweenMenu") && !UI.IsMenuOpen("Lockpicking Menu") && !UI.IsMenuOpen("Quantity Menu") && !UI.IsMenuOpen("StatsMenu") && !UI.IsMenuOpen("ContainerMenu") && !UI.IsMenuOpen("Sleep/Wait Menu") && !UI.IsMenuOpen("Book Menu") && !UI.IsMenuOpen("FavoritesMenu") && !UI.IsMenuOpen("Crafting Menu") && !UI.IsMenuOpen("Training Menu") && !UI.IsMenuOpen("Mist Menu")
		areMenuOpen=0
		return false
	endIf
	return true
EndFunction



Function startSSX(bool force=false)
	if areMenuOpen && !force
		return
	endIf
	iAmActive = 1
	letsWait = 0
	updateAllNeededActors()
	int handle = ModEvent.Create("ssxStartSSXMod") 
	ModEvent.PushInt(handle, scanMode)
	ModEvent.Send(handle)
	int i = rules.length
	while i
		i-=1
		rules[i].status=0
	endWhile
	if force
		areMenuOpen=0
		log("Forced Starting Scent of Sex", notifActivationN())
	else
		log("Starting Scent of Sex", notifActivationN())
	endIf
	Utility.waitMenuMode(1.0)
	checkPlayerProtection()
EndFunction

Function stopSSX()
	iAmActive = 0
	letsWait=1
	if PlayerRef.getActorValue("Health")<2.0
		PlayerRef.ResetHealthAndLimbs()
	endIf
	int handle = ModEvent.Create("ssxStopSSXMod") 
	ModEvent.PushString(handle, "DoIt")
	ModEvent.Send(handle)
	Utility.waitMenuMode(0.2)
	if !dontStopScenes
		int i=scenes.length
		while i
			i-=1
			releaseScene(index=i)
		endWhile
		i=allActors.length
		while i
			i-=1
			Actor a = allActors[i]
			if a && a.isInFaction(ssxInvolved)
				a.removeFromFaction(ssxInvolved)
			endIf
		endWhile
	endIf
	
	_whatIAmDoing=""
	schedulerScan = -1.0
	schedulerCheckerUpdate = -1.0
	schedulerCheckerEvent = -1.0
	schedulerPlayer = -1.0
	schedulerSManager = -1.0

	; Remove all spectators override
	ActorUtil.RemoveAllPackageOverride(ssxSpectatorCrowdPackages[0])
	ActorUtil.RemoveAllPackageOverride(ssxSpectatorCrowdPackages[1])
	ActorUtil.RemoveAllPackageOverride(ssxSpectatorCrowdPackages[2])
	ActorUtil.RemoveAllPackageOverride(ssxSpectatorCrowdPackages[3])
	ActorUtil.RemoveAllPackageOverride(ssxSpectatorCrowdPackages[4])
	ActorUtil.RemoveAllPackageOverride(ssxSpectatorCrowdPackages[5])
	
	; Remove the player from the involved
	if PlayerRef.isInFaction(ssxInvolved)
		PlayerRef.removeFromFaction(ssxInvolved)
	endIf
	
	int i = usedBeds.length
	while i
		i-=1
		usedBeds[i]=None
	endWhile

	i = rules.length
	while i
		i-=1
		rules[i].status=0
	endWhile
	
	
	letsWait=0
EndFunction

string[] Property scenesDescription Auto


; -)) -------------------------- EVENTS Management --------------------------


; ((- -------------------------- RULES --------------------------

SSX_Rule_Alias[] Property rules Auto
int Property rulesNum auto
Faction[] Property rulesAskFactions Auto

String Function getPositionShortName(SSX_Rule_Alias r, int pos)
	int i
	String res=""
	if r.isNobody(pos)
		return s("$SSX_ShortNobody")
	elseIf r.isPlayer(pos)
		return s("$SSX_ShortPlayer")
	elseIf r.isGeneric(pos) || r.isGenericWPl(pos)
		String races
		; Check the position modes
		i = r.getPosVal(pos)
		if i==21
			res = s("$SSX_ShortMHFol")
		elseIf i==22
			res = s("$SSX_ShortFHFol")
		elseIf i==23
			res = s("$SSX_ShortHFol")
		elseIf i==25
			res = s("$SSX_ShortMHNFol")
		elseIf i==26
			res = s("$SSX_ShortFHNFol")
		elseIf i==27
			res = s("$SSX_ShortHNFol")
		elseIf i==29
			res = s("$SSX_ShortMH")
		elseIf i==30
			res = s("$SSX_ShortFH")
		elseIf i==31
			res = s("$SSX_ShortH")
		elseIf i==37
			res = s("$SSX_ShortMCFol")
		elseIf i==38
			res = s("$SSX_ShortFCFol")
		elseIf i==39
			res = s("$SSX_ShortCFol")
		elseIf i==41
			res = s("$SSX_ShortMCNFol")
		elseIf i==42
			res = s("$SSX_ShortFCNFol")
		elseIf i==43
			res = s("$SSX_ShortCNFol")
		elseIf i==45
			races = r.getRaceFilter(pos)
			if races!=""
				res = s("$SSX_ShortMC") + ": " + races
			else
				res = s("$SSX_ShortMC")
			endIf
		elseIf i==46
			races = r.getRaceFilter(pos)
			if races!=""
				res = s("$SSX_ShortFC") +": " + races
			else
				res = s("$SSX_ShortFC")
			endIf
		elseIf i==47
			races = r.getRaceFilter(pos)
			if races!=""
				res = races
			else
				res = s("$SSX_ShortC")
			endIf
		elseIf i==52
			res = s("$SSX_ShortMFol")
		elseIf i==53
			res = s("$SSX_ShortMFol")
		elseIf i==54
			res = s("$SSX_ShortFFol")
		elseIf i==55
			res = s("$SSX_ShortFol")
		elseIf i==57
			res = s("$SSX_ShortMNFol")
		elseIf i==58
			res = s("$SSX_ShortFNFol")
		elseIf i==59
			res = s("$SSX_ShortNFol")
		elseIf i==61
			res = s("$SSX_ShortM")
		elseIf i==62
			res = s("$SSX_ShortF")
		elseIf i==63
			res = s("$SSX_ShortEverybody")
		endIf
		if res!=""
			if r.isGenericWPl(pos)
				return res + s("$SSX_ShortWPl")
			endIf
			return res
		endIf
		return "ERROR i==" + i
	elseIf r.isRelationship1(pos) || r.isRelationship2(pos)
		return s("$SSX_ShortRelationship")
	elseIf r.isSpecific(pos)
		return s("$SSX_ShortSpecific")
	elseIf r.isFaction(pos)
		return s("$SSX_ShortFaction")
	elseIf r.isSameRace(pos)
		return s("$SSX_ShortSameRace")
	endIf
	return "Something wrong"
EndFunction
; first 6 bits are used for Sex, Fellowship, Humanity, then the remaining bits are used as integer defining the type
; 1	Male ; 2	Female ; 4	Human ; 8	Creature ; 16 Follower ; 32 Not Follower
; sex/fell/hum: 1=10=Male/Follower/Human, 2=01=Female/NotFoll/Creature, 0/3=11=Both
; Type: 0=Nobody, 1=player, 2=Generic NPC, 3=Generic and Player, 4=Specific NPC, 5=In relationship with 1st, 6=In relationship with 2nd, 7=In factions, 8=Same creature

String Function getPositionLongName(SSX_Rule_Alias r, int pos)
	int i
	String res=""
	if r.isNobody(pos)
		return s("$SSX_Nobody")
	elseIf r.isPlayer(pos)
		if r.isPosNotInvolved(pos)
			return s("$SSX_Player") + " (Not involved)"
		endIf
		return s("$SSX_Player")
	elseIf r.isGeneric(pos)
		res+=s("$SSX_TypeGeneric")
	elseIf r.isGenericWPl(pos)
		res+=s("$SSX_TypeGeneric") + s("$SSX_ShortWPl")
	elseIf r.isSpecific(pos)
		res+=s("$SSX_TypeSpecific")
	elseIf r.isRelationship(pos)
		res+=s("$SSX_TypeRelationship")
	elseIf r.isFaction(pos)
		res+=s("$SSX_TypeFaction")
	elseIf r.isSameRace(pos)
		res+=s("$SSX_TypeSameRace")
	endIf

	if !r.isSpecific(pos) && !r.isSameRace(pos)
		; Add sex, hum, fell, in case required (generic=always required)
		i = r.getSex(pos)
		if i==1
			res+=" " + s("$SSX_Male")
		elseIf i==2
			res+=" " + s("$SSX_Female")
		elseIf i==3 && r.isGeneric(pos)
			res+=" " + s("$SSX_BothMF")
		endIf
		i = r.getHumanity(pos)
		if i==1
			res+=" " + s("$SSX_Human")
		elseIf i==2
			res+=" " + s("$SSX_Creature")
		elseIf i==3 && r.isGeneric(pos)
			res+=" " + s("$SSX_BothHC")
		endIf
		i = r.getFellowship(pos)
		if i==1
			res+=" " + s("$SSX_Follower")
		elseIf i==2
			res+=" " + s("$SSX_NonFollower")
		elseIf i==3
			res+=" " + s("$SSX_BothFN")
		endIf
	endIf
	
	if r.isSpecific(pos)
		res+=" " + r.getSpecificActorNames(pos, onlyFirstWithDots=false)
	endIf
	if r.isRelationship1(pos)
		if pos==0
			res+=" " + s("$SSX_InRelationshipWithSrcAs")
		elseIf pos==1 || pos==2
			res+=" " + s("$SSX_InRelationshipWithDstAs")
		endIf
	endIf
	if r.isRelationship2(pos)
		if pos==0 || pos==1
			res+=" " + s("$SSX_InRelationshipWithCollAs")
		elseIf pos==2
			res+=" " + s("$SSX_InRelationshipWithSrcAs")
		endIf
	endIf
	if r.isRelationship(pos)
		string[] parts = StringUtil.split(r.getIDs(pos), ";")
		i=0
		while i<parts.length
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if f
				pos = associations.find(f as AssociationType)
				if pos!=-1
					res+=associationNames[pos]
				endIf
			endIf
			if i+1<parts.length
				res+=", "
			endIf
			i+=1
		endWhile
	endIf
	if r.isFaction(pos)
		res+=" Factions: "
		string[] parts = StringUtil.split(r.getIDs(pos), ";")
		i=0
		while i<parts.length
			Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if f
				res+=getNameAndEditorID(f as Faction)
			endIf
			if i+1<parts.length
				res+=", "
			endIf
			i+=1
		endWhile
	endIf
	
	; Race filters?
	String races = r.getRaceFilter(pos)
	if races!=""
		res+=" Races: "
		if r.getRaceMode(pos)==0
			if StringUtil.find(races, ",")!=-1
				res+= "at least one of " + races
			else
				res+=races
			endIf
		else
			if StringUtil.find(races, ",")!=-1
				res+= "not one of these " + races
			else
				res+= "not " + races
			endIf
		endIf
	endIf
	
	if r.isPosNotInvolved(pos)
		res+=" (Not involved)"
	endIf
	return res
EndFunction

String Function getPositionValues(SSX_Rule_Alias r, int pos)
	int i
	String res=""
	String tmp
	string[] parts
	Form f
	if r.isSpecific(pos)
		res=r.getSpecificActorNames(pos, onlyFirstWithDots=false)
	elseIf r.isRelationship(pos)
		parts = StringUtil.split(r.getIDs(pos), ";")
		i=0
		while i<parts.length
			f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if f
				pos = associations.find(f as AssociationType)
				if pos!=-1
					res+=associationNames[pos]+", "
				endIf
			endIf
			i+=1
		endWhile
		if StringUtil.getLength(res)>2
			return StringUtil.subString(res, 0, StringUtil.getLength(res) - 2)
		endIf
	elseIf r.isFaction(pos)
		parts = StringUtil.split(r.getIDs(pos), ";")
		i=0
		while i<parts.length
			f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
			if f
				tmp = getNameAndEditorID(f as Faction)
				if tmp!=""
					res+=tmp + ", "
				endIf
			endIf
			i+=1
		endWhile
		if StringUtil.getLength(res)>2
			return StringUtil.subString(res, 0, StringUtil.getLength(res) - 2)
		endIf
	endIf
	return res
EndFunction



; Returs the absolute index of the rule that is used inside the evets as parameter, this because SSX_Rule_Alias extends RefAlias, and RefAlias does NOT extend Form
int Function getRuleIndex(SSX_Rule_Alias r)
	int i = rules.length
	while i
		i-=1
		if rules[i]==r
			return i
		endIf
	endWhile
	return -1
EndFunction

SSX_Rule_Alias Function getRuleByIndex(int index)
	if index<0 || index>rules.length
		return None
	endIf
	return rules[index] as SSX_Rule_Alias
EndFunction

int function countRules(bool bothEnabledAndDisabled = false)
	rulesNum = 0
	int i = rules.length
	while i
		i -= 1
		SSX_Rule_Alias r = rules[i]
		if (!bothEnabledAndDisabled && r.inUse==2) || (bothEnabledAndDisabled && r.inUse!=0)
			rulesNum += 1
		endIf
	endWhile
	return rulesNum
EndFunction

int Function countRulesWithPlayer()
	{Check that there is at least one rule involving the player}
	int numWithPlayer = 0
	int i = rules.length
	while i
		i -= 1
		SSX_Rule_Alias r = rules[i]
		if r.isPlayerInvolved() && r.inUse==1
			numWithPlayer += 1
		endIf
	endWhile
	return numWithPlayer
EndFunction

int Function countRulesStartedByPlayer()
	int numWithPlayer = 0
	int i = rules.length
	while i
		i -= 1
		SSX_Rule_Alias r = rules[i]
		if r.inUse==2 && r.startsOn==2
			numWithPlayer += 1
		endIf
	endWhile
	return numWithPlayer
EndFunction

String[] Property ruleNames Auto

Function generateRuleNames(String id)
	{Fill an array with all the active rules, exluded this one}
	int num=0
	int i = rules.length
	while i
		i-=1
		SSX_Rule_Alias r = rules[i]
		if r.inUse==2 && r.id!=id
			num+=1
		endIf
	endWhile
	if num==0
		ruleNames = CreateStringArray(1)
		ruleNames[0] = s("$SSX_NoRules")
	else
		ruleNames = CreateStringArray(num)
		i = rules.length
		num=0
		while i
			i-=1
			SSX_Rule_Alias r = rules[i]
			if r.inUse==2 && r.id!=id
				ruleNames[num] = r.name
				num+=1
			endIf
		endWhile
	endIf
EndFunction

int Function getRuleIndexById(String id)
	int i = rules.length
	while i
		i-=1
		SSX_Rule_Alias r = rules[i]
		if r.inUse==2 && r.id==id
			return ruleNames.find(r.name)
		endIf
	endWhile
	return 0
EndFunction

int Function getRuleIdByIndex(int index)
	return getRuleByName(ruleNames[index]).id
EndFunction


SSX_Rule_Alias Function getRuleById(String id)
	int i = rules.length
	while i
		i-=1
		SSX_Rule_Alias r = rules[i]
		if r.inUse==2 && r.id==id
			return r
		endIf
	endWhile
	return None
EndFunction

SSX_Rule_Alias Function getRuleByName(String name)
	int i = rules.length
	while i
		i-=1
		SSX_Rule_Alias r = rules[i]
		if r.inUse==2 && r.name==name
			return r
		endIf
	endWhile
	return None
EndFunction

Function setRule(String file, bool singleRule, int i, SSX_Rule_Alias r)
	String section=""
	if !singleRule
		section=".rules["+i+"]"
	endIf

	JSONUtil.SetPathIntValue(file, section+".id", r.id)
	JSONUtil.SetPathStringValue(file, section+".name", r.name)
	JSONUtil.SetPathStringValue(file, section+".author", r.author)
	JSONUtil.SetPathStringValue(file, section+".description", r.description)
	JSONUtil.SetPathIntValue(file, section+".inUse", r.inUse)
	JSONUtil.SetPathIntValue(file, section+".version", getVersion())
	; Participants
	JSONUtil.SetPathIntValue(file, section+".participants.dst", r.dst)
	JSONUtil.SetPathStringValue(file, section+".participants.dstIDs", r.dstIDs)
	JSONUtil.SetPathStringValue(file, section+".participants.dstRaces", r.dstRaces)
	JSONUtil.SetPathStringValue(file, section+".participants.dstMods", r.dstMods)
	JSONUtil.SetPathIntValue(file, section+".participants.src", r.src)
	JSONUtil.SetPathStringValue(file, section+".participants.srcIDs", r.srcIDs)
	JSONUtil.SetPathStringValue(file, section+".participants.srcRaces", r.srcRaces)
	JSONUtil.SetPathStringValue(file, section+".participants.srcMods", r.srcMods)
	JSONUtil.SetPathIntValue(file, section+".participants.coll", r.coll)
	JSONUtil.SetPathStringValue(file, section+".participants.collIDs", r.collIDs)
	JSONUtil.SetPathStringValue(file, section+".participants.collRaces", r.collRaces)
	JSONUtil.SetPathStringValue(file, section+".participants.collMods", r.collMods)
	JSONUtil.SetPathIntValue(file, section+".participants.raceMode", r.raceMode)
	JSONUtil.SetPathStringValue(file, section+".participants.dstNegFactIDs", r.dstNegFactIDs)
	JSONUtil.SetPathStringValue(file, section+".participants.srcNegFactIDs", r.srcNegFactIDs)
	JSONUtil.SetPathStringValue(file, section+".participants.collNegFactIDs", r.collNegFactIDs)
	JSONUtil.SetPathIntValue(file, section+".participants.partsProp", r.partsProp)
	JSONUtil.SetPathIntValue(file, section+".participants.passiveIs", r.passiveIs)
	; Clothing
	JSONUtil.SetPathIntValue(file, section+".clothing.stripping", r.stripping)
	JSONUtil.SetPathStringValue(file, section+".clothing.wearAtStartDst", r.wearAtStartDst)
	JSONUtil.SetPathStringValue(file, section+".clothing.wearAtStartSrc", r.wearAtStartSrc)
	JSONUtil.SetPathStringValue(file, section+".clothing.wearAtStartColl", r.wearAtStartColl)
	JSONUtil.SetPathStringValue(file, section+".clothing.wearAtEndDst", r.wearAtEndDst)
	JSONUtil.SetPathStringValue(file, section+".clothing.wearAtEndSrc", r.wearAtEndSrc)
	JSONUtil.SetPathStringValue(file, section+".clothing.wearAtEndColl", r.wearAtEndColl)
	; Anims and Tags
	JSONUtil.SetPathStringValue(file, section+".animsAndTags.tags", r.tags)
	JSONUtil.SetPathStringValue(file, section+".animsAndTags.avoid", r.avoid)
	JSONUtil.SetPathStringValue(file, section+".animsAndTags.tagsA", r.tagsA)
	JSONUtil.SetPathStringValue(file, section+".animsAndTags.avoidA", r.avoidA)
	JSONUtil.SetPathStringValue(file, section+".animsAndTags.specificAnimIDs", r.specificAnimIDs)
	JSONUtil.SetPathStringValue(file, section+".animsAndTags.specificAnimAIDs", r.specificAnimAIDs)
	JSONUtil.SetPathIntValue(file, section+".animsAndTags.andOrForTags", r.andOrForTags)
	JSONUtil.SetPathIntValue(file, section+".animsAndTags.addGenderTags", r.addGenderTags)
	; Properties
	JSONUtil.SetPathFloatValue(file, section+".properties.timeBeforeReDo", r.timeBeforeReDo)
	JSONUtil.SetPathIntValue(file, section+".properties.probability", r.probability)
	JSONUtil.SetPathIntValue(file, section+".properties.beds", r.beds)
	JSONUtil.SetPathIntValue(file, section+".properties.stopAllCombats", r.stopAllCombats)
	JSONUtil.SetPathIntValue(file, section+".properties.scaleActors", r.scaleActors)
	JSONUtil.SetPathIntValue(file, section+".properties.enableOrgies", r.enableOrgies)
	; Interactions
	JSONUtil.SetPathIntValue(file, section+".interactions.aggressive", r.aggressive)
	JSONUtil.SetPathIntValue(file, section+".interactions.askingSex", r.askingSex)
	JSONUtil.SetPathIntValue(file, section+".interactions.dialogues", r.dialogues)
	; Starting and Filters
	JSONUtil.SetPathIntValue(file, section+".starting.startsOn", r.startsOn)
	JSONUtil.SetPathIntValue(file, section+".starting.filter1", r.filter1)
	JSONUtil.SetPathIntValue(file, section+".starting.filter2", r.filter2)
	JSONUtil.SetPathIntValue(file, section+".starting.filter3", r.filter3)
	JSONUtil.SetPathIntValue(file, section+".starting.timeFilter", r.timeFilter)
	JSONUtil.SetPathIntValue(file, section+".starting.arousalLevel", r.arousalLevel)
	JSONUtil.SetPathIntValue(file, section+".starting.healthLevel", r.healthLevel)
	JSONUtil.SetPathIntValue(file, section+".starting.staminaLevel", r.staminaLevel)
	JSONUtil.SetPathIntValue(file, section+".starting.magickaLevel", r.magickaLevel)
	JSONUtil.SetPathStringValue(file, section+".starting.hasToWearDst", r.hasToWearDst)
	JSONUtil.SetPathStringValue(file, section+".starting.notToWearDst", r.notToWearDst)
	JSONUtil.SetPathStringValue(file, section+".starting.hasToWearSrc", r.hasToWearSrc)
	JSONUtil.SetPathStringValue(file, section+".starting.notToWearSrc", r.notToWearSrc)
	JSONUtil.SetPathStringValue(file, section+".starting.hasToWearColl", r.hasToWearColl)
	JSONUtil.SetPathStringValue(file, section+".starting.notToWearColl", r.notToWearColl)
	JSONUtil.SetPathIntValue(file, section+".starting.interiorExterior", r.interiorExterior)
	JSONUtil.SetPathStringValue(file, section+".starting.locations", r.locations)
	JSONUtil.SetPathStringValue(file, section+".starting.cells", r.cells)
	JSONUtil.SetPathStringValue(file, section+".starting.locationTypes", r.locationTypes)
	JSONUtil.SetPathIntValue(file, section+".starting.prevRule", r.prevRule)
	; Highlight
	JSONUtil.SetPathIntValue(file, section+".highlight", r.highLights)
EndFunction

Function getRule(String file, bool singleRule, int i, SSX_Rule_Alias r, SSX_MCM_Quest mcm)
	String section=""
	if !singleRule
		section=".rules["+i+"]"
	endIf

	int version  = JSONUtil.GetPathIntValue(file, section+".version", 0)
	if version<10300
		log("Rule " + JSONUtil.GetPathStringValue(file, section+".name", s("$SSX_noname")) + " is way too old and cannot be imported", notifErrors())
		r.init(JSONUtil.GetPathStringValue(file, section+".name", s("$SSX_noname")))
		return
	endIf
	r.id = JSONUtil.GetPathIntValue(file, section+".id", -1)
	if r.id==-1
		r.id=Utility.RandomInt(1, 65535)
	endIf
	r.name = 						JSONUtil.GetPathStringValue(file, section+".name", s("$SSX_noname"))
	r.author = 					JSONUtil.GetPathStringValue(file, section+".author", "")
	r.description = 		JSONUtil.GetPathStringValue(file, section+".description", "")
	r.inUse = 					JSONUtil.GetPathIntValue(file, section+".inUse", 0)
	; Participants
	r.dst = 						JSONUtil.GetPathIntValue(file, section+".participants.dst", 0)
	r.dstIDs = 					JSONUtil.GetPathStringValue(file, section+".participants.dstIDs", "")
	r.dstRaces = 				JSONUtil.GetPathStringValue(file, section+".participants.dstRaces", "")
	r.dstMods = 				JSONUtil.GetPathStringValue(file, section+".participants.dstMods", "")
	r.src = 						JSONUtil.GetPathIntValue(file, section+".participants.src", 0)
	r.srcIDs = 					JSONUtil.GetPathStringValue(file, section+".participants.srcIDs", "")
	r.srcRaces = 				JSONUtil.GetPathStringValue(file, section+".participants.srcRaces", "")
	r.srcMods = 				JSONUtil.GetPathStringValue(file, section+".participants.srcMods", "")
	r.coll = 						JSONUtil.GetPathIntValue(file, section+".participants.coll", 0)
	r.collIDs = 				JSONUtil.GetPathStringValue(file, section+".participants.collIDs", "")
	r.collRaces = 			JSONUtil.GetPathStringValue(file, section+".participants.collRaces", "")
	r.collMods = 				JSONUtil.GetPathStringValue(file, section+".participants.collMods", "")
	r.raceMode =  			JSONUtil.GetPathIntValue(file, section+".participants.raceMode", 0)
	r.dstNegFactIDs =  	JSONUtil.GetPathStringValue(file, section+".participants.dstNegFactIDs", "")
	r.srcNegFactIDs =  	JSONUtil.GetPathStringValue(file, section+".participants.srcNegFactIDs", "")
	r.collNegFactIDs =  JSONUtil.GetPathStringValue(file, section+".participants.collNegFactIDs", "")
	r.partsProp = 			JSONUtil.GetPathIntValue(file, section+".participants.partsProp", 1)
	r.passiveIs = 			JSONUtil.GetPathIntValue(file, section+".participants.passiveIs", 0)
	; Clothing
	r.stripping = 			JSONUtil.GetPathIntValue(file, section+".clothing.stripping", 0)
	r.wearAtStartDst = 	JSONUtil.GetPathStringValue(file, section+".clothing.wearAtStartDst", "")
	r.wearAtStartSrc = 	JSONUtil.GetPathStringValue(file, section+".clothing.wearAtStartSrc", "")
	r.wearAtStartColl = JSONUtil.GetPathStringValue(file, section+".clothing.wearAtStartColl", "")
	r.wearAtEndDst = 		JSONUtil.GetPathStringValue(file, section+".clothing.wearAtEndDst", "")
	r.wearAtEndSrc = 		JSONUtil.GetPathStringValue(file, section+".clothing.wearAtEndSrc", "")
	r.wearAtEndColl = 	JSONUtil.GetPathStringValue(file, section+".clothing.wearAtEndColl", "")
	; Anims and Tags
	r.tags = 						JSONUtil.GetPathStringValue(file, section+".animsAndTags.tags", "")
	r.avoid = 					JSONUtil.GetPathStringValue(file, section+".animsAndTags.avoid", "")
	r.tagsA = 					JSONUtil.GetPathStringValue(file, section+".animsAndTags.tagsA", "")
	r.avoidA = 					JSONUtil.GetPathStringValue(file, section+".animsAndTags.avoidA", "")
	r.specificAnimIDs = JSONUtil.GetPathStringValue(file, section+".animsAndTags.specificAnimIDs", "")
	r.specificAnimAIDs = JSONUtil.GetPathStringValue(file, section+".animsAndTags.specificAnimAIDs", "")
	r.andOrForTags = 		JSONUtil.GetPathIntValue(file, section+".animsAndTags.andOrForTags", 0)
	r.addGenderTags = 	JSONUtil.GetPathIntValue(file, section+".animsAndTags.addGenderTags", 0)
	; Properties
	r.timeBeforeReDo = 	JSONUtil.GetPathFloatValue(file, section+".properties.timeBeforeReDo", 0.0)
	r.probability = 		JSONUtil.GetPathIntValue(file, section+".properties.probability", 1)
	r.beds = 						JSONUtil.GetPathIntValue(file, section+".properties.beds", 0)
	r.stopAllCombats = 	JSONUtil.GetPathIntValue(file, section+".properties.stopAllCombats", 0)
	r.scaleActors = 		JSONUtil.GetPathIntValue(file, section+".properties.scaleActors", 0)
	r.enableOrgies = 		JSONUtil.GetPathIntValue(file, section+".properties.enableOrgies", 0)
	; Interactions
	r.aggressive = 			JSONUtil.GetPathIntValue(file, section+".interactions.aggressive", 0)
	r.askingSex = 			JSONUtil.GetPathIntValue(file, section+".interactions.askingSex", 0)
	r.dialogues = 			JSONUtil.GetPathIntValue(file, section+".interactions.dialogues", 0)
	; Starting and Filters
	r.startsOn = 				JSONUtil.GetPathIntValue(file, section+".starting.startsOn", 0)
	r.filter1 = 				JSONUtil.GetPathIntValue(file, section+".starting.filter1", 0)
	r.filter2 = 				JSONUtil.GetPathIntValue(file, section+".starting.filter2", 0)
	r.filter3 = 				JSONUtil.GetPathIntValue(file, section+".starting.filter3", 0)
	r.timeFilter =			JSONUtil.GetPathIntValue(file, section+".starting.timeFilter", -1)
	r.arousalLevel = 		JSONUtil.GetPathIntValue(file, section+".starting.arousalLevel", -1)
	r.healthLevel = 		JSONUtil.GetPathIntValue(file, section+".starting.healthLevel", -1)
	r.staminaLevel = 		JSONUtil.GetPathIntValue(file, section+".starting.staminaLevel", -1)
	r.magickaLevel = 		JSONUtil.GetPathIntValue(file, section+".starting.magickaLevel", -1)
	r.hasToWearDst = 		JSONUtil.GetPathStringValue(file, section+".starting.hasToWearDst", "")
	r.notToWearDst = 		JSONUtil.GetPathStringValue(file, section+".starting.notToWearDst", "")
	r.hasToWearSrc = 		JSONUtil.GetPathStringValue(file, section+".starting.hasToWearSrc", "")
	r.notToWearSrc = 		JSONUtil.GetPathStringValue(file, section+".starting.notToWearSrc", "")
	r.hasToWearColl = 	JSONUtil.GetPathStringValue(file, section+".starting.hasToWearColl", "")
	r.notToWearColl = 	JSONUtil.GetPathStringValue(file, section+".starting.notToWearColl", "")
	r.interiorExterior =	JSONUtil.GetPathIntValue(file, section+".starting.interiorExterior", 0)
	r.locations = 			JSONUtil.GetPathStringValue(file, section+".starting.locations", "")
	r.cells = 					JSONUtil.GetPathStringValue(file, section+".starting.cells", "")
	r.locationTypes = 	JSONUtil.GetPathStringValue(file, section+".starting.locationTypes", "")
	r.prevRule = 				JSONUtil.GetPathIntValue(file, section+".starting.prevRule", 0)
	; Highlight
	r.highLights =			JSONUtil.GetPathIntValue(file, section+".highlight", 0)

	; Covert beds if they are from a previous version before 1.4d
	; Conversion: 0->0, 1->2, 2->6, 3->8, 4->1, 5->3, 6->4, 7->9
	if version<10404
		if r.beds==0
			r.beds=0
		elseIf r.beds==1
			r.beds=2
		elseIf r.beds==2
			r.beds=6
		elseIf r.beds==3
			r.beds=8
		elseIf r.beds==4
			r.beds=1
		elseIf r.beds==5
			r.beds=3
		elseIf r.beds==6
			r.beds=4
		elseIf r.beds==7
			r.beds=9
		endIf 
	endIf
	
	if r.inUse!=0
		checkRuleIDs(r, mcm)
		r.generateLocations()
		r.generateClothes()
	endIf
EndFunction

Function checkRuleIDs(SSX_Rule_Alias r, SSX_MCM_Quest mcm)
	{Check the rule IDs}
	String res
	bool somethingWrong=false
	String whatIsWrong=""
	if r.dstIDs!=""
		res = doCleanIDs(r, "Target Specific Actors", r.dstIDs, mcm)
		if res!=""
			somethingWrong = true
			r.dstIDs=res
			whatIsWrong="Target Specific Actors\n"
		endIf
	endIf
	if r.srcIDs!=""
		res = doCleanIDs(r, "Source Specific Actors", r.srcIDs, mcm)
		if res!=""
			somethingWrong = true
			r.srcIDs=res
			whatIsWrong+="Problem: Source Specific Actors\n"
		endIf
	endIf
	if r.collIDs!=""
		res = doCleanIDs(r, "Collaborator Specific Actors", r.collIDs, mcm)
		if res!=""
			somethingWrong = true
			r.collIDs=res
			whatIsWrong+="Problem: Collaborator Specific Actors\n"
		endIf
	endIf
	if r.hasToWearDst!=""
		res = doCleanIDs(r, "Target Has to Wear", r.hasToWearDst, mcm)
		if res!=""
			somethingWrong = true
			r.hasToWearDst=res
			whatIsWrong+="Problem: Target Has to Wear\n"
		endIf
	endIf
	if r.hasToWearSrc!=""
		res = doCleanIDs(r, "Source Has to Wear", r.hasToWearSrc, mcm)
		if res!=""
			somethingWrong = true
			r.hasToWearSrc=res
		whatIsWrong+="Problem: Source Has to Wear\n"
		endIf
	endIf
	if r.hasToWearColl!=""
		r.hasToWearColl = doCleanIDs(r, "Collaborator Has to Wear", r.hasToWearColl, mcm)
		if res!=""
			somethingWrong = true
			r.hasToWearColl=res
			whatIsWrong+="Problem: Collaborator Has to Wear\n"
		endIf
	endIf
	if r.notToWearDst!=""
		res = doCleanIDs(r, "Target Not to Wear", r.notToWearDst, mcm)
		if res!=""
			somethingWrong = true
			r.notToWearDst=res
			whatIsWrong+="Problem: Target Not to Wear\n"
		endIf
	endIf
	if r.notToWearSrc!=""
		r.notToWearSrc = doCleanIDs(r, "Source Not to Wear", r.notToWearSrc, mcm)
		if res!=""
			somethingWrong = true
			r.notToWearSrc=res
			whatIsWrong+="Problem: Source Not to Wear\n"
		endIf
	endIf
	if r.notToWearColl!=""
		res = doCleanIDs(r, "Collaborator Not to Wear", r.notToWearColl, mcm)
		if res!=""
			somethingWrong = true
			r.notToWearColl=res
			whatIsWrong+="Problem: Collaborator Not to Wear\n"
		endIf
	endIf
	if r.locations!=""
		res = doCleanIDs(r, "Locations", r.locations, mcm)
		if res!=""
			somethingWrong = true
			r.locations=res
			whatIsWrong+="Problem: Locations\n"
		endIf
	endIf
	if r.cells!=""
		res = doCleanIDs(r, "Cells", r.cells, mcm)
		if res!=""
			somethingWrong = true
			r.cells=res
			whatIsWrong+="Problem: Cells\n"
		endIf
	endIf
	if r.specificAnimIDs!=""
		res = doCleanAnimIDs(r, "Anim IDs", r.specificAnimIDs, mcm)
		if res!=""
			somethingWrong = true
			r.specificAnimIDs=res
			whatIsWrong+="Problem: Anim IDs\n"
		endIf
	endIf
	if r.specificAnimAIDs!=""
		res = doCleanAnimIDs(r, "Aggressive Anim IDs", r.specificAnimAIDs, mcm)
		if res!=""
			somethingWrong = true
			r.specificAnimAIDs=res
			whatIsWrong+="Problem: Aggressive Anim IDs\n"
		endIf
	endIf

	if !mcm && somethingWrong
		debug.messagebox("--- Scent of Sex WARNING ---\nThe rule: " + r.name + "\nhas problems with some of the IDs inside.\nPlease check the rules in the MCM to fix them.\n" + whatIsWrong)
	endIf	
EndFunction


String Function doCleanIDs(SSX_Rule_Alias r, String type, String val, SSX_MCM_Quest mcm)
	int doCleaning=0
	String[] parts=StringUtil.split(val, ";")
	int i = parts.length
	while i
		i-=1
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if !f && doCleaning==0
			if mcm && mcm.showMessage("Some of the IDs of " + type + " for " + r.name + " are not valid.\nDo you want to remove them?", true, "Yes", "No")
				parts[i]=""
				doCleaning=1
			else
				doCleaning=2
			endIf
		endIf
	endWhile
	String res=""
	if doCleaning!=0
		i = 0
		while i<parts.length
			if parts[i]!=""
				res+=parts[i]+";"
			endIf
			i+=1
		endWhile
		if res!=""
			res=StringUtil.subString(res, 0, StringUtil.getLength(res) - 1)
		endIf
	endIf
	return res
EndFunction

String Function doCleanAnimIDs(SSX_Rule_Alias r, String type, String val, SSX_MCM_Quest mcm)
	int doCleaning=0
	String[] parts=StringUtil.split(val, ";")
	int i = parts.length
	while i
		i-=1
		sslBaseAnimation a = SexLab.GetAnimationByRegistry(parts[i])
		if !a
			a = SexLab.GetCreatureAnimationByRegistry(parts[i])
		endIf
		if !a && doCleaning==0
			if mcm && mcm.showMessage("Some of " + type + " for\n" + r.name + "\nare not valid.\n"+parts[i]+"\nDo you want to remove them?", true, "Yes", "No")
				parts[i]=""
				doCleaning=1
			else
				doCleaning=2
			endIf
		endIf
	endWhile
	String res=""
	if doCleaning!=0
		i = 0
		while i<parts.length
			if parts[i]!=""
				res+=parts[i]+";"
			endIf
			i+=1
		endWhile
		if res!=""
			res=StringUtil.subString(res, 0, StringUtil.getLength(res) - 1)
		endIf
	endIf
	return res
EndFunction

Function updateAllNeededActors()
	{Check all conditions by searching the rules, update the array of all valid races}
	needP = 0
	needH = 0
	needC = 0
	needM = 0
	needF = 0
	needN = 0
	needW = 0
	int i = rules.length
	while i
		i-=1
		SSX_Rule_Alias r = rules[i]
		if r.inUse==2
			int pos=3
			while pos
				pos-=1
				if r.isPlayer(pos)
					needP = 1
				elseIf r.isSpecific(pos)
					String[] parts = StringUtil.split(r.getIDs(pos), ";")
					int j=parts.length
					while j
						j-=1
						Actor a = PO3_SKSEFunctions.GetFormFromEditorID(parts[j]) as Actor
						if a
							if isMale(a)
								needM=1
							else
								needF=1
							endIf
							if isFollower(a)
								needF=1
							else
								needN=1
							endIf
							if isCreature(a) && SexLab.AllowCreatures && !nexusMode
								needC=1
							endIf
							if isHuman(a)
								needH=1
							endIf
						endIf
					endWhile
				elseIf !r.isNobody(pos)
					if r.isHuman(pos)
						needH=1
					endIf
					if r.isCreature(pos) && SexLab.AllowCreatures && !nexusMode
						needC=1
					endIf
					if r.isMale(pos)
						needM=1
					endIf
					if r.isFemale(pos)
						needF=1
					endIf
					if r.isFollower(pos)
						needW=1
					endIf
					if r.isNotFollower(pos)
						needN=1
					endIf
					if r.isGenericWPl(pos)
						needP = 1
					endIf
				endIf
			endWhile
		endIf
	endWhile
EndFunction

Function sortRules()
	String[] names = CreateStringArray(rules.length)
	int i = rules.length
	while i
		i-=1
		if rules[i].inUse !=0
			names[i] = rules[i].name
		else
			names[i] = "ÿÿÿÿÿÿ"
		endIf
	endWhile
	PapyrusUtil.SortStringArray(names)
	; Now reorder the rules by the sorted names
	i = 0
	while i<names.length
		int j = 0
		while j<rules.length
			if rules[j].name==names[i]
				if i!=j
					SSX_Rule_Alias tmp = rules[i]
					rules[i] = rules[j]
					rules[j] = tmp
				endIf
			endIf
			j+=1
		endWhile
		i+=1
	endWhile
	i=names.length
	while i<rules.length
		names[i] = ""
		i+=1
	endWhile
EndFunction

; -))


; ((- --------------------------- SUPPORT Functions --------------------------

; Type: 0=Male Human (M), 1=Female Human (F), 2=Male Creature (S), 3=Female Creature (B)
int Function getSexBitsForType(int type)
	if type==0 ; M
		return Math.LogicalAnd(0xF, orientationMode)
	elseIf type==1 ; F
		return Math.LogicalAnd(0xF, Math.RightShift(orientationMode, 4))
	elseIf type==2 ; S = Male Creature
		return Math.LogicalAnd(0xF, Math.RightShift(orientationMode, 8))
	elseIf type==3 ; B = Female Creature
		return Math.LogicalAnd(0xF, Math.RightShift(orientationMode, 12))
	endIf
	return 0 ; Should not happen
endFunction

int Function setSexBitsForType(int type, int sexes)
	if type==0 ; M
		return Math.LogicalAnd(0xFFF0, orientationMode) + sexes
	elseIf type==1 ; F
		return Math.LogicalAnd(0xFF0F, orientationMode) + Math.LeftShift(sexes, 4)
	elseIf type==2 ; S = Male Creature
		return Math.LogicalAnd(0xF0FF, orientationMode) + Math.LeftShift(sexes, 8)
	elseIf type==3 ; B = Female Creature
		return Math.LogicalAnd(0x0FFF, orientationMode) + Math.LeftShift(sexes, 12)
	endIf
	return 0 ; Should not happen
endFunction






int Function getArousalLevel(Actor a)
	if !a || slaf==None
		return 0
	endIf
	return slaf.GetActorArousal(a)
EndFunction

Bool Function isPlayerNaked()
	return isActorNaked(PlayerRef)
EndFunction

Bool Function isActorNaked(Actor a)
	float rating = 0.0
	rating += getNakedRating(a, 1) ; head
	rating += getNakedRating(a, 2) ; body
	rating += getNakedRating(a, 3) ; hands
	rating += getNakedRating(a, 4) ; forearms
	rating += getNakedRating(a, 7) ; feet
	rating += getNakedRating(a, 8) ; calves
	rating += getNakedRating(a, 22) ; pelvis
	return (rating <= nakedMinLevel)
EndFunction

String Function calculateNudityCheck(Actor a)
	String res = s("$SSX_NudityCheckCalculation", a.getDisplayName())
	res += calculateNudityRating(a, 1) + ", " ; head
	res += calculateNudityRating(a, 2) + ", " ; body
	res += calculateNudityRating(a, 3) + ",\n" ; hands
	res += calculateNudityRating(a, 4) + ", " ; forearms
	res += calculateNudityRating(a, 7) + ", " ; feet
	res += calculateNudityRating(a, 8) + ", " ; calves
	res += calculateNudityRating(a, 22) + "\n" ; pelvis
	float rating = 0.0
	rating += getNakedRating(a, 1) ; head
	rating += getNakedRating(a, 2) ; body
	rating += getNakedRating(a, 3) ; hands
	rating += getNakedRating(a, 4) ; forearms
	rating += getNakedRating(a, 7) ; feet
	rating += getNakedRating(a, 8) ; calves
	rating += getNakedRating(a, 22) ; pelvis
	res += s("$SSX_FinalRating", rating as int, nakedMinLevel as int)
	if rating <= nakedMinLevel
		res += s("$SSX_NakedIfIsNaked")
	else
		res += s("$SSX_NakedIfNotNaked")
	endIf
	return res
EndFunction

Float Function getNakedRating(Actor a, int bodyPart)
	Armor piece = a.GetWornForm(Armor.GetMaskForSlot(30 + bodyPart)) as Armor
	; Check first the armor filters (never nude, always nude)
	if piece && piece.getname()!=""
		; First check if the piece is in the nakedList
		String id = PO3_SKSEFunctions.GetFormEditorID(piece)
		if nudeArmorsIDs.find(id)!=-1
			return 0.0 ; Nude because specific item
		endIf
		; Then check if it has naked keywords
		int i = armorKeywordConsideredNaked.length
		while i
			i-=1
			if armorKeywordConsideredNaked[i]!=0
				if piece.HasKeyword(armorKeywords[i] As Keyword)
					return 0.0
				endIf
			endIf
		endWhile
	
		if bodyPart==1 ; head
			if nakedHead==0
				return 1500.0
			elseIf nakedHead==1
				return 0.0
			endIf
		elseIf bodyPart==2 ; body
			if nakedBody==0
				return 1500.0
			elseIf nakedBody==1
				return 0.0
			endIf
		elseIf bodyPart==3 ; hands
			if nakedHands==0
				return 1500.0
			elseIf nakedHands==1
				return 0.0
			endIf
		elseIf bodyPart==4 ; forearms
			if nakedForearms==0
				return 1500.0
			elseIf nakedForearms==1
				return 0.0
			endIf
		elseIf bodyPart==7 ; feet
			if nakedFeet==0
				return 1500.0
			elseIf nakedFeet==1
				return 0.0
			endIf
		elseIf bodyPart==8 ; calves
			if nakedCalves==0
				return 1500.0
			elseIf nakedCalves==1
				return 0.0
			endIf
		elseIf bodyPart==22 ; pelvis
			if nakedPelvis==0
				return 1500.0
			elseIf nakedPelvis==1
				return 0.0
			endIf
		endIf
	else
		return 0.0
	endIf
	; Normal calculation for the other items
	return piece.GetArmorRating()
EndFunction

String Function calculateNudityRating(Actor a, int bodyPart)
	float rating = 0.0
	String res
	Armor piece = a.GetWornForm(Armor.GetMaskForSlot(30 + bodyPart)) as Armor
	if !piece || piece.getname()==""
		return s("$SSX_NothingHere", bodyParts[bodyPart])
	endIf
	if nudeArmorsIDs.find(PO3_SKSEFunctions.GetFormEditorID(piece))!=-1
		return s("$SSX_InNakedList", bodyParts[bodyPart]) + "(" + piece.getName() + ")"
	endIf
	; Check if the piece has one of the keywords
	int i = armorKeywordConsideredNaked.length
	while i
		i-=1
		if armorKeywordConsideredNaked[i]!=0
			if piece.HasKeyword(armorKeywords[i] as Keyword)
				return s("$SSX_InNakedKeywords", bodyParts[bodyPart]) + "(" + piece.getName() + ")"
			endIf
		endIf
	endWhile
	
	; Check the specific parts
	int valToCheck = -1
	if bodyPart==1 ; head
		valToCheck = nakedHead
	elseIf bodyPart==2 ; body
		valToCheck = nakedBody
	elseIf bodyPart==3 ; hands
		valToCheck = nakedHands
	elseIf bodyPart==4 ; forearms
		valToCheck = nakedForearms
	elseIf bodyPart==7 ; feet
		valToCheck = nakedFeet
	elseIf bodyPart==8 ; calves
		valToCheck = nakedCalves
	elseIf bodyPart==22 ; pelvis
		valToCheck = nakedPelvis
	endIf
	if valToCheck==0
		return s("$SSX_NeverNaked", bodyParts[bodyPart]) + "(" + piece.getName() + ")"
	elseIf valToCheck==1
		return s("$SSX_AlwaysNaked", bodyParts[bodyPart]) + "(" + piece.getName() + ")"
	elseIf valToCheck==2
		return s("$SSX_RatingOf", bodyParts[bodyPart], piece.GetArmorRating()) + "(" + piece.getName() + ")"
	endIf
	return "UNKNOWN=" + bodyPart
EndFunction

; Calculates the names, besed from IDs of the items that the participant should wear
String Function calculateWearablesNames(String tmpWearables, String noneName)
	if tmpWearables==""
		return noneName
	endIf
	String[] parts = StringUtil.split(tmpWearables, ";")
	String res = ""
	int i = 0
	while i < parts.length
		Form f = PO3_SKSEFunctions.GetFormFromEditorID(parts[i])
		if f
			String name = f.getName()
			if name==""
				; EditorID
				res+=parts[i]
			else
				res+=name
			endIf
		endIf
		i += 1
		if i>2
			return res + "..."
			i = parts.length
		else
			res += " "
		endIf
	endWhile
	return res
EndFunction

; returns true if the clothes are good
bool Function checkClothes(SSX_Rule_Alias r, Actor a, int pos)
	bool htw = r.hasItemsToWear(pos)
	bool ntw = r.hasItemsNotToWear(pos)
	bool goodHTW = !htw
	bool goodNTW = true
	int i
	Armor[] armors
	Keyword[] keywords
	
	if htw
		armors = r.getItemsToWear(pos)
		i = armors.length
		while i
			i-=1
			Armor f = armors[i]
			if f && a.IsEquipped(f)
				goodHTW=true
				i=0
			endIf
		endWhile
		if !goodHTW
			keywords = r.getKWToWear(pos)
			i = keywords.length
			while i
				i-=1
				Keyword f = keywords[i]
				if f && a.WornHasKeyword(f)
					goodHTW=true
					i=0
				endIf
			endWhile
		endIf
	endIf
	if ntw && goodHTW
		armors = r.getItemsNotToWear(pos)
		i = armors.length
		while i
			i-=1
			Armor f = armors[i]
			if f && a.IsEquipped(f)
				goodNTW=false
				i=0
			endIf
		endWhile
		if goodNTW
			keywords = r.getKWNotToWear(pos)
			i = keywords.length
			while i
				i-=1
				Keyword f = keywords[i]
				if f && a.WornHasKeyword(f)
					goodNTW=false
					i=0
				endIf
			endWhile
		endIf
	endIf
	
	return goodHTW && goodNTW
endFunction

bool Function OLD_checkClothes(SSX_Rule_Alias r, Actor a, int pos) ; FIXME
	bool htw = r.hasItemsToWear(pos)
	bool ntw = r.hasItemsNotToWear(pos)
	bool goodHTW = !htw
	bool goodNTW = !ntw
	int i
	Armor[] armors
	Keyword[] keywords
	
	if htw
		armors = r.getItemsToWear(pos)
		i = armors.length
		while i
			i-=1
			Armor f = armors[i]
			if f && a.IsEquipped(f)
				goodHTW=true
				i=0
			endIf
		endWhile
		if !goodHTW
			keywords = r.getKWToWear(pos)
			i = keywords.length
			while i
				i-=1
				Keyword f = keywords[i]
				if f && a.WornHasKeyword(f)
					goodHTW=true
					i=0
				endIf
			endWhile
		endIf
	endIf
	if ntw
		armors = r.getItemsNotToWear(pos)
		i = armors.length
		while i
			i-=1
			Armor f = armors[i]
			if f && a.IsEquipped(f)
				goodNTW=false
				i=0
			endIf
		endWhile
		if goodNTW
			keywords = r.getKWNotToWear(pos)
			i = keywords.length
			while i
				i-=1
				Keyword f = keywords[i]
				if f && a.WornHasKeyword(f)
					goodNTW=false
					i=0
				endIf
			endWhile
		endIf
	endIf
	
	return goodHTW && goodNTW
endFunction

bool Function OLDcheckClothes(SSX_Rule_Alias r, Actor a, int pos)
	bool htw = r.hasItemsToWear(pos)
	bool ntw = r.hasItemsNotToWear(pos)
	bool goodHTW = !htw
	bool goodNTW = !ntw
	
	int i=32
	while i
		i-=1
		Armor piece = a.GetWornForm(Armor.GetMaskForSlot(30 + i)) as Armor
		if piece
			if htw && !goodHTW
				if r.isInHasToWear(pos, piece)
					goodHTW=true
				endIf
			endIf
			if ntw && goodNTW
				if r.isInNotToWear(pos, piece)
					goodNTW=false
				endIf
			endIf
		endIf
	endWhile

	return goodHTW && goodNTW
endFunction

String Function s(String txt, String p1="!@#$", String p2="!@#$", String p3="!@#$")
	int cache = translationCache.find(txt)
	String res
	if cache==-1
		res = JSONUtil.GetStringValue(translationsPath, txt, missing = "MISSING TRANSLATION FOR " + txt)
		if StringUtil.Find(res, "MISSING TRANSLATION")!=-1
			if currentGameTranslation!="English"
				; Try English
				res = JSONUtil.GetStringValue(configFolder + "translations\\english.json", txt, missing = "MISSING TRANSLATION FOR " + txt)
				if StringUtil.Find(res, "MISSING TRANSLATION")!=-1
					debug.trace("[SSX] MISSING TRANSLATION:  " + txt + "  ------------------------------------------------------------------------------------------------")
					int empty = translationCache.find("")
					if empty != -1
						translationCache[empty] = txt
						translationValue[empty] = "???"
					endIf
				endIf
			else
				debug.trace("[SSX] MISSING TRANSLATION:  " + txt + "  ------------------------------------------------------------------------------------------------")
				int empty = translationCache.find("")
				if empty != -1
					translationCache[empty] = txt
					translationValue[empty] = "???"
				endIf
			endIf
		endIf
		; Add the string to the value
		int empty = translationCache.find("")
		if empty == -1
			; Expand the cache
			empty = translationCache.length
			translationCache = ResizeStringArray(translationCache, empty + 64, "")
			translationValue = ResizeStringArray(translationValue, empty + 64, "")
		endIf
		translationCache[empty] = txt
		translationValue[empty] = res
	else
		res = translationValue[cache]
	endIf
	if p1!="!@#$"
		int pos = StringUtil.Find(res, "%s1")
		if pos!=-1
			if pos==0
				res = p1 + StringUtil.Substring(res, 3)
			else
				res = StringUtil.Substring(res, 0, pos) + p1 + StringUtil.Substring(res, pos + 3)
			endIf
			if p2!="!@#$"
				pos = StringUtil.Find(res, "%s2")
				if pos!=-1
					if pos==0
						res = p2 + StringUtil.Substring(res, pos + 3)
					else
						res = StringUtil.Substring(res, 0, pos) + p2 + StringUtil.Substring(res, pos + 3)
					endIf
					if p3!="!@#$"
						pos = StringUtil.Find(res, "%s3")
						if pos!=-1
							if pos==0
								res = p3 + StringUtil.Substring(res, pos + 3)
							else
								res = StringUtil.Substring(res, 0, pos) + p3 + StringUtil.Substring(res, pos + 3)
							endIf
						endIf
					endIf
				endIf
			endIf
		endIf
	endIf
	return res
EndFunction

function log(String msg, int type)
	if StringUtil.find(msg, "SkyUI")!=-1
		debug.tracestack("[SSX] SkyUI message sent!")
	endIf

	if type==notifMsgBox()
		debug.MessageBox("Scent of Sex - Warning!\n" + msg)
		debug.trace("[SSX] " + msg)
	else
		if type<10
			if type%2==0
				if getDebug(type)
					debug.notification("[SSX] " + msg)
				endIf
				if getDebug(type+1)
					debug.trace("[SSX] " + msg)
				endIf
			else
				if getDebug(type)
					debug.trace("[SSX] " + msg)
				endIf
			endIf
		else
			if getDebug(type)
				debug.trace("[SSX] " + msg)
			endIf
		endIf
	endIf
endFunction


function hlg(Actor a, int color, int from)
	if !a || color<1 || !a.Is3DLoaded() || !a.getParentCell() || !a.getParentCell().IsAttached()
		return
	endIf
	
	if from==highlightScan() && !getHighlight(highlightScan())
		return
	elseIf from==highlightAsk() && !getHighlight(highlightAsk())
		return
	elseIf from==highlightClean() && !getHighlight(highlightClean())
		return
	elseIf from==highlightPotential() && !getHighlight(highlightPotential())
		return
	elseIf from==highlightScene() && !getHighlight(highlightScene())
		return
	elseIf from==highlightValid() && !getHighlight(highlightValid())
		return
	endIf
	highlightColors[color - 1].cast(a, a)
endFunction


int Function getFactionGroupColor(int group)
	return Math.RightShift(Math.LogicalAnd(factionSpells, Math.LeftShift(15, (group - 1)*4 + 1)), (group - 1)*4 + 1)
endFunction

function setFactionGroupColor(int group, int val)
	factionSpells = Math.LogicalAnd(factionSpells, (0xFFFFFFFF - Math.LeftShift(15, (group - 1)*4 + 1)))
	factionSpells = Math.LogicalOr(factionSpells, Math.LeftShift(val, (group - 1)*4 + 1))
endFunction

bool Function getDebug(int val) ; Gets the bit of the item, as boolean
	return Math.RightShift(Math.LogicalAnd(notifications, Math.LeftShift(1, val)), val)==1
endFunction

Function changeDebug(int val) ; Switches the bit of the specific item
	if Math.RightShift(Math.LogicalAnd(notifications, Math.LeftShift(1, val)), val)==1
		; Clean
		notifications = Math.LogicalAnd(notifications, 0x7FFFFFFF - Math.LeftShift(1, val))
	else
		; Set
		notifications = Math.LogicalOr(notifications, Math.LeftShift(1, val))
	endIf
endFunction

Function setDebug(int val, bool mode) ; Changes the bit of the specific item
	if mode
		notifications = Math.LogicalOr(notifications, Math.LeftShift(1, val))
	else
		notifications = Math.LogicalAnd(notifications, 0x7FFFFFFF - Math.LeftShift(1, val))
	endIf
endFunction

int function notifActivationN() global
	return 0
endFunction
int function notifActivationT() global
	return 1
endFunction
int function notifWhatIsGoingOnN() global
	return 2
endFunction
int function notifWhatIsGoingOnT() global
	return 3
endFunction
int function notifActorsInScanN() global
	return 4
endFunction
int function notifActorsInScanT() global
	return 5
endFunction
int function notifRulePlayedN() global
	return 6
endFunction
int function notifRulePlayedT() global
	return 7
endFunction
int function notifAnimPlayedN() global
	return 8
endFunction
int function notifAnimPlayedT() global
	return 9
endFunction
int function notifDontBotherOnSLENFix() global
	return 10
endFunction
int function notifDontBotherOnDefeatFix() global
	return 11
endFunction
int function notifMsgBox() global
	return 12
endFunction

int function notifTimeToComplete() global
	return 13 ; time to complete actions
endFunction
int function notifWarnings() global
	return 14 ; warnings
endFunction
int function notifErrors() global
	return 15 ; errors
endFunction
int function notifCombats() global
	return 16 ; combats
endFunction
int function notifRelationship() global
	return 17 ; relationship
endFunction
int function notifCheckerDetails() global
	return 18 ; detailed activity of rule checker
endFunction
int function notifPlayerDetails() global
	return 19 ; detailed activity of rule player
endFunction
int function notifScanDetails() global
	return 20 ; detailed activity of rule player
endFunction
int function notifSceneManDetails() global
	return 21 ; detailed activity of scene manager
endFunction
int function notifCleanDetails() global
	return 22 ; detailed activity of cleaner
endFunction
int function notifDeferredDetails() global
	return 23 ; detailed activity of deferred loaders
endFunction
int function notifBadRule() global
	return 24 ; bad rule explanation
endFunction
int function notifActorsFoundLong() global
	return 25 ; actors found in the scan (long)
endFunction
int function notifNotGoodActors() global
	return 26 ; Actor bad for rule (long)
endFunction
int function notifActorForRule() global
	return 27 ; Actor good for rule
endFunction
int function notifCatchers() global
	return 28 ; actions of catchers
endFunction
int function notifAnimsScan() global
	return 29 ; actions of catchers
endFunction

int Function getMFSB(Actor a)
	if !a
		return -1
	endIf
	int sex = calculateSex(a)
	if isCreature(a)
		return 2+sex
	endIf
	return sex
endFunction

int Function calculateSex(Actor a)
	if !a
		return -1
	endIf
	if genderMode==0
		return a.getLeveledActorBase().getSex()
	endIf
	int s = SexLab.getGender(a)
	; TODO: not sure what to do with CF.GetGender (it doesn't exist anymore)
	; if s > 1 && CF
	; 	return CF.GetGender(a) - 1
	; else
	; 	return Math.LogicalAnd(s, 1)
	; endIf
	return Math.LogicalAnd(s, 1)
EndFunction

String Function getNameAndEditorID(Form f) global
	String name = f.getName()
	String editorID = PO3_SKSEFunctions.GetFormEditorID(f)
	if name==""
		return editorID
	elseIf name
		return name + " | " + editorID
	else
		return ""
	endIf
EndFunction

String Function getNegativeFactionNames(SSX_Rule_Alias r, int pos)
	String negFactIDs=r.getNegativeFactions(pos)
	if negFactIDs==""
		return "None defined"
	endIf
	String[] facts = StringUtil.split(negFactIDs, ";")
	String res=""
	int i=0
	while i<facts.length
		Faction f = PO3_SKSEFunctions.GetFormFromEditorID(facts[i]) as Faction
		if f
			res+=getNameAndEditorID(f)
			if i<facts.length - 1
				res+="; "
			endIf
		endIf
		i+=1
	endWhile
	return res
EndFunction

; -))

; ((- ----------------- Animation and Tags ----------------------------------

String[] Property allTags Auto
int Property numTags Auto

String[] Property globalSexTags Auto
String[] Property globalSexTagsL Auto

bool Function isAnimEnabled(String id)
	return JSONUtil.GetPathIntValue(configFile, ".anims." + id, 1)==1
EndFunction

Function enableAnim(String id, bool enabled)
	if enabled
		JSONUtil.SetPathIntValue(configFile, ".anims." + id, 1)
	else
		JSONUtil.SetPathIntValue(configFile, ".anims." + id, 0)
	endIf	
EndFunction

int Function generateGenderTagsActors(String[] orig, int addGenderTags, Actor[] actors, bool doItLazy)
{Returns numParticipants}
; actors: the actual list of actors to consider
; addGenderTags: 0=Add strict tags, 1=Add lazy tags, 2=try strict but then try again in lazy mode, 3=don't add them
	int numParticipants = 0
	int numGTags=0

	int i = 0
	while i<actors.length
		bool addM = false
		bool addF = false
		bool addC = false
		Actor a = actors[i]
		if a
			if addGenderTags==0 || addGenderTags==2 ; Strict or two steps
				if isCreature(a)
					addC = true
				else
					if useSLSexuality==1
						int sexuality = SexLab.GetSexuality(a)
						if sexuality>65 ; Straight
							if calculateSex(a)==0
								addM=true
							else
								addM=true
								addF=true
							endIf
						else
							addM=true
							addF=true
						endIf
					else
						if calculateSex(a)==0
							addM=true
						else
							addF=true
						endIf
					endIf
				endIf
			elseIf addGenderTags==1 || doItLazy ; Lazy
				if isCreature(a)
					addC=true
				else
					addM=true
					addF=true
				endIf
			else ; Don't add... but increase the numParticipants
				numParticipants+=1
			endIf

			; Now add for real the gender tags
			if addM && !addF && !addC
				if numParticipants==0
					orig[numGTags] = "M"
					numGTags=1
				else
					; Add M to all the previous
					int j=numGTags
					while j
						j-=1
						orig[j] = orig[j] + "M"
					endWhile
				endIf
				numParticipants+=1
			elseIf !addM && addF && !addC
				if numParticipants==0
					orig[numGTags] = "F"
					numGTags=1
				else
					; Add M to all the previous
					int j=numGTags
					while j
						j-=1
						orig[j] = orig[j] + "F"
					endWhile
				endIf
				numParticipants+=1
			elseIf addM && addF && !addC
				if numParticipants==0
					orig[0] = "M"
					orig[1] = "F"
					numGTags=2
				else
					; Duplicate tags and add to one set M and one set C
					int j=numGTags
					while j
						j-=1
						orig[j + numGTags] = orig[j] + "M"
						orig[j] = orig[j] + "F"
					endWhile
					numGTags *= 2
				endIf
				numParticipants+=1
			elseIf !addM && !addF && addC
				if numParticipants==0
					orig[numGTags] = "C"
					numGTags=1
				else
					; Add C to all the previous
					int j=numGTags
					while j
						j-=1
						orig[j] = orig[j] + "C"
					endWhile
				endIf
				numParticipants+=1
			elseIf addM && !addF && addC
				if numParticipants==0
					orig[0] = "M"
					orig[1] = "C"
					numGTags=2
				else
					; Duplicate tags and add to one set M and one set C
					int j=numGTags
					while j
						j-=1
						orig[j + numGTags] = orig[j] + "M"
						orig[j] = orig[j] + "C"
					endWhile
					numGTags *= 2
				endIf
				numParticipants+=1
			elseIf !addM && addF && addC
				if numParticipants==0
					orig[0] = "C"
					orig[1] = "F"
					numGTags=2
				else
					; Duplicate tags and add to one set M and one set C
					int j=numGTags
					while j
						j-=1
						orig[j + numGTags] = orig[j] + "C"
						orig[j] = orig[j] + "F"
					endWhile
					numGTags *= 2
				endIf
				numParticipants+=1
			elseIf addM && addF && addC
				if numParticipants==0
					orig[0] = "M"
					orig[1] = "F"
					orig[3] = "C"
					numGTags=3
				else
					; Duplicate tags and add to one set M and one set C
					int j=numGTags
					while j
						j-=1
						orig[j + 2 * numGTags] = orig[j] + "M"
						orig[j + numGTags] = orig[j] + "F"
						orig[j] = orig[j] + "C"
					endWhile
					numGTags *= 3
				endIf
				numParticipants+=1
			endIf
		endIf
		
		i+=1
	endWhile

	
	if addGenderTags==2 && !doItLazy
		numParticipants = generateGenderTagsActors(orig, 2, actors, true) ; Retry in lazy mode
	else
		; Clean the remaining
		while numGTags < orig.length
			orig[numGTags]=""
			numGTags+=1
		endWhile
	endIf
	
	return numParticipants
EndFunction

int Function generateGenderTagsInts(String[] orig, int addGenderTags, int[] actorsSex, bool doItLazy)
{Returns numParticipants}
; actorSex: 0=pos not used, 1=Human Male, 2=Human Female, 3=Humans, 4=Creature Male, 5=Creature Female, 6=Creatures
; addGenderTags: 0=Add strict tags, 1=Add lazy tags, 2=try strict but then try again in lazy mode, 3=don't add them
	int numParticipants = 0
	int numGTags=0
	int i = 0
	while i<actorsSex.length
		bool addM = false
		bool addF = false
		bool addC = false
		int so = -1;
		if i==0
			so=getSexBitsForType(1)
		elseIf i==1
			so=getSexBitsForType(0)
		else
			so=0
		endIf
		if actorsSex[i]==1 ; M
			if (addGenderTags==0 || (addGenderTags==2 && !doItLazy)) && Math.LogicalAnd(so, 2)==2
				addM = true
			else
				addM = true
				addF = true
			endIf
			
		elseIf actorsSex[i]==2 ; F
			if (addGenderTags==0 || (addGenderTags==2 && !doItLazy)) && Math.LogicalAnd(so, 1)==1
				addF = true
			else
				addM = true
				addF = true
			endIf
		
		elseIf actorsSex[i]==3 ; MF
			addM = true
			addF = true
		
		elseIf actorsSex[i]==4 ; MC
			if (addGenderTags==0 || (addGenderTags==2 && !doItLazy)) && Math.LogicalAnd(so, 2)==2
				addM = true
			else
				addM = true
				addF = true
			endIf
			addC = true
		
		elseIf actorsSex[i]==5 ; FC
			if (addGenderTags==0 || (addGenderTags==2 && !doItLazy)) && Math.LogicalAnd(so, 1)==1
			else
				addM = true
				addF = true
			endIf
			addC = true
		
		elseIf actorsSex[i]==6 ; MFC
			addM = true
			addF = true
			addC = true

		elseIf actorsSex[i]==-1 ; Not valid
			numGTags = orig.length
			while numGTags
				numGTags-=1
				orig[numGTags]=""
			endWhile
			return 0 ; Stop right away
		endIf
		
		; Now add for real the gender tags, but split creatures and non creatures
		if !addC
			if addM && !addF
				if numParticipants==0
					orig[numGTags] = "M"
					numGTags=1
				else
					; Add M to all the previous
					int j=numGTags
					while j
						j-=1
						orig[j] = orig[j] + "M"
					endWhile
				endIf
				numParticipants+=1
			elseIf !addM && addF
				if numParticipants==0
					orig[numGTags] = "F"
					numGTags=1
				else
					; Add F to all the previous
					int j=numGTags
					while j
						j-=1
						orig[j] = orig[j] + "F"
					endWhile
				endIf
				numParticipants+=1
			elseIf addM && addF
				if numParticipants==0
					orig[0] = "M"
					orig[1] = "F"
					numGTags=2
				else
					; Duplicate tags and add to one set M and one set C
					int j=numGTags
					while j
						j-=1
						orig[j + numGTags] = orig[j] + "M"
						orig[j] = orig[j] + "F"
					endWhile
					numGTags *= 2
				endIf
				numParticipants+=1
			endIf
		else
			if numParticipants==0
				orig[numGTags] = "C"
				numGTags=1
			else
				; Add C to all the previous
				int j=numGTags
				while j
					j-=1
					orig[j] = orig[j] + "C"
				endWhile
			endIf
			numParticipants+=1
		endIf
		i+=1
	endWhile

	; Clean the remaining
	while numGTags < orig.length
		orig[numGTags]=""
		numGTags+=1
	endWhile
	
	return numParticipants
EndFunction


sslBaseAnimation[] Function getAnims(Actor[] actors, SSX_Rule_Alias r, bool aggressive, String[] raceFilters=None)
	int numParticipants = generateGenderTagsActors(globalSexTags, r.genderTagMode(aggressive), actors, false)
	; Get the actual anims using the other function
	sslBaseAnimation[] anims = getActualAnims(numParticipants, globalSexTags, r, aggressive, raceFilters)
	
	; Maybe re-get the anims using a different gender tags mode
	if (!anims || anims.length==0) && r.genderTagMode(aggressive)==2
		numParticipants = generateGenderTagsActors(globalSexTags, r.genderTagMode(aggressive), actors, true)
		anims = getActualAnims(numParticipants, globalSexTags, r, aggressive, raceFilters)
	endIf

	return anims
EndFunction

; This function is called when the actors are not available, so their type is got from the rule definition
sslBaseAnimation[] Function getAnimsByType(SSX_Rule_Alias r, bool aggressive, String[] raceFilters=None)
	{Check for humanity and creatures}
	if (aggressive && r.specificAnimIDs!="") || (!aggressive && (r.specificAnimIDs!="" || r.specificAnimAIDs!=""))
		return getSpecificAnims(r, aggressive)
	endIf
	
	int[] actorsSex = new int[5] ; Each value will follow the MFSB schema
	actorsSex = r.fillActorsSexArray(actorsSex, calculateSex(PlayerRef), orientationMode, aggressive)
	int numParticipants = generateGenderTagsInts(globalSexTags, r.genderTagMode(aggressive), actorsSex, false)
	; Get the actual anims using the other function
	sslBaseAnimation[] anims = getActualAnims(numParticipants, globalSexTags, r, aggressive, raceFilters)
	
	return anims
EndFunction

sslBaseAnimation[] Function getActualAnims(int numParticipants, String[] genderTags, SSX_Rule_Alias r, bool aggressive, String[] raceFilters=None)
	{Find how many gender tags we have to consider}
	int numGenderTags = genderTags.find("")
	if numGenderTags==-1
		numGenderTags = genderTags.length
	endIf
	bool allTagsReq = !r.allTagsRequired(aggressive)
	String cOkTags
	String cKoTags
	bool andOr 
	; In case of aggressive grab the anims using the aggressive settings, in case they are not defined, get the normal settings, but add the aggressive tag
	if aggressive
		cOkTags = r.tagsA
		cKoTags = r.avoidA
		if cOkTags=="" && cKoTags==""
			cOkTags = r.tags
			cKoTags = r.avoid
		endIf
	else
		cOkTags = r.tags
		cKoTags = r.avoid
	endIf

	String tmpTags
	if cOkTags==""
		allTagsReq=true
	endIf
	if r.aggressiveTagReqired()==2 && !aggressive
		; Be sure we add aggressive in the KO tags
		if StringUtil.find(cKoTags, "Aggressive")==-1
			if cKoTags==""
				cKoTags="Aggressive"
			else
				cKoTags+=",Aggressive"
			endIf
		endIf
	endIf
	
	; Understand what to do for searching the tags (we may need to do multiple searches and split the tags), start by cycling on all possible gendertags
	sslBaseAnimation[] resAnims
	sslBaseAnimation[] anims
	int gt = numGenderTags
	bool withC = false
	while gt
		gt-=1
		String gTags = genderTags[gt]
		if StringUtil.find(gTags, "C")==-1 ; Humans
			if allTagsReq ; AND mode
			
				if r.aggressiveTagReqired()==1 && aggressive; Add for aggressive
					if StringUtil.find(cOkTags, "Aggressive")==-1
						if cOkTags==""
							cOkTags="Aggressive"
						else
							cOkTags+=",Aggressive"
						endIf
					endIf
				elseIf r.aggressiveTagReqired()==2 ; Add for aggressive and remove for consensual
					if aggressive
						if StringUtil.find(cOkTags, "Aggressive")==-1
							if cOkTags==""
								cOkTags="Aggressive"
							else
								cOkTags+=",Aggressive"
							endIf
						endIf
					else
						if StringUtil.find(cOkTags, "Aggressive")!=-1
							int pa = StringUtil.find(cOkTags, ",Aggressive")
							if pa!=-1
								cOkTags=StringUtil.subString(cOkTags, 0, pa - 1) + StringUtil.subString(cOkTags, pa + 10)
							else
								pa = StringUtil.find(cOkTags, "Aggressive,")
								if pa!=-1
									cOkTags=StringUtil.subString(cOkTags, pa + 10)
								elseIf cOkTags=="Aggressive"
									cOkTags=""
								endIf
							endIf
						endIf
					endIf
				endIf
			
				if StringUtil.find(cOkTags, gTags)==-1
					if cOkTags==""
						tmpTags = gTags
					else
						tmpTags = cOkTags + "," + gTags
					endIf
				else
					tmpTags = cOkTags
				endIf
				anims = SexLab.getAnimationsByTags(numParticipants, tmpTags, TagSuppress=cKoTags, RequireAll=true)
				if anims && anims.length>0
					resAnims = MergeAnimLists(resAnims, anims)
				endIf
			
			else ; OR mode
				String[] subTags=StringUtil.split(cOkTags, ",") ; Not Aggressive
				int st = subTags.length
				while st
					st -= 1
					tmpTags = subTags[st]
					if StringUtil.find(tmpTags, gTags)==-1
						if tmpTags==""
							tmpTags = gTags
						else
							tmpTags = tmpTags + "," + gTags
						endIf
					endIf
					
					; Check if we have to add the aggressive tags
					if r.aggressiveTagReqired()==1 && aggressive; Add for aggressive
						if StringUtil.find(tmpTags, "Aggressive")==-1
							if tmpTags==""
								tmpTags="Aggressive"
							else
								tmpTags+=",Aggressive"
							endIf
						endIf
					elseIf r.aggressiveTagReqired()==2 ; Add for aggressive and remove for consensual
						if aggressive
							if StringUtil.find(tmpTags, "Aggressive")==-1
								if tmpTags==""
									tmpTags="Aggressive"
								else
									tmpTags+=",Aggressive"
								endIf
							endIf
						else
							if StringUtil.find(tmpTags, "Aggressive")!=-1
								int pa = StringUtil.find(tmpTags, ",Aggressive")
								if pa!=-1
									tmpTags=StringUtil.subString(tmpTags, 0, pa - 1) + StringUtil.subString(tmpTags, pa + 10)
								else
									pa = StringUtil.find(tmpTags, "Aggressive,")
									if pa!=-1
										tmpTags=StringUtil.subString(tmpTags, pa + 10)
									elseIf tmpTags=="Aggressive"
										tmpTags=""
									endIf
								endIf
							endIf
						endIf
					endIf
					anims = SexLab.getAnimationsByTags(numParticipants, tmpTags, TagSuppress=cKoTags, RequireAll=true)
					if anims && anims.length>0
						resAnims = MergeAnimLists(resAnims, anims)
					endIf
				endWhile
				
			endIf
			
		else ; Creatures
			withC = true
			
			if allTagsReq ; AND mode
				if StringUtil.find(cOkTags, gTags)==-1
					if cOkTags==""
						tmpTags = gTags
					else
						tmpTags = cOkTags + "," + gTags
					endIf
				else
					tmpTags = cOkTags
				endIf
				
				; We may have a racefilter, with a set of possible race, or we may be in case of a multi creature animation (the rule knows it)
				if r.isMultiCreatures()
					; OK, this can be tricky
					; Find the anims using all racekeys, then filter the anims that respect the specific positions
					int rf = raceFilters.length
					while rf
						rf -= 1
						if raceFilters[rf]=="Chart Horses" || raceFilters[rf]=="ChartHorses" || raceFilters[rf]=="Chart Horse" || raceFilters[rf]=="ChartHorse" || raceFilters[rf]=="CartHorses" || raceFilters[rf]=="CartHorse"
							raceFilters[rf]="Horses"
						endIf

						if raceFilters[rf]!="" && isRaceEnabled(raceFilters[rf])
							if tmpTags!="" || cKoTags!=""
								anims = SexLab.GetCreatureAnimationsByRaceKeyTags(numParticipants, raceFilters[rf], tmpTags, TagSuppress=cKoTags, RequireAll=true)
							else
								anims = SexLab.GetCreatureAnimationsByRaceKey(numParticipants, raceFilters[rf])
							endIf
							if anims && anims.length>0
								; Now filter the anims based on all racetypes for each position
								int ta = anims.length
								while ta
									ta-=1
									if anims[ta] && !testRacesForPositions(anims[ta], r)
										anims[ta]=none
									endIf
								endWhile
								resAnims = MergeAnimLists(resAnims, anims)
							endIf
						endIf
					endWhile
				
				else ; Single race
					bool b = false
					int rf = raceFilters.length
					while rf
						rf -= 1
						if raceFilters[rf] != ""
							b = true
							rf = 0
						endIf
					endWhile
					if b
						rf = raceFilters.length
						while rf
							rf -= 1
							if raceFilters[rf]=="Chart Horses" || raceFilters[rf]=="ChartHorses" || raceFilters[rf]=="Chart Horse" || raceFilters[rf]=="ChartHorse" || raceFilters[rf]=="CartHorses" || raceFilters[rf]=="CartHorse"
								raceFilters[rf]="Horses"
							endIf

							if raceFilters[rf]!="" && isRaceEnabled(raceFilters[rf])
								if tmpTags!="" || cKoTags!=""
									anims = SexLab.GetCreatureAnimationsByRaceKeyTags(numParticipants, raceFilters[rf], tmpTags, TagSuppress=cKoTags, RequireAll=true)
								else
									anims = SexLab.GetCreatureAnimationsByRaceKey(numParticipants, raceFilters[rf])
								endIf
								if anims && anims.length>0
									resAnims = MergeAnimLists(resAnims, anims)
								endIf
							endIf
						endWhile
					else ; No race filters (we still need to filter by races enabled)
						rf = numAllRacesC
						while rf
							rf-=1
							if allRacesCEnabled[rf]
								if tmpTags!="" || cKoTags!=""
									anims = SexLab.GetCreatureAnimationsByRaceKeyTags(numParticipants, allRacesC[rf], tmpTags, TagSuppress=cKoTags, RequireAll=true)
								else
									anims = SexLab.GetCreatureAnimationsByRaceKey(numParticipants, allRacesC[rf])
								endIf
								if anims && anims.length>0
									resAnims = MergeAnimLists(resAnims, anims)
								endIf
							endIf
						endWhile
					endIf
				endif
				
				
				
			else ; OR mode
			
				String[] subTags=StringUtil.split(cOkTags, ",") ; Not Aggressive
				int st = subTags.length
				while st
					st -= 1
					String partialTag = subTags[st]
					if StringUtil.find(partialTag, gTags)==-1
						if cOkTags==""
							tmpTags = gTags
						else
							tmpTags = partialTag + "," + gTags
						endIf
					else
						tmpTags = partialTag
					endIf
					
					; We may have a racefilter, with a set of possible race, or we may be in case of a multi creature animation (the rule knows it)
					if r.isMultiCreatures()
						; OK, this can be tricky
						; Find the anims using all racekeys, then filter the anims that respect the specific positions
						
						bool b = false
						int rf = raceFilters.length
						if rf > 0 && rf < 6
							while rf > 0
								rf -= 1
								if raceFilters[rf] != ""
									b = true
									rf = 0
								endIf
							endWhile
						endIf
					
						if b
							rf = raceFilters.length
							while rf
								rf -= 1
								if raceFilters[rf]=="Chart Horses" || raceFilters[rf]=="ChartHorses" || raceFilters[rf]=="Chart Horse" || raceFilters[rf]=="ChartHorse" || raceFilters[rf]=="CartHorses" || raceFilters[rf]=="CartHorse"
									raceFilters[rf]="Horses"
								endIf

								if raceFilters[rf]!="" && isRaceEnabled(raceFilters[rf])
									if tmpTags!="" || cKoTags!=""
										anims = SexLab.GetCreatureAnimationsByRaceKeyTags(numParticipants, raceFilters[rf], tmpTags, TagSuppress=cKoTags, RequireAll=true)
									else
										anims = SexLab.GetCreatureAnimationsByRaceKey(numParticipants, raceFilters[rf])
									endIf
									if anims && anims.length>0
										; Now filter the anims based on all racetypes for each position
										int ta = anims.length
										while ta
											ta-=1
											if anims[ta] && !testRacesForPositions(anims[ta], r)
												anims[ta]=none
											endIf
										endWhile
										resAnims = MergeAnimLists(resAnims, anims)
									endIf
								endIf
							endWhile
							
						else ; No race filters (we still need to filter by races enabled)
							rf = numAllRacesC
							while rf
								rf-=1
								if allRacesCEnabled[rf]
									if tmpTags!="" || cKoTags!=""
										anims = SexLab.GetCreatureAnimationsByRaceKeyTags(numParticipants, allRacesC[rf], tmpTags, TagSuppress=cKoTags, RequireAll=true)
									else
										anims = SexLab.GetCreatureAnimationsByRaceKey(numParticipants, allRacesC[rf])
									endIf
									if anims && anims.length>0
										resAnims = MergeAnimLists(resAnims, anims)
									endIf
								endIf
							endWhile
						endIf
					
					else ; Single creature
						bool b = false
						int rf = raceFilters.length
						if rf > 0 && rf < 6
							while rf > 0
								rf -= 1
								if raceFilters[rf] != ""
									b = true
									rf = 0
								endIf
							endWhile
						endIf
						if b
							rf = raceFilters.length
							while rf
								rf -= 1
								if raceFilters[rf]=="Chart Horses" || raceFilters[rf]=="ChartHorses" || raceFilters[rf]=="Chart Horse" || raceFilters[rf]=="ChartHorse" || raceFilters[rf]=="CartHorses" || raceFilters[rf]=="CartHorse"
									raceFilters[rf]="Horses"
								endIf

								if raceFilters[rf]!="" && isRaceEnabled(raceFilters[rf])
									if tmpTags!="" || cKoTags!=""
										anims = SexLab.GetCreatureAnimationsByRaceKeyTags(numParticipants, raceFilters[rf], tmpTags, TagSuppress=cKoTags, RequireAll=true)
									else
										anims = SexLab.GetCreatureAnimationsByRaceKey(numParticipants, raceFilters[rf])
									endIf
									if anims && anims.length>0
										resAnims = MergeAnimLists(resAnims, anims)
									endIf
								endIf
							endWhile
						else ; No race filters (we still need to filter by races enabled)
							rf = numAllRacesC
							while rf
								rf-=1
								if allRacesCEnabled[rf]
									if tmpTags!="" || cKoTags!=""
										anims = SexLab.GetCreatureAnimationsByRaceKeyTags(numParticipants, allRacesC[rf], tmpTags, TagSuppress=cKoTags, RequireAll=true)
									else
										anims = SexLab.GetCreatureAnimationsByRaceKey(numParticipants, allRacesC[rf])
									endIf
									if anims && anims.length>0
										resAnims = MergeAnimLists(resAnims, anims)
									endIf
								endIf
							endWhile
						endIf						
					endIf
				endWhile
				
			endIf
		endIf
	endWhile
	
	if !resAnims || resAnims.length==0
		if genderTags[0]!=""
			log("no anims " + numParticipants + " people, ok=" + cOkTags + ", ko=" + cKoTags + " gtags=" + genderTags + " aggr=" + aggressive + " creatures=" + withC, notifAnimsScan())
		endIf
	else
		log("#" + resAnims.length + " anims " + numParticipants + " people, ok=" + cOkTags + ", ko=" + cKoTags + " gtags=" + genderTags + " aggr=" + aggressive + " creatures=" + withC, notifAnimsScan())
	endIf
	return resAnims
EndFunction

bool Function testRacesForPositions(sslBaseAnimation a, SSX_Rule_Alias r)
	string dRace=""
	string sRace=""
	string cRace=""
	int i = allRacesC.length
	while i
		i-=1
		if a.IsPositionRace(0, allRacesC[i])
			dRace=allRacesC[i]
		elseIf a.IsPositionRace(1, allRacesC[i])
			sRace=allRacesC[i]
		elseIf a.IsPositionRace(2, allRacesC[i])
			cRace=allRacesC[i]
		endIf
	endWhile
	
	; if we have a single race, then is not good by default
	if (dRace=="" && sRace=="") || (dRace=="" && cRace=="") || (cRace=="" && sRace=="")
		return false
	endIf

	if r.isCreature(0) && r.isCreature(1) ; D&S
		if StringUtil.find(r.dstRaces, dRace)!=-1 && StringUtil.find(r.srcRaces, sRace)!=-1
			return true
		elseIf StringUtil.find(r.dstRaces, sRace)!=-1 && StringUtil.find(r.srcRaces, dRace)!=-1 ; Swap...
			return true
		endIf
		return false
	endIf

	if r.isCreature(0) && r.isCreature(2) ; D&C
		if StringUtil.find(r.dstRaces, dRace)!=-1 && StringUtil.find(r.collRaces, cRace)!=-1
			return true
		elseIf StringUtil.find(r.dstRaces, cRace)!=-1 && StringUtil.find(r.collRaces, dRace)!=-1 ; Swap...
			return true
		endIf
		return false
	endIf

	if r.isCreature(1) && r.isCreature(2) ; S&C
		if StringUtil.find(r.srcRaces, sRace)!=-1 && StringUtil.find(r.collRaces, cRace)!=-1
			return true
		elseIf StringUtil.find(r.srcRaces, cRace)!=-1 && StringUtil.find(r.collRaces, sRace)!=-1 ; Swap...
			return true
		endIf

		return false
	endIf

	return false
endFunction

sslBaseAnimation[] Function getSpecificAnimsForActors(Actor[] actors, SSX_Rule_Alias r, bool aggr)
	{check if we should use the tags, also in lazy mode and filter the non-valid anims}
	generateGenderTagsActors(globalSexTags, r.genderTagMode(aggr), actors, false)
	generateGenderTagsActors(globalSexTagsL, r.genderTagMode(aggr), actors, true)
	
	sslBaseAnimation[] tmpAnims
	String ids = r.specificAnimIDs
	if aggr && r.specificAnimAIDs!=""
		ids = r.specificAnimAIDs
	endIf
	String[] animIDs = StringUtil.split(ids, ";")
	tmpAnims = sslUtility.AnimationArray(animIDs.length)
	int j = 0
	while j<animIDs.length
		tmpAnims[j] = SexLab.GetAnimationByRegistry(animIDs[j])
		if !tmpAnims[j]
			tmpAnims[j] = SexLab.GetCreatureAnimationByRegistry(animIDs[j])
		endIf
		; Do we have to check the sex tags? 0=add them, 1=add lazy, 2=add but if fail remove, 3=don't add
		if tmpAnims[j]
			bool good=true
			if r.genderTagMode(aggr)==0 ; Add them, so filter the anim as is
				good=false
				int i = globalSexTags.length
				while i
					i-=1
					if globalSexTags[i] && tmpAnims[j].hasTag(globalSexTags[i])
						good=true
						i=0
					endIf
				endWhile
				if !good
					tmpAnims[j]=none
				endIf
			elseIf r.genderTagMode(aggr)==1 ; lazy
				good=false
				int i = globalSexTagsL.length
				while i
					i-=1
					if globalSexTagsL[i] && tmpAnims[j].hasTag(globalSexTagsL[i])
						good=true
						i=0
					endIf
				endWhile
				if !good
					tmpAnims[j]=none
				endIf
			elseIf r.genderTagMode(aggr)==2 ; Add, but if failing still get anims
				good=false
				int i = globalSexTags.length
				while i
					i-=1
					if globalSexTags[i] && tmpAnims[j].hasTag(globalSexTags[i])
						good=true
						i=0
					endIf
				endWhile
				if !good
					i = globalSexTagsL.length
					while i
						i-=1
						if globalSexTagsL[i] && tmpAnims[j].hasTag(globalSexTagsL[i])
							good=true
							i=0
						endIf
					endWhile
				endIf
			endIf
			; Do we have to filter the Aggressiveness?
			if good && r.aggressiveTagReqired()==3
				if aggr
					; Be sure we have the aggressive tag
					if !tmpAnims[j].hasTag("Aggressive")
						good=false
					endIf
				else
					; Be sure we DON'T have the aggressive tag
					if tmpAnims[j].hasTag("Aggressive")
						good=false
					endIf
				endIf
			endIf
				
			if !good
				tmpAnims[j]=none
			endIf
		endIf
		j+=1
	endWhile
	
	return tmpAnims
EndFunction

sslBaseAnimation[] Function getSpecificAnims(SSX_Rule_Alias r, bool aggr)
	sslBaseAnimation[] tmpAnims
	String ids = r.specificAnimIDs
	if aggr && r.specificAnimAIDs!=""
		ids = r.specificAnimAIDs
	endIf
	String[] animIDs = StringUtil.split(ids, ";")
	tmpAnims = sslUtility.AnimationArray(animIDs.length)
	int j = 0
	while j<animIDs.length
		tmpAnims[j] = SexLab.GetAnimationByRegistry(animIDs[j])
		if !tmpAnims[j]
			tmpAnims[j] = SexLab.GetCreatureAnimationByRegistry(animIDs[j])
		endIf
		; Do we have to filter the Aggressiveness?
		if r.aggressiveTagReqired()==3
			if aggr
				; Be sure we have the aggressive tag
				if !tmpAnims[j].hasTag("Aggressive")
					tmpAnims[j]=none
				endIf
			else
				; Be sure we DON'T have the aggressive tag
				if tmpAnims[j].hasTag("Aggressive")
					tmpAnims[j]=none
				endIf
			endIf
		endIf
		j+=1
	endWhile

	return tmpAnims
EndFunction

String Function generateAnimNames(SSX_Rule_Alias r, bool aggressive)
	sslBaseAnimation[] tmpAnims
	String[] animIDs
	if aggressive
		animIDs = StringUtil.split(r.specificAnimAIDs, ";")
	else
		animIDs = StringUtil.split(r.specificAnimIDs, ";")
	endIf
	tmpAnims = sslUtility.AnimationArray(animIDs.length)
	int j = 0
	while j<animIDs.length
		tmpAnims[j] = SexLab.GetAnimationByRegistry(animIDs[j])
		if !tmpAnims[j]
			tmpAnims[j] = SexLab.GetCreatureAnimationByRegistry(animIDs[j])
		endIf
		j+=1
	endWhile
	String res = ""
	j=0
	int done=0
	while j<tmpAnims.length && done<3
		sslBaseAnimation anim = tmpAnims[j]
		if anim
			if done>0
				res += ", "
			endIf
			res += tmpAnims[j].name
			done+=1
			if done==2
				return res + ", ..."
			endIf
		endIf
		j+=1
	endWhile
	return res
EndFunction

String[] Function getAllValidCreatureRaces()
	int i
	int num = 0
	i = numAllRacesC
	while i
		i-=1
		if allRacesCEnabled[i]
			num+=1
		endIf
	endWhile
	if num<1
		num=1
	endIf
	String[] res = CreateStringArray(num)
	num=0
	i = numAllRacesC
	while i
		i-=1
		if allRacesCEnabled[i]
			res[num] = allRacesC[i]
			num+=1
		endIf
	endWhile
	return res
EndFunction

Function generateRaceFilters(String[] toFill, SSX_Rule_Alias r)
	if !SexLab.AllowCreatures
		toFill[0]=""
		return
	endIf


	String[] allValidCRaces = getAllValidCreatureRaces()
	String[] ruleRaces
	int i
	int num = 0
	if r.dstRaces!="" && r.isCreature(0)
		ruleRaces = StringUtil.split(r.dstRaces, ";")
		if r.getRaceMode(0)==0 ; Inclusive
			i = ruleRaces.length
			while i
				i-=1
				if allValidCRaces.find(ruleRaces[i])!=-1
					toFill[num] = ruleRaces[i]
					num+=1
				endIf
			endWhile
		else ; Exclusive
			i = allValidCRaces.length
			while i
				i-=1
				if ruleRaces.find(allValidCRaces[i])==-1
					toFill[num] = ruleRaces[i]
					num+=1
				endIf
			endWhile
		endIf
	endIf
	; Source races
	if r.srcRaces!="" && r.isCreature(1) && !r.isNobody(1)
		ruleRaces = StringUtil.split(r.srcRaces, ";")
		if r.getRaceMode(1)==0 ; Inclusive
			i = ruleRaces.length
			while i
				i-=1
				if allValidCRaces.find(ruleRaces[i])!=-1 && toFill.find(ruleRaces[i])==-1
					toFill[num] = ruleRaces[i]
					num+=1
				endIf
			endWhile
		else ; Exclusive
			i = allValidCRaces.length
			while i
				i-=1
				if ruleRaces.find(allValidCRaces[i])==-1
					toFill[num] = ruleRaces[i]
					num+=1
				endIf
			endWhile
		endIf
	endIf
	; Collaborator races
	if r.collRaces!="" && r.isCreature(2) && !r.isNobody(2) && !r.isSameRace(2)
		ruleRaces = StringUtil.split(r.collRaces, ";")
		if r.getRaceMode(2)==0 ; Inclusive
			i = ruleRaces.length
			while i
				i-=1
				if allValidCRaces.find(ruleRaces[i])!=-1 && toFill.find(ruleRaces[i])==-1
					toFill[num] = ruleRaces[i]
					num+=1
				endIf
			endWhile
		else ; Exclusive
			i = allValidCRaces.length
			while i
				i-=1
				if ruleRaces.find(allValidCRaces[i])==-1
					toFill[num] = ruleRaces[i]
					num+=1
				endIf
			endWhile
		endIf
	endIf
EndFunction

int Function getByIDNameTags(sslBaseAnimation[] resAnims, int numParticipants, String tmpVal, bool withCreatures)
	int numRes=0
	; Search by ID
	sslBaseAnimation anim
	
	if !withCreatures
		anim = SexLab.GetAnimationByRegistry(tmpVal)
		if anim!=None
			resAnims[0] = anim
			return 1
		endIf
		anim = SexLab.GetAnimationByName(tmpVal)
		if anim!=None
			resAnims[0] = anim
			return 1
		endIf
		sslBaseAnimation[] res = SexLab.GetAnimationsByTags(numParticipants, tmpVal)
		int i=0
		while res && i<resAnims.length && i<res.length
			resAnims[i] = res[i]
			i+=1
		endWhile
		return i
	else
		anim = SexLab.GetCreatureAnimationByRegistry(tmpVal)
		if anim!=None
			resAnims[0] = anim
			return 1
		endIf
		anim = SexLab.GetCreatureAnimationByName(tmpVal)
		if anim!=None
			resAnims[0] = anim
			return 1
		endIf
		sslBaseAnimation[] res = SexLab.GetCreatureAnimationsByTags(numParticipants, tmpVal)
		int i=0
		while res && i<resAnims.length && i<res.length
			resAnims[i] = res[i]
			i+=1
		endWhile
		return i
	endIf
EndFunction

; humanity: 0=both, 1=humans, 2=creatures
Function getAllAnimationNames(int numParticipants, int humanity=0, String name="", String tag="", String[] raceTypes)
	{First count the anims}
	int tot = 0
	int i
	sslBaseAnimation anim
	if humanity!=2
		Form SexLabQuestAnimations = Game.GetFormFromFile(0x639DF, "SexLab.esm")
		sslAnimationSlots AnimSlots = SexLabQuestAnimations as sslAnimationSlots
		i = AnimSlots.Slotted
		while i
			i-=1
			anim = AnimSlots.GetBySlot(i)
			if anim && anim.name && anim.Enabled && anim.PositionCount==numParticipants
				if (name!="" && (StringUtil.find(anim.name, name)!=-1 || StringUtil.find(anim.Registry, name)!=-1)) || (tag!="" && anim.getRawTags().find(tag)!=-1) || (name=="" && tag=="")
					tot+=1
				endIf
			endIf
		endWhile
	endIf
	if humanity!=1
		Form SexLabQuestRegistry = Game.GetFormFromFile(0x664FB, "SexLab.esm")
		sslCreatureAnimationSlots AnimSlots = SexLabQuestRegistry as sslCreatureAnimationSlots
		i = AnimSlots.Slotted
		while i
			i-=1
			anim = AnimSlots.GetBySlot(i)
			if anim && anim.name && anim.Enabled && anim.PositionCount==numParticipants
				if raceTypes && raceTypes.length>0 && raceTypes[0]!=""
					if anim.HasValidRaceKey(raceTypes)
						if (name!="" && (StringUtil.find(anim.name, name)!=-1 || StringUtil.find(anim.Registry, name)!=-1)) || (tag!="" && anim.getRawTags().find(tag)!=-1) || (name=="" && tag=="")
							tot+=1
						endIf
					endIf
				else
					if (name!="" && (StringUtil.find(anim.name, name)!=-1 || StringUtil.find(anim.Registry, name)!=-1)) || (tag!="" && anim.getRawTags().find(tag)!=-1) || (name=="" && tag=="")
						tot+=1
					endIf
				endIf
			endIf
		endWhile
	endIf
	
	if tot==0
		animNames = new String[1]
		animNames[0] = s("$SSX_NoAnimsFound")
		return
	endIf
	; And get the real names now and return it
	animNames = CreateStringArray(tot)
	tot = 0
	if humanity!=2
		Form SexLabQuestAnimations = Game.GetFormFromFile(0x639DF, "SexLab.esm")
		sslAnimationSlots AnimSlots = SexLabQuestAnimations as sslAnimationSlots
		i = AnimSlots.Slotted
		while i
			i-=1
			anim = AnimSlots.GetBySlot(i)
			if anim && anim.name && anim.Enabled && anim.PositionCount==numParticipants
				if (name!="" && (StringUtil.find(anim.name, name)!=-1 || StringUtil.find(anim.Registry, name)!=-1)) || (tag!="" && anim.getRawTags().find(tag)!=-1) || (name=="" && tag=="")
					animNames[tot]=anim.name
					tot+=1
				endIf
			endIf
		endWhile
	endIf
	if humanity!=1
		Form SexLabQuestRegistry = Game.GetFormFromFile(0x664FB, "SexLab.esm")
		sslCreatureAnimationSlots AnimSlots = SexLabQuestRegistry as sslCreatureAnimationSlots
		i = AnimSlots.Slotted
		while i
			i-=1
			anim = AnimSlots.GetBySlot(i)
			if anim && anim.name && anim.Enabled && anim.PositionCount==numParticipants
				if raceTypes && raceTypes.length>0 && raceTypes[0]!=""
					if anim.HasValidRaceKey(raceTypes)
						if (name!="" && (StringUtil.find(anim.name, name)!=-1 || StringUtil.find(anim.Registry, name)!=-1)) || (tag!="" && anim.getRawTags().find(tag)!=-1) || (name=="" && tag=="")
							animNames[tot]=anim.name
							tot+=1
						endIf
					endIf
				else
					if (name!="" && (StringUtil.find(anim.name, name)!=-1 || StringUtil.find(anim.Registry, name)!=-1)) || (tag!="" && anim.getRawTags().find(tag)!=-1) || (name=="" && tag=="")
						animNames[tot]=anim.name
						tot+=1
					endIf
				endIf
			endIf
		endWhile
	endIf
EndFunction


; -))

; ((- ----------------- SexLab, Aroused, Health, etc. function -----------------

Bool Function weHaveSLA()
	return slaf!=None
EndFunction

Bool Function forePlayActive()
	return SexLabConfig.ForeplayStage
endFunction

int Function getHealthLevel(Actor a)
	if !a
		return 0
	endIf
	float den = a.GetBaseActorValue("Health")
	if den==0
		return 100
	endIf
	return (100 * a.GetActorValue("Health") / den) as Int
EndFunction

int Function getStaminaLevel(Actor a)
	if !a
		return 0
	endIf
	float den = a.GetBaseActorValue("Stamina")
	if den==0
		return 100
	endIf
	return (100 * a.GetActorValue("Stamina") / den) as Int
EndFunction

int Function getMagickaLevel(Actor a)
	if !a
		return 0
	endIf
	float den = a.GetBaseActorValue("Magicka")
	if den==0
		return 100
	endIf
	return (100 * a.GetActorValue("Magicka") / den) as Int
EndFunction

bool function raceHasAnimations(string RaceKey, int actorsCount=-1)
{Checks if there is any animation for the specified Race Key, without actually getting the animations that takes a huge amount of time}
	if !sslCreatureAnimationSlots.HasRaceKey(RaceKey)
		return false
	endIf
	int i = CreatureSlots.Slotted
	while i
		i -= 1
		sslBaseAnimation slot = CreatureSlots.GetBySlot(i)
		if slot.RaceType == RaceKey && Slot.Enabled && (actorsCount==-1 || actorsCount == slot.PositionCount)
			return true
		endIf
	endWhile
	return false
endFunction

sslBaseAnimation[] Function MergeAnimLists(sslBaseAnimation[] l1, sslBaseAnimation[] l2) global
{Merges two lists of sslAnimations in a single list, skipping the None elements and the duplicated elements}
	sslBaseAnimation[] maxRes = new sslBaseAnimation[128]
	int maxResNum = 0 
	int i = l1.length
	while i
		i -= 1
		sslBaseAnimation a = l1[i]
		if a && maxRes.find(a)==-1
			maxRes[maxResNum] = a
			maxResNum += 1
		endIf
	endWhile
	i = l2.length
	while i && maxResNum<128
		i -= 1
		sslBaseAnimation a = l2[i]
		if a && maxRes.find(a)==-1
			maxRes[maxResNum] = a
			maxResNum += 1
		endIf
	endWhile

	if maxResNum==128
		return maxRes
	endIf
	sslBaseAnimation[] res = sslUtility.AnimationArray(maxResNum)
	while maxResNum
		maxResNum -= 1
		res[maxResNum] = maxRes[maxResNum]
	endWhile
	return res
EndFunction

Function setSexLabActorScaling(bool scaleActors)
	SexLabConfig.ScaleActors = scaleActors
EndFunction

Function restoreSexLabActorScaling()
	SexLabConfig.ScaleActors = defaultSexLabActorsScaling
EndFunction

; -)) 


; ((- ------------------- Actors Functions ----------------------------------------------------

; Actor status is a bit filed with the following bits
; 0 	-    1 -	<not used, set to 1 in the answer>
; 1 	-    2 -	sex gender (female)
; 2 	-    4 -	follower
; 3 	-    8 -	creature
; 4 	-   16 -	is Naked
; 5 	-   32 -	is Sleeping
; 6 	-   64 -	is Sneaking
; 7 	-  128 -	has Weapon
; 8 	-  256 -	in combat
; 9 	-  512 -	is Bleeding
; 10 	- 1024 -	is Unconscious

Form[] cachedActors ; List of actors, just to keep the creaturesIDs
String[] cachedRaces ; RaceID of the creature
Int[] cachedTypes ; 0 = not valid, 1 if human, 2 if creature
int numCachedActors


Function forceActorsCleanUp()
	{Forgets all the actors in the arrays and around the player, remove all factions, remove all caches}
	while updatingAllActors
		Utility.waitMenuMode(0.5)
	endWhile
	updatingAllActors = true
	int i=allActors.length
	while i
		i-=1
		Actor a = allActors[i]
		if a
			removeFromAllActors(none, i, false)
		endIf
		allActors[i]=none
	endWhile

	i=cachedActors.length
	while i
		i-=1
		Actor a = cachedActors[i] as Actor
		if a
			if a.isInFaction(ssxAllFriends)
				a.removeFromFaction(ssxAllFriends)
			endIf
			if a.isInFaction(ssxCreatures)
				a.removeFromFaction(ssxCreatures)
			endIf
			if a.isInFaction(ssxInvolved)
				a.removeFromFaction(ssxInvolved)
			endIf
			a.evaluatePackage()
		endIf
		cachedActors[i]=None
		cachedRaces[i]=0
		cachedTypes[i]=0
	endWhile
	numCachedActors=0

	i=mcmActors.length
	while i
		i-=1
		Actor a = mcmActors[i]
		if a
			if a.isInFaction(ssxAllFriends)
				a.removeFromFaction(ssxAllFriends)
			endIf
			if a.isInFaction(ssxCreatures)
				a.removeFromFaction(ssxCreatures)
			endIf
			if a.isInFaction(ssxInvolved)
				a.removeFromFaction(ssxInvolved)
			endIf
			a.evaluatePackage()
		endIf
	endWhile
	
	updatingAllActors = false
EndFunction

bool Function addActor(Actor a) ; Adds the actor to the cache and sets the race value, returns false if the actor is not valid
	if !a
		return false
	endIf
	int pos = cachedActors.find(a)
	int asCreature=0
	if pos==-1 ; Add it
		if !a || a.isDisabled() || !a.is3DLoaded()
			return false ; But can be temporary, so not adding
		endIf
		
		if numCachedActors>=cachedActors.length
			cachedActors = ResizeFormArray(cachedActors, cachedActors.length + 64, None)
			cachedRaces = ResizeStringArray(cachedRaces, cachedActors.length + 64, None)
			cachedTypes = ResizeIntArray(cachedTypes, cachedActors.length + 64, 0)
		endIf
		
		Race r = a.getLeveledActorBase().getRace()
		if a.isChild() || r.IsChildRace()
			cachedActors[numCachedActors] = a
			cachedTypes[numCachedActors] = 0 ; Not valid because child
			cachedRaces[numCachedActors] = "Child"
			numCachedActors+=1
			return false
		endIf
		
		String raceID = sslCreatureAnimationSlots.GetRaceKey(r)
		if SexLab.getGender(a)>1
			asCreature=1
		else
			raceID = MiscUtil.GetRaceEditorID(r)
		endIf
		if raceID!=""
			int i = StringUtil.find(raceID, "Race")
			if i!=-1
				if i+4 == StringUtil.GetLength(raceID)
					raceID = StringUtil.Substring(raceID, 0, i)
				else ; "Race" is in between other words, just remove the sub part and replace with a space
					raceID = StringUtil.Substring(raceID, 0, i) + " " + StringUtil.Substring(raceID, i+4)
				endIf
			endIf	
		endIf

		cachedActors[numCachedActors] = a
		cachedTypes[numCachedActors] = asCreature + 1
		cachedRaces[numCachedActors] = raceID
		numCachedActors+=1
		return asCreature==1
	else
		return cachedTypes[pos] == 2
	endIf
endFunction

String Function getActorRaceID(Actor a)
	if !a
		return ""
	endIf
	int pos = cachedActors.find(a)
	if pos!=-1
		return cachedRaces[pos]
	endIf
	addActor(a)
	pos = cachedActors.find(a)
	if pos!=-1
		return cachedRaces[pos]
	endIf
	return "" ; Something wrong
EndFunction


bool Function validateActor(Actor a)
	{Many of the other checks are already done before, and some of them are not really required here. SexLab will re-perform the checks when the animation (if any) will start}

	if !a
		return false
	endIf
	if a.IsFlying()
		debug.trace(">>>>> ValidateActor: [" + a.getDisplayName() + "] is BAD because flying")
		return false
	endIf
	if !a.is3DLoaded() || a.IsDead() || a.IsDisabled() || a.IsOnMount() || a.IsBeingRidden() || a.isSwimming() || a.IsInFaction(SexLabForbiddenFaction) || a.isChild() || PlayerRef.getDistance(a)>8000.0
		return false
	endIf
	; player at least sometimes gets stuck in involved faction
	if (a.isInFaction(ssxInvolved) && !searchScene(a=a))
		debug.trace(">>>>> FIXME! For some reason " + a.getDisplayName() + " was stuck in ssxInvolved!")
		a.removeFromFaction(ssxInvolved)
	endIf
	return true
EndFunction


bool Function isMale(Actor a)
	return calculateSex(a) == 0
EndFunction

bool Function isFemale(Actor a)
	return calculateSex(a) == 1
EndFunction

bool Function isFollower(Actor a)
	return a && a.isPlayerTeamMate()
EndFunction

bool Function isCreature(Actor a)
	return addActor(a)
EndFunction

bool Function isHuman(Actor a)
	return !addActor(a)
EndFunction


Function resetCache(bool resetRaces)
	numCachedActors = 0
	cachedActors = CreateFormArray(128)
	cachedRaces = CreateStringArray(128)
	cachedTypes = CreateIntArray(128)
EndFunction


Function moveActor(Actor a, Actor t, ObjectReference b)
	if !a
		return
	endIf
	if t
		float taz = t.GetAngleZ() + Utility.RandomFloat(-90.0, 90.0)
		a.DisableNoWait()
		a.moveTo(t, 100.0 * Math.Sin(taz), 100.0 * Math.Cos(taz), t.GetHeight())
		a.EnableNoWait()
		a.EvaluatePackage() 
	elseIf b
		a.DisableNoWait()
		a.SetPosition(b.getPositionX(), b.getPositionY(), b.getPositionZ())
		a.EnableNoWait()
		a.EvaluatePackage() 
	endIf
EndFunction

Function setInvolved(Actor a1, Actor a2=None, Actor a3=None, Actor a4=None, Actor a5=None)
	if a1 && !a1.IsInFaction(ssxInvolved)
		a1.addToFaction(ssxInvolved)
		if isCreature(a1)
			a1.addToFaction(ssxCreatures)
		endIf
	endIf
	if a2 && !a2.IsInFaction(ssxInvolved)
		a2.addToFaction(ssxInvolved)
		if isCreature(a2)
			a2.addToFaction(ssxCreatures)
		endIf
	endIf
	if a3 && !a3.IsInFaction(ssxInvolved)
		a3.addToFaction(ssxInvolved)
		if isCreature(a3)
			a3.addToFaction(ssxCreatures)
		endIf
	endIf
	if a4 && !a4.IsInFaction(ssxInvolved)
		a4.addToFaction(ssxInvolved)
		if isCreature(a4)
			a4.addToFaction(ssxCreatures)
		endIf
	endIf
	if a5 && !a5.IsInFaction(ssxInvolved)
		a5.addToFaction(ssxInvolved)
		if isCreature(a5)
			a5.addToFaction(ssxCreatures)
		endIf
	endIf
EndFunction

Function removeInvolved(Actor a1, Actor a2=None, Actor a3=None, Actor a4=None, Actor a5=None)
	if a1 && a1.IsInFaction(ssxInvolved)
		a1.removeFromFaction(ssxInvolved)
	endIf
	if a2 && a2.IsInFaction(ssxInvolved)
		a2.removeFromFaction(ssxInvolved)
	endIf
	if a3 && a3.IsInFaction(ssxInvolved)
		a3.removeFromFaction(ssxInvolved)
	endIf
	if a4 && a4.IsInFaction(ssxInvolved)
		a4.removeFromFaction(ssxInvolved)
	endIf
	if a5 && a5.IsInFaction(ssxInvolved)
		a5.removeFromFaction(ssxInvolved)
	endIf
EndFunction


Package[] Property ssxSpectatorCrowdPackages Auto
Actor[] Property spectators0 Auto
Actor[] Property spectators1 Auto
Actor[] Property spectators2 Auto
Actor[] Property spectators3 Auto
Actor[] Property spectators4 Auto
Actor[] Property spectators5 Auto

Function addSpectators(SSX_Rule_Alias r, Actor target)
	int numSpectators = r.getSpectators()
	if numSpectators==0
		return
	endIf
	; Find some free actor
	int index = sceneDs.find(target)
	if index==-1
		return
	endIf
	Actor[] allSpectators
	if index==0
		allSpectators=spectators0
	elseIf index==1
		allSpectators=spectators1
	elseIf index==2
		allSpectators=spectators2
	elseIf index==3
		allSpectators=spectators3
	elseIf index==4
		allSpectators=spectators4
	elseIf index==5
		allSpectators=spectators5
	endIf
	
	int found=0 ; total number of actors found in allActors (used to randomize picked actors)
	int place=allActors.length ; allActors iterator
	int n = numSpectators ; allSpectators iterator
	
	; How does it work?  We loop through allActors, skipping empty slots.  We count every actor we found, and each of them we consider
	; for spectator position.  Our goal is to get [numSpectators] random actors from the 'crowd' of allActors.  The likelihood of any
	; given actor to end up spectator is [numSpectators] / [allActors].  This is accomplished by iterative randomint(0 <-> actors-so-far),
	; compared to [numSpectators].  As long as there are empty spectator slots, actors-so-far (and randomint) will be less than number of
	; slots, so we fill in any available actors.  Once number of actors found passes number of slots, the likelihood of adding any new actor
	; will start going down.  By the time we reach end of allActors, each actor has had their chance, which should be same for all of them.
	; -- Reikiri
	
	while n
		n -= 1
		allSpectators[n] = none
	endWhile
	while place
		place -= 1
		Actor a = allActors[place]
		if a
			if Utility.RandomInt(0, found) < numSpectators
				if validateActor(a) && !a.isInFaction(ssxInvolved) && !isCreature(a)
					allSpectators[n]=a
					n += 1
					if n == numSpectators
						n = 0
					endIf
				else
					found -= 1 ; This actor was a dud, we count it as 'empty slot' to make sure all spectators are filled if possible
				endIf
			else
			endIf
			found += 1
		endIf
	endWhile
	n = numSpectators
	while n
		n -= 1
		Actor a = allSpectators[n]
		if a
			ActorUtil.addPackageOverride(a, ssxSpectatorCrowdPackages[index], 95)
			a.SetLookAt(target, true)
		endIf
	endWhile

	return
endFunction

Function cleanSpectators(int index)
	Actor[] allSpectators
	if index==0
		allSpectators=spectators0
	elseIf index==1
		allSpectators=spectators1
	elseIf index==2
		allSpectators=spectators2
	elseIf index==3
		allSpectators=spectators3
	elseIf index==4
		allSpectators=spectators4
	elseIf index==5
		allSpectators=spectators5
	endIf
	int i=8
	while i
		i-=1
		if allSpectators[i]
			allSpectators[i].clearLookAt()
			ActorUtil.RemovePackageOverride(allSpectators[i], ssxSpectatorCrowdPackages[0])
			ActorUtil.RemovePackageOverride(allSpectators[i], ssxSpectatorCrowdPackages[1])
			ActorUtil.RemovePackageOverride(allSpectators[i], ssxSpectatorCrowdPackages[2])
			ActorUtil.RemovePackageOverride(allSpectators[i], ssxSpectatorCrowdPackages[3])
			ActorUtil.RemovePackageOverride(allSpectators[i], ssxSpectatorCrowdPackages[4])
			ActorUtil.RemovePackageOverride(allSpectators[i], ssxSpectatorCrowdPackages[5])
			allSpectators[i].EvaluatePackage()
		endIf
		allSpectators[i]=None
	endWhile
endFunction

Function doSpectatorMasturbate(int index, int mode)
	Actor[] allSpectators
	if index==0
		allSpectators=spectators0
	elseIf index==1
		allSpectators=spectators1
	elseIf index==2
		allSpectators=spectators2
	elseIf index==3
		allSpectators=spectators3
	elseIf index==4
		allSpectators=spectators4
	elseIf index==5
		allSpectators=spectators5
	endIf
	int i=8
	while i
		i-=1
		if allSpectators[i] && !allSpectators[i].isInFaction(SexLabAnimatingFaction)
			int sex = allSpectators[i].getLeveledActorbase().getSex()
			if mode==3 || (mode==1 && sex==0) || (mode==2 && sex==1)
				if SexLab.getGender(allSpectators[i])==0
					SexLab.QuickStart(allSpectators[i], AnimationTags = "M")
					return
				else
					SexLab.QuickStart(allSpectators[i], AnimationTags = "F")
					return
				endIf
			endIf
		endIf
	endWhile
endFunction


; -))

; ((- Cells and Locations ************************************************************************************************************************************************************************

bool Function isValidLocation(Location l, Cell c, SSX_Rule_Alias r)
	bool isIncl = !r.getCellInclExcl()
	if l
		; Check if for the specified rule the passed location is valid
		if r.realLocations.find(l)!=-1
			return isIncl ; It is directly in the list
		endIf
		; Check if there are keywords and the location has a keyword
		if r.realLocKeywords.length>0 && r.realLocKeywords[0]
			int i = r.realLocKeywords.length
			while i
				i -= 1
				if l.HasKeyword(r.realLocKeywords[i])
					return isIncl
				endIf
			endWhile
		endIf
		; Check if the parent is in the list
		int i = r.realLocations.length
		while i
			i -= 1
			if r.realLocations[i]
				if r.realLocations[i].IsChild(l)
					return isIncl
				endIf
			endIf
		endWhile
	endIf
	if c
		if r.realCells.find(c)==-1
			return !isIncl
		else
			return isIncl
		endIf
	endIf
	return !isIncl ; Not good, sorry
EndFunction

Function updateCellAndLocation(Cell c)
	currentPlayerCell = c
	if currentPlayerCell.IsInterior()
		cellIntExt = 1
	else
		cellIntExt = 2
	endIf
	playerLocation = PlayerRef.getCurrentLocation()
	if cellIntExt==2
		if playerLocation
			log("New cell=" + playerLocation.getName(), notifScanDetails())
		else
			log("New cell=" + currentPlayerCell.getName(), notifScanDetails())
		endIf
	else
		log("New cell=" + currentPlayerCell.getName(), notifScanDetails())
	endIf
	if playerLocation
		locationID = PO3_SKSEFunctions.GetFormEditorID(playerLocation)
	endIf
	; Check if we may need to restart
	if lastPlayerCell!=currentPlayerCell
		if iAmActive && ((lastPlayerCell && lastPlayerCell.IsInterior()) || currentPlayerCell.IsInterior())
			int handle = ModEvent.Create("ssxScanCell")
			ModEvent.PushString(handle, "CellScanner")
			ModEvent.Send(handle)
		endIf
		lastPlayerCell=currentPlayerCell
		if currentPlayerCell.IsInterior()
			; Clean up the actors on the rules
			int i = rules.length
			while i
				i-=1
				SSX_Rule_Alias r = rules[i]
				if r && r.inUse==2
					r.clearValidActors()
				endIf
			endWhile
		endIf
	endIf
EndFunction

String Function GetNameFromEditorID(String editorID) global
	String s = GetNameAndEditorID(PO3_SKSEFunctions.GetFormFromEditorID(editorID))
	if s
		return s
	else
		return "UNKOWN"
	endIf
endFunction

; -))


; ((- Race functions ************************************************************************************************************************************************************************

String[] Property allRacesH Auto
String[] Property allRacesHEditIDs Auto
int[] Property allRacesHEnabled Auto
int Property numAllRacesH Auto
String[] Property allRacesC Auto
int[] Property allRacesCEnabled Auto
int Property numAllRacesC Auto

String[] Property allValidRacesH Auto
String[] Property allValidRacesC Auto
String[] Property allValidRacesB Auto

bool needToSortRaceArraysH
bool needToSortRaceArraysC
bool needToUpdateRaceDisplayArraysH
bool needToUpdateRaceDisplayArraysC
int Property updateRacesProgress Auto


bool Function needToUpdateRaces()
	if needToUpdateRaceDisplayArraysH || needToUpdateRaceDisplayArraysC
		updateRacesProgress=-1
		return true
	endIf
	return false
EndFunction

String Function getRaceID(Race r)
	if !r || r.IsChildRace()
		return ""
	endIf
	String raceID = sslCreatureAnimationSlots.GetRaceKey(r)
	if raceID!="" ; It is for sure a valid SexLab creature race
		return raceID
	endIf
	raceID = MiscUtil.GetRaceEditorID(r)
	int i = StringUtil.find(raceID, "Race")
	if i!=-1
		if i+4 == StringUtil.GetLength(raceID)
			raceID = StringUtil.Substring(raceID, 0, i)
		else ; "Race" is in between other words, just remove the sub part and replace with a space
			raceID = StringUtil.Substring(raceID, 0, i) + " " + StringUtil.Substring(raceID, i+4)
		endIf
	endIf	
	return raceID
EndFunction

bool Function raceIsKnown(Race r=None, String raceID="")
	if r
		String raceKey = sslCreatureAnimationSlots.GetRaceKey(r)
		if raceKey!=""
			return allRacesC.find(raceKey)!=-1
		endIf
		return allRacesHEditIDs.find(MiscUtil.GetRaceEditorID(r))!=-1
	endIf
	if raceID!=""
		if allRacesC.find(raceID)!=-1
			return true
		endIf
		return allRacesHEditIDs.find(raceID)!=-1
	endIf
	return false
endFunction


Function addRace(String raceID, Race r=None, int enabled=1, bool isCreature)
	if StringUtil.find(raceID, "Child")!=-1 || StringUtil.find(raceID, "Enfant")!=-1 || (r && r.IsChildRace())
		return
	endIf

	if r ; get the RaceID by Race
		String raceKey = sslCreatureAnimationSlots.GetRaceKey(r)
		if raceKey!="" ; It is for sure a valid SexLab creature race
			isCreature=true
			raceID = raceKey
			if !SexLab.HasCreatureRaceKeyAnimation(raceKey, Gender = -1) ; But it does not have SexLab animations, so it is not a valid creature
				enabled=0
			endIf
		else
			; Can be a creature NOT managed by SexLab (so useless) or a Human, understand if it is a creature or human on keyword and the ability to speak with it
			if r && (r.HasKeyword(ActorTypeCreature) || r.HasKeyword(ActorTypeAnimal) || !r.IsRaceFlagSet(0x00200000)) ; Probably it is a creature
				isCreature=true
				; Check if there are SexLab animations
				if !SexLab.HasCreatureRaceAnimation(r, Gender = -1) ; But it does not have SexLab animations, so it is not a valid creature
					enabled=0
				endIf
			endIf
		endIf
	endIf

	if raceID=="" && r
		raceID = MiscUtil.GetRaceEditorID(r)
	endIf
	
	if raceID=="CartHorseRace"
		isCreature = true
		raceID = "Chart Horses"
	endIf
	if r
		String raceKey = sslCreatureAnimationSlots.GetRaceKey(r)
		if raceKey=="Chart Horses" || raceKey=="ChartHorses" || raceKey=="Chart Horse" || raceKey=="ChartHorse" || raceKey=="CartHorses" || raceKey=="CartHorse"
			isCreature = true
			raceID = "Chart Horses"
		endIf
	endIf
	
	String editID = raceID
	int i = StringUtil.find(raceID, "Race")
	if i!=-1
		if i+4 == StringUtil.GetLength(raceID)
			raceID = StringUtil.Substring(raceID, 0, i)
		else ; "Race" is in between other words, just remove the sub part and replace with a space
			raceID = StringUtil.Substring(raceID, 0, i) + " " + StringUtil.Substring(raceID, i+4)
		endIf
	endIf

	if !isCreature
		needToSortRaceArraysH = true
		needToUpdateRaceDisplayArraysH = true
		if allRacesH.find(raceID)==-1
			if numAllRacesH>=allRacesH.length
				allRacesH = ResizeStringArray(allRacesH, numAllRacesH + 64)
				allRacesHEditIDs = ResizeStringArray(allRacesHEditIDs, numAllRacesH + 64)
				allRacesHEnabled = ResizeIntArray(allRacesHEnabled, numAllRacesH + 64)
				if !allRacesH || !allRacesHEnabled
					debug.messagebox("WARNING!\nNot possible to resize an array of strings H!\nSSX will not work!\nNum="+numAllRacesH)
				endIf
			endIf
			allRacesH[numAllRacesH] = raceID
			allRacesHEditIDs[numAllRacesH] = editID
			allRacesHEnabled[numAllRacesH] = enabled
			numAllRacesH+=1
		endIf
	else
		needToSortRaceArraysC = true
		needToUpdateRaceDisplayArraysC = true
		i = allRacesC.find(raceID)
		if i==-1
			if numAllRacesC>=allRacesC.length
				allRacesC = Utility.ResizeStringArray(allRacesC, numAllRacesC + 64)
				allRacesCEnabled = Utility.ResizeIntArray(allRacesCEnabled, numAllRacesC + 64)
				if !allRacesC || !allRacesCEnabled
					debug.messagebox("WARNING!\nNot possible to resize an array of strings C!\nSSX will not work!\nNum="+numAllRacesH)
				endIf
			endIf
			allRacesC[numAllRacesC] = raceID
			allRacesCEnabled[numAllRacesC] = enabled
			numAllRacesC+=1
		else
			allRacesCEnabled[i] = enabled
		endIf
	endIf
EndFunction

Function enableRace(String raceID, int enabled=1)
	int pos = allRacesH.find(raceID)
	if pos!=-1
		needToUpdateRaceDisplayArraysH = (allRacesHEnabled[pos]!=enabled) || needToUpdateRaceDisplayArraysH
		allRacesHEnabled[pos]=enabled
		return
	endIf
	pos = allRacesHEditIDs.find(raceID)
	if pos!=-1
		needToUpdateRaceDisplayArraysH = (allRacesHEnabled[pos]!=enabled) || needToUpdateRaceDisplayArraysH
		allRacesHEnabled[pos]=enabled
		return
	endIf
	pos = allRacesC.find(raceID)
	if pos!=-1
		if SexLab.HasCreatureRaceKeyAnimation(raceID) && enabled
			needToUpdateRaceDisplayArraysC = (allRacesCEnabled[pos]!=enabled) || needToUpdateRaceDisplayArraysC
			allRacesCEnabled[pos]=enabled
		else
			needToUpdateRaceDisplayArraysC = allRacesCEnabled[pos] || needToUpdateRaceDisplayArraysC
			allRacesCEnabled[pos]=0
		endIf
	endIf	
EndFunction

bool Function isRaceEnabled(String raceID)
	int pos = allRacesH.find(raceID)
	if pos!=-1
		return allRacesHEnabled[pos]==1
	endIf
	pos = allRacesHEditIDs.find(raceID)
	if pos!=-1
		return allRacesHEnabled[pos]==1
	endIf
	pos = allRacesC.find(raceID)
	if pos!=-1
		return allRacesCEnabled[pos]==1
	endIf	
	return false
EndFunction

bool Function isCreatureRace(String raceID)
	if allRacesH.find(raceID)!=-1
		return false
	endIf
	if allRacesC.find(raceID)!=-1
		return true
	endIf
	return false
EndFunction

bool Function hasRaceValidAnimations(String raceID)
	return SexLab.HasCreatureRaceKeyAnimation(raceID)
EndFunction

Function sortStringAndInt(String[] strs, int[] ints, int size)
	String[] tmp = CreateStringArray(size)
	int i = size
	while i
		i-=1
		tmp[i]=strs[i]+ints[i]
	endWhile
	PapyrusUtil.SortStringArray(tmp)
	i = size
	while i
		i-=1
		if StringUtil.subString(tmp[i], StringUtil.getLength(tmp[i]) - 1)=="1"
			ints[i] = 1
		else
			ints[i] = 0
		endIf
		strs[i]=StringUtil.subString(tmp[i], 0, StringUtil.getLength(tmp[i]) - 1)
	endWhile
endFunction

Function sortStringsAndInt(String[] strs1, String[] strs2, int[] ints, int size)
	String[] tmp = CreateStringArray(size)
	int i = size
	while i
		i-=1
		tmp[i]=strs1[i]+"\n"+strs2[i]+"\n"+ints[i]
	endWhile
	PapyrusUtil.SortStringArray(tmp)
	i = size
	while i
		i-=1
		String[] parts = StringUtil.split(tmp[i], "\n")
		strs1[i] = parts[0]
		strs2[i] = parts[1]
		if parts[2]=="1"
			ints[i] = 1
		else
			ints[i] = 0
		endIf
	endWhile
endFunction


Function updateValidRaces()
	int i
	updateRacesProgress = 0
	if needToSortRaceArraysH
		sortStringsAndInt(allRacesH, allRacesHEditIDs, allRacesHEnabled, numAllRacesH)
		needToSortRaceArraysH = false
	endIf
	updateRacesProgress = 1
	if needToSortRaceArraysC
		sortStringAndInt(allRacesC, allRacesCEnabled, numAllRacesC)
		needToSortRaceArraysC = false
	endIf
	updateRacesProgress = 2
	int j
	int numH = 0
	int numC = 0
	; Count the num of enabled races, always
	i = numAllRacesH
	while i
		i-=1
		if allRacesHEnabled[i]
			numH+=1
		endIf
	endWhile
	updateRacesProgress = 3
	i = numAllRacesC
	while i
		i-=1
		if allRacesCEnabled[i]
			numC+=1
		endIf
	endWhile
	updateRacesProgress = 4

	float progress = (90.0 / (numAllRacesH + numAllRacesC + numH + NumC))
	if needToUpdateRaceDisplayArraysH ; Create and fill the array, and sort it
		allValidRacesH = CreateStringArray(numH)
		i = numAllRacesH
		j=0
		while i
			i-=1
			if allRacesHEnabled[i]
				allValidRacesH[j] = allRacesH[i]
				j+=1
			endIf
			updateRacesProgress = (updateRacesProgress + progress) as Int
		endWhile
		PapyrusUtil.SortStringArray(allValidRacesH)
		updateRacesProgress += 1
	endIf
	
	if needToUpdateRaceDisplayArraysC ; Create and fill the array, and sort it
		allValidRacesC = CreateStringArray(numC)
		i = numAllRacesC
		j=0
		while i
			i-=1
			if allRacesCEnabled[i]
				allValidRacesC[j] = allRacesC[i]
				j+=1
			endIf
			updateRacesProgress = (updateRacesProgress + progress) as Int
		endWhile
		PapyrusUtil.SortStringArray(allValidRacesC)
		updateRacesProgress += 1
	elseIf !allValidRacesC
		String[] allRaceKeys = sslCreatureAnimationSlots.GetAllRaceKeys()
		j=allRaceKeys.length
		allValidRacesC = CreateStringArray(j)
		while j
			j-=1
			allValidRacesC[j]=allRaceKeys[j]
		endWhile
		PapyrusUtil.SortStringArray(allValidRacesC)
		updateRacesProgress += 1
	endIf
	
	if needToUpdateRaceDisplayArraysH || needToUpdateRaceDisplayArraysC ; Create and fill the array, and sort it
		allValidRacesB = CreateStringArray(numH + numC)
		i = numH
		j=0
		while i
			i-=1
			allValidRacesB[j] = allValidRacesH[i]
			j+=1
			updateRacesProgress = (updateRacesProgress + progress) as Int
		endWhile
		i = numC
		while i
			i-=1
			allValidRacesB[j] = allValidRacesC[i]
			j+=1
			updateRacesProgress = (updateRacesProgress + progress) as Int
		endWhile
		PapyrusUtil.SortStringArray(allValidRacesB)
		updateRacesProgress = 100
		needToUpdateRaceDisplayArraysH = false
		needToUpdateRaceDisplayArraysC = false
	endIf
EndFunction

bool Function atLeastOneValidRace(SSX_Rule_Alias r, int position)
	{Check if for the specified position, at least one race is valid}
	String races = r.getRaceFilter(position)
	String[] theRaces
	if races==""
		return true
	endIf
	if r.getRaceMode(position)==0 ; Inclusive, at least one of the specified has to be active
		theRaces = StringUtil.split(races, ";")
		int i = theRaces.length
		while i
			i-=1
			int pos = allRacesH.find(theRaces[i])
			if pos!=-1
				if allRacesHEnabled[pos]==1
					return true
				endIf
			else
				pos = allRacesC.find(theRaces[i])
				if pos!=-1
					if allRacesCEnabled[pos]==1
						return true
					endIf
				endIf
			endIf
		endWhile
	else ; Exclusive, at least one of the not-listed should be active
		int i = numAllRacesH
		while i
			i-=1
			if allRacesHEnabled[i]
				if StringUtil.find(races, allRacesH[i])==-1
					return true
				endIf
			endIf
		endWhile
		i = numAllRacesC
		while i
			i-=1
			if allRacesCEnabled[i]
				if StringUtil.find(races, allRacesC[i])==-1
					return true
				endIf
			endIf
		endWhile
	endIf
	return false ; none found
EndFunction

Function updateAllNeededRaces()
	{Check if a race is required by a rule and it is globally active, add it only if both conditions are true.}
	if SexLab.AllowCreatures && !nexusMode
		needRaces = CreateStringArray(numAllRacesH + numAllRacesC)
	else
		needRaces = CreateStringArray(numAllRacesH)	
	endIf
	
	; We need to count the actual races, but can be done only after we find all the actual races
	int count=0
	String raceFilter
	bool atLeastOneFilterH = false
	bool atLeastOneFilterC = false
	; Scan all the active rules, for each find the race filters for all participants, add the found race, but in case "all races needed" then limit to the enabled races
	int i=rules.length
	while i
		i-=1
		SSX_Rule_Alias r = rules[i]
		if r.inUse==2
			int j=3
			while j
				j-=1
				if !r.isNobody(j) && r.getRaceFilter(j)
					String[] parts = StringUtil.split(r.getRaceFilter(j), ";")
					int enabled = 0
					int k=parts.length
					while k
						k-=1
						if needRaces.find(parts[k])==-1
							int pos=allRacesH.find(parts[k])
							if pos==-1
								pos=allRacesC.find(parts[k])
								if pos!=-1
									enabled=allRacesCEnabled[pos]
								endIf
							else
								enabled=allRacesHEnabled[pos]
							endIf
							if enabled
								needRaces[count] = parts[k]
								count+=1
							endIf
						endIf
					endWhile
					if !atLeastOneFilterH && !atLeastOneFilterC && enabled==1
						if r.isHuman(j)
							atLeastOneFilterH=true
						else
							atLeastOneFilterC=true
						endIf
					endIf
				endIf
			endWhile
		endIf
	endWhile
	if !atLeastOneFilterH
		i = numAllRacesH
		while i
			i-=1
			if allRacesHEnabled[i]
				needRaces[count] = allRacesH[i]
				count+=1
			endIf
		endWhile
	endIf
	if !atLeastOneFilterC && SexLab.AllowCreatures && !nexusMode
		i = numAllRacesC
		while i
			i-=1
			if allRacesCEnabled[i]
				needRaces[count] = allRacesC[i]
				count+=1
			endIf
		endWhile
	endIf

	; OK, now needRaces has all IDs of the races. Only the ones requred and enabled. Now construct the Form array. First we need to check the required size. Creature races are RaceKeys and they can mapo to multiple races
	int numForms = 0
	i = count
	while i
		i-=1
		String raceID = needRaces[i]
		Race[] rs = sslCreatureAnimationSlots.GetAllRaces(raceID)
		if !rs || rs.length==0
			; It should be human
			numForms+=1
		else
			numForms+=rs.length
		endIf
	endWhile
	needRacesR = Utility.resizeFormArray(needRacesR, numForms)
	; Now fill it
	numForms = 0
	i = count
	while i
		i-=1
		String raceID = needRaces[i]
		Race[] rs = sslCreatureAnimationSlots.GetAllRaces(raceID)
		if !rs || rs.length==0
			; It should be human
			int pos = allRacesH.find(raceID)
			if pos!=-1
				Race ra = Race.GetRace(allRacesHEditIDs[pos])
				if ra
					needRacesR[numForms]=ra
					numForms+=1
				endIf
			endIf
		else
			; It is a creature
			int j=rs.length
			while j
				j-=1
				if rs[j]
					needRacesR[numForms]=rs[j]
					numForms+=1
				endIf
			endWhile
		endIf
	endWhile
EndFunction

bool Function isAnyOfTheseRacesEnabled(String raceIDs)
	if raceIDs==""
		return isAnyCreatureRaceEnabled()
	endIf
	String[] parts = StringUtil.split(raceIDs, ";")
	int i = parts.length
	while i
		i-=1
		if isRaceEnabled(parts[i])
			return true
		endIf
	endWhile
	return false
EndFunction

bool Function isAnyCreatureRaceEnabled()
	int i = numAllRacesC
	while i
		i-=1
		if allRacesCEnabled[i]
			return true
		endIf
	endWhile
	return false
EndFunction

Function enableCreatures(String raceIDs)
	if raceIDs=="" ; All of them
		int i = numAllRacesC
		while i
			i-=1
			if allRacesC[i]==0
				needToUpdateRaceDisplayArraysC=true
			endIf
			enableRace(allRacesC[i], 1)
		endWhile
		return
	endIf
	String[] parts = StringUtil.split(raceIDs, ";")
	int i = parts.length
	while i
		i-=1
		if parts[i]==0
			needToUpdateRaceDisplayArraysC=true
		endIf
		enableRace(parts[i], 1)
	endWhile
EndFunction

String[] Function getRaceTypes(SSX_Rule_Alias r, bool beEmpty=false)
	if beEmpty
		return emptyRaceKeys
	endIf
	if r.dstRaces=="" && r.srcRaces=="" && r.collRaces==""
		return emptyRaceKeys
	endIf
	String[] tmp = new String[64]
	int num = 0
	int i
	String[] parts
	if r.dstRaces!="" && r.isCreature(0)
		parts = StringUtil.split(r.dstRaces, ";")
		i = parts.length
		while i
			i-=1
			if tmp.find(parts[i])==-1
				tmp[num] = parts[i]
				num+=1
			endIf
		endWhile
	endIf
	if r.srcRaces!="" && r.isCreature(1)
		parts = StringUtil.split(r.srcRaces, ";")
		i = parts.length
		while i
			i-=1
			if tmp.find(parts[i])==-1
				tmp[num] = parts[i]
				num+=1
			endIf
		endWhile
	endIf
	if r.collRaces!="" && r.isCreature(2)
		parts = StringUtil.split(r.collRaces, ";")
		i = parts.length
		while i
			i-=1
			if tmp.find(parts[i])==-1
				tmp[num] = parts[i]
				num+=1
			endIf
		endWhile
	endIf
	if num==0
		return emptyRaceKeys
	endIf
	parts = CreateStringArray(num)
	while num
		num-=1
		parts[num] = tmp[num]
	endWhile
	return parts
EndFunction

; -))

; ((- Object and ID functions ************************************************************************************************************************************************************************

String Function getObjectModName(Form f) global
	int modIndex = Math.RightShift(Math.LogicalAnd(f.GetFormID(), 0xFF000000), 24)
	String modName = Game.GetModName(modIndex)
	int pos = StringUtil.find(modName, ".e")
	if pos!=-1
		modName = StringUtil.substring(modName, 0, pos)
	endIf
	return modName
EndFunction

String Function getObjectFullModName(Form f) global
	int modIndex = Math.RightShift(Math.LogicalAnd(f.GetFormID(), 0xFF000000), 24)
	return Game.GetModName(modIndex)
EndFunction

Form[] Function getWornItems(Actor a) global
	if !a
		return CreateFormArray(0)
	endIf
	Form[] res = new Form[32]
	int m=32
	int pos=1
	while m
		m-=1
		res[m] = a.GetWornForm(pos)
		pos *= 2
	endWhile
	return res
EndFunction

; -))

; ((- Sorting functions ************************************************************************************************************************************************************************

int Function getStringVal(String s, int pos) global
{Returns an Int of the character in the "pos" position of the string of the String}
	int len = StringUtil.GetLength(s)
	int res = 0
	int done = 0
	while pos < len && done < 3
		int v = StringUtil.AsOrd(StringUtil.GetNthChar(s, pos))
		if v > 96 && v<123 ; Letters are between 65 and 90, Skyrim is not case sensitive, so everything should be compared uppercase
			v -= 32
		endIf
		res *= 256
		res += v
		done += 1
		pos += 1
	endWhile
	while done < 3
		res *= 256
		done += 1
	endWhile
	return res
EndFunction

bool Function compareStr(String a, String b) global
{Compares two strings and returns True if the first string is lower or equal than the second}
	if a==b
		return false
	endIf

	; Go for 3 chars at time, put them in an int to do a quick compare
	int pos = 0
	int l2 = StringUtil.GetLength(b)
	int max = StringUtil.GetLength(a)
	if max > l2
		max = l2
	endIf
	
	while pos < max
		int va = getStringVal(a, pos)
		int vb = getStringVal(b, pos)
		if va < vb
			return true
		elseIf va > vb
			return false
		endIf
		pos += 3
	endWhile
	return false
EndFunction

Function sortAnims(sslBaseAnimation[] srcArray) global
; Sort the animations in the source array by name
	; Start from the first item, check what is the minimal not null value, and swap with the first (if it is not the first), do it until the array is completed
	int pos = 0
	while pos < srcArray.length
		String minVal = "~~~~"
		int minPos = -1
		if srcArray[pos]
			minVal = srcArray[pos].name
			minPos = pos
		endIf
		; Find the min value from the current position included to the end
		int j = pos + 1
		while j < srcArray.length
			if srcArray[j] && srcArray[j].name!="" && compareStr(srcArray[j].name, minVal)
				minVal = srcArray[j].name
				minPos = j
			endIf
			j+=1
		endWhile
		; Swap is it is not the current position
		if minPos!=-1 && minPos!=pos
			sslBaseAnimation tmp = srcArray[pos]
			srcArray[pos] = srcArray[minPos]
			srcArray[minPos] = tmp
		endIf
		pos+=1
	endWhile
EndFunction


; -))

; ((- Global Utility functions **************************************************************************************************************

String[] Function CreateStringArray(int size) global
	String[] res = Utility.CreateStringArray(size)
	if !res && size>0
		int times = 0
		while times<100 && !res
			Utility.waitMenuMode(0.1)
			res = Utility.CreateStringArray(size)
			times += 1
		endWhile
	endIf
	if size!=0 && (!res || res.length==0)
		debug.messagebox("--- SSX ERRROR ---\n Scent of Sex cannot init a string array!!!!\nThe mod will NOT work!\nTry to re-init the mod in the MCM.")
		debug.trace("[SSX] ERRROR: cannot init a string array!!!! The mod will NOT work!\nTry to re-init the mod in the MCM.")
		res = new String[128]
		SSX_Runner_Quest mySelf = PO3_SKSEFunctions.GetFormFromEditorID("ssxRunnerQuest") As SSX_Runner_Quest
		if mySelf
			mySelf.iAmInitialized=0
		endIf
	endIf
	return res
EndFunction

Form[] Function CreateFormArray(int size) global
	Form[] res = Utility.CreateFormArray(size)
	if !res
		int times = 0
		while times<100 && !res
			Utility.waitMenuMode(0.1)
			res = Utility.CreateFormArray(size)
			times += 1
		endWhile
	endIf
	if size!=0 && (!res || res.length==0)
		debug.messagebox("--- SSX ERRROR ---\n Scent of Sex cannot init a Form array!!!!\nThe mod will NOT work!\nTry to re-init the mod in the MCM.")
		debug.trace("[SSX] ERRROR: cannot init a Form array!!!! The mod will NOT work!\nTry to re-init the mod in the MCM.")
		res = new Form[128]
		SSX_Runner_Quest mySelf = PO3_SKSEFunctions.GetFormFromEditorID("ssxRunnerQuest") As SSX_Runner_Quest
		if mySelf
			mySelf.iAmInitialized=0
		endIf
	endIf
	return res
EndFunction

Int[] Function CreateIntArray(int size) global
	Int[] res = Utility.CreateIntArray(size)
	if !res
		int times = 0
		while times<100 && !res
			Utility.waitMenuMode(0.1)
			res = Utility.CreateIntArray(size)
			times += 1
		endWhile
	endIf
	if size!=0 && (!res || res.length==0)
		debug.messagebox("--- SSX ERRROR ---\n Scent of Sex cannot init an int array!!!!\nThe mod will NOT work!\nTry to re-init the mod in the MCM.")
		debug.trace("[SSX] ERRROR: cannot init an int array!!!! The mod will NOT work!\nTry to re-init the mod in the MCM.")
		res = new Int[128]
		SSX_Runner_Quest mySelf = PO3_SKSEFunctions.GetFormFromEditorID("ssxRunnerQuest") As SSX_Runner_Quest
		if mySelf
			mySelf.iAmInitialized=0
		endIf
	endIf
	return res
EndFunction

String[] Function ResizeStringArray(String[] source, int size, String fill="") ; OK
	String[] res = Utility.ResizeStringArray(source, size, fill)
	if !res
		int times = 0
		while times<100 && !res
			Utility.waitMenuMode(0.1)
			res = Utility.ResizeStringArray(source, size, fill)
			times += 1
		endWhile
	endIf
	if !res
		debug.messagebox("--- SSX ERRROR ---\n Scent of Sex cannot resize a String array!!!!\nThe mod will NOT work!\nTry to re-init the mod in the MCM.")
		debug.trace("[SSX] ERRROR: cannot resize a String array!!!! The mod will NOT work!\nTry to re-init the mod in the MCM.")
		res = new String[128]
		SSX_Runner_Quest mySelf = PO3_SKSEFunctions.GetFormFromEditorID("ssxRunnerQuest") As SSX_Runner_Quest
		if mySelf
			mySelf.iAmInitialized=0
		endIf
	endIf
	return res
EndFunction

int[] Function ResizeIntArray(int[] source, int size, int fill = 0) ; OK
	int[] res = Utility.ResizeIntArray(source, size, fill)
	if !res
		int times = 0
		while times<100 && !res
			Utility.waitMenuMode(0.1)
			res = Utility.ResizeIntArray(source, size, fill)
			times += 1
		endWhile
	endIf
	if !res
		debug.messagebox("--- SSX ERRROR ---\n Scent of Sex cannot resize an int array!!!!\nThe mod will NOT work!\nTry to re-init the mod in the MCM.")
		debug.trace("[SSX] ERRROR: cannot resize an int array!!!! The mod will NOT work!\nTry to re-init the mod in the MCM.")
		res = new Int[128]
		SSX_Runner_Quest mySelf = PO3_SKSEFunctions.GetFormFromEditorID("ssxRunnerQuest") As SSX_Runner_Quest
		if mySelf
			mySelf.iAmInitialized=0
		endIf
	endIf
	return res
EndFunction

Form[] Function ResizeFormArray(Form[] source, int size, Form fill = None) ; OK
	Form[] res = Utility.ResizeFormArray(source, size, fill)
	if !res
		int times = 0
		while times<100 && !res
			Utility.waitMenuMode(0.1)
			res = Utility.ResizeFormArray(source, size, fill)
			times += 1
		endWhile
	endIf
	if !res
		debug.messagebox("--- SSX ERRROR ---\n Scent of Sex cannot resize a Form array!!!!\nThe mod will NOT work!\nTry to re-init the mod in the MCM.")
		debug.trace("[SSX] ERRROR: cannot resize a Form array!!!! The mod will NOT work!\nTry to re-init the mod in the MCM.")
		res = new Form[128]
		SSX_Runner_Quest mySelf = PO3_SKSEFunctions.GetFormFromEditorID("ssxRunnerQuest") As SSX_Runner_Quest
		if mySelf
			mySelf.iAmInitialized=0
		endIf
	endIf
	return res
EndFunction

String Function convertHex(int val) global
	string res=""
	while val
		int part = Math.LogicalAnd(val, 0xF)
		if part<10
			res = part + res
		elseIf part==10
			res = "A" + res
		elseIf part==11
			res = "B" + res
		elseIf part==12
			res = "C" + res
		elseIf part==13
			res = "D" + res
		elseIf part==14
			res = "E" + res
		elseIf part==15
			res = "F" + res
		endIf
		val = Math.RightShift(val, 4)
	endWhile
	return res
EndFunction

String Function bitField(int val) global
	string res = ""
	int i=0
	int step=0
	while val
		res += Math.LogicalAnd(val, 1)
		val = Math.RightShift(val, 1)
		i += 1
		step+=1
		if step==4
			res+=" "
			step=0
		endIf
	endWhile
	while i<32
		res += "0"
		i += 1
		step+=1
		if step==4
			res+=" "
			step=0
		endIf
	endWhile
	return res
EndFunction

String Function dump(int tmp) global
	if tmp==0
		return "0000 0000 0000 0000 0000 0000 0000 0000"
	endIf
	string res = ""

	int val = tmp
	int i=0
	while i<8
		int mask = Math.LeftShift(0xF, i * 4)
		int part = Math.RightShift(Math.LogicalAnd(val, mask), i * 4)
		int j=0
		while j<4
			res += Math.LogicalAnd(part, 1)
			part = Math.RightShift(part, 1)
			j+=1
		endWhile
		res+=" "
		i+=1
	endWhile
	return res
EndFunction

String[] Property trackers Auto
float[] Property startTime Auto

Function startT(String msg)
	if !getDebug(notifTimeToComplete()) && msg!="Loading Configuration"
		return
	endIf
	int pos = trackers.find(msg)
	if pos==-1
		int i=trackers.length
		while i
			i-=1
			if trackers[i]==""
				pos = i
				i = 0
			endIf
		endWhile
		if pos==-1
			debug.trace("[SSX] Too many trackers at the same time")
			return
		endIf
	endIf
	trackers[pos] = msg
	startTime[pos] = Utility.GetCurrentRealTime()
endFunction

Function endT(String msg)
	if !getDebug(notifTimeToComplete()) && msg!="Loading Configuration"
		return
	endIf
	int pos = trackers.find(msg)
	if pos==-1
		debug.trace("[SSX] Tracker \"" + msg + "\" not found")
		int i=trackers.length
		while i
			i-=1
			debug.trace("[SSX] Tracker " + i + " =\"" + trackers[i] + "\"")
		endWhile
		return
	endIf
	log("Elapsed time for " + msg + " = " + (Utility.GetCurrentRealTime() - startTime[pos]), notifTimeToComplete())
	trackers[pos] = ""
EndFunction

; -))

; ((- Actors of the cell, beds, and eventCatchers **************************************************************************************************************

ReferenceAlias[] Property eventCatchers Auto
ReferenceAlias[] Property eventCatchersB Auto
ReferenceAlias Property playerEventCatcher Auto
ReferenceAlias Property playerEventCatcherB Auto
int Property numCatchers Auto
int Property numCatchersB Auto
Actor[] Property allActors Auto ; Actors Array of all the found actors that are OK for the rules, some items can be null because it is pre-initialized with 64 elements (updated by CellScanner)
int allActorsNum ; Number of found actors and available actors in the current cell (updated by CellScanner)
Faction Property ssxInvolved Auto ; Holds all the actors already participating in the scenes
Faction Property ssxCanIBeAsked Auto
Faction Property ssxAskingFaction Auto
Float[] Property allActorsAggression Auto
int[] Property allActorsPredfaction Auto
bool updatingAllActors = false

bool function noActors()
	int i = allActors.length
	while i
		i-=1
		if allActors[i]
			return false
		endIf
	endWhile
	return true
endFunction

int function countActors()
	int num=0
	int i = allActors.length
	while i
		i-=1
		if allActors[i]
			num+=1
		endIf
	endWhile
	return num
EndFunction

bool Function checkValidityForScan(Actor a)
	if !a || !validateActor(a) || !a.getParentCell().IsAttached()
		log("Actor " + a.getDisplayName() + " is removed because it is not valid", notifNotGoodActors())
		return false
	elseIf skipActorsInNamedScenes==1
		Scene aScene = a.GetCurrentScene()
		if aScene!=None && aScene.IsPlaying()
			String sceneName = aScene.GetOwningQuest().getName()
			if sceneName!="" && sceneName!="[SSX] Scene Manager"
				log("Actor " + a.getDisplayName() + " is removed because it is playing a named scene: " + aScene.GetOwningQuest().getName(), notifNotGoodActors())
				return false
			endIf
		endIf
	elseIf needRaces!="" && needRaces.find(getRaceID(a.getLeveledActorBase().getRace()))==-1
		log("Actor " + a.getDisplayName() + " is removed because its race is not needed", notifNotGoodActors())
		return false
	endIf
	return true
EndFunction

bool Function checkGHFForScan(Actor a)
	{Actor type GHF}
	bool isM = isMale(a)
	bool isW = a.isPlayerTeamMate()
	bool isH = isHuman(a)
	bool isP = a==PlayerRef

	bool isGood = (isP && needP) || (((isM && needM) || (!isM && needF)) && ((isH && needH) || (!isH && needC)) && ((isW && needW) || (!isW && needN)))
	if !isGood
		log("Actor " + a.getDisplayName() + " is removed because its gender, humanity, fellowship are not required. Male=" + isM + "/" + needM + "-" + needF + " Human=" + isH + "/" + needH + "-" + needC + " Follower=" + isW + "/" + needW + "-" + needN, notifNotGoodActors())
		return false
	endIf

	; This guy is good...
	log("Scan: Adding " + a.getDisplayName(), notifActorForRule())
	hlg(a, notifHighLightColorScan, highlightScan())
	return true
EndFunction


bool Function addToAllActors(Actor a)
	if !a
		return true ; nothing to add
	endIf

	if allActors.find(a)!=-1
		return false ; debatable.  we didn't add, but actor is now in array.  latter is usually more important
	endIf

	int times=10
	while updatingAllActors && times ; from here on we may change things
		Utility.waitMenuMode(1.0)
		times-=1
	endWhile
	if times==0
		return true
	endIf
	updatingAllActors=true

	int i = allActors.find(none)
	if a == playerRef && i == -1 && !removeFromAllActors(none, 0, false)
		i = 0
	endIf
	if i == -1
		updatingAllActors = false
		return true
	endIf
	allActors[i] = a
	storeAggression(a)
	if atLeastOneFriendAdded
		stopCombatForActor(a)
	endIf
	a.removeFromFaction(ssxInvolved)
	clearCached(i)
	updatingAllActors=false
	hlg(a, notifHighLightColorScan, highlightScan())
	return false
endFunction

bool Function storeAggression(Actor a)
	if !a || a == PlayerRef
		return true
	endIf
	if a.isInFaction(ssxAllFriends); if actor is not pacified, update rank even if they were already stored - because game events can and will change the value
		return true
	endIf
	int f = a.getActorValue("Aggression") as int
	if a.isInFaction(PredatorFaction)
		f -= 100
	endIf
	a.addToFaction(ssxAggressionFaction)
	a.setFactionRank(ssxAggressionFaction, f)
	return false
endFunction

bool Function restoreAggression(Actor a, bool r=false)
	if !a || a==PlayerRef
		return true
	endIf
	if !a.isInFaction(ssxAggressionFaction)
		return true
	endIf
	int f = a.getFactionRank(ssxAggressionFaction)
	if f < 0
		a.addToFaction(PredatorFaction)
		f +=100
	endIf
	if a.getActorValue("Aggression") == 0.0 && f != 0; possible rare case where event made npc aggressive while they were pacified - this is NOT perfect, it can't detect if event pacified actor during stopcombat
		a.setActorValue("Aggression", f)
	endIf
	if r
		a.removeFromFaction(ssxAggressionFaction)
	endIf
	return false
endFunction

bool Function removeFromAllActors(Actor a, int pos = -1, bool l = true) ; a = actor to remove, pos = alternate position to clear, l = lock while removing
	if pos == -1 ; if no pos given, try to find
		pos = allActors.find(a)
		if pos == -1 ; we have no pos and no valid actor, no-can-do
			return true
		endIf
	else ; we have pos, so just get actor from the location
		a = allActors[pos]
	endIf
	
	if a && (sceneSs.find(a)!=-1 || sceneDs.find(a)!=-1 || sceneC1s.find(a)!=-1 || sceneC2s.find(a)!=-1 || sceneC3s.find(a)!=-1)
		return true; we have actor, and actor is involved in scene, we can't remove them
	endIf
	
	if l ; normally we handle locking, but sometimes calling function can take care of it
		int times=0
		while updatingAllActors && times<10
			Utility.waitMenuMode(1.0)
			times+=1
		endWhile
		if times==10
			return true
		endIf
	
		updatingAllActors=true
	endIf
	if a ; we have valid actor, remove factions and restore aggression
		restoreAggression(a, true)
		a.removeFromFaction(ssxAllFriends)
		a.removeFromFaction(ssxScanningFaction)
		a.RemoveFromFaction(ssxPlayerAskFactions[0])
		a.RemoveFromFaction(ssxPlayerAskFactions[1])
		a.RemoveFromFaction(ssxPlayerAskFactions[2])
		a.RemoveFromFaction(ssxPlayerAskFactions[3])
		a.RemoveFromFaction(ssxPlayerAskFactions[4])
		a.RemoveFromFaction(ssxCanIBeAsked)
		a.RemoveFromFaction(ssxAskingFaction)
		a.evaluatePackage()
	endIf
	allActors[pos] = none
	if l
		updatingAllActors=false
	endIf
	return false
endFunction

Function dumpAllActors(String what)
	String msg = "All Actors from " + what + ": "
	int i=allActors.length
	int n=0
	while i
		i-=1
		Actor a = allActors[i]
		if a
			n += 1
			msg += a.getDisplayName() + " ("
			if isMale(a)
				msg+="M"
			else
				msg+="F"
			endIf
			if a.isPlayerTeamMate()
				msg+="F"
			else
				msg+="N"
			endIf
			if isCreature(a)
				msg+="C"
			else
				msg+="H"
			endIf
			msg+=" " + getActorRaceID(a) + "), "
		endIf
	endWhile
	msg+=n + " actors"
	log(msg, notifActorsFoundLong())
endFunction


bool atLeastOneFriendAdded = false
bool ceaseFire = false

Function stopCeaseFire(int mode)
	if !ceaseFire
		return
	endIf
	ceaseFire = false
	if mode != 3 && mode != 5
		return
	endIf
	if mode == 3 && forceStopCombats != 1 && forceStopCombats != 3
		return
	endIf
	if mode == 5 && forceStopCombats != 2 && forceStopCombats != 3
		return
	endIf
	if countScenesPlaying() > 0
		return
	endIf
	resetCombat()
EndFunction

Function startCeaseFire(int mode)
	if atLeastOneFriendAdded || ceaseFire
		return
	endIf
	if (mode == 3 && (forceStopCombats == 1 || forceStopCombats == 3)) || (mode == 5 && (forceStopCombats == 2 || forceStopCombats == 3)) || (mode==4)
		ceaseFire = true
		stopAllCombats()
	endIf
EndFunction

Function stopAllCombats()
	int times=0
	while updatingAllActors && times<10
		Utility.waitMenuMode(1.0)
		times+=1
	endWhile
	PlayerRef.addToFaction(ssxAllFriends)
	updatingAllActors=true
	int i = allActors.length
	while i
		i-=1
		Actor a  = allActors[i]
		if a
			stopCombatForActor(a,1)
		endIf
	endWhile
	i = allActors.length
	while i
		i-=1
		Actor a  = allActors[i]
		if a
			stopCombatForActor(a,2)
		endIf
	endWhile
	i = allActors.length
	while i
		i-=1
		Actor a  = allActors[i]
		if a
			stopCombatForActor(a,3)
		endIf
	endWhile
	updatingAllActors=false
	log("Combats stopped", notifCombats())
endFunction

Function stopCombatForActor(Actor a, int stage = -1)
	if a == PlayerRef
		return
	endIf
	if stage == 1 || stage == -1
		storeAggression(a)
		a.addToFaction(ssxAllFriends) ; add to friends BEFORE setting aggression to 0, ssxAllFriends prevents aggression updates to faction
		a.setActorValue("Aggression", 0) ; value cannot be < 0 or a float so it's best we can do - no way to trace if event 're-zeroes' it during stopcombat
		a.removeFromFaction(PredatorFaction)
	endIf
	if stage == 2 || stage == -1
		a.evaluatePackage()
	endIf
	if stage == 3 || stage == -1
		a.stopCombat()
		a.stopCombatAlarm()
		a.sheatheWeapon()
		a.damageAV("Health", 0.001)
	endIf
	atLeastOneFriendAdded = true
EndFunction


Function resetCombat()
	if !atLeastOneFriendAdded || hasEvent()
		return
	endIf

	ceasefire = false

	int times=0
	while updatingAllActors && times<10
		Utility.waitMenuMode(1.0)
		times+=1
	endWhile
	updatingAllActors=true
	int i = allActors.length
	while i
		i -= 1
		Actor a  = allActors[i]
		if a
			restoreAggression(a) ; first restore aggression, then remove friend faction - this ensures aggression is up before we allow storing/updating it into faction (ssxAllFriends prevents updates)
			a.removeFromFaction(ssxAllFriends)
			a.evaluatePackage()
		endIf
	endWhile
	atLeastOneFriendAdded = false
	updatingAllActors=false
	PlayerRef.removeFromFaction(ssxAllFriends)
	int handle = ModEvent.Create("ssxCleanNow")
	ModEvent.PushInt(handle, 2)
	ModEvent.Send(handle)
	log("Combats restored", notifCombats())
EndFunction

Function removeNoMoreValidActors()
	int times=0
	while updatingAllActors && times<10
		Utility.waitMenuMode(1.0)
		times+=1
	endWhile
	if times==10
		return
	endIf
	updatingAllActors=true
	
	int i=allActors.length
	while i
		i-=1
		Actor a = allActors[i]
		if a && !validateActor(a)
			removeFromAllActors(none, i, false)
		endIf
	endWhile
	updatingAllActors=false
endFunction

Function removeFromScanningFaction()
	int times=0
	while updatingAllActors && times<10
		Utility.waitMenuMode(1.0)
		times+=1
	endWhile
	if times==10
		return
	endIf
	updatingAllActors=true
	int i = allActors.length
	while i
		i-=1
		Actor a  = allActors[i]
		if a
			a.removeFromFaction(ssxScanningFaction)
		endIf
	endWhile
	updatingAllActors=false
	int handle = ModEvent.Create("ssxCleanNow")
	ModEvent.PushInt(handle, 1)
	ModEvent.Send(handle)
endFunction

Function purgeFarActors()
	while updatingAllActors
		Utility.waitMenuMode(0.5)
	endWhile
	updatingAllActors = true

	int i = allActors.length
	while i
		i-=1
		if allActors[i] && PlayerRef.getDistance(allActors[i]) > 8000.0
			removeFromAllActors(none, i, false)
		endIf
	endWhile
	
	updatingAllActors = false
EndFunction

int Function removeActorForGood(Actor a=None, int i=-1, Actor[] people)
	if i!=-1
		a = people[i]
		people[i]=None
	endIf
	if !a
		return 0
	endIf
	a.RemoveFromFaction(ssxScanningFaction)
	a.RemoveFromFaction(ssxAllFriends)
	a.RemoveFromFaction(ssxInvolved)
	
	a.RemoveFromFaction(ssxPlayerAskFactions[0])
	a.RemoveFromFaction(ssxPlayerAskFactions[1])
	a.RemoveFromFaction(ssxPlayerAskFactions[2])
	a.RemoveFromFaction(ssxPlayerAskFactions[3])
	a.RemoveFromFaction(ssxPlayerAskFactions[4])
	a.RemoveFromFaction(ssxCanIBeAsked)
	a.RemoveFromFaction(ssxAskingFaction)
	releaseScene(none, -1, a)
	removeFromAllActors(a)
	return 1
endFunction

bool Function checkActorSex(int ruleSexVal, Actor a)
	if !a
		return false
	endIf
	if ruleSexVal==3 || orientationMode==3 ; Both are good
		return true
	endIf
	if ruleSexVal==1 ; Male required or orientation mode should be lesbian
		return isMale(a) || orientationMode==2
		
	elseIf ruleSexVal==2 ; Female required or orientation mode is gay
		return isFemale(a) || orientationMode==1
	
	endIf
	return false ; Just as fallback, we should not reach whis step
EndFunction

bool Function checkActorHumanity(int ruleHumanityVal, Actor a)
	if !a
		return false
	endIf
	if (ruleHumanityVal==1 && isCreature(a)) || (ruleHumanityVal==2 && isHuman(a))
		return false
	endIf
	return true
EndFunction

bool Function checkActorRace(SSX_Rule_Alias r, int pos, Actor a)
	if !a
		return false
	endIf
	String raceID
	int i = cachedActors.find(a)
	if i==-1
		raceID = getActorRaceID(a)
	else
		raceID = cachedRaces[i]
	endIf
	if raceID==""
		return false
	endIf
	
	; Check if is in all needed races
	
	; 1) If not specified, all is good
	; 2) If specified and inclusive, has to be in
	; 3) If specified and exclusive, has not to be in
	; and then double check the global filters

	if r.getRaceMode(pos)==0 ; inclusive
		String races = r.getRaceFilter(pos)
		if races!="" && StringUtil.find(";" + races + ";", ";" + raceID + ";")==-1
			return false
		endIf
	else ; exclusive
		String races = r.getRaceFilter(pos)
		if races!="" && StringUtil.find(";" + races + ";", ";" + raceID + ";")!=-1
			return false
		endIf
	endIf

	; Normal global filters
	i = allRacesH.find(raceID)
	if i!=-1
		if allRacesHEnabled[i]==0
			return false
		endIf
	else
		i = allRacesC.find(raceID)
		if i!=-1
			if allRacesCEnabled[i]==0
				return false
			endIf
		endIf
	endIf
	
	return true
EndFunction

Function checkPlayerProtection()
	{Quickly check if the player requires a protected catcher}
	if iAmActive!=0
		; Set up the catcher for the player
		int handle = ModEvent.Create("ssxSetPlayerProtectedCatcher")
		ModEvent.PushString(handle, "SSX")
		ModEvent.Send(handle)
	endIf
endFunction
		
; -))
